/********************************************************************************/
/*  t@C    F$Workfile: SddApi.c $                                       */
/*  Tv          FSDOpAPIt@C                                         */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 06/09/12 09:52 $                                  */
/*                  [hCg֐Oǉ 2006/08/1 H.Miura              */
/*                  [hCg֐㏈ǉ 2006/08/1 H.Miura              */
/*                  IOCTLʎ擾pʑOǉ 2006/08/08 H.Miura      */
/********************************************************************************/
/* wb_[t@C */
#include "SddCom.h"
#include "SddRegister.h"
#include "SddRegister_dma.h"
#include "SddOsSemaphore.h"
#include "SddOsIntr.h"
#include "SddError.h"
#include "SddDma.h"
#include "SddIoctl_basic.h"
#include "SddIoctl_unuse.h"
#include "SddIoctl_usb.h"
#include "SddCardInOut.h"
#include "SddIoctl_sdio.h"

#ifdef _SDD_STATUS_MONITOR_ /* Xe[^Xj^pvON */
#include "..\StatusMonitor\statusmonitor.h"
#define setIoctlStatusMonitor() {\
    setStatusData(1,(unsigned int)uh_Cmd);       /* R}hi[ */\
}

#else
#define setIoctlStatusMonitor() {\
    /* Ȃ */\
}
#endif /* _SDD_STATUS_MONITOR_ */

/* ϐ錾 */
SDD_DEV	SddDev[SDD_DEV_COUNT];	/* ێp\ */
SDD_HANDLE SddHandleForDriver[SDD_DEV_COUNT];  /* hCoANZXpnh */

#ifdef _SDD_PADDING_DMA_
UB gub_PadBuf[SDD_SECTOR_SIZE] ={0};
#ifdef _SDD_UNIPHIER_XP_
UB *gpub_PadBuf = (UB *)gub_PadBuf + 0x40000000;
#else
UB *gpub_PadBuf = (UB *)gub_PadBuf;
#endif /* _SDD_UNIPHIER_XP_ */
#endif /* _SDD_PADDING_DMA_ */

/* o͐R}hƂ̏֐̍\ */
typedef struct {
	WFP1 vp_Func;	/* o͐R}h֐ */
} SDD_IOCTL_FUNC_SET;


#ifdef _SDD_FUNC_SECURE_
#include "SddApi_secure.c"
#else
/* o͐R}he[u */
static const SDD_IOCTL_FUNC_SET	 Sdd_IocTab[] = {
	{Sdd_IocInit},			/* SD foCXhCo:SDD_IOC_INIT */
	{Sdd_IocSoftReset},		/* SD I/F\tgZbg:SDD_IOC_SOFT_RESET */
#ifdef _SDD_ENABLE_STANDBY_
	{Sdd_IocSetMode},		/* SD I/F[hݒ:SDD_IOC_SET_MODE */
#else
    {NULL},
#endif
	{Sdd_IocSetClockDiv},	/* SDNbNݒ:SDD_IOC_SET_CLOCK_DIV */
#ifdef _SDD_ENABLE_RINGBUF_
	{Sdd_IocSetRingBuff},	/* Oobt@ݒSDD_IOC_SET_RING_BUFF */
#else
	{NULL},
#endif
	{Sdd_IocSetEventCbf},	/* CxgR[obN֐o^SDD_IOC_SET_EVENT_CBF */
	{Sdd_IocCardInit},		/* J[hSDD_IOC_CARD_INIT */
	{Sdd_IocGetCardType},	/* J[h^Cv擾SDD_IOC_GET_CARD_TYPE */
	{Sdd_IocGetSectorSize},	/* ZN^TCY擾SDD_IOC_GET_SECTOR_SIZE */
	{Sdd_IocGetCardCapacity},	/* J[hTCY擾SDD_IOC_GET_CARD_CAPACITY */
	{Sdd_IocGetAreaSize},		/* ʏ̈TCY擾SDD_IOC_GET_AREA_SIZE */
	{Sdd_IocErase},			/* ʏ̈SDD_IOC_ERASE */
#ifdef _SDD_ENABLE_FLUSH_
	{Sdd_IocFlushBuf},		/* obt@tbVSDD_IOC_FLUSH_BUF */
#else
	{NULL},
#endif
	{Sdd_IocCheckWp},		/* CgveNg`FbNSDD_IOC_CHECK_WP */
	{Sdd_IocGetCardInfo},	/* J[h擾(CIDACSD擾)SDD_IOC_GET_CARD_INFO */
	{Sdd_IocGetStatus},		/* SDfoCXhCoXe[^X擾SDD_IOC_GET_STATUS */
	{Sdd_IocGetCardStatus},	/* J[hXe[^X擾SDD_IOC_GET_CARD_STATUS */
	{Sdd_IocGetSdStatus},	/* SDXe[^X擾SDD_IOC_GET_SD_STATUS */
	{Sdd_IocGetResult},		/* ʎ擾SDD_IOC_GET_RESULT */
#ifdef _SDD_SDUSB_TRANSFER_
	{Sdd_IocCancel},		/* LZSDD_IOC_CANCEL */
	{Sdd_IocUsbRead},		/* USBʏ̈惊[hSDD_IOC_USB_READ */
	{Sdd_IocUsbWrite},		/* USBʏ̈惉CgSDD_IOC_USB_WRITE */
	{Sdd_IocUsbHstGet},		/* USBF؃p[^̎擾SDD_IOC_USB_HST_GET */
	{Sdd_IocUsbHstSet},		/* USBF؃p[^̐ݒSDD_IOC_USB_HST_SET */
	{Sdd_IocUsbSetSecureAreaSize},	/* USBFؗ̈TCYݒ */
	{Sdd_IocUsbGetMKB},		/* USB MKB擾 */
	{Sdd_IocUsbSecureRead},	/* USBFؗ̈惊[hSDD_IOC_USB_SECURE_READ */
	{Sdd_IocUsbSecureWrite},	/* USBFؗ̈惉CgSDD_IOC_USB_SECURE_WRITE */
#else
	{NULL},
	{NULL},
	{NULL},
	{NULL},
	{NULL},
	{NULL},
	{NULL},
	{NULL},
	{NULL},
#endif
#ifdef _SDD_ENABLE_ENDIAN_
	{Sdd_IocEndian},		/* SDMAC`Endian̐ݒ */
#else
    {NULL},
#endif /* _SDD_ENABLE_ENDIAN_ */
#ifdef _SDD_ENABLE_IOC_READWRITE_
	{Sdd_IocRead},			/* ʏ̈惊[hSDD_IOC_READ */
	{Sdd_IocWrite},			/* ʏ̈惉CgSDD_IOC_WRITE */
#else
	{NULL},
	{NULL},
#endif /* _SDD_ENABLE_IOC_READWRITE_ */
#ifdef _SDD_ENABLE_VERSION_
	{Sdd_IocVersion},		/* SDDo[W擾SDD_IOC_VERSION */
#else
	{NULL},
#endif /* _SDD_ENABLE_VERSION_ */
#ifdef _SDD_RW_WAIT_
	{Sdd_IocSetRWWait},		/* RWR}hsOEFCgݒSDD_IOC_SET_RW_WAIT */
#else
	{NULL},
#endif
#ifdef _SDD_ENABLE_MCLK_CHANGE_
	{Sdd_IocChangeMclk},
#else
	{NULL},					/* ֐ */
#endif
#ifdef _SDD_ALLOW_MMC_
	{Sdd_IocGetExtCsd},		/* EXT-CSD擾(MMC Ver4.0ȏΏ) */
#else
    {NULL},
#endif
	{Sdd_IocSetCardFunc},	/* J[ht@NVݒ */
	{Sdd_IocSpeedClassRecording},	/* Xs[hNXΉL^ */
#ifdef _SDD_FUNC_SDIO_
    {Sdd_IocSetIoReadDirect},
    {Sdd_IocSetIoWriteDirect},
    {Sdd_IocSetIoReadExtended},
    {Sdd_IocSetIoWriteExtended},
#else
    {NULL},
    {NULL},
    {NULL},
    {NULL},
#endif
#ifdef _SDD_FUNC_QUICK_BOOT_
	{Sdd_IocSetBootInfo},
#else
	{NULL},
#endif
	{Sdd_IocGetErrInfo},
	{Sdd_IocSendSmart},
	{Sdd_IocSendCommand},
    {Sdd_IocGetRca},                  /* RCA擾SDD_IOC_GET_RCA */
    {Sdd_IocGetScr}                   /* Scr擾SDD_IOC_GET_SCR */
	};
#endif /* _SDD_FUNC_SECURE_ */

/* Tu֐t@C */
#include "SddSubr_api.c"

#ifdef _SDD_HWTIMER_SPEEDTEST_
/* HW^C}xpJE^ */
UW UwHwTimerStart1;                         /* HW^C}Jn_^C}l1 */
UW UwHwTimerStart2;                         /* HW^C}Jn_^C}l2 */
UW UwHwTimerStart3;                         /* HW^C}Jn_^C}l3 */
UW UwHwTimerEnd1;                           /* HW^C}I_^C}l1 */
UW UwHwTimerEnd2;                           /* HW^C}I_^C}l2 */
UW UwHwTimerEnd3;                           /* HW^C}I_^C}l3 */
UW UwSectors;                               /* Read/WriteZN^ */
#endif

int SDD_module_init( void )
{
	return 0;
}

void SDD_module_del( void )
{
}

/********************************************************************************/
/*  ֐		FSDD_Attach													*/
/*  Tv		FhCoo^֐												*/
/*  			FSDfoCXhCo̓o^sB								*/
/*  		FȂ 															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2004.1.22														*/
/********************************************************************************/
SDD_ERROR SDD_Attach( void )
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
    UW i;
	SDD_DEV *p_sdd;

	UW	uw_tmpDevID;

   Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Attach>\n");

	uw_tmpDevID = SDD_DEVICEID_NORMAL;

    /* hCop */
    Sdds_driver_init();

#ifdef _SDD_HWTIMER_SPEEDTEST_
    Sddr_SettingHWTimer();    /* HW^C}ԑp^C}ݒ */
    Sddr_StartHWTimer();      /* HW^C}ԑp^C}Jn */
#endif
    
    for(i=0; i<SDD_DEV_COUNT; i++) {
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Attach DevNo=%ld\n",i);
        p_sdd = &(SddDev[i]);
        /*==================================================*/
        /* rJn										*/
        /*	G[̏ꍇ̂݁AG[					*/
        /*		uh_ret |= G[lݒ						*/
        /*		ԑJځiSddDev[port].uh_Status = ύXj*/
        /*		return;										*/
        /*==================================================*/
        w_TmpRet = Sdds_StartExcl( &(SddHandleForDriver[i]), uw_tmpDevID );	
        if(w_TmpRet != SDD_SUCCESS){
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"A:%ld\n", w_ret);
            return w_ret;
        }
        do {	/* G[ɏbreak邽߂do-while(0) */
            /*==================================================================*/
            /* (SddDev[i].uh_Status)̃`FbN								*/
            /*	1)DETACH(0x00)̏ꍇAp									*/
            /*	2)LȊȌꍇAG[1iSDD_ERR_ALREADY_ATTACHEDj		*/
            /*	G[1F													*/
            /*		uh_ret |= G[lݒ;										*/
            /*		ԑJځiSddDev[i].uh_Status = ύXj					*/
            /*		return;														*/
            /* duh_status̒l͂ǂȂH							*/
            /*==================================================================*/
            if((Sdds_GetStatus(&(SddHandleForDriver[i])) & SDD_STATUS_MASK) != SDD_STATUS_DETACH){
                w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_ALREADY_ATTACHED);
                Sdds_DebugPrint(__LINE__, SDD_PERR,"A:%ld\n", w_ret);
                break;		/* ԃG[̂ߏI */
            }
            
            /* Attach̎
			O[oϐ
			NbNiIMCLK/IMCLK2j
			LSIZbg
			荞݋֎~iSDI/F-S&StreamDMACj
			荞݃R[obN NULLݒ
			荞݋iCDMł̃J[h}̂݋j
			Sdds_AttachSub()Ŏs 
             */
            /*	1)߂lIiSUCCESSj̏ꍇA
				rIցipj
			2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
				G[2F
				uh_ret |= G[lݒ;
				Z}tH(SEM_SDD)ԋp
				ԑJځiSddDev[port].uh_Status = ύXj
				return;
             */
            w_TmpRet = Sdds_AttachSub(&(SddHandleForDriver[i]));
#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait(&(SddHandleForDriver[0]), WAIT_ATTACH );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

            if(w_TmpRet != SDD_SUCCESS){
                w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, w_TmpRet);
                Sdds_DebugPrint(__LINE__, SDD_PERR,"A:%ld\n", w_ret);
                break;		/* A^b`G[̂ߏI */
            }

            /*==========================================*/
            /* ԑJځiattachցj						*/
            /*	SddDev[i].uh_StatusAttach&Closeݒ	*/
            /*==========================================*/
            Sdds_SetStatus(&(SddHandleForDriver[i]), (UH)(SDD_STATUS_ATTACHFLG | SDD_STATUS_CLOSE));
#ifdef _SDD_FUNC_SECURE_
            p_sdd->uh_SecureStatus = SDD_SECURE_STATUS_CLOSE;
#endif /* _SDD_FUNC_SECURE_ */

        } while(0);		/* [vł͂Ȃ(0) */

        /*==========================================*/
        /* rI  Z}tH(SEM_SDD)̊J	*/
        /*	G[̏ꍇ̂݁AG[
		uh_ret |= G[lݒ
		ԑJځiSddDev[i].uh_Status = ύXj
		return;
         */
        /*==========================================*/
        w_TmpRet = Sdds_EndExcl( &(SddHandleForDriver[i]),uw_tmpDevID );
        if(w_TmpRet != SDD_SUCCESS){
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"A:%ld\n", w_ret);
        }
    }
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<SDD_Attach w_ret = %ld\n", w_ret);

	return w_ret;
}

/********************************************************************************/
/*  ֐		FSDD_Close														*/
/*  Tv		FN[Y֐													*/
/*  			FfoCX̃N[YsB									*/
/*  		FSDD_HANDLE *p_Handle	[in] nh|C^(!=NULL)			*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2004.1.26														*/
/********************************************************************************/
SDD_ERROR SDD_Close(SDD_HANDLE *p_Handle)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	SDD_HANDLE	*p_tmpSddHandle;
#ifdef	_SDD_FUNC_SECURE_
	SDD_DEV	*p_sdd;
#endif /* _SDD_FUNC_SECURE_ */
	UW	uw_tmpDevID;
    UB  ub_TmpPort;
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Close>\n");
#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_Handle, WAIT_CLOSE );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */
    
	/* ֐ł̓Rs[gp */	
	p_tmpSddHandle = p_Handle;
	uw_tmpDevID = SDD_DEVICEID_NORMAL;

/*==================================================================================*/
/* ̃`FbN & ݒ															*/
/*	1)p_SddHandle == NULL̏ꍇAG[1(SDD_ERR_PARAM)							*/
/*	2)LȊȌꍇAp														*/
/*	G[1F																	*/
/*		uh_ret |= G[lݒ;														*/
/*		ԑJځiSddDev[port].uh_Status = ύXj								*/
/*		return;																		*/
/*==================================================================================*/
	if(p_tmpSddHandle == NULL){
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_PARAM);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld\n", w_ret);
		return w_ret;
	}
	else if (p_tmpSddHandle->vp_Sdif == NULL){
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld\n", w_ret);
		return w_ret;
	}
    else if (p_tmpSddHandle->ub_Port > SDD_DEV_COUNT) {
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld\n", w_ret);
		return w_ret;
    }
    else if (SddHandleForDriver[Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)].vp_Sdif != p_tmpSddHandle->vp_Sdif) {
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld\n", w_ret);
		return w_ret;
    }
    ub_TmpPort = Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port);  /* Ō̃Z}tHpɃ|[gԍL */

#ifdef	_SDD_FUNC_SECURE_
    p_sdd = p_Handle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    /* Closes̈m */
	if(p_tmpSddHandle == p_sdd->p_NormalHandle){
		uw_tmpDevID = SDD_DEVICEID_NORMAL;
	}
	else if(p_tmpSddHandle == p_sdd->p_SecureHandle){
		uw_tmpDevID = SDD_DEVICEID_SECURE;
	}
	p_sdd -> p_Handle = p_tmpSddHandle;
#endif	/* _SDD_FUNC_SECURE_ */

/*==================================================*/
/* rJn 									*/
/*	G[̏ꍇ̂݁AG[1					*/
/*	G[1F									*/
/*		uh_ret |= G[lݒ						*/
/*		ԑJځiSddDev[port].uh_Status = ύXj*/
/*		return;										*/
/*==================================================*/
	w_TmpRet = Sdds_StartExcl(p_tmpSddHandle, uw_tmpDevID );	
	if(w_TmpRet != SDD_SUCCESS){
        /* Sdds_StartExclpG[ */
        w_ret = Sdds_StartExclError(p_tmpSddHandle, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                        w_ret,
                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
		return w_ret;
	}

	do {	/* G[ɏbreak邽߂do-while(0) */

		/*==========================================================*/
		/* (SddDev[port].uh_Status)̃`FbN					*/
		/* ʏSDDD̏ꍇ											*/
		/*	1)OPEN(0x01)̏ꍇAp							*/
		/*	2)DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED)	*/
		/*	3)LȊȌꍇAG[1(SDD_ERR_STATUS)			*/
		/*	G[1F											*/
		/*		uh_ret |= G[lݒ;								*/
		/*		ԑJځiSddDev[port].uh_Status = ύXj		*/
		/*		return;												*/
		/* FSDDD̏ꍇ											*/
		/*	1)FOPEN(p_SecureHandle != NULL)̏ꍇAp		*/
		/* 	FOpenȊONGȂ̂ňȉŃG[R[h			*/
		/*	2)FCLOSE(p_SecureHandle == NULL)̏ꍇ				*/
		/*	   G[1(SDD_ERR_NOT_OPEND)						*/
		/*	3)DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED)	*/
		/*	4)ʏOpen/ClosȅꍇAp						*/
		/*	5)LȊȌꍇAG[1(SDD_ERR_STATUS)			*/
		/*	G[1F											*/
		/* 		uh_ret |= G[lݒ;								*/
		/* 		ԑJځiSddDev[port].uh_Status = ύXj		*/
		/*		return;												*/
		/*==========================================================*/
#ifdef	_SDD_FUNC_SECURE_
		if( uw_tmpDevID == SDD_DEVICEID_NORMAL ){
#endif	/* _SDD_FUNC_SECURE_ */
		if ((Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK) != SDD_STATUS_OPEN){
			switch(Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK){
				case SDD_STATUS_DETACH:	/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */	
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
					break;
				case SDD_STATUS_CLOSE:	/* CLOSE(0x02)̏ꍇAG[1(SDD_ERR_NOT_OPENED) */
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_OPENED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
					break;
				default:				/* LȊȌꍇAG[1(SDD_ERR_STATUS) */
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STATUS);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
					break;
			}

			break;		/* ԃG[̂ߏ~ */
		}
#ifdef	_SDD_FUNC_SECURE_
		}
		if( uw_tmpDevID == SDD_DEVICEID_SECURE ){
			if((p_sdd->uh_SecureStatus & SDD_STATUS_MASK) != SDD_SECURE_STATUS_OPEN){
				switch(p_sdd->uh_SecureStatus & SDD_STATUS_MASK){
					case SDD_SECURE_STATUS_CLOSE:	/* CLOSE(0x02)̏ꍇAG[1(SDD_ERR_NOT_OPENED) */
                        w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_OPENED);
                        Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                                        w_ret,
                                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
                        break;
					default:
						/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */	
						if((Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK) == SDD_STATUS_DETACH){
                            w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                            Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                                            w_ret,
                                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
						break;
						}
						else {
							w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STATUS);
                            Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                                            w_ret,
                                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
							/* LȊȌꍇAG[1(SDD_ERR_STATUS) */
						}
						break;
				}
					break;		/* ԃG[̂ߏ~ */
				}
			}

		/* nh|C^͐ݒς݂̗̈悩ǂ̃`FbN */
		if( (p_tmpSddHandle != p_sdd->p_NormalHandle)
		 && (p_tmpSddHandle != p_sdd->p_SecureHandle) ){
			w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
			break;
		}
#endif	/* _SDD_FUNC_SECURE_ */

		/* Close̎
			SDD_HANDLESDD_DEṼ|C^NA
			SDD_HANDLEɃ|[gԍNA
			Sdds_CloseSub()Ŏs 
		*/
		/*
			1)߂lIiSUCCESSj̏ꍇA
				rIցipj
			2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
				G[2F
				uh_ret |= G[lݒ;
				Z}tH(SEM_SDD)ԋp
				return;
		*/
		w_TmpRet = Sdds_CloseSub(p_tmpSddHandle);

		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(&(SddHandleForDriver[ub_TmpPort]), __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
			break;		/* N[YG[̂ߏ~ */
		}

		/*==============================*/
		/* ԑJځiOPENCLOSEj		*/
		/*	CLOSEԂɑJ				*/
		/* ʏSDDD̏ꍇ				*/
		/* 	uh_StatusCloseɕύX		*/
		/* 	p_NormalHandleNULLݒ	*/
		/* FSDDD̏ꍇ				*/
		/*  p_SecureHandleNULLɐݒ	*/
		/*==============================*/
#ifdef	_SDD_FUNC_SECURE_
		if( uw_tmpDevID == SDD_DEVICEID_NORMAL ){
			Sdds_SetStatus(&(SddHandleForDriver[ub_TmpPort]), (Sdds_GetStatus(&(SddHandleForDriver[ub_TmpPort])) & ~SDD_STATUS_MASK) | SDD_STATUS_CLOSE);
			p_sdd->p_NormalHandle = NULL;
		}
		else{
			p_sdd->uh_SecureStatus = (p_sdd->uh_SecureStatus & ~SDD_STATUS_MASK) | SDD_SECURE_STATUS_CLOSE;
			p_sdd->p_SecureHandle = NULL;
		}
		p_sdd -> p_Handle = NULL;
#else	/* _SDD_FUNC_SECURE_ */
		Sdds_SetStatus(&(SddHandleForDriver[ub_TmpPort]), (Sdds_GetStatus(&(SddHandleForDriver[ub_TmpPort])) & ~SDD_STATUS_MASK) | SDD_STATUS_CLOSE);
#endif	/* _SDD_FUNC_SECURE_ */

	} while(0);		/* [vł͂Ȃ(0) */

/*==================================================*/
/* rI 									*/
/*	G[̏ꍇ̂݁AG[					*/
/*		uh_ret |= G[lݒ						*/
/*		ԑJځiSddDev[port].uh_Status = ύXj*/
/*		return;										*/
/*==================================================*/
	w_TmpRet = Sdds_EndExcl(&(SddHandleForDriver[ub_TmpPort]), uw_tmpDevID );
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(&(SddHandleForDriver[ub_TmpPort]), __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"C:%ld %04X %04X\n",
                        w_ret,
                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
	}
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<SDD_Close w_ret = %ld\n", w_ret);

	return w_ret;
}

/********************************************************************************/
/*  ֐		FSDD_Detach													*/
/*  Tv		FhCoo^֐											*/
/*  			FSDfoCXhCo̓o^sB							*/
/*  		FȂ 															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2004.1.22														*/
/********************************************************************************/
SDD_ERROR SDD_Detach(void)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
    UW i;
	SDD_DEV *p_sdd;

	UW	uw_tmpDevID;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Detach>\n");
#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( &(SddHandleForDriver[0]), WAIT_DETACH );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */
#ifdef _SDD_HWTIMER_SPEEDTEST_
    Sddr_StopHWTimer();      /* HW^C}ԑp^C}~ */
#endif
	uw_tmpDevID = SDD_DEVICEID_NORMAL;

    for(i=0; i<SDD_DEV_COUNT; i++) {
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Detach DevNo=%ld\n",i);
        p_sdd = &(SddDev[i]);
        /*==================================================*/
        /* rJn  Z}tH(SEM_SDD)̊l			*/
        /*	G[̏ꍇ̂݁AG[1					*/
        /*	G[1F									*/
        /*		uh_ret |= G[lݒ						*/
        /*		ԑJځiSddDev[i].uh_Status = ύX)	*/
        /*		return;										*/
        /*==================================================*/
        w_TmpRet = Sdds_StartExcl( &(SddHandleForDriver[i]), uw_tmpDevID );

        if(w_TmpRet != SDD_SUCCESS){
            /* Sdds_StartExclpG[ */
            w_ret = Sdds_StartExclError(&(SddHandleForDriver[i]), w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"D:%ld\n", w_ret);
            return w_ret;
        }
	
        do {	/* G[ɏbreak邽߂do-while(0) */
            /*==========================================================================*/
            /* (SddDev[i].uh_Status)̃`FbN										*/
            /*	1)CLOSE(0x02)̏ꍇAp											*/
            /*	2)DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED)					*/
            /*	3)LȊȌꍇAG[1iSDD_ERR_STATUS)							*/
            /*	G[1F															*/
            /*		uh_ret |= G[lݒ;												*/
            /*		ԑJځiSddDev[i].uh_Status = ύXj							*/
            /*		return;																*/
            /*==========================================================================*/
            if((Sdds_GetStatus(&(SddHandleForDriver[i])) & SDD_STATUS_MASK) != SDD_STATUS_CLOSE){
                switch(Sdds_GetStatus(&(SddHandleForDriver[i])) & SDD_STATUS_MASK){
                  case SDD_STATUS_DETACH:	/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */
                    w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"D:%ld\n", w_ret);
                    break;
                  default:				/* LȊȌꍇAG[1(SDD_ERR_STATUS)			*/
					w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_STATUS);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"D:%ld\n", w_ret);
					break;
                }

                break;		/* ԃG[̂ߏ~ */
            }

#ifdef _SDD_FUNC_SECURE_
            if((p_sdd->uh_SecureStatus & SDD_STATUS_MASK) != SDD_SECURE_STATUS_CLOSE){
                switch(Sdds_GetStatus(&(SddHandleForDriver[i])) & SDD_STATUS_MASK){
                  case SDD_STATUS_DETACH:	/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */
                    w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"D:%ld\n", w_ret);
                    break;
                  default:				/* LȊȌꍇAG[1(SDD_ERR_STATUS)			*/
                    w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_STATUS);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"D:%ld\n", w_ret);
					break;
                }

                break;		/* ԃG[̂ߏ~ */
            }
#endif /* _SDD_FUNC_SECURE_ */

            /* Detach̎
			荞݋֎~iSDI/F-S&StreamDMACj
			荞݃R[obN֐̃NA
			Sdds_DetachSub()Ŏs 
             */
            /*
			1)߂lIiSUCCESSj̏ꍇA
				rIցipj
			2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
				G[2F
				uh_ret |= G[lݒ;
				Z}tH(SEM_SDD)ԋp
				return;
             */
            w_TmpRet = Sdds_DetachSub(&(SddHandleForDriver[i]));

            if(w_TmpRet != SDD_SUCCESS){
                w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, w_TmpRet);
                Sdds_DebugPrint(__LINE__, SDD_PERR,"D:%ld\n", w_ret);

                break;		/* f^b`G[̂ߏ~ */
            }

            /*==================================*/
            /* ԑJځidetachցj				*/
            /*	SddDev[i].uh_StatusDetachݒ	*/
            /*	J[hς݃tONA	*/
            /*==================================*/
            Sdds_SetStatus(&(SddHandleForDriver[i]), SDD_STATUS_DETACH);

#ifdef _SDD_FUNC_SECURE_
            /* uh_SecureStatusNA邽SDD_STATUS_CLEARݒ */
            p_sdd->uh_SecureStatus = SDD_SECURE_STATUS_CLEAR;
#endif /* _SDD_FUNC_SECURE_ */
            
        } while(0);		/* [vł͂Ȃ(0) */

        /*==================================================*/
        /* rI  									*/
        /*	G[̏ꍇ̂݁AG[					*/
        /*		uh_ret |= G[lݒ						*/
        /*		ԑJځiSddDev[i].uh_Status = ύXj	*/
        /*		return;										*/
        /*==================================================*/
        w_TmpRet = Sdds_EndExcl( &(SddHandleForDriver[i]), uw_tmpDevID );

        if(w_TmpRet != SDD_SUCCESS){
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"D:%ld\n", w_ret);
        }
    }

    /* hCop폜 */
    Sdds_driver_exit();
    
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<SDD_Detach w_ret = %ld\n", w_ret);
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSDD_Init														*/
/*  Tv		FVXeSDfoCXhCȍsiۂ̓_~[)	*/
/*  		FȂ 															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2004.2.22														*/
/********************************************************************************/
void SDD_Init( void )
{
    UW i;
	UW	uw_tmpDevID;

	uw_tmpDevID = SDD_DEVICEID_NORMAL;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Init>\n");
 /* SddDev̏sĖȂ̔fKv */
    for(i=0; i<SDD_DEV_COUNT; i++) {
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Init DevNo=%ld\n",i);
        Sdds_SetHandle(&(SddHandleForDriver[i]), i);
        Sdds_InitData(&(SddHandleForDriver[i]));
    }
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<SDD_Init\n");
	return;
}

/********************************************************************************/
/*  ֐		FSDD_Ioctl														*/
/*  Tv		Fo͐֐												*/
/*  			FSD I/F̓o͐sB									*/
/*  		FSDD_HANDLE *p_Handle	[in] nh|C^(!=NULL)			*/
/*				FUH uh_Cmd				[in] o̓R}h						*/
/*				FUW uw_Arg				[in] R}h						*/
/*				Fvoid *pv_Arg			[in/out] R}h̃|C^			*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2007.6.18														*/
/********************************************************************************/
SDD_ERROR SDD_Ioctl(SDD_HANDLE *p_Handle, UH uh_Cmd, UW uw_Arg, void *pv_Arg)
{
	/* ߂lɏlݒ */
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	SDD_HANDLE	*p_tmpSddHandle;
	UH uh_tmpStatus = 0;
	SDD_DEV	*p_sdd = NULL; /* pgr0060 */
	UW	uw_Mode = (UW)0;
	UW	uw_tmpDevID;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Ioctl> uh_Cmd = %x uw_Arg=%ld pv_Arg=%lX\n", uh_Cmd, uw_Arg, (UW)pv_Arg);
#ifdef _SDD_DEBUG_REGISTER_
    /* 
     * ł́AWX^pr̃fobOR}hIOCTLĂяo
     * fobOpr̃R}h́A`FbNs킸ɏs
     */
    if (uh_Cmd == SDD_IOC_DEBUG_REGISTER) {
        /* WX^Read/WriteR}h */
        SDD_DEBUG_REGISTER *p_SddDr = (SDD_DEBUG_REGISTER *)pv_Arg;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_RegAddr = %lX\n", p_SddDr->uw_RegAddr);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"ub_Direction = %d\n", p_SddDr->ub_Direction);
        if (p_SddDr->ub_Direction == SDD_IOC_DEBUG_REGISTER_WRITE) {
            /* f[^ */
            Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uh_Data = %X\n", p_SddDr->uh_Data);
            Sdd_M_SetReg((*(SDD_VULH *)(p_SddDr->uw_RegAddr)), p_SddDr->uh_Data);
        }
        else {
            /* f[^擾 */
            Sdd_M_GetReg((*(SDD_VULH *)(p_SddDr->uw_RegAddr)), p_SddDr->uh_Data);
            Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uh_Data = %X\n", p_SddDr->uh_Data);
        }
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<SDD_Ioctl w_ret = %ld\n", SDD_SUCCESS);
        return SDD_SUCCESS;
    }
#endif

	uw_tmpDevID = SDD_DEVICEID_NORMAL;

	/* ̃Rs[ */
	p_tmpSddHandle = p_Handle;
/*==================================================================================*/
/* ̃`FbN & ݒ															*/
/*	1)p_tmpSddHandle == NULL && Õn̏ȊȌꍇAG[1(SDD_ERR_PARAM)*/
/*	2)uh_tmpCmd > CMD_MAX̏ꍇAG[1(SDD_ERR_COMMAND)						*/
/*  3)ÕR}hŃnhNULLȊȌꍇAG[1(SDD_ERR_PARAM)			*/
/*	4)LȊȌꍇAp														*/
/*	G[1F																	*/
/*		uh_ret |= G[lݒ;														*/
/*		ԑJځiSddDev[port].uh_Status = ύXj								*/
/*		return;																		*/	
/*==================================================================================*/
#ifdef	_SDD_ANGOU_
	if ( ( p_tmpSddHandle != NULL ) && ( SDD_IOC_ANGOU_CMD_START <= uh_Cmd ) && ( uh_Cmd <= SDD_IOC_ANGOU_MAX ) ) {	/* MILN_SDD006 */
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret,  SDD_ERR_ILLEGAL_HANDLE);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld\n", uh_Cmd, w_ret);
		return w_ret;
	} else 
#endif /* _SDD_ANGOU_ */
	if( ( p_tmpSddHandle == NULL )
#ifdef	_SDD_ANGOU_
		&& ( uh_Cmd < SDD_IOC_ANGOU_CMD_START )
#endif /* _SDD_ANGOU_ */	
	){
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_PARAM);
		if ((uh_Cmd == SDD_IOC_READ) || (uh_Cmd == SDD_IOC_WRITE)){
            p_sdd = SddHandleForDriver[0].vp_Sdif;
			p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
		}
        Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld\n", uh_Cmd, w_ret);
		return w_ret;
	}
	else if (
#ifdef _SDD_ANGOU_
		( p_tmpSddHandle != NULL ) &&
		(( uh_Cmd < SDD_IOC_ANGOU_CMD_START ) || ( uh_Cmd > SDD_IOC_ANGOU_MAX )) && 
#endif	/* _SDD_ANGOU_ */
		(p_tmpSddHandle->vp_Sdif == NULL)
	){
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
		if ((uh_Cmd == SDD_IOC_READ) || (uh_Cmd == SDD_IOC_WRITE)){
            p_sdd = SddHandleForDriver[0].vp_Sdif;
			p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
		}
        Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld\n", uh_Cmd, w_ret);
		return w_ret;
	}
	else if( (uh_Cmd > (SDD_CMD_MAX - 1)) || (Sdd_IocTab[uh_Cmd].vp_Func == NULL) ) {
		w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		if ((uh_Cmd == SDD_IOC_READ) || (uh_Cmd == SDD_IOC_WRITE)){
            p_sdd = SddHandleForDriver[0].vp_Sdif;
			p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
		}
        Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld\n", uh_Cmd, w_ret);
		return w_ret;
	}

	/* ÕR}hȊOɑ΂Ă̂ݍs̃`FbN & ݒ */
#ifdef _SDD_ANGOU_
	if (p_tmpSddHandle != NULL) {
#endif /* _SDD_ANGOU_ */
		if (p_tmpSddHandle->ub_Port > SDD_DEV_COUNT) {
			w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
			Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld\n", uh_Cmd, w_ret);
			return w_ret;
		}
		else if (SddHandleForDriver[Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)].vp_Sdif != p_tmpSddHandle->vp_Sdif) {
			w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
			Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld\n", uh_Cmd, w_ret);
			return w_ret;
		}

		p_sdd = p_tmpSddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#ifdef _SDD_ANGOU_
	}
#endif /* _SDD_ANGOU_ */

#ifdef	_SDD_FUNC_SECURE_
	/* IOCTLs̈m */
#ifdef _SDD_ANGOU_
	if ( p_tmpSddHandle == NULL ){
        /* AngouW[NULLœnĂׁAPort0̃nhn(ÍgKvꍇɂ́AÍLib݂ŃI[vɎ{悤ɕύXKv) */
        p_tmpSddHandle = &(SddHandleForDriver[0]);
		p_sdd = p_tmpSddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
		uw_tmpDevID = 0;
	} else 
#endif /* _SDD_ANGOU_ */
	if(p_tmpSddHandle == p_sdd->p_NormalHandle){ /* pgr0060 */
		uw_tmpDevID = SDD_DEVICEID_NORMAL;
	}
	else if(p_tmpSddHandle == p_sdd->p_SecureHandle){
		uw_tmpDevID = SDD_DEVICEID_SECURE;
	}
	p_sdd -> p_Handle = p_tmpSddHandle;
#endif	/* _SDD_FUNC_SECURE_ */	
#ifdef _SDD_HWTIMER_SPEEDTEST_
    UwHwTimerStart1 = Sddr_GetHWTimer();      /* HW^C}ԑp^C}擾 */
#endif

/*==================================================*/
/* rJn										*/
/*	G[̏ꍇ̂݁AG[1					*/
/*	G[1F									*/
/*		uh_ret |= G[lݒ						*/
/*		ԑJځiSddDev[port].uh_Status = ύXj*/
/*		return;										*/
/*==================================================*/
	w_TmpRet = Sdds_StartExcl(p_tmpSddHandle, uw_tmpDevID );	

	if(w_TmpRet != SDD_SUCCESS){
        /* Sdds_StartExclpG[ */
        w_ret = Sdds_StartExclError(p_tmpSddHandle, w_TmpRet);
		if ((uh_Cmd == SDD_IOC_READ) || (uh_Cmd == SDD_IOC_WRITE)){
			p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
		}
            Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                            uh_Cmd,
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
		return w_ret;
	}

    /* IOCTL֐Os */
    SDD_Ioctl_before(p_tmpSddHandle);

	do {	/* G[ɏbreak邽߂do-while(0) */
		/*==================================================================*/
		/* (SddDev[port].uh_Status)̃`FbN							*/
		/*	ʏSDDDR}h̏ꍇ											*/
		/*	1)OPEN(0x01)̏ꍇA											*/
		/*		ԑJڏiSddDev[port].uh_Statusj̕ۑ ub_tmpStatus	*/
		/*		p													*/
		/*	2)DETACH(0x00)̏ꍇAG[1iSDD_ERR_NOT_ATTACHED)		*/
		/*	3)CLOSE(0x02)̏ꍇAG[1iSDD_ERR_NOT_OPENED)			*/
		/*	4)USB_R/W(0x02)̏ꍇAIOCTL̃`FbN							*/
		/*		4-1)LZAʎ擾̏ꍇ						*/
		/*			ԑJڏiSddDev[port].uh_Statusj̕ۑ ub_tmpStatus*/
		/*			p												*/
		/*		4-2)LȊȌꍇAG[1iSDD_ERR_STATUS)			*/
		/*	5)LȊȌꍇAG[1iSDD_ERR_STATUS)					*/
		/*	G[1F													*/
		/*		uh_ret |= G[lݒ;										*/
		/*		ԑJځiSddDev[port].uh_Status = ύXj				*/
		/*		return;														*/
		/*	FSDDDR}h̏ꍇ											*/
		/*	1)FOPEN(p_SecureHandle != NULL)̏ꍇAp				*/
		/* 	FOpenȊONGȂ̂ňȉŃG[R[h					*/
		/*	2)FCLOSE(p_SecureHandle == NULL)̏ꍇ						*/
		/*	   G[1(SDD_ERR_NOT_OPEND)								*/
		/*	3)DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED)			*/
		/*	4)ʏOpen/ClosȅꍇAp								*/
		/*	5)LȊȌꍇAG[1(SDD_ERR_STATUS)					*/
		/*	G[1F													*/
		/* 		uh_ret |= G[lݒ;										*/
		/* 		ԑJځiSddDev[port].uh_Status = ύXj				*/
		/*==================================================================*/
#ifdef	_SDD_FUNC_SECURE_
		if( uw_tmpDevID == SDD_DEVICEID_NORMAL ){
#endif	/* _SDD_FUNC_SECURE_ */
			switch (Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK) {
				case SDD_STATUS_DETACH:
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                    uh_Cmd,
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
				case SDD_STATUS_CLOSE:
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_OPENED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                    uh_Cmd,                                    
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
				case SDD_STATUS_OPEN:
					/* p */
					break;
				case SDD_STATUS_USB_RW:
					if ((uh_Cmd == SDD_IOC_GET_RESULT) || (uh_Cmd == SDD_IOC_CANCEL)){
						/* p */
					}
					else {
						w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STATUS);
                        Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                        uh_Cmd,
                                        w_ret,
                                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        p_sdd->SddCommandSendData.uh_Cmd);
					}
					break;
				default:	
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STATUS);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                    uh_Cmd,
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
			}
			if(w_ret != SDD_SUCCESS){
				break;		/* ԃG[̂ߏ~ */
			}
#ifdef	_SDD_FUNC_SECURE_
		}

		if( uw_tmpDevID == SDD_DEVICEID_SECURE ){
			switch (p_sdd->uh_SecureStatus & SDD_STATUS_MASK) {
				case SDD_SECURE_STATUS_CLOSE:
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_OPENED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                    uh_Cmd,
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
				case SDD_SECURE_STATUS_OPEN:
					/* USB RWԂ̏ꍇ̓G[ */
					if((Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK) == SDD_STATUS_USB_RW){
						w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STATUS);
                        Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                        uh_Cmd,
                                        w_ret,
                                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        p_sdd->SddCommandSendData.uh_Cmd);
					}
					/* p */
					break;
				default:
					/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */	
					if((Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK) == SDD_STATUS_DETACH){
						w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                        Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                        uh_Cmd,
                                        w_ret,
                                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        p_sdd->SddCommandSendData.uh_Cmd);
						break;
					}
					else {
						w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STATUS);
                        Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                        uh_Cmd,
                                        w_ret,
                                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        p_sdd->SddCommandSendData.uh_Cmd);
						break;
					}
			}
			if(w_ret != SDD_SUCCESS){
				break;		/* ԃG[̂ߏ~ */
			}
		}

#ifdef _SDD_ANGOU_
		if ( uw_tmpDevID == 0 ) {
			switch ( Sdds_GetStatus(p_tmpSddHandle) ) {
				case SDD_STATUS_DETACH:
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                    uh_Cmd,
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
				default:	/* AttachԂ̏ꍇAp */
					break;
			}
			
			if(w_ret != SDD_SUCCESS){	/* MILN_SDD003 */
				break;		/* ԃG[̂ߏ~ */
			}
		}
#endif /* _SDD_ANGOU_ */	

		/* nh|C^/R}h`FbN */
		/* nh|C^͐ݒς݂̗̈悩ǂ̃`FbN */
		/* ʏHandleł̔F؃R}hsNG`FbN */
		/* FHnadleł̒ʏR}hsNG`FbN */
		w_TmpRet = Sdds_HandleCMDCheck( p_tmpSddHandle, uh_Cmd );
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                            uh_Cmd,
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
#endif	/* _SDD_FUNC_SECURE_ */

		/* 
			STANBY[hΉ
			STANDBYԂł͈ȉ̊֐̂IMCLKONɂĎs
				SDD_IOC_INIT
				SDD_IOC_SET_MODE
				SDD_IOC_GET_STATUS
				SDD_IOC_SET_RING_BUFF
				SDD_IOC_SET_EVENT_CBF
			L֐ȊO
			STANBY[h̏ꍇ̓ANZXG[
		*/
		w_TmpRet = Sddr_GetMode(p_tmpSddHandle,&uw_Mode);
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                            uh_Cmd,
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
		if(uw_Mode == SDD_MODE_STANDBY){
			switch(uh_Cmd){
				case SDD_IOC_INIT:
				case SDD_IOC_SET_RING_BUFF:
				case SDD_IOC_SET_EVENT_CBF:
				case SDD_IOC_VERSION:
				case SDD_IOC_SET_RW_WAIT:
						w_TmpRet = Sddr_SetMode(p_tmpSddHandle,SDD_MODE_NORMAL);
						if(w_TmpRet != SDD_SUCCESS){
							w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
                            Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                            uh_Cmd,
                                            w_ret,
                                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                            p_sdd->SddCommandSendData.uh_Cmd);
						}
						break;
				case SDD_IOC_SET_MODE:
				case SDD_IOC_GET_STATUS:
				case SDD_IOC_CHANGE_MCLK:
						break;	/* SDD_IOC_SET_MODE,SDD_IOC_GET_STATUSSTANDBY[hɐݒ肷֐̂IMCLKo͂Ȃ */
				default:
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STANDBY);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                    uh_Cmd,
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					p_sdd->Result.w_Result = w_ret;
					break;
			}
		}
		if(w_ret != SDD_SUCCESS){
			break;		/* STANDBY[hG[̂ߏ~ */
		}

		uh_tmpStatus = Sdds_GetStatus(p_tmpSddHandle);	/* ԑJڏiSddDev[port].uh_Statusj̕ۑ */

#ifdef _SDD_FUNC_SDIO_
        /* 샂[hɂT|[g`FbN */
        switch(uh_Cmd) {
          case SDD_IOC_INIT:
          case SDD_IOC_SOFT_RESET:
          case SDD_IOC_SET_MODE:
          case SDD_IOC_SET_CLOCK_DIV:
          case SDD_IOC_SET_EVENT_CBF:
          case SDD_IOC_CARD_INIT:
          case SDD_IOC_GET_CARD_TYPE:
          case SDD_IOC_GET_STATUS:
          case SDD_IOC_VERSION:
          case SDD_IOC_CHANGE_MCLK:
            /* [hɂ炸T|[g{R}ḧׁAȂ */
            w_TmpRet = SDD_SUCCESS;
            break;
          case SDD_IOC_SETIO_READ_DIRECT:
          case SDD_IOC_SETIO_WRITE_DIRECT:
          case SDD_IOC_SETIO_READ_EXTENDED:
          case SDD_IOC_SETIO_WRITE_EXTENDED:
            /* SDIOpR}hŃ`FbN */
            w_TmpRet = Sdds_OperationModeCheck(p_tmpSddHandle, SDD_CARD_INIT_MODE_SDIO);
            break;
          default:
            /* pR}hƂă`FbN */
            w_TmpRet = Sdds_OperationModeCheck(p_tmpSddHandle, SDD_CARD_INIT_MODE_MEMORY);
            break;
        }
        if(w_TmpRet != SDD_SUCCESS){
            w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                            uh_Cmd,
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
        }
#endif /* _SDD_FUNC_SDIO_ */

		/* J[hL&ς݃`FbN */
		w_TmpRet = Sdds_CardInitcheck( p_tmpSddHandle, uh_Cmd );
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                            uh_Cmd,
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}

		/* ֐e[uvp_Func()ɐݒ肷 */
		w_TmpRet = CheckAndSetArgPointer( p_tmpSddHandle, uh_Cmd, &uw_Arg, pv_Arg );
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                            uh_Cmd,
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}

#ifdef	_SDD_ANGOU_
		if ( uw_tmpDevID ){
#endif /* _SDD_ANGOU_ */
			w_TmpRet = Sdds_ChangeState( p_tmpSddHandle, uh_Cmd, uw_tmpDevID, TRUE);
#ifdef	_SDD_ANGOU_
		}
#endif /* _SDD_ANGOU_ */

		/* IOCTL̎ */
		/*==========================================================*/
		/* o͐R}hsiӂɌ肷j 				*/
		/*	SddIoctlTbl[uh_Cmd].pvFunc(p_tmpSddHandle, uw_Arg)		*/
		/*	e͎ۂɂ͊eIOCTL֐Ŏs				*/
		/*	ԑJځiSddDev[port].uh_StatusIOCTRLEUSB_RWԂցj*/
		/*==========================================================*/
		/*
			1)߂lIiSUCCESSj̏ꍇA
				rIցipj
			2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
				G[2F
				uh_ret |= G[lݒ;
				Z}tH(SEM_SDD)ԋp
				ԑJڂȌԂɖ߂
				iSddDev[port].uh_Status = ub_tmpStatusj
				return;
		*/
        /* Xe[^Xj^[ɂIOCTLR}hi[ */
        setIoctlStatusMonitor();

#ifdef _SDD_SDCARDINOUT_KENSHO_
		Sdd_CardinoutKenshoWait( p_Handle, WAIT_IOCTL );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

		w_TmpRet = Sdd_IocTab[uh_Cmd].vp_Func(p_tmpSddHandle, uw_Arg);

		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                            uh_Cmd,
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			if(Sdds_GetStatus(p_tmpSddHandle) & (SDD_STATUS_IOCTL | SDD_STATUS_USB_RW)){
				if(uh_Cmd != SDD_IOC_CARD_INIT) {
					Sdds_SetStatus(p_tmpSddHandle, uh_tmpStatus);
				}
				else {
					Sdds_SetStatus(p_tmpSddHandle, uh_tmpStatus & ~SDD_STATUS_INITFLG);
				}
			}
		}

		/* ܂Ƃ߂ďԑJ */
		/* F؃R}hSecureOpenŖȂ */
		/* G[͔Ȃ */
		w_TmpRet = Sdds_ChangeState( p_tmpSddHandle, uh_Cmd, uw_tmpDevID, FALSE);
	} while(0);	/* [vł͂Ȃ(0) */

	/* 
		STANBY[hΉ
		STANBY[h̏ꍇ͒ʏ탂[hiIMCLKONjɑJڂ
		J[h}mČɖ߂
		(SDD_IOC_SET_MODEIMCLK̐ݒ֐̂ߐݒ肵Ȃ)
	*/
	if(uw_Mode == SDD_MODE_STANDBY){
		if(!((uh_Cmd == SDD_IOC_SET_MODE) || (uh_Cmd == SDD_IOC_GET_STATUS) || (uh_Cmd == SDD_IOC_CHANGE_MCLK))){
			w_TmpRet = Sddr_SetMode(p_tmpSddHandle, SDD_MODE_STANDBY);
			if(w_TmpRet != SDD_SUCCESS){
				w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
                Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                                uh_Cmd,
                                w_ret,
                                (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                p_sdd->SddCommandSendData.uh_Cmd);
			}
		}
	}

/*==============================================*/
/* rI  								*/
/*	G[̏ꍇ̂݁AG[				*/
/*		uh_ret |= G[lݒ					*/
/*		ԑJڂȌԂɖ߂				*/
/*		iSddDev[port].uh_Status = ub_tmpStatusj	*/
/*		return;									*/
/*==============================================*/
	w_TmpRet = Sdds_EndExcl( p_tmpSddHandle, uw_tmpDevID );
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                        uh_Cmd,
                        w_ret,
                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        p_sdd->SddCommandSendData.uh_Cmd);
	}

/*===============================================*/
/*	ԑJڂ͂ȂiIOCTL̎֐̓Ŏ{) */
/*	IOCTLԂUSB-R/WԂ邽			 */
/*===============================================*/
	if((uh_Cmd == SDD_IOC_READ) && (w_ret != SDD_SUCCESS)){
		p_sdd->Result.uw_Resid = 0;	/* Readł́AƂ]̂͊̌̏ŃG[ꍇłA]ZN^0ɂ */
	}
    if (    uh_Cmd == SDD_IOC_READ
         || uh_Cmd == SDD_IOC_WRITE
         || uh_Cmd == SDD_IOC_ERASE
#ifdef _SDD_FUNC_SECURE_
         || uh_Cmd == SDD_IOC_GET_MKB
         || uh_Cmd == SDD_IOC_SECURE_ERASE
         || uh_Cmd == SDD_IOC_SECURE_READ
         || uh_Cmd == SDD_IOC_SECURE_WRITE
#endif /* _SDD_FUNC_SECURE_ */
#ifdef _SDD_SDUSB_TRANSFER_
        || uh_Cmd == SDD_IOC_USB_READ
        || uh_Cmd == SDD_IOC_USB_WRITE
#ifdef _SDD_SDUSB_SECURE_
        || uh_Cmd == SDD_IOC_USB_GET_MKB
        || uh_Cmd == SDD_IOC_USB_SECURE_READ
        || uh_Cmd == SDD_IOC_USB_SECURE_WRITE
#endif /* _SDD_SDUSB_SECURE_ */
#endif /* _SDD_SDUSB_TRANSFER_ */
        ) {
        if(w_ret != SDD_SUCCESS){
            p_sdd->Result.w_Result = w_ret;	/* Read/Writen̏ꍇ̂݃G[ei[ */
            Sdds_DebugPrint(__LINE__, SDD_PERR,"I%X:%ld %04X %04X %X\n",
                            uh_Cmd,
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
        }
    }

	if ((uh_Cmd == SDD_IOC_READ) || (uh_Cmd == SDD_IOC_WRITE)){
		p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
	}
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<SDD_Ioctl w_ret = %ld\n", w_ret);
#ifdef _SDD_HWTIMER_SPEEDTEST_
    UwHwTimerEnd1 = Sddr_GetHWTimer();      /* HW^C}ԑp^C}擾 */
    Sdds_DebugPrint(__LINE__, SDD_PERR,"SDD_Ioctl,%ld,%ld\n", UwHwTimerStart1, UwHwTimerEnd1);
#endif
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSDD_Open														*/
/*  Tv		FI[v֐													*/
/*  			Fw肳ꂽfoCX̃I[vsB							*/
/*  		FUW uw_DevID			[in] I[vfoCXID				*/
/*				FSDD_HANDLE *p_Handle	[in] nh|C^(!=NULL)			*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2004.1.22														*/
/********************************************************************************/
SDD_ERROR SDD_Open(UW uw_DevID, SDD_HANDLE *p_Handle)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	UW	uw_tmpDevID;
	SDD_HANDLE	*p_tmpSddHandle;
	SDD_DEV *p_sdd;
    UB ub_PortNo;     /* PortNo */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Open>\n");
	/* ֐ł̓Rs[gp */	
	uw_tmpDevID = uw_DevID & SDD_DEVICEID_AREA_MASK;			/* 폜\(QƂ݂̂̂߃Rs[̈ӖȂ) */
	p_tmpSddHandle = p_Handle;
    ub_PortNo = (UB)(uw_DevID&SDD_DEVICEID_PORTNUM_MASK)>>SDD_DEVICEID_PORTNUM_SHIFT;
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_DevID =%lX uw_tmpDevID = %lX ub_PortNo=%d\n", uw_DevID, uw_tmpDevID, ub_PortNo);

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( &(SddHandleForDriver[ub_PortNo]), WAIT_OPEN );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */
    /* |[gԍmF */
    if (ub_PortNo >= SDD_DEV_COUNT) {
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]), __LINE__, w_ret, SDD_ERR_ILLEGAL_ID);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld\n", w_ret);
		return w_ret;
    }
    /* SDD DEV\̎w */
    p_sdd = &(SddDev[ub_PortNo]);

/*==========================================================================*/
/* ̃`FbN & ݒ													*/
/*	1)uw_tmpDevID == SDDDevID̏ꍇAp								*/
/*	2)p_Handle != NULL̏ꍇAp										*/
/*	3)foCXIDُ(ʏEF؈ȊO)̏ꍇAG[1iSDD_ERR_ILLEGAL_ID)*/
/*	3)LȊȌꍇAG[1iSDD_ERR_PARAM)							*/
/*	G[1F															*/
/*		uh_ret |= G[ݒ;												*/
/*		ԑJځiSddDev[port].uh_Status = ύX)						*/
/*		return;																*/
/*==========================================================================*/
#ifdef _SDD_FUNC_SECURE_
	if( (uw_tmpDevID != SDD_DEVICEID_NORMAL) && (uw_tmpDevID != SDD_DEVICEID_SECURE)){
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]),__LINE__, w_ret, SDD_ERR_ILLEGAL_ID);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld\n", w_ret);
		return w_ret;
	}
#else	/* _SDD_FUNC_SECURE_ */
	if((uw_tmpDevID&SDD_DEVICEID_AREA_MASK) != SDD_DEVICEID_NORMAL){
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]),__LINE__, w_ret, SDD_ERR_ILLEGAL_ID);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld\n", w_ret);
		return w_ret;
	}
#endif	/* _SDD_FUNC_SECURE_ */
	if(p_tmpSddHandle == NULL){
		w_ret = Sdds_SetErr(&(SddHandleForDriver[0]),__LINE__, w_ret, SDD_ERR_PARAM);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld\n", w_ret);
		return w_ret;
	}
#ifdef	_SDD_FUNC_SECURE_
/* ʏ̈pnh|C^ƔFؗ̈pnh|C^͈قȂ̈ł邩ǂ̃`FbN */
	if(uw_tmpDevID == SDD_DEVICEID_NORMAL){
		 if(p_tmpSddHandle == p_sdd->p_SecureHandle){
             w_ret = Sdds_SetErr(&(SddHandleForDriver[0]),__LINE__, w_ret, SDD_ERR_PARAM);
             Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld\n", w_ret);
             return w_ret;
		}
	}
	if(uw_tmpDevID == SDD_DEVICEID_SECURE){
		 if(p_tmpSddHandle == p_sdd->p_NormalHandle){
             w_ret = Sdds_SetErr(&(SddHandleForDriver[0]),__LINE__, w_ret, SDD_ERR_PARAM);
             Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld\n", w_ret);
             return w_ret;
		}
	}
	p_sdd -> p_Handle = p_tmpSddHandle;
#endif	/* _SDD_FUNC_SECURE_ */

/*==================================================*/
/* rJn 									*/
/*	G[̏ꍇ̂݁AG[1					*/
/*	G[1F									*/
/*		uh_ret |= G[lݒ						*/
/*		ԑJځiSddDev[port].uh_Status = ύXj*/
/*		return;										*/
/*==================================================*/
	w_TmpRet = Sdds_StartExcl( &(SddHandleForDriver[ub_PortNo]), uw_tmpDevID );	
	if(w_TmpRet != SDD_SUCCESS){
        /* Sdds_StartExclpG[ */
        w_ret = Sdds_StartExclError(&(SddHandleForDriver[ub_PortNo]), w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld %04X %04X\n",
                        w_ret,
                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
		return w_ret;
	}

	do {	/* G[ɏbreak邽߂do-while(0) */

		/*==========================================================*/
		/* (SddDev[port].uh_Status)̃`FbN					*/
		/* ʏSDDD̏ꍇ											*/
		/*	1)CLOSE(0x02)̏ꍇAp							*/
		/*	2)OPEN(0x01)̏ꍇAG[1(SDD_ERR_ALREADY_OPENED)	*/
		/*	3)DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED)	*/
		/*	4)LȊȌꍇAG[1(SDD_ERR_STATUS)			*/
		/*	G[1F											*/
		/* 		uh_ret |= G[lݒ;								*/
		/* 		ԑJځiSddDev[port].uh_Status = ύXj		*/
		/*		return;												*/
		/* FSDDD̏ꍇ											*/
		/*	1)FOPEN(p_SecureHandle != NULL)̏ꍇ				*/
		/* 		G[1(SDD_ERR_ALREADY_OPENED)					*/
		/*	2)FCLOSE(p_SecureHandle == NULL)̏ꍇAp		*/
		/* 	ʏOpen/CloseȊONGȂ̂ňȉŃG[R[h		*/
		/*	3)DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED)	*/
		/*	4)LȊȌꍇAG[1(SDD_ERR_STATUS)			*/
		/*	G[1F											*/
		/* 		uh_ret |= G[lݒ;								*/
		/* 		ԑJځiSddDev[port].uh_Status = ύXj		*/
		/*		return;												*/
		/*==========================================================*/
		if( uw_tmpDevID == SDD_DEVICEID_NORMAL ){
		if ((Sdds_GetStatus(&(SddHandleForDriver[ub_PortNo])) & SDD_STATUS_MASK) != SDD_STATUS_CLOSE){
			switch(Sdds_GetStatus(&(SddHandleForDriver[ub_PortNo])) & SDD_STATUS_MASK){
				case SDD_STATUS_DETACH:	/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */	
					w_ret = Sdds_SetErr(&(SddHandleForDriver[ub_PortNo]), __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld %04X %04X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
					break;
				case SDD_STATUS_OPEN:	/* OPEN(0x01)̏ꍇAG[1(SDD_ERR_ALREADY_OPENED) */
					w_ret = Sdds_SetErr(&(SddHandleForDriver[ub_PortNo]), __LINE__, w_ret, SDD_ERR_ALREADY_OPENED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld %04X %04X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
					break;
				default:				/* LȊȌꍇAG[1(SDD_ERR_STATUS) */
					w_ret = Sdds_SetErr(&(SddHandleForDriver[ub_PortNo]), __LINE__, w_ret, SDD_ERR_STATUS);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld %04X %04X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
					break;
			}

			break;		/* ԃG[̂ߏ~ */
		}
		}
#ifdef	_SDD_FUNC_SECURE_
		if( uw_tmpDevID == SDD_DEVICEID_SECURE ){
			if((p_sdd->uh_SecureStatus & SDD_STATUS_MASK) != SDD_SECURE_STATUS_CLOSE){
				switch(p_sdd->uh_SecureStatus & SDD_STATUS_MASK){
					case SDD_SECURE_STATUS_OPEN:	/* OPEN(0x01)̏ꍇAG[1(SDD_ERR_ALREADY_OPENED) */
                        w_ret = Sdds_SetErr(&(SddHandleForDriver[ub_PortNo]), __LINE__, w_ret, SDD_ERR_ALREADY_OPENED);
                        Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld %04X %04X\n",
                                        w_ret,
                                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
				break;
					default:
						/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */	
						if((Sdds_GetStatus(&(SddHandleForDriver[ub_PortNo])) & SDD_STATUS_MASK) == SDD_STATUS_DETACH){
                            w_ret = Sdds_SetErr(&(SddHandleForDriver[ub_PortNo]), __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                            Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld %04X %04X\n",
                                            w_ret,
                                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
						break;
						}
						else {
							w_ret = Sdds_SetErr(&(SddHandleForDriver[ub_PortNo]), __LINE__, w_ret, SDD_ERR_STATUS);
                            Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld %04X %04X\n",
                                            w_ret,
                                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
							/* LȊȌꍇAG[1(SDD_ERR_STATUS) */
						}
						break;
				}
					break;		/* ԃG[̂ߏ~ */
				}
			}
#endif	/* _SDD_FUNC_SECURE_ */

		/* Open̎
			SDD_HANDLESDD_DEṼ|C^ݒ
			SDD_HANDLEɃ|[gԍݒ
			Sdds_SetHandle()Ŏs 
		*/
		/*
			1)߂lIiSUCCESSj̏ꍇA
				rIցipj
			2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
				G[2F
				uh_ret |= G[lݒ;
				Z}tH(SEM_SDD)ԋp
				return;
		*/
        w_TmpRet = Sdds_SetHandle(p_tmpSddHandle, ub_PortNo);
        if(w_TmpRet != SDD_SUCCESS){
            w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld %04X %04X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
			break;		/* I[vG[̂ߏ~ */
        }

		/*==============================*/
		/* ԑJځiCLOSEOPENj		*/
		/*	OpenԂɑJ				*/
		/* ʏSDDD̏ꍇ				*/
		/* 	uh_StatusOpenɕύX		*/
		/* 	p_NormalHandleݒ		*/
		/* FSDDD̏ꍇ				*/
		/*  p_SecureHandleݒ		*/
		/*==============================*/
		if( uw_tmpDevID == SDD_DEVICEID_NORMAL ){
			Sdds_SetStatus(p_tmpSddHandle, (Sdds_GetStatus(p_tmpSddHandle) & ~SDD_STATUS_MASK) | SDD_STATUS_OPEN);
#ifdef	_SDD_FUNC_SECURE_
			p_sdd->p_NormalHandle = p_tmpSddHandle;
		}
		if( uw_tmpDevID == SDD_DEVICEID_SECURE ){
			p_sdd->uh_SecureStatus = (p_sdd->uh_SecureStatus & ~SDD_STATUS_MASK) | SDD_SECURE_STATUS_OPEN;
			p_sdd->p_SecureHandle = p_tmpSddHandle;
#endif	/* _SDD_FUNC_SECURE_ */
		}

	} while(0);		/* [vł͂Ȃ(0) */

/*==========================================*/
/* rI  Z}tH(SEM_SDD)̊J	*/
/*	G[̏ꍇ̂݁AG[
		uh_ret |= G[lݒ
		ԑJځiSddDev[port].uh_Status = ύXj
		return;
*/
/*==========================================*/
	w_TmpRet = Sdds_EndExcl( &(SddHandleForDriver[ub_PortNo]), uw_tmpDevID );
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(&(SddHandleForDriver[ub_PortNo]), __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"O:%ld %04X %04X\n",
                        w_ret,
                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)));
	}
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<SDD_Open w_ret=%ld\n", w_ret);

	return w_ret;
}

/********************************************************************************/
/*  ֐		FSDD_Read														*/
/*  Tv		F[h֐													*/
/*  			FJ[h̓ǂݍ݊JnItZbgAǂݍ݃f[^i[̈ցA*/
/*				Fǂݍ݃ZN^Aăf[^ǂݍށB					*/
/*  		FSDD_HANDLE *p_Handle	[in] nh|C^(!=NULL)			*/
/*				FB *pb_Buff			[in] ǂݍ݃f[^i[̈|C^		*/
/*				FUW uw_Count			[in] ǂݍ݃ZN^					*/
/*				FUW uw_Offset			[in] ǂݍ݊JnItZbg(ZN^j	*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2004.1.29														*/
/********************************************************************************/
SDD_ERROR SDD_Read(SDD_HANDLE *p_Handle, B *pb_Buff, UW uw_Count, UW uw_Offset)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	SDD_HANDLE	*p_tmpSddHandle;
	B *pb_tmpBuff;
	UW uw_tmpCount;
	UW uw_tmpOffset;
	UH	uh_tmpStatus;	/* ݂̏ԕێp */
	SDD_DEV	*p_sdd;
	UB	ub_CardInOut;
	UW	uw_Mode = (UW)0;
    UB i;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Read> pb_Buff=%lX, uw_Count=%ld, uw_Offset=%ld\n", (UW)pb_Buff, uw_Count, uw_Offset);
	/* ֐ł̓Rs[gp */
	p_tmpSddHandle = p_Handle;
	pb_tmpBuff = pb_Buff;
	uw_tmpCount = uw_Count;
	uw_tmpOffset = uw_Offset;

	/*==================================================================================*/
	/* ̃`FbN & ݒ															*/
	/*	1)p_SddHandle == NULL̏ꍇAG[1(SDD_ERR_PARAM)							*/
	/*	2)pb_tmpBuff == NULL̏ꍇAG[1iSDD_ERR_PARAM)							*/
	/*	3)LȊȌꍇAp														*/
	/*	G[1F																	*/
	/*		uh_ret |= G[lݒ;														*/
	/*		ԑJځiSddDev[port].uh_Status = ύXj								*/
	/*		return;																		*/
	/*==================================================================================*/
	if((p_tmpSddHandle == NULL) || (pb_tmpBuff == NULL)){
        for (i=0; i<SDD_DEV_COUNT; i++) {
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_PARAM);
            p_sdd = SddHandleForDriver[i].vp_Sdif;
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        }
        Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld\n", w_ret);
		return w_ret;
	}
	else if (p_tmpSddHandle->vp_Sdif == NULL){
        for (i=0; i<SDD_DEV_COUNT; i++) {
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
            p_sdd = SddHandleForDriver[i].vp_Sdif;
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        }
        Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld\n", w_ret);
		return w_ret;
	}
    else if (p_tmpSddHandle->ub_Port > SDD_DEV_COUNT) {
        for (i=0; i<SDD_DEV_COUNT; i++) {
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
            p_sdd = SddHandleForDriver[i].vp_Sdif;
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        }
        Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld\n", w_ret);
		return w_ret;
    }
    else if (SddHandleForDriver[Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)].vp_Sdif != p_tmpSddHandle->vp_Sdif) {
        for (i=0; i<SDD_DEV_COUNT; i++) {
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
            p_sdd = SddHandleForDriver[i].vp_Sdif;
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        }
        Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld\n", w_ret);
		return w_ret;
    }
	else if (Sddr_CheckAddrAlign(pb_tmpBuff)) {		/* ]ACg`FbN */
		w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
        p_sdd = p_Handle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
        p_sdd->Result.w_Result = w_ret;
		p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld\n", w_ret);
		return w_ret;
	}
#ifdef _SDD_HWTIMER_SPEEDTEST_
    UwHwTimerStart1 = Sddr_GetHWTimer();      /* HW^C}ԑp^C}擾 */
#endif
    p_sdd = p_Handle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    /* IOCTLʎ擾pʑOǉ 2006/08/08 H.Miura */
    Sdds_ioctl_getResult_before(SDD_PREFLG_READ);

    /* [hCg֐Oǉ 2006/08/1 H.Miura */
    w_TmpRet = SDD_ReadWrite_before(p_tmpSddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
		p_sdd->Result.w_Result = w_ret;
		p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                        w_ret,
                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        p_sdd->SddCommandSendData.uh_Cmd);
		return w_ret;
	}

	uh_tmpStatus = Sdds_GetStatus(p_tmpSddHandle); /* G[̏ꍇɑȌԂɖ߂邽߂ɕێ */

	do {	/* G[ɏbreak邽߂do-while(0) */
		/*======================================================================================*/
		/* (SddDev[port].uh_Status)̃`FbN												*/
		/*	1)OPEN(0x01)̏ꍇA																*/
		/*		ԑJڏiSddDev[port].uh_Statusj̕ۑ ub_tmpStatus						*/
		/*		p																		*/
		/*	2)DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED)								*/	
		/*	3)CLOSE(0x02)̏ꍇAG[1iSDD_ERR_NOT_OPENED)								*/	
		/*	4)LȊȌꍇAG[1iSDD_ERR_STATUS)										*/	
		/* 	J[hς݃tO(SddDev[port].uh_Status)̃`FbN							*/
		/*	5)ς(0x80)̏ꍇA																*/
		/*		ԑJڏiSddDev[port].uh_Statusj̕ۑ uh_tmpStatus						*/
		/*		p																		*/
		/*	6)LȊȌꍇAG[1iSDD_ERR_NOT_CARD_INIT)								*/
		/*	G[1F																		*/
		/*		uh_ret |= G[lݒ;															*/
		/*		ԑJځiSddDev[port].uh_Status = ύXj									*/
		/*		return;																			*/
		/*======================================================================================*/
		if ((Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK) != SDD_STATUS_OPEN){
			switch(Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK){
				case SDD_STATUS_DETACH:	/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */	
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
				case SDD_STATUS_CLOSE:	/* CLOSE(0x02)̏ꍇAG[1(SDD_ERR_NOT_OPENED) */
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_OPENED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
				default:				/* LȊȌꍇAG[1(SDD_ERR_STATUS) */
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STATUS);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
			}

			break;	/* ԃG[̂ߏ~ */
		}

#ifdef	_SDD_FUNC_SECURE_
        /* ʏHandlełȂꍇsNG */
		/* FHnadlȅꍇsNG */
		if(p_tmpSddHandle != p_sdd->p_NormalHandle){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
		p_sdd -> p_Handle = p_tmpSddHandle;
#endif	/* _SDD_FUNC_SECURE_ */
        /* 
		STANBY[hΉ
		STANBY[h̏ꍇ̓ANZXG[
         */
        w_TmpRet = Sddr_GetMode(p_tmpSddHandle, &uw_Mode);
        if(w_TmpRet != SDD_SUCCESS){
            w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
            Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
            break;
        }
        if(uw_Mode == SDD_MODE_STANDBY){
            w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STANDBY);
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
            Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
            break;
        }

		Sdds_StopCDDetect(p_tmpSddHandle);
		/*==========================================================================*/
		/* J[h̗L`FbN														*/
		/*	1)J[hL̏ꍇAp											*/
		/*	2)ȊȌꍇAG[1											*/
		/*		G[1F														*/
		/*			uh_ret = SDD_ERR_NO_CARD										*/
		/*			return;															*/
		/*==========================================================================*/
		Sddr_DetectCard( p_tmpSddHandle, &ub_CardInOut ); /* J[hL`FbN */
		if ( ub_CardInOut == SDD_CARDOUT) {
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NO_CARD);
			p_sdd->Result.w_Result = w_ret;
			p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
			Sdds_StartCDDetect(p_tmpSddHandle);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
		if ((Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_INITFLG) == 0) {		/* J[hς݈ȊO̓G[(SDD_ERR_NOT_CARD_INIT) */
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_CARD_INIT);
			Sdds_StartCDDetect(p_tmpSddHandle);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;	/* J[h̓G[̂ߏ~ */
		}
		Sdds_StartCDDetect(p_tmpSddHandle);
		
		/* J[hʏ̈TCY̏ꍇG[ */
		if((uw_tmpOffset + uw_tmpCount) > p_sdd->uw_NormalSize){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}

		/*==================================*/
		/* ԑJځiOPENREADj			*/
		/*	SddDev[port].uh_Status ReadԂ	*/
		/*==================================*/
		Sdds_SetStatus(p_tmpSddHandle, (Sdds_GetStatus(p_tmpSddHandle) & ~SDD_STATUS_MASK) | SDD_STATUS_READ);

		/* ZN^0̏ꍇ̏ʐݒ */
		if (uw_tmpCount == 0) {/*	uw_tmpCount == 0̏ꍇAI(SDD_SUCCESS)	*/
			break;	/*@ǂݍ݃ZN^0̏ꍇ~ */
		}

		/* Read̎
			SD_CLK̏o͂ƒ~
			Oobt@ݒiOobt@ǂŃOobt@ݒύXj
			StreamDMACݒƋN
			ReadR}hR}hsO
			ReadR}hiCMD18)s
			X|XM
			AccessAllEnd&StreamDMAC]I
			G[`FbNiCMD13js
			
			G[ɃgCs
			ǂݏoZN^LSI]MAXTCYȏi0xFFFFj̏ꍇJԂ
			Sdds_ReadWriteSub()Ŏs 
			
			P = p_SddHandle(폜)
			Q = pb_tmpBuff
			R = uw_tmpCount
			S = uw_tmpOffset
		*/
		/*
			1)߂lIiSUCCESSj̏ꍇA
				rIցipj
			2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
				G[2F
				uh_ret |= G[lݒ;
				Z}tH(SEM_SDD)ԋp
				ԑJڂȌԂɖ߂
				iSddDev[port].uh_Status = ub_tmpStatusj
				return;
		*/
		w_TmpRet = Sddr_EnaClk(p_tmpSddHandle, SDD_CLK_ENABLE);	/* SD_CLK̏o */
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
		w_TmpRet = Sdds_ReadWriteSub(p_tmpSddHandle, pb_tmpBuff, uw_tmpCount, uw_tmpOffset, FALSE);
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            w_TmpRet = Sddr_EnaClk(p_tmpSddHandle, SDD_CLK_DISABLE);	/* SD_CLK̒~ */
            if(w_TmpRet != SDD_SUCCESS){
                w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            }
            Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
		w_TmpRet = Sddr_EnaClk(p_tmpSddHandle, SDD_CLK_DISABLE);	/* SD_CLK̒~ */
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
	} while(0);	/* [vł͂Ȃ(0) */

	/*==============================*/
	/* ԑJ						*/
	/*==============================*/
	if(w_ret != SDD_SUCCESS){
		/*==========================================*/
		/*	ԑJڂȌԂɖ߂				*/
		/*	iSddDev[port].uh_Status = ub_tmpStatusj	*/
		/*==========================================*/
		Sdds_SetStatus(p_tmpSddHandle, uh_tmpStatus);
	} else {
		/*==============================*/
		/* ԑJځiREADOPENj		*/
		/*	OPENԂɖ߂				*/
		/*==============================*/
		Sdds_SetStatus(p_tmpSddHandle, (Sdds_GetStatus(p_tmpSddHandle) & ~SDD_STATUS_MASK) | SDD_STATUS_OPEN);
	}

    /* [hCg֐㏈ǉ 2006/08/1 H.Miura */
    w_TmpRet = SDD_ReadWrite_after(p_tmpSddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"R:%ld %04X %04X %X\n",
                        w_ret,
                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        p_sdd->SddCommandSendData.uh_Cmd);
	}

	if(w_ret != SDD_SUCCESS){
		p_sdd->Result.uw_Resid = 0;	/* Readł́AƂ]̂͊̌̏ŃG[ꍇłA]ZN^0ɂ */
	}
    
	p_sdd->Result.w_Result = w_ret;
	p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<SDD_Read w_ret=%ld\n", w_ret);
#ifdef _SDD_HWTIMER_SPEEDTEST_
    UwHwTimerEnd1 = Sddr_GetHWTimer();      /* HW^C}ԑp^C}擾 */
    UwSectors = uw_tmpCount;
    Sdds_DebugPrint(__LINE__, SDD_PERR,"SDD_Read(%d sectors),%ld,%ld\n", UwSectors, UwHwTimerStart1, UwHwTimerEnd1);
#endif

	return w_ret;
}

/********************************************************************************/
/*  ֐		FSDD_Write														*/
/*  Tv		FCg֐													*/
/*  			F݃f[^i[̈悩AJ[h̏݊JnItZbgցA*/
/*				F݃ZN^Aăf[^ށB					*/
/*  		FSDD_HANDLE *p_Handle	[in] nh|C^(!=NULL)			*/
/*				FB *pb_Buff			[in] ݃f[^i[̈|C^		*/
/*				FUW uw_Count			[in] ݃ZN^					*/
/*				FUW uw_Offset			[in] ݊JnItZbg(ZN^j	*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2004.1.29														*/
/********************************************************************************/
SDD_ERROR SDD_Write(SDD_HANDLE *p_Handle, B *pb_Buff, UW uw_Count, UW uw_Offset)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	SDD_HANDLE	*p_tmpSddHandle;
	B *pb_tmpBuff;
	UW uw_tmpCount;
	UW uw_tmpOffset;
	UH uh_tmpStatus;	/* ݂̏ԕێp */
	SDD_DEV	*p_sdd;
	UB ub_CardInOut;
	UW	uw_Mode = (UW)0;
    UB i;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"SDD_Write> pb_Buff=%lX, uw_Count=%ld, uw_Offset=%ld\n", (UW)pb_Buff, uw_Count, uw_Offset);
	/* ֐ł̓Rs[gp */
	p_tmpSddHandle = p_Handle;
	pb_tmpBuff = pb_Buff;
	uw_tmpCount = uw_Count;		/* gC[v̂Ō̒l͕ێ */
	uw_tmpOffset = uw_Offset;	/* gC[v̂Ō̒l͕ێ */

/*==================================================================================*/
/* ̃`FbN & ݒ															*/
/*	1)p_SddHandle == NULL̏ꍇAG[1(SDD_ERR_PARAM)							*/
/*	2)pb_tmpBuff == NULL̏ꍇAG[1iSDD_ERR_PARAM)							*/
/*	3)uw_tmpCount == 0̏ꍇAI(SDD_SUCCESS)									*/
/*	4)LȊȌꍇAp														*/
/*	G[1F																	*/
/*		uh_ret |= G[lݒ;														*/
/*		ԑJځiSddDev[port].uh_Status = ύXj								*/
/*		return;																		*/
/*==================================================================================*/
	if((p_tmpSddHandle == NULL) || (pb_tmpBuff == NULL)){
        for (i=0; i<SDD_DEV_COUNT; i++) {
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_PARAM);
            p_sdd = SddHandleForDriver[i].vp_Sdif;
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        }
        Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld\n", w_ret);
		return w_ret;
	}
	else if (p_tmpSddHandle->vp_Sdif == NULL){
        for (i=0; i<SDD_DEV_COUNT; i++) {
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
            p_sdd = SddHandleForDriver[i].vp_Sdif;
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        }
        Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld\n", w_ret);
		return w_ret;
	}
    else if (p_tmpSddHandle->ub_Port > SDD_DEV_COUNT) {
        for (i=0; i<SDD_DEV_COUNT; i++) {
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
            p_sdd = SddHandleForDriver[i].vp_Sdif;
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        }
        Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld\n", w_ret);
		return w_ret;
    }
    else if (SddHandleForDriver[Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)].vp_Sdif != p_tmpSddHandle->vp_Sdif) {
        for (i=0; i<SDD_DEV_COUNT; i++) {
            w_ret = Sdds_SetErr(&(SddHandleForDriver[i]), __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
            p_sdd = SddHandleForDriver[i].vp_Sdif;
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        }
        Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld\n", w_ret);
		return w_ret;
    }
	else if (Sddr_CheckAddrAlign(pb_tmpBuff)) {		/* ]ACg`FbN */
		w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
        p_sdd = p_Handle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
		p_sdd->Result.w_Result = w_ret;
		p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld\n", w_ret);
		return w_ret;
	}
#ifdef _SDD_HWTIMER_SPEEDTEST_
    UwHwTimerStart1 = Sddr_GetHWTimer();      /* HW^C}ԑp^C}擾 */
#endif

    p_sdd = p_Handle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    /* IOCTLʎ擾pʑOǉ 2006/08/08 H.Miura */
    Sdds_ioctl_getResult_before(SDD_PREFLG_WRITE);

    /* [hCg֐Oǉ 2006/08/1 H.Miura */
    w_TmpRet = SDD_ReadWrite_before(p_tmpSddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
		p_sdd->Result.w_Result = w_ret;
		p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
        Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                        w_ret,
                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        p_sdd->SddCommandSendData.uh_Cmd);
		return w_ret;
	}

	uh_tmpStatus = Sdds_GetStatus(p_tmpSddHandle); /* G[̏ꍇɑȌԂɖ߂邽߂ɕێ */

	do {	/* G[ɏbreak邽߂do-while(0) */

		/*======================================================================================*/
		/* (SddDev[port].uh_Status)̃`FbN												*/
		/*	1)OPEN(0x01)̏ꍇA																*/
		/*		ԑJڏiSddDev[port].uh_Statusj̕ۑ ub_tmpStatus						*/
		/*		p																		*/
		/*	2)DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED)								*/	
		/*	3)CLOSE(0x02)̏ꍇAG[1iSDD_ERR_NOT_OPENED)								*/	
		/*	4)LȊȌꍇAG[1iSDD_ERR_STATUS)										*/	
		/* 	J[hς݃tO(SddDev[port].uh_Status)̃`FbN							*/
		/*	5)ς(0x80)̏ꍇA																*/
		/*		ԑJڏiSddDev[port].uh_Statusj̕ۑ ub_tmpStatus						*/
		/*		p																		*/
		/*	6)LȊȌꍇAG[1iSDD_ERR_NOT_CARD_INIT)								*/
		/*	G[1F																		*/
		/*		uh_ret |= G[lݒ;															*/
		/*		ԑJځiSddDev[port].uh_Status = ύXj									*/
		/*		return;																			*/
		/*======================================================================================*/
		if ((Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK) != SDD_STATUS_OPEN){
			switch(Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_MASK){
				case SDD_STATUS_DETACH:	/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */	
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
				case SDD_STATUS_CLOSE:	/* CLOSE(0x02)̏ꍇAG[1(SDD_ERR_NOT_OPENED) */
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_OPENED);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
				default:				/* LȊȌꍇAG[1(SDD_ERR_STATUS) */
					w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STATUS);
                    Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                                    w_ret,
                                    (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                                    p_sdd->SddCommandSendData.uh_Cmd);
					break;
			}

			break;	/* ԃG[̂ߏ~ */
		}

#ifdef	_SDD_FUNC_SECURE_
        /* ʏHandlełȂꍇsNG */
		/* FHnadlȅꍇsNG */
		if(p_tmpSddHandle != p_sdd->p_NormalHandle){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_ILLEGAL_HANDLE);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
		p_sdd -> p_Handle = p_tmpSddHandle;
#endif	/* _SDD_FUNC_SECURE_ */

        /* 
		STANBY[hΉ
		STANBY[h̏ꍇ̓ANZXG[
         */
        w_TmpRet = Sddr_GetMode(p_tmpSddHandle, &uw_Mode);
        if(w_TmpRet != SDD_SUCCESS){
            w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
            Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
            break;
        }
        if(uw_Mode == SDD_MODE_STANDBY){
            w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_STANDBY);
            p_sdd->Result.w_Result = w_ret;
            p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
            Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
            break;
        }

		Sdds_StopCDDetect(p_tmpSddHandle);
		/*==========================================================================*/
		/* J[h̗L`FbN														*/
		/*	1)J[hL̏ꍇAp											*/
		/*	2)ȊȌꍇAG[1											*/
		/*		G[1F														*/
		/*			uh_ret = SDD_ERR_NO_CARD										*/
		/*			return;															*/
		/*==========================================================================*/
		Sddr_DetectCard( p_tmpSddHandle, &ub_CardInOut ); /* J[hL`FbN */
		if ( ub_CardInOut == SDD_CARDOUT) {
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NO_CARD);
			p_sdd->Result.w_Result = w_ret;
			p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
			Sdds_StartCDDetect(p_tmpSddHandle);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}

		if ((Sdds_GetStatus(p_tmpSddHandle) & SDD_STATUS_INITFLG) == 0) {		/* J[hς݈ȊO̓G[(SDD_ERR_NOT_CARD_INIT) */
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_NOT_CARD_INIT);
			Sdds_StartCDDetect(p_tmpSddHandle);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;	/* J[h̓G[̂ߏ~ */
		}
		Sdds_StartCDDetect(p_tmpSddHandle);
		
		/* J[hʏ̈TCY̏ꍇG[ */
		if((uw_tmpOffset + uw_tmpCount) > p_sdd->uw_NormalSize){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}

		/*==================================*/
		/* ԑJځiOPENWRITEj			*/
		/*	SddDev[port].uh_Status WriteԂ	*/
		/*==================================*/
		Sdds_SetStatus(p_tmpSddHandle, (Sdds_GetStatus(p_tmpSddHandle) & ~SDD_STATUS_MASK) | SDD_STATUS_WRITE);

		/* ZN^0̏ꍇ̏ʐݒ */
		if (uw_tmpCount == 0) {
			break;	/*@ǂݍ݃ZN^0̏ꍇ~ */
		}

		/* Write̎
			SD_CLK̏o͂ƒ~
			CgveNg`FbN
			Oobt@ݒiOobt@ǂŃOobt@ݒύXj
			StreamDMACݒƋN
			WriteR}hR}hsO
			WriteR}hiCMD25)s
			X|XM
			AccessAllEnd&StreamDMAC]I
			G[`FbNiCMD13js
			
			G[ɃgCs
			ǂݏoZN^LSI]MAXTCYȏi0xFFFFj̏ꍇJԂ
			Sdds_ReadWriteSub()Ŏs 
			
			P = p_SddHandle
			Q = pb_tmpBuff
			R = uw_tmpCount
			S = uw_tmpOffset
		*/
		/*
			1)߂lIiSUCCESSj̏ꍇA
				rIցipj
			2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
				G[2F
				uh_ret |= G[lݒ;
				Z}tH(SEM_SDD)ԋp
				ԑJڂȌԂɖ߂
				iSddDev[port].uh_Status = ub_tmpStatusj
				return;
		*/
		w_TmpRet = Sddr_EnaClk(p_tmpSddHandle, SDD_CLK_ENABLE);	/* SD_CLK̏o */
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
		w_TmpRet = Sdds_ReadWriteSub(p_tmpSddHandle, pb_tmpBuff, uw_tmpCount, uw_tmpOffset, TRUE);
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            w_TmpRet = Sddr_EnaClk(p_tmpSddHandle, SDD_CLK_DISABLE);	/* SD_CLK̒~ */
            if(w_TmpRet != SDD_SUCCESS){
                w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            }
            Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}
		w_TmpRet = Sddr_EnaClk(p_tmpSddHandle, SDD_CLK_DISABLE);	/* SD_CLK̒~ */
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                            w_ret,
                            (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                            p_sdd->SddCommandSendData.uh_Cmd);
			break;
		}

	} while(0);	/* [vł͂Ȃ(0) */

	/*==============================*/
	/* ԑJ						*/
	/*==============================*/
	if(w_ret != SDD_SUCCESS){
		/*==========================================*/
		/*	ԑJڂȌԂɖ߂				*/
		/*	iSddDev[port].uh_Status = ub_tmpStatusj	*/
		/*==========================================*/
		Sdds_SetStatus(p_tmpSddHandle, uh_tmpStatus);
	} else {
		/*==============================*/
		/* ԑJځiREADOPENj		*/
		/*	OPENԂɖ߂				*/
		/*==============================*/
		Sdds_SetStatus(p_tmpSddHandle, (Sdds_GetStatus(p_tmpSddHandle) & ~SDD_STATUS_MASK) | SDD_STATUS_OPEN);
	}

    /* [hCg֐㏈ǉ 2006/08/1 H.Miura */
    w_TmpRet = SDD_ReadWrite_after(p_tmpSddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_tmpSddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PERR,"W:%ld %04X %04X %X\n",
                        w_ret,
                        (UH)SDD_SD_INFO1(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        (UH)SDD_SD_INFO2(Sdd_M_GetPortNum(p_tmpSddHandle->ub_Port)),
                        p_sdd->SddCommandSendData.uh_Cmd);
	}

	p_sdd->Result.w_Result = w_ret;
	p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<SDD_Write w_ret=%ld\n", w_ret);

#ifdef _SDD_HWTIMER_SPEEDTEST_
    UwHwTimerEnd1 = Sddr_GetHWTimer();      /* HW^C}ԑp^C}擾 */
    UwSectors = uw_tmpCount;
    Sdds_DebugPrint(__LINE__, SDD_PERR,"SDD_Write(%d sectors),%ld,%ld\n", UwSectors, UwHwTimerStart1, UwHwTimerEnd1);
#endif
	return w_ret;
}


#if defined(_SDD_LINUX_)
EXPORT_SYMBOL(SDD_Attach);
EXPORT_SYMBOL(SDD_Detach);
EXPORT_SYMBOL(SDD_Init);
EXPORT_SYMBOL(SDD_Open);
EXPORT_SYMBOL(SDD_Close);
EXPORT_SYMBOL(SDD_Read);
EXPORT_SYMBOL(SDD_Write);
EXPORT_SYMBOL(SDD_Ioctl);

/************************************************************/
/* module̓o^                                       */
/************************************************************/
module_init(SDD_module_init);
module_exit(SDD_module_del);

#endif /* defined(_SDD_LINUX_) */
