/********************************************************************************/
/*  t@C    F$Workfile: SddSubr_api.c $                                  */
/*  Tv          FSDfoCXhCoAPIpo͐֐pTu֐t@C     */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 07/04/26 14:35 $                                  */
/*                  A^b`Oǉ 2006/07/31 H.Miura                     */
/*                  f^b`Oǉ 2006/07/31 H.Miura                     */
/********************************************************************************/
/* wb_[t@C */
#include "SddOsTimer.h"

static SDD_ERROR Sdds_AttachSub(SDD_HANDLE *p_SddHandle);
static SDD_ERROR Sdds_CloseSub(SDD_HANDLE *p_SddHandle);
static SDD_ERROR Sdds_DetachSub(SDD_HANDLE *p_SddHandle);
static SDD_ERROR SDD_ReadWrite_before(SDD_HANDLE *p_SddHandle);
static SDD_ERROR SDD_ReadWrite_after(SDD_HANDLE *p_SddHandle);
static SDD_ERROR Sdds_AttachSub_before(SDD_HANDLE *p_SddHandle);
static SDD_ERROR Sdds_DetachSub_before(SDD_HANDLE *p_SddHandle);
static SDD_ERROR Sdds_AttachSub_after(SDD_HANDLE *p_SddHandle);
static SDD_ERROR Sdds_DetachSub_after(SDD_HANDLE *p_SddHandle);

/* Tu֐t@C */
#if defined(_SDD_MN6682X_)
#include "device/SddSubr_api_for_mn6682x.c"
#endif /* defined(_SDD_MN6682X_) */

#if defined(_SDD_MN66830_)
#include "device/SddSubr_api_for_mn66830.c"
#endif /* defined(_SDD_MN66830_) */

#if defined(_SDD_USE_SDMACLIB_)
#include "device/SddSubr_api_for_sdmaclib.c"
#endif /* defined(_SDD_USE_SDMACLIB_) */

#ifdef _SDD_JUPITER_
#include "device/SddSubr_api_for_jupiter.c"
#endif	/* _SDD_JUPITER_ */

#ifdef _SDD_UNIPHIER_2P_
#include "device/SddSubr_api_for_uniphier2p.c"
#endif	/* _SDD_UNIPHIER_2P_ */

#ifdef _SDD_UNIPHIER_XP_
#include "device/SddSubr_api_for_uniphierxp.c"
#endif	/* _SDD_UNIPHIER_XP_ */

#ifdef _SDD_PEAKS_PRO2_
#include "device/SddSubr_api_for_PeaksPro2.c"
#endif	/* _SDD_PEAKS_PRO2_ */

#ifdef _SDD_PCAM_
#include "device/SddSubr_api_for_pcam.c"
#endif	/* _SDD_PCAM_ */

#ifdef _SDD_4M_ANDROID_
#include "device/SddSubr_api_for_4mAndroid.c"
#endif	/* _SDD_4M_ANDROID_ */

#if !defined(_SDD_UNIPHIER_XP_)
/************************************************************************************/
/*  ֐		FSdds_DetachSub_middle											    */
/*  Tv		Ff^b`									                */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.3.6														    */
/************************************************************************************/
static SDD_ERROR Sdds_DetachSub_middle(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	
	/*==============================================*/
	/* SDI/F̃n[hZbg						*/
	/*	Sddr_HardReset( void )						*/
	/*	߂lG[Ȃ							*/
	/*	IOBPeriReset[0]̐ݒ(1ŃZbgj			*/
	/*==============================================*/
	w_TmpRet = Sddr_HardReset(p_SddHandle, SDD_MODE_STANDBY);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}

	/*==============================================*/
	/*	IMCLK2~:Sddr_SetDetectCLK(UW uw_Mode)	*/
	/*	=SDD_MODE_STANDBYiSTANDBYIMCLK2~j*/
	/*==============================================*/
	w_TmpRet = Sddr_SetDetectCLK(p_SddHandle, SDD_MODE_STANDBY);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}
	
	/*==============================================================================*/
	/* SD IOubNCNbN~												*/
	/*	IMCLK~:Sddr_SetMode(UW uw_Mode)											*/
	/*	=SDD_MODE_STANDBYiSTANDBYIMCLK~j									*/
	/*==============================================================================*/
	w_TmpRet = Sddr_SetMode(p_SddHandle, SDD_MODE_STANDBY);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}
	
	return w_Result;
}
#endif /* _SDD_UNIPHIER_XP_ */

/************************************************************************************/
/*  ֐		FSdds_AttachSub													*/
/*  Tv		FA^b`														*/
/*  			FhCõO[oϐ̏ASD I/F̑SW[Z	*/
/*				FbgsACxgR[obN֐ݒ肷B					*/
/*				F	O[oϐ											*/
/*				F	NbNiIMCLK/IMCLK2j									*/
/*				F	LSIZbg														*/
/*				F	荞݋֎~iSDI/F-S&StreamDMACj							*/
/*				F	荞݃R[obN NULLݒ									*/
/*				F	荞݋iCDMł̃J[h}̂݋j					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.3.6															*/
/************************************************************************************/
static SDD_ERROR Sdds_AttachSub(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;

    /* A^b`Oǉ 2006/07/31 H.Miura */
    w_TmpRet = Sdds_AttachSub_before(p_SddHandle);
	if(w_TmpRet != SDD_SUCCESS){
        w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
        return w_Result;
	}

	/*==========================================================*/
	/* hCoO[oϐ 						*/
	/*	ϐ SDD_DEV, R[obN֐				*/
	/*	Sdds_InitData()ł							*/
	/*	߂l̓G[Ȃipj							*/
	/*==========================================================*/
	Sdds_InitData(p_SddHandle);
	
	w_TmpRet = Sdds_Init(p_SddHandle);		/* Ƃ̋ʏ */
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}

    /* A^b`㏈ǉ 2007/02/02 H.Miura */
    w_TmpRet = Sdds_AttachSub_after(p_SddHandle);
	if(w_TmpRet != SDD_SUCCESS){
        w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
        return w_Result;
	}
    
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_CloseSub													*/
/*  Tv		FCLOSE														*/
/*  			FSDfoCXhCoCLOSEs							*/
/*				F	SDD_HANDLESDD_DEṼ|C^NA						*/
/*				F	SDD_HANDLEɃ|[gԍNA								*/
/*  		FȂ															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2004.1.22														*/
/********************************************************************************/
static SDD_ERROR Sdds_CloseSub(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;

	/*======================================*/
	/*	SDD_HANDLẼNA					*/
	/*	p_SddHandle->vp_Sdif = NULL			*/
	/*	p_SddHandle->ub_Port = |[gNA	*/
	/*======================================*/
	p_SddHandle->vp_Sdif = NULL;
	p_SddHandle->ub_Port = SDD_PORT_CLR;

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_DetachSub												*/
/*  Tv		Ff^b`													*/
/*  			FSDfoCXhCo̓o^sB							*/
/*				F	Detach̎												*/
/*				F	荞݋֎~iSDI/F-S&StreamDMACj						*/
/*				F	荞݃R[obN֐̃NA							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
static SDD_ERROR Sdds_DetachSub(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	UW	uw_Mode = (UW)0;

    /* f^b`Oǉ 2006/07/31 H.Miura */
    w_TmpRet = Sdds_DetachSub_before(p_SddHandle);
	if(w_TmpRet != SDD_SUCCESS){
        w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
	}

	/*======================================*/
	/*	AVIOubN̊荞݋֎~		*/
	/*	IOBIntrEn[0`1]̋֎~i0ŋ֎~j	*/
	/*	Sddr_DisSDBLKIntip_SddHandle)		*/
	/*	߂lG[Ȃipj		*/
	/*======================================*/
	w_TmpRet = Sddr_DisSDBLKInt(p_SddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}

    /* 
		STANBY[hΉ
		STANBY[h̏ꍇ͒ʏ탂[hiIMCLKONjɑJڂ
		J[h}mČɖ߂
	*/
	w_TmpRet = Sddr_GetMode(p_SddHandle, &uw_Mode);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}
	if(uw_Mode == SDD_MODE_STANDBY){
		w_TmpRet = Sddr_SetMode(p_SddHandle, SDD_MODE_NORMAL);
		if(w_TmpRet != SDD_SUCCESS){
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
			return w_Result;
		}
	}

    /*==================================*/
	/* SD I/F̑S荞݋֎~		*/
	/*	Sddr_DisIntAll( void )			*/
	/*	߂lG[Ȃipj	*/
	/*==================================*/
	Sddr_DisIntAll(p_SddHandle);	/* pgr0024 */

	if(uw_Mode == SDD_MODE_STANDBY){
		w_TmpRet = Sddr_SetMode(p_SddHandle, SDD_MODE_STANDBY);
		if(w_TmpRet != SDD_SUCCESS){
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
			return w_Result;
		}
	}

	/*
		UniPhierXPΉ
		 CNbN~Ƀn[hZbgȂ΂ȂȂn[hEFAdl
		 ̑̃foCX̓n[hZbgɃNbN~
	*/
	w_TmpRet = Sdds_DetachSub_middle(p_SddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}

    /*==================================*/
	/* Xg[DMAC荞݋֎~		*/
	/*	Sddr_DisDmacInt(p_SddHandle)	*/
	/*  ߂lG[Ȃipj	*/
	/*==================================*/
	Sddr_DisDmaInt(p_SddHandle);

    /* DetachSubp㏈ǉ 2007/02/02 H.Miura */
    w_TmpRet = Sdds_DetachSub_after(p_SddHandle);
    if(w_TmpRet != SDD_SUCCESS){
        w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
        return w_Result;
    }

	/*======================================================================*/
	/* hCoǗ̓ێO[oϐ̃NAA						*/		
	/* CxgR[obN֐AR[obN֐̃NAiׂNULLݒj	*/
	/*	Sdds_InitData( p_SddHandle )										*/
	/*	߂lG[Ȃipj										*/
	/*======================================================================*/
	Sdds_InitData(p_SddHandle);

	return w_Result;
}



#ifndef _SDD_MN6682X_
/************************************************************************************/
/*  ֐		FSDD_ReadWrite_before												*/
/*  Tv		F[hCg֐O										    */
/*  			F[hCg֐̑OsB                              */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.03.09														*/
/************************************************************************************/
static SDD_ERROR SDD_ReadWrite_before(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	/*==================================================*/
	/* rJn  									*/
	/*	G[̏ꍇ̂݁AG[1					*/
	/*	G[1F									*/
	/*		uh_ret |= G[lݒ						*/
	/*		ԑJځiSddDev[port].uh_Status = ύXj*/
	/*		return;										*/
	/*==================================================*/
	w_TmpRet = Sdd_WaiSem(&(p_sdd->OsInfo.normalSem));	/* OSbp[֐ */

	if(w_TmpRet != SDD_SUCCESS){
        /* Sdds_StartExclpG[ */
        w_ret = Sdds_StartExclError(p_SddHandle, w_TmpRet);
		p_sdd->Result.w_Result = w_ret;
		p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
		return w_ret;
	}
    return SDD_SUCCESS;
}
#endif /* _SDD_MN6682X_ */

#ifndef _SDD_MN6682X_
/************************************************************************************/
/*  ֐		FSDD_ReadWrite_after											    */
/*  Tv		F[hCg֐㏈										    */
/*  			F[hCg֐̌㏈sB                              */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.3.09															*/
/************************************************************************************/
static SDD_ERROR SDD_ReadWrite_after(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*==============================================*/
	/* rI  								*/
	/*	G[̏ꍇ̂݁AG[				*/
	/*		uh_ret |= G[lݒ					*/
	/*		return;									*/
	/*==============================================*/
	w_TmpRet = Sdd_SigSem(&(p_sdd->OsInfo.normalSem));	/* OSbp[֐ */

	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}
    return w_ret;
}
#endif /* _SDD_MN6682X_ */

#ifndef _SDD_USE_SDMACLIB_
/************************************************************************************/
/*  ֐		FSdds_AttachSub_after											    */
/*  Tv		FA^b`㏈									                */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.3.6														    */
/************************************************************************************/
static SDD_ERROR Sdds_AttachSub_after(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	SDD_ERROR	w_Result = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	/*==========================================*/
	/*  荞݂̋							*/
	/*	銄荞݁FSDI/FEStreamDMAC-ch4	*/
	/*	Sdd_EnaInt()ł			*/
	/*	FȂ								*/
	/*	߂l̓G[Ȃipj			*/
	/*==========================================*/
	w_TmpRet = Sdd_EnaInt( &p_sdd->OsInfo.sdifIntInfo );
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}

/******* ARMDMA荞݋/֎~͏ʑws悤ɕύX *********/
#ifdef _SDD_CTRL_INTC_ 
	w_TmpRet = Sdd_EnaInt( &p_sdd->OsInfo.dmaIntInfo );
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}
#endif

	/*==============================================================*/
	/* SD I/F̃J[ho|[OJn(CDMł̃J[h}o)	*/
	/*	Sdds_StartCDDetect(void)									*/
	/*	߂lG[Ȃipj								*/
	/*==============================================================*/
	return Sdds_StartCDDetect(p_SddHandle);
}

/************************************************************************************/
/*  ֐		FSdds_DetacuSub_before											    */
/*  Tv		Ff^b`O									                */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.3.6														    */
/************************************************************************************/
static SDD_ERROR Sdds_DetachSub_before(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;

	/*==============================================================*/
	/* SD I/F̃J[ho|[O~(CDMł̃J[h}o)	*/
	/*	Sdds_StopCDDetect(void)										*/
	/*	߂lG[Ȃipj								*/
	/*==============================================================*/
	w_Result = Sdds_StopCDDetect(p_SddHandle);

	/*==========================================*/
	/*  荞݂̋֎~							*/
	/*	֎~銄荞݁FSDI/FEStreamDMAC-ch4	*/
	/*	Sdd_DisInt()ł			*/
	/*	FȂ								*/
	/*	߂l̓G[Ȃipj			*/
	/*==========================================*/

/******** ARMDMA荞݋/֎~͏ʑws悤ɕύX *********/
#ifdef _SDD_CTRL_INTC_ 
	w_TmpRet = Sdd_DisInt( &p_sdd->OsInfo.dmaIntInfo );
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}
#endif

	w_TmpRet = Sdd_DisInt( &p_sdd->OsInfo.sdifIntInfo );
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}
	
	return w_Result;
}

#endif /* _SDD_USE_SDMACLIB_ */

#ifndef _SDD_MN66830_
/************************************************************************************/
/*  ֐		FSDD_Ioctl_before												    */
/*  Tv		FIOCTL֐O												    */
/*  			FIOCTL֐̑OsB                                     */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*  ߂l		FȂ																*/
/*  ŏIXV	F2010.3.9															*/
/************************************************************************************/
static void SDD_Ioctl_before(SDD_HANDLE *p_SddHandle)
{
    /* Ȃ */
	return;
}
#endif /* _SDD_MN66830_ */
