/********************************************************************************/
/*  t@C    F$Workfile: SddIoctl_basic.c $                               */
/*  Tv          FSDfoCXhCoʏpo͐֐t@C              */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 07/04/26 15:50 $                                  */
/*                  Sdds_ReadSub,Sdds_WriteSubʉ2006/08/07 H.Miura        */
/*                  IOCTLpʑOǉ 2006/08/08 H.Miura              */
/*                  IOCTLpʌ㏈ǉ 2006/08/08 H.Miura              */
/*                  IOCTLpREAD/WRITEʌ㏈ǉ 2006/08/08 H.Miura  */
/*                  IOCTLʎ擾pʑOǉ 2006/08/08 H.Miura      */
/*                  USBF؏p㏈ǉ 2006/08/08 H.Miura                */
/********************************************************************************/
/* wb_[t@C */
#include "SddCom.h"
#include "SddRegister.h"
#include "SddRegister_dma.h"
#include "SddOsEvent.h"
#include "SddOsIntr.h"
#include "SddError.h"
#include "SddSecure.h"
#include "SddIoctl_basic.h"
#include "SddIoctl_usb.h"
#include "SddOsTimer.h"
#include "SddCardInOut.h"

SDD_ERROR Sdds_Init_before(SDD_HANDLE *p_SddHandle);

/* Tu֐t@C */
#include "SddSubr_basic.c"

#if defined(_SDD_UNIPHIER_XP_)
#include "device/SddIoctl_basic_for_uniphierxp.c"
#endif /* defined(_SDD_UNIPHIER_XP_) */

/**********************************************************************************/
/*  ֐		FSdd_IocCardInit												  */
/*  Tv		FJ[h (SDD_IOC_CARD_INIT)								  */
/*  			FJ[h̏sAJ[h̊e擾B				  */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                */
/*      		FUW uw_Mode:J[hSDD_CARD_INIT_HARD/SDD_CARD_INIT_SOFT  */
/*                           SDIOSDD_CARD_INIT_SDIO_HARD/SDD_CARD_INIT_SDIO_SOFT*/
/*                           (4bit:SDD_CARD_INIT_HARD/SDD_CARD_INIT_SOFT)	  */
/*                           4bit:SDD_CARD_INIT_MODE_MEMORY([h)     */
/*                                    SDD_CARD_INIT_MODE_SDIO(SDIO[h)         */
/*  ߂l		FFSDD_SUCCESS												  */
/*  			FsFG[R[h											  */
/*  ŏIXV	F2009.03.10													  */
/**********************************************************************************/
SDD_ERROR Sdd_IocCardInit(SDD_HANDLE *p_SddHandle, UW uw_Mode)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	UB ub_CardInOut;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	UH uh_tmpStatus;
    uh_tmpStatus = Sdds_GetStatus(p_SddHandle);	/* ݂̏ԕێ */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocCardInit>\n");
    
	/*	QƂ݂̂Ȃ̂ŁARs[͎{Ȃ	*/

	/*==============*/
	/* `FbN */
	/*==============*/
	/*
		(uw_Mode)̃`FbN
		1) SDD_CARD_INIT_SOFT or SDD_CARD_INIT_HARD̏ꍇ
			p
		2)LȊȌꍇ
			G[1F
				uh_ret = SDD_ERR_PARAM;
				return;
	*/
	if( (uw_Mode != SDD_CARD_INIT_SOFT) && (uw_Mode != SDD_CARD_INIT_HARD)
#ifdef _SDD_FUNC_SDIO_
        && (uw_Mode != SDD_CARD_INIT_SDIO_SOFT) && (uw_Mode != SDD_CARD_INIT_SDIO_HARD)
#endif /* _SDD_FUNC_SDIO_ */
#ifdef _SDD_ALLOW_UHS1_
		&& (uw_Mode != SDD_CARD_INIT_LV_SOFT) && (uw_Mode != SDD_CARD_INIT_LV_HARD)
#endif /* _SDD_ALLOW_UHS1_ */
        ) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocCardInit w_ret = %ld\n", w_ret);
		return w_ret;
	}

	/*======================================================*/
	/* J[h}Adnm艻҂						*/
	/*	J[h艻҂֐(Sddr_WaitStable())				*/
	/*	=Ȃ											*/
	/*	߂lG[Ȃipj						*/
	/*======================================================*/
	Sddr_WaitStable();

	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */

	/*====================*/
	/* J[hL`FbN */
	/*====================*/
	/*
		̓J[ho֐ĂтSddr_DetectCard(UB *pub_CardInOut)Ŏs
		 = &ub_CardInOut
		߂lFȂ
		̖߂lɂĈȉ̏s
			1)J[hL̏ꍇ(ub_CardInOut==SDD_CARDIN)
				p
			2)̏ꍇ(ub_CardInOut==SDD_CARDOUT)
				G[2F
				uh_ret = SDD_ERR_CARD_OUT;
				return;
	*/
	Sddr_DetectCard(p_SddHandle, &ub_CardInOut);
	if(ub_CardInOut == SDD_CARDOUT) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NO_CARD);
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocCardInit w_ret = %ld\n", w_ret);
		return w_ret;
	}
	
	/*==============================================*/
	/* SOFT[hJ[h݂Ȃ珈Ȃ */
	/*==============================================*/
	/*
		(uw_Mode)
		1)SDD_CARD_INIT_SOFT̏ꍇ(_SDD_FUNC_SDIO_ݒ莞́ASOFTO񃂁[hƓ[hw̏ꍇ)
			1-1)J[h(SddDev[port].uh_Status == 0x80)̏ꍇ
				G[3
					ԑJ(ɖ߂)
					uh_ret = SDD_ERR_STATUS; -> SUCCESSɕύX
					(łSDD_ERR_ALREADY_INITǉĂ悢)
					return;
			1-2)J[h݂łȂ(SddDev[port].uh_Status != 0x80)ꍇ
				p
		2) ȊOȂ΁Ap
	*/
	if((uw_Mode & SDD_CARD_INIT_MODE_MASK) == SDD_CARD_INIT_SOFT){
		if(Sdds_GetStatus(p_SddHandle) & SDD_STATUS_INITFLG){
			if(((uw_Mode & SDD_CARD_MODE_MASK) == p_sdd->uw_OperationMode)	/* ݂̃Iy[V[hƈvꍇ */
				|| ((uw_Mode & SDD_CARD_MODE_MASK) == p_sdd->uw_PreOperationMode)) /* Ow̃Iy[V[hƈvƂ */
			{
				Sdds_SetStatus(p_SddHandle, uh_tmpStatus);	/* ԂOɖ߂ */
				Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
	            Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocCardInit w_ret = %ld\n", w_ret);
				return w_ret;
			}
		}
	}

	/*==============*/
	/* J[h */
	/*==============*/
	/*
		̓J[h֐(Sdds_CardInit)Ŏs
		Sdds_CardInit
		FȂ
		߂lF
			iSUCCESSj̏ꍇ
				Ƒ
			G[iSUCCESS)ȊȌꍇ
				G[3
					ԑJ(ɖ߂)
					uh_ret = ߂l̃G[R[h;
					return;

	*/
	Sddr_CardDataInit(p_SddHandle);							/* J[h̏Ȃ */
	p_sdd->ub_CardType = (UB)SDD_CARD_TYPE_UNKNOWN;	/* Ƃ肠m̃J[hƂ */
	p_sdd->w_error = SDD_SUCCESS;		/* Ƃ肠G[NA */

	p_sdd->uw_TmpOperationMode = uw_Mode & SDD_CARD_MODE_MASK;	/* Iy[V[ḧꎞۑ */
	p_sdd->uw_PreOperationMode = uw_Mode & SDD_CARD_MODE_MASK;	/* OwIy[V[hXV */

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */

	w_TmpRet = Sdds_CardInit(p_SddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		p_sdd->ub_CardType = (UB)SDD_CARD_TYPE_UNKNOWN;	/* J[hs͖m̃J[hƂ */
        /* IOCTLpʌ㏈ǉ 2006/08/08 H.Miura */
        if ((w_TmpRet = Sdds_ioctl_after(p_SddHandle)) != SDD_SUCCESS) {
            w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        }
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocCardInit w_ret = %ld\n", w_ret);
		return w_ret;	/* G[ɏԂ߂APIwŎ{ */
	}
    /* IOCTLpʌ㏈ǉ 2006/08/08 H.Miura */
    if ((w_TmpRet = Sdds_ioctl_after(p_SddHandle)) != SDD_SUCCESS) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocCardInit w_ret = %ld\n", w_ret);
		return w_ret;	/* G[ɏԂ߂APIwŎ{ */
    }

	/*==================================================================*/
	/* J[hσtOݒ											*/
	/*	SddDev[port].uh_Status |= SDD_STATUS_INITFLG					*/
	/*==================================================================*/
	Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle)|SDD_STATUS_INITFLG);

	p_sdd->uw_OperationMode = p_sdd->uw_TmpOperationMode;	/* Iy[V[hm肳 */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocCardInit w_ret = %ld\n", w_ret);
	return w_ret;
}

/************************************************************************************/
/*  ֐		FSdd_IocCheckWp													*/
/*  Tv		FCgveNg`FbN (SDD_IOC_CHECK_WP)						*/
/*  			Fw肳ꂽCgveNg`FbNB						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*      		FUW uw_Arg;SDD_WP\̂̃AhX									*/
/*				F(SDD_WP_ALL/SDD_WP_MECHANICAL/SDD_WP_PERMANENT/SDD_WP_TEMPORARY	*/
/*				FSDD_WP_CCC_BLOCK_WRITE/SDD_WP_CCC_ERASE/SDD_WP_ROMCARD)			*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.03.10													    */
/************************************************************************************/
SDD_ERROR Sdd_IocCheckWp(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_WP *p_SddWp = (SDD_WP *)uw_Arg;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocCheckWp>\n");
	/*==============*/
	/* `FbN */
	/*==============*/
	if((p_SddWp->uw_CheckWP == 0) || (p_SddWp->uw_CheckWP & ~SDD_WP_ALL)){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocCheckWp w_ret = %ld\n", w_ret);
		return w_ret;
	}

	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
	/*================================*/
	/* w肳ꂽCgveNg擾 */
	/*================================*/
	/*	WriteProtect̃`FbN
		`FbNWriteProtect͕݌vi\2-6ĵƂ
		͈ȉWriteProtect`FbN֐ōs
		SDD_ERROR Sdds_GetWP(UW uw_Check, BOOL bl_Stop, UW * puw_WP)
		FUW uw_Check(`FbNΏWP)
 			 BOOL bl_Stop(WPĂŏIȂ)
  			 UW uw_WP(`FbNWP)
		߂lFG[Ȃipj
	
		|C^փCgveNgݒ
		*((UW *)p_SddWp) =iSDD_DEV.Ub_Wp̂Aw肳ꂽWPbitݒj;
		SDD_DEV.Ub_Wp̓J[hɎ擾iMechancalj
	*/
	Sdds_GetWP(p_SddHandle, p_SddWp->uw_CheckWP, FALSE, &(p_SddWp->uw_Result));

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocCheckWp\n");
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocErase													*/
/*  Tv		Fʏ̈ (SDD_IOC_ERASE)									*/
/*  			FŎw肵SDD_ERASE\̂̏JnZN^ZN^ */
/*				Fʏ̈̏ȂB									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;(SDD_ERASE\̂̃AhX)							*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocErase(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	SDD_ERASE *pSddErase = (SDD_ERASE *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW	uw_AdrStart = 0;
	UW	uw_AdrEnd = 0;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocErase>\n");
	
    /* IOCTLʎ擾pʑOǉ 2006/08/08 H.Miura */
    Sdds_ioctl_getResult_before(SDD_PREFLG_ERASE);

	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */

/*** SDKiVer2.0ΉJnA2005.12.19 ***/
	/* HCJ[h̏ꍇAstart,endP = BLOCK */
	if(p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2))
	{
		/* \JnAhX̌ */
		uw_AdrStart = pSddErase->uw_Address;
		/* \IAhX̌ */
		uw_AdrEnd = pSddErase->uw_Address + pSddErase->uw_Count;
	}
#ifdef _SDD_ALLOW_MMC_
	/* Large Erase[hɑΉĂMMC̏ꍇ */
	else if(p_sdd->MmcInfo.ub_HcFlag & SDD_MMC_HC)
	{
		/* \JnAhX̌ */
		uw_AdrStart = ((pSddErase->uw_Address + p_sdd->uw_EraseByteMin - 1) / p_sdd->uw_EraseByteMin) * p_sdd->uw_EraseByteMin;
		/* \IAhX̌ */
		uw_AdrEnd = ((pSddErase->uw_Address + pSddErase->uw_Count) / p_sdd->uw_EraseByteMin) * p_sdd->uw_EraseByteMin;
	
	}
#endif /* _SDD_ALLOW_MMC_ */
	else {
		/* \JnAhX̌ */
		uw_AdrStart = (((pSddErase->uw_Address * SDD_SECTOR_SIZE) + p_sdd->uw_EraseByteMin - 1) / p_sdd->uw_EraseByteMin) * p_sdd->uw_EraseByteMin;
		/* \IAhX̌ */
		uw_AdrEnd = (((pSddErase->uw_Address + pSddErase->uw_Count) * SDD_SECTOR_SIZE) / p_sdd->uw_EraseByteMin) * p_sdd->uw_EraseByteMin;
	}
/*** SDKiVer2.0ΉENDA2005.12.19 ***/
	/* \ȂꍇI */
	if(uw_AdrStart == uw_AdrEnd){
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocErase w_ret = %ld\n", w_ret);
		return w_ret;
	}
	
	/* ʏ̈ȊOErase w̏ꍇG[ */
	if((pSddErase->uw_Address + pSddErase->uw_Count) > p_sdd->uw_NormalSize){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		p_sdd->Result.w_Result = w_ret;
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocErase w_ret = %ld\n", w_ret);
		return w_ret;
	}

	if(pSddErase->uw_Count == (UW)0) {	/* ZN^0̏ꍇ̓AhXvZȂ̂ŐIc */
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocErase w_ret = %ld\n", w_ret);
		return w_ret;
	}

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */

	/*
		Erase̎Sdds_EraseSub()Ŏs
			Sdds_EraseSub()
			FJnZN^
				  ZN^
			߂lF
				1)߂lIiSUCCESSj̏ꍇA
					p
				2)߂lG[̏ꍇ̂݁iSUCCESSȊOj
					G[2F
					uh_ret |= G[lݒ;
					ԑJڂȌԂɖ߂
					return;
	*/
    /* IOCTLpʑOǉ 2006/08/08 H.Miura */
    /*                        ύX 2007/04/24 Suzuki  */
	if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocErase w_ret = %ld\n", w_ret);
		return w_ret;
	}
	w_TmpRet = Sdds_EraseSub(p_SddHandle, uw_AdrStart, uw_AdrEnd);
    /* IOCTLpREAD/WRITEʌ㏈ǉ 2006/08/08 H.Miura  */
    Sdds_ioctl_readwrite_after(p_SddHandle);

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocErase w_ret = %ld\n", w_ret);
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetAreaSize											*/
/*  Tv		Fʏ̈TCY擾 (SDD_IOC_GET_AREA_SIZE)					*/
/*  			Fʏ̈TCY擾										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;(̈TCYi[pAhX)							*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetAreaSize(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	UW *puw_Size = (UW *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetAreaSize>\n");
#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_GETAREASIZE );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */	
	/*==================*/
	/* ʏ̈eʎ擾 */
	/*==================*/
	/*
		|C^փhCof[^̒ʏ̈eʐݒ
		*(puw_Size) = SddDev[port].uw_NormalSize;
		SDD_DEV.uw_NormalSize̓J[hɎ擾
	*/
	*(puw_Size) = p_sdd->uw_NormalSize;

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetAreaSize\n");
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetCardCapacity										*/
/*  Tv		FJ[hTCY擾 (SDD_IOC_GET_CARD_CAPACITY)					*/
/*  			FɕێJ[hTCY擾						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;(Capacityi[pAhX)							*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetCardCapacity(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	UW *puw_Capacity = (UW *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetCardCapacity>\n");
#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_GETCARDCAPACITY );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
	/*================*/
	/* J[heʎ擾 */
	/*================*/
	/*
		|C^փhCof[^̃J[heʐݒ
		*(puw_Capacity) = SddDev[port].uw_CardSize;
		SDD_DEV.uw_CardSize̓J[hɎ擾(512Bɐݒ)
	*/
	*(puw_Capacity) = p_sdd->uw_CardSize;

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetCardCapacity\n");
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetCardInfo											*/
/*  Tv		FJ[h擾 (SDD_IOC_GET_CARD_INFO)						*/
/*  			FJ[h(CID,CSD)擾B								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;J[hi[pAhX(32B̈)					*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetCardInfo(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	UB *pub_Info = (UB *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetCardInfo>\n");
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
	/*===========*/
	/* CIDRs[ */
	/*===========*/
	/*
		|C^փhCof[^CIDRs[
		P = pub_Info
		Q = SddDev[port].ub_Cid
		R = CID_SIZE
		Sdd_memcpy(UB *pub_Dst, UB *pub_Src, UH uh_Size)JmpAp
	*/
#ifdef _SDD_BIGENDIAN_
	Sdds_memcpyChangeEndian(p_SddHandle, pub_Info, p_sdd->ub_Cid, SDD_CID_SIZE);
#else /* _SDD_BIGENDIAN_ */
	Sdd_memcpy(p_SddHandle, pub_Info, p_sdd->ub_Cid, SDD_CID_SIZE);
#endif /* _SDD_BIGENDIAN_ */

	/*===========*/
	/* CSDRs[ */
	/*===========*/
	/*
		|C^փhCof[^CSDRs[
		P = pub_Info
		Q = SddDev[port].ub_Csd
		R = CSD_SIZE
		Sdd_memcpy(p_SddHandle, UB *pub_Dst, UB *pub_Src, UH uh_Size)JmpAp
	*/
	pub_Info += SDD_CID_SIZE;
#ifdef _SDD_BIGENDIAN_
	Sdds_memcpyChangeEndian(p_SddHandle, pub_Info, p_sdd->ub_Csd, SDD_CSD_SIZE);
#else /* _SDD_BIGENDIAN_ */
	Sdd_memcpy(p_SddHandle, pub_Info, p_sdd->ub_Csd, SDD_CSD_SIZE);
#endif /* _SDD_BIGENDIAN_ */
	
	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetCardInfo\n");
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetCardStatus											*/
/*  Tv		FJ[hXe[^X擾 (SDD_IOC_GET_CARD_STATUS)				*/
/*  			FJ[hXe[^X擾B									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;J[hXe[^Xi[pAhX(4B̈)				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetCardStatus(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	UW	*puw_Status = (UW *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetCardStatus>\n");
	/*==================================*/
	/* J[hXe[^X擾 			*/
	/*==================================*/
	/*
		CMD13Card Status擾
		Sdds_GetCardStatus()Ŏs
			FȂ
			߂lF
				1)߂lIiSUCCESSj̏ꍇA
					|C^փhCof[^̃J[hXe[^Xݒ
					*puw_Status = SddDev[port].uw_CardStatus;
				2)߂lG[̏ꍇ̂݁iSUCCESSȊOj
					G[1F
					uh_ret |= G[lݒ;
					ԑJڂȌԂɖ߂
					return;
	*/
    /* IOCTLpʑOǉ 2006/08/08 H.Miura */
    /*                        ύX 2007/04/24 Suzuki  */
	if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetCardStatus\n");
		return w_ret;
	}
	w_TmpRet = Sdds_GetCardStatus(p_SddHandle);

	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}else{
		*puw_Status = p_sdd->uw_CardStatus;
	}
    /* IOCTLpʌ㏈ǉ 2006/08/08 H.Miura */
    if ((w_TmpRet = Sdds_ioctl_after(p_SddHandle)) != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
    }
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetCardStatus\n");
    return w_ret;
}

#ifdef _SDD_ALLOW_MMC_
/********************************************************************************/
/*  ֐		FSdd_IocGetExtCsd												*/
/*  Tv		FEXT-CSD擾 (SDD_IOC_GET_EXT_CSD)								*/
/*  			FEXT-CSD擾(MMC Ver4.0ȏオΏہjB					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*              FUW uw_Arg;EXT-CSDi[pAhX(4B̈)						*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.23														*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetExtCsd(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	UB	*pub_ExtCsd = (UB *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetExtCSD>\n");

	/* MMCKi Ver4.0ȏ̃J[hΏۂɂȂ */
	if (((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC) 
		&& (p_sdd->MmcInfo.ub_Spec >= SDD_MMC_SPEC_VERS_4)){
		/*==================================*/
		/* EXT-CSD擾 						*/
		/*==================================*/
		/*
			CMD8EXT-CSD擾
			Sdds_GetExtCsd()Ŏs
				FȂ
				߂lF
					1)߂lIiSUCCESSj̏ꍇA
						|C^փhCof[^EXT-CSDݒ
						*puw_Status = SddDev[0].Mmcinfo.ub_ExtCsd[0];
					2)߂lG[̏ꍇ̂݁iSUCCESSȊOj
						G[1F
						uh_ret |= G[lݒ;
						ԑJڂȌԂɖ߂
						return;
		*/
	    /* IOCTLpʑOǉ 2006/08/08 H.Miura */
	    /*                        ύX 2007/04/24 Suzuki  */
		if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetExtCsd\n");
			return w_ret;
		}
		w_TmpRet = Sdds_MmcGetExtCsd(p_SddHandle);

		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		}else{
#ifdef _SDD_BIGENDIAN_
			Sdds_memcpyChangeEndian(p_SddHandle, pub_ExtCsd, p_sdd->MmcInfo.ub_ExtCsd, SDD_MMC_EXTCSD_SIZE);
#else /* _SDD_BIGENDIAN_ */
			Sdd_memcpy(p_SddHandle, pub_ExtCsd, p_sdd->MmcInfo.ub_ExtCsd, SDD_MMC_EXTCSD_SIZE);
#endif /* _SDD_BIGENDIAN_ */
		}
	    /* IOCTLpʌ㏈ǉ 2006/08/08 H.Miura */
	    if ((w_TmpRet = Sdds_ioctl_after(p_SddHandle)) != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	    }
	}else{
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
	}
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetExtCsd\n");
    return w_ret;
}
#endif /* _SDD_ALLOW_MMC_ */

/********************************************************************************/
/*  ֐		FSdd_IocGetCardType											*/
/*  Tv		FJ[h^Cv擾 (SDD_IOC_GET_CARD_TYPE)						*/
/*  			FɕێJ[h^Cv擾B					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;(TypẽAhXj									*/
/*				F(SDD_CARD_TYPE_SD/SDD_CARD_TYPE_MMC/SDD_CARD_TYPE_IO/			*/
/*				FSDD_CARD_TYPE_COMBO/SDD_CARD_TYPE_UNKNOWN/SDD_CARD_TYPE_NOCARD*/
/*				F/SDD_CARD_TYPE_PERFORMANCE)									*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetCardType(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	UW *puw_Type = (UW *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UB	ub_CardInOut;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetCardType>\n");
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
	/*==========================================================================*/
	/* J[h̗L`FbN														*/
	/*	1)J[hL̏ꍇAp											*/
	/*	2)ȊȌꍇAG[1											*/
	/*		G[1F														*/
	/*			uh_ret = SDD_SUCCESS 											*/
	/*			*uw_Arg = SDD_CARD_TYPE_NOCARD									*/
	/*			return;															*/
	/*==========================================================================*/
	Sddr_DetectCard( p_SddHandle, &ub_CardInOut ); /* J[hL`FbN */
	if ( ub_CardInOut == SDD_CARDOUT) {
		*puw_Type = SDD_CARD_TYPE_NOCARD;
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetCardType w_ret = %ld\n", w_ret);
		return w_ret;	/* SDD_SUCCESS */
	}

	/*==========================================================================*/
	/* J[hς݃tO(SddDev[port].uh_Status)̃`FbN					*/
	/*	1)ς(0x80)̏ꍇAp											*/
	/*	2)ȊȌꍇAG[1											*/
	/*		G[1F														*/
	/*			J[hTypeݒ=SDD_CARD_TYPE_UNKNOWN							*/
	/*			uh_ret |= SDD_SUCCESS											*/
	/*			return;															*/
	/*==========================================================================*/
	if (!(Sdds_GetStatus(p_SddHandle) & SDD_STATUS_INITFLG)) {
		*puw_Type = SDD_CARD_TYPE_UNKNOWN;
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetCardType w_ret = %ld\n", w_ret);
		return w_ret;	/* SDD_SUCCESS */
	}

	/*==================*/
	/* J[h^Cv擾 */
	/*==================*/
	/*
		|C^փhCof[^̃J[h^Cvݒ
		*(puw_Type) = (UW)SddDev[port].ub_CardType;
		SDD_DEV.ub_CardType̓J[hɎ擾
	*/
	*(puw_Type) = (UW)p_sdd->ub_CardType | ((UW)p_sdd->uh_CardType2 << 8);

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetCardType w_ret = %ld\n", w_ret);
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetResult												*/
/*  Tv		Fʎ擾 (SDD_IOC_GET_RESULT)								*/
/*  			FÕ[h^Cg^̏ʂ擾B				*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;SDD_RESULT\̂̃AhX							*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetResult(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
#ifdef	_SDD_SDUSB_TRANSFER_
	SDD_ERROR w_TmpRet;
#endif
	SDD_RESULT *p_SddResult = (SDD_RESULT *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetResult>\n");
	/*==============*/
	/* O񏈗  
		(SddDev[port].uh_Status, SddDev[port].Result.uh_Flag)*/
	/*==============*/
	/* 
		݂̏ԂUSB,R/W肵𕪊
		SddDev[port].ub_Preflg̃`FbN 
		1)USB-Read(SddDev[port].ub_Preflg == }Nl0x01)̏ꍇ
			USB_ReadEnd
			Sdds_USBReadEnd();Ŏs
				FȂ
				߂lF
					1)߂lIiSUCCESSj̏ꍇA
						eݒ(SDD_RESULT.uh_Flag = e)
						p
				2)߂lG[̏ꍇ̂݁iSUCCESSȊOj
					G[1F
					uh_ret |= G[lݒ;
					return;
		2)USB-Write(SddDev[port].ub_Preflg == }Nl0x02)̏ꍇ
			USB_WriteEnd
			Sdds_USBWriteEnd();Ŏs
				FȂ
				߂lF
					1)߂lIiSUCCESSj̏ꍇA
						eݒ(SDD_RESULT.uh_Flag = e)
						p
				2)߂lG[̏ꍇ̂݁iSUCCESSȊOj
					G[1F
					uh_ret |= G[lݒ;
					return;
  		4)Read, Write(SddDev[port].ub_Preflg == }Nl0x01,0x02)̏ꍇ
			eݒ(SDD_RESULT.uh_Flag = e)
			p
		5)LȊȌꍇ
			G[1F
				ZN^ݒ(SDD_RESULT.uw_Resid = 0)
				ʐݒ(SDD_RESULT.w_Result = SDD_SUCCESS)
				eݒ(SDD_RESULT.uh_Flag = SDD_RESULT_OTHER)
				uh_ret = SDD_ERR_NOT_SUPPORT;
				return;
  	*/
	
#ifdef	_SDD_SDUSB_TRANSFER_
	if((Sdds_GetStatus(p_SddHandle) & SDD_STATUS_USB_RW) && (p_sdd->ub_Preflg & SDD_PREFLG_READ)){
		w_TmpRet = Sdds_USBReadEnd(p_SddHandle);
		if(w_TmpRet != SDD_SUCCESS){
			p_sdd->Result.w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		}
		p_SddResult->uh_Flag = SDD_RESULT_READ;
	}
	else if((Sdds_GetStatus(p_SddHandle) & SDD_STATUS_USB_RW) && (p_sdd->ub_Preflg & SDD_PREFLG_WRITE)){
		w_TmpRet = Sdds_USBWriteEnd(p_SddHandle);
		if(w_TmpRet != SDD_SUCCESS){
			p_sdd->Result.w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		}
		p_SddResult->uh_Flag = SDD_RESULT_WRITE;
	}
	else if((Sdds_GetStatus(p_SddHandle) & SDD_STATUS_IOCTL) && (p_sdd->ub_Preflg & SDD_PREFLG_READ)){
#else 
	if((Sdds_GetStatus(p_SddHandle) & SDD_STATUS_IOCTL) && (p_sdd->ub_Preflg & SDD_PREFLG_READ)){
#endif /* _SDD_SDUSB_TRANSFER_ */
			p_SddResult->uh_Flag = SDD_RESULT_READ;
	}
	else if((Sdds_GetStatus(p_SddHandle) & SDD_STATUS_IOCTL) && (p_sdd->ub_Preflg & SDD_PREFLG_WRITE)){
			p_SddResult->uh_Flag = SDD_RESULT_WRITE;
	}
	else if((Sdds_GetStatus(p_SddHandle) & SDD_STATUS_IOCTL) && (p_sdd->ub_Preflg & SDD_PREFLG_ERASE)){
			p_SddResult->uh_Flag = SDD_RESULT_ERASE;
	}
#ifdef	_SDD_FUNC_SECURE_
	else if((p_sdd->uh_SecureStatus & SDD_SECURE_STATUS_IOCTL) && (p_sdd->ub_Preflg & SDD_PREFLG_READ)){
			p_SddResult->uh_Flag = SDD_RESULT_READ;
	}
	else if((p_sdd->uh_SecureStatus & SDD_SECURE_STATUS_IOCTL) && (p_sdd->ub_Preflg & SDD_PREFLG_WRITE)){
			p_SddResult->uh_Flag = SDD_RESULT_WRITE;
	}
	else if((p_sdd->uh_SecureStatus & SDD_SECURE_STATUS_IOCTL) && (p_sdd->ub_Preflg & SDD_PREFLG_ERASE)){
			p_SddResult->uh_Flag = SDD_RESULT_ERASE;
	}
#endif	/* _SDD_FUNC_SECURE_ */
	else{	/* Read,Write,EraseȂŁASDD_IOC_GER_RESULTĂ΂ꂽꍇ */
		p_SddResult->uw_Resid = 0;
		p_SddResult->w_Result = SDD_SUCCESS;
		p_SddResult->uh_Flag = SDD_RESULT_OTHER;
		p_sdd->uw_UsbRwSector = 0;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetResult w_ret = %ld\n", w_ret);
		return w_ret;	/* I */
	}

	/*====================================*/
	/* ʐݒ(O[of[^) */
	/*====================================*/
	/* ZN^ݒ(SDD_RESULT.uw_Resid = SddDev[port].Result.uw_Resid) */				
	/* ʐݒ(SDD_RESULT.w_Result = SddDev[port].Result.w_Result) */	
	/* eݒ(SDD_RESULT.uh_Flag = SddDev[port].Result.uh_Flag) */
	p_SddResult->uw_Resid = p_sdd->Result.uw_Resid;
	p_SddResult->w_Result = p_sdd->Result.w_Result;
	p_sdd->uw_UsbRwSector = 0;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetResult w_ret = %ld\n", w_ret);
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetSdStatus											*/
/*  Tv		FSDXe[^X擾 (SDD_IOC_GET_SD_STATUS)						*/
/*  			FJ[hSDXe[^X擾B							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB uw_Arg;SDXe[^Xi[pAhX(64B̈)					*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetSdStatus(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	UB *pub_SdStatus = (UB *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UB ub_type;
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetSdStatus>\n");
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
	/*==========================================*/
	/* J[h^Cv`FbN
	 (SD,SDROMJ[h,COMBOJ[ĥݎ擾\) */
	/*==========================================*/
	/*
		J[h^Cv`FbN(SddDev[port].ub_CardType)
			1) SddDev[port].ub_CardType(CARDTYPE_SD | CARDTYPE_SDROM | CARDTYPE_COMBO)ꂩ̏ꍇ
				p
			2)LȊȌꍇA
				G[1F
					uh_ret = SDD_ERR_NOT_SUPPORT;
					return;
	*/
	ub_type = (UB)(p_sdd->ub_CardType & (UB)SDD_CARD_TYPE_MASK);

	if ((ub_type != (UB)SDD_CARD_TYPE_SD) && (ub_type != (UB)SDD_CARD_TYPE_COMBO)) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetSdStatus w_ret = %ld\n", w_ret);
		return w_ret;
	}

	/*====================*/
	/* SDXe[^XRs[ */
	/*====================*/
	/*
		|C^փhCof[^SDXe[^XRs[
		P = pub_SdStatus
		Q = SddDev[port].ub_SdStatus
		R = SDSTATUS_SIZE
		Sdd_memcpy(p_SddHandle, UB *pub_Dst, UB *pub_Src, UH uh_Size)JmpAp
		SDD_DEV.Ub_SdStatus̓J[hɎ擾
	*/
	Sdd_memcpy(p_SddHandle, pub_SdStatus, p_sdd->ub_SdStatus, SDD_SDSTATUS_SIZE);
	
	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetSdStatus w_ret = %ld\n", w_ret);
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetSectorSize											*/
/*  Tv		FZN^TCY擾 (SDD_IOC_GET_SECTOR_SIZE)					*/
/*  			Fɐݒ肵liŒlF512B)擾					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;(TCỸAhX)									*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetSectorSize(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	UW *puw_Size = (UW *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetSectorSize>\n");
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */

	/*==================*/
	/* ZN^TCY擾 */
	/*==================*/
	/*
		|C^փhCof[^̃ZN^TCYݒ
		*(puw_Size) = SddDev[port].uw_SectorSize;
		SDD_DEV.uw_SectorSize̓J[hɎ擾(512Bɐݒ)
	*/
	*(puw_Size) = p_sdd->uw_SectorSize;

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetSectorSize\n");
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetStatus												*/
/*  Tv		FSDfoCXhCoXe[^X擾 (SDD_IOC_GET_STATUS)			*/
/*  			FSDfoCXhCoXe[^XiJ[h^CvAXg[DMACL*/
/*				FEA[hAWPAJ[hL擾B					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;Statusi[pAhX(4B̈)						*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetStatus(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	
	UB ub_CardInOut;
	UW uw_Wp;
	UW uw_Status = 0;
	UW uw_Mode;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_ERROR w_TmpRet;
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetStatus>\n");
	/*	Rs[I/FwŎ{Ă̂Ŏ{Ȃ	*/

	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
	/*==================*/
	/* SD I/F[h擾 */
	/*==================*/
	/*
		SD I/F[h擾(IOBPeriClkStop)
		Sddr_GetMode()Ŏs
			Fuw_RetMode
			߂lFȂ
			1) uw_RetMode == SDD_MODE_STANDBY(X^oC[h)Ȃ΁Auw_Status |= (UW)(SDD_STATUS_STANBY)(2bit)
			2) uw_RetMode == SDD_MODE_NORMALȂ΁Auw_Status &= (UW)(~(SDD_STATUS_STANBY))
	*/
	w_TmpRet = Sddr_GetMode(p_SddHandle, &uw_Mode);
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetStatus w_ret=%ld\n", w_ret);
		return w_ret;
	}
	if(uw_Mode == SDD_MODE_STANDBY){
		uw_Status |= (UW)(SDD_STATUS_STANBY);
		w_TmpRet = Sddr_SetMode(p_SddHandle, SDD_MODE_NORMAL);
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
			Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
            Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetStatus w_ret=%ld\n", w_ret);
			return w_ret;
		}
	}else{
		uw_Status &= (UW)(~(SDD_STATUS_STANBY));
	}

	/*================*/
	/* J[hL擾 */
	/*================*/
	/*
	J[hL(INFO1)
		̓J[ho֐ĂтSddr_DetectCard(UB *pub_CardInOut)Ŏs
		 = &ub_CardInOut
		߂lFȂ
		̖߂lɂĈȉ̏s
			1)J[hL̏ꍇ(ub_CardInOut==SDD_CARDIN)
				uw_Status |= (UW)(SDD_CARDIN)(0bit)
			2)̏ꍇ(ub_CardInOut==SDD_CARDOUT)
			uw_Status |= (UW)(SDD_CARDOUT)
	*/
	Sddr_DetectCard(p_SddHandle, &ub_CardInOut);
	if(ub_CardInOut == SDD_CARDIN){
			uw_Status |= (UW)SDD_CARDIN;

	/*==================*/
	/* J[h^Cv擾 */
	/*==================*/
	/*
		J[h^Cvrbg(4-9bit)ɐݒ
		uw_Status |= ((SddDev[port].uw_CardType << 4) | 0x000003f0)
	*/
			uw_Status |= (((UW)(p_sdd->ub_CardType) << SDD_CARD_TYPE_SHIFT) & SDD_CARD_TYPE_SHIFT_MASK);
	}else{
			uw_Status &= (UW)(~(SDD_CARDIN));
			/* J[h^CvݒiJ[h΍j */
			uw_Status |= ((SDD_CARD_TYPE_NOCARD << SDD_CARD_TYPE_SHIFT) & SDD_CARD_TYPE_SHIFT_MASK);
	}

	/*======================*/
	/* CgveNg擾 */
	/*======================*/
	/*
		CgveNg`FbNAłCgveNg΃CgveNgƂ
		P = SDD_WP_ALL
		Q = TRUE
		R = &uw_Wp
		Sdds_GetWP(UW uw_Check, BOOL bl_Stop, UW * puw_WP)jumpAp
			1) uw_Wp == 0(WPȂ)Ȃ΁Auw_Status &= (UW)((SDD_STATUS_WP))
			2) uw_Wp != 0(WP)Ȃ΁Auw_Status |= (UW)(SDD_STATUS_WP))(1bit)
	*/
	Sdds_GetWP(p_SddHandle, SDD_WP_ALL, TRUE, &uw_Wp);
	if(uw_Wp & SDD_WP_ALL){
		uw_Status |= (UW)(SDD_STATUS_WP);
	}else{
		uw_Status &= (UW)(~(SDD_STATUS_WP));
	}

	/*============*/
	/* ɐݒ */
	/*============*/
	/*
		|C^֊e擾ʐݒ
		*((UW *)pv_Arg) = uw_Status;
	*/
	*((UW *)uw_Arg) = uw_Status;
	
	/* 
		STANBY[hΉ
		STANBY[h̏ꍇ͒ʏ탂[hiIMCLKONjɑJڂ
		J[h}mČɖ߂
	*/
	if(uw_Mode == SDD_MODE_STANDBY){
		w_TmpRet = Sddr_SetMode(p_SddHandle, SDD_MODE_STANDBY);
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		}
	}

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetStatus w_ret=%ld\n", w_ret);
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocInit													*/
/*  Tv		FSDfoCXhCo (SDD_IOC_INIT)						*/
/*  			FhCõO[oϐ̏ASD I/F̑SW[Z*/
/*				FbgsACxgR[obN֐ݒ肷B				*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg		(SDD_INIT\̂̃AhX)						*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocInit(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;					/* ߂l̃ftHgݒ */
	SDD_ERROR	w_TmpRet;
	SDD_INIT *p_SddInit = (SDD_INIT *)uw_Arg;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocInit>\n");
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */

	/*=========================================*/
	/* CxgR[obN֐̐ݒ(CARD=IN) */
	/*=========================================*/
	/*
	1 = SDD_EVENT_CARD_IN
	2 = SddInit.vp_CardInFunc
	3 = SddInit.uw_CardInParam

	Sddr_SetCbf(UW uw_WaitEvent, void * vp_Func, UW uw_Param)jumpAp
	*/
	Sdds_SetCbf(p_SddHandle, SDD_EVENT_CARD_IN, p_SddInit->vp_CardInFunc, p_SddInit->uw_CardInParam);

	/*==========================================*/
	/* CxgR[obN֐̐ݒ(CARD=OUT) */
	/*==========================================*/
	/*
	1 = SDD_EVENT_CARD_OUT
	2 = SddInit.vp_CardOutFunc
	3 = SddInit.uw_CardOutParam

	Sddr_SetCbf(UW uw_WaitEvent, void * vp_Func, UW uw_Param)jumpAp
	*/
	Sdds_SetCbf(p_SddHandle, SDD_EVENT_CARD_OUT, p_SddInit->vp_CardOutFunc, p_SddInit->uw_CardOutParam);

	/*
		AttachƂ̓f[^قȂ邽
		Sdds_InitSub()ōs
			FȂ
			߂lF
				1)߂lIiSUCCESSj̏ꍇA
					p
				2)߂lG[̏ꍇ̂݁iSUCCESSȊOjA(Ȃ͂ꉞĂj
					G[2F
					uh_ret |= G[lݒ;
					return;
	*/
	w_TmpRet = Sdds_InitSub(p_SddHandle);

	if(w_TmpRet != SDD_SUCCESS){
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocInit w_ret=%ld\n", w_ret);
		return w_ret;	/* G[ɏԂ߂APIwŎ{ */
	}

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocInit w_ret=%ld\n", w_ret);
	return w_ret;
}

#ifdef _SDD_ENABLE_IOC_READWRITE_
/********************************************************************************/
/*  ֐		FSdd_IocRead													*/
/*  Tv		Fʏ̈惊[h֐(SDD_IOC_READ)								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FSDD_RW *pv_Arg												*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocRead(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*	Rs[I/FwŎ{Ă̂Ŏ{Ȃ
		̂߂Ɉ̃Rs[	*/
	SDD_RW *p_SddRw;
    p_SddRw = (SDD_RW *)uw_Arg;	/* SDD_RW\̂ւ̃|C^ɃRs[ */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocRead>\n");

    /* IOCTLʎ擾pʑOǉ 2006/08/08 H.Miura */
    Sdds_ioctl_getResult_before(SDD_PREFLG_READ);

	/*==============*/
	/* `FbN */
	/*==============*/
	/*
		1)p_SddRw->pb_Buff == NULL ̏ꍇ
			G[1F
				uh_ret = SDD_ERR_PARAM;
				return;
		2)pub_SddRw != NULL̏ꍇ
			p
	*/
	if(p_SddRw->pb_Buff == NULL){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		p_sdd->Result.w_Result = w_ret;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocRead w_ret=%ld\n", w_ret);
		return w_ret;
	}
	else if (Sddr_CheckAddrAlign(p_SddRw->pb_Buff)) {		/* ]ACg`FbN */
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		p_sdd->Result.w_Result = w_ret;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocRead w_ret=%ld\n", w_ret);
		return w_ret;
	}

	/* J[hʏ̈TCY̏ꍇG[ */
	if(((p_SddRw->uw_Offset) + (p_SddRw->uw_Count)) > p_sdd->uw_NormalSize){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		p_sdd->Result.w_Result = w_ret;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocRead w_ret=%ld\n", w_ret);
		return w_ret;
	}

	/*
		Read̎
		SD_CLK̏o͂ƒ~
		StreamDMACݒƋN
		ReadR}hR}hsO
		ReadR}hiCMD18)s
		X|XM
		
		G[ɃgCsȂ
		Sdds_ReadWriteSub()Ŏs 
		
		P = pb_Buff
		Q = uw_Count
		R = uw_Offset
	*/
	/*
		1)߂lIiSUCCESSj̏ꍇA
			rIցipj
		2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
			G[2F
			uh_ret |= G[lݒ;

	*/
	if(p_SddRw->uw_Count != 0){
        /* IOCTLpʑOǉ 2006/08/08 H.Miura */
        /*                        ύX 2007/04/24 Suzuki  */
		if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocRead w_ret=%ld\n", w_ret);
			return w_ret;
		}
		w_TmpRet = Sdds_ReadWriteSub(p_SddHandle, p_SddRw->pb_Buff, p_SddRw->uw_Count, p_SddRw->uw_Offset, FALSE);
        /* IOCTLpREAD/WRITEʌ㏈ǉ 2006/08/08 H.Miura  */
        Sdds_ioctl_readwrite_after(p_SddHandle);
	}

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocRead w_ret=%ld\n", w_ret);
	return w_ret;
}
#endif /* _SDD_ENABLE_IOC_READWRITE_ */

/************************************************************************************/
/*  ֐		FSdd_IocSetClockDiv												*/
/*  Tv		FSDNbNݒ (SDD_IOC_SET_CLOCK_DIV)							*/
/*  			Fw肳ꂽݒ肷B										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*      		FUW uw_ClockDiv													*/
/*				F(SDD_CLOCK_DIV_1/SDD_CLOCK_DIV_2/SDD_CLOCK_DIV_4/					*/
/*				FSDD_CLOCK_DIV_8/SDD_CLOCK_DIV_16/SDD_CLOCK_DIV_32/				*/
/*				FSDD_CLOCK_DIV_64/SDD_CLOCK_DIV_128/SDD_CLOCK_DIV_256/				*/
/*				FSDD_CLOCK_DIV_512/SDD_CLOCK_DIV_FULLSPEED/SDD_CLOCK_DIV_LOWSPEED)	*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.03.10														*/
/************************************************************************************/
SDD_ERROR Sdd_IocSetClockDiv(SDD_HANDLE *p_SddHandle, UW uw_ClockDiv)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	UW uw_SetDiv;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocSetClockDiv>\n");
	
	/* 
		SDR25,SDR50[h̓NbNύXs
		SDIPOAC^C~O{邽ߌŒ蕪̂ݎgp\
	*/ 
	if (((p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK) == SDD_CARD_FUNC_SDR25)
		 || ((p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK) == SDD_CARD_FUNC_SDR50)) {
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetClockDiv w_ret = %ld\n", w_ret);
			return w_ret;
	}

	/*	QƂ݂̂Ȃ̂ňRs[͎{Ȃ	*/

	/*==============*/
	/* `FbN */
	/*==============*/
	/*
		(uw_Mode)
		1)FULLSPEED̏ꍇA
			1-1)J[hς(SDD_DEV.uh_Status)̏ꍇ
				Ȃ΍ől(SddDev[port].Csd)ݒl(uh_clkdevɐݒ)Ƃ
			1-2)LȊȌꍇ
				2(uh_clkdev)ɐݒ
		2)LOWSPEED̏ꍇ
				i400Khzȉj(uh_clkdev)ɐݒ肷
		3) SDD_CLOCK_DIV_1`SDD_CLOCK_DIV_512̏ꍇ
		 ől(CSD)ł邩`FbN
			2-1) ől葬ꍇA
				G[1
			2-2) LȊȌꍇ
				w蕪(uh_clkdev)ɐݒ肷
		4)ȊȌꍇAG[1
			G[1F
				uh_ret |= SDD_ERR_PARAM
				return;
	*/	
	w_TmpRet = Sdds_CheckSetDiv(p_SddHandle, uw_ClockDiv, &uw_SetDiv);
	if (w_TmpRet != SDD_SUCCESS) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetClockDiv w_ret = %ld\n", w_ret);
		return w_ret;
	}

	/*==================================*/
	/* SDNbNݒ֐Ăт */
	/*==================================*/
	/*
		SDCLK(SD_CLK_CTRLWX^)̐ݒ
		Sddr_SetClkDivŎs
			 = SDD_CLOCK_DIV_1`512̂ǂꂩ
			߂lFȂ
	*/
	Sddr_SetClkDiv(p_SddHandle, uw_SetDiv);
	
	/*================================================*/
	/* ύXɂƂȂ^CAEgTCN̕ύX */
	/*================================================*/
	/* 
		TOP[27:24](SD_OPTIONWX^j̐ݒ
		Sddr_SetClkDivŎs
			 = SDD_CLOCK_DIV_1`512̂ǂꂩ
			߂lFȂ
	*/		
	Sddr_SetTimeOutCycle(p_SddHandle, uw_SetDiv);

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetClockDiv w_ret = %ld\n", w_ret);
    
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocSetEventCbf											*/
/*  Tv		FCxgR[obN֐o^ (SDD_IOC_SET_EVENT_CBF)			*/
/*  			FCxgɎsR[obN֐SDfoCXhCo*/
/*				Fo^B													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;(SDD_EVENT_CBF\̂̃AhX)						*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocSetEventCbf(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_EVENT_CBF *p_SddEventCbf = (SDD_EVENT_CBF *)uw_Arg; 
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocSetEventCbf>\n");
    
	/*==============*/
	/* `FbN */
	/*==============*/
	/*
		1)p_SddEventCbf == NULL̏ꍇ
			G[1
		2)p_SddEventCbf != NULL̏ꍇ
			̃Cxg(pv_Arg->uw_WaitEvent)
			2-1)͈͓(SDD_EVENT_CARD_OUT,SDD_EVENT_CARD_IN,SDD_EVENT_ERROR(_SDD_CALL_CBF_RETRY_INFO_`FSDD_EVENT_ERR_RETRY_LBA,SDD_EVENT_ERR_RETRY_ERCD,SDD_EVENT_ERR_RETRY_INFO))Ȍꍇ
				G[1
			2-2) ͈͓̏ꍇ
				p
			
			G[1F
				uh_ret = SDD_ERR_PARAM;
				return;
	*/

	if((p_SddEventCbf->uw_WaitEvent & ~(SDD_EVENT_ALL)) || 
		((p_SddEventCbf->uw_WaitEvent & SDD_EVENT_ALL) == 0)){	/* T|[gCxg͐ݒCxgȂ */
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetEventCbf w_ret=%ld\n", w_ret);
		return w_ret;
	}

	/*======================================*/
	/* CxgR[obNݒ֐Ăяo */
	/*======================================*/
	/*
	hCõR[obNe[uւ̓o^
	P = SddEventCbf.uw_WaitEvent
	Q = SddEventCbf.vp_Func
	R = SddEventCbf.uw_Param
	Sdd_SetCbf(UW uw_WaitEvent, void * vp_Func, UW uw_Param)jumpAp
	*/
	Sdds_SetCbf(p_SddHandle, p_SddEventCbf->uw_WaitEvent, p_SddEventCbf->vp_Fp, p_SddEventCbf->uw_Param);/* pgr0689 */
	

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetEventCbf w_ret=%ld\n", w_ret);
	return w_ret;
}

#ifdef _SDD_ENABLE_STANDBY_
/********************************************************************************/
/*  ֐		FSdd_IocSetMode												*/
/*  Tv		FSD I/F[hݒ (SDD_IOC_SET_MODE)							*/
/*  			FSD I/F̓샂[hݒ肷B								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Mode (SDD_MODE_NORMAL/SDD_MODE_STANDBY)					*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocSetMode(SDD_HANDLE *p_SddHandle, UW uw_Mode)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
    SDD_ERROR w_TmpRet;
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocSetMode>\n");
    
	/*	QƂ݂̂Ȃ̂ňRs[{Ȃ	*/

	/*==============*/
	/* `FbN */
	/*==============*/
	/*
		(uw_Mode)
			1)SDD_MODE_NORMAL or SDD_MODE_STANDBYł
				p
			2)ȊȌꍇAG[1
				G[1F
					uh_ret |= SDD_ERR_PARAM
					return;
	*/
	if((uw_Mode != SDD_MODE_NORMAL) && (uw_Mode != SDD_MODE_STANDBY)){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetMode w_ret=%ld\n", w_ret);
		return w_ret;
	}

	/*==================*/
	/* SD I/F[hݒ */
	/*==================*/
	/*
		IOBPeriClkStopCLKSTP_IMCLKݒ
		void Sddr_SetMode(UW uw_Mode)Ŏs
			 = uw_ModeiSDD_MODE_NORMAL or SDD_MODE_STANBY)
			߂lFȂ
	*/
	w_TmpRet = Sddr_SetMode(p_SddHandle, uw_Mode);
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetMode w_ret=%ld\n", w_ret);
	return w_ret;
}
#endif /* _SDD_ENABLE_STANDBY_ */

#ifdef _SDD_RW_WAIT_
/********************************************************************************/
/*  ֐		FSdd_IocSetRWWait												*/
/*  Tv		FRWR}hsOEFCgݒ (SDD_IOC_VERSION)				*/
/*  			FRWR}hsOɃEFCgTCNݒ肷					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FSDD_WAIT *pv_Arg												*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocSetRWWait(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocSetRWWait>\n");

	/*	Rs[I/FwŎ{Ă̂Ŏ{Ȃ
		̂߂Ɉ̃Rs[	*/
	SDD_WAIT *p_SddWait = (SDD_WAIT *)uw_Arg;	/* SDD_WAIT\̂ւ̃|C^ɃRs[ */

	/* ُ̏ꍇSDD_ERR_PARAM^[ */
	if(p_SddWait->uh_Flug & ~SDD_WAIT_ALL){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetRWWait w_ret=%ld\n", w_ret);
		return w_ret;
	}

	if(p_SddWait->uh_Flug == SDD_WAIT_DEFAULT){		/* TCNZbg */
		p_sdd->uw_ReadWait = 0;
		p_sdd->uw_WriteWait = 0;
	} else { 
		if(p_SddWait->uh_Flug & SDD_WAIT_READ){		/* [h̃EFCgTCNZbg */
			p_sdd->uw_ReadWait = p_SddWait->uw_Count;
		}
		if(p_SddWait->uh_Flug & SDD_WAIT_WRITE){	/* Cg̃EFCgTCNZbg */
			p_sdd->uw_WriteWait = p_SddWait->uw_Count;
		}

	}

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetRWWait w_ret=%ld\n", w_ret);
	return w_ret;

}
#endif	/* _SDD_RW_WAIT_ */

/********************************************************************************/
/*  ֐		FSdd_IocSoftReset												*/
/*  Tv		FSD I/F\tgZbg (SDD_IOC_SOFT_RESET)						*/
/*  			Fw肳ꂽ\tgZbgsB								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Module													*/
/*				F(SDD_SOFT_RESET_ANGOU/SDD_SOFT_RESET_SD/						*/
/*				FSDD_SOFT_RESET_OTHER/SDD_SOFT_RESET_ALL)						*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocSoftReset(SDD_HANDLE *p_SddHandle, UW uw_Module)
{
	SDD_ERROR  w_ret = SDD_SUCCESS;
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocSoftReset>\n");
	/*==============*/
	/* `FbN */
	/*==============*/
	/*
		(uw_Module)SDD_SOFT_RESET_ALL̃rbg͈͓(Odl6.7.2QƁj
		ł邩A܂̓rbgĂȂ̃`FbN
			1) ͈͊ÕrbgĂꍇAG[1
			2)rbgĂȂꍇAG[1
				G[1
				uh_ret |= SDD_ERR_PARAM
				return;
			3)ȊȌꍇAp
	*/

	if((uw_Module & ~(SDD_SOFT_RESET_ALL)) || (uw_Module == 0x00)){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSoftReset w_ret=%ld\n", w_ret);
		return w_ret;
	}

	/*================*/
	/* \tgZbg */
	/*================*/
	/*
		w胂W[̃\tgZbg
		Sddr_SoftReset( ResetubN )ōs
		Fuw_ModuleiZbgubNj
		߂lFȂ
	*/
	Sddr_SoftReset(p_SddHandle, uw_Module);

	/*==================================================*/
	/* ԑJځiIOCTLOPENj						    */
	/*	SddDev[port].uh_Status &= ~SDD_STATUS_INITFLG	*/
	/*	SddDev[port].uh_Status &= ~SDD_STATUS_IOCTL	    */
	/*	SddDev[port].uh_Status |= 	SDD_STATUS_OPEN		*/
	/*==================================================*/
	if (uw_Module & SDD_SOFT_RESET_SD) {
		Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_INITFLG);
	};

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSoftReset w_ret=%ld\n", w_ret);
	return w_ret;
}

#ifdef _SDD_ENABLE_VERSION_
/********************************************************************************/
/*  ֐		FSdd_IocVersion												*/
/*  Tv		FSDDDo[W擾 (SDD_IOC_VERSION)							*/
/*  			FSDDD̃o[W擾									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;(o[W̃AhX)								*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocVersion(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	UW *puw_Version = (UW *)uw_Arg;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocVersion>\n");

	/*==================*/
	/* SDDDo[W擾 */
	/*==================*/
	*puw_Version = SDD_SOFT_VERSION;

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocVersion\n");
	return w_ret;
}
#endif /* _SDD_ENABLE_VERSION_ */

#ifdef _SDD_ENABLE_IOC_READWRITE_
/********************************************************************************/
/*  ֐		FSdd_IocWrite													*/
/*  Tv		Fʏ̈惉Cg֐(SDD_IOC_WRITE)								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FSDD_RW *pv_Arg												*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocWrite(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*	Rs[I/FwŎ{Ă̂Ŏ{Ȃ
		̂߂Ɉ̃Rs[	*/
	SDD_RW *p_SddRw;
    p_SddRw = (SDD_RW *)uw_Arg;	/* SDD_RW\̂ւ̃|C^ɃRs[ */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocWrite>\n");

    /* IOCTLʎ擾pʑOǉ 2006/08/08 H.Miura */
    Sdds_ioctl_getResult_before(SDD_PREFLG_WRITE);

	/*==============*/
	/* `FbN */
	/*==============*/
	/*
		1)p_SddRw == NULL or p_SddRw->pb_Buff == NULL ̏ꍇ
			G[1F
				uh_ret = SDD_ERR_PARAM;
				return;
		2)pub_SddRw != NULL̏ꍇ
			p
	*/
	if(p_SddRw->pb_Buff == NULL){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		p_sdd->Result.w_Result = w_ret;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocWrite w_ret=%ld\n", w_ret);
		return w_ret;
	}
	else if (Sddr_CheckAddrAlign(p_SddRw->pb_Buff)) {		/* ]ACg`FbN */
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		p_sdd->Result.w_Result = w_ret;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocWrite w_ret=%ld\n", w_ret);
		return w_ret;
	}

	/* J[hʏ̈TCY̏ꍇG[ */
	if(((p_SddRw->uw_Offset) + (p_SddRw->uw_Count)) > p_sdd->uw_NormalSize){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		p_sdd->Result.w_Result = w_ret;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocWrite w_ret=%ld\n", w_ret);
		return w_ret;
	}

	/*
		Write̎
		SD_CLK̏o͂ƒ~
		StreamDMACݒƋN
		WriteR}hR}hsO
		WriteR}hiCMD25)s
		X|XM
		
		G[ɃgCsȂ
		Sdds_ReadWriteSub()Ŏs 
		
		P = pb_Buff
		Q = uw_Count
		R = uw_Offset
	*/
	/*
		1)߂lIiSUCCESSj̏ꍇA
			rIցipj
		2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
			G[2F
			uh_ret |= G[lݒ;
	*/
	if(p_SddRw->uw_Count != 0){
        /* IOCTLpʑOǉ 2006/08/08 H.Miura */
        /*                        ύX 2007/04/24 Suzuki  */
		if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
            Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocWrite w_ret=%ld\n", w_ret);
			return w_ret;
		}
        w_TmpRet = Sdds_ReadWriteSub(p_SddHandle, p_SddRw->pb_Buff, p_SddRw->uw_Count, p_SddRw->uw_Offset, TRUE);
        /* IOCTLpREAD/WRITEʌ㏈ǉ 2006/08/08 H.Miura  */
        Sdds_ioctl_readwrite_after(p_SddHandle);
	}
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocWrite w_ret=%ld\n", w_ret);
	return w_ret;
}
#endif /* _SDD_ENABLE_IOC_READWRITE_ */

/********************************************************************************/
/*  ֐		FSdd_IocSetCardFunc											*/
/*  Tv		FJ[ht@NVݒ(SDD_IOC_SET_CARDFUNCj				*/
/*  			FJ[ht@NVݒ肷								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*				FUW uw_Arg;J[ht@NVݒl							*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.23														*/
/********************************************************************************/
SDD_ERROR Sdd_IocSetCardFunc(SDD_HANDLE *p_SddHandle, UW uw_Func)
{
#if	defined(_SDD_HIGHSPEEDCLK_)
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet = SDD_SUCCESS;
	SDD_DEV *p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW	uw_SetFunc = SDD_CARD_FUNC_NO_FUNC;
	UW	uw_SetDiv;

#if	defined(_SDD_HIGHSPEEDCLK_)
	if(p_sdd->ub_HighspeedInfo != SDD_HIGHSPEEDCLK_USED) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
		return w_ret;
	}
#endif

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocSetCardFunc>\n");

	/*
		p[^L͈̓`FbN
	*/
#ifdef _SDD_ALLOW_UHS1_
	if (p_sdd->ub_UHS1Info == SDD_ALLOW_UHS1_USED) {
		if ((uw_Func != SDD_FUNC_SPEED_12) && (uw_Func != SDD_FUNC_SPEED_25)
		 && (uw_Func != SDD_FUNC_SPEED_50)) {
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
			return w_ret;
		}
	} else {
		if ((uw_Func != SDD_FUNC_SPEED_12) && (uw_Func != SDD_FUNC_SPEED_25)) {
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
			return w_ret;
		}
	}
#else
	if ((uw_Func != SDD_FUNC_SPEED_12) && (uw_Func != SDD_FUNC_SPEED_25)) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
		return w_ret;
	}
#endif /* _SDD_ALLOW_UHS1_ */
#ifdef _SDD_ALLOW_MMC_
	/******* MMC̏ꍇ ******/
	if ((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC){
		/* 
			ȉ̂ꂩ𖞂ꍇ͖T|[gG[ƂďI
			1.MMCKiVer4.0
			2.nCXs[h[hΉ
			3.APInCXs[h[hiSDD_FUNC_SPEED_25jȊO
		*/
		if ((p_sdd->MmcInfo.ub_Spec < SDD_MMC_SPEC_VERS_4) 
			|| ((p_sdd->MmcInfo.uh_Func & (SDD_MMC_FUNC_HS_52MHZ | SDD_MMC_FUNC_HS_26MHZ)) == 0)
			|| (uw_Func != SDD_FUNC_SPEED_25))
		{
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
		    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
    		return w_ret;
    	}
		/* 
		   łɐݒς̏ꍇ͉Ƀ^[
		*/
		if (p_sdd->MmcInfo.uh_SetFunc & (SDD_MMC_FUNC_HS_52MHZ | SDD_MMC_FUNC_HS_26MHZ)){
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
    		return w_ret;
		}
		/* 
			IoctlOiNbNJnj
		*/
		if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
			return w_ret;
		}
		/*
			nCXs[h[hݒ菈
		*/
		w_TmpRet = Sdds_MmcSetHighSpeed(p_SddHandle);
		if (w_TmpRet == SDD_SUCCESS) {
			p_sdd->MmcInfo.uh_SetFunc |= (p_sdd->MmcInfo.uh_Func & (SDD_MMC_FUNC_HS_52MHZ | SDD_MMC_FUNC_HS_26MHZ));
		}
	}
    /****** SD̏ꍇ ******/
    else if((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) & (UB)SDD_CARD_TYPE_SD){
#else
    /****** SD̏ꍇ ******/
    if((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) & (UB)SDD_CARD_TYPE_SD){
#endif /* _SDD_ALLOW_MMC_ */
		/* 
			KiVer1.01̏ꍇ͖T|[gG[ƂďI
		*/
    	if((p_sdd->ub_Scr[0] & SDD_SCR_SD_SPEC_59_56) == SDD_SCR_SD_SPEC_VER_1_01){
    		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
		    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
    		return w_ret;
		}		
		/*
			݂APIь݂SDJ[ht@NVɂďꍇ
		*/
		switch (uw_Func){
			case SDD_FUNC_SPEED_12:
				switch(p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK){
					case SDD_CARD_FUNC_NO_FUNC:
						break;	/* ɏI */
					case SDD_CARD_FUNC_HIGH_SPEED:
#ifdef _SDD_ALLOW_UHS1_
					case SDD_CARD_FUNC_SDR12:
#endif
						uw_SetFunc = SDD_CARD_FUNC_DEFAULT_SPEED;
						break;
#ifdef _SDD_ALLOW_UHS1_
					case SDD_CARD_FUNC_SDR25:
					case SDD_CARD_FUNC_SDR50:
#endif
						uw_SetFunc = SDD_CARD_FUNC_SDR12;
						break;
					default:
						break;
				}
				break;
			case SDD_FUNC_SPEED_25:
				switch(p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK){
					case SDD_CARD_FUNC_NO_FUNC:
#ifdef _SDD_ALLOW_UHS1_
					case SDD_CARD_FUNC_SDR25:
#endif
						uw_SetFunc = SDD_CARD_FUNC_HIGH_SPEED;
						break;
					case SDD_CARD_FUNC_HIGH_SPEED:
						break;	/* ɏI */
#ifdef _SDD_ALLOW_UHS1_
					case SDD_CARD_FUNC_SDR12:
					case SDD_CARD_FUNC_SDR50:
#endif
						uw_SetFunc = SDD_CARD_FUNC_SDR25;
						break;
					default:
						break;
				}
				break;
#ifdef _SDD_ALLOW_UHS1_
			case SDD_FUNC_SPEED_50:
				switch(p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK){
					case SDD_CARD_FUNC_NO_FUNC:
					case SDD_CARD_FUNC_HIGH_SPEED:
						w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
						break;
					case SDD_CARD_FUNC_SDR12:
					case SDD_CARD_FUNC_SDR25:
						uw_SetFunc = SDD_CARD_FUNC_SDR50;
						break;
					case SDD_CARD_FUNC_SDR50:
						break;	/* ɏI */
				}
				break;
#endif
			default: 
				break;
		}
		/* 
			ݒsviΉAݒϓj̏ꍇAΉ@\̏ꍇ͏I
		*/
		if((uw_SetFunc == SDD_CARD_FUNC_NO_FUNC) || (w_ret != SDD_SUCCESS)){	/* MISRAOK:3:3356 ^ɂȂ邱Ƃ邽ߖȂ */
		    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
			return w_ret;
		}
		/*
			NbNύX(4)
			NbN˒ᑬNbNiSDR50SDR12ꍇjݒ莞CSDĎ擾̃NbNΉ̈Ɏ߂邽
		*/
		Sddr_SetClkDiv(p_SddHandle, SDD_CLOCK_DIV_4);
		Sddr_SetTimeOutCycle(p_SddHandle, SDD_CLOCK_DIV_4);
		/* 
			IoctlOiNbNJnj
		*/
		if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
			return w_ret;
		}
		/*
			Xs[h[hؑ֏
		*/
		w_TmpRet = Sdds_SetCardFunction(p_SddHandle, uw_SetFunc);
		if (w_TmpRet == SDD_SUCCESS) {
			if (uw_SetFunc == SDD_CARD_FUNC_DEFAULT_SPEED){
				p_sdd->uw_CardFunc = (p_sdd->uw_CardFunc & (~SDD_CARD_FUNC_SPEED_MASK)) | 0x0;	/* J[ht@NVNA */
			} else {
				p_sdd->uw_CardFunc = (p_sdd->uw_CardFunc & (~SDD_CARD_FUNC_SPEED_MASK)) | uw_SetFunc;
			}
			/*
				CSD̍XV
			*/
			w_TmpRet = Sdds_SendSelectCMD(p_SddHandle, FALSE);
			if(w_TmpRet == SDD_SUCCESS) {
				w_TmpRet = Sdds_SendCSDCMD(p_SddHandle);
				if(w_TmpRet == SDD_SUCCESS) {
					w_TmpRet = Sdds_SendSelectCMD(p_SddHandle, TRUE);
				}
			}
		}
	}
	/*
		SD/MMCʏ
		Xs[h[hύXɊꍇ́AΉőNbNɕύX
	*/
	if (w_TmpRet == SDD_SUCCESS){
		w_TmpRet = Sdds_CheckSetDiv(p_SddHandle, SDD_CLOCK_DIV_FULLSPEED, &uw_SetDiv);
		if (w_TmpRet == SDD_SUCCESS) {
			Sddr_SetClkDiv(p_SddHandle, uw_SetDiv);	/* uw_SetDivɕݒ */
			Sddr_SetTimeOutCycle(p_SddHandle, uw_SetDiv);
		} else{
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		}
	} else {
		w_ret= Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}
	/* 
		Ioctl㏈iNbN~j
	*/
    if ((w_TmpRet = Sdds_ioctl_after(p_SddHandle)) != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
    return w_ret;
#else
	SDD_ERROR w_ret = SDD_SUCCESS;
	w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSetCardFunc w_ret = %ld\n", w_ret);
	return w_ret;
#endif
}


/********************************************************************************/
/*  ֐		FSdd_IocSpeedClassRecording									*/
/*  Tv		FXs[hNXL^ݒ(SDD_IOC_SPEEDCLASS_RECORDINGj			*/
/*  			FCMD20ΉJ[hɃR}h𔭍s							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*				FUW uw_Arg;Xs[hNXL^ݒl							*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.23														*/
/********************************************************************************/
SDD_ERROR Sdd_IocSpeedClassRecording(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	SDD_DEV *p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocSpeedClassRecording>\n");

	/*
		p[^L͈̓`FbN
	*/
	if((uw_Arg != SDD_START_RECORDING) && (uw_Arg != SDD_CREAT_DIR) && (uw_Arg != SDD_UPDATE_CI)){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
	 	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSpeedClassRecording w_ret = %ld\n", w_ret);
		return w_ret;
	}
	/* 
		Xs[hNXL^ΉJ[h`FbN
	*/
	if ((p_sdd->uh_CardType2 & SDD_CARDTYPE2_CLASS_RECORD) == 0){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
	 	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSpeedClassRecording w_ret = %ld\n", w_ret);
		return w_ret;
	}
	/* 
		IoctlOiNbNJnj
	*/
	if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSpeedClassRecording w_ret = %ld\n", w_ret);
		return w_ret;
	}
	/*
		Xs[hNXL^R}h
	*/
	w_TmpRet = Sdds_SpeedClassRecording(p_SddHandle, uw_Arg);
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}
	/*
		Ioctl㏈iNbN~j
	*/
    if ((w_TmpRet = Sdds_ioctl_after(p_SddHandle)) != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}
	
	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSpeedClassRecording w_ret = %ld\n", w_ret);
    return w_ret;
}


/************************************************************************************/
/*  ֐		FSdds_Init															*/
/*  Tv		F														*/
/*  			FSD I/F̑SW[Zbgs								*/
/*				F	NbNiIMCLK/IMCLK2j									*/
/*				F	LSIZbg														*/
/*				F	荞݋֎~iSDI/F-S&StreamDMACj							*/
/*				F	荞݃R[obN NULLݒ									*/
/*				F	荞݋iCDMł̃J[h}̂݋j					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.3.6														    */
/************************************************************************************/
SDD_ERROR Sdds_Init(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
    SDD_ERROR w_TmpRet;
#ifdef _SDD_FUNC_QUICK_BOOT_
	UH uh_SdClkCtrlClkEn = 0;
#endif /* _SDD_FUNC_QUICK_BOOT_ */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_Init>\n");
	/*======================================*/
	/*	SDIOubN̊荞݋֎~		*/
	/*	IOBPeriIntrEn[0`1]̋֎~i0ŋ֎~j*/
	/*	Sddr_DisSDBLKIntip_SddHandle)		*/
	/*	߂lG[Ȃipj		*/
	/*======================================*/
	w_TmpRet = Sddr_DisSDBLKInt(p_SddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdds_Init w_Result=%ld\n", w_Result);
		return w_Result;
	}

	/*======================================*/
	/* Xg[DMAC荞݋֎~			*/
	/*	Sddr_DisDmacInt(p_SddHandle)		*/
	/*	߂lG[Ȃipj		*/
	/*======================================*/
	Sddr_DisDmaInt(p_SddHandle);

	/*
		UniPhierXPΉ
		 n[hZbgɃNbNȂ΂ȂȂn[hEFAdl
		 ̑foCX̓NbNɃn[hZbg
	*/
	w_TmpRet = Sdds_Init_before(p_SddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdds_Init w_Result=%ld\n", w_Result);
		return w_Result;
	}

#ifdef _DEVICE_MASTER_
	/*==============================================*/
	/* DMACZbg							*/
	/*	Sddr_DmacBLKReset( p_SddHandle )			*/
	/*@߂lG[Ȃ							*/
	/*	IOBReset[11]̐ݒ(0ŃZbg)			*/
	/*	肠邩H@add by shiiba				*/
	/*==============================================*/
	Sddr_DmacBLKReset(p_SddHandle);
#endif
	
	/*==============================================*/
	/* SD I/F̑S荞݋֎~					*/
	/*	Sddr_DisIntAll( p_SddHandle )				*/
	/*	߂lG[Ȃipj				*/
	/*==============================================*/
	Sddr_DisIntAll(p_SddHandle);	/* pgr0024 */

	/*==============================================*/
	/* Xg[DMAC荞݋֎~					*/
	/*	Sddr_DisDmacInt(void)						*/
	/*  ߂lG[Ȃipj				*/
	/*==============================================*/
	/* Sddr_DisDmaInt(); */ /* Qd֎~Ă邽ߕKvȂ */

#ifdef _SDD_FUNC_QUICK_BOOT_
	/*==============================================*/
	/* SDNbNԎQ							*/
	/*==============================================*/
	Sdd_M_GetReg(SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_SdClkCtrlClkEn);
#endif /* _SDD_FUNC_QUICK_BOOT_ */

	/*==========================================================*/
	/* LSIS\tgZbg							            */
	/*	Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_ALL)	        */
	/*	߂lG[Ȃipj				            */
	/*==========================================================*/
	Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_ALL);

#ifdef _SDD_FUNC_QUICK_BOOT_
	/*==============================================*/
	/* NbNo͏ԂłꍇAďo		*/
	/*==============================================*/
	if( uh_SdClkCtrlClkEn & SDD_SD_CLK_CTRL_SCKLEN ){
		Sddr_SetClkDiv(p_SddHandle, SDD_CLOCK_DIV_LOWSPEED );		/* 256ɐݒ */
		Sddr_SetTimeOutCycle(p_SddHandle, SDD_CLOCK_DIV_LOWSPEED );
		
		w_TmpRet = Sddr_EnaClk(p_SddHandle, SDD_CLK_ENABLE );	/* SDNbN */
		if (w_TmpRet != SDD_SUCCESS) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdds_Init w_Result=%ld\n", w_Result);
			return w_Result;
		}
	}
#endif /* _SDD_FUNC_QUICK_BOOT_ */

	/*==============================================*/
	/* J[hopNbNݒiőlF2^10j		*/
	/*	Sddr_SetWaitCycleCD(p_SddHandle, UW)		*/
	/*	߂lG[Ȃipj				*/
	/*==============================================*/
	Sddr_SetWaitCycleCD(p_SddHandle, SDD_SD_OPTION_CTOP_FIRST);
	/* IMCLKȂƊݕƌ댟o邩 */
	/* SDD_IOC_INITSDD_IOC_CARD_INITɂăJ[hos̑΍ */
	(void)Sdd_Delay(SDD_WAIT_2MSEC);

#ifdef _DEVICE_MASTER_
	/*==============================================*/
	/* DMAC荞݋							*/
	/*	Sddr_EnaDmacBLKInt( p_SddHandle )			*/
	/*@߂lG[Ȃ							*/
	/*	IOB_IntrEnable[2]̐ݒ(1Ŋ荞݋)	*/
	/*	肠邩H@add by shiiba				*/
	/*==============================================*/
	Sddr_EnaDmacBLKInt(p_SddHandle);
#endif

	/*==============================================*/
	/*	SDIOubN̊荞݋				*/
	/*	IOBIntrEn[0`1]̋i1ŋj			*/
	/*	Sddr_EnaSDBLKIntip_SddHandle)				*/
	/*	߂lG[Ȃipj				*/
	/*==============================================*/
	w_TmpRet = Sddr_EnaSDBLKInt(p_SddHandle);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdds_Init w_Result=%ld\n", w_Result);
		return w_Result;
	}

	/*======================================================*/
	/* SD I/F̊荞݋	(CDMł̃J[h}荞)	*/
	/*	Sddr_EnaIntCD(p_SddHandle)							*/
	/*	߂lG[Ȃipj						*/
	/*======================================================*/
	Sddr_EnaIntCD(p_SddHandle);	/* pgr0024 */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdds_Init w_Result=%ld\n", w_Result);
	return w_Result;
}


/************************************************************************************************/
/*  ֐		FSdds_ReadWriteSub																*/
/*  Tv		FʏRead/Writeʏ														*/
/*				F	SD_CLK̏o͂ƒ~															*/
/*				F	(CgCgveNg`FbN)											*/
/*				F	Oobt@ݒiOobt@ǂŃOobt@ݒύXj	*/
/*				F	StreamDMACݒƋN														*/
/*				F	ReadWriteR}hR}hsO											*/
/*				F	ReadR}hiCMD18)or WriteR}hiCMD25)s							*/
/*				F	X|XM															*/
/*				F	AccessAllEnd&StreamDMAC]I											*/
/*				F	G[`FbNiCMD13js													*/
/*				F	Cg݊ZN^擾R}h(ACMD22)s						*/
/*				F	Cg݊ZN^擾											*/
/*				F	G[ɃgCs												*/
/*				F	ǂݏoor݃ZN^LSI]MAXTCYȏi0xFFFFj̏ꍇJԂ	*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                              */
/*      		F	B *pb_Writebuf(݃f[^i[|C^)					                */
/*				F  UW uw_SecCnt(]ZN^)									                */
/*				F  UW uw_Offset(ItZbg)										            */
/*              F  BOOL bl_Write  ReadR}hs(FALSE) or WriteR}hs(TRUE)           */
/*  ߂l		FFSDD_SUCCESS																*/
/*  			FsFG[R[h															*/
/*  ŏIXV	F2009.03.09																	*/
/************************************************************************************************/
SDD_ERROR Sdds_ReadWriteSub(SDD_HANDLE *p_SddHandle, B *pb_Buff, UW uw_Count, UW uw_Offset, BOOL bl_Write)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UW uw_SendSec;			/* ]ZN^ */
	UB ub_RetryCount;		/* gC{ */
	UW uw_RestSec = 0;		/* cZN^ */
	UW uw_CurrentOffset;	/* JnItZbg */
	UW uw_Wp;				/* WP̃`FbN */
	UW uw_GetWriteSec;		/* ݊ZN^擾 */
	UW uw_NextDMAStAdEst;	/* DMA]JnAhXl add by shiiba 04/2/12 */
	B  *pb_Buf = NULL;
	UW uw_DAT0state;		/* DAT0rW[ */
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#ifdef _SDD_READ_ZERO_PADDING_
	UW *puw_Buff;
	UW uw_padcnt;
#endif /* _SDD_READ_ZERO_PADDING_ */

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_READWRITESUB );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

	/* `FbN͍sȂiʂŎ{ς݁j */

	/*  */
	ub_RetryCount = 0;
	uw_Wp = 0;
	uw_GetWriteSec = 0;
	uw_RestSec = 0; /* PG-ReliefΉ */

	/* 
		G[擾@\ON(TRUE)ɐݒ
	*/
	p_sdd->ErrInfo.bl_ErrChk = TRUE;

	/*======================================================*/
	/*	gC[vJn									*/
	/*	ŏ̏ꍇ̂݃gCJE^NA				*/
	/*	gCJE^gCݒlɂȂ܂ŌJԂ	*/
	/*	gCJE^̓wb_t@CŒ`				*/
	/*======================================================*/
	while(ub_RetryCount <= SDD_RETRY_MAX) {
		pb_Buf = pb_Buff;
	
		/*  */
		uw_SendSec = 0;
		uw_RestSec = uw_Count;			/* ]ZN^̐ݒ */
		uw_CurrentOffset = uw_Offset;	/* JnItZbg̐ݒ */
		w_Result = SDD_SUCCESS;			/* gC̃G[NA */

		/* ̏ʁi[hECgZN^j̏ */
		p_sdd->Result.uw_Resid = 0;

        if (bl_Write) {
            /* ݎ */
            /*==================================================================*/
            /*	WriteProtect̃`FbN											*/
            /*	`FbNWriteProtect͕݌vi\2-6ĵƂ				*/
            /*	͈ȉWriteProtect`FbN֐ōs					*/
            /*	SDD_ERROR Sdds_GetWP(UW uw_Check, BOOL bl_Stop, UW * puw_WP)	*/
            /*	߂lG[Ȃipj									*/
            /*		WriteProtectĂꍇ									*/
            /*			[v1o											*/
            /*		WriteProtectĂȂꍇ								*/
            /*			p												*/
            /*==================================================================*/
            Sdds_GetWP(p_SddHandle, ( SDD_WP_ALL & ~SDD_WP_CCC_ERASE), TRUE, &uw_Wp);
            if(uw_Wp){
                w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_WP);
                return w_Result;
            }
        }

		/* ێSDD_DMA_INFO */
        if (bl_Write) {
            /* ݎݒ */
            p_sdd->DmaInfo.uw_DMADstAddr = (UW)&SDD_SD_BUF(Sdd_M_GetPortNum(p_SddHandle->ub_Port));
            p_sdd->DmaInfo.uw_DMASrcAddr = (UW)pb_Buff;
        }
        else {
            /* ǂݍݎݒ */
            p_sdd->DmaInfo.uw_DMADstAddr = (UW)pb_Buff;
            p_sdd->DmaInfo.uw_DMASrcAddr = (UW)&SDD_SD_BUF(Sdd_M_GetPortNum(p_SddHandle->ub_Port));
        }
		p_sdd->DmaInfo.uw_RestSec = uw_Count;
		p_sdd->DmaInfo.uw_DMASize = 0;

		/*======================================================*/
		/*	[vP ]Jn									*/
		/*	]ZN^ɓ]cZN^΃[v1s		*/
		/*	ic]ZN^̓[Jϐŕێj				*/
		/*======================================================*/
		while(uw_RestSec){

			/*==========================================================*/
			/* [v1ɂč̃[vœ]ZN^̌		*/
			/*	i1̓]TCYMAX0x7FFFZN^܂Łj				*/
			/*		StreamDMAC̓]TCYɂ鐧					*/
			/*	]ZN^̐擪AhXvZ							*/
			/*	]ZN^̌vZ										*/
			/*==========================================================*/
			uw_SendSec = MIN(SDD_SD_SECCNT_CNT_MAX, uw_RestSec);

			/*==================================================*/
			/* MMCJ[hoO΍						    */
			/*	eFMMC̍ŏIAhXւ̃ANZX			*/
			/*	@@@̃R}hOUT OF RANGEG[	*/
			/*	FŏIAhX̔pItZbg̎擾		*/
			/*==================================================*/
			p_sdd->uw_Offset = uw_CurrentOffset;

#ifdef _SDD_ENABLE_RINGBUF_
			/*==============================================================================================*/
			/* Oobt@̐ݒ																			*/
			/*	X^[gAhXƃ[v1]TCY烊Oobt@(SDD_DEV.Ringbuffer)ɑ݂邩H	*/
			/*	݂ꍇAȉ2̂Âꂩ̏s												*/
			/*		1)[v1]ZN^~]TCY̓Oobt@TCYȉ								*/
			/*			StreamDMAC̃WX^ɃOobt@(SDD_DEV.Ringbuffer)ݒ						*/
			/*		2)[v1]ZN^~]TCY̓Oobt@TCYȏ								*/
			/*			SDD_ERR_PARAMݒ																	*/
			/*	݂ȂꍇAX^[gAhXƓ]TCY烊Oobt@Đݒ						*/
			/*	̓Oobt@֐(Sddr_CheckRingBuff((UW)pb_Buffer2, uw_Count2))Ŏs			*/
			/*	1)߂lIiSUCCESSj̏ꍇ															*/
			/*		p																				*/
			/*	2)߂lG[(SUCCESSȊOj̏ꍇAG[1												*/
			/*		G[1F																			*/
			/*		w_Result |= G[ݒ;																	*/
			/*		returniSDD_Read܂Ŗ߂j																*/
			/*==============================================================================================*/
			w_ResTmp = Sdds_CheckRingBuff(p_SddHandle, (UW)pb_Buf, uw_SendSec);
			if(w_ResTmp != SDD_SUCCESS) {
                /* Read͓]ZN^NA鏈́AʂŎ{ */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				return w_Result;
			}
#endif

			/*	Read/WriteR}hs`X|X
				f[^]OSDI/Feݒ1
					荞݋֎~
					G[NA
					CMD12sݒ
					荞݋
					CBUSY҂
				ARGݒiWriteJnoffsetݒj
				R}hiCMD18)s or R}hiCMD25)s
				X|XorG[M҂
				X|XG[`FbN
				Read/WriteR}hs֐ Sdds_SendCMDMulti()Ŏ{
				 = [v1offsetiByteP)
					   Read/WriteR}hs

				1)߂lIiSUCCESSj̏ꍇA
				ipj
				2)߂lG[̏ꍇ̂݁iSUCCESSȊOjAG[2
					G[2F
						DMA~
							SDI/F DMA]~ݒ(2L̂)
							StreamDMAC荞݋֎~
							StreamDMAC荞݃NA
							StreamDMAC]~(2L̂)
							Sdds_StopSdma()Ŏs
							FȂ
							߂lFG[Ȃ
						]ZN^NAiSddDev.Result.uw_Resid = 0;j
						G[lۑ[J֐ |= G[lݒ;
						
						if(^CAEgG[ƃJ[hȊȌꍇj
							STOPR}hs
								Sdds_SendCMD()Ŏs
								FCMD12,ARG"0"
								߂lFCMD12s̃G[R[h
						       Sdds_SendCMDMulti()Ŏs
						w_Result = G[lۑ[Jϐ;

					[v1o
			*/
/*** SDKiVer2.0ΉJnA2005.12.19 ***/
			/* HCJ[h̏ꍇAoffsetP = BLOCK */
#ifdef _SDD_ALLOW_MMC_
			if((p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2)) || (p_sdd->MmcInfo.ub_HcFlag == SDD_MMC_HC))
#else
			if(p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2))
#endif /* _SDD_ALLOW_MMC_ */
			{
				w_ResTmp = Sdds_SendCMDMulti(p_SddHandle, uw_CurrentOffset, bl_Write, uw_SendSec, FALSE, (UB *)pb_Buff);
			}
			else
			{
				w_ResTmp = Sdds_SendCMDMulti(p_SddHandle, uw_CurrentOffset * SDD_SECTOR_SIZE, bl_Write, uw_SendSec, FALSE, (UB *)pb_Buff);
			}
/*** SDKiVer2.0ΉENDA2005.12.19 ***/

			if(w_ResTmp == SDD_SUCCESS) {
                p_sdd->Result.uw_Resid += uw_SendSec;
				uw_CurrentOffset += uw_SendSec;			
				uw_RestSec -= uw_SendSec;				/* ]cZN^XV */

			/* 	]ZN^݂Ƃ																								*/
			/* 		DMAJnAhXliDMA]JnAhX{]oCgj̎Zo 												*/
			/* 		1)Oobt@ɓ]JnAhX݂鎞																	*/
			/* 			I)Oobt@ŏIAhXDMAJnAhXl 														*/
			/* 				̓]JnAhXDMAJnAhXl@															*/
			/*			II)Oobt@ŏIAhXDMAJnAhXl 														*/
			/* 				̓]JnAhXOobt@JnAhX{(DMAJnAhXl|Oobt@ŏIAhX) 	*/
			/* 		2)Oobt@ɓ]JnAhX݂Ȃ̓Oobt@@\OFF̎@									*/
			/*			̓]JnAhXDMAJnAhXl 																*/
			/* 													add by shiiba 04/2/12 													*/
				if (uw_RestSec){
					uw_NextDMAStAdEst = (UW)pb_Buf + (uw_SendSec * SDD_SECTOR_SIZE);
					if((p_sdd->RingBuffer.uw_BuffStart <= (UW)pb_Buf) && (p_sdd->RingBuffer.uw_BuffEnd > (UW)pb_Buf)){
						if (p_sdd->RingBuffer.uw_BuffEnd > uw_NextDMAStAdEst) {
							pb_Buf = (void *)uw_NextDMAStAdEst;
						} else {
							pb_Buf = (void *)(p_sdd->RingBuffer.uw_BuffStart + (uw_NextDMAStAdEst - p_sdd->RingBuffer.uw_BuffEnd));
						}
					} else {
						pb_Buf = (void *)uw_NextDMAStAdEst;
					}
				}

			} else {
                /* Read͓]ZN^NA鏈́AʂŎ{ */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				break;	/* G[A[v1I */
			}
#ifndef	_SDD_NO_RESID_
            if (bl_Write) {
                /*	ݎA݊ZN^`FbN
				ubNTCYݒ(4Byte)
				CMD55s
				ACMD22sO
				ACMD22s
				X|XM
				AccessAllEnd]I
				G[`FbN
				G[ȂiSUCCESSj̏ꍇ
					ACMD22Ŏ擾]ς݃ZN^=SD Buffer擾
				G[iSUCCESSȊOj̏ꍇ
					ACMD22Ŏ擾]ς݃ZN^=0
				ubNTCYݒi512Byte)
				ۂɂ͏݃ZN^擾֐Ŏs
				Sdds_GetWrSector(UW *puw_WriteSector)
				=݊ZN^
				߂liSUCCESSj̏ꍇ
					݊ZN^(puw_WriteSector) == [v1]ZN^̏ꍇ
						]ZN^͒ǉiSddDev.Result.uw_Resid += [v1]ZN^;j
					݊ZN^(puw_WriteSector) != [v1]ZN^̏ꍇ
						]ZN^͂̂܂܁iSddDev.Result.uw_Resid ̂܂;j
					[v1o
				2)߂l^CAEgG[̏ꍇ̂݁jAG[2
					G[2F
						STOPR}hs
							R1(card_status)`FbN
						i^CAEg̏ꍇ̓n[hNGmȂ̂
						R}hssj
						]ZN^̂܂܁iSddDev.Result.uw_Resid = ̂܂;j
						w_Result |= G[lݒ;
					[v1o
                 */
                if ((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) != SDD_CARD_TYPE_MMC){
                    w_ResTmp = Sdds_GetWrSector(p_SddHandle, &uw_GetWriteSec);
                    if(w_ResTmp != SDD_SUCCESS) {
                        w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
                        break;
                    } else {
                        if(uw_SendSec != uw_GetWriteSec) {
                            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NUM_WR_SECTORS);
                            break;
                        }
                    }
                }
            }
#endif	/* !_SDD_NO_RESID_ */

		/*==========================*/
		/*	[v1 End			*/
		/*==========================*/
		}

		/*
			]ɊꍇOS^CAEgJ[h0oCg]G[(UniPhier2P̂݁AfoCXł͔Ȃ)̓gC[v𔲂 
			(p_sdd->w_errorIP甭G[݂̂AOS^CAEgJ[h͔fȂ)
			ȊÕG[̓gCJE^CNg 
		*/ 
		if ((w_Result == SDD_SUCCESS) || Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_CARD_OUT) 
				|| Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_OS_TIMEOUT) || Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_SDMA_STOP)) {
				break;  
		} else {
			if(Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_IP_TIMEOUT)){
				/* J[hrW[Ԃł̃R}hsɂ0Byte]h */
				Sdd_TimerStart(p_SddHandle, SDD_DAT0_BUSY_WAIT_TIME_BEFORE_RETRY);
				while(1) {
					Sddr_CheckDAT0(p_SddHandle, &uw_DAT0state);
					if (uw_DAT0state != 0){		/* rW[  */
						break;
					}
					if (Sdds_CheckErr(p_SddHandle, p_sdd->w_error, SDD_ERR_OS_TIMEOUT)) {	/* ^CAEgAnhOS^CAEgG[ݒ */
						/*w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, p_sdd->w_error);*/	/* {OS^CAEgłȂߏʂɒm点Ȃ悤ɃRgAEg */
						break;
					}
					w_ResTmp = Sdd_Delay(SDD_DAT0_BUSY_DELAY_TIME);	/* ^XN҂ԂɈڍs */
					if(w_ResTmp != SDD_SUCCESS)  {
						/* ߂lFG[Ȃ͂ */
						/* G[Ăʒm͂Ȃ */
					}
				}
				Sdd_TimerStop(p_SddHandle);
				if (Sdds_CheckErr(p_SddHandle, p_sdd->w_error, SDD_ERR_OS_TIMEOUT)) {
					p_sdd->w_error &= ~SDD_ERR_OS_TIMEOUT;		/* {OS^CAEgłȂ߃G[NA */
					break;
				}
			}
#ifdef _SDD_CARD_STATUS_CHECK_
			w_ResTmp = Sdds_GetCardStatus(p_SddHandle);	/* 񃊃gCւ̃X|Xɍ̃G[Ȃ悤CMD13𔭍sĂ */
			if(w_ResTmp != SDD_SUCCESS) {
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			}
#endif /* _SDD_CARD_STATUS_CHECK_ */
            ub_RetryCount++;
			Sdds_CallCbfRetryLba( p_SddHandle, uw_Offset );					/* gC(JnZN^AhX)ʒmR[obN֐ďo */
			Sdds_CallCbfRetryErcd( p_SddHandle, w_Result );					/* gC(G[R[h)ʒmR[obN֐ďo */
			Sdds_CallCbfRetryInfo( p_SddHandle, w_Result, ub_RetryCount );	/* gC(gC)ʒmR[obN֐ďo */
			if( ub_RetryCount == SDD_RETRY_MAX ){	/* MISRAOK:3:3356,3:3359,3:3201 `l̕ύXl̂ߖȂ */
                Sdds_DebugPrint(__LINE__, SDD_PWARN,"CMD0Retry=%u\n", ub_RetryCount);
				w_ResTmp = Sdds_InitCardBeforRetry( p_SddHandle );	/* CMD00~2AJ[hď{ */
				if(w_ResTmp != SDD_SUCCESS) {
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
					break;
				}
			}else{
                Sdds_DebugPrint(__LINE__, SDD_PWARN,"SoftResetRetry=%u\n", ub_RetryCount);
				Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_SD);	/* SD-IPSDRSTZbg */
				w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_ENABLE);		/* ZbgŒ~ꂽSDCLKďo */
				if (w_ResTmp != SDD_SUCCESS) {
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
					break;
				}
			}
		}

	/*==========================*/
	/*	gC[vEnd		*/
	/*==========================*/
	}
	/* SDCLK~nOAbvh~΍A2006.02.22 */
	if ((Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_CARD_OUT)) 
			|| (Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_OS_TIMEOUT))) 
	{
		Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_SD);	/* SD-IPSDRSTZbg */
	}

	if( (w_Result == SDD_SUCCESS) && (ub_RetryCount >= 1) ){
		Sdds_CallCbfRetryLba( p_SddHandle, uw_Offset );					/* gC(JnZN^AhX)ʒmR[obN֐ďo */
		Sdds_CallCbfRetryErcd( p_SddHandle, w_Result );					/* gC(G[R[h)ʒmR[obN֐ďo */
		Sdds_CallCbfRetryInfo( p_SddHandle, w_Result, ub_RetryCount );	/* gC(gC)ʒmR[obN֐ďo */
	}
    /*
    	G[ݒ & 0pfBOiJ[h̏ꍇ)
    */
	if((!Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_CARD_OUT)) && (p_sdd->ErrInfo.bl_ErrChk == TRUE)){
		/* 
			G[̓擾
		*/
		
	    if(w_Result != SDD_SUCCESS){
	    	if (bl_Write == TRUE){
	    		p_sdd->ErrInfo.ub_ErrProcess = SDD_ERR_WRITE;
	    	} else{
	    		p_sdd->ErrInfo.ub_ErrProcess = SDD_ERR_READ;
	    	}
	    	p_sdd->ErrInfo.uw_ReqOffset = uw_Offset;
	    	p_sdd->ErrInfo.uw_ReqSize = uw_Count;
	    	p_sdd->ErrInfo.uw_ErrOffset = uw_Offset + uw_Count - p_sdd->ErrInfo.uw_ErrSize;
			/* 
				DMAc]TCYiuw_ErrSizej0 
				cZN^iuw_RestSecj0łȂꍇ(Sdds_SendCMDMultiG[̏ꍇj
				]ԂƂ݂ȂLݒ{
					1.G[ItZbgiuw_ErrOffsetjItZbgʒuiuw_Offsetjɐݒ
					2.c]TCYiuw_ErrSizej]TCYiuw_Count)ɐݒ
			*/
			if ((p_sdd->ErrInfo.uw_ErrSize == 0) && (uw_RestSec != 0)){
					p_sdd->ErrInfo.uw_ErrOffset = uw_Offset;
					p_sdd->ErrInfo.uw_ErrSize = uw_Count;
			}
    	}
#ifdef _SDD_READ_ZERO_PADDING_
		if (bl_Write == FALSE){
			p_sdd->ErrInfo.bl_PadMode = TRUE;

#ifndef _SDD_PADDING_DMA_
			/* 
				pb_Buff̃AhX4oCgACg̏ꍇ4BytePʂ0pfBO
				iDMAC̃AhXACgAȂĂ͂j
				łȂꍇ1bytePʂ0pfBO
			*/
			if (((UW)pb_Buff % 4) == 0) {
				puw_Buff = (UW *)pb_Buff + (uw_Count - p_sdd->ErrInfo.uw_ErrSize) * SDD_SECTOR_SIZE;
				uw_padcnt = (p_sdd->ErrInfo.uw_ErrSize * SDD_SECTOR_SIZE) >> 2 ; /* UB^UW^ւ̕ϊ(div 4) */
				while(uw_padcnt--){
					/*
						Oobt@gp̃AhX`FbN
					*/
					if ((p_sdd->RingBuffer.uw_OnOffFlg) && (puw_Buff == (UW *)p_sdd->RingBuffer.uw_BuffEnd)){
						puw_Buff = (UW *)p_sdd->RingBuffer.uw_BuffStart;	/* I[̏ꍇ͐擪ɃAhXړ */
					}
					*puw_Buff++ = (UW)0;		/* 4bytepfBO */
				}
			}
			else{
				pb_Buf = pb_Buff + (uw_Count - p_sdd->ErrInfo.uw_ErrSize) * SDD_SECTOR_SIZE;
				uw_padcnt = p_sdd->ErrInfo.uw_ErrSize * SDD_SECTOR_SIZE;
				while(uw_padcnt--){
					/*
						Oobt@gp̃AhX`FbN
					*/
					if ((p_sdd->RingBuffer.uw_OnOffFlg) && (pb_Buff == (B *)p_sdd->RingBuffer.uw_BuffEnd)){
						pb_Buff = (B *)p_sdd->RingBuffer.uw_BuffStart;	/* I[̏ꍇ͐擪ɃAhXړ */
					}
					*pb_Buff++ = (B)0;			/* 1oCgpfBO */
				}
			}
#else
			pb_Buf = pb_Buff + (uw_Count - p_sdd->ErrInfo.uw_ErrSize) * SDD_SECTOR_SIZE;
			uw_padcnt = p_sdd->ErrInfo.uw_ErrSize * SDD_SECTOR_SIZE;
			p_sdd->ErrInfo.pub_PadBuf = gpub_PadBuf;
			
			
			Sdds_FillMemory(p_SddHandle, (UB *)pb_Buff, p_sdd->ErrInfo.pub_PadBuf, uw_padcnt);
#endif	/* _SDD_PADDING_DMA_ */
			p_sdd->ErrInfo.bl_PadMode = FALSE;
		}	
#endif /* _SDD_READ_ZERO_PADDING_ */
	}
	else{ 
		Sdds_ErrInfoClear(p_SddHandle);
	}
	/* 
		G[擾@\OFF(FALSE)ɐݒ
	*/
	p_sdd->ErrInfo.bl_ErrChk = FALSE;

	return	w_Result;
}

#if !defined(_SDD_UNIPHIER_XP_)
/********************************************************************************/
/*  ֐		FSdds_Init_before												*/
/*  Tv		F̑O											*/
/*  			FNbNɁAn[hZbg{B					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
SDD_ERROR Sdds_Init_before(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;

	/*==============================================================================*/
	/* SD IOubNCNbN												*/
	/* ftHgœĂdlǂłƂ߂Ă邩Ȃ̂ON	*/
	/*	IMCLK:Sddr_SetMode(UW uw_Mode)											*/
	/*	=SDD_MODE_NORMALiNORMALIMCLKój									*/
	/*	߂lG[Ȃipj												*/
	/*==============================================================================*/
	w_TmpRet = Sddr_SetMode(p_SddHandle, SDD_MODE_NORMAL);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}
	/*==============================================*/
	/*	IMCLK2:Sddr_SetDetectCLK(UW uw_Mode)	*/
	/*	=SDD_MODE_NORMALiNORMALIMCLK2ój	*/
	/*	߂lG[Ȃipj				*/
	/*==============================================*/
	w_TmpRet = Sddr_SetDetectCLK(p_SddHandle, SDD_MODE_NORMAL);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}

	/*==============================================*/
	/* SDI/F̃n[hZbg					*/
	/*	Sddr_HardReset( void )						*/
	/*	߂lG[Ȃ							*/
	/*==============================================*/
	w_TmpRet = Sddr_HardReset(p_SddHandle, SDD_MODE_NORMAL);
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
		return w_Result;
	}

	return w_Result;
}
#endif /* _SDD_UNIPHIER_XP_ */

#ifdef _SDD_ENABLE_RINGBUF_
/********************************************************************************/
/*  ֐		FSdd_IocSetRingBuff											*/
/*  Tv		FOobt@ݒ (SDD_IOC_SET_RING_BUFF)	            */
/*  			FOobt@̊eyуXg[DMACL/ݒ肷B	*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg; (SDD_RING_BUFF̃AhXj							*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.04.23													*/
/********************************************************************************/
SDD_ERROR Sdd_IocSetRingBuff(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
#if !defined(_SDD_PIO_)
	SDD_ERROR w_ret = SDD_SUCCESS;
	UB ub_Val = 0;
	SDD_RING_BUFF	*p_SddRingBuff = (SDD_RING_BUFF *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*==============*/
	/* `FbN */
	/*==============*/
	/*
		1)p_SddRingBuff == NULL̏ꍇ
			G[1

		2)p_SddRingBuff != NULL̏ꍇ
			2-1)p_SddRingBuff64ByteEȊȌꍇ
				G[1
			2-2)p_SddRingBuff64ByteȄꍇ
				3-1)pv_Arg->uw_BuffStart < pv_Arg->uw_BuffEndȊȌꍇ
					G[1
				3-2)pv_Arg->uw_BuffStart < pv_Arg->uw_BuffEnd̏ꍇ
					p
			
			G[1F
				uh_ret = SDD_ERR_PARAM;
				return;
	*/

	if(p_SddRingBuff->uw_OnOffFlg == SDD_USE_RINGBUFF ){ 			/* Oobt@@\ON`FbN */
		ub_Val = (UB)(p_SddRingBuff->uw_BuffStart % SDD_RINGBUF_BOUNDARY);
		if(ub_Val){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
			return w_ret;
		}
		ub_Val = (UB)(p_SddRingBuff->uw_BuffEnd % SDD_RINGBUF_BOUNDARY);
		if(ub_Val){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
			return w_ret;
		}
		if ( (p_SddRingBuff->uw_BuffStart + SDD_RINGBUF_BOUNDARY) > (p_SddRingBuff->uw_BuffEnd) ){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
			return w_ret;
		}
	}
	else if (p_SddRingBuff->uw_OnOffFlg != SDD_NO_USE_RINGBUFF){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
			return w_ret;
	}

	/*============================================================*/
	/* Oobt@OnOffFlg,Start,EndhCoɂݒ   */
	/*============================================================*/
	p_sdd->RingBuffer.uw_OnOffFlg = p_SddRingBuff->uw_OnOffFlg;
	if (p_sdd->RingBuffer.uw_OnOffFlg){
		p_sdd->RingBuffer.uw_BuffStart = p_SddRingBuff->uw_BuffStart;/* pgr0689 */
		p_sdd->RingBuffer.uw_BuffEnd = p_SddRingBuff->uw_BuffEnd;
	}
	else {	/* Oobt@gpStart=0, End=0ɐݒ */
		p_sdd->RingBuffer.uw_BuffStart = 0x00000000;
		p_sdd->RingBuffer.uw_BuffEnd = 0x00000000;
	}
	
	/*
		ۂStreamDMACɂ͐ݒ肵Ȃ
		RFRead/Writeɂ͕KSddr_SetRingBuffg
		ݒ肷悤ɂĂ邽
	*/
	return w_ret;
#else  /* defined(_SDD_PIO_) */
	/* PIO]̏ꍇAOobt@@\͔T|[g */
	return SDD_ERR_NOT_SUPPORT;
#endif /* !defined(_SDD_PIO_) */
}

#endif /* _SDD_ENABLE_RINGBUF_ */

#ifdef _SDD_ENABLE_ENDIAN_
/**********************************************************************************/
/*  ֐		FSdd_IocEndian                                                   */
/*  Tv		FStreamDMACgpEndianݒ(SDD_IOC_ENDIAN)                    */ 
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                */
/*      		FUW@uw_Arg 0 = Little Endian; 1 = Big Endian                    */
/*  ߂l		FFSDD_SUCCESS                                               */
/*  			FsFG[R[h                                              */
/*  ŏIXV	F2009.04.23													  */
/**********************************************************************************/
SDD_ERROR Sdd_IocEndian(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	if(uw_Arg == SDD_ENDIAN_CHANGE_OFF)
	{
		p_sdd -> uw_Endian = SDD_ENDIAN_CHANGE_OFF;	/* Endian = Little */
	}
	else if(uw_Arg == SDD_ENDIAN_CHANGE_ON)
	{
		p_sdd -> uw_Endian = SDD_ENDIAN_CHANGE_ON;	/* Endian = Big */
	}
	else
	{
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);	/*0,1ȊOp[^G[ */
	}
    return w_ret;
}
#endif /* _SDD_ENABLE_ENDIAN_ */

#ifdef _SDD_FUNC_QUICK_BOOT_
/************************************************************************************/
/*  ֐		FSdd_IocSetBootInfo												*/
/*  Tv		FSDDD Boot̐ݒ (SDD_IOC_SET_BOOT_INFO)						*/
/*  			FBootLoaderł̃J[hݒ肷							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh					*/
/*  			FUW uw_BootInfo(J[h)									*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  ŏIXV	F2008.2.7															*/
/************************************************************************************/
SDD_ERROR Sdd_IocSetBootInfo(SDD_HANDLE *p_SddHandle, UW uw_BootInfo)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_DEV		*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*==============*/
	/* Bootݒ */
	/*==============*/
	p_sdd->ub_Cmd8Info = (uw_BootInfo >> 1) & SDD_BOOT_INFO_MASK;
	p_sdd->ub_StartCardInit = uw_BootInfo & SDD_BOOT_INFO_MASK;

	return w_ret;
}
#endif /* _SDD_FUNC_QUICK_BOOT_ */

/************************************************************************************/
/*  ֐		FSdd_IocGetErrInfo													*/
/*  Tv		FSDDD G[̎擾 (SDD_IOC_GET_ERRINFO)						*/
/*  			FSDJ[hANZX̃G[擾							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh					*/
/*				FUW uw_Arg															*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  ŏIXV	F2009.6.4															*/
/************************************************************************************/
SDD_ERROR Sdd_IocGetErrInfo(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_DEV		*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	SDD_ERR_INFO *p_SddErr = (SDD_ERR_INFO *)uw_Arg;
	UB ub_CardInOut;
	UB i;

	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetErrInfo>\n");
	
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */

	/*====================*/
	/* J[hL`FbN */
	/*====================*/
	/*
		̓J[ho֐ĂтSddr_DetectCard(UB *pub_CardInOut)Ŏs
		 = &ub_CardInOut
		߂lFȂ
		̖߂lɂĈȉ̏s
			1)J[hL̏ꍇ(ub_CardInOut==SDD_CARDIN)
				p
			2)̏ꍇ(ub_CardInOut==SDD_CARDOUT)
				G[2F
				uh_ret = SDD_ERR_CARD_OUT;
				return;
	*/
	Sddr_DetectCard(p_SddHandle, &ub_CardInOut);

	if(ub_CardInOut == SDD_CARDOUT) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NO_CARD);
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetErrInfo w_ret = %ld\n", w_ret);
		return w_ret;
	}
	
	
	/*
		G[̐ݒ
	*/
	p_SddErr->ub_ErrProcess = p_sdd->ErrInfo.ub_ErrProcess;
	p_SddErr->ub_ErrRank = p_sdd->ErrInfo.ub_ErrRank;
	p_SddErr->uh_Reserve1 = 0;
	p_SddErr->uw_Offset = p_sdd->ErrInfo.uw_ReqOffset;
	p_SddErr->uw_Size = p_sdd->ErrInfo.uw_ReqSize;
	p_SddErr->uw_ErrOffset = p_sdd->ErrInfo.uw_ErrOffset;
	p_SddErr->uw_Resid = p_sdd->ErrInfo.uw_ReqSize - p_sdd->ErrInfo.uw_ErrSize;
	for(i=0;i<4;i++){
		p_SddErr->uw_Reserve2[i] = 0;
	}
	
	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
	/*
		ێG[̃NA
	*/
	Sdds_ErrInfoClear(p_SddHandle);
	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetErrInfo=%ld\n", w_ret);
	
	return w_ret;
}

/************************************************************************************/
/*  ֐		FSdd_IocSendSmart													*/
/*  Tv		FSMARTR}h̔s (SDD_IOC_SEND_SMART)							*/
/*  			FSMARTR}h𔭍s											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh					*/
/*				FUW uw_Arg															*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  ŏIXV	F2009.6.4															*/
/************************************************************************************/
SDD_ERROR Sdd_IocSendSmart(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	SDD_SMART_INFO *p_smartinfo = (SDD_SMART_INFO *)uw_Arg;
	SDD_CMD_INFO cmdinfo;

	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocSendSmart>\n");

	/* 
		p[^G[`FbN
	*/
	if(((p_smartinfo->ub_Type != SDD_SMART_READ) 
		&& (p_smartinfo->ub_Type != SDD_SMART_WRITE)
		&& (p_smartinfo->ub_Type != SDD_SMART_PASSWORD))
		|| (p_smartinfo->pub_Arg == NULL)
		|| (p_smartinfo->pub_Data == NULL))
	{
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendSmart w_ret=%ld\n", w_ret);
		return w_ret;
	}

	/* 
		IoctlOiNbNJnj
	*/
	if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendSmart w_ret = %ld\n", w_ret);
		return w_ret;
	}

	/*
		Argument(Password)ݒ菈
	*/
	cmdinfo.uw_Cmd = (UW)(SDD_CMD_GEN_CMD | SDD_SOFT_CMD_WRITE);
	cmdinfo.uw_Arg =  0x00000000;
	cmdinfo.uw_Size = SDD_SECTOR_SIZE;
	cmdinfo.pub_Rsp = NULL;
	cmdinfo.pub_Data = p_smartinfo->pub_Arg;
	
	/*
		\tgR}hiCMD56js
	*/
	w_TmpRet = Sdds_SetSoftCmd(p_SddHandle, &cmdinfo);
	if (w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		if ((w_TmpRet = Sdds_ioctl_after(p_SddHandle)) != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		}
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendSmart w_ret=%ld\n", w_ret);
		return w_ret;
	}
	
	/* 
		DataM
	*/
	switch(p_smartinfo->ub_Type){
		case SDD_SMART_PASSWORD:
			break;
		case SDD_SMART_READ:
			cmdinfo.uw_Cmd = (UW)(SDD_CMD_GEN_CMD | SDD_SOFT_CMD_READ);
			cmdinfo.uw_Arg =  0x00000001;
			cmdinfo.uw_Size = SDD_SECTOR_SIZE;
			cmdinfo.pub_Rsp = NULL;
			cmdinfo.pub_Data = p_smartinfo->pub_Data;
			w_TmpRet = Sdds_SetSoftCmd(p_SddHandle, &cmdinfo);
			break;
		case SDD_SMART_WRITE:
			cmdinfo.uw_Cmd = (UW)(SDD_CMD_GEN_CMD | SDD_SOFT_CMD_WRITE);
			cmdinfo.uw_Arg =  0x00000000;
			cmdinfo.uw_Size = SDD_SECTOR_SIZE;
			cmdinfo.pub_Rsp = NULL;
			cmdinfo.pub_Data = p_smartinfo->pub_Data;
			w_TmpRet = Sdds_SetSoftCmd(p_SddHandle, &cmdinfo);
			break;
		default:
			break;
	}

	if (w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}

	/* 
		Ioctl㏈iNbN~j
	*/
    if ((w_TmpRet = Sdds_ioctl_after(p_SddHandle)) != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}

	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendSmart w_ret=%ld\n", w_ret);
	return w_ret;
}

/************************************************************************************/
/*  ֐		FSdd_IocSendCommand												*/
/*  Tv		FėpSDR}h̔s (SDD_IOC_SEND_COMMAND)						*/
/*  			FSDJ[hANZX̃G[擾							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh					*/
/*				FUW uw_Arg															*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  ŏIXV	F2009.6.4															*/
/************************************************************************************/
SDD_ERROR Sdd_IocSendCommand(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_ERROR w_TmpRet;
	SDD_CMD_INFO *p_cmdinfo = (SDD_CMD_INFO *)uw_Arg;
	UB ub_CardInOut;

	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocSendCommand>\n");

#ifndef _SDD_ANGOU_
    /* ÍW[Ȃꍇɂ̓fbhbNׁASR}h͎̓ɂ̓p[^G[Ƃ */
    if (p_cmdinfo->uw_Cmd >=SDD_CMD_SCMD) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendCommand w_ret = %ld\n", w_ret);
		return w_ret;
    }
#endif /* _SDD_ANGOU_ */

	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */

	/*====================*/
	/* J[hL`FbN */
	/*====================*/
	/*
		̓J[ho֐ĂтSddr_DetectCard(UB *pub_CardInOut)Ŏs
		 = &ub_CardInOut
		߂lFȂ
		̖߂lɂĈȉ̏s
			1)J[hL̏ꍇ(ub_CardInOut==SDD_CARDIN)
				p
			2)̏ꍇ(ub_CardInOut==SDD_CARDOUT)
				G[2F
				uh_ret = SDD_ERR_CARD_OUT;
				return;
	*/
	Sddr_DetectCard(p_SddHandle, &ub_CardInOut);

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */

	if(ub_CardInOut == SDD_CARDOUT) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NO_CARD);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendCommand w_ret = %ld\n", w_ret);
		return w_ret;
	}

	/* 
		p[^G[`FbN
		p_cmdinfo->uw_Cmd̐ݒl̐mFSdds_SetSoftCmdŎ{ 
	*/
	if(((p_cmdinfo->uw_Size > SDD_SECTOR_SIZE) && ((p_cmdinfo->uw_Size%SDD_SECTOR_SIZE) != 0))
		||((p_cmdinfo->uw_Size != 0) && (p_cmdinfo->pub_Data == NULL))){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendCommand w_ret = %ld\n", w_ret);
		return w_ret;
	}

	/* 
		X|Ẍ̃`FbN
			ł̓X|Xl͕ԂȂdl̂ߖANULL̂ݗL
	*/
	if(p_cmdinfo->pub_Rsp != NULL){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendCommand w_ret = %ld\n", w_ret);
		return w_ret;
	}

	/* 
		IoctlOiNbNJnj
	*/
	if ((w_TmpRet = Sdds_ioctl_before(p_SddHandle)) != SDD_SUCCESS) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendCommand w_ret = %ld\n", w_ret);
		return w_ret;
	}
	
	/*
		\tgR}hs
	*/
	w_TmpRet = Sdds_SetSoftCmd(p_SddHandle, p_cmdinfo);
	if (w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}

	/* 
		Ioctl㏈iNbN~j
	*/
    if ((w_TmpRet = Sdds_ioctl_after(p_SddHandle)) != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}

	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocSendCommand w_ret=%ld\n", w_ret);
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetRca										            */
/*  Tv		FRCA擾 (SDD_IOC_GET_RCA)					                    */
/*  			FɕێRCA擾						        */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg;(RCAi[pAhX)							        */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.07.13													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetRca(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	UW *puw_Rca = (UW *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetRca>\n");
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
	/*================*/
	/* RCA擾 */
	/*================*/
	/*
		|C^փhCof[^̃J[heʐݒ
		*(puw_Rca) = SddDev[port].uh_Rca;
		SDD_DEV.uh_Rca̓J[hɎ擾
	*/
	*(puw_Rca) = (UW)(p_sdd->uh_Rca);

	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetRca\n");
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_IocGetScr										            */
/*  Tv		FSCR擾 (SDD_IOC_GET_SCR)					                    */
/*  			FɕێSCR擾						        */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB uw_Arg;SCRXe[^Xi[pAhX(8B̈)					*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.09.17													*/
/********************************************************************************/
SDD_ERROR Sdd_IocGetScr(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	UB *pub_Scr = (UB *)uw_Arg;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UB ub_type;
	
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdd_IocGetScr>\n");
	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
	/*==========================================*/
	/* J[h^Cv`FbN
	 (SD̂ݎ擾\) */
	/*==========================================*/
	/*
		J[h^Cv`FbN(SddDev[port].ub_CardType)
			1) SddDev[port].ub_CardType(CARDTYPE_SD)̏ꍇ
				p
			2)LȊȌꍇA
				G[1F
					uh_ret = SDD_ERR_NOT_SUPPORT;
					return;
	*/
	ub_type = (UB)(p_sdd->ub_CardType & (UB)SDD_CARD_TYPE_MASK);

	if (ub_type != (UB)SDD_CARD_TYPE_SD) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_SUPPORT);
		Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetScr w_ret = %ld\n", w_ret);
		return w_ret;
	}

	/*====================*/
	/* SCRRs[ */
	/*====================*/
	/*
		|C^փhCof[^SCRRs[
		P = pub_SdScr
		Q = SddDev[port].ub_Scr
		R = SDD_SCR_SIZE
		Sdd_memcpy(p_SddHandle, UB *pub_Dst, UB *pub_Src, UH uh_Size)JmpAp
		SDD_DEV.ub_Scr̓J[hɎ擾
	*/
	Sdd_memcpy(p_SddHandle, pub_Scr, p_sdd->ub_Scr, SDD_SCR_SIZE);
	
	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdd_IocGetScr w_ret = %ld\n", w_ret);
	return w_ret;
}

#ifdef _SDD_ENABLE_MCLK_CHANGE_
/********************************************************************************/
/*  ֐		FSdd_IocChangeMclk												*/
/*  Tv		FSDIP MCLK̕ύX (SDD_IOC_CHANGE_MCLK)							*/
/*  			FSDIPMCLK؂ւ(=55MHz, O=63.5MHz)				*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg														*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdd_IocChangeMclk(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	if (((UB)uw_Arg != SDD_MCLK_INTERNAL) && ((UB)uw_Arg != SDD_MCLK_EXTERNAL)) {
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_PARAM);
		return w_ret;
	}

#if 0
	if (p_sdd->ub_MclkInfo == (UB)uw_Arg) {
		return w_ret;
	}
#endif
	Sdds_StopCDDetect(p_SddHandle);	/* J[hoNbNu~邽߁A댟oh */

	Sddr_ChangeMclk(p_SddHandle, (UB)uw_Arg);	/* MCLK̐؂ւ */

	Sdds_StartCDDetect(p_SddHandle);	/* J[ȟoNbNu~邽߁A댟oh */

	p_sdd->ub_MclkInfo = (UB)uw_Arg;

	return w_ret;
}
#endif	/* _SDD_ENABLE_MCLK_CHANGE_ */

