/********************************************************************************/
/*  t@C    F$Workfile: SddSubr_basic.c $                                */
/*  Tv          FSDfoCXhCoʏpo͐֐pTu֐t@C    */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 06/06/12 12:10 $                                  */
/********************************************************************************/
#include "SddDma.h"
#include "SddError.h"

static SDD_ERROR Sdds_CardInit( SDD_HANDLE *p_SddHandle );
static SDD_ERROR Sdds_InitSub(SDD_HANDLE *p_SddHandle);

/********************************************************************************/
/*  ֐		FSdds_CardInit													*/
/*  Tv		FJ[h̏Ȃ										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
static SDD_ERROR Sdds_CardInit( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UW	uw_SetDiv;

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_CARDINIT );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

#ifdef	_SDD_DETECT_SDIO_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#endif

#ifdef _SDD_ALLOW_UHS1_
	/*======================================================*/
	/*	PowerCyclepɋd0VɐݒiݒςȂύXȂj*/
	/*  dݒ֐(Sdds_SwitchVoltagej					*/
	/*		FSDD_VOL_0								    */
	/*		߂lFʁiFG[Ȃj			*/
	/*======================================================*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sdds_SwitchVoltage(0V)\n");
	w_ResTmp = Sdds_SwitchVoltage(p_SddHandle, SDD_VOL_0);
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	/*======================================================*/
	/*	d3.3VɐݒiݒςȂύXȂj			*/
	/*  dݒ֐(Sdds_SwitchVoltagej					*/
	/*		FSDD_VOL_33								*/
	/*		߂lFʁiFG[Ȃj			*/
	/*======================================================*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sdds_SwitchVoltage(3.3V)\n");
	w_ResTmp = Sdds_SwitchVoltage(p_SddHandle, SDD_VOL_33);
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
#endif /* _SDD_ALLOW_UHS1_ */

	/*======================================================*/
	/*	SDI/F̃\tgZbg								*/
	/*  SDIPZbg֐(Sddr_SoftReset)					*/
	/*		 = SDD_SOFT_RESET_SD						*/
	/*		߂lFȂ									*/
	/*======================================================*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sddr_SoftReset\n");	/* MISRAOK:3:1332 ψŎgp@ɖȂ */
	Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_ALL);

    /*======================================================*/
    /*  SDI/FDMA[h̉                              */
    /*  DMA[hݒ֐(Sddr_DisDmaSDIF)                  */
    /*      Fp_SddHandle                               */
    /*      ߂lFȂ                                    */
    /*======================================================*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sddr_DisDmaSDIF\n");	/* MISRAOK:3:1332 ψŎgp@ɖȂ */
    Sddr_DisDmaSDIF(p_SddHandle);

	/*======================================================*/
	/*	SD CLK̕ݒ									*/
	/*	Sddr_SetClkDivŎs						*/
	/*		 = LOWSPEED									*/
	/*		߂lFȂ									*/
	/*======================================================*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sdds_CheckSetDiv\n");	/* MISRAOK:3:1332 ψŎgp@ɖȂ */
	w_ResTmp = Sdds_CheckSetDiv(p_SddHandle, SDD_CLOCK_DIV_LOWSPEED, &uw_SetDiv);
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	Sddr_SetClkDiv(p_SddHandle, uw_SetDiv);

	/*================================================*/
	/* ύXɂƂȂ^CAEgTCN̕ύX */
	/*================================================*/
	/* 
		TOP[27:24](SD_OPTIONWX^j̐ݒ
		Sddr_SetClkDivŎs
			 = SDD_CLOCK_DIV_1`512̂ǂꂩ
			߂lFȂ
	*/		
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sddr_SetTimeOutCycle\n");	/* MISRAOK:3:1332 ψŎgp@ɖȂ */
	Sddr_SetTimeOutCycle(p_SddHandle, uw_SetDiv);

	/*======================================================*/
	/* SDNbN(SD_CLK_CTRL)							*/
	/*	SDNbNݒ֐(Sddr_EnaClk())					*/
	/*	=SDD_CLK_ENABLEiENABLESD_CLKój			*/
	/*	߂lG[Ȃipj						*/
	/*======================================================*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sddr_EnaClk\n");
	w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_ENABLE);
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*================================================*/
	/* J[h̓dON74ClockAő1ms҂(SDKi) */
	/*================================================*/
	/*
		tslp_tskOSbsO֐Ŏs
			1: ^CAEg(1ms)
			߂lFG[Ȃî͂j
				G[̏ꍇ
					w_Result |= G[R[h
					SDNbN~(Sddr_EnaClk)
						=SDD_CLK_DISABLEiDISABLESD_CLK~j
						߂lG[Ȃip)
					return;
	*/
	w_ResTmp = Sdd_Delay(SDD_INIT_SD_MSEC);
	w_ResTmp &= ~SDD_ERR_OS_TIMEOUT;	/* SDD_ERR_OS_TIMEOUTNA  */
	if (w_ResTmp != SDD_SUCCESS) {
			/* ߂lFG[Ȃ͂ */
			/* G[Ăʒm͂Ȃ */
	}

#ifdef	_SDD_DETECT_SDIO_
	/*
		SDIO/SD_COMBOJ[h
		Sdds_SDIOInit()Ŏs
			Sdds_SDIOInit()
				Fp_SddHandle
				߂lF
					iSUCCESSj̏ꍇ
						J[hʔ(SDD_DEV.Ub_CardType)
							SDIO(0x02̃}Nl)̏ꍇ
								w_Result = SDD_ERR_NOT_SUPPORT;
								return;
							SDIOȊȌꍇ
								p
					G[iSUCCESSȊOj̏ꍇ
						w_Result = G[lݒ;
						return;
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sdds_SDIOInit\n");
	w_ResTmp = Sdds_SDIOInit(p_SddHandle);
#ifdef _SDD_FUNC_SDIO_
    if (p_sdd->uw_TmpOperationMode != SDD_CARD_INIT_MODE_SDIO) {
        /* [h/d[hŏĂꍇSDIOJ[hNOT_SUPPORT */
        if(w_ResTmp == SDD_SUCCESS) {
            if(((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) == SDD_CARD_TYPE_IO) {
                w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
                return w_Result;
            }
        } else {
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
            return w_Result;
        }
    }
    else {
        /* SDIO[hŏĂꍇAG[NOT_SUPPORT */
        if(w_ResTmp != SDD_SUCCESS) {
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
            return w_Result;
        }
	}
#else
	if(w_ResTmp == SDD_SUCCESS) {
		if(((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) == SDD_CARD_TYPE_IO) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
			return w_Result;
		}
	} else {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
#endif /* _SDD_FUNC_SDIO_ */
#endif	/* _SDD_DETECT_SDIO_ */

#ifdef _SDD_FUNC_SDIO_
    if (p_sdd->uw_TmpOperationMode != SDD_CARD_INIT_MODE_SDIO) {
        /*
		SD_MemoryJ[h
		Sdds_SDInitŎs
			Sdds_SDInit()
				Fp_SddHandle
				߂lF
					iSUCCESSj̏ꍇ
						p
					G[iSUCCESSȊOj̏ꍇ
						w_Result = G[lݒ;
						return;
         */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sdds_SDInit\n");
        w_ResTmp = Sdds_SDInit(p_SddHandle);

        if(w_ResTmp != SDD_SUCCESS) {
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
        }
        return w_Result;
    }
    else {
        /* SDIO[ḧSDIOps */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sdds_IO_Init\n");
        w_ResTmp = Sdds_IO_Init(p_SddHandle, NULL,NULL);
        if(w_ResTmp != SDD_SUCCESS) {
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
        }
        return w_Result;
    }
#else
    
    /*
		SD_MemoryJ[h
		Sdds_SDInitŎs
			Sdds_SDInit()
				FȂ
				߂lF
					iSUCCESSj̏ꍇ
						p
					G[iSUCCESSȊOj̏ꍇ
						w_Result = G[lݒ;
						return;
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CardInit:Sdds_SDInit\n");
	w_ResTmp = Sdds_SDInit(p_SddHandle);

	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}
	return w_Result;
#endif /* _SDD_FUNC_SDIO_*/
}

/************************************************************************************/
/*  ֐		FSdds_InitSub														*/
/*  Tv		FSDDD													*/
/*  			FhCõO[oϐ̏ASD I/F̑SW[Z	*/
/*				FbgsA														*/
/*				F	O[oϐ											*/
/*				F	NbNiIMCLK/IMCLK2j									*/
/*				F	LSIZbg														*/
/*				F	荞݋֎~iSDI/F-S&StreamDMACj							*/
/*				F	荞݃R[obN NULLݒ									*/
/*				F	荞݋iCDMł̃J[h}̂݋j					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/* 	    		FȂ																*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.03.10														*/
/************************************************************************************/
SDD_ERROR Sdds_InitSub(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
    SDD_ERROR w_TmpRet;

	/*==========================================================*/
	/* hCoO[oϐ 						*/
	/*	ϐ SDD_DEṼR[obN֐ȊO̕ϐ 	*/
	/*	Sdds_InitData()ł							*/
	/*	߂l̓G[Ȃipj							*/
	/*==========================================================*/
	Sdds_InitDataNonCbf(p_SddHandle);	/*R[obN֐ȊȌ */
	
	w_TmpRet = Sdds_Init(p_SddHandle);		/* Ƃ̋ʏ */
	if(w_TmpRet != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_TmpRet);
	}

	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_InitCardBeforRetry										*/
/*  Tv		FŌ̃gCJnOŎ{鏀						*/
/*  			FCMD002sAJ[h̍ď{					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
static SDD_ERROR Sdds_InitCardBeforRetry( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;

#if defined(_SDD_DEFECT_P8CARD_)
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uw_ClkDiv;			/* NbNύXp */
	UW uw_tmpClkDiv = p_sdd->uw_ClkDiv;	/* ݂SDNbNۑ */
	UH uh_tmpStatus = Sdds_GetStatus(p_SddHandle);	/* ݂̏ԕێ */

#ifdef _SDD_ALLOW_UHS1_
	if(p_sdd->uw_OperationMode == SDD_CARD_INIT_MODE_LV){
        /* PowerCycle̎{ */
        w_ResTmp = Sdds_SwitchVoltage(p_SddHandle, SDD_VOL_0);		/* 0Vdؑ */
        if(w_ResTmp != SDD_SUCCESS){
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
            return w_Result;
        }
        w_ResTmp = Sdds_SwitchVoltage(p_SddHandle, SDD_VOL_33);		/* 3.3Vdؑ */
        if(w_ResTmp != SDD_SUCCESS){
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
            return w_Result;
        }
	}
#endif /* _SDD_ALLOW_UHS1_ */

	w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_DISABLE);	/* SD_CLK̒~AF1̏ꍇɑS̐䃌WX^(IOBCLKEN)ICLKSELrbgNA */
	if(w_ResTmp != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_SD);	/* SD-IPSDRSTZbg */
	
	w_ResTmp = Sdds_CheckSetDiv(p_SddHandle, SDD_CLOCK_DIV_LOWSPEED, &uw_ClkDiv);	/* SD CLK̕ݒ */
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	Sddr_SetClkDiv(p_SddHandle, uw_ClkDiv);
	Sddr_SetTimeOutCycle(p_SddHandle, uw_ClkDiv);	/* ύXɂƂȂ^CAEgTCN̕ύX */
	
	w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_ENABLE);		/* ZbgŒ~ꂽSDCLKďo */
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		Sddr_SetClkDiv(p_SddHandle, uw_tmpClkDiv);		/* SDNbNɖ߂(O[oϐASD_CLK_CTRLWX^) */
		Sddr_SetTimeOutCycle(p_SddHandle, uw_tmpClkDiv);	/* SDNbNύXɂƂȂ^CAEgTCNɖ߂ */
		return w_Result;
	}
	
	/* Panasonic SDM08G s΍ */
	Sdds_ResetCard(p_SddHandle);		/* CMD00si1ځj */
	Sdds_ResetCard(p_SddHandle);		/* CMD00si2ځj */

	Sddr_CardDataInit(p_SddHandle);					/* J[h̏Ȃ */
	p_sdd->ub_CardType = (UB)SDD_CARD_TYPE_UNKNOWN;	/* Ƃ肠m̃J[hƂ */
	p_sdd->w_error = SDD_SUCCESS;		/* Ƃ肠G[NA */

	w_ResTmp = Sdds_CardInit(p_SddHandle);		/* J[hď{ */
	if(w_ResTmp != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		p_sdd->ub_CardType = (UB)SDD_CARD_TYPE_UNKNOWN;	/* J[hs͖m̃J[hƂ */
		w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_DISABLE);	/* SD_CLK̒~ */
		if(w_ResTmp != SDD_SUCCESS){
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		}
		Sddr_SetClkDiv(p_SddHandle, uw_tmpClkDiv);		/* SDNbNɖ߂(O[oϐASD_CLK_CTRLWX^) */
		Sddr_SetTimeOutCycle(p_SddHandle, uw_tmpClkDiv);	/* SDNbNύXɂƂȂ^CAEgTCNɖ߂ */
		return w_Result;
	}

	/* ς݃tOĐݒ */
	Sdds_SetStatus( p_SddHandle, uh_tmpStatus );
	/*
		J[h̍ďASDNbNRead/Write{ȌԂɖ߂B
	*/
	w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_DISABLE);
	if(w_ResTmp != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		Sddr_SetClkDiv(p_SddHandle, uw_tmpClkDiv);		/* SDNbNɖ߂(O[oϐASD_CLK_CTRLWX^) */
		Sddr_SetTimeOutCycle(p_SddHandle, uw_tmpClkDiv);	/* SDNbNύXɂƂȂ^CAEgTCNɖ߂ */
		return w_Result;
	}

	Sddr_SetClkDiv(p_SddHandle, uw_tmpClkDiv);		/* SDNbNɖ߂(O[oϐASD_CLK_CTRLWX^) */
	Sddr_SetTimeOutCycle(p_SddHandle, uw_tmpClkDiv);	/* SDNbNύXɂƂȂ^CAEgTCNɖ߂ */

	w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_ENABLE);		/* ZbgŒ~ꂽSDCLKďo */
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

#else
	Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_SD);	/* SD-IPSDRSTZbg */
	w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_ENABLE);		/* ZbgŒ~ꂽSDCLKďo */
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}
#endif /* _SDD_DEFECT_P8CARD_ */

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_CallCbfRetryLba											*/
/*  Tv		FgC̏ʒʒmR[obN֐̌ďo				*/
/*  			Fʂw肵JnAhXʒm							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Offset(擪ZN^AhX)								*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sdds_CallCbfRetryLba( SDD_HANDLE *p_SddHandle, UW uw_Offset )
{
#if defined(_SDD_CALL_CBF_RETRY_INFO_)
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/* API֐Ăяo̊JnZN^AhXʒmpR[obN֐L */
	if( p_sdd->CbfRetryLba.vp_Fp ){
		/* R[obN֐L̏ꍇAf[^\SDD_DEVAPI֐Ăяo̊JnZN^AhXʒmpR[obN֐ďo */
		(*(p_sdd->CbfRetryLba.vp_Fp))(SDD_EVENT_ERR_RETRY_LBA ,p_sdd->CbfRetryLba.uw_Param, uw_Offset);
	}
#endif /* _SDD_CALL_CBF_RETRY_INFO_ */
}

/********************************************************************************/
/*  ֐		FSdds_CallCbfRetryErcd											*/
/*  Tv		FgC̏ʒʒmR[obN֐̌ďo				*/
/*  			FgCƂȂG[R[hʒm						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FW w_Result(G[R[h)										*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sdds_CallCbfRetryErcd( SDD_HANDLE *p_SddHandle, W w_Result )
{
#if defined(_SDD_CALL_CBF_RETRY_INFO_)
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/* gC̃gKƂȂG[R[hʒmpR[obN֐L */
	if( p_sdd->CbfRetryErcd.vp_Fp ){
		/* R[obN֐L̏ꍇAf[^\SDD_DEṼgC̃gKƂȂG[R[hʒmpR[obN֐ďo */
		(*(p_sdd->CbfRetryErcd.vp_Fp))(SDD_EVENT_ERR_RETRY_ERCD ,p_sdd->CbfRetryErcd.uw_Param, (UW)w_Result);
	}
#endif /* _SDD_CALL_CBF_RETRY_INFO_ */
}

/********************************************************************************/
/*  ֐		FSdds_CallCbfRetryInfo											*/
/*  Tv		FgC̏ʒʒmR[obN֐̌ďo				*/
/*  			FRead/WritẽgCʒmR[obN֐R			*/
/*  			  Ăяo													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F W w_Result(G[R[h)										*/
/*  			FUB ub_RetryCount(gC)								*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sdds_CallCbfRetryInfo( SDD_HANDLE *p_SddHandle, W w_Result, UB ub_RetryCount )
{
#if defined(_SDD_CALL_CBF_RETRY_INFO_)
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	if( ub_RetryCount < 1 ){
		return;		/* ub_RetryCount̒l"1"菬ꍇAΉ */
	}

	/* gCʒmpR[obN֐L */
	if ( p_sdd->CbfRetryInfo.vp_Fp ) {
		if( w_Result != SDD_SUCCESS ){
			/* R[obN֐L̏ꍇAf[^\SDD_DEṼgCʒmpR[obN֐ďo */
			(*(p_sdd->CbfRetryInfo.vp_Fp))(SDD_EVENT_ERR_RETRY_INFO, p_sdd->CbfRetryInfo.uw_Param, (UW)( (0xF0 | (ub_RetryCount - 1)) ));
		}else{
			/* R[obN֐L̏ꍇAf[^\SDD_DEṼgCʒmpR[obN֐ďo */
			(*(p_sdd->CbfRetryInfo.vp_Fp))(SDD_EVENT_ERR_RETRY_INFO, p_sdd->CbfRetryInfo.uw_Param, (UW)ub_RetryCount);
		}
	}
#endif /* _SDD_CALL_CBF_RETRY_INFO_ */
}
