/***********************************************************************************/
/*  t@C  F$Workfile: SddDma.c $                                            */
/*  Tv        FSDfoCXhCoDMA֘Ai[t@C                        */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.            */
/*  ŏIXV  F$Modtime: 06/06/12 10:20 $                                       */
/*                SDD_DMAIntrpOǉ 2006/06/30 H.Miura                       */
/*                DMA~ǉ 2006/07/03 H.Miura                               */
/*                DMA~㏈ǉ 2006/07/03 H.Miura                             */
/***********************************************************************************/
/* wb_[t@C */
#include "SddCom.h"
#include "SddRegister_dma.h"
#include "SddOsEvent.h"
#include "SddError.h"
#include "SddDma.h"
#include "SddOsIntr.h"
#include "SddCardInOut.h"

/* Tu֐t@C */
#if defined(_SDD_JUPITER_)
#include "device/SddDma_for_jupiter.c"
#endif /* defined(_SDD_JUPITER_) */

#if defined(_SDD_UNIPHIER_2P_)
#include "device/SddDma_for_uniphier2p.c"
#endif /* defined(_SDD_UNIPHIER_2P_) */

#if defined(_SDD_UNIPHIER_XP_)
#include "device/SddDma_for_uniphierxp.c"
#endif /* defined(_SDD_UNIPHIER_XP_) */

#if defined(_SDD_MN6682X_)
#include "device/SddDma_for_mn6682x.c"
#endif /* defined(_SDD_MN6682X_) */

#if defined(_SDD_USE_SDMACLIB_)
#include "device/SddDma_for_sdmaclib.c"
#endif /* defined(_SDD_USE_SDMACLIB_) */

#if defined(_SDD_PEAKS_PRO2_)
#include "device/SddDma_for_PeaksPro2.c"
#endif /* defined(_SDD_PEAKS_PRO2_) */

#if defined(_SDD_PCAM_)
#include "device/SddDma_for_pcam.c"
#define _SDD_USE_SDMACLIB_
#endif /* defined(_SDD_PCAM_) */

#if defined(_SDD_4M_ANDROID_)
#include "device/SddDma_for_4mAndroid.c"
#endif /* defined(_SDD_4M_ANDROID_) */

#if !defined(_SDD_USE_SDMACLIB_) && !defined(_SDD_PCAM_) && !defined(_SDD_4M_ANDROID_)
/********************************************************************************/
/*  ֐		FSdds_StartSdma_before											*/
/*  Tv		FSdds_StartSdmapʑO						            */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*				F]JnAhX												*/
/*				FRead] or Write]											*/
/*  ߂l		FSDD_ERROR														*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
static SDD_ERROR Sdds_StartSdma_before(SDD_HANDLE *p_SddHandle, UW uw_StartAd, UW uw_Rw) {
    /* Ȃ */
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSdds_EndSdma													*/
/*  Tv		FDMA]I								            */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
SDD_ERROR Sdds_EndSdma( SDD_HANDLE *p_SddHandle )
{
    /* Ȃ */
	return SDD_SUCCESS;
}
#endif /* !defined(_SDD_USE_SDMACLIB_) && !defined(_SDD_PCAM_) && !defined(_SDD_4M_ANDROID_) */

/********************************************************************************/
/*  ֐		FSddr_EnaDmaSDIF												*/
/*  Tv		FSD I/F DMAݒ(Enable)							            */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_EnaDmaSDIF( SDD_HANDLE *p_SddHandle )
{
	/* CC_EXT_MODEDMASDRWrbg"1"ɐݒ */
	Sdd_M_OrReg(SDD_CC_EXT_MODE(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_EXT_MODE_DMASDRW);
	return;
}

/********************************************************************************/
/*  ֐		FSDD_DMAIntr													*/
/*  Tv		FSD I/F֘ADMA荞ݏȂ(^XNReLXg)	*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
void SDD_DMAIntr(SDD_HANDLE *p_SddHandle)
{
    W w_ret;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
	/* SDD_DMAIntrpOǉ 2006/06/30 H.Miura */
	SDD_DMAIntr_before(p_SddHandle);

	/*==============================================================================*/
	/* 荞݌o`FbN	iďo֐Ń`FbNNAς̏ꍇ͂svj*/
	/*==============================================================================*/
    /*================================*/
    /* DMA]荞݌o	  */
    /*================================*/
    /*========================================*/
    /* 荞݌õ[Jϐւ̑ޔ */
    /*========================================*/
    /* foCX擾(֐\Aȉe) */
    /* uw_status = Sdd_GetDMAIntrStatus();*//* DMCIntrSt & DMC荞݃Xe[^XWX^}XN(SDDDŎgpbit)*/
    /* 荞݂̃NA(o)	*/

    /* DMA~ ܂́AReadAllAccessEndMDMA~Kv */
    Sddr_DisDmaSDIF(p_SddHandle);
    Sddr_DisDmaInt(p_SddHandle);
    Sddr_ClrDmaInt(p_SddHandle);	/* pgr0024 */

    /* 荞ݗv *//* FSDD_DMA_CHł̌oL */
    /* ȍꍇ	*/
    /*return;*/	/* Ȃ */
    /* oL̏ꍇ */	
	/*==================================================================================*/
	/* 荞݌o`FbNI	iďo֐Ń`FbNNAς̏ꍇ͂܂ŕsvj*/
	/*==================================================================================*/	
    /* iԌ]̏ꍇ̓^C}~vBT|[gj */
    w_ret = Sdd_SetEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), SDD_EVENTFLG_DMA_END);		/* DMAʒm(֐ďo) */
    if (w_ret != SDD_SUCCESS) {				/* G[`FbN 	*/
        /* ߂lFG[Ȃ͂ */
        /* CxgʒmŃG[Ăʒm͂Ȃ */
    }
	return;	/* ߂lȂ */
}

#ifdef _SDD_ENABLE_RINGBUF_
/********************************************************************************************/
/*  ֐		FSdds_CheckRingBuff														*/
/*  Tv		FOobt@̔Ayѐݒ											*/
/*					݂ꍇAȉ2̂Âꂩ̏s							*/
/*					1)[v1]ZN^~]TCY̓Oobt@TCYȉ				*/
/*						StreamDMAC̃WX^ɃOobt@(SDD_DEV.Ringbuffer)ݒ		*/
/*					2)[v1]ZN^~]TCY̓Oobt@TCYȏ				*/
/*						SDD_ERR_PARAMݒ													*/
/*					݂ȂꍇAX^[gAhXƓ]TCY烊Oobt@Đݒ	*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                          */
/*      		FUW uw_Start	[in]	JnAhX										*/
/*				FUW uw_Count	[in]	ZN^											*/
/*  ߂l		FFSDD_SUCCESS															*/
/*  			FsFG[R[h														*/
/*  ŏIXV	F2009.03.09																*/
/********************************************************************************************/
SDD_ERROR Sdds_CheckRingBuff(SDD_HANDLE *p_SddHandle, UW uw_Start, UW uw_Count)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	UW	uw_CountByte;
	UW	uw_RingBuffSize;
	UW	uw_End;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/* 
	̊JnAhXSDfoCXhCoێĂ郊Oobt@AhX
	(SDD_DEV.RingBuff.uw_BuffStart, uw_BuffEnd)Ɣr

		1) obt@̏ꍇA

			Oobt@̃TCY(̃ZN^*ZN^TCY)r

				1-1) (̃ZN^*ZN^TCY)̓Oobt@TCYȉ
					1: SDfoCXhCoێĂ郊Oobt@AhX(SDD_DEV.RingbufferStart)
					2: SDfoCXhCoێĂ郊Oobt@AhX((SDD_DEV.RingbufferEnd)
					Oobt@ݒ֐(Sddr_SetRingBuff)jumpAp
					߂lG[Ȃipj

				1-2) (̃ZN^*ZN^TCY)̓Oobt@TCYȏ
					߂lɃG[ݒ(w_Result  SDD_ERR_PARAM) 
		2) obt@ȌꍇA
			1: ̊JnAhX(Start)
			2: ̊JnAhX+(̃ZN^*ZN^TCY)(End)
			Oobt@ݒ֐(Sddr_SetRingBuff)jumpAp	64ByteEւ̕ϊ͍L֐łȂ
					߂lG[Ȃipj
	*/

	uw_CountByte = uw_Count * SDD_SECTOR_SIZE;		/* ZN^oCgϊ */
	uw_RingBuffSize = p_sdd->RingBuffer.uw_BuffEnd - p_sdd->RingBuffer.uw_BuffStart;	/* Oobt@TCY */

	/* Oobt@ */
	if((p_sdd->RingBuffer.uw_BuffStart <= uw_Start) && (p_sdd->RingBuffer.uw_BuffEnd > uw_Start)) {	/* ~XC 04/2/6 shiiba */
		if(uw_RingBuffSize >= uw_CountByte) {
			Sddr_SetRingBuff(p_SddHandle, p_sdd->RingBuffer.uw_BuffStart, p_sdd->RingBuffer.uw_BuffEnd);
		}
		else{
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
		}
	}
	else{	/* Oobt@O ̓Oobt@@\Off */
		uw_End = uw_Start + uw_CountByte;		/* ~XC 04/2/6 shiiba */
		Sddr_SetRingBuff(p_SddHandle, uw_Start, uw_End);
	}

	return w_Result;
}
#endif /* _SDD_ENABLE_RINGBUF_ */
#ifndef _SDD_MN6682X_
/********************************************************************************/
/*  ֐		FSdds_StartSdma												*/
/*  Tv		FStream DMAC&SDI/F DMA̓]ݒ								*/
/*					SDI/F DMA]ݒ(2L̂)									*/
/*					StreamDMAC荞݋֎~										*/
/*					StreamDMAC荞݃NA								*/
/*					StreamDMAC]ݒ											*/
/*					StreamDMAC]N(2L̂݁j									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F]TCYiZN^j											*/
/*				F]X^[gAhX										*/
/*				FRead] or Write]											*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
SDD_ERROR Sdds_StartSdma(SDD_HANDLE *p_SddHandle, UW uw_SendSec, UW uw_StartAd, UW uw_Rw)	/* @ύX@uw_Offsetuw_StartAd   shiiba*/
{
   	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UW uw_SendByte;

    /* Sdds_StartSdmapʑO֐ǉ(2007.2.2) */
    w_ResTmp = Sdds_StartSdma_before(p_SddHandle, uw_StartAd, uw_Rw);
	if(w_ResTmp != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
        return w_Result;
	}

	/*==========================================*/
	/* SDI/F DMA]ݒ(2L̂)				*/
	/*	CC_EXT_MODEDMASDRWrbg"1"ɐݒ	*/
	/*	Sddr_EnaDmaSDIF()						*/
	/*==========================================*/
	Sddr_EnaDmaSDIF(p_SddHandle);

	/*==========================================*/
	/*	StreamDMAC荞݋֎~					*/
	/*	Sddr_DisDmaInt()						*/
	/*==========================================*/
	Sddr_DisDmaInt(p_SddHandle);

	/*==========================================*/
	/*	StreamDMAC荞݃NA			*/
	/*	Sddr_ClrDmaInt()						*/
	/*==========================================*/
	Sddr_ClrDmaInt(p_SddHandle);	/* pgr0024 */

	/*======================================================*/
	/* StreamDMAC]ݒ									*/
	/*	Sddr_SetDma(UW uw_StartAd,UW uw_DataByte,UW uw_Rw);	*/
	/*	=]TCY,]X^[gAhX,				*/
	/*	     Read or Write(ʂ̈)					*/
	/*======================================================*/
	uw_SendByte = uw_SendSec * SDD_SECTOR_SIZE;

	w_ResTmp = Sddr_SetDma(p_SddHandle, uw_StartAd, uw_SendByte, uw_Rw);	/* @ύX@uw_Offsetuw_StartAd  shiiba */
	if(w_ResTmp != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		w_ResTmp = Sdds_EndSdma(p_SddHandle);		/* SDI/F DMA]ݒASDMACN[YASDRAM̃foCXnh */
		if (w_ResTmp != SDD_SUCCESS) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		}
	}
	return w_Result;
}
#endif /* _SDD_MN6682X_ */

#if !defined(_SDD_MN6682X_) && !defined(_SDD_4M_ANDROID_)
/********************************************************************************/
/*  ֐		FSdds_StopSdma													*/
/*  Tv		FDMA~														*/
/*					SDI/F DMA]~ݒ(2L̂)								*/
/*					StreamDMAC荞݋֎~										*/
/*					StreamDMAC荞݃NA								*/
/*					StreamDMAC]~(2L̂)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_StopSdma( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
    SDD_ERROR w_ResTmp;
	SDD_ERROR w_DmaErr = SDD_SUCCESS;

	/*==========================================*/
	/* SDI/F DMA]ݒ(2L̂)				*/
	/*	CC_EXT_MODEDMASDRWrbg"0"ɐݒ	*/
	/*	Sddr_DisDmaSDIF()						*/
	/*==========================================*/
	Sddr_DisDmaSDIF(p_SddHandle);

	/* DMA~ǉ 2006/07/03 H.Miura */
	w_ResTmp = Sdds_StopSdma_DMAStop(p_SddHandle, &w_DmaErr);
	if(w_ResTmp != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
        return	w_Result;
	}

	/*==========================================*/
	/* StreamDMAC荞݃NA				*/
	/*	Sddr_ClrDmaInt()						*/
	/*==========================================*/
	Sddr_ClrDmaInt(p_SddHandle);	/* pgr0024 */

	/* DMA~㏈ǉ 2006/07/03 H.Miura */
	w_ResTmp = Sdds_StopSdma_after(p_SddHandle, &w_DmaErr);
	if(w_ResTmp != SDD_SUCCESS){
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}
	return	w_Result;
}
#endif /* !defined(_SDD_MN6682X_) && !defined(_SDD_4M_ANDROID_) */

#ifdef _SDD_READ_ZERO_PADDING_
/********************************************************************************/
/*  ֐		FSdds_StartPaddingSdma											*/
/*  Tv		FStream DMAC&SDI/F DMA̓]ݒ								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F]TCYioCgj											*/
/*				F]X^[gAhX										*/
/*				F]X^[gAhX										*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
SDD_ERROR Sdds_StartPaddingSdma(SDD_HANDLE *p_SddHandle, UW uw_SendByte, UW uw_SrcAd, UW uw_DstAd)
{
	SDD_ERROR w_Result = SDD_SUCCESS;

	w_Result = Sdds_StartSdma_before(p_SddHandle, uw_DstAd, uw_SrcAd);
	if(w_Result != SDD_SUCCESS){
		return w_Result;
	}
	
	w_Result = Sddr_SetDma(p_SddHandle, uw_DstAd, uw_SendByte, SDD_DMA_READ);
	if(w_Result != SDD_SUCCESS){
		w_Result = Sdds_EndSdma(p_SddHandle);		/* SDMACN[YASDRAM̃foCXnh */
	}
	
	return w_Result;
}
#endif

#if !defined(_SDD_4M_ANDROID_)
/********************************************************************************/
/*  ֐		FSdds_DMATransfer											    */
/*  Tv		FDMA]{								                */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.12.14												    */
/********************************************************************************/
SDD_ERROR Sdds_DMATransfer(SDD_HANDLE *p_SddHandle, SDD_COMMAND_DATA *pscdData) {
#ifdef _SDD_DMA_TRANSFER_AFTER_COMMAND_
    SDD_ERROR w_ResTmp = SDD_SUCCESS; /* ߂lꎞi[p */
     /* M */
     if (pscdData->uh_Type & SDD_COMMAND_TYPE_WRITE) {
         /* Write] */
         w_ResTmp = Sdds_StartSdma(p_SddHandle, pscdData->uw_SendSec, (UW)(pscdData->pub_Buff), SDD_DMA_WRITE);
     }
     else {
         /* Read] */
         w_ResTmp = Sdds_StartSdma(p_SddHandle, pscdData->uw_SendSec, (UW)(pscdData->pub_Buff), SDD_DMA_READ);
     }
    if (w_ResTmp != SDD_SUCCESS) {
        /* G[{ */
        return w_ResTmp;
    }
#endif /* _SDD_DMA_TRANSFER_AFTER_COMMAND_ */
     return Sdds_WaitTransEnd(p_SddHandle, pscdData->uw_AEndTimeOut, TRUE);
}
#endif /*!defined(_SDD_4M_ANDROID_) */

