/********************************************************************************/
/*  t@C    F$Workfile: SddDriverLib.c $                                 */
/*  Tv          FSDfoCXhCoʃCut@C                    */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 06/06/12 13:30 $                                  */
/*                  䉉ZOǉ 2006/07/03 H.Miura                   */
/*                  ݒ菈ǉ 2006/07/03 H.Miura                     */
/*                  O[oϐǉ 2006/07/03 H.Miura           */
/********************************************************************************/
/* wb_[t@C */
#include "SddCom.h"
#include "SddRegister.h"
#include "SddOsEvent.h"
#include "SddOsIntr.h"
#include "SddError.h"
#include "SddSecure.h"
#include "SddOsTimer.h"
#include "SddCardInOut.h"
#include "SddOsSemaphore.h"
#include "SddOsEvent.h"
#include "SddRegister_dma.h"

/* e[u */
static UW Sdd_TransTimeVal[] = {
	SDD_TIMEVAL_10,
	SDD_TIMEVAL_12,
	SDD_TIMEVAL_13,
	SDD_TIMEVAL_15,
	SDD_TIMEVAL_20,
	SDD_TIMEVAL_25,
	SDD_TIMEVAL_30,
	SDD_TIMEVAL_35,
	SDD_TIMEVAL_40,
	SDD_TIMEVAL_45,
	SDD_TIMEVAL_50,
	SDD_TIMEVAL_55,
	SDD_TIMEVAL_60,
	SDD_TIMEVAL_70,
	SDD_TIMEVAL_80
};

/* e[u */
static UW Sdd_TransTransSpeed[] = {
	SDD_TRANSSPEED_100K,
	SDD_TRANSSPEED_1M,
	SDD_TRANSSPEED_10M,
	SDD_TRANSSPEED_100M
};

static void Sdds_NormalSizeCalc( SDD_HANDLE *p_SddHandle );
static void Sdds_SecureSizeCalc( SDD_HANDLE *p_SddHandle );

#if defined(_SDD_SUPPORT_1MBPS_)
UW Sdds_EraseTimeoutCulc(UW uw_SecCnt);
#endif

/* Tu֐t@C */
#if defined(_SDD_JUPITER_)
#include "device/SddDriverLib_for_jupiter.c"
#endif /* defined(_SDD_JUPITER_) */

#if defined(_SDD_UNIPHIER_2P_)
#include "device/SddDriverLib_for_uniphier2p.c"
#endif /* defined(_SDD_UNIPHIER_2P_) */

#if defined(_SDD_UNIPHIER_XP_)
#include "device/SddDriverLib_for_uniphierxp.c"
#endif /* defined(_SDD_UNIPHIER_XP_) */

#if defined(_SDD_MN6682X_)
#include "device/SddDriverLib_for_mn6682x.c"
#endif /* defined(_SDD_MN6682X_) */

#if defined(_SDD_MN66822_)
#include "device/SddDriverLib_for_mn66822.c"
#endif /* defined(_SDD_MN66822_) */

#if defined(_SDD_MN66826_)
#include "device/SddDriverLib_for_mn66826.c"
#endif /* defined(_SDD_MN66826_) */

#if defined(_SDD_USE_SDMACLIB_)
#include "device/SddDriverLib_for_sdmaclib.c"
#endif /* defined(_SDD_USE_SDMACLIB_) */

#if defined(_SDD_PEAKS_PRO2_)
#include "device/SddDriverLib_for_PeaksPro2.c"
#endif /* defined(_SDD_PEAKS_PRO2_) */

#if defined(_SDD_PCAM_)
#include "device/SddDriverLib_for_pcam.c"
#endif /* defined(_SDD_PCAM_) */

#if defined(_SDD_4M_ANDROID_)
#include "device/SddDriverLib_for_4mAndroid.c"
#endif /* defined(_SDD_4M_ANDROID_) */

#if defined(_SDD_MN66830_)
#include "device/SddDriverLib_for_mn66830.c"
#endif /* defined(_SDD_MN66830_) */

static SDD_ERROR Sdds_CardInitchecksub( SDD_HANDLE *p_SddHandle );

#ifndef _SDD_USE_SDMACLIB_
/********************************************************************************/
/*  ֐		FSdds_InitDataNonCbf_after										*/
/*  Tv		FO[oϐ㏈					            */
/*  		FȂ									                        */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
#define Sdds_InitDataNonCbf_after() {\
    /* Ȃ */\
}
#endif /* _SDD_USE_SDMACLIB_ */

#if defined(_SDD_FUNC_SECURE_)
#include "SddDriverLib_secure.c"
#endif /* defined(_SDD_FUNC_SECURE_) */



/********************************************************************************/
/*  ֐		FSddr_CardDataInit												*/
/*  Tv		FSDDD̕ێJ[hf[^̏							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.6													    */
/********************************************************************************/
void Sddr_CardDataInit(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uw_x;
	
	/*  ێ\(SDD_DEV)̓J[ĥݏ		*/ 
	Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_INITFLG);
	p_sdd->ub_CardType = (UB)SDD_CARD_TYPE_NOCARD;
	p_sdd->uw_CardFunc = SDD_CARD_FUNC_NO_FUNC;
#ifndef _SDD_RW_WAIT_
	p_sdd->uw_CardInfo = (UW)0;
#endif /* _SDD_RW_WAIT_ */
	p_sdd->uw_CardSize =  (UW)0;
	p_sdd->uw_NormalSize = (UW)0;
	p_sdd->uw_SecureSize = (UW)0;
	p_sdd->uw_SectorSize = (UW)0;
	p_sdd->uw_Wp = (UW)0;
	p_sdd->uw_EraseByteMin = (UW)0;
	p_sdd->uh_Rca = (UH)0x0000;		/* J[h̍ŏCMD55ŎgpRCAl(0x0000)ݒ */
	for(uw_x = 0; uw_x < SDD_OCR_SIZE; uw_x++){
		p_sdd->ub_Ocr[uw_x] = 0;
	}
	for(uw_x = 0; uw_x < SDD_CID_SIZE; uw_x++){
		p_sdd->ub_Cid[uw_x] = 0;
	}
	for(uw_x = 0; uw_x < SDD_CSD_SIZE; uw_x++){
		p_sdd->ub_Csd[uw_x] = 0;
	}
	for(uw_x = 0; uw_x < SDD_SCR_SIZE; uw_x++){
		p_sdd->ub_Scr[uw_x] = 0;
	}
	for(uw_x = 0; uw_x < SDD_SDSTATUS_SIZE; uw_x++){
		p_sdd->ub_SdStatus[uw_x] = 0;
	}
	p_sdd->uw_CardStatus = (UW)0;    
/*** SDKiVer2.0ΉJnA2005.12.14 ***/
	p_sdd->v20.uh_PhyVer = (UH)0;		/* SDJ[hKiVersionԍΉFMBF1-ʃJ[h,2-HCJ[hGLBF1-Ver1.x,2-Ver2.x */
	p_sdd->v20.ub_Lock = 0;				/* SDJ[hLock */
	p_sdd->v20.ub_Class = 0;			/* Sppeed Class */
	p_sdd->v20.ub_Perfm = 0;			/* MOVE Performance */
	p_sdd->v20.ub_Au = 0;				/* AU Size */
	p_sdd->v20.ub_ErTm = 0;				/* Erase TimeOut	*/
	p_sdd->v20.ub_ErOffset = 0;			/* Erase Time Offset*/
	p_sdd->v20.uh_ErSize = (UH)0;;		/* Erase Size by AU */
	p_sdd->v20.ub_PhyExt = 0;			/* SDKig */
	p_sdd->v20.ub_para2 = 0;			/* Reserved */
/*** SDKiVer2.0ΉENDA2005.12.14 ***/
#ifdef _SDD_ALLOW_MMC_
	p_sdd->MmcInfo.ub_Spec = 0;
	p_sdd->MmcInfo.ub_HcFlag = 0;
	p_sdd->MmcInfo.uh_Func = 0;
	p_sdd->MmcInfo.uh_SetFunc = 0;
	p_sdd->MmcInfo.ub_PowerClass = 0;
	p_sdd->MmcInfo.ub_DeviceType = 0;
	p_sdd->MmcInfo.uw_EraseUnitSize = 0;
	p_sdd->MmcInfo.uw_EraseTimeout = 0;
	for(uw_x = 0; uw_x < SDD_MMC_EXTCSD_SIZE; uw_x++){
		p_sdd->MmcInfo.ub_ExtCsd[uw_x] = 0;
	}
#endif /* _SDD_ALLOW_MMC_ */

    p_sdd->uw_OperationMode = SDD_CARD_INIT_MODE_MEMORY;  /* [hŏ */
	p_sdd->uh_CardType2 = 0;		/* J[h^CvgȂɐݒ */

	Sdds_ErrInfoClear(p_SddHandle); /* G[̃NA */

#ifdef _SDD_SDCARDINOUT_KENSHO_
/* P̃eXg11.D.7Sdds_CardInitňꎞ~ݒlNA邽ߍ폜B
   AT-EnginenȊOŉe邩Ȃ̂ŁA_SDD_T_ENGINE_̏ꍇ̂
   ƂĂB */
#ifndef _SDD_T_ENGINE_
    p_sdd->Sdd_Cardinout_Kensho_Wait_Switch = FALSE;
    p_sdd->Sdd_Cardinout_Kensho_Wait_Position = WAIT_NOT;
#endif
#endif /*  _SDD_SDCARDINOUT_KENSHO_ */
	return;
}


/********************************************************************************/
/*  ֐		FSdds_ErrInfoClear												*/
/*  Tv		FSDDD̕ێG[̃NA								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.6													    */
/********************************************************************************/
void Sdds_ErrInfoClear(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
	p_sdd->ErrInfo.ub_ErrProcess = 0;
	p_sdd->ErrInfo.ub_ErrRank = 0;
	p_sdd->ErrInfo.uw_ReqOffset = 0;
	p_sdd->ErrInfo.uw_ReqSize = 0;
	p_sdd->ErrInfo.uw_ErrOffset = 0;
	p_sdd->ErrInfo.uw_ErrSize = 0;
	p_sdd->ErrInfo.bl_ErrChk = FALSE;
	p_sdd->ErrInfo.bl_PadMode = FALSE;
	p_sdd->ErrInfo.pub_PadBuf = NULL;
	return;
}

#ifndef _SDD_FUNC_SECURE_
/********************************************************************************/
/*  ֐		FCheckAndSetArgPointer											*/
/*  Tv		F֐e[uɐݒ肷̐ݒ								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH uh_Cmd														*/
/*  			FUW *puw_Arg1													*/
/*  			FUW *puw_Arg2													*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR CheckAndSetArgPointer(SDD_HANDLE *p_SddHandle, UH uh_Cmd, UW *puw_Arg1, void *pv_Arg2)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	switch(uh_Cmd){
		/* NULL`FbN&Resultݒ */
		case SDD_IOC_ERASE:
		case SDD_IOC_READ:
		case SDD_IOC_WRITE:
#ifdef _SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_READ:
		case SDD_IOC_USB_WRITE:
		case SDD_IOC_USB_GET_MKB:
		case SDD_IOC_USB_SECURE_READ:
		case SDD_IOC_USB_SECURE_WRITE:
#endif /* _SDD_SDUSB_TRANSFER_ */
			if(pv_Arg2 == NULL){
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
				p_sdd->Result.w_Result = w_Result;
			}
			*puw_Arg1 = (UW)pv_Arg2;
			break;
		case SDD_IOC_INIT:
		case SDD_IOC_SET_RING_BUFF:
		case SDD_IOC_SET_EVENT_CBF:
		case SDD_IOC_VERSION:
		case SDD_IOC_GET_CARD_TYPE:
		case SDD_IOC_GET_SECTOR_SIZE:
		case SDD_IOC_GET_CARD_CAPACITY:
		case SDD_IOC_GET_AREA_SIZE:
		case SDD_IOC_CHECK_WP:
		case SDD_IOC_GET_CARD_INFO:
		case SDD_IOC_GET_STATUS:
		case SDD_IOC_GET_CARD_STATUS:
		case SDD_IOC_GET_SD_STATUS:
		case SDD_IOC_GET_RESULT:
#ifdef	_SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_HST_GET:
		case SDD_IOC_USB_HST_SET:
#endif /* _SDD_SDUSB_TRANSFER_ */
#ifdef _SDD_RW_WAIT_
		case SDD_IOC_SET_RW_WAIT:
#endif
#ifdef _SDD_ALLOW_MMC_
		case SDD_IOC_GET_EXT_CSD:
#endif /* _SDD_ALLOW_MMC_ */
#ifdef _SDD_FUNC_SDIO_
        case SDD_IOC_SETIO_READ_DIRECT:
        case SDD_IOC_SETIO_WRITE_DIRECT:
        case SDD_IOC_SETIO_READ_EXTENDED:
        case SDD_IOC_SETIO_WRITE_EXTENDED:
#endif
		case SDD_IOC_GET_ERRINFO:
		case SDD_IOC_SEND_SMART:
		case SDD_IOC_SEND_COMMAND:
        case SDD_IOC_GET_RCA:
        case SDD_IOC_GET_SCR:
		/* NULL`FbN */
			if(pv_Arg2 == NULL){
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
			}
			*puw_Arg1 = (UW)pv_Arg2;
			break;
		default:
		/* NULL`FbNȂ */
			break;
		}

	return	w_Result;
}
#endif /* _SDD_FUNC_SECURE_ */

#ifndef _SDD_FUNC_SECURE_
/********************************************************************************/
/*  ֐		FSdds_CardInitcheck											*/
/*  Tv		FJ[h`FbN											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH uh_Cmd														*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_CardInitcheck( SDD_HANDLE *p_SddHandle, UH uh_Cmd )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	switch(uh_Cmd){
		/* J[hσ`FbN&Resultݒ */
		case SDD_IOC_ERASE:
		case SDD_IOC_READ:
		case SDD_IOC_WRITE:
#ifdef _SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_READ:
		case SDD_IOC_USB_WRITE:
		case SDD_IOC_USB_GET_MKB:
		case SDD_IOC_USB_SECURE_READ:
		case SDD_IOC_USB_SECURE_WRITE:
#endif /* _SDD_SDUSB_TRANSFER_ */
				/*==============================================================*/
				/* Sdds_CardInitcheck𔭍s									*/
				/* J[hL̃`FbNAJ[hς݃`FbN				*/
				/*==============================================================*/
				w_ResTmp = Sdds_CardInitchecksub(p_SddHandle);
				if(w_ResTmp != SDD_SUCCESS){
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
					p_sdd->Result.w_Result = w_Result;
				}
				break;
		case SDD_IOC_GET_SECTOR_SIZE:
		case SDD_IOC_GET_CARD_CAPACITY:
		case SDD_IOC_GET_AREA_SIZE:
		case SDD_IOC_CHECK_WP:
		case SDD_IOC_GET_CARD_INFO:
		case SDD_IOC_GET_CARD_STATUS:
		case SDD_IOC_GET_SD_STATUS:
#ifdef _SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_HST_GET:
		case SDD_IOC_USB_HST_SET:
		case SDD_IOC_USB_SET_SECURE_AREA_SIZE:
#endif /* _SDD_SDUSB_TRANSFER_ */
#ifdef _SDD_ALLOW_MMC_
		case SDD_IOC_GET_EXT_CSD:
#endif /* _SDD_ALLOW_MMC_ */
		case SDD_IOC_SET_CARDFUNC:
		case SDD_IOC_SPEEDCLASS_RECORDING:
		case SDD_IOC_SEND_SMART:
        case SDD_IOC_GET_RCA:
        case SDD_IOC_GET_SCR:
				/*==============================================================*/
				/* Sdds_CardInitcheck𔭍s									*/
				/* J[hL̃`FbNAJ[hς݃`FbN				*/
				/*==============================================================*/
				w_ResTmp = Sdds_CardInitchecksub(p_SddHandle);
				if(w_ResTmp != SDD_SUCCESS){
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				}
				break;
		default:
				/* J[hL`FbN/ς݂ȂR}h */
				break;
	}

	return w_Result;
}
#endif /* _SDD_FUNC_SECURE_ */

/********************************************************************************/
/*  ֐		FSdds_CardInitchecksub											*/
/*  Tv		FJ[h`FbN											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sdds_CardInitchecksub( SDD_HANDLE *p_SddHandle )
{
	UB	ub_CardInOut;
	SDD_ERROR w_ret = SDD_SUCCESS;

	Sdds_StopCDDetect(p_SddHandle);
	/*==================================================================*/
	/* J[h̗L`FbN												*/
	/*	1)J[hL̏ꍇAp									*/
	/*	2)ȊȌꍇAG[									*/
	/*		Sdds_SetErr𔭍s(SDD_ERR_NO_CARD)							*/
	/*==================================================================*/
	Sddr_DetectCard( p_SddHandle, &ub_CardInOut ); /* J[hL`FbN */
	if ( ub_CardInOut == SDD_CARDOUT) {
		w_ret = SDD_ERR_NO_CARD;
		Sdds_StartCDDetect(p_SddHandle);
		return w_ret;
	}

	/*==================================================================*/
	/* J[hς݃tO(SddDev[port].uh_Status)̃`FbN			*/
	/*	1)ς(0x80)̏ꍇAp									*/
	/*	2)ȊȌꍇAG[									*/
	/*		Sdds_SetErr𔭍s(SDD_ERR_NOT_CARD_INIT)					*/
	/*==================================================================*/
	if(!(Sdds_GetStatus(p_SddHandle) & SDD_STATUS_INITFLG)){
		w_ret = SDD_ERR_NOT_CARD_INIT;
		Sdds_StartCDDetect(p_SddHandle);
		return w_ret;
	}
	Sdds_StartCDDetect(p_SddHandle);

	return SDD_SUCCESS;
}

#ifndef _SDD_FUNC_SECURE_
/********************************************************************************/
/*  ֐		FSdds_ChangeState												*/
/*  Tv		FIOCTLԑJ													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH uh_Cmd														*/
/*				FUW uw_tmpDevID ANZẌfoCXID							*/
/*  			FBOOL b_Direction TRUE:OPENxxx/FALSE:xxxOPEN				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_ChangeState( SDD_HANDLE *p_SddHandle, UH uh_Cmd, UW uw_tmpDevID, BOOL bl_Direction )
{
	SDD_ERROR w_Result = SDD_SUCCESS;

	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */

	switch(uh_Cmd){
#ifdef _SDD_SDUSB_TRANSFER_
		case SDD_IOC_CANCEL:
			if(bl_Direction == FALSE){
				/*==============================================*/
				/* ԑJځiUSB R/WOPENj					*/
				/*	SddDev[port].uh_Status &= ~SDD_STATUS_USB_RW*/
				/*	SddDev[port].uh_Status |= SDD_STATUS_OPEN	*/
				/*==============================================*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_USB_RW);
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_OPEN);
			}
			break;

		case SDD_IOC_USB_READ:
		case SDD_IOC_USB_WRITE:
		case SDD_IOC_USB_GET_MKB:
		case SDD_IOC_USB_SECURE_READ:
		case SDD_IOC_USB_SECURE_WRITE:
			if(bl_Direction == TRUE){
				/*======================================*/
				/* ԑJځiOPENUSB_RWj		        */
				/*	SddDev[port].ub_Status &= ~0x01	    */
				/*	SddDev[port].ub_Status |= USB_RW	*/
				/*======================================*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_OPEN);
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_USB_RW);
			}
			/* USB_RW̃G[̏ꍇSdd_Ioctl֐Ōɖ߂ */
			/* SDD_STATUS_USB_RWɂǂ̂SDD_IOC_GET_RESULTSDD_IOC_CANCEL */
			break;
#endif /* _SDD_SDUSB_TRANSFER_ */
		case SDD_IOC_READ:
			if(bl_Direction == TRUE){
				/*==========================================*/
				/* ԑJځiOPENIOCTLj				    */
				/*	SddDev[port].ub_Status &= ~0x01			*/
				/*	SddDev[port].ub_Status |= IOCTL | READ	*/
				/*==========================================*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_OPEN);
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | (SDD_STATUS_IOCTL | SDD_STATUS_READ));
			}
			else{
				/*=======================================*/
				/* ԑJ 	IOCTL->OPEN		 		 */
				/*=======================================*/
				/* OPENԂ֑J
					SddDev[port].uh_Status = OPEN
				*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~(SDD_STATUS_IOCTL | SDD_STATUS_READ));
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_OPEN);
			}
			break;

		case SDD_IOC_WRITE:
			if(bl_Direction == TRUE){
				/*==========================================*/
				/* ԑJځiOPENIOCTLj				    */
				/*	SddDev[port].ub_Status &= ~0x01		    */
				/*	SddDev[port].ub_Status |= IOCTL | WRITE	*/
				/*==========================================*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) &  ~SDD_STATUS_OPEN);
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | (SDD_STATUS_IOCTL | SDD_STATUS_WRITE));
			}
			else{
				/*====================================*/
				/* ԑJ		IOCTL->OPEN			  */
				/*====================================*/
				/* OPENԂ֑J
					SddDev[port].uh_Status = OPEN
				*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~(SDD_STATUS_IOCTL | SDD_STATUS_WRITE));
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_OPEN);
			}
			break;
			default:
				if(bl_Direction == TRUE){
					if( uw_tmpDevID == SDD_DEVICEID_NORMAL ){
						/*==============================================*/
						/* ԑJځiOPENIOCTLj				    	*/
						/*	SddDev[port].uh_Status &= ~SDD_STATUS_OPEN	*/
						/*	SddDev[port].uh_Status |= SDD_STATUS_IOCTL  */
						/*==============================================*/
						Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_OPEN);
						Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_IOCTL);
					}
				}
				else{
					if( uw_tmpDevID == SDD_DEVICEID_NORMAL ){
						/*==============================================*/
						/* ԑJځiIOCTLOPENj					    */
						/*	SddDev[port].uh_Status &= 	SDD_STATUS_IOCTL*/
						/* GET_RESULT̏ꍇ							    */
						/*	ԑJځiUSB_R/W or IOCTL->OPENj 		    */
						/*	SddDev[port].uh_Status |= 	SDD_STATUS_OPEN	*/
						/*==============================================*/
						if ( uh_Cmd == SDD_IOC_GET_RESULT){	/* SDD_IOC_GET_RESULT̏ꍇ */
							Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~(SDD_STATUS_IOCTL | SDD_STATUS_USB_RW));
						}
						else {	/* ׂẴR}h */
							Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_IOCTL);
						}
						Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_OPEN);
					}
				}
				break;
	}
	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */

	return w_Result;
}
#endif /* _SDD_FUNC_SECURE_ */

/********************************************************************************/
/*  ֐		FSdds_GetCsdTransSpeed											*/
/*  Tv		FCSDTransSpeed߂										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sdds_GetCsdTransSpeed(SDD_HANDLE *p_SddHandle, UW *puw_TransMax)
{
	UB ub_TransTime;
	UB ub_TransSpeed;
	UW uw_TimeVal = 0;
	UW uw_TransSpeed = 0;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

#ifdef _SDD_ALLOW_MMC_
	if (p_sdd->MmcInfo.uh_SetFunc & SDD_MMC_FUNC_HS_52MHZ){		/* nCXs[h[h52MHzΉMMC̏ꍇ */
		*puw_TransMax = SDD_MMC_CLK_52MHZ;
	}
	else if (p_sdd->MmcInfo.uh_SetFunc & SDD_MMC_FUNC_HS_26MHZ) {	/* nCXs[h[h26MHzΉMMC̏ꍇ */
		*puw_TransMax = SDD_MMC_CLK_26MHZ;
	}
	else {	/* LȊOSD/MMC̏ꍇ */
		ub_TransSpeed = (UB)(p_sdd->ub_Csd[12] & SDD_CSD_TRANS_SPEED);
		ub_TransTime = (UB)((p_sdd->ub_Csd[12] >> 3) & SDD_CSD_TRANS_TIME);

		uw_TimeVal = Sdd_TransTimeVal[!ub_TransTime ? 0 : ub_TransTime - 1]; /* Klocwork΍ */
		uw_TransSpeed = Sdd_TransTransSpeed[ub_TransSpeed];

		*puw_TransMax = (UW)((uw_TimeVal * uw_TransSpeed) / 10);	/*  CSD̍ō(KHz)(Pʂ킹1/10ɂĂj */
	}
#else
	ub_TransSpeed = (UB)(p_sdd->ub_Csd[12] & SDD_CSD_TRANS_SPEED);
	ub_TransTime = (UB)((p_sdd->ub_Csd[12] >> 3) & SDD_CSD_TRANS_TIME);

	uw_TimeVal = Sdd_TransTimeVal[!ub_TransTime ? 0 : ub_TransTime - 1]; /* Klocwork΍ */
	uw_TransSpeed = Sdd_TransTransSpeed[ub_TransSpeed];

	*puw_TransMax = (UW)((uw_TimeVal * uw_TransSpeed) / 10);	/*  CSD̍ō(KHz)(Pʂ킹1/10ɂĂj */
#endif /* _SDD_ALLOW_MMC_ */
}

/********************************************************************************/
/*  ֐		FSdds_GetWP													*/
/*  Tv		FCgveNg擾											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Check(`FbNΏWP)									*/
/*  			FBOOL bl_Stop(WP΂ŏI)							*/
/*  			FUW uw_WP(`FbNWP)										*/
/*  ߂l		FȂ															*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sdds_GetWP(SDD_HANDLE *p_SddHandle, UW uw_Check, BOOL bl_Stop, UW * puw_WP)
{
	UB	ub_MechanicalWP;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_GETWP );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

	/* 擾l̃NA */ /*(擾̍ہAׂ|= Ă̂ōŏɃNAKvj*/
	(*puw_WP) = 0;

	/*	ȉMechanicalWP`FbNȊO
		WP`FbN͑SSDD_DEV.WPł悢 */

	/*================================*/
	/* J[hWP`FbN(SD_INFO1) */
	/*================================*/
	/*
	J[hWPoΏ۔
		1) ΏۂȂ΃J[hWP֐(Sddr_GetMecanicalWP)jump
		CgveNg && CgveNgIwȂ珈I
	*/
#ifndef _SDD_NO_WPCHECK_
	if(uw_Check & SDD_WP_MECHANICAL) {
		Sddr_GetMechanicalWP(p_SddHandle, &ub_MechanicalWP);			/* J[hWP֐ */
		if(ub_MechanicalWP == SDD_MECHANICALWP_ON) {	/* CgveNg */
			(*puw_WP) |= SDD_WP_MECHANICAL;				/* J[hWPveNgݒ*/
			p_sdd->uw_Wp |= SDD_WP_MECHANICAL;			/* ۑ */
			if(bl_Stop) {
				return;
			}
		}
		else {
			p_sdd->uw_Wp &= ~SDD_WP_MECHANICAL;			/* ۑ */
		}
	}
#endif
    
	/*==============================*/
	/*	J[hWPȊÕ`FbN	*/
	/*	SSDD_DEV.WP擾		*/
	/*==============================*/
	if ( p_sdd->uw_Wp & uw_Check ){					/* 擾ΏۗL */
		(*puw_WP) |= ( p_sdd->uw_Wp & uw_Check );	/* veNgݒ */
		if(bl_Stop) {
			return;
		}
	}
	/*===================*/
	/* ROMJ[h`FbN */
	/*===================*/
	/*
	ROMJ[hoΏ۔
		1) ΏۂȂROMJ[h(p_sdd->ub_CardType)
		CgveNg && CgveNgIwȂ珈I
	*/

	/*=====================================================================*/
	/* CSDCCC(Card Command Class)ɂClass4  (block write)T|[g */
	/*=====================================================================*/
	/*
	CSDCCC(Card Command Class)ɂClass4  (block write)T|[goΏ۔
		1) ΏۂȂCSD(p_sdd->ub_Csd)
		CgveNg && CgveNgIwȂ珈I
	*/
	
	/*======================================================================*/
	/* CSDCCC(Card Command Class)ɂClass5 (erase)T|[g`FbN */
	/*======================================================================*/
	/*
	CSDCCC(Card Command Class)ɂClass5 (erase)T|[goΏ۔
		1) ΏۂȂCSD(p_sdd->ub_Csd)
		CgveNg && CgveNgIwȂ珈I
	*/

	/*=================================*/
	/* CSDPERM_WRITE_PROTECT`FbN */
	/*=================================*/
	/*
	CSDPERM_WRITE_PROTECToΏ۔
		1) ΏۂȂCSD(p_sdd->ub_Csd)
		CgveNg && CgveNgIwȂ珈I
	*/

	/*================================*/
	/* CSDTMP_WRITE_PROTECT`FbN */
	/*================================*/
	/*
	CSDTMP_WRITE_PROTECToΏ۔
		1) ΏۂȂCSD(p_sdd->ub_Csd)
		CgveNg && CgveNgIwȂ珈I
	*/

	return;
}

#ifndef _SDD_FUNC_SECURE_
/********************************************************************************/
/*  ֐		FSdds_InitData													*/
/*  Tv		FhCoO[oϐ								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
void Sdds_InitData(SDD_HANDLE *p_SddHandle)
{
    /* O[oϐǉ 2006/07/03 H.Miura */
    Sdds_InitData_init(p_SddHandle);

#ifdef _SDD_FUNC_QUICK_BOOT_
	p_sdd->ub_Cmd8Info = 0;
	p_sdd->ub_StartCardInit = 0;
#endif /* _SDD_FUNC_QUICK_BOOT_ */

	/* R[obNȊÕf[^ */
	Sdds_InitDataNonCbf(p_SddHandle);

	/* R[obÑf[^ */
	Sdds_ClrCbfAll(p_SddHandle);

#if defined(_SDD_PADDING_DMA_) && defined(_SDD_UNIPHIER_XP_)
	Sdd_memcpy(p_SddHandle, gpub_PadBuf, gub_PadBuf, SDD_SECTOR_SIZE);
#endif

	return;
}
#endif /* _SDD_FUNC_SECURE_ */


#ifndef _SDD_FUNC_SECURE_
/********************************************************************************/
/*  ֐		FSdds_InitDataNonCbf											*/
/*  Tv		FhCoO[oϐ(ԁAR[obN֐ȊO)	*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.06													    */
/********************************************************************************/
void Sdds_InitDataNonCbf( SDD_HANDLE *p_SddHandle )
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/* J[h̏ */
	Sddr_CardDataInit(p_SddHandle);
	
	/*  ێ\(SDD_DEV)̏		*/ 
	p_sdd->ub_Preflg = 0;
	p_sdd->uw_UsbRwSector = (UW)0;
	p_sdd->Result.uw_Resid = (UW)0;
	p_sdd->Result.w_Result = (SDD_ERROR)0;
	p_sdd->Result.uh_Flag = (UH)0;
	p_sdd->RingBuffer.uw_OnOffFlg = 0x00000000;
	p_sdd->RingBuffer.uw_BuffStart = 0x00000000;
	p_sdd->RingBuffer.uw_BuffEnd = 0x00000000;
	p_sdd->DmaInfo.uw_DMASrcAddr = (UW)0;
	p_sdd->DmaInfo.uw_DMADstAddr = (UW)0;
	p_sdd->DmaInfo.uw_DMASize = (UW)0;
	p_sdd->DmaInfo.uw_RestSec = (UW)0;
	p_sdd->w_error = (W)0;
	p_sdd->uw_Offset = (UW)0;
	p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
	p_sdd->uw_ReadWait = (UW)0;
	p_sdd->uw_WriteWait = (UW)0;
	p_sdd->uw_ClkDiv = SDD_CLOCK_DIV_128;

	/* |[gʂ̐ݒ */
	if(Sdd_M_GetPortNum(p_SddHandle->ub_Port) == 0) {
		/* |[gԍ0̐ݒ */
#if !defined(_SDD_JUPITER_)
		p_sdd->uw_Imclk = SDD_IMCLK_PORT0;					/* MCLKݒ */
#endif /* !defined(_SDD_JUPITER_) */
#if defined(_SDD_HIGHSPEEDCLK_)
		p_sdd->ub_HighspeedInfo = SDD_HIGHSPEEDCLK_PORT0;	/* SDJ[h/MMCΉݒ */
#endif /* _SDD_HIGHSPEEDCLK_ */
#if defined(_SDD_ALLOW_UHS1_)
		p_sdd->ub_UHS1Info = SDD_ALLOW_UHS1_PORT0;			/* UHS-IJ[hΉݒ */
#endif /* _SDD_ALLOW_UHS1_ */
	} else {
		/* |[gԍ1̐ݒ */
#if !defined(_SDD_JUPITER_)
		p_sdd->uw_Imclk = SDD_IMCLK_PORT1;					/* MCLKݒ */
#endif /* !defined(_SDD_JUPITER_) */
#if defined(_SDD_HIGHSPEEDCLK_)
		p_sdd->ub_HighspeedInfo = SDD_HIGHSPEEDCLK_PORT1;	/* SDJ[h/MMCΉݒ */
#endif /* _SDD_HIGHSPEEDCLK_ */
#if defined(_SDD_ALLOW_UHS1_)
		p_sdd->ub_UHS1Info = SDD_ALLOW_UHS1_PORT1;			/* UHS-IJ[hΉݒ */
#endif /* _SDD_ALLOW_UHS1_ */
	}

    /* O[oϐ㏈ǉ H.Miura 2007.02.05 */
    Sdds_InitDataNonCbf_after();

	return;
}
#endif /* _SDD_FUNC_SECURE_ */
	
/********************************************************************************/
/*  ֐		FSdds_SdcardSizeCalc											*/
/*  Tv		FARG NULL`FbN												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
void Sdds_SdcardSizeCalc(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
	/* ʏ̈TCY̌vZ */
	Sdds_NormalSizeCalc(p_SddHandle);
	
	/* Fؗ̈TCY̌vZ */
	Sdds_SecureSizeCalc(p_SddHandle);
	/* S̈TCY̌vZ */
	p_sdd->uw_CardSize = p_sdd->uw_NormalSize + p_sdd->uw_SecureSize;
	return;
}

/********************************************************************************/
/*  ֐		FSdds_NormalSizeCalc											*/
/*  Tv		Fʏ̈TCY̌vZ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static void Sdds_NormalSizeCalc( SDD_HANDLE *p_SddHandle )
{
	UW uw_Size = 0;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
	/* ʏ̈TCY̌vZ(SDJ[hAMMC̏ꍇ̂) */
	if( ((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) & (UB)SDD_CARD_TYPE_SD) ||
		((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC) ){
		if( ((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC) ||
			((p_sdd->ub_Csd[15] & SDD_CSD_STRUCTURE_MASK) == SDD_CSD_STRUCTURE_V10) ){
			/* MMC܂CSD Ver.1.0̏ꍇimemory capacity = BLOCKNR * BLOCK_LEN, BLOCKNR = (C_SIZE+1) * MULTj */
			/* CSDSD BufferɊi[ꂽƂCRC1Byte  */
			uw_Size = (((UW)(p_sdd->ub_Csd[9] & SDD_CSD_C_SIZE_BIT_73_72) << 10 )
						| ((UW)(p_sdd->ub_Csd[8] & SDD_CSD_C_SIZE_BIT_71_64) << 2 )
						| ((UW)(p_sdd->ub_Csd[7] & SDD_CSD_C_SIZE_BIT_63_62) >> 6 )) + 1;		/* C_SIZE + 1 */
			uw_Size *= (UW)(4 << (((p_sdd->ub_Csd[6] & SDD_CSD_C_SIZE_MULTI_BIT_49_48) << 1 )
						| ((p_sdd->ub_Csd[5] & SDD_CSD_C_SIZE_MULTI_BIT_47_47) >> 7 )));	/* MULT */
			uw_Size *= ( (1 << (p_sdd->ub_Csd[10] & SDD_CSD_READ_BL_LEN_BIT_83_80)) / p_sdd->uw_SectorSize );	/* BLOCK_LEN */
		}else{
			/* CSD Ver2.0̏ꍇimemory capacity = (C_SIZE+1) * 512K bytej */
			uw_Size = (((UW)(p_sdd->ub_Csd[8] & 0x3F) << 16) | ((UW)p_sdd->ub_Csd[7] << 8) | ((UW)p_sdd->ub_Csd[6]) ) + 1;	/* C_SIZE+1 */
			if( uw_Size > 0x003FFFFF ){
				uw_Size = 0xFFFFFFFF;
			}else{
				uw_Size *= (512 * 1024 / p_sdd->uw_SectorSize);
			}
		}
	}

#ifdef _SDD_ALLOW_MMC_
	/* MMC-HCJ[h̏ꍇEXT-CSDeʎZo */
	if (p_sdd->MmcInfo.ub_HcFlag == SDD_MMC_HC){
		uw_Size = ((UW)p_sdd->MmcInfo.ub_ExtCsd[215] << 24) | ((UW)p_sdd->MmcInfo.ub_ExtCsd[214] << 16)
					| ((UW)p_sdd->MmcInfo.ub_ExtCsd[213] << 8) | (UW)p_sdd->MmcInfo.ub_ExtCsd[212];
	}
#endif /* _SDD_ALLOW_MMC_ */
	
	/* vZʂO[oϐɊi[ */
	p_sdd->uw_NormalSize = uw_Size;
	
	return;
}

/********************************************************************************/
/*  ֐		FSdds_SecureSizeCalc											*/
/*  Tv		FFؗ̈TCY̌vZ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static void Sdds_SecureSizeCalc( SDD_HANDLE *p_SddHandle )
{
	UW uw_Size = 0;
	UB ub_ReadBlockLen = 0;
	UB ub_CSizeMult = 0;
	UB ub_BitLen = 0;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
	/* SDLCJ[h	: Protected Area = SIZE_OF_PROTECTED_AREA_* MULT * BLOCK_LEN */
	/* SDHCJ[h	: Protected Area = SIZE_OF_PROTECTED_AREA                    */
	/* MMC			: Protected Area = 0                                         */
	/* Fؗ̈TCY̌vZiSDJ[ĥ݁j                                      */
	if((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) & (UB)SDD_CARD_TYPE_SD){
		uw_Size = ((UW)p_sdd->ub_SdStatus[4] << 24) |
				  ((UW)p_sdd->ub_SdStatus[5] << 16) |
				  ((UW)p_sdd->ub_SdStatus[6] << 8)  |
				   (UW)p_sdd->ub_SdStatus[7];			/* SIZE_OF_PROTECTED_AREA */
		if( (p_sdd->ub_Csd[15] & SDD_CSD_STRUCTURE_MASK) == SDD_CSD_STRUCTURE_V10 ){
			/* SDLCJ[hiCSD Ver1.0j̏ꍇ */
			ub_CSizeMult = (((p_sdd->ub_Csd[6] & SDD_CSD_C_SIZE_MULTI_BIT_49_48) << 1 )		/* C_SIZE_MULT */
				| ((p_sdd->ub_Csd[5] & SDD_CSD_C_SIZE_MULTI_BIT_47_47) >> 7 ));
			ub_ReadBlockLen = (p_sdd->ub_Csd[10] & SDD_CSD_READ_BL_LEN_BIT_83_80);			/* READ_BL_LEN */
			while( ((uw_Size / p_sdd->uw_SectorSize) >> ub_BitLen) != 0 ){					/* SIZE_OF_PROTECTED_AREA  ZN^TCY̌߂ */
				ub_BitLen++;
			}
			if( (ub_BitLen + (ub_CSizeMult + 2) + ub_ReadBlockLen) > 32 ){
				uw_Size = 0xFFFFFFFF;					/* UWI[o[t[ꍇAőlݒ */
			}else{
				uw_Size *= (4 << ub_CSizeMult);												/* MULTi=2^(C_SIZE_MULT + 2)j{ */
				uw_Size *= (1 << ub_ReadBlockLen) / p_sdd->uw_SectorSize;					/* BLOCK_LENi=2^READ_BL_LENj{  ZN^P*/
			}
		}else{
			/* SDHCJ[hiCSD Ver2.0j̏ꍇ */
			uw_Size /= p_sdd->uw_SectorSize;			/* ZN^Pʂɕϊ */
		}
	}
	
	/* vZʂO[oϐɊi[ */
	p_sdd->uw_SecureSize = uw_Size;
	
	return;
}

/********************************************************************************/
/*  ֐		FSdds_CheckCardSize											*/
/*  Tv		FsJ[heʃ`FbN										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_CheckCardSize( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
	/* sJ[heʃ`FbNiSDJ[h̏ꍇ̂݁j */
	if( (p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) & (UB)SDD_CARD_TYPE_SD ){
		if(p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2)){			/* Ver.2.00J[hi2GBj*/
#ifndef _SDD_ALLOW_ILL4G_V2HC_
			if(p_sdd->uw_NormalSize < SDD_MIN_HCCARD_SIZE){					/* SDHCJ[hȂ̂ɗeʂȂ */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
				p_sdd->ub_CardType |= SDD_CARD_TYPE_SDSPEC_VIOLATION;
				return w_Result;
			}
#endif /* _SDD_ALLOW_ILL4G_V2HC_ */
#ifndef _SDD_ALLOW_ILL32G_
			if((p_sdd->uw_NormalSize > SDD_MAX_HCCARD_SIZE) && ((p_sdd->v20.ub_PhyExt & SDD_PHY_VER3) == 0) ) {					/* s32GBJ[h */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
				p_sdd->ub_CardType |= SDD_CARD_TYPE_SDSPEC_VIOLATION;
				return w_Result;
			}
#endif /* _SDD_ALLOW_ILL32G_ */
		}else if(p_sdd->v20.uh_PhyVer == (SDD_PHY_LCCARD | SDD_PHY_VER2)){	/* Ver.2.00J[hi2GBȉj*/
#ifndef _SDD_ALLOW_ILL4G_V2LC_
			if(p_sdd->uw_NormalSize > SDD_MAX_LCCARD_SIZE){					/* s4GBJ[h */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
				p_sdd->ub_CardType |= SDD_CARD_TYPE_SDSPEC_VIOLATION;
				return w_Result;
			}
#endif /* _SDD_ALLOW_ILL4G_V2LC_ */
		}else{																	/* Ver.1.XXJ[hi2GBȉj*/
#ifndef _SDD_ALLOW_ILL4G_V1_
			if(p_sdd->uw_NormalSize > SDD_MAX_LCCARD_SIZE){					/* s4GBJ[h */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
				p_sdd->ub_CardType |= SDD_CARD_TYPE_SDSPEC_VIOLATION;
				return w_Result;
			}
#endif /* _SDD_ALLOW_ILL4G_V1_ */
		}
#ifdef _SDD_ALLOW_NON_SECURE_
        /* Fؗ̈ȂJ[h */
        if (p_sdd->uw_SecureSize == 0) {
            /* Fؗ̈TCY0bytëׁAFؗ̈ȂJ[hƔ */
            p_sdd->ub_CardType |= (UB)SDD_CARD_TYPE_NONSECURE;
        }
#endif
	}

#ifdef _SDD_ALLOW_MMC_
#ifdef _SDD_ALLOW_MMC_ILL4G_
	/* sJ[heʃ`FbNiMMC̏ꍇ̂݁j */
	if ( (p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC ){
		if ((p_sdd->MmcInfo.ub_HcFlag == 0) && ( p_sdd->uw_NormalSize > SDD_MMC_MAX_LCCARD_SIZE)){	/* s2GBMMC΍ */
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
		}
	}
#endif
#endif /* _SDD_ALLOW_MMC_ */

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_GetStatus											    */
/*  Tv		FXe[^X擾										        */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		Fp_sdd->uh_Status												*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
UH Sdds_GetStatus(SDD_HANDLE *p_SddHandle) {
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    UH uh_Status;

    if (p_sdd->OsInfo.cdCycInfo.bl_Active == FALSE) {
        /* J[h}opnh~Ăꍇɂ͂̂܂ܒlԂ */
        uh_Status = p_sdd->uh_Status;
    }
    else {
        /* J[h}opnhNĂꍇɂ͒~ŒlԂ */
        Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
        uh_Status = p_sdd->uh_Status;
        Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    }
    return uh_Status;
}

/********************************************************************************/
/*  ֐		FSdds_SetStatus											    */
/*  Tv		FXe[^Xݒ										        */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*              FUH uh_Status  												*/
/*  ߂l		FȂ												            */
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
void Sdds_SetStatus( SDD_HANDLE *p_SddHandle, UH uh_Status) {
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    if (p_sdd->OsInfo.cdCycInfo.bl_Active == FALSE) {
        /* J[h}opnh~Ăꍇɂ͂̂܂ܒlݒ肷 */
        p_sdd->uh_Status = uh_Status;
    }
    else {
        /* J[h}opnhNĂꍇɂ͒~Œlݒ肷 */
        Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */
        p_sdd->uh_Status = uh_Status;
        Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
    }
}

/********************************************************************************/
/*  ֐		FSdds_CalcTimeOutTime											*/
/*  Tv		F^CAEgԉZ 								            */
/*  		FUW uw_SendSec ZN^										*/
/*  			FBOOL bl_Write(ReadR}h(FALSE) or WriteR}h(TRUE)      */
/*  ߂l		FUW ^CAEg											*/
/*  ŏIXV	F2007.10.09													*/
/********************************************************************************/
UW Sdds_CalcTimeOutTime(UW uw_SendSec, BOOL bl_Write, SDD_HANDLE *p_SddHandle) {
	UW uw_TimeOutMsec = 0;
#ifndef _SDD_SUPPORT_1MBPS_
	SDD_DEV *p_sdd = p_SddHandle->vp_Sdif;
#endif

    if (bl_Write == TRUE) {
        /* ݎ^CAEg */
#ifdef _SDD_SUPPORT_1MBPS_	/* 1Mbpsȏ̓]x݂̂T|[gꍇ */
		uw_TimeOutMsec = SDD_GET_WRITETIMEOUTMSEC(uw_SendSec);
#else
        if(uw_SendSec <= SDD_512_SENDSEC){
            uw_TimeOutMsec = SDD_512_TIMEOUT_MSEC;
        }
        else {
            uw_TimeOutMsec = SDD_GET_WRITETIMEOUTMSEC(uw_SendSec, 
                                                      (p_sdd->ub_Csd[SDD_CSD_R2W_FACTOR_BYTE_OFFSET] >> SDD_CSD_R2W_FACTOR_BIT_OFFSET) & SDD_CSD_R2W_FACTOR_MASK);
        }
#endif
    }
    else {
        /* ǂݏo^CAEg */
#ifdef _SDD_SUPPORT_1MBPS_	/* 1Mbpsȏ̓]x݂̂T|[gꍇ */
		uw_TimeOutMsec = SDD_GET_READTIMEOUTMSEC(uw_SendSec);
#else
        if(uw_SendSec <= SDD_512_SENDSEC){
            uw_TimeOutMsec = SDD_512_TIMEOUT_MSEC;
        }
        else {
            uw_TimeOutMsec = SDD_GET_READTIMEOUTMSEC(uw_SendSec);
        }
#endif
    }
    return uw_TimeOutMsec;
}

/********************************************************************************/
/*  ֐		FSdds_Get_EraseTm												*/
/*  Tv		FVer2.0KiΉErase^CAEgvZ							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW ZN^												*/
/*  ߂l		F^CAEgl												*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
UW Sdds_Get_EraseTm(SDD_HANDLE *p_SddHandle, UW uw_SecCnt)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uw_TimeOut = 0;
	UW uw_AuSize = 0;
	
	if( (p_sdd->v20.ub_ErTm != 0) && 	/* Erase TimeOut	*/
		(p_sdd->v20.uh_ErSize != 0) && 	/* Erase Size by AU */
		(p_sdd->v20.ub_Au != 0) )		/* AU Size */
	{	/* SD_Status̐ݒlɌvZ */
		
		/* AUP->BlockPʃTCY */
		uw_AuSize = ((UW)0x00000020 << (p_sdd->v20.ub_Au - 1));
		
		/* oE_łȂOAUlA炩2AUČvZsĂ */
		uw_TimeOut = ((uw_SecCnt / uw_AuSize + 2) * p_sdd->v20.ub_ErTm) / p_sdd->v20.uh_ErSize + p_sdd->v20.ub_ErOffset;
		
		/* ^CAEgĺA]Ɏ邽߁ALQ{i͓ɂȂj */
		/* AUoE_lꍇAő1.5sǉ邽߁A3ǉ */
		uw_TimeOut = (uw_TimeOut * 2) + 3;
		
		/* sPʂmsPʂɕϊ */
		if( uw_TimeOut > 0x003FFFFF ){
			uw_TimeOut = 0xFFFFFFFF;	/* I[o[t[̂߁Amsϊőlݒ肷 */
		}else{
			uw_TimeOut *= 1000;
		}
	}
#ifdef _SDD_ALLOW_MMC_
	/* Large Erase[hΉMMC̏ꍇ */
	else if(p_sdd->MmcInfo.uh_SetFunc & SDD_MMC_FUNC_LARGE_ERASE)
	{
		uw_TimeOut = p_sdd->MmcInfo.uw_EraseTimeout * (uw_SecCnt / p_sdd->MmcInfo.uw_EraseUnitSize);
	
	}
#endif /* _SDD_ALLOW_MMC_ */
	else/* SD_StatusEraseTimeΉJ[h */
	{
#ifdef _SDD_SUPPORT_1MBPS_
		uw_TimeOut = SDD_GET_ERASETIMEOUTMSEC(uw_SecCnt);
#else
		if(uw_SecCnt <= SDD_512_SENDSEC){
			uw_TimeOut = SDD_512_TIMEOUT_MSEC;
		}else{
			uw_TimeOut = SDD_GET_ERASETIMEOUTMSEC(uw_SecCnt);
		}
#endif
	}
	
	return uw_TimeOut;
}

#if !defined(_SDD_JUPITER_) && !defined(_SDD_FUNC_SECURE_)
/********************************************************************************/
/*  ֐		FSdds_HandleCMDCheck											*/
/*  Tv		Fnh|C^/R}h`FbN								*/
/*  			Fnh|C^͐ݒς݂̗̈悩ǂ̃`FbN			*/
/*				FʏHandleł̔F؃R}hsNG`FbN						*/
/*				FFHnadleł̒ʏR}hsNG`FbN						*/
/*  		FSDD_HANDLE *p_Handle											*/
/*  			FUH uh_Cmd														*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_HandleCMDCheck(SDD_HANDLE *p_SddHandle, UH uh_Cmd)
{
	SDD_ERROR w_Result = SDD_SUCCESS;

	return	w_Result;
}
#endif /* !define(_SDD_JUPITER_) && !define (_SDD_FUNC_SECURE_) */

/********************************************************************************/
/*  ֐		FSdds_driver_init												*/
/*  Tv		FhCop֐    							            */
/*  		FȂ													        */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.6													    */
/********************************************************************************/
void Sdds_driver_init(void)
{
    UB i;
    /* hCoANZXpnh */
    for (i=0; i<SDD_DEV_COUNT; i++) {
        Sdds_SetHandle(&(SddHandleForDriver[i]), i);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"%d:SddHandleForDriver[i].vp_Sdif=%X SddHandleForDriver[i].ub_Port=%d\n",i,(int)SddHandleForDriver[i].vp_Sdif,SddHandleForDriver[i].ub_Port);
    }
      
    /* Z}tH */
    Sdds_CreateSemaphore();
    /* Cxg */
    Sdds_CreateEvent();
#ifdef _SDD_ANGOU_
    /* ÕCxg */
    Sdds_CreateAngouEvent();
#endif /* _SDD_ANGOU_ */
    
	return;
}

/********************************************************************************/
/*  ֐		FSdds_driver_exit												*/
/*  Tv		FhCopI֐    							            */
/*  		FȂ													        */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.6													    */
/********************************************************************************/
void Sdds_driver_exit(void)
{
#ifdef _SDD_ANGOU_
#ifndef _SDD_ITRON_
    /* ÕCxg폜 */
    Sdds_DeleteAngouEvent();
#endif /* _SDD_ITRON_ */
#endif /* _SDD_ANGOU_ */
    /* Cxg폜 */
    Sdds_DeleteEvent();
    /* Z}tH폜 */
    Sdds_DeleteSemaphore();
	return;
}

/********************************************************************************/
/*  ֐		FSdds_Memcpy													*/
/*  Tv		FRs[֐(TCYwt)										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*                void *pv_Dst Rs[                                         */
/*                void *pv_Src Rs[                                         */
/*                UW   uw_Size Rs[TCY                                     */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sdd_memcpy( SDD_HANDLE *p_SddHandle, void *pv_Dst, void *pv_Src, UW uw_Size )
{
	UW	uw_Res;						/* i[p(cTCY)	*/
	UB	*pub_NowD, *pub_NowS;		/* i[p|C^		*/

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_MEMCPY );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */


	/**** TCY0Ȃ琬 ****/
	if ( uw_Size == 0 ){
		return;
	}

	/**** ̊i[ ****/
	pub_NowD = (UB *)pv_Dst;
	pub_NowS = (UB *)pv_Src;
	uw_Res = uw_Size;

	for ( ; uw_Res > 0; uw_Res--, pub_NowD++, pub_NowS++) {
		*pub_NowD = *pub_NowS;
	}

	return;
}

/********************************************************************************/
/*  ֐		FSdds_memcpyChangeEndian										*/
/*  Tv		FGfBAϊRs[֐(TCYwt)						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F																*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
void Sdds_memcpyChangeEndian( SDD_HANDLE *p_SddHandle, void *pv_Dst, void *pv_Src, UW uw_Size )
{

	UW	uw_Res;						/* i[p(cTCY)	*/
	UB	*pub_NowD, *pub_NowS;		/* i[p|C^		*/

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_MEMCPYCHANGEENDIAN );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */


	/**** TCY0Ȃ琬 ****/
	if ( uw_Size == 0 ){
		return;
	}

	/**** ̊i[ ****/
	pub_NowD = (UB *)pv_Dst;
	pub_NowD += uw_Size - 1;
	pub_NowS = (UB *)pv_Src;
	uw_Res = uw_Size;

	for ( ; uw_Res > 0; uw_Res--, pub_NowD--, pub_NowS++) {
		*pub_NowD = *pub_NowS;
	}
	
	return;
}

/********************************************************************************/
/*  ֐		FSdds_SetHandle												*/
/*  Tv		FHandleݒ菈												*/
/*				F	SDD_HANDLESDD_DEṼ|C^ݒ							*/
/*				F	SDD_HANDLEɃ|[gԍݒ								*/
/*  		FSDD_HANDLE *p_SddHandle nh								*/
/*              FUB ub_Port |[gԍ                                         */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.06														*/
/********************************************************************************/
SDD_ERROR Sdds_SetHandle(SDD_HANDLE *p_SddHandle, UB ub_Port)
{
	SDD_ERROR w_Result = SDD_SUCCESS;

	/*==============================================*/
	/*	SDD_HANDLESDD_DEV|C^ݒ	        */
	/*	p_SddHandle->vp_Sdif = &(SddDev[|[gԍ])*/
	/*	p_SddHandle->ub_Port = |[gԍ	        */
	/*==============================================*/
	p_SddHandle->vp_Sdif = &SddDev[ub_Port];	/* foCX̏ꍇ́ASddDev[unit]Ƃ */
	Sdd_M_SetPortNum(p_SddHandle->ub_Port,ub_Port);  /* |[gԍݒ */

	return w_Result;
}

#if defined(_SDD_SUPPORT_1MBPS_)
/********************************************************************************/
/*  ֐		FSdds_EraseTimeoutCulc											*/
/*  Tv		FErace^CAEgvZ(_SDD_SUPPORT_1MBPS_`)				*/
/*  		F																*/
/*  ߂l		F																*/
/*  ŏIXV	F2004.1.22														*/
/********************************************************************************/
UW Sdds_EraseTimeoutCulc(UW uw_SecCnt)
{
	UW	uw_TimeOut = 0xFFFFFFFF;
	
	if (uw_SecCnt < 0x00100000){
		uw_TimeOut = (uw_SecCnt * SDD_SECTOR_SIZE * 8 / 1000) + 2000;
	}
	else if (uw_SecCnt < 0x3E7FFC18) {
		uw_TimeOut = ((uw_SecCnt / 1000 + 1) * SDD_SECTOR_SIZE * 8) + 2000;
	}
	
	if (uw_TimeOut > SDD_TIMEOUT_MAX_MSEC){
		uw_TimeOut = SDD_TIMEOUT_MAX_MSEC;
	}
	
	return uw_TimeOut;
}
#endif


#ifdef _SDD_READ_ZERO_PADDING_
/********************************************************************************/
/*  ֐		FSdds_FillMemory												*/
/*  Tv		F0߂{											*/
/*  		FSDD_HANDLE *p_SddHandle nh								*/
/*				Fvoid *pv_Dst ݐAhX									*/
/*				Fvoid *pv_Src ݌AhX									*/
/*				FUW uw_Size ݃TCYioCgj								*/
/*  ߂l		F																*/
/*  ŏIXV	F2004.1.22														*/
/********************************************************************************/
void Sdds_FillMemory(SDD_HANDLE *p_SddHandle, void *pv_Dst, void *pv_Src, UW uw_Size)
{
/* ̊֐̓G[Jo֐Ȃ̂ŁA{IɃG[͕ԂȂ */

#if defined(_SDD_UNIPHIER_XP_) && defined(_SDD_USE_SDMACLIB_)
	SDD_ERROR w_Result = SDD_SUCCESS;
	

	w_Result = Sdds_StartPaddingSdma(p_SddHandle, uw_Size, (UW)pv_Src, (UW)pv_Dst);
	if(w_Result != SDD_SUCCESS){
		return;
	}

	w_Result =  Sdds_WaitFillMemEnd(p_SddHandle, SDD_FILLMEM_TIMEOUT);
	if(w_Result != SDD_SUCCESS){
		w_Result = Sddr_StopDma(p_SddHandle);
	}
	
	w_Result = Sdds_EndSdma(p_SddHandle);		/* SDMACN[YASDRAM̃foCXnh */
	return;

#else

	return;
#endif
}
#endif /* _SDD_READ_ZERO_PADDING_ */
