/********************************************************************************/
/*  t@C    F$Workfile: SddDriverLib_secure.c $                          */
/*  Tv          FZLApSDfoCXhCoʃCut@C          */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 06/06/12 13:30 $                                  */
/*                  䉉ZOǉ 2006/07/03 H.Miura                   */
/*                  ݒ菈ǉ 2006/07/03 H.Miura                     */
/*                  O[oϐǉ 2006/07/03 H.Miura           */
/********************************************************************************/

#ifdef _SDD_FUNC_SECURE_
/********************************************************************************/
/*  ֐		FCheckAndSetArgPointer											*/
/*  Tv		F֐e[uɐݒ肷̐ݒ								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH uh_Cmd														*/
/*  			FUW *puw_Arg1													*/
/*  			FUW *puw_Arg2													*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR CheckAndSetArgPointer(SDD_HANDLE *p_SddHandle, UH uh_Cmd, UW *puw_Arg1, void *pv_Arg2)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	switch(uh_Cmd){
		/* NULL`FbN&Resultݒ */
		case SDD_IOC_ERASE:
		case SDD_IOC_READ:
		case SDD_IOC_WRITE:
#ifdef _SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_READ:
		case SDD_IOC_USB_WRITE:
		case SDD_IOC_USB_GET_MKB:
		case SDD_IOC_USB_SECURE_READ:
		case SDD_IOC_USB_SECURE_WRITE:
#endif /* _SDD_SDUSB_TRANSFER_ */
		case SDD_IOC_GET_MKB:
		case SDD_IOC_SECURE_READ:
		case SDD_IOC_SECURE_WRITE:
#if !defined(_SDD_ANGOU_)
        /* OÍgpύX */
		case SDD_IOC_SET_R1:
		case SDD_IOC_GET_R2:
		case SDD_IOC_GET_RES1:
		case SDD_IOC_SET_RES2:
        case SDD_IOC_GET_MID:
#endif
			if(pv_Arg2 == NULL){
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
				p_sdd->Result.w_Result = w_Result;
			}
			*puw_Arg1 = (UW)pv_Arg2;
			break;
		case SDD_IOC_INIT:
		case SDD_IOC_SET_RING_BUFF:
		case SDD_IOC_SET_EVENT_CBF:
		case SDD_IOC_VERSION:
		case SDD_IOC_GET_CARD_TYPE:
		case SDD_IOC_GET_SECTOR_SIZE:
		case SDD_IOC_GET_CARD_CAPACITY:
		case SDD_IOC_GET_AREA_SIZE:
		case SDD_IOC_CHECK_WP:
		case SDD_IOC_GET_CARD_INFO:
		case SDD_IOC_GET_STATUS:
		case SDD_IOC_GET_CARD_STATUS:
		case SDD_IOC_GET_SD_STATUS:
		case SDD_IOC_GET_RESULT:
#ifdef	_SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_HST_GET:
		case SDD_IOC_USB_HST_SET:
#endif /* _SDD_SDUSB_TRANSFER_ */
#ifdef _SDD_RW_WAIT_
		case SDD_IOC_SET_RW_WAIT:
#endif
#ifdef _SDD_ALLOW_MMC_
		case SDD_IOC_GET_EXT_CSD:
#endif /* _SDD_ALLOW_MMC_ */
		case SDD_IOC_GET_SECURE_AREA_SIZE:
		case SDD_IOC_SET_KRU:
		case SDD_IOC_SET_ENCDK:
		case SDD_IOC_SET_CALC_ENCMK:
		case SDD_IOC_SET_DCE:
		case SDD_IOC_SET_COND_ENCMK:
		case SDD_IOC_SET_DV:
		case SDD_IOC_SET_SDP:
		case SDD_IOC_GET_SDP:
		case SDD_IOC_MAKE_RW_ARG:
		case SDD_IOC_MAKE_ERASE_ARG:
		case SDD_IOC_AUTH_CHECK:
#ifdef _SDD_ANGOU_
        case SDD_IOC_C2_SET_FRAME:
        case SDD_IOC_C2_ENCDEC_CONTENTS:
        case SDD_IOC_C2_ENC_UR:
        case SDD_IOC_C2_DEC_UR:
        case SDD_IOC_C2_MAKE_TK:
        case SDD_IOC_C2_SET_TK:
        case SDD_IOC_C2_GET_RANDOM:
#endif /* _SDD_ANGOU_ */
#ifdef _SDD_FUNC_SDIO_
        case SDD_IOC_SETIO_READ_DIRECT:
        case SDD_IOC_SETIO_WRITE_DIRECT:
        case SDD_IOC_SETIO_READ_EXTENDED:
        case SDD_IOC_SETIO_WRITE_EXTENDED:
#endif
		case SDD_IOC_GET_ERRINFO:
		case SDD_IOC_SEND_SMART:
		case SDD_IOC_SEND_COMMAND:
        case SDD_IOC_GET_RCA:
        case SDD_IOC_GET_SCR:
		/* NULL`FbN */
			if(pv_Arg2 == NULL){
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
			}
			*puw_Arg1 = (UW)pv_Arg2;
			break;
		default:
		/* NULL`FbNȂ */
			break;
		}

	return	w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_CardInitcheck											*/
/*  Tv		FJ[h`FbN											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH uh_Cmd														*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_CardInitcheck( SDD_HANDLE *p_SddHandle, UH uh_Cmd )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	switch(uh_Cmd){
		/* J[hσ`FbN&Resultݒ */
		case SDD_IOC_ERASE:
		case SDD_IOC_READ:
		case SDD_IOC_WRITE:
#ifdef _SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_READ:
		case SDD_IOC_USB_WRITE:
		case SDD_IOC_USB_GET_MKB:
		case SDD_IOC_USB_SECURE_READ:
		case SDD_IOC_USB_SECURE_WRITE:
#endif /* _SDD_SDUSB_TRANSFER_ */
		case SDD_IOC_GET_MKB:
		case SDD_IOC_SECURE_READ:
		case SDD_IOC_SECURE_WRITE:
		case SDD_IOC_SECURE_ERASE:
				/*==============================================================*/
				/* Sdds_CardInitcheck𔭍s									*/
				/* J[hL̃`FbNAJ[hς݃`FbN				*/
				/*==============================================================*/
				w_ResTmp = Sdds_CardInitchecksub(p_SddHandle);
				if(w_ResTmp != SDD_SUCCESS){
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
					p_sdd->Result.w_Result = w_Result;
				}
				break;
		case SDD_IOC_GET_SECTOR_SIZE:
		case SDD_IOC_GET_CARD_CAPACITY:
		case SDD_IOC_GET_AREA_SIZE:
		case SDD_IOC_CHECK_WP:
		case SDD_IOC_GET_CARD_INFO:
		case SDD_IOC_GET_CARD_STATUS:
		case SDD_IOC_GET_SD_STATUS:
#ifdef _SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_HST_GET:
		case SDD_IOC_USB_HST_SET:
		case SDD_IOC_USB_SET_SECURE_AREA_SIZE:
#endif /* _SDD_SDUSB_TRANSFER_ */
#ifdef _SDD_ALLOW_MMC_
		case SDD_IOC_GET_EXT_CSD:
#endif /* _SDD_ALLOW_MMC_ */
		case SDD_IOC_SET_CARDFUNC:
		case SDD_IOC_SPEEDCLASS_RECORDING:
		case SDD_IOC_GET_SECURE_AREA_SIZE:
		case SDD_IOC_SET_KRU:
		case SDD_IOC_SELECT_MDK:
		case SDD_IOC_SET_ENCDK:
		case SDD_IOC_SET_CALC_ENCMK:
		case SDD_IOC_SET_DCE:
		case SDD_IOC_SET_COND_ENCMK:
		case SDD_IOC_SET_DV:
		case SDD_IOC_GET_MID:
		case SDD_IOC_SET_SDP:
		case SDD_IOC_GET_SDP:
		case SDD_IOC_SET_R1:
		case SDD_IOC_GET_R2:
		case SDD_IOC_SET_RES2:
		case SDD_IOC_GET_RES1:
		case SDD_IOC_GO_NEXT_AKE:
		case SDD_IOC_MAKE_RW_ARG:
		case SDD_IOC_MAKE_ERASE_ARG:
		case SDD_IOC_SET_RW_ARG:
		case SDD_IOC_AUTH_CHECK:
		case SDD_IOC_SET_SECURE_AREA:
		case SDD_IOC_SEND_SMART:
        case SDD_IOC_GET_RCA:
        case SDD_IOC_GET_SCR:
				/*==============================================================*/
				/* Sdds_CardInitcheck𔭍s									*/
				/* J[hL̃`FbNAJ[hς݃`FbN				*/
				/*==============================================================*/
				w_ResTmp = Sdds_CardInitchecksub(p_SddHandle);
				if(w_ResTmp != SDD_SUCCESS){
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				}
				break;
		default:
				/* J[hL`FbN/ς݂ȂR}h */
				break;
	}

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_ChangeState												*/
/*  Tv		FIOCTLԑJ													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH uh_Cmd														*/
/*				FUW uw_tmpDevID ANZẌfoCXID							*/
/*  			FBOOL b_Direction TRUE:OPENxxx/FALSE:xxxOPEN				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_ChangeState( SDD_HANDLE *p_SddHandle, UH uh_Cmd, UW uw_tmpDevID, BOOL bl_Direction )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */

	switch(uh_Cmd){
#ifdef _SDD_SDUSB_TRANSFER_
		case SDD_IOC_CANCEL:
			if(bl_Direction == FALSE){
				/*==================================================*/
				/* ԑJځiUSB R/WOPENj					    */
				/*	SddDev[port].uh_Status &= ~SDD_STATUS_USB_RW	*/
				/*	SddDev[port].uh_Status |= SDD_STATUS_OPEN		*/
				/*==================================================*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_USB_RW);
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_OPEN);
			}
			break;

		case SDD_IOC_USB_READ:
		case SDD_IOC_USB_WRITE:
		case SDD_IOC_USB_GET_MKB:
		case SDD_IOC_USB_SECURE_READ:
		case SDD_IOC_USB_SECURE_WRITE:
			if(bl_Direction == TRUE){
				/*======================================*/
				/* ԑJځiOPENUSB_RWj		        */
				/*	SddDev[port].ub_Status &= ~0x01	    */
				/*	SddDev[port].ub_Status |= USB_RW	*/
				/*======================================*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_OPEN);
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_USB_RW);
			}
			/* USB_RW̃G[̏ꍇSdd_Ioctl֐Ōɖ߂ */
			/* SDD_STATUS_USB_RWɂǂ̂SDD_IOC_GET_RESULTSDD_IOC_CANCEL */
			break;
#endif /* _SDD_SDUSB_TRANSFER_ */
		case SDD_IOC_READ:
			if(bl_Direction == TRUE){
				/*==============================================*/
				/* ԑJځiOPENIOCTLj			        	*/
				/*	SddDev[portNum].ub_Status &= ~0x01			*/
				/*	SddDev.[portNum]ub_Status |= IOCTL | READ	*/
				/*==============================================*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_OPEN);
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | (SDD_STATUS_IOCTL | SDD_STATUS_READ));
			}
			else{
				/*=======================================*/
				/* ԑJ 	IOCTL->OPEN		 		 */
				/*=======================================*/
				/* OPENԂ֑J
					SddDev[port].uh_Status = OPEN
				*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~(SDD_STATUS_IOCTL | SDD_STATUS_READ));
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_OPEN);
			}
			break;

		case SDD_IOC_WRITE:
			if(bl_Direction == TRUE){
				/*==========================================*/
				/* ԑJځiOPENIOCTLj				    */
				/*	SddDev[Port].ub_Status &= ~0x01			*/
				/*	SddDev[Port].ub_Status |= IOCTL | WRITE	*/
				/*==========================================*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) &  ~SDD_STATUS_OPEN);
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | (SDD_STATUS_IOCTL | SDD_STATUS_WRITE));
			}
			else{
				/*====================================*/
				/* ԑJ		IOCTL->OPEN			  */
				/*====================================*/
				/* OPENԂ֑J
					SddDev[port].uh_Status = OPEN
				*/
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~(SDD_STATUS_IOCTL | SDD_STATUS_WRITE));
				Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_OPEN);
			}
			break;

		case SDD_IOC_SECURE_READ:
		case SDD_IOC_GET_MKB:
			if(bl_Direction == TRUE){
				/*==========================================================*/
				/* ԑJځiOPENIOCTLj									*/
				/* SddDev[port].uh_SecureStatus &= ~SECURE_OPEN				*/
				/* SddDev[port].uh_SecureStatus |= SECURE_IOCTL | SECURE_READ	*/
				/*==========================================================*/
				p_sdd->uh_SecureStatus &= ~SDD_SECURE_STATUS_OPEN;
				/* Secure ReadEGetMKBp */
				p_sdd->uh_SecureStatus |= (SDD_SECURE_STATUS_IOCTL | SDD_SECURE_STATUS_READ);
			}
			else{
				/*==============================================================*/
				/* ԑJځiIOCTLOPENj									    */
				/* SddDev[port].uh_SecureStatus &= SECURE_IOCTL | SECURE_READ	*/
				/* SddDev[port].uh_SecureStatus |= SECURE_OPEN					*/
				/*==============================================================*/
				/* Secure ReadEGetMKBp */
				p_sdd->uh_SecureStatus &= ~(SDD_SECURE_STATUS_IOCTL | SDD_SECURE_STATUS_READ);
				p_sdd->uh_SecureStatus |= SDD_SECURE_STATUS_OPEN;
			}
			break;

		case SDD_IOC_SECURE_WRITE:
			if(bl_Direction == TRUE){
				/*==============================================================*/
				/* ԑJځiOPENIOCTLj									    */
				/* SddDev[port].uh_SecureStatus &= ~SECURE_OPEN				    */
				/* SddDev[port].uh_SecureStatus |= SECURE_IOCTL | SECURE_WRITE	*/
				/*==============================================================*/
				p_sdd->uh_SecureStatus &= ~SDD_SECURE_STATUS_OPEN;
				/* Secure Writep */
				p_sdd->uh_SecureStatus |= (SDD_SECURE_STATUS_IOCTL | SDD_SECURE_STATUS_WRITE);
			}
			else{
				/*==============================================================*/
				/* ԑJځiIOCTLOPENj									    */
				/* SddDev[port].uh_SecureStatus &= SECURE_IOCTL | SECURE_WRITE	*/
				/* SddDev[portl].uh_SecureStatus |= SECURE_OPEN					*/
				/*==============================================================*/
				/* Secure Writep */
				p_sdd->uh_SecureStatus &= ~(SDD_SECURE_STATUS_IOCTL | SDD_SECURE_STATUS_WRITE);
				p_sdd->uh_SecureStatus |= SDD_SECURE_STATUS_OPEN;
			}
			break;

			default:
				if(bl_Direction == TRUE){
					if( uw_tmpDevID == SDD_DEVICEID_NORMAL ){
						/*=============================================*/
						/* ԑJځiOPENIOCTLj					   */
						/*	SddDev[port].uh_Status &= ~SDD_STATUS_OPEN */
						/*	SddDev[port].uh_Status |= SDD_STATUS_IOCTL */
						/*=============================================*/
						Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_OPEN);
						Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_IOCTL);
					}
					else{	/* F؃R}h̏ꍇ */
						/*==========================================================*/
						/* ԑJځiOPENIOCTLj								    */
						/* SddDev[port].uh_SecureStatus &= ~SDD_SECURE_STATUS_OPEN	*/
						/* SddDev[port].uh_SecureStatus |= SDD_SECURE_STATUS_IOCTL	*/
						/*==========================================================*/
						p_sdd->uh_SecureStatus &= ~SDD_SECURE_STATUS_OPEN;
						p_sdd->uh_SecureStatus |= SDD_SECURE_STATUS_IOCTL;
					}
				}
				else{
					if( uw_tmpDevID == SDD_DEVICEID_NORMAL ){
						/*==============================================*/
						/* ԑJځiIOCTLOPENj					    */
						/*	SddDev[port].uh_Status &= 	SDD_STATUS_IOCTL*/
						/* GET_RESULT̏ꍇ							    */
						/*	ԑJځiUSB_R/W or IOCTL->OPENj 		    */
						/*	SddDev[port].uh_Status |= 	SDD_STATUS_OPEN	*/
						/*==============================================*/
						if ( uh_Cmd == SDD_IOC_GET_RESULT){	/* SDD_IOC_GET_RESULT̏ꍇ */
							Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~(SDD_STATUS_IOCTL | SDD_STATUS_USB_RW));
						}
						else {	/* ׂẴR}h */
							Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) & ~SDD_STATUS_IOCTL);
						}
						Sdds_SetStatus(p_SddHandle, Sdds_GetStatus(p_SddHandle) | SDD_STATUS_OPEN);
					}
					else{	/* F؃R}h̏ꍇ */
						/*==========================================================*/
						/* ԑJځiIOCTLOPENj								    */
						/* SddDev[port].uh_SecureStatus &= SDD_SECURE_STATUS_IOCTL	*/
						/* GET_RESULT̏ꍇ										    */
						/*	F؂USB_RWԂ͂Ȃ̂IOCTLNA				    */
						/* SddDev[port].uh_SecureStatus |= SDD_SECURE_STATUS_OPEN	*/
						/*==========================================================*/
						p_sdd->uh_SecureStatus &= ~SDD_SECURE_STATUS_IOCTL;
						p_sdd->uh_SecureStatus |= SDD_SECURE_STATUS_OPEN;
					}
				}
				break;
	}
	Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_InitData													*/
/*  Tv		FhCoO[oϐ								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
void Sdds_InitData(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    /* O[oϐǉ 2006/07/03 H.Miura */
    Sdds_InitData_init(p_SddHandle);

#ifdef _SDD_FUNC_QUICK_BOOT_
	p_sdd->ub_Cmd8Info = 0;
	p_sdd->ub_StartCardInit = 0;
#endif /* _SDD_FUNC_QUICK_BOOT_ */

	p_sdd->uh_SecureStatus = SDD_SECURE_STATUS_CLEAR;
	p_sdd->p_NormalHandle = NULL;
	p_sdd->p_SecureHandle = NULL;
	p_sdd->p_Handle = NULL;

	/* R[obNȊÕf[^ */
	Sdds_InitDataNonCbf(p_SddHandle);

	/* R[obÑf[^ */
	Sdds_ClrCbfAll(p_SddHandle);

#if defined(_SDD_PADDING_DMA_) && defined(_SDD_UNIPHIER_XP_)
	Sdd_memcpy(p_SddHandle, gpub_PadBuf, gub_PadBuf, SDD_SECTOR_SIZE);
#endif

	return;
}

/********************************************************************************/
/*  ֐		FSdds_InitDataNonCbf											*/
/*  Tv		FhCoO[oϐ(ԁAR[obN֐ȊO)	*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.3.6														*/
/********************************************************************************/
void Sdds_InitDataNonCbf(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#ifndef _SDD_ANGOU_
	int i;
#endif

	/* J[h̏ */
	Sddr_CardDataInit(p_SddHandle);
	
	/*  ێ\(SDD_DEV)̏		*/ 
	p_sdd->ub_Preflg = 0;
	p_sdd->uw_UsbRwSector = (UW)0;
	p_sdd->Result.uw_Resid = (UW)0;
	p_sdd->Result.w_Result = (SDD_ERROR)0;
	p_sdd->Result.uh_Flag = (UH)0;
	p_sdd->RingBuffer.uw_OnOffFlg = 0x00000000;
	p_sdd->RingBuffer.uw_BuffStart = 0x00000000;
	p_sdd->RingBuffer.uw_BuffEnd = 0x00000000;
	p_sdd->DmaInfo.uw_DMASrcAddr = (UW)0;
	p_sdd->DmaInfo.uw_DMADstAddr = (UW)0;
	p_sdd->DmaInfo.uw_DMASize = (UW)0;
	p_sdd->DmaInfo.uw_RestSec = (UW)0;
	p_sdd->w_error = (W)0;
	p_sdd->uw_Offset = (UW)0;
	p_sdd->uw_Endian = SDD_ENDIAN_CHANGE_OFF;
	p_sdd->uw_ReadWait = (UW)0;
	p_sdd->uw_WriteWait = (UW)0;
	p_sdd->uw_ClkDiv = SDD_CLOCK_DIV_128;

	/* |[gʂ̐ݒ */
	if(Sdd_M_GetPortNum(p_SddHandle->ub_Port) == 0) {
		/* |[gԍ0̐ݒ */
#if !defined(_SDD_JUPITER_)
		p_sdd->uw_Imclk = SDD_IMCLK_PORT0;					/* MCLKݒ */
#endif /* !defined(_SDD_JUPITER_) */
#if defined(_SDD_HIGHSPEEDCLK_)
		p_sdd->ub_HighspeedInfo = SDD_HIGHSPEEDCLK_PORT0;	/* SDJ[h/MMCΉݒ */
#endif /* _SDD_HIGHSPEEDCLK_ */
#if defined(_SDD_ALLOW_UHS1_)
		p_sdd->ub_UHS1Info = SDD_ALLOW_UHS1_PORT0;			/* UHS-IJ[hΉݒ */
#endif /* _SDD_ALLOW_UHS1_ */
	} else {
		/* |[gԍ1̐ݒ */
#if !defined(_SDD_JUPITER_)
		p_sdd->uw_Imclk = SDD_IMCLK_PORT1;					/* MCLKݒ */
#endif /* !defined(_SDD_JUPITER_) */
#if defined(_SDD_HIGHSPEEDCLK_)
		p_sdd->ub_HighspeedInfo = SDD_HIGHSPEEDCLK_PORT1;	/* SDJ[h/MMCΉݒ */
#endif /* _SDD_HIGHSPEEDCLK_ */
#if defined(_SDD_ALLOW_UHS1_)
		p_sdd->ub_UHS1Info = SDD_ALLOW_UHS1_PORT1;			/* UHS-IJ[hΉݒ */
#endif /* _SDD_ALLOW_UHS1_ */
	}

	p_sdd->uw_SecureRwSector = (UW)0;
	p_sdd->uw_SecureRwOffset = (UW)0;
#ifdef	_SDD_ANGOU_LASTFRAME_
	p_sdd->uw_LastFrame = (UW)0;
#endif
#if !defined(_SDD_ANGOU_)
	for (i=0; i<SDD_RN1_SIZE; i++) {
		p_sdd->ub_RN1[i] = (UB)0;
	}
	for (i=0; i<SDD_RN2_SIZE; i++) {
		p_sdd->ub_RN2[i] = (UB)0;
	}
	for (i=0; i<SDD_RES1_SIZE; i++) {
		p_sdd->ub_RES1[i] = (UB)0;
	}
	for (i=0; i<SDD_RES2_SIZE; i++) {
		p_sdd->ub_RES2[i] = (UB)0;
	}
	for (i=0; i<SDD_MID_SIZE; i++) {
		p_sdd->ub_MID[i] = (UB)0;
	}
	p_sdd->uh_SecureRWArg = (UH)0;
#endif

    /* O[oϐ㏈ǉ H.Miura 2007.02.05 */
    Sdds_InitDataNonCbf_after();

	return;
}

#if !defined(_SDD_JUPITER_)
/********************************************************************************/
/*  ֐		FSdds_HandleCMDCheck											*/
/*  Tv		Fnh|C^/R}h`FbN(Uniphier2Pp)				*/
/*  			Fnh|C^͐ݒς݂̗̈悩ǂ̃`FbN			*/
/*				FʏHandleł̔F؃R}hsNG`FbN						*/
/*				FFHnadleł̒ʏR}hsNG`FbN						*/
/*  		FSDD_HANDLE *p_Handle											*/
/*  			FUH uh_Cmd														*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_HandleCMDCheck(SDD_HANDLE *p_SddHandle, UH uh_Cmd)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

#ifdef _SDD_ANGOU_
	if ( uh_Cmd < SDD_IOC_ANGOU_CMD_START ) {
#endif /* _SDD_ANGOU_ */
	/* nh|C^͐ݒς݂̗̈悩ǂ̃`FbN */
	 if( (p_SddHandle != p_sdd->p_NormalHandle)
		 && (p_SddHandle != p_sdd->p_SecureHandle) ){
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_ILLEGAL_HANDLE);
			return w_Result;
	}
	/* ʏHandleł̔F؃R}hsNG */
	if(p_SddHandle == p_sdd->p_NormalHandle){
		if( uh_Cmd > (SDD_SECURE_CMD_MIN - 1)) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_ILLEGAL_HANDLE);
			return w_Result;
		}
	}

	/* FHandleł̒ʏR}hsNG */
	if(p_SddHandle == p_sdd->p_SecureHandle){
		switch(uh_Cmd){
			case SDD_IOC_INIT:
			case SDD_IOC_SET_MODE:
			case SDD_IOC_SET_CLOCK_DIV:
			case SDD_IOC_SET_RING_BUFF:
			case SDD_IOC_SET_EVENT_CBF:
			case SDD_IOC_CARD_INIT:
			case SDD_IOC_ERASE:
			case SDD_IOC_CANCEL:
			case SDD_IOC_READ:
			case SDD_IOC_WRITE:
#ifdef _SDD_RW_WAIT_
			case SDD_IOC_SET_RW_WAIT:
#endif
#ifdef _SDD_SDUSB_TRANSFER_
			case SDD_IOC_USB_READ:
			case SDD_IOC_USB_WRITE:
			case SDD_IOC_USB_HST_GET:
			case SDD_IOC_USB_HST_SET:
			case SDD_IOC_USB_SET_SECURE_AREA_SIZE:
			case SDD_IOC_USB_GET_MKB:
			case SDD_IOC_USB_SECURE_READ:
			case SDD_IOC_USB_SECURE_WRITE:
#endif	/* _SDD_SD_USB_TRANSFER_ */
#ifdef _SDD_ALLOW_MMC_
			case SDD_IOC_GET_EXT_CSD:
#endif /* _SDD_ALLOW_MMC_ */
				/* sNGR}h */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_ILLEGAL_HANDLE);
				break;
			default:
				break;
		}
	}
#ifdef _SDD_ANGOU_
	}
#endif /* _SDD_ANGOU_ */

	return	w_Result;
}
#endif /* !define(_SDD_JUPITER_) */

#endif /* _SDD_FUNC_SECURE_ */

