/********************************************************************************/
/*  t@C    F$Workfile: SddDriverLib_for_MarvieAV.c $                    */
/*  Tv          FSDfoCXhCoʃCut@C(MarvieAVp)        */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 08/07/24 9:45 $                                   */
/********************************************************************************/
#if defined(_SDD_MARVIE_AV_)
/********************************************************************************/
/*  ֐		FSdds_InitData_init										    */
/*  Tv		FO[oϐ(MarvieAVp)						    */
/*  		FȂ									                        */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
#define Sdds_InitData_init() {\
	/*  ێ\(SDD_DEV)̏		*/ \
	Sdds_SetStatus(SDD_STATUS_CLEAR);\
	p_sdd->ub_DetectInfo = (UB)0;\
}
/********************************************************************************/
/*  ֐		FSdds_CheckDiv													*/
/*  Tv		FœKȕ߂(MarvieAVp)							    */
/*  		F																*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
void Sdds_CheckDiv(UW uw_TransMax, UW *puw_ClkDiv)
{
	if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_1 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_1;
	} else if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_2 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_2;
	} else if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_4 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_4;
	} else if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_8 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_8;
	} else if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_16 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_16;
	} else if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_32 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_32;
	} else if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_64 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_64;
	} else if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_128 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_128;
	} else if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_256 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_256;
	} else if(uw_TransMax >= (UW)(SDD_IMCLK >> (SDD_CLOCK_DIV_512 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_512;
	} else {
		*puw_ClkDiv = 0;
	}
}

/********************************************************************************/
/*  ֐		FSdds_ArgNullCMDCheck											*/
/*  Tv		FARG NULL`FbN								                */
/*  		FSDD_HANDLE *p_Handle											*/
/*  			FUH uh_Cmd														*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2007.10.26													*/
/********************************************************************************/
SDD_ERROR Sdds_ArgNullCMDCheck(UW uw_Arg, UH uh_Cmd)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV *p_sdd = &(SddDev[0]);

	switch(uh_Cmd){
		/* NULL`FbN&Resultݒ */
		case SDD_IOC_ERASE:
		case SDD_IOC_READ:
		case SDD_IOC_WRITE:
#ifdef _SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_READ:
		case SDD_IOC_USB_WRITE:
		case SDD_IOC_USB_GET_MKB:
		case SDD_IOC_USB_SECURE_READ:
		case SDD_IOC_USB_SECURE_WRITE:
#endif /* _SDD_SDUSB_TRANSFER_ */
#ifdef	_SDD_FUNC_SECURE_	/* 20080925 NonSecure */
#endif	/* _SDD_FUNC_SECURE_ */	/* 20080925 NonSecure */
			if(uw_Arg == (UW)(NULL)){
				w_Result = Sdds_SetErr(w_Result, SDD_ERR_PARAM);
				p_sdd->Result.w_Result = w_Result;
			}
			break;
		case SDD_IOC_INIT:
		case SDD_IOC_SET_RING_BUFF:
		case SDD_IOC_SET_EVENT_CBF:
		case SDD_IOC_VERSION:
		case SDD_IOC_GET_CARD_TYPE:
		case SDD_IOC_GET_SECTOR_SIZE:
		case SDD_IOC_GET_CARD_CAPACITY:
		case SDD_IOC_GET_AREA_SIZE:
		case SDD_IOC_CHECK_WP:
		case SDD_IOC_GET_CARD_INFO:
		case SDD_IOC_GET_STATUS:
		case SDD_IOC_GET_CARD_STATUS:
		case SDD_IOC_GET_SD_STATUS:
		case SDD_IOC_GET_RESULT:
#ifdef	_SDD_SDUSB_TRANSFER_
		case SDD_IOC_USB_HST_GET:
		case SDD_IOC_USB_HST_SET:
#endif /* _SDD_SDUSB_TRANSFER_ */
#ifdef _SDD_RW_WAIT_
		case SDD_IOC_SET_RW_WAIT:
#endif
#ifdef _SDD_FUNC_SECURE_
#endif /* _SDD_FUNC_SECURE_ */
		/* NULL`FbN */
			if(uw_Arg == (UW)(NULL)){
				w_Result = Sdds_SetErr(w_Result, SDD_ERR_PARAM);
			}
			break;
		default:
		/* NULL`FbNȂ */
			break;
		}

	return	w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_CheckSetDiv												*/
/*  Tv		Fݒ肷镪߂(MarvieAVp)							*/
/*  		F																*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
SDD_ERROR Sdds_CheckSetDiv(UW uw_ClockDiv, UW *puw_SetDiv)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV *p_sdd = &(SddDev[0]);
	UW uw_CsdDiv;

	switch (uw_ClockDiv) {
		case SDD_CLOCK_DIV_FULLSPEED:
			if (p_sdd->uh_Rca != 0){	/* J[h܂͏ */
				Sdds_GetCsdTransSpeed(&uw_CsdDiv);
				Sdds_CheckDiv(uw_CsdDiv, puw_SetDiv);
			}
			else {
                *puw_SetDiv = SDD_CLOCK_DIV_2; /* J[h܂̓J[hȂ */\
			}
			break;
		case SDD_CLOCK_DIV_LOWSPEED:
			*puw_SetDiv = SDD_CLOCK_DIV_256; /* MMCΉ */
			break;
		case SDD_CLOCK_DIV_1:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_2: 	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_4:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_8: 	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_16:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_32: 	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_64:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_128:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_256:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_512:
			if (Sdds_GetStatus() & SDD_STATUS_INITFLG) {
				Sdds_GetCsdTransSpeed(&uw_CsdDiv);
				Sdds_CheckDiv(uw_CsdDiv, puw_SetDiv);
				if(uw_ClockDiv < *puw_SetDiv){
					w_Result = Sdds_SetErr(w_Result, SDD_ERR_PARAM);
				}else{
					*puw_SetDiv = uw_ClockDiv;
				}
			}
			else {
				*puw_SetDiv = uw_ClockDiv;
			}
			break;
		default:
			w_Result = Sdds_SetErr(w_Result, SDD_ERR_PARAM);
			break;
	}
	return w_Result;
}

#endif /* defined(_SDD_MARVIE_AV_) */
