/********************************************************************************/
/*  t@C    F$Workfile: SddDriverLib_for_PeaksPro2.c $                   */
/*  Tv          FSDfoCXhCoʃCut@C(PeaksPro2p)       */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 06/06/20 09:10 $                                  */
/********************************************************************************/
#if defined(_SDD_PEAKS_PRO2_)
/********************************************************************************/
/*  ֐		FSdds_InitData_init										    */
/*  Tv		FO[oϐ(PeaksPro2p)						    */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.06													    */
/********************************************************************************/
static void Sdds_InitData_init(SDD_HANDLE *p_SddHandle) {
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    /*  ێ\(SDD_DEV)̏		*/
    Sdds_SetStatus(p_SddHandle, SDD_STATUS_CLEAR);
    p_sdd->ub_DetectInfo = SDD_DETECT_NON;
#ifdef _SDD_CARDDETECT_INTR_
    p_sdd->ub_PreviousDetect = SDD_DETECT_CARDOUT;
#endif
#ifdef _SDD_CARDDETECT_SDDAT3_
    p_sdd->ub_DetectState = SDD_STATE_DETECTED;
#endif
}

/********************************************************************************/
/*  ֐		FSdds_CheckDiv													*/
/*  Tv		FœKȕ߂(PeaksPro2p)							    */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sdds_CheckDiv(SDD_HANDLE *p_SddHandle, UW uw_TransMax, UW *puw_ClkDiv)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW	uw_Imclk;

    uw_Imclk = p_sdd->uw_Imclk;

	if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_1 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_1;
	} else if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_2 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_2;
	} else if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_4 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_4;
	} else if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_8 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_8;
	} else if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_16 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_16;
	} else if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_32 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_32;
	} else if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_64 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_64;
	} else if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_128 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_128;
	} else if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_256 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_256;
	} else if(uw_TransMax >= (UW)(uw_Imclk >> (SDD_CLOCK_DIV_512 - 1))) {
		*puw_ClkDiv = SDD_CLOCK_DIV_512;
	} else {
		*puw_ClkDiv = 0;
	}

	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CheckDiv TransMax=%ld uw_Imclk=%ld ClkDiv=%ld\n",
					uw_TransMax, uw_Imclk, *puw_ClkDiv);
}

/********************************************************************************/
/*  ֐		FSdds_CheckSetDiv												*/
/*  Tv		Fݒ肷镪߂(PeaksPro2p)							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F																*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
SDD_ERROR Sdds_CheckSetDiv(SDD_HANDLE *p_SddHandle, UW uw_ClockDiv, UW *puw_SetDiv)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uw_CsdDiv;

	switch (uw_ClockDiv) {
		case SDD_CLOCK_DIV_FULLSPEED:
			if (p_sdd->uh_Rca != 0){	/* J[h܂͏ */
				Sdds_GetCsdTransSpeed(p_SddHandle, &uw_CsdDiv);
				Sdds_CheckDiv(p_SddHandle, uw_CsdDiv, puw_SetDiv);
			}
			else {
                *puw_SetDiv = SDD_CLOCK_DIV_2; /* J[h܂̓J[hȂ */\
			}
			break;
		case SDD_CLOCK_DIV_LOWSPEED:
			*puw_SetDiv = SDD_CLOCK_DIV_256; /* MMCΉ */
			break;
		case SDD_CLOCK_DIV_1:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_2: 	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_4:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_8: 	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_16:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_32: 	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_64:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_128:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_256:	/* ܂Ƃ߂break̂߂ł͏ȗ */
		case SDD_CLOCK_DIV_512:
			if (Sdds_GetStatus(p_SddHandle) & SDD_STATUS_INITFLG) {
				Sdds_GetCsdTransSpeed(p_SddHandle, &uw_CsdDiv);
				Sdds_CheckDiv(p_SddHandle, uw_CsdDiv, puw_SetDiv);
				if(uw_ClockDiv < *puw_SetDiv){
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
				}else{
					*puw_SetDiv = uw_ClockDiv;
				}
			}
			else {
				*puw_SetDiv = uw_ClockDiv;
			}
			break;
		default:
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
			break;
	}
	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_CheckSetDiv ClockDiv=%ld SetDiv=%ld\n",
					uw_ClockDiv, *puw_SetDiv);
	return w_Result;
}

#endif /* defined(_SDD_PEAKS_PRO2_) */
