/********************************************************************************/
/*  t@C    F$Workfile: SddError.c $                                     */
/*  Tv          FSDfoCXhCoG[֘At@C                    */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 06/06/12 15:00 $                                  */
/********************************************************************************/
#include "SddCom.h"
#include "SddRegister.h"
#include "SddError.h"
#include "SddIoctl_sdio.h"
#if SDD_DEBUG_PRINT_LEVEL != 0
#ifdef _SDD_T_ENGINE_
#include <stdio.h>
#include <stdarg.h>
#endif /* _SDD_T_ENGINE_ */
#endif /* SDD_DEBUG_PRINT_LEVEL */

/* Tu֐t@C */
#if defined(_SDD_USE_SDMACLIB_)
#include "device/SddError_for_sdmaclib.c"
#endif /* defined(_SDD_USE_SDMACLIB_) */

#if defined(_SDD_PCAM_)
#include "device/SddError_for_pcam.c"
#endif /* defined(_SDD_PCAM_) */

/********************************************************************************/
/*  ֐		FSdds_CheckErr													*/
/*  Tv		FG[R[h`FbN										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FG[R[h													*/
/*				F`FbNG[											*/
/*  ߂l		FG[ݒ肳Ă != 0									*/
/*				FG[ݒ肳ĂȂ == 0									*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
UW Sdds_CheckErr( SDD_HANDLE *p_SddHandle, SDD_ERROR w_ErrCode, SDD_ERROR w_Err )
{
	if(w_Err & SDD_ERR_MASK_SERIAL) {	/* VAG[̏ꍇ */
		if((w_ErrCode & SDD_ERR_MASK_SERIAL) == w_Err) {
			return 1;	/* w̃G[̓G[R[hɐݒ肳Ă */
		} else {
			return 0;	/* w̃G[̓G[R[hɐݒ肳ĂȂ */
		}
	} else {							/* rbgG[̏ꍇ */
		if(w_ErrCode & SDD_ERR_MASK_ERRBIT & w_Err) {
			return 1;	/* w̃G[̓G[R[hɐݒ肳Ă */
		} else {
			return 0;	/* w̃G[̓G[R[hɐݒ肳ĂȂ */
		}
	}
}

/********************************************************************************/
/*  ֐		FSdds_CheckLastSectorError 									*/
/*  Tv		FŏIZN^ANZXG[΍	 								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_SendSec, SDD_ERROR *w_ResTmp							*/
/*  ߂l		FȂ                											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
SDD_ERROR Sdds_CheckLastSectorError(SDD_HANDLE *p_SddHandle, UW uw_SendSec, SDD_ERROR w_ResTmp)
{	
    SDD_ERROR w_Result = w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

     /* sJ[h΍ */
     /* seFŏIAhX,ŏI-1AhX(̂)ւ̃ANZXRead/WriteOUT_OF_RANGEG[𔭐 */
     /* FOUT_OF_RANGEG[Ăꍇ̓G[NA */
    
    if (w_Result == SDD_ERR_R1_STATUS) {
	    if ( ((p_sdd->uw_Offset + uw_SendSec == p_sdd->uw_NormalSize - 1) || (p_sdd->uw_Offset + uw_SendSec == p_sdd->uw_NormalSize)) 
			&& ((p_sdd->uw_CardStatus & SDD_CARD_STATUS_ERROR) == SDD_CARD_STATUS_OUT_OF_RANGE) ) {
				w_Result = SDD_SUCCESS;	/* OUT_OF_RANGEG[NA */
	    }
	}	

    return w_Result;
}                

/********************************************************************************/
/*  ֐		FSdds_ErrorProcess												*/
/*  Tv		FJ[hG[̃G[V[PX						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FSDD_ERROR w_ErrCode											*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sdds_ErrProcess(SDD_HANDLE *p_SddHandle, SDD_ERROR w_ErrCode)
{
	Sddr_DisIntReadyCMD(p_SddHandle);		/* SD_INFO1_MASKSD_INFO2_MASK̃}XN */

	if (Sdds_CheckErr(p_SddHandle, w_ErrCode, SDD_ERR_CARD_OUT) == 0) {
		if (Sdds_CheckErr(p_SddHandle, w_ErrCode, SDD_ERR_OS_TIMEOUT)) { /* J[hroG[ȊO */
			Sdds_ErrorStop(p_SddHandle, FALSE);
		}
		else {
			Sdds_ErrorStop(p_SddHandle, TRUE);		/* STOPR}hs */
		}
	}

	if(Sddr_CheckSecCnt(p_SddHandle)) {	/* ]ZN^ݒ肪L`FbN(֐FSD_STOPWX^LE`FbN) */
		Sddr_DisSecCnt(p_SddHandle);	/* ]ZN^ݒ肪LȏꍇAݒi֐FSD_SECCNTWX^ݒj */
	}

	return;
}

/********************************************************************************/
/*  ֐		FSdds_SetErr													*/
/*  Tv		FG[ݒ菈												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FG[R[h													*/
/*				FVɔG[											*/
/*  ߂l		FVG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdds_SetErr(SDD_HANDLE *p_SddHandle, int iLine, SDD_ERROR w_ErrCode, SDD_ERROR w_Err )
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    UW uw_Mode;

    if(w_Err != SDD_SUCCESS) {
		if(w_ErrCode & SDD_ERR_MASK_SERIAL) {	/* ɘ_aȊÕG[ݒ肳Ăꍇ */
			w_ErrCode |= (w_Err & SDD_ERR_MASK_ERRBIT);
			/* G[uꍇ͂ɏ */
	
		} else {		/* ɘ_aȊÕG[ݒ肳ĂȂꍇ */
			w_ErrCode = w_Err | (w_ErrCode & SDD_ERR_MASK_ERRBIT);
		}
        if (Sdds_DoExecCommandError(p_SddHandle, w_ErrCode)) {
            /* ʏ탂[h̏ꍇɂ̓WX^lo(STANDBY[hɂ̓WX^ɃANZXoȂ) */
            Sddr_GetModeRegister(p_SddHandle, &uw_Mode);
            if (uw_Mode == SDD_MODE_NORMAL) {
#ifdef _SDD_EXTERNAL_POWER_CONTROL_
                Sdds_DebugPrint(iLine, SDD_PWARN,"ER %lX %04lX %04lX %04lX %X %X %X\n",
                                w_Err,
                                p_sdd->uw_SDINFO1_INTERR, p_sdd->uw_SDINFO2_INTERR,
                                p_sdd->w_error,
                                p_sdd->SddCommandSendData.uh_Cmd,
                                p_sdd->SddCommandSendData.uh_Arg0,
                                p_sdd->SddCommandSendData.uh_Arg1);
#else
                Sdds_DebugPrint(iLine, SDD_PWARN,"ER %lX %04lX %04lX %04lX %04lX %04lX %04lX %04lX %X %X %X\n",
                                w_Err,
                                SDD_SD_INFO1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),
                                SDD_SD_INFO2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),
                                SDD_SD_ERR_STR1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),
                                SDD_SD_ERR_STR2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),
                                p_sdd->uw_SDINFO1_INTERR, p_sdd->uw_SDINFO2_INTERR,
                                p_sdd->w_error,
                                p_sdd->SddCommandSendData.uh_Cmd,
                                p_sdd->SddCommandSendData.uh_Arg0,
                                p_sdd->SddCommandSendData.uh_Arg1);
#endif
            }
            else {
                Sdds_DebugPrint(iLine, SDD_PWARN,"ER %lX\n",w_Err);
            }
        }
	}
	return w_ErrCode;
}

/*********************************************************************************/
/*  ֐		FSdds_DoExecCommandError										 */
/*  Tv		FR}hG[֐									 */
/*                G[sR}h{G[̃Zbg𔻒肷       */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FSDD_ERROR w_err G[ԍ                                 */
/*  ߂l		FBOOL TRUE:G[{,FALSE:R}hG[{Ȃ*/
/*  ŏIXV	F2009.3.9													    */
/*********************************************************************************/
BOOL Sdds_DoExecCommandError(SDD_HANDLE *p_SddHandle, SDD_ERROR w_err) {
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    if ((p_sdd->SddCommandSendData.uh_Cmd==SDD_CMD_IF_COND && w_err == SDD_ERR_IP_TIMEOUT) ||
        (p_sdd->SddCommandSendData.uh_Cmd==SDD_CMD_CARDRST && w_err == SDD_ERR_CARD_OUT)
#ifdef _SDD_FUNC_SDIO_
		||(p_sdd->SddCommandSendData.uh_Cmd==SDD_CMD_PREACMD && p_sdd->uw_TmpOperationMode == SDD_CARD_INIT_MODE_SDIO) ||
        (p_sdd->SddCommandSendData.uh_Cmd==SDD_CMD_IO_OP_COND && p_sdd->uw_TmpOperationMode == SDD_CARD_INIT_MODE_MEMORY) ||
        (p_sdd->SddCommandSendData.uh_Cmd==SDD_CMD_IO_RW_DIRECT_WRITE && p_sdd->uw_TmpOperationMode == SDD_CARD_INIT_MODE_SDIO && p_sdd->SddCommandSendData.uh_Arg0 == SDD_ARG0_IOCARD_RST && p_sdd->SddCommandSendData.uh_Arg1 == SDD_ARG1_IOCARD_RST ) 
#endif
#ifdef _SDD_HIGHSPEEDCLK_
		||(p_sdd->SddCommandSendData.uh_Cmd==SDD_CMD_CARDFUNC && w_err == SDD_ERR_NOT_SUPPORT)
#endif
        ) {
			/* CMD8Ń^CAEg̏ꍇɂ̓G[L͂Ȃ(RFȃJ[hłVer2.0Ή̏ꍇɂ͔) */
			/* CMD0ŃJ[h̏ꍇɂ̓G[L͂Ȃ(RFJ[hŏɔ) */
			/* SDIO[hACMD55`FbNɂ̓G[L͂Ȃ(RFSDIOʎɏɔ) */
			/* [hCMD5`FbNɂ̓G[L͂Ȃ(RFJ[hʎɏɔ) */
        return FALSE;
    }
    else {
        return TRUE;
    }
    
}

/********************************************************************************/
/*  ֐		FSdds_PrintCardInfo											*/
/*  Tv		F\												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ											@@@@@@@@*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
void Sdds_PrintCardInfo(SDD_HANDLE *p_SddHandle) {
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uh_Status=%d\n",p_sdd->uh_Status);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"ub_Preflg=%d\n",p_sdd->ub_Preflg);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"ub_CardType=%d\n",p_sdd->ub_CardType);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_CardSize=%ld\n",p_sdd->uw_CardSize);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_NormalSize=%ld\n",p_sdd->uw_NormalSize);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_SectorSize=%ld\n",p_sdd->uw_SectorSize);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_UsbRwSector=%ld\n",p_sdd->uw_UsbRwSector);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_Wp=%ld\n",p_sdd->uw_Wp);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_EraseByteMin=%ld\n",p_sdd->uw_EraseByteMin);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Result(uw_Resid)=%ld\n",p_sdd->Result.uw_Resid);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Result(w_Result)=%ld\n",p_sdd->Result.w_Result);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Result(uh_Flag)=%d\n",p_sdd->Result.uh_Flag);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uh_Rca=%d\n",p_sdd->uh_Rca);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_CardStatus=%ld\n",p_sdd->uw_CardStatus);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"w_error=%ld\n",p_sdd->w_error);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_CardFunc=%ld\n",p_sdd->uw_CardFunc);
#ifndef _SDD_RW_WAIT_
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_CardInfo=%ld\n",p_sdd->uw_CardInfo);
#endif /* _SDD_RW_WAIT_ */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"ub_DetectInfo=%d\n",p_sdd->ub_DetectInfo);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"uw_SecureSize=%ld\n",p_sdd->uw_SecureSize);
    Sdds_DebugPrint(__LINE__, SDD_PBUFDEBUG,"OCR:\n");
    Sdds_DebugBufPrint(__LINE__, SDD_PBUFDEBUG, p_sdd->ub_Ocr, SDD_OCR_SIZE);
    Sdds_DebugPrint(__LINE__, SDD_PBUFDEBUG,"CID:\n");
    Sdds_DebugBufPrint(__LINE__, SDD_PBUFDEBUG, p_sdd->ub_Cid, SDD_CID_SIZE);
    Sdds_DebugPrint(__LINE__, SDD_PBUFDEBUG,"CSD:\n");
    Sdds_DebugBufPrint(__LINE__, SDD_PBUFDEBUG, p_sdd->ub_Csd, SDD_CSD_SIZE);
    Sdds_DebugPrint(__LINE__, SDD_PBUFDEBUG,"SCR:\n");
    Sdds_DebugBufPrint(__LINE__, SDD_PBUFDEBUG, p_sdd->ub_Scr, SDD_SCR_SIZE);
    Sdds_DebugPrint(__LINE__, SDD_PBUFDEBUG,"SDSTATUS:\n");
    Sdds_DebugBufPrint(__LINE__, SDD_PBUFDEBUG, p_sdd->ub_SdStatus, SDD_SDSTATUS_SIZE);
}
#if SDD_DEBUG_PRINT_LEVEL != 0
/********************************************************************************/
/*  ֐		FSdds_DebugPrint												*/
/*  Tv		FfobOo͏֐											*/
/*                SDD_DEBUG_PRINT_LEVELȉ̃xݒ̏ꍇAfobOo͎{ */
/*  		Fint iLine __LINE__ C}N͏                       */
/*                int iLevel o̓x											*/
/*                           SDD_PDEBUG fobOpr                            */
/*                           SDD_PWORN  [jOxpr                    */
/*                           SDD_PERR   G[xpr                        */
/*				Fconst char *format,...printf								*/
/*  ߂l		FȂ											                */
/*  ŏIXV	F2007.10.17													*/
/********************************************************************************/
#if defined(_SDD_T_ENGINE_)
void Sdds_DebugPrint(int iLine, int iLevel, const char *format, ...) {
    va_list va;
    if (iLevel <= SDD_DEBUG_PRINT_LEVEL) {
        va_start(va, format);
        printf("SDD:%d ",iLine);
        vprintf(format, va);
        va_end(va);
    }
}
#elif defined(_SDD_ITRON_)
void Sdds_DebugPrint(int iLine, int iLevel, const char *format, ...) {	/* MISRAOK:3:1332 ψŎgp@ɖȂ */
}
#endif /* defined(_SDD_T_ENGINE_) */
#elif SDD_DEBUG_PRINT_LEVEL == 0
#if defined(_SDD_ITRON_)
void Sdds_DebugPrint(int iLine, int iLevel, const char *format, ...) {	/* MISRAOK:3:1332 ψŎgp@ɖȂ */
}
#endif /*defined(_SDD_ITRON_) */
#endif /* SDD_DEBUG_PRINT_LEVEL != 0 */

#if SDD_DEBUG_PRINT_LEVEL != 0
/********************************************************************************/
/*  ֐		FSdds_DebugBufPrint											*/
/*  Tv		Fobt@pfobOo͏֐								*/
/*                SDD_DEBUG_PRINT_LEVELȉ̃xݒ̏ꍇAfobOo͎{ */
/*  		Fint iLine __LINE__ C}N͏                       */
/*                int iLevel o̓x											*/
/*                           SDD_PDEBUG fobOpr                            */
/*                           SDD_PWORN  [jOxpr                    */
/*                           SDD_PERR   G[xpr                        */
/*				Fconst char *buf obt@|C^								*/
/*              : int num    \obt@TCY                                 */
/*  ߂l		FȂ											                */
/*  ŏIXV	F2009.7.13													    */
/********************************************************************************/
#if defined(_SDD_T_ENGINE_)
void Sdds_DebugBufPrint(int iLine, int iLevel, const char *buf, int num) {
    int i;
    if (iLevel <= SDD_DEBUG_PRINT_LEVEL) {
        for(i=0; i<num; i++) {
            if (i!=0 && i%16==0) {
                printf("\n");
            }
            printf("%02X ", (unsigned char)buf[i]);
        }
        printf("\n");
    }
}
#elif defined(_SDD_ITRON_)
void Sdds_DebugBufPrint(int iLine, int iLevel, const char *buf, int num) {
}
#endif /* defined(_SDD_T_ENGINE_) */
#elif SDD_DEBUG_PRINT_LEVEL == 0
#if defined(_SDD_ITRON_)
void Sdds_DebugBufPrint(int iLine, int iLevel, const char *buf, int num) {
}
#endif /*defined(_SDD_ITRON_) */
#endif /* SDD_DEBUG_PRINT_LEVEL != 0 */
