/***********************************************************************************/
/*  t@C  F$Workfile: SddOsEvent.c $                                        */
/*  Tv        FSDfoCXhCoOSnCxgi[t@C(Linuxp)          */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.            */
/*  ŏIXV  F$Modtime: 07/12/12 10:25 $                                       */
/***********************************************************************************/
#ifdef _SDD_LINUX_
#include <linux/delay.h>

/********************************************************************************/
/*  ֐		FSdd_ClrEvent													*/
/*  Tv		FCxgNA												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FT_OS_EVENT *eve  Cxg\̃|C^                   */
/*                UW SddFlgptn     NAtOp^[							*/
/*  ߂l		FIFSDD_SUCCESS											*/
/*				FُI p[^G[FSDD_ERR_PARAM						*/
/*  ŏIXV	F2009.03.13													*/
/********************************************************************************/
SDD_ERROR Sdd_ClrEvent(SDD_HANDLE *p_SddHandle, T_OS_EVENT *eve, UW SddFlgptn)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    
    spin_lock_irqsave(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags);   //  spin_lock(spin_lock_irqsave,spin_unlock_irqrestore͓֐R[Kv

    eve->uw_EventFlag &= ~SddFlgptn;
    
    spin_unlock_irqrestore(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags); //  spin_lock

    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSdd_SetEvent													*/
/*  Tv		FCxgʒm													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FT_OS_EVENT *eve  Cxg\̃|C^                   */
/*              Fuw_event CxgiDMAʒm(SDD_EVENT_DMA)				*/
/*				F						Response endʒm(SDD_EVENT_RES)			*/
/*				F						R/W access end(SDD_EVENT_RWEND)			*/
/*  			F						^CAEgʒm(SDD_EVENT_TMOUT)		*/
/*				F						J[h}ʒm(SDD_EVENT_CARD_IN)		*/
/*				F						J[hoʒm(SDD_EVENT_CARD_OUT)		*/
/*  			F						G[ʒm(SDD_EVENT_ERROR))			*/
/*  ߂l		FIFSDD_SUCCESS											*/
/*				FُIFVXeR[G[iVXeُj				*/
/*  ŏIXV	F2009.03.13													*/
/********************************************************************************/
SDD_ERROR Sdd_SetEvent(SDD_HANDLE *p_SddHandle, T_OS_EVENT *eve, UW uw_event)
{	
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    spin_lock_irqsave(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags);   //  spin_lock(spin_lock_irqsave,spin_unlock_irqrestore͓֐R[Kv

    eve->uw_EventFlag |= uw_event;
    
    spin_unlock_irqrestore(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags); //  spin_lock

    wake_up(&(eve->wq));

	return SDD_SUCCESS;	
}

/********************************************************************************/
/*  ֐		FSdd_WaiEvent													*/
/*  Tv		FCxg҂													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FT_OS_EVENT *eve  Cxg\̃|C^                   */
/*              FUW SddFlgptn, UW *p_SddFlgptn, UW uw_tmout					*/
/*  ߂l		FIFSDD_SUCCESS											*/
/*				FُI p[^G[FSDD_ERR_PARAM						*/
/*				F         ^CAEg    FSDD_ERR_OS_TIMEOUT					*/
/*  ŏIXV	F2009.03.13													*/
/********************************************************************************/
SDD_ERROR Sdd_WaiEvent(SDD_HANDLE *p_SddHandle, T_OS_EVENT *eve, UW SddFlgptn, UW *p_SddFlgptn, UW uw_tmout)
{
	SDD_ERROR w_ret;
	
    w_ret = wait_event_timeout(eve->wq, (eve->uw_EventFlag & SddFlgptn),  (UDW)(HZ * uw_tmout) / 1000);
    if (w_ret < 0) {
		Sdd_ClrEvent(p_SddHandle, eve, (eve->uw_EventFlag & SddFlgptn));  /* ITronTA_CLR̃tOɂ킹ׂɃCxgNA */
        return SDD_ERR_PARAM;
    }
    else if (w_ret == 0) {
		Sdd_ClrEvent(p_SddHandle, eve, (eve->uw_EventFlag & SddFlgptn));  /* ITronTA_CLR̃tOɂ킹ׂɃCxgNA */
        return SDD_ERR_OS_TIMEOUT;
    }
    else {
        *p_SddFlgptn = eve->uw_EventFlag;
        Sdd_ClrEvent(p_SddHandle, eve, (*p_SddFlgptn&SddFlgptn));         /* ITronTA_CLR̃tOɂ킹ׂɃCxgNA */
        return SDD_SUCCESS;
    }
}

/********************************************************************************/
/*  ֐		FSdd_Delay														*/
/*  Tv		FrW[EFCg												*/
/*  		FUW uw_Wait													*/
/*  ߂l		FI:SDD_SUCCESS											*/
/*				@ُI:p[^G[(SDD_ERR_PARAM)						*/
/*						   ^CAEgG[iSDD_ERR_OS_TIMEOUT)				*/
/*  ŏIXV	F2007.12.12													*/
/********************************************************************************/
SDD_ERROR Sdd_Delay(UW uw_Wait)
{
/* #20325 modify start */
    long wait_time;

    if(uw_Wait < (1000/HZ)*2) {
       mdelay(uw_Wait);
    }
    else {
       wait_time = msecs_to_jiffies(uw_Wait);
       while(wait_time)
         wait_time = schedule_timeout(wait_time);
    }
    return SDD_SUCCESS;
/* #20325 modify end */
}

/************************************************************************************/
/*  ֐		FSdd_CreEve													    */
/*  Tv		FCxgtO												*/
/*  		FT_OS_EVENT *eve CxgtO\̃|C^					*/
/*  ߂l		FIFSDD_SUCCESS												*/
/*  ŏIXV	F2009.3.2															*/
/************************************************************************************/
SDD_ERROR Sdd_CreEve(T_OS_EVENT *eve)
{
    /* [NL[̏ */
    init_waitqueue_head(&(eve->wq));
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSdd_DelEve												    */
/*  Tv		FCxgtO폜											*/
/*  		FT_OS_EVENT *eve CxgtO\̃|C^				*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.3														*/
/********************************************************************************/
SDD_ERROR Sdd_DelEve(T_OS_EVENT *eve)
{
    /* Ȃ */
    return SDD_SUCCESS;		/* ߂l^[ */
}

/************************************************************************************/
/*  ֐		FSdds_CreateEvent												    */
/*  Tv		FCxg쐬									                */
/*  			FCxgp[NL[̍쐬sB                      */
/* 			FȂ																*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2008.1.8															*/
/************************************************************************************/
SDD_ERROR Sdds_CreateEvent(void)
{
	SDD_DEV	*p_sdd;
    SDD_ERROR w_Result;
    UW i;

    for(i=0; i<SDD_DEV_COUNT; i++) {
        p_sdd = &(SddDev[i]);
        w_Result = Sdd_CreEve(&(p_sdd->OsInfo.normalEventFlag));
        if(w_Result != SDD_SUCCESS){			/* 0ȊȌꍇ̓VXeR[G[ */
            return w_Result;
        }
    }
    return w_Result;
}


#ifdef _SDD_USE_ITRON_H_
/********************************************************************************/
/*  ֐		FSdd_SetTim0													*/
/*  Tv		FVXe0ɐݒ											*/
/*  		FSYSTIM *p_systim												*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.7.29 													*/
/********************************************************************************/
SDD_ERROR Sdd_SetTim0( SYSTIM *p_systim )
{
	/* ݂jiffies */
	jiffies=0;  
	return SDD_SUCCESS;	
}

/********************************************************************************/
/*  ֐		FSdd_GetTimR													*/
/*  Tv		F݂̃VXe擾										*/
/*  		FSYSTIM *p_systim												*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.7.29 													*/
/********************************************************************************/
SDD_ERROR Sdd_GetTimR( SYSTIM *p_systim )
{
	*p_systim=(SYSTIM)((jiffies*HZ)/1000); /* ݃VXe擾	*/

	return SDD_SUCCESS;	
}

/********************************************************************************/
/*  ֐		FSdd_GetTimLow													*/
/*  Tv		FVXe(Low)o										*/
/*  		FSYSTIM *p_systim												*/
/*  ߂l		FVXe(Low)												*/
/*  ŏIXV	F2009.7.29 													*/
/********************************************************************************/
UW Sdd_GetTimLow( SYSTIM *p_systim )
{
	return (UW)(*p_systim);	
}

/********************************************************************************/
/*  ֐		FSdd_Gettim													*/
/*  Tv		F݂̃VXe擾										*/
/*  		FSYSTIM *p_systim												*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.7.29 													*/
/********************************************************************************/
void Sdd_GetTim( SYSTIM *p_systim )
{
	*p_systim=(SYSTIM)((jiffies*HZ)/1000); /* ݃VXe擾	*/

	return;	
}
#else
/********************************************************************************/
/*  ֐		FSdd_SetTim0													*/
/*  Tv		FVXe0ɐݒ											*/
/*  		FSYSTIM *p_systim												*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2008.5.13 													*/
/********************************************************************************/
SDD_ERROR Sdd_SetTim0( SYSTIM *p_systim )
{
	/* ݂jiffies */
	jiffies=0;  
	return SDD_SUCCESS;	
}

/********************************************************************************/
/*  ֐		FSdd_GetTimR													*/
/*  Tv		F݂̃VXe擾										*/
/*  		FSYSTIM *p_systim												*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2008.5.13 													*/
/********************************************************************************/
SDD_ERROR Sdd_GetTimR( SYSTIM *p_systim )
{
	p_systim->hi=0;
#if 0	/* Ida */
	p_systim->lo=(UW)(((UDW)jiffies*(UDW)HZ)/1000); /* ݃VXe擾	*/
#else	/* Ida */
	p_systim->lo = (UW)(((UDW)jiffies * TICK_USEC)/1000UL);
#endif	/* Ida */

	return SDD_SUCCESS;	
}

/********************************************************************************/
/*  ֐		FSdd_GetTimLow													*/
/*  Tv		FVXe(Low)o										*/
/*  		FSYSTIM *p_systim												*/
/*  ߂l		FVXe(Low)												*/
/*  ŏIXV	F2004.11.17 													*/
/********************************************************************************/
UW Sdd_GetTimLow( SYSTIM *p_systim )
{
	UW w_timlow;
	
	w_timlow = p_systim->lo;					/* VXe(Low)Ԃ	*/
	
	return w_timlow;	
}

#define TICK_MSEC ((1000UL + USER_HZ/2) / USER_HZ)
/********************************************************************************/
/*  ֐		FSdd_Gettim													*/
/*  Tv		F݂̃VXe擾										*/
/*  		FSYSTIM *p_systim												*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2004.11.17 													*/
/********************************************************************************/
void Sdd_GetTim( SYSTIM *p_systim )
{
	p_systim->hi=0;
#if 0	/* Ida */
	p_systim->lo=(UW)(((UDW)jiffies*(UDW)HZ)/1000); /* ݃VXe擾	*/
	p_systim->lo = (UW)(((UDW)jiffies * TICK_USEC)/1000UL);
	printk("SDD:%s() systim update p_systim->lo = 0x%08x \n", __FUNCTION__, p_systim->lo);
#else	/* Ida */
	p_systim->lo = (UW)((UDW)jiffies * TICK_MSEC);
#endif	/* Ida */

	return;	
}
#endif

#ifdef _SDD_SDCARDINOUT_KENSHO_
/********************************************************************************/
/*  ֐		FSdd_WaitHumanIF												*/
/*  Tv		FlԂ̑҂										        */
/*  		FȂ												            */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.12.14 													*/
/********************************************************************************/
void Sdd_WaitHumanIF() {
    printk("(in 2 sec)");
    Sdd_Delay(2000);
}
#endif
#endif /* _SDD_LINUX_ */

