/***********************************************************************************/
/*  t@C  F$Workfile: SddOsIntr.c $                                         */
/*  Tv        FSDfoCXhCoOSn荞ݏi[t@C(Linuxp)          */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.            */
/*  ŏIXV  F$Modtime: 06/06/12 09:45 $                                       */
/*                SDD_Intr()Oǉ 2006/06/30 H.Miura                          */
/*                WX^ݒ菈Sddr_GetResponseƒu2006/06/30 H.Miura   */
/*                SDD_Intrp݌㏈ǉ 2006/06/30 H.Miura                  */
/*                SDD_Intrpǂݍ݌㏈ǉ 2006/06/30 H.Miura                  */
/***********************************************************************************/
#ifdef _SDD_LINUX_
#include <linux/irq.h>
#include <asm/irq.h>
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
#include <mach/intctl-regs.h>
#endif  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

#ifdef _SDD_AM_LINUX_
#ifdef	_SDD_ACRE_ISR_

#ifndef _SDD_EXTERNAL_INTR_CONTROL_
#ifdef _SDD_UPPER_2_6_18_
struct irq_chip *oldhandler[NR_IRQS];
#else /* _SDD_UPPER_2_6_18_ */
hw_irq_controller *oldhandler[NR_IRQS];
#endif /* _SDD_UPPER_2_6_18_ */

static unsigned int SDD_StartupIRQ(unsigned int irq) {
    oldhandler[irq]->startup(irq);
	return SDD_SUCCESS;
}
static void SDD_ShutdownIRQ(unsigned int irq) {
	oldhandler[irq]->shutdown(irq);
}
static void SDD_EnableIRQ(unsigned int irq) {
    oldhandler[irq]->enable(irq);
}
static void SDD_DisableIRQ(unsigned int irq) {
	oldhandler[irq]->disable(irq);
}
static void SDD_AckIRQ(unsigned int irq) {
    oldhandler[irq]->end(irq);
}
static void SDD_EndIRQ(unsigned int irq) {
    oldhandler[irq]->ack(irq);
}
#ifdef _SDD_UPPER_2_6_18_
static struct irq_chip SDD_IrqType = {
	"sdcard",
	SDD_StartupIRQ,
	SDD_ShutdownIRQ,
	SDD_EnableIRQ,
	SDD_DisableIRQ,
	SDD_AckIRQ,
	SDD_EndIRQ,
    NULL
};
#else /* _SDD_UPPER_2_6_18_ */
static struct hw_interrupt_type SDD_IrqType = {
	"sdcard",
	SDD_StartupIRQ,
	SDD_ShutdownIRQ,
	SDD_EnableIRQ,
	SDD_DisableIRQ,
	SDD_AckIRQ,
	SDD_EndIRQ,
    NULL
};
#endif /* _SDD_UPPER_2_6_18_ */
#endif	/* !_SDD_EXTERNAL_INTR_CONTROL_ */

/********************************************************************************/
/*  ֐		FSdd_AcreIsr													*/
/*  Tv		F荞݃nho^											*/
/*  		FT_OS_INTR *osintr 荞ݏ|C^                        */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.4.21														*/
/********************************************************************************/
SDD_ERROR Sdd_AcreIsr(T_OS_INTR *osintr)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
#ifndef _SDD_EXTERNAL_INTR_CONTROL_
#ifdef _SDD_UPPER_2_6_18_
	oldhandler[osintr->intNo] = irq_desc[osintr->intNo].chip;
	irq_desc[osintr->intNo].chip = &SDD_IrqType;
#else
	oldhandler[osintr->intNo] = irq_desc[osintr->intNo].handler;
	irq_desc[osintr->intNo].handler = &SDD_IrqType;
#endif
#endif

    w_ret = request_irq(osintr->intNo, (void *)osintr->isr, 0, osintr->device, (void *)(osintr->device));
#ifndef _SDD_EXTERNAL_INTR_CONTROL_ 
    irq_desc[osintr->intNo].depth = 1;
#endif
    return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_DelIsr													*/
/*  Tv		F荞݃nh폜											*/
/*  		FT_OS_INTR *osintr 荞ݏ|C^                        */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.4.21														*/
/********************************************************************************/
SDD_ERROR Sdd_DelIsr(T_OS_INTR *osintr)
{
    free_irq(osintr->intNo, (void *)(osintr->device));
#ifndef _SDD_EXTERNAL_INTR_CONTROL_
#ifdef _SDD_UPPER_2_6_18_
	irq_desc[osintr->intNo].chip = oldhandler[osintr->intNo];
#else
	irq_desc[osintr->intNo].handler = oldhandler[osintr->intNo];
#endif
#endif
    return SDD_SUCCESS;
}
#endif /* _SDD_ACRE_ISR_ */

/********************************************************************************/
/*  ֐		FSdd_DisInt													*/
/*  Tv		F荞݋֎~													*/
/*  		FT_OS_INTR *osintr 荞ݏ|C^                        */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.2.17														*/
/********************************************************************************/
SDD_ERROR Sdd_DisInt(T_OS_INTR *osintr)
{
#ifndef _SDD_EXTERNAL_INTR_CONTROL_
    oldhandler[osintr->intNo]->disable(osintr->intNo);
#endif
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSdd_EnaInt													*/
/*  Tv		F荞݋													*/
/*  		FT_OS_INTR *osintr 荞ݏ|C^                        */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.2.17														*/
/********************************************************************************/
SDD_ERROR Sdd_EnaInt(T_OS_INTR *osintr)
{
#ifndef _SDD_EXTERNAL_INTR_CONTROL_
	oldhandler[osintr->intNo]->enable(osintr->intNo);
#endif
    return SDD_SUCCESS;
}

irqreturn_t  (*SDD_IntrFunc[])(int irq, void *dev_id, struct pt_regs *regs) = {
    SDD_Intr_0
#if SDD_DEV_COUNT >= 2
    ,SDD_Intr_1
#endif
#if SDD_DEV_COUNT >= 3
    ,SDD_Intr_2
#endif
};

irqreturn_t  (*Sdd_DMAIntrFunc[])(int irq, void *dev_id, struct pt_regs *regs) = {
    Sdd_DMAIntr_0
#if SDD_DEV_COUNT >= 2
    ,Sdd_DMAIntr_1
#endif
#if SDD_DEV_COUNT >= 3
    ,Sdd_DMAIntr_2
#endif
};
/********************************************************************************/
/*  ֐		FSDD_Intr_0												    */
/*  Tv		FSDD_Intr Port0pĂяo(Linux)							*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
irqreturn_t SDD_Intr_0(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_Intr{ */
	SDD_Intr(&(SddHandleForDriver[0]));
	return IRQ_HANDLED;
}

/********************************************************************************/
/*  ֐		FSdd_DMAIntr_0											        */
/*  Tv		FSDD_DMAIntr Port0pĂяo(Linux)						*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
irqreturn_t Sdd_DMAIntr_0(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_DMAIntr{ */
	SDD_DMAIntr(&(SddHandleForDriver[0]));
	return IRQ_HANDLED;
}

#if SDD_DEV_COUNT >= 2
/********************************************************************************/
/*  ֐		FSDD_Intr_1												    */
/*  Tv		FSDD_Intr Port1pĂяo(Linux)							*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
irqreturn_t SDD_Intr_1(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_Intr{ */
	SDD_Intr(&(SddHandleForDriver[1]));
	return IRQ_HANDLED;
}

/********************************************************************************/
/*  ֐		FSdd_DMAIntr_1											        */
/*  Tv		FSDD_DMAIntr Port1pĂяo(Linux)						*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
irqreturn_t Sdd_DMAIntr_1(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_DMAIntr{ */
	SDD_DMAIntr(&(SddHandleForDriver[1]));
	return IRQ_HANDLED;
}
#endif

#if SDD_DEV_COUNT >= 3
/********************************************************************************/
/*  ֐		FSDD_Intr_2												    */
/*  Tv		FSDD_Intr Port2pĂяo(Linux)							*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2010.3.9														*/
/********************************************************************************/
irqreturn_t SDD_Intr_2(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_Intr{ */
	SDD_Intr(&(SddHandleForDriver[2]));
	return IRQ_HANDLED;
}

/********************************************************************************/
/*  ֐		FSdd_DMAIntr_2											        */
/*  Tv		FSDD_DMAIntr Port2pĂяo(Linux)						*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2010.3.9														*/
/********************************************************************************/
irqreturn_t Sdd_DMAIntr_2(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_DMAIntr{ */
	SDD_DMAIntr(&(SddHandleForDriver[2]));
	return IRQ_HANDLED;
}
#endif

#else	/* _SDD_AM_LINUX_ */

#ifdef	_SDD_ACRE_ISR_
static unsigned int SDD_StartupIRQ(unsigned int irq) {
	return SDD_SUCCESS;
}
static void SDD_ShutdownIRQ(unsigned int irq) {
}
static void SDD_EnableIRQ(unsigned int irq) {
	EnableGicr(irq); /* enable irq for SD */
}
static void SDD_DisableIRQ(unsigned int irq) {
	DisableGicr(irq); /* disable irq for SD */
}
static void SDD_AckIRQ(unsigned int irq) {
	ClearGicr(irq); /* Clear interrupt status */
}
static void SDD_EndIRQ(unsigned int irq) {
	ClearGicr(irq); /* Clear interrupt status */
}

#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */

static void SDD_MaskIRQ(unsigned int irq) {
}
static void SDD_MaskAckIRQ(unsigned int irq) {
}
static void SDD_UnMaskIRQ(unsigned int irq) {
}

static struct irq_chip SDD_IrqType = {
	.typename = "sdcard",
	.startup =	SDD_StartupIRQ,
	.shutdown =	SDD_ShutdownIRQ,
	.enable =	SDD_EnableIRQ,
	.disable =	SDD_DisableIRQ,
	.mask =		SDD_MaskIRQ,
	.mask_ack =	SDD_MaskAckIRQ,
	.unmask =	SDD_UnMaskIRQ,
	.ack =		SDD_AckIRQ,
	.end =		SDD_EndIRQ,
};

#else /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

static struct hw_interrupt_type SDD_IrqType = {
	"sdcard",
	SDD_StartupIRQ,
	SDD_ShutdownIRQ,
	SDD_EnableIRQ,
	SDD_DisableIRQ,
	SDD_AckIRQ,
	SDD_EndIRQ,
	NULL
};

#endif /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

/********************************************************************************/
/*  ֐		FSdd_AcreIsr													*/
/*  Tv		F荞݃nho^											*/
/*  		FT_OS_INTR *osintr 荞ݏ|C^                        */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.4.21														*/
/********************************************************************************/
SDD_ERROR Sdd_AcreIsr(T_OS_INTR *osintr)
{
	SDD_ERROR w_ret = SDD_SUCCESS;
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
    w_ret = request_irq(osintr->intNo, (void *)osintr->isr, 0, osintr->device, (void *)(osintr->device));
    set_irq_chip( osintr->intNo, &SDD_IrqType );
#else	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
    irq_desc[osintr->intNo].handler = &SDD_IrqType;
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
    SetLevelGicr(osintr->intNo, osintr->ub_Level);
    return w_ret;
}

/********************************************************************************/
/*  ֐		FSdd_DelIsr													*/
/*  Tv		F荞݃nh폜											*/
/*  		FT_OS_INTR *osintr 荞ݏ|C^                        */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.2.17														*/
/********************************************************************************/
SDD_ERROR Sdd_DelIsr(T_OS_INTR *osintr)
{
    free_irq(osintr->intNo, (void *)(osintr->device));
    return SDD_SUCCESS;
}
#endif /* _SDD_ACRE_ISR_ */

/********************************************************************************/
/*  ֐		FSdd_DisInt													*/
/*  Tv		F荞݋֎~													*/
/*  		FT_OS_INTR *osintr 荞ݏ|C^                        */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.2.17														*/
/********************************************************************************/
SDD_ERROR Sdd_DisInt(T_OS_INTR *osintr)
{
	DisableGicr(osintr->intNo);
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSdd_EnaInt													*/
/*  Tv		F荞݋													*/
/*  		FT_OS_INTR *osintr 荞ݏ|C^                        */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.2.17														*/
/********************************************************************************/
SDD_ERROR Sdd_EnaInt(T_OS_INTR *osintr)
{
	EnableGicr(osintr->intNo);
    return SDD_SUCCESS;
}

irqreturn_t  (*SDD_IntrFunc[])(int irq, void *dev_id, struct pt_regs *regs) = {
    (void *)SDD_Intr_0
#if SDD_DEV_COUNT >= 2
    ,(void *)SDD_Intr_1
#endif
#if SDD_DEV_COUNT >= 3
    ,(void *)SDD_Intr_2
#endif
};

irqreturn_t  (*Sdd_DMAIntrFunc[])(int irq, void *dev_id, struct pt_regs *regs) = {
    (void *)Sdd_DMAIntr_0
#if SDD_DEV_COUNT >= 2
    ,(void *)Sdd_DMAIntr_1
#endif
#if SDD_DEV_COUNT >= 3
    ,(void *)Sdd_DMAIntr_2
#endif
};

/********************************************************************************/
/*  ֐		FSDD_Intr_0												    */
/*  Tv		FSDD_Intr Port0pĂяo(Linux)							*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
irqreturn_t SDD_Intr_0(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_Intr{ */
	SDD_Intr(&(SddHandleForDriver[0]));
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	SDD_EndIRQ( irq );
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	return IRQ_HANDLED;
}

/********************************************************************************/
/*  ֐		FSdd_DMAIntr_0											        */
/*  Tv		FSDD_DMAIntr Port0pĂяo(Linux)						*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
irqreturn_t Sdd_DMAIntr_0(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_DMAIntr{ */
	SDD_DMAIntr(&(SddHandleForDriver[0]));
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	SDD_EndIRQ( irq );
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	return IRQ_HANDLED;
}

#if SDD_DEV_COUNT >= 2
/********************************************************************************/
/*  ֐		FSDD_Intr_1												    */
/*  Tv		FSDD_Intr Port1pĂяo(Linux)							*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
irqreturn_t SDD_Intr_1(int irq, void *dev_id, struct pt_regs *regs)
{
    UW flags;
    
	/* SDD_Intr{ */
	SDD_Intr(&(SddHandleForDriver[1]));
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	SDD_EndIRQ( irq );
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	return IRQ_HANDLED;
}

/********************************************************************************/
/*  ֐		FSdd_DMAIntr_1											        */
/*  Tv		FSDD_DMAIntr Port1pĂяo(Linux)						*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
irqreturn_t Sdd_DMAIntr_1(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_DMAIntr{ */
	SDD_DMAIntr(&(SddHandleForDriver[1]));
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	SDD_EndIRQ( irq );
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	return IRQ_HANDLED;
}
#endif

#if SDD_DEV_COUNT >= 3
/********************************************************************************/
/*  ֐		FSDD_Intr_2												    */
/*  Tv		FSDD_Intr Port2pĂяo(Linux)							*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2010.3.9														*/
/********************************************************************************/
irqreturn_t SDD_Intr_2(int irq, void *dev_id, struct pt_regs *regs)
{
    UW flags;
    
	/* SDD_Intr{ */
	SDD_Intr(&(SddHandleForDriver[2]));
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	SDD_EndIRQ( irq );
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	return IRQ_HANDLED;
}

/********************************************************************************/
/*  ֐		FSdd_DMAIntr_2											        */
/*  Tv		FSDD_DMAIntr Port2pĂяo(Linux)						*/
/*  		Firq ݔԍ                        			            */
/*                void *dev_id                                                  */
/*                struct pt_regs *regs                                          */
/*  ߂l		FI:SDD_SUCCESS											*/
/*  ŏIXV	F2010.3.9														*/
/********************************************************************************/
irqreturn_t Sdd_DMAIntr_2(int irq, void *dev_id, struct pt_regs *regs)
{
	/* SDD_DMAIntr{ */
	SDD_DMAIntr(&(SddHandleForDriver[2]));
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	SDD_EndIRQ( irq );
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	return IRQ_HANDLED;
}
#endif

#endif

/********************************************************************************/
/*  ֐		FSdds_StartCDDetect											*/
/*  Tv		FSD I/F̃J[ho݋									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  ŏIXV	F2009.03.6													    */
/********************************************************************************/
SDD_ERROR Sdds_StartCDDetect(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	//SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*====================*/
	/* nh̋N */
	/*====================*/
	Sdd_CDDetectHdr(p_SddHandle ); /* BM4447 */
	//w_Result = Sdd_StartCyc( p_SddHandle, &(p_sdd->OsInfo.cdCycInfo) );

	return w_Result;
}

#endif /*  _SDD_LINUX_ */
