/***********************************************************************************/
/*  t@C  F$Workfile: SddOsSemaphore.c $                                    */
/*  Tv        FSDfoCXhCoOSnZ}tHEr䏈i[t@C(Linuxp)*/
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.            */
/*  ŏIXV  F$Modtime: 06/06/12 01:10 $                                       */
/***********************************************************************************/
#ifdef _SDD_LINUX_
/********************************************************************************/
/*  ֐		FSdd_SigSem													*/
/*  Tv		FZ}tHʒm													*/
/*  		FT_OS_SEM *sem Z}tHւ̃|C^				        */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.2.19														*/
/********************************************************************************/
SDD_ERROR Sdd_SigSem(T_OS_SEM *sem)
{
    up(&(sem->sem));
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_WaiSem													*/
/*  Tv		FZ}tHҋ@													*/
/*  		FT_OS_SEM *sem Z}tHւ̃|C^				        */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.2.19														*/
/********************************************************************************/
SDD_ERROR Sdd_WaiSem(T_OS_SEM *sem)
{
    down(&(sem->sem));
    return SDD_SUCCESS;
}


/********************************************************************************/
/*  ֐		FSdd_SnsCtx													*/
/*  Tv		FZ}tHҋ@													*/
/*  		Fvoid Ȃ														*/
/*  ߂l		FTRUE:^XNReLXg/FALSEF^XNReLXg			*/
/*  ŏIXV	F2007.12.12													*/
/********************************************************************************/
BOOL Sdd_SnsCtx( void )
{
    return TRUE;
}

/************************************************************************************/
/*  ֐		FSdds_CreateSemaphore												*/
/*  Tv		FZ}tH쐬									                */
/*  			FZ}tH̍쐬sB                                    */
/* 			FȂ																*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2008.1.8															*/
/************************************************************************************/
SDD_ERROR Sdds_CreateSemaphore(void)
{
	SDD_DEV	*p_sdd;
    SDD_ERROR w_Result;
    UW i;

    for(i=0; i<SDD_DEV_COUNT; i++) {
        p_sdd = &(SddDev[i]);
        /* Z}tH쐬 */
        w_Result = Sdd_CreSem(&(p_sdd->OsInfo.normalSem));
        if(w_Result != SDD_SUCCESS){			/* 0ȊȌꍇ̓VXeR[G[ */
            return w_Result;
        }
#ifdef _SDD_FUNC_SECURE_
        w_Result = Sdd_CreSem(&(p_sdd->OsInfo.angouSem));
        if(w_Result != SDD_SUCCESS){			/* 0ȊȌꍇ̓VXeR[G[ */
            return w_Result;
        }
#endif /* _SDD_FUNC_SECURE_ */
        /* XsbN쐬 */
        w_Result = Sdd_CreSpinlock(&(p_sdd->OsInfo.slock));
        if(w_Result != SDD_SUCCESS){			/* 0ȊȌꍇ̓VXeR[G[ */
            return w_Result;
        }
    }
    return w_Result;
}

/********************************************************************************/
/*  ֐		FSdd_CreSem													*/
/*  Tv		FZ}tH													*/
/*  		FT_OS_SEM *sem Z}tHւ̃|C^				        */
/*  ߂l		FIFSDD_SUCCESS											*/
/*				FُIFG[͕ԂȂ                     				*/
/*  ŏIXV	F2009.2.19														*/
/********************************************************************************/
SDD_ERROR Sdd_CreSem(T_OS_SEM *sem)
{
    /* Z}tH */
    sema_init(&(sem->sem), 1);
	return SDD_SUCCESS;		/* ߂l^[ */
}

/********************************************************************************/
/*  ֐		FSdd_CreSpinlock												*/
/*  Tv		FXsbN												*/
/*  		FT_OS_SPINLOCK *slock 	XsbN\     			    */
/*  ߂l		FIFSDD_SUCCESS											*/
/*				FُIFG[͕ԂȂ                     				*/
/*  ŏIXV	F2009.3.3														*/
/********************************************************************************/
SDD_ERROR Sdd_CreSpinlock(T_OS_SPINLOCK *slock)
{
    /* XsbN */
    spin_lock_init(&(slock->slock));
	return SDD_SUCCESS;		/* ߂l^[ */
}

/********************************************************************************/
/*  ֐		FSdd_DelSem													*/
/*  Tv		FZ}tH폜													*/
/*  		FT_OS_SEM *sem Z}tHւ̃|C^				        */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.2.19														*/
/********************************************************************************/
SDD_ERROR Sdd_DelSem(T_OS_SEM *sem)
{
    /* Z}tH폜͂Ȃ */
	return SDD_SUCCESS;		/* ߂l^[ */
}

/********************************************************************************/
/*  ֐		FSdds_StartExclError											*/
/*  Tv		FSDfoCXhCoprJnpG[					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FG[R[h										        */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
SDD_ERROR Sdds_StartExclError(SDD_HANDLE *p_SddHandle, SDD_ERROR w_TmpRet)
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
    /* ITRONȊȌꍇɂ̓Z}tH𓮓IɊmۂׂɁASDD_ERR_NOT_ATTACHEDēx`FbN */
    if((Sdds_GetStatus(p_SddHandle) & SDD_STATUS_MASK) != SDD_STATUS_CLOSE){
        switch(Sdds_GetStatus(p_SddHandle) & SDD_STATUS_MASK){
          case SDD_STATUS_DETACH:	/* DETACH(0x00)̏ꍇAG[1(SDD_ERR_NOT_ATTACHED) */
            w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, SDD_ERR_NOT_ATTACHED);
            break;
          default:				/* LȊȌꍇ */
            w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
        }
    }
	return w_ret;
}


#endif /*  _SDD_LINUX_ */
