/***********************************************************************************/
/*  t@C  F$Workfile: SddOsTimer.c $                                        */
/*  Tv        FSDfoCXhCoOSn^C}i[t@C(Linuxp)            */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.            */
/*  ŏIXV  F$Modtime: 06/06/12 09:45 $                                       */
/***********************************************************************************/
#ifdef _SDD_LINUX_
/****************************************************************************************/
/*  ֐		FSdd_CreCyclic															*/
/*  Tv		Fnh														*/
/*  		FT_OS_CYCHANDLE *cyc nh					                */
/*  ߂l		FIFSDD_SUCCESS													*/
/*				FُIFVXeR[G[iVXeُj						*/
/*  ŏIXV	F2009.2.18																*/
/****************************************************************************************/
SDD_ERROR Sdd_CreCyclic(T_OS_CYCHANDLE *cyc)
{
    init_timer(&(cyc->cyc));
    cyc->bl_Active = FALSE;
	return SDD_SUCCESS;		/* ߂l^[ */
}
/********************************************************************************/
/*  ֐		FSdd_DelCyclic													*/
/*  Tv		Fnh폜												*/
/*  		FT_OS_CYCHANDLE *cyc nh					        */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.2.18														*/
/********************************************************************************/
SDD_ERROR Sdd_DelCyclic(T_OS_CYCHANDLE *cyc)
{
    /* Ȃ */
	return SDD_SUCCESS;		/* ߂l^[ */
}

/********************************************************************************/
/*  ֐		FSdd_CheckCyc													*/
/*  Tv		FnhN`FbN										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*       		Fub_cyc (nhN:1Anh~F0) 			*/
/*  ߂l		FIFSDD_SUCCESS											*/
/*				FُI p[^G[FSDD_ERR_PARAM						*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
SDD_ERROR Sdd_CheckCyc(SDD_HANDLE *p_SddHandle, UB *ub_cyc)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    spin_lock_irqsave(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags);   //  spin_lock(spin_lock_irqsave,spin_unlock_irqrestore͓֐R[Kv
    if (p_sdd->OsInfo.cdCycInfo.bl_Active == TRUE) {
        *ub_cyc = (UB)1;
    }
    else {
        *ub_cyc = (UB)0;
    }
    spin_unlock_irqrestore(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags); //  spin_lock
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSdd_StartCyc													*/
/*  Tv		FnhJn												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FT_OS_CYCHANDLE *cyc nh					        */
/*  ߂l		FIFSDD_SUCCESS											*/
/*				FُI p[^G[FSDD_ERR_PARAM						*/
/*  ŏIXV	F2009.03.13													*/
/********************************************************************************/
SDD_ERROR Sdd_StartCyc(SDD_HANDLE *p_SddHandle, T_OS_CYCHANDLE *cyc )
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    spin_lock_irqsave(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags);   //  spin_lock(spin_lock_irqsave,spin_unlock_irqrestore͓֐R[Kv
    if (cyc->bl_Active == TRUE) {
		/* NĂꍇɂ͒~ */
        mod_timer(&(cyc->cyc), cyc->cyc.expires);
	}
    else {
        if (cyc->uw_SddTimer == 0) {
            /* ^C}lݒ肳ĂȂꍇɂ́A100msecԊuŋN */
            cyc->cyc.expires = (unsigned long)(jiffies + HZ/10); /* 100msecԊuN */
        }
        else {
            /* ^C}lݒ肳Ăꍇɂ́A̒lɐݒ */
            
            cyc->cyc.expires = (unsigned long)(jiffies + HZ*cyc->uw_SddTimer/1000); /* ݒԊuN */
        }
        cyc->cyc.data=0;
/*        add_timer(&(cyc->cyc));*/					/* #20192 modify */
        mod_timer(&(cyc->cyc),cyc->cyc.expires);	/* #20192 modify */
    }
    cyc->bl_Active = TRUE;
    spin_unlock_irqrestore(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags); //  spin_lock

	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSdd_StopCyc													*/
/*  Tv		Fnh~												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FT_OS_CYCHANDLE *cyc nh					        */
/*  ߂l		FIFSDD_SUCCESS											*/
/*				FُI p[^G[FSDD_ERR_PARAM						*/
/*  ŏIXV	F2009.03.13													*/
/********************************************************************************/
SDD_ERROR Sdd_StopCyc( SDD_HANDLE *p_SddHandle, T_OS_CYCHANDLE *cyc )
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	/*================================================*/
	/* nhNĂȂΒ~Ȃ */
	/*================================================*/
    spin_lock_irqsave(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags);   //  spin_lock(spin_lock_irqsave,spin_unlock_irqrestore͓֐R[Kv
    if (cyc->bl_Active == TRUE) {
        del_timer(&(cyc->cyc));
        cyc->bl_Active = FALSE;     /* J[h}pnh~ */
    }
    spin_unlock_irqrestore(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags); //  spin_lock
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSdd_TimerHdr													*/
/*  Tv		F^CAEgpnh									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.23													*/
/********************************************************************************/
void Sdd_TimerHdr(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    Sdd_SetEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), SDD_EVENTFLG_TIMEOUT);
    spin_lock_irqsave(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags);   //  spin_lock(spin_lock_irqsave,spin_unlock_irqrestore͓֐R[Kv
    p_sdd->w_error |= SDD_ERR_OS_TIMEOUT;	/* |[Õ`FbNp */
	p_sdd->OsInfo.cycInfo.bl_Active = FALSE;
    spin_unlock_irqrestore(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags); //  spin_lock
}

/********************************************************************************/
/*  ֐		FSdd_CDDetectHdr_before										*/
/*  Tv		FnhO(Linuxp)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.11													*/
/********************************************************************************/
void Sdd_CDDetectHdr_before(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

    spin_lock_irqsave(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags);   //  spin_lock(spin_lock_irqsave,spin_unlock_irqrestore͓֐R[Kv
    p_sdd->OsInfo.cdCycInfo.bl_Active = FALSE;     /* J[h}pnh~ */
    spin_unlock_irqrestore(&p_sdd->OsInfo.slock.slock,p_sdd->OsInfo.slock.flags); //  spin_lock
}

/********************************************************************************/
/*  ֐		FSdd_CDDetectHdr_after											*/
/*  Tv		Fnh㏈(Linuxp)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.11													*/
/********************************************************************************/
void Sdd_CDDetectHdr_after(SDD_HANDLE *p_SddHandle)
{
#ifndef _SDD_CARDDETECT_START_BY_INTR_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    
    Sdd_StartCyc(p_SddHandle, &(p_sdd->OsInfo.cdCycInfo));
#endif
}


#endif /*  _SDD_LINUX_ */
