/***********************************************************************************/
/*  t@C  F$Workfile: SddOsEvent.c $                                        */
/*  Tv        FSDfoCXhCoOSnCxgi[t@C                   */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.            */
/*  ŏIXV  F$Modtime: 06/06/12 10:25 $                                       */
/*                AccessAllEndI҂Oǉ 2006/07/03 H.Miura                */
/*                AccessAllEndI҂1st㏈ǉ 2006/07/03 H.Miura             */
/*                AccessAllEndI҂2nd㏈ǉ 2006/07/03 H.Miura             */
/*                AccessAllEndI҂3rd㏈ǉ 2006/07/03 H.Miura             */
/***********************************************************************************/
/* wb_[t@C */
#include "SddCom.h"
#include "SddError.h"
#include "SddRegister.h"
#include "SddOsEvent.h"
#include "SddOsTimer.h"
#include "SddCardInOut.h"
#include "SddOsSemaphore.h"


/* Tu֐t@C */
#if defined(_SDD_UNIPHIER_2P_)
#include "device/SddOsEvent_for_uniphier2p.c"
#endif /* defined(_SDD_UNIPHIER_2P_) */

#if defined(_SDD_UNIPHIER_XP_)
#include "device/SddOsEvent_for_uniphierxp.c"
#endif /* defined(_SDD_UNIPHIER_XP_) */

#if defined(_SDD_LINUX_)
#include "Linux/SddOsEvent_for_Linux.c"
#endif

#if defined(_SDD_ITRON_)
#include "ITron/SddOsEvent_for_ITron.c"
#endif

#if defined(_SDD_T_ENGINE_)
#include "TEngine/SddOsEvent_for_TEngine.c"
#endif

#if !defined(_SDD_UNIPHIER_XP_) && !defined(_SDD_UNIPHIER_2P_)
/********************************************************************************/
/*  ֐     FSdds_WaitTransEnd_2PBug_Start                                  */
/*  Tv       FWaitTransEndp2PBugΉJn                                */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l     FȂ                                                           */
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static void Sdds_WaitTransEnd_2PBug_Start(SDD_HANDLE *p_SddHandle) {
    /* Ȃ */;
}

/********************************************************************************/
/*  ֐     FSdds_WaitTransEnd_2PBug_End                                    */
/*  Tv       FWaitTransEndp2PBugΉI                                */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l     FȂ                                                           */
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
static void Sdds_WaitTransEnd_2PBug_End(SDD_HANDLE *p_SddHandle) {
    /* Ȃ */;
}
#endif /* !defined(_SDD_UNIPHIER_XP_) && !defined(_SDD_UNIPHIER_2P_) */

/********************************************************************************/
/*  ֐		FSdds_CheckEraseEnd											*/
/*  Tv		FErase̊mF											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Timeout													*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_CheckEraseEnd(SDD_HANDLE *p_SddHandle, UW uw_Timeout)
{
	SDD_ERROR	w_Result = SDD_SUCCESS;
	SDD_ERROR 	w_R1 = SDD_SUCCESS;
	UW	uw_DAT0state;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	SDD_ERROR	w_ResTmp;

	Sdd_TimerStart(p_SddHandle, uw_Timeout);	 /* IPoO΍Jn */
	while(1) {
		Sddr_CheckDAT0(p_SddHandle, &uw_DAT0state);
		if (uw_DAT0state != 0){		/* rW[  */
			break;
		}
		if (p_sdd->w_error != SDD_SUCCESS) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, p_sdd->w_error);
			break;
		}
		w_ResTmp = Sdd_Delay(SDD_DAT0_BUSY_DELAY_TIME);				/* 莞Ԃ̑҂ */
		w_ResTmp &= ~SDD_ERR_OS_TIMEOUT;	/* SDD_ERR_OS_TIMEOUTNA(K͂)  */
		if(w_ResTmp != SDD_SUCCESS)  {
			/* ߂lFG[Ȃ͂ */
			/* G[Ăʒm͂Ȃ */
		}
	}
	if (w_Result == SDD_SUCCESS) {
		Sddr_CheckCardStatus(p_SddHandle, SDD_CARD_STATUS_READ, &w_R1);
		if (w_R1 != SDD_SUCCESS) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_R1);
		}
#ifdef _SDD_ERASE_CHECK_
		else{
			while(1) {
				w_ResTmp = Sdds_GetCardStatus(p_SddHandle);	/* J[hXe[^X擾 */	
				if (w_ResTmp == SDD_SUCCESS) {
					if ( ((p_sdd->uw_CardStatus & SDD_CARD_STATUS_CURRENT_STATE) == SDD_CARD_STATUS_TRAN_STATE)
						&& (p_sdd->uw_CardStatus & SDD_CARD_STATUS_READY_FOR_DATA) ){ 
							break;
					}
					if (p_sdd->w_error != SDD_SUCCESS){
						w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, p_sdd->w_error);
						break;
					}
				} else {
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				  	break;
				}
	
				w_ResTmp = Sdd_Delay(SDD_WAIT_ERASE_MSEC);
				w_ResTmp &= ~SDD_ERR_OS_TIMEOUT;	/* SDD_ERR_OS_TIMEOUTNA(K͂)  */
				if(w_ResTmp != SDD_SUCCESS)  {
					/* ߂lFG[Ȃ͂ */
					/* G[Ăʒm͂Ȃ */
				}
			}
		}
#endif
	}
	Sdd_TimerStop(p_SddHandle);	/*@IPoO΍I */

	return w_Result;
}

/****************************************************************************************/
/*  ֐		FSdds_ClrCbfAll														*/
/*  Tv		FCxgR[obN֐AR[obN֐̃NAiׂNULLݒj	*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                      */
/*  ߂l		FFSDD_SUCCESS														*/
/*  			FsFG[R[h													*/
/*  ŏIXV	F2004.1.22																*/
/****************************************************************************************/
SDD_ERROR Sdds_ClrCbfAll( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;

	/*======================================*/
	/* CxgR[obNݒ֐Ăяo */
	/*======================================*/
	/*
	hCõR[obNe[uւ̓o^
	P = SddEventCbf.uw_WaitEvent
	Q = SddEventCbf.vp_Func
	R = SddEventCbf.uw_Param
	Sddr_SetCbf(UW uw_WaitEvent, void * vp_Func, UW uw_Param)jumpAp
	*/
	Sdds_SetCbf(p_SddHandle, SDD_EVENT_ALL, NULL, 0x00000000);	/* R[obN֐̃NA(ׂNULLݒ) */
	
	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_SetCbf													*/
/*  Tv		FR[obN֐̓o^Ȃ								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*       		FUW ҂Cxg												*/
/*  			Fvoid * R[obN֐										*/
/*  			FUW R[obN֐ւ̔Cӈ								*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
void Sdds_SetCbf(SDD_HANDLE *p_SddHandle, UW uw_WaitEvent, VOIDFP3 vp_Func, UW uw_Param)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/* Cxg3Ȃ烋[vŏȂjEE */

	/*========================*/
	/* J[h}Cxgݒ */
	/*========================*/
	/*
	  ҂Cxg̃J[h}Cxg(SDD_EVENT_CARDIN)rbg
		1) rbgON
			hCõJ[h}CxgR[obNo^̈(SDD_DEV.CbfIn.vp_Fp)Ɉ[֐|C^]ݒ
			                                                    (SDD_DEV.CbfIn.vp_Param)Ɉ[Cӈ]ݒ
	*/
	if(uw_WaitEvent & SDD_EVENT_CARD_IN) {
		p_sdd->CbfIn.vp_Fp = vp_Func;
		p_sdd->CbfIn.uw_Param = uw_Param;
	}
	/*========================*/
	/* J[hroCxgݒ */
	/*========================*/
	/*
	  ҂Cxg̃J[hroCxg(SDD_EVENT_CARDOUT)rbg
		1) rbgON
			hCõJ[hroCxgR[obNo^̈(SDD_DEV.CbfOut.vp_Fp)Ɉ[֐|C^]ݒ
			                                                    (SDD_DEV.CbfOut.vp_Param)Ɉ[Cӈ]ݒ
	*/
	if(uw_WaitEvent & SDD_EVENT_CARD_OUT) {
		p_sdd->CbfOut.vp_Fp = vp_Func;
		p_sdd->CbfOut.uw_Param = uw_Param;
	}
	/*====================*/
	/* G[Cxgݒ */
	/*====================*/
	/*
	  ҂Cxg̃G[Cxg(SDD_EVENT_ERROR)rbg
		1) rbgON
			hCõG[CxgR[obNo^̈(SDD_DEV.CbfErr.vp_Fp)Ɉ[֐|C^]ݒ
			                                                (SDD_DEV.CbfErr.vp_Param)Ɉ[Cӈ]ݒ
	*/
	if(uw_WaitEvent & SDD_EVENT_ERROR) {
		p_sdd->CbfErr.vp_Fp = vp_Func;
		p_sdd->CbfErr.uw_Param = uw_Param;
	}

#ifdef _SDD_CALL_CBF_RETRY_INFO_
    /*=====================================*/
	/* G[gCCxgݒ(LBAʒm) */
	/*=====================================*/
	/*
	  ҂Cxg̃G[gCCxg(SDD_EVENT_ERR_RETRY_LBA)rbg
		1) rbgON
			hCõG[gCCxg(LBAʒm)̃R[obNo^̈(SDD_DEV.CbfRetryLba.vp_Fp)Ɉ[֐|C^]ݒ
			                                                                   (SDD_DEV.CbfRetryLba.vp_Param)Ɉ[Cӈ]ݒ
	*/
	if(uw_WaitEvent & SDD_EVENT_ERR_RETRY_LBA) {
		p_sdd->CbfRetryLba.vp_Fp = vp_Func;
		p_sdd->CbfRetryLba.uw_Param = uw_Param;
	}
	/*==============================================*/
	/* G[gCCxgݒ(G[R[hʒm) */
	/*==============================================*/
	/*
	  ҂Cxg̃G[gCCxg(SDD_EVENT_ERR_RETRY_ERCD)rbg
		1) rbgON
			hCõG[gCCxg(G[R[hʒm)R[obNo^̈(SDD_DEV.CbfRetryErcd.vp_Fp)Ɉ[֐|C^]ݒ
			                                                                          (SDD_DEV.CbfRetryErcd.vp_Param)Ɉ[Cӈ]ݒ
	*/
	if(uw_WaitEvent & SDD_EVENT_ERR_RETRY_ERCD) {
		p_sdd->CbfRetryErcd.vp_Fp = vp_Func;
		p_sdd->CbfRetryErcd.uw_Param = uw_Param;
	}
	/*==============================================*/
	/* G[gCCxgݒ(gCʒm) */
	/*==============================================*/
	/*
	  ҂Cxg̃G[Cxg(SDD_EVENT_ERR_RETRY_INFO)rbg
		1) rbgON
			hCõG[Cxg(gCʒm)R[obNo^̈(SDD_DEV.CbfRetryInfo.vp_Fp)Ɉ[֐|C^]ݒ
			                                                                  (SDD_DEV.CbfRetryInfo.vp_Param)Ɉ[Cӈ]ݒ
	*/
	if(uw_WaitEvent & SDD_EVENT_ERR_RETRY_INFO) {
		p_sdd->CbfRetryInfo.vp_Fp = vp_Func;
		p_sdd->CbfRetryInfo.uw_Param = uw_Param;
	}
#endif /* _SDD_CALL_CBF_RETRY_INFO_ */

	return;
}

/********************************************************************************/
/*  ֐		FSdds_WaitAllEnd												*/
/*  Tv		FAccessAllEndI҂										*/
/*				 AccessAllEnd҂荞݉									*/
/*				 iAccessAllEnd҂jor (G[Ijő҂itwai_flg)			*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FRead/Writef[^̓]/],]TCY,ZN^TCY	*/
/*                ]TCÝA1]ɃTCYBZN^TCY͑M           */
/*                BOOL bl_Write ݏ(TRUE:Write,FALSE:Read)             */
/*                UW uw_TimeOutMsec TimeOut                                 */
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
SDD_ERROR Sdds_WaitAllEnd( SDD_HANDLE *p_SddHandle, UB * pub_Buff, UW uw_Cnt, UW uw_SendSec, BOOL bl_Write, UW uw_TimeOutMsec)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UW uw_WaiEvent;
	UW uw_Event;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UB ub_CardInOut;
    UW i;

    if(bl_Write != TRUE ) {
		Sddr_EnaIntSDBuf(p_SddHandle, SDD_BUF_READ);
    } else {
		Sddr_EnaIntSDBuf(p_SddHandle, SDD_BUF_WRITE);
	}
    for (i=0; i<uw_SendSec; i++) {
        /* 
		BRE/BWE҂
		twai_flgł̃tO҂s
		OS̃bsO֐Ŏs
		F҂tOp^[(BRE,BWEorG[MorJ[h)
			 ҂ԁif[^]^CAEgl-}Nj
		߂lF
			̏ꍇ
                READFSD_BUF̃f[^SDRAM֓]
				WRITEFSDRAM̃f[^SD_BUF֓]
         */
        uw_WaiEvent = SDD_EVENTFLG_BRWENA | SDD_EVENTFLG_ERROR | SDD_EVENTFLG_CARD_OUT;

        w_ResTmp = Sdd_WaiEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_WaiEvent, &uw_Event, SDD_1SEC_TIMEOUT_MSEC);
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_WaitAllEnd w_ResTmp = %ld uw_Event=%lx!\n",w_ResTmp, uw_Event);
        if(w_ResTmp == SDD_SUCCESS) {						/*  */
            w_ResTmp = Sdd_ClrEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_Event);				/* CxgtÕNA */
            if(uw_Event & SDD_EVENTFLG_BRWENA) {		/* BREݎ擾 */
                if(bl_Write != TRUE ) {
                    /* Readf[^SDRAM֓] */
                    Sddr_CopyFromBuf(p_SddHandle, pub_Buff, uw_Cnt);
                } else {
                    /* SDRAM̃f[^SD_BUF֓] */
                    Sddr_CopyToBuf(p_SddHandle, pub_Buff, uw_Cnt);
                }
                pub_Buff += uw_Cnt;
            } 
            else if(uw_Event) {
                if(uw_Event & SDD_EVENTFLG_CARD_OUT){
                    w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_CARD_OUT);
                }
                else if(uw_Event & SDD_EVENTFLG_ERROR){
                    Sddr_DetectCard(p_SddHandle, &ub_CardInOut);
                    if(ub_CardInOut == SDD_CARDOUT) {
                        w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_CARD_OUT);
                    }
                    else {
                        w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, p_sdd->w_error);
                        /* ɁASdds_ErrProcessɂSTOPR}hs{邽߁A̎_łSdds_ErrorStopsȂ */
                    }
                }
                return w_Result;
            }
        } 
        else {									/* ُ(^CAEgȂ͂)̏ꍇ */
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
            /* ɁASdds_ErrProcessɂSTOPR}hs{邽߁A̎_łSdds_ErrorStopsȂ */
            return w_Result;
        }
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_WaitAllEnd %ld byte Transfer!\n",uw_Cnt);
    }
    if(bl_Write != TRUE ) {
        Sddr_DisIntSDBuf(p_SddHandle, SDD_BUF_READ);
    } else {
        Sddr_DisIntSDBuf(p_SddHandle, SDD_BUF_WRITE);
    }
        
    /* Access End */
    w_Result = Sdds_WaitTransEnd(p_SddHandle, uw_TimeOutMsec, FALSE);
	return w_Result;

}


/********************************************************************************/
/*  ֐		FSdds_WaitResEnd												*/
/*  Tv		FX|XorG[M҂									*/
/*					X|XG[`FbN									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_TimeOutMsec TimeOut				                    */
/*                UH uh_Cmd R}h                                            */
/*  ߂l		F	FSDD_SUCCESS											*/
/*					G[FCBUSY^CAEg									*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_WaitResEnd(SDD_HANDLE *p_SddHandle, UW uw_TimeOutMsec, UH uh_Cmd)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uw_WaiEvent;
	UW uw_Event = 0;
	UB ub_CardInOut;

/*
X|XorG[M҂
	twai_flgł̃tO҂s
	OS̃bsO֐Ŏs
	F҂tOp^[(X|XMorG[MorJ[h)
		 ҂ԁij
	߂lF
		̏ꍇ
			҂̃tO擾
				tOeiResEnd)F
                    Ȃ
				tOeiResEndȊOjF
					w_Result |= G[lݒ
					return;
		ُ(^CAEgȂ͂)̏ꍇ
			w_Result |= G[lݒ
			return;
*/
    if (uh_Cmd == SDD_CMD_ERASE ||
        uh_Cmd == SDD_CMD_SECURE_AREA ||
        uh_Cmd == SDD_CMD_SECUREERASE) {
        /* ErasenR}h̓^CAEgCxg擾Ȃ */
        uw_WaiEvent = SDD_EVENTFLG_RES_END | SDD_EVENTFLG_ERROR | SDD_EVENTFLG_CARD_OUT;
    }
    else {
        uw_WaiEvent = SDD_EVENTFLG_RES_END | SDD_EVENTFLG_ERROR | SDD_EVENTFLG_CARD_OUT | SDD_EVENTFLG_TIMEOUT;
    }

	w_ResTmp = Sdd_WaiEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_WaiEvent, &uw_Event, uw_TimeOutMsec);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_WaitResEnd w_ResTmp = %ld uw_Event=%lx!\n",w_ResTmp, uw_Event);

	if(w_ResTmp == SDD_SUCCESS) {
		if (uw_Event == SDD_EVENTFLG_RES_END) {
            if (uh_Cmd == SDD_CMD_ERASE ||
                uh_Cmd == SDD_CMD_SECURE_AREA ||
                    uh_Cmd == SDD_CMD_SECUREERASE) {
                /* ErasenR}h̏ꍇAErasemF */
                w_ResTmp = Sdds_CheckEraseEnd(p_SddHandle, uw_TimeOutMsec);		
                if (w_ResTmp != SDD_SUCCESS){
                    w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
                }        
            }
            else {
                /* Ȃ */
            }
		}
		if(uw_Event & SDD_EVENTFLG_CARD_OUT) {
            if (uh_Cmd != SDD_CMD_CARDRST) {
                /* Resetɂ̓J[h邪G[ƂȂ */
                w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_CARD_OUT);
            }
		}
		else if(uw_Event & SDD_EVENTFLG_TIMEOUT) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_OS_TIMEOUT);
		}
		else if(uw_Event & SDD_EVENTFLG_ERROR) {
			Sddr_DetectCard(p_SddHandle, &ub_CardInOut);
			if(ub_CardInOut == SDD_CARDOUT) {
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_CARD_OUT);
			}
			else {
#ifdef _SDD_FUNC_SDIO_
                if (((uh_Cmd == SDD_CMD_PREACMD) && (p_sdd->uw_TmpOperationMode == SDD_CARD_INIT_MODE_SDIO)) ||
                    ((uh_Cmd == SDD_CMD_IO_OP_COND) && (p_sdd->uw_TmpOperationMode == SDD_CARD_INIT_MODE_MEMORY))){
                    /* SDIO[hACMDM,[hCMD5Mɂ̓G[LȂ */
                    w_Result = p_sdd->w_error;
                }
                else {
                    w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, p_sdd->w_error);
                }
#else
                w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, p_sdd->w_error);
#endif /* _SDD_FUNC_SDIO_ */
			}
		}
#ifdef	SDD_DEBUG_1SECTOR
		else if(uw_Event & SDD_EVENTFLG_DMA_END) {
			w_Result = Sdd_SetEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), SDD_EVENTFLG_DMA_END);		/* DMAʒm(֐ďo) */
			if (w_Result != SDD_SUCCESS) {				/* G[`FbN 	*/
				/* ߂lFG[Ȃ͂ */
				/* CxgʒmŃG[Ăʒm͂Ȃ */
			}
		}
#endif	/* SDD_DEBUG_1SECTOR */
	} 
	else {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}
#ifdef _SDD_CARD_STATUS_CHECK_
    if (uh_Cmd == SDD_CMD_ERASE ||
        uh_Cmd == SDD_CMD_SECURE_AREA ||
        uh_Cmd == SDD_CMD_SECUREERASE) {
        /* ErasenR}h̏ꍇAJ[hXe[^XmF */
        w_ResTmp = Sdds_GetCardStatus(p_SddHandle);
        if(w_ResTmp != SDD_SUCCESS) {
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
        }
    }
#endif /* _SDD_CARD_STATUS_CHECK_ */

    
	return w_Result;

}

/****************************************************************************************/
/*  ֐		FSdds_WaitTransEnd														*/
/*  Tv		FAccessAllEnd&StreamDMACI҂									*/
/*				  AccessAllEnd҂荞݉											*/
/*				 iStreamDMAC & AccessAllEnd҂jor (G[Ijő҂itwai_flg)		*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                      */
/*      		FUW uw_TimeOutMsec TimeOut				                            */
/*                BOOL bl_DMA DMA]stO(TRUE:DMA]s,FALSE:PIO      */
/*  ߂l		FFSDD_SUCCESS														*/
/*				 G[FCBUSY^CAEg												*/
/*  ŏIXV	F2009.03.09															*/
/****************************************************************************************/
SDD_ERROR Sdds_WaitTransEnd(SDD_HANDLE *p_SddHandle, UW uw_TimeOutMsec, BOOL bl_DMA)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UW uw_WaiEvent;
	UW uw_Event;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UB ub_CardInOut;

#ifndef _SDD_ONLY_DMA_END_
    /*	AccessAllEnd҂荞݉ǉ
		Sddr_EnaTransEnd()
			Fp_SddHandle
			߂lFȂ
	*/
	Sddr_EnaTransEnd(p_SddHandle);
#else
    if (bl_DMA != TRUE) {
	/*	AccessAllEnd҂荞݉ǉ
		Sddr_EnaTransEnd()
			Fp_SddHandle
			߂lFȂ
	*/
	Sddr_EnaTransEnd(p_SddHandle);
    }
#endif
/*
	AccessAllEnd&StreamDMACI҂
	twai_flgł̃tO҂si݌v̑҂ԂMAX...)
	OS̃bsO֐Ŏs
	F҂tOp^[((AccessAllEndM&StreamDMACI)or(G[MorJ[h))
		 ҂ԁif[^]^CAEgl-}Nj
	߂lF
		̏ꍇ
			҂tÕNAi擾҂tONA)
				clr_flgł̃tO҂s
				OS̃bsO֐Ŏs
			҂̃tO擾
				tOeiAccessAllEnd&StreamDMAC)F
                Ȃ
		ُ(^CAEgȂ͂)̏ꍇ
			CMD12s~
				Sddr_SetStop( UB ub_Stop )
				F~
				߂lFȂ
			w_Result |= G[lݒ
			return;
*/
    if (bl_DMA == TRUE) {
        /* DMA]{ꍇ */
#ifndef _SDD_ONLY_RW_ACCESS_END_
        uw_WaiEvent = SDD_EVENTFLG_RW_ACCESS_END | SDD_EVENTFLG_DMA_END | SDD_EVENTFLG_ERROR | SDD_EVENTFLG_CARD_OUT;
#else
        uw_WaiEvent = SDD_EVENTFLG_RW_ACCESS_END | SDD_EVENTFLG_ERROR | SDD_EVENTFLG_CARD_OUT;
#endif
    }
    else {
        /* DMA]{Ȃꍇ */
        uw_WaiEvent = SDD_EVENTFLG_RW_ACCESS_END | SDD_EVENTFLG_ERROR | SDD_EVENTFLG_CARD_OUT;
    }
	while(1) {
		w_ResTmp = Sdd_WaiEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_WaiEvent, &uw_Event, uw_TimeOutMsec);	/* ԁA]TCYɂă^CAEglςKv*/
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_WaitTransEnd w_ResTmp = %ld uw_Event=%lx!\n",w_ResTmp, uw_Event);
        if (bl_DMA == FALSE) {
            /* 2PBugΉ */
            Sdds_WaitTransEnd_2PBug_Start(p_SddHandle);
        }

		if(w_ResTmp == SDD_SUCCESS) {							/*  */
			if(uw_Event & SDD_EVENTFLG_RW_ACCESS_END) {
				uw_WaiEvent &= ~SDD_EVENTFLG_RW_ACCESS_END;		/* Cxg͎̑҂͂ */
#ifdef _SDD_ONLY_RW_ACCESS_END_
                break;										/* Cxg҂I */
#else
                if (bl_DMA == TRUE) {
                    /* DMA]̏ꍇ */
                    if((uw_WaiEvent & SDD_EVENTFLG_DMA_END) == 0) {	/* R/W ENDDMA */
                        uw_Event |= SDD_EVENTFLG_DMA_END;			/* DMAƂɂ */
                        break;										/* Cxg҂I */
                    }
                }
                else {
                    break;										/* Cxg҂I */
                }
#endif
			}
#ifndef _SDD_ONLY_RW_ACCESS_END_
            if (bl_DMA == TRUE) {
                if(uw_Event & SDD_EVENTFLG_DMA_END) {
                    uw_WaiEvent &= ~SDD_EVENTFLG_DMA_END;			/* Cxg͎̑҂͂ */
                    if((uw_WaiEvent & SDD_EVENTFLG_RW_ACCESS_END) == 0) {	/* R/W ENDDMA */
                        uw_Event |= SDD_EVENTFLG_RW_ACCESS_END;		/* R/W ENDƂɂ */
                        break;										/* Cxg҂I */
                    }
                }
            }
#endif
			if(uw_Event & SDD_EVENTFLG_ERROR) {		/* G[Ȃ΃Cxg҂I */
				break;
			}
			if(uw_Event & SDD_EVENTFLG_CARD_OUT) {	/* J[hroȂ΃Cxg҂I */
				break;
			}
		} 
		else {
			break;	/* G[ACxg҂I */
		}
	}

	if(w_ResTmp == SDD_SUCCESS) {						/*  */
		w_ResTmp = Sdd_ClrEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_Event);	/* CxgtÕNA */
		if(uw_Event == (SDD_EVENTFLG_RW_ACCESS_END | SDD_EVENTFLG_DMA_END)) {	/* AccessAllEnd&StreamDMAC */
            /* Ȃ */
		} 
		else {
			if(uw_Event & SDD_EVENTFLG_CARD_OUT) {
				w_Result =  Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_CARD_OUT);
			}
			else if(uw_Event & SDD_EVENTFLG_ERROR) {
				Sddr_DetectCard(p_SddHandle, &ub_CardInOut);
				if(ub_CardInOut == SDD_CARDOUT) {
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_CARD_OUT);
				}
				else {
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, p_sdd->w_error);
					/* ɁASdds_ErrProcessɂSTOPR}hs{邽߁A̎_łSdds_ErrorStopsȂ */
				}
			}
		}
	} 
	else {							/* ُ(^CAEgȂ͂)̏ꍇ */
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		/* ɁASdds_ErrProcessɂSTOPR}hs{邽߁A̎_łSdds_ErrorStopsȂ */
	}

    /*	AccessAllEnd҂荞݋֎~ǉ
		Sddr_DisTransEnd()
			FȂ
			߂lFȂ
	*/
	Sddr_DisTransEnd(p_SddHandle);

    if (bl_DMA == FALSE) {
        /* 2PBugΉ */
        Sdds_WaitTransEnd_2PBug_End(p_SddHandle);
    }
    
    return w_Result;
}

/************************************************************************************/
/*  ֐		FSdds_DeleteEvent												    */
/*  Tv		FCxg폜									                */
/*  			FCxgp[NL[̍폜sB                      */
/* 			FȂ																*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.3.6															*/
/************************************************************************************/
SDD_ERROR Sdds_DeleteEvent(void)
{
	SDD_ERROR w_Result;
    UW i;
	SDD_DEV	*p_sdd;
    
    for(i=0; i<SDD_DEV_COUNT; i++) {
        p_sdd = &(SddDev[i]);
        /*==========================================================*/
        /*  CxgtO̍폜									*/
        /*	Sdd_DelEve()łȂ							*/
        /*==========================================================*/
        w_Result = Sdd_DelEve(&(p_sdd->OsInfo.normalEventFlag));
        if(w_Result < SDD_SUCCESS){			/* 0ȉ̏ꍇ̓VXeR[G[ */
            return w_Result;
        }
    }
    return SDD_SUCCESS;
}


#ifdef _SDD_READ_ZERO_PADDING_
/****************************************************************************************/
/*  ֐		FSdds_WaitFillMemEnd													*/
/*  Tv		FDMA]I҂													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                      */
/*      		FUW uw_TimeOutMsec TimeOut				                            */
/*  ߂l		FFSDD_SUCCESS														*/
/*				 G[F^CAEg													*/
/*  ŏIXV	F2009.03.09															*/
/****************************************************************************************/
SDD_ERROR Sdds_WaitFillMemEnd(SDD_HANDLE *p_SddHandle, UW uw_TimeOutMsec)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UW uw_WaiEvent;
	UW uw_Event;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	uw_WaiEvent = SDD_EVENTFLG_DMA_END;
	w_ResTmp = Sdd_WaiEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_WaiEvent, &uw_Event, uw_TimeOutMsec);
	if (w_ResTmp == SDD_SUCCESS){
		if(uw_Event == SDD_EVENTFLG_DMA_END){
			w_ResTmp = Sdd_ClrEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_Event);	/* CxgtÕNA */
		}else{
			/* DMAI҂ȊOEventꍇ͉Ȃ */
		}
	}else{
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}

	return w_Result;
}
#endif	/* _SDD_READ_ZERO_PADDING_ */

