/***********************************************************************************/
/*  t@C  F$Workfile: SddOsIntr.c $                                         */
/*  Tv        FSDfoCXhCoOSn荞ݏi[t@C                   */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.            */
/*  ŏIXV  F$Modtime: 06/06/12 09:45 $                                       */
/*                SDD_Intr()Oǉ 2006/06/30 H.Miura                          */
/*                WX^ݒ菈Sddr_GetResponseƒu2006/06/30 H.Miura   */
/*                SDD_Intrp݌㏈ǉ 2006/06/30 H.Miura                  */
/*                SDD_Intrpǂݍ݌㏈ǉ 2006/06/30 H.Miura                  */
/***********************************************************************************/
/* wb_[t@C */
#include "SddCom.h"
#include "SddRegister.h"
#include "SddOsEvent.h"
#include "SddOsTimer.h"
#include "SddOsIntr.h"
#include "SddSecure.h"
#include "SddRegister_dma.h"
#include "SddCardInOut.h"
#include "SddDma.h"

/* Tu֐t@C */
#if defined(_SDD_UNIPHIER_2P_)
#include "device/SddOsIntr_for_uniphier2p.c"
#endif /* defined(_SDD_UNIPHIER_2P_) */

#if defined(_SDD_UNIPHIER_XP_)
#include "device/SddOsIntr_for_uniphierxp.c"
#endif /* defined(_SDD_UNIPHIER_XP_) */

#if defined(_SDD_MN6682X_)
#include "device/SddOsIntr_for_mn6682x.c"
#endif /* defined(_SDD_MN6682X_) */

#if defined(_SDD_LINUX_)
#include "Linux/SddOsIntr_for_Linux.c"
#endif

#if defined(_SDD_ITRON_)
#include "ITron/SddOsIntr_for_ITron.c"
#endif

#if defined(_SDD_T_ENGINE_)
#include "TEngine/SddOsIntr_for_TEngine.c"
#endif

const UW SDD_INTRNO[] = {
    SDD_INTNO_SDIO
#if SDD_DEV_COUNT >= 2
    ,SDD_INTNO_SDIO_2
#endif
#if SDD_DEV_COUNT >= 3
    ,SDD_INTNO_SDIO_3
#endif
};
const UW SDD_DMAINTRNO[] = {
    SDD_INTNO_SDMA
#if SDD_DEV_COUNT >= 2
    ,SDD_INTNO_SDMA_2
#endif
#if SDD_DEV_COUNT >= 3
    ,SDD_INTNO_SDMA_3
#endif
};

#ifndef _SDD_MN6682X_
#ifdef _SDD_ANGOU_
/********************************************************************************/
/*  ֐		FSdds_AngouIntrExe												*/
/*  Tv		FÕp̊ݏN									    */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ												            */
/*  ŏIXV	F2009.03.23													*/
/********************************************************************************/
static void Sdds_AngouIntrExe( SDD_HANDLE *p_SddHandle )
{
    /* Ȃ */
}
#endif /* _SDD_ANGOU_ */
#endif /* _SDD_MN6682X_ */

#if !defined(_SDD_UNIPHIER_2P_) && !defined(_SDD_UNIPHIER_XP_)
/********************************************************************************/
/*  ֐     FSDD_Intr_before                                                */
/*  Tv       FSDD_IntrpO(Jupiterp)                                    */
/*         FȂ                                                           */
/*  ߂l     FȂ                                                           */
/*  ŏIXV F2006/06/30                                                     */
/********************************************************************************/
#define SDD_Intr_before(handle) {\
    /* Ȃ */\
}
#endif /* !defined(_SDD_UNIPHIER_2P_) && !defined(_SDD_UNIPHIER_XP_) */

/********************************************************************************/
/*  ֐		FSDD_Intr														*/
/*  Tv		FSD I/F荞ݏȂ(^XNReLXg)			*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
void SDD_Intr(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	W 	w_ret;
	UW	uw_status1;
	UW	uw_status2;
	UW	uw_event = (UW)0;
    /* SDD_Intr()Oǉ 2006/06/30 H.Miura */
	SDD_Intr_before(p_SddHandle);
	
	/*========================================*/
	/* 荞݌õ[Jϐւ̑ޔ */
	/*========================================*/
	/* foCX擾(荞݃}XN`FbN܂) */
	/* J[hro荞݋mFi荞݃}XN`FbNj */
	uw_status1 = Sddr_GetInt(p_SddHandle, SDD_INT_STATUS1);/* ֐FSD_INFO1WX^ޔ */
	uw_status2 = Sddr_GetInt(p_SddHandle, SDD_INT_STATUS2);/* ֐FSD_INFO2WX^ޔ */
	
	/*========================================*/
	/* 荞݂̃NA						  */
	/*========================================*/
	/* foCXݒ */
/*	Sddr_ClrInt(SDD_INT_CLR1, uw_status1);*/	/* ֐FSD_INFO1WX^荞݃NA */
/*	Sddr_ClrInt(SDD_INT_CLR2, uw_status2);*/	/* ֐FSD_INFO2WX^荞݃NA */
				
	/*==============================*/
	/* SD I/F̊荞ݗv`FbN */
	/*==============================*/
	/* 荞ݗviޔ𗘗pj *//* FoL */
	if ((uw_status1 | uw_status2) == 0) {/* ȍꍇ	*/
		return;	/* Ȃ */
	}
	else {
        /* J[ho`FbN(2006.2.16 H.Miura)@*/
        SDD_GetCDIntr(p_SddHandle, uw_status1, &uw_event);

		/*========================================*/
		/*  G[̏ꍇ					  */
		/*========================================*/
		/*	Y荞݃}XN&NA
				SD_INFO2̊YG[荞݃}XNƊYG[̃NA
				OŎs					*/
		if (Sdd_M_AllErrCheck(uw_status2)) {	/* SG[`FbN */
            p_sdd->uw_SDINFO1_INTERR |= uw_status1;
            p_sdd->uw_SDINFO2_INTERR |= uw_status2;
			Sddr_ClrInt(p_SddHandle, SDD_INT_CLR2, uw_status2);	/* G[NA */
			Sddr_ClrInt(p_SddHandle, SDD_INT_CLR1, SDD_SD_INFO1_RES_END|SDD_SD_INFO1_RW_ACCESSEND);	/* G[Response end/Access endrbgNA */
			p_sdd->w_error |= Sddr_Stat2Err(uw_status2);	/* G[R[hϊ */
			/* SDDD̏ԔiSddDev[port].uh_Status)
						SddDev[port].uh_Status = SDD_STATUS_USB_RWԂ̏ꍇ */
			if (p_sdd->uh_Status & SDD_STATUS_USB_RW) {
				/* G[R[obN֐L */
				if (p_sdd->CbfErr.vp_Fp) {
					/* R[obN֐L̏ꍇAf[^\SDD_DEṼG[ʒmpR[obN֐ďo */
					(*(p_sdd->CbfErr.vp_Fp))(SDD_EVENT_ERROR ,p_sdd->CbfErr.uw_Param, p_sdd->w_error);
					/* p */
				}
				/* R[obN֐̏ꍇAp */
			}
			/* Cxgʒm(G[) */
			uw_event |= SDD_EVENTFLG_ERROR;
		}

		/*========================================*/
		/* 	Response end̏ꍇ				  */
		/*========================================*/
		/*	Response荞݃}XN&NA
			SD_INFO1Response荞݃}XNResponsẽNA
							Sddr_DisResEnd()Ŏs
							Sddr_ClrResEnd 
				OŎs					*/
		if (Sdd_M_ResponseCheck(uw_status1)) {	
			Sddr_ClrInt(p_SddHandle, SDD_INT_CLR1, SDD_SD_INFO1_RES_END);	/* Response end荞݃NA */
			/* Cxgʒm(X|XGh) */
			uw_event |= SDD_EVENTFLG_RES_END;
			/* WX^ݒ菈Sddr_GetResponseƒu2006/06/30 H.Miura */
			Sddr_GetResponse(p_SddHandle, &(p_sdd->uw_CardStatus));
		}
		/*========================================*/
		/* 	R/W access end̏ꍇ			  */
		/*========================================*/
		/*	AccessAllEnd荞݃}XN&NA
						Sddr_DisTransEnd()Ŏs
				OŎs					*/
		if (Sdd_M_DataEndCheck(uw_status1)) {	
			Sddr_ClrInt(p_SddHandle, SDD_INT_CLR1, SDD_SD_INFO1_RW_ACCESSEND);	/* R/W access end荞݃NA */
			/* Cxgʒm([hECgEANZXGh) */
			uw_event |= SDD_EVENTFLG_RW_ACCESS_END;
			/* WX^ݒ菈Sddr_GetResponseƒu2006/06/30 H.Miura */
			Sddr_GetResponse(p_SddHandle, &(p_sdd->uw_CardStatus));
		}
		/*========================================*/
		/* 	BWE荞݂̏ꍇ				  */
		/*========================================*/
		/*	BWE荞݃}XN&NA
					Sddr_DisBWE()Ŏs	
					OŎs 		*/
		if (Sdd_M_BWECheck(uw_status2)) {	
			Sddr_ClrInt(p_SddHandle, SDD_INT_CLR2, SDD_SD_INFO2_BWE);	/* BWE荞݃NA */
			/* Cg̏ꍇ */
            /* Cxgʒm(BWE荞) */
            uw_event |= SDD_EVENTFLG_BRWENA;
		}
		/*========================================*/
		/* 	BRE荞݂̏ꍇ				  */
		/*========================================*/
		/*	BRE荞݃}XN&NA
				Sddr_DisBWE()Ŏs				
				OŎsς 				*/
		if (Sdd_M_BRECheck(uw_status2)) {
			Sddr_ClrInt(p_SddHandle, SDD_INT_CLR2, SDD_SD_INFO2_BRE);	/* BRE荞݃NA */
			/* [h̏ꍇ */
            /* Cxgʒm(BRE荞) */
            uw_event |= SDD_EVENTFLG_BRWENA;
		}
#ifdef _SDD_FUNC_SDIO_
        if (Sdd_M_CheckReg(SDD_SDIO_INFO1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),SDIO_INFO1_ERROR_SET)) {
            /* SDIOnŃG[ */
			p_sdd->w_error = SDD_ERR_SDIO_INTR_ERROR;	/* G[R[hϊ */
            /* G[R[obN֐L */
            if (p_sdd->CbfErr.vp_Fp) {
                /* R[obN֐L̏ꍇAf[^\SDD_DEṼG[ʒmpR[obN֐ďo */
                (*(p_sdd->CbfErr.vp_Fp))(SDD_EVENT_ERROR ,p_sdd->CbfErr.uw_Param, p_sdd->w_error);
                /* p */
            }
			/* Cxgʒm(G[) */
			uw_event |= SDD_EVENTFLG_ERROR;
		}
#endif

		if(uw_event != (UW)0){
			w_ret = Sdd_SetEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_event);
		}
	}
#ifdef _SDD_ANGOU_
    /* ÕpݏN */
    Sdds_AngouIntrExe(p_SddHandle);
#endif /* _SDD_ANGOU_ */

	return;
}

/********************************************************************************/
/*  ֐		FSddr_Stat2Err													*/
/*  Tv		FSD_INFO2WX^̃G[R[hSDDD̃G[R[hɕϊ	*/
/*  		FSD_INFO2WX^̓e										*/
/*  ߂l		FG[R[hiOdlKj 									*/
/*  ŏIXV	F2003.12.17													*/
/********************************************************************************/
SDD_ERROR Sddr_Stat2Err(UW uw_status)
{
	SDD_ERROR  w_Result = 0;
	
	if (uw_status & SDD_SD_INFO2_ERR_ILAACCESS) {
		w_Result |= SDD_ERR_ILA;
	}
	if (uw_status & SDD_SD_INFO2_CBSY) {
		w_Result |= SDD_ERR_ACC_TIMEOUT;
	}
	if (uw_status & SDD_SD_INFO2_RES_TIMEOUT_ERR) {
		w_Result |= SDD_ERR_IP_TIMEOUT;
	}
	if (uw_status & SDD_SD_INFO2_TIMEOUT_ERR) {
		w_Result |= SDD_ERR_IP_TIMEOUT;
	}
	if (uw_status & SDD_SD_INFO2_STOP_ERR) {
		w_Result |= SDD_ERR_END;
	}
	if (uw_status & SDD_SD_INFO2_CRC_ERR) {
		w_Result |= SDD_ERR_CRC;
	}
	if (uw_status & SDD_SD_INFO2_CMD_ERR) {
		w_Result |= SDD_ERR_COMMAND;
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_CheckCDDetect											*/
/*  Tv		FSD I/F̃J[ho|[ONmF							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		F~=0, N=1											*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
UB Sdds_CheckCDDetect(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	UB	ub_check;

	/*========================*/
	/* nh̒~mF */
	/*========================*/
	w_Result = Sdd_CheckCyc(p_SddHandle, &ub_check);	/* pgr0024 */

	return ub_check;
}


/********************************************************************************/
/*  ֐		FSdds_StopCDDetect												*/
/*  Tv		FSD I/F̃J[ho݋֎~									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  ŏIXV	F2009.03.6													    */
/********************************************************************************/
SDD_ERROR Sdds_StopCDDetect(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*====================*/
	/* nh̒~ */
	/*====================*/
	w_Result = Sdd_StopCyc( p_SddHandle, &(p_sdd->OsInfo.cdCycInfo) );	

	return w_Result;
}

#if !defined(_SDD_LINUX_)
void (*SDD_IntrFunc[])(void) = {
	/*  1XbgiXPj2Xbgڂ]ꍇSDD_Intr_0SDD_Intr1ύXKv */
    SDD_Intr_0
#if SDD_DEV_COUNT >= 2
    ,SDD_Intr_1
#endif
#if SDD_DEV_COUNT >= 3
    ,SDD_Intr_2
#endif
};

#if !defined(_SDD_MN6682X_)
void (*Sdd_DMAIntrFunc[])(void) = {
    Sdd_DMAIntr_0
#if SDD_DEV_COUNT >= 2
    ,Sdd_DMAIntr_1
#endif
#if SDD_DEV_COUNT >= 3
    ,Sdd_DMAIntr_2
#endif
};

/********************************************************************************/
/*  ֐		FSDD_Intr_0												    */
/*  Tv		FSDD_Intr Port0pĂяo							        */
/*  		FȂ                        			                        */
/*  ߂l		FȂ											                */
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
void SDD_Intr_0(void)
{
	/* SDD_Intr{ */
	SDD_Intr(&(SddHandleForDriver[0]));
}
/********************************************************************************/
/*  ֐		FSdd_DMAIntr_0											        */
/*  Tv		FSDD_DMAIntr Port0pĂяo									*/
/*  		FȂ                        			                        */
/*  ߂l		FȂ											                */
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
void Sdd_DMAIntr_0(void)
{
	/* SDD_DMAIntr{ */
	SDD_DMAIntr(&(SddHandleForDriver[0]));
}

#if SDD_DEV_COUNT >= 2
/********************************************************************************/
/*  ֐		FSDD_Intr_1												    */
/*  Tv		FSDD_Intr Port1pĂяo							        */
/*  		FȂ                        			                        */
/*  ߂l		FȂ											                */
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
void SDD_Intr_1(void)
{
	/* SDD_Intr{ */
	SDD_Intr(&(SddHandleForDriver[1]));
}
/********************************************************************************/
/*  ֐		FSdd_DMAIntr_1											        */
/*  Tv		FSDD_DMAIntr Port1pĂяo									*/
/*  		FȂ                        			                        */
/*  ߂l		FȂ											                */
/*  ŏIXV	F2009.3.19														*/
/********************************************************************************/
void Sdd_DMAIntr_1(void)
{
	/* SDD_DMAIntr{ */
	SDD_DMAIntr(&(SddHandleForDriver[1]));
}
#endif

#if SDD_DEV_COUNT >= 3
/********************************************************************************/
/*  ֐		FSDD_Intr_2												    */
/*  Tv		FSDD_Intr Port2pĂяo							        */
/*  		FȂ                        			                        */
/*  ߂l		FȂ											                */
/*  ŏIXV	F2010.3.9														*/
/********************************************************************************/
void SDD_Intr_2(void)
{
	/* SDD_Intr{ */
	SDD_Intr(&(SddHandleForDriver[2]));
}

/********************************************************************************/
/*  ֐		FSdd_DMAIntr_2											        */
/*  Tv		FSDD_DMAIntr Port2pĂяo									*/
/*  		FȂ                        			                        */
/*  ߂l		FȂ											                */
/*  ŏIXV	F2010.3.9														*/
/********************************************************************************/
void Sdd_DMAIntr_2(void)
{
	/* SDD_DMAIntr{ */
	SDD_DMAIntr(&(SddHandleForDriver[2]));
}
#endif

#endif /* !defined(_SDD_MN6682X_) */
#endif /* !defined(_SDD_LINUX_) */

