/***********************************************************************************/
/*  t@C  F$Workfile: SddOsSemaphore.c $                                    */
/*  Tv        FSDfoCXhCoOSnZ}tHEr䏈i[t@C         */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.            */
/*  ŏIXV  F$Modtime: 06/06/12 01:10 $                                       */
/***********************************************************************************/
/* wb_[t@C */
#include "SddCom.h"
#include "SddOsSemaphore.h"
#include "SddError.h"

#if defined(_SDD_LINUX_)
#include "Linux/SddOsSemaphore_for_Linux.c"
#endif

#if defined(_SDD_ITRON_)
#include "ITron/SddOsSemaphore_for_ITron.c"
#endif

#if defined(_SDD_T_ENGINE_)
#include "TEngine/SddOsSemaphore_for_TEngine.c"
#endif

/********************************************************************************/
/*  ֐		FSdds_EndExcl													*/
/*  Tv		FSDfoCXhCoprI								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FANZẌfoCXID										*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
SDD_ERROR Sdds_EndExcl( SDD_HANDLE *p_SddHandle, UW uw_tmpDevID )
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

#ifdef	_SDD_FUNC_SECURE_
	/* FSDDD̎Z}tH */
	if( uw_tmpDevID == SDD_DEVICEID_SECURE ) {
		w_TmpRet = Sdd_SigSem(&(p_sdd->OsInfo.angouSem));	/* OSbp[֐ */
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		}
		/* G[łʏSDDDZ}tHKv邽returnȂ */
	}
#endif	/* _SDD_FUNC_SECURE_ */

	w_TmpRet = Sdd_SigSem(&(p_sdd->OsInfo.normalSem));	/* OSbp[֐ */
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
	}
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSdds_StartExcl												*/
/*  Tv		FSDfoCXhCoprJn								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*              FUW uw_tmpDevID ANZẌfoCXID							*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
SDD_ERROR Sdds_StartExcl(SDD_HANDLE *p_SddHandle, UW uw_tmpDevID )
{
	SDD_ERROR	w_ret = SDD_SUCCESS;
	SDD_ERROR	w_TmpRet;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	w_TmpRet = Sdd_WaiSem(&(p_sdd->OsInfo.normalSem));	/* OSbp[֐ */
	if(w_TmpRet != SDD_SUCCESS){
		w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
		return w_ret;
	}

#ifdef	_SDD_FUNC_SECURE_
	if( uw_tmpDevID == SDD_DEVICEID_SECURE ) {
		/* FSDDD̎Z}tHl */
		w_TmpRet = Sdd_WaiSem(&(p_sdd->OsInfo.angouSem));	/* OSbp[֐ */
		if(w_TmpRet != SDD_SUCCESS){
			w_ret = Sdds_SetErr(p_SddHandle, __LINE__, w_ret, w_TmpRet);
			/* G[̎breakĒʏSDDDpZ}tH{ */
			w_TmpRet = Sdd_SigSem(&(p_sdd->OsInfo.normalSem));	/* OSbp[֐ */
			/* ÕZ}tHlG[̏ꍇSDZ}tȞʂ͔肵Ȃ */
		}
	}
#endif		/* _SDD_FUNC_SECURE_ */
	return w_ret;
}

#if !defined(_SDD_T_ENGINE_)
/************************************************************************************/
/*  ֐		FSdds_DeleteSemaphore												*/
/*  Tv		FZ}tH폜												    */
/*  			FZ}tH̍폜sB                                    */
/* 			FȂ																*/
/*  ߂l		FFSDD_SUCCESS													*/
/*  			FsFG[R[h												*/
/*  ŏIXV	F2009.3.3															*/
/************************************************************************************/
SDD_ERROR Sdds_DeleteSemaphore(void)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
    UW i;
	SDD_DEV	*p_sdd;

    for(i=0; i<SDD_DEV_COUNT; i++) {
        p_sdd = &(SddDev[i]);
        /*==========================================================*/
        /*  Z}tH̍폜											*/
        /*	폜Z}tH͒ʏSDDDƔFSDDDpZ}tHA		*/
        /*							FSDDDƈÕpZ}tH		*/
        /*	Sdd_DelSem()łȂ							*/
        /*==========================================================*/
        w_Result = Sdd_DelSem(&(p_sdd->OsInfo.normalSem));
        if(w_Result < SDD_SUCCESS){			/* 0ȉ̏ꍇ̓VXeR[G[ */
            return w_Result;
        }
#ifdef	_SDD_FUNC_SECURE_
        w_Result = Sdd_DelSem(&(p_sdd->OsInfo.angouSem));
        if(w_Result < SDD_SUCCESS){			/* 0ȉ̏ꍇ̓VXeR[G[ */
            return w_Result;
        }
#endif
    }
    return SDD_SUCCESS;
}
#endif

