/***********************************************************************************/
/*  t@C  F$Workfile: SddOsTimer.c $                                        */
/*  Tv        FSDfoCXhCoOSn^C}i[t@C                     */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.            */
/*  ŏIXV  F$Modtime: 06/06/12 09:45 $                                       */
/***********************************************************************************/
/* wb_[t@C */
#include "SddCom.h"
#include "SddRegister.h"
#include "SddOsEvent.h"
#include "SddOsTimer.h"
#include "SddCardInOut.h"
#include "SddOsSemaphore.h"

/* Tu֐t@C */
#if defined(_SDD_LINUX_)
#include "Linux/SddOsTimer_for_Linux.c"
#endif

#if defined(_SDD_ITRON_)
#include "ITron/SddOsTimer_for_ITron.c"
#endif

#if defined(_SDD_T_ENGINE_)
#include "TEngine/SddOsTimer_for_TEngine.c"
#endif

/********************************************************************************/
/*  ֐		FSdd_TimerHdr_0												*/
/*  Tv		FSdd_TimerHdr Port0Ăяo		                            */
/*  		FȂ                                                          */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.23													*/
/********************************************************************************/
void Sdd_TimerHdr_0(void)
{
	/* Sdd_TimerHdr{ */
	Sdd_TimerHdr(&(SddHandleForDriver[0]));
}

/********************************************************************************/
/*  ֐		FSdd_CDDetectHdr_0												*/
/*  Tv		FSdd_CDDetectHdr Port0Ăяo		                        */
/*  		FȂ                                                          */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.23													*/
/********************************************************************************/
void Sdd_CDDetectHdr_0(void)
{
	/* Sdd_CDDetectHdr{ */
	Sdd_CDDetectHdr(&(SddHandleForDriver[0]));
}

#if SDD_DEV_COUNT >= 2
/********************************************************************************/
/*  ֐		FSdd_TimerHdr_1												*/
/*  Tv		FSdd_TimerHdr Port1Ăяo		                            */
/*  		FȂ                                                          */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.23													*/
/********************************************************************************/
void Sdd_TimerHdr_1(void)
{
	/* Sdd_TimerHdr{ */
	Sdd_TimerHdr(&(SddHandleForDriver[1]));
}

/********************************************************************************/
/*  ֐		FSdd_CDDetectHdr_1												*/
/*  Tv		FSdd_CDDetectHdr Port1Ăяo		                        */
/*  		FȂ                                                          */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.23													*/
/********************************************************************************/
void Sdd_CDDetectHdr_1(void)
{
	/* Sdd_CDDetectHdr{ */
	Sdd_CDDetectHdr(&(SddHandleForDriver[1]));
}
#endif

#if SDD_DEV_COUNT >= 3
/********************************************************************************/
/*  ֐		FSdd_TimerHdr_2												*/
/*  Tv		FSdd_TimerHdr Port2Ăяo		                            */
/*  		FȂ                                                          */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.03.09													*/
/********************************************************************************/
void Sdd_TimerHdr_2(void)
{
	/* Sdd_TimerHdr{ */
	Sdd_TimerHdr(&(SddHandleForDriver[2]));
}

/********************************************************************************/
/*  ֐		FSdd_CDDetectHdr_2												*/
/*  Tv		FSdd_CDDetectHdr Port2Ăяo		                        */
/*  		FȂ                                                          */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.03.09													*/
/********************************************************************************/
void Sdd_CDDetectHdr_2(void)
{
	/* Sdd_CDDetectHdr{ */
	Sdd_CDDetectHdr(&(SddHandleForDriver[2]));
}
#endif

void (*Sdd_TimerHdrFunc[])(void) = {
    Sdd_TimerHdr_0
#if SDD_DEV_COUNT >= 2
    ,Sdd_TimerHdr_1
#endif
#if SDD_DEV_COUNT >= 3
    ,Sdd_TimerHdr_2
#endif
};

void (*Sdd_CDDetectHdrFunc[])(void) = {
    Sdd_CDDetectHdr_0
#if SDD_DEV_COUNT >= 2
    ,Sdd_CDDetectHdr_1
#endif
#if SDD_DEV_COUNT >= 3
    ,Sdd_CDDetectHdr_2
#endif
};

#ifndef _SDD_LINUX_
/********************************************************************************/
/*  ֐		FSdd_TimerHdr													*/
/*  Tv		F^CAEgpnh									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.23													*/
/********************************************************************************/
void Sdd_TimerHdr(SDD_HANDLE *p_SddHandle)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*=========================================*/
	/* ^C}l0ȏ̏ꍇɂ̂݃JEg_E */
	/*=========================================*/
	if(p_sdd->OsInfo.cycInfo.uw_SddTimer > 0) {
		/*==============*/
		/* ^C}lZ */
		/*==============*/
		p_sdd->OsInfo.cycInfo.uw_SddTimer -= SDD_CYCTIM_CYCID;

		/*==================================================*/
		/* ^C}AEgȂ΃CxgtOݒ(^C}ʒm) */
		/*==================================================*/
		if(p_sdd->OsInfo.cycInfo.uw_SddTimer == 0) {
			Sdd_SetEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), SDD_EVENTFLG_TIMEOUT);
			p_sdd->w_error |= SDD_ERR_OS_TIMEOUT;	/* |[Õ`FbNp */
		}
		else if (p_sdd->OsInfo.cycInfo.uw_SddTimer < SDD_CYCTIM_CYCID) {	/* uw_SddTimer̒lSDD_CYCTIM_CYCID̔{łȂƂ */
			p_sdd->OsInfo.cycInfo.uw_SddTimer  = SDD_CYCTIM_CYCID;	/* uw_SddTimer̒lSDD_CYCTIM_CYCID̔{ɂۂ߂邽 */
		}
	}
}
#endif /* _SDD_LINUX_ */

/********************************************************************************/
/*  ֐		FSdd_TimerStart												*/
/*  Tv		F^CAEgp^C}Jn										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW	^CAEgl(^CeBbN)							*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdd_TimerStart(SDD_HANDLE *p_SddHandle, UW uw_NewTimer)
{
	SDD_ERROR w_Result = (W)0;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	
	/*================*/
	/* ^C}lݒ */
	/*================*/
	p_sdd->OsInfo.cycInfo.uw_SddTimer = uw_NewTimer;

	/*================================================*/
	/* nhNĂȂȂ΋NȂ */
	/*================================================*/
	if(p_sdd->OsInfo.cycInfo.bl_Active == FALSE) {
		/*====================*/
		/* nh̋N */
		/*====================*/
		Sdd_ClrEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), SDD_EVENTFLG_TIMEOUT);
		p_sdd->w_error = SDD_SUCCESS;
		w_Result = Sdd_StartCyc(p_SddHandle, &(p_sdd->OsInfo.cycInfo));
		p_sdd->OsInfo.cycInfo.bl_Active = TRUE;
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdd_TimerStop													*/
/*  Tv		F^CAEgp^C}~										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FVXeR[G[											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdd_TimerStop( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR er_err = 0;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*================================================*/
	/* nhNĂȂΒ~Ȃ */
	/*================================================*/
	if(p_sdd->OsInfo.cycInfo.bl_Active == TRUE) {
		/*====================*/
		/* nh̒~ */
		/*====================*/
		er_err = Sdd_StopCyc(p_SddHandle, &(p_sdd->OsInfo.cycInfo));
		p_sdd->OsInfo.cycInfo.bl_Active = FALSE;
	}
	return er_err;
}
