/********************************************************************************/
/*  t@C    F$Workfile: SddRegister.c $                                  */
/*  Tv          FSDfoCXhCoWX^ANZXiwjt@C        */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 06/06/12 13:20 $                                  */
/*                WX^ݒ菈Sddr_GetResponseƒu2006/06/19 H.Miura*/
/*                SD NbN o͏ǉ 2006/06/30 H.Miura                   */
/*                SD NbN ~ǉ 2006/06/30 H.Miura                   */
/*                SD I/F[hݒNORMALǉ 2006/07/03 H.Miura           */
/*                SD I/F[hݒNORMALǉ 2006/07/03 H.Miura         */
/********************************************************************************/
/* wb_[t@C */
#include "SddCom.h"
#include "SddOsEvent.h"
#include "SddRegister.h"
#include "SddError.h"
#ifdef _SDD_SDCARDINOUT_KENSHO_
#include "SddCardInOut.h"
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

/* Tu֐t@C */
#ifdef _SDD_JUPITER_
#include "device/SddRegister_for_jupiter.c"
#endif	/* _SDD_JUPITER_ */

#ifdef _SDD_UNIPHIER_2P_
#include "device/SddRegister_for_uniphier2p.c"
#endif /*  _SDD_UNIPHIER_2P_ */

#ifdef _SDD_UNIPHIER_XP_
#include "device/SddRegister_for_uniphierxp.c"
#endif /*  _SDD_UNIPHIER_XP_ */

#if defined(_SDD_MN6682X_)
#include "device/SddRegister_for_mn6682x.c"
#endif /* defined(_SDD_MN6682X_) */

#if defined(_SDD_MN66822_)
#include "device/SddRegister_for_mn66822.c"
#endif /* defined(_SDD_MN6682X_) */

#if defined(_SDD_MN66826_)
#include "device/SddRegister_for_mn66826.c"
#endif /* defined(_SDD_MN6682X_) */

#if defined(_SDD_USE_SDMACLIB_)
#include "device/SddRegister_for_sdmaclib.c"
#endif /* defined(_SDD_USE_SDMACLIB_) */

#if defined(_SDD_PEAKS_PRO2_)
#include "device/SddRegister_for_PeaksPro2.c"
#endif /* defined(_SDD_PEAKS_PRO2_) */

#if defined(_SDD_PCAM_)
#include "device/SddRegister_for_pcam.c"
#endif /* defined(_SDD_PCAM_) */

#if defined(_SDD_4M_ANDROID_)
#include "device/SddRegister_for_4mAndroid.c"
#endif /* defined(_SDD_4M_ANDROID_) */

#if defined(_SDD_MN66830_)
#include "device/SddRegister_for_mn66830.c"
#endif /* defined(_SDD_MN66830_) */

/********************************************************************************/
/*  ֐		FSddr_DisIntSDBuf												*/
/*  Tv		FSD I/F SD-BUF荞݋֎~										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FRead(SDD_BUF_READ)/Write(SDD_BUF_WRITE)						*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_DisIntSDBuf(SDD_HANDLE *p_SddHandle, UW uw_status)
{
	/*
		if(Read){
			SD_INFO2_MaskBRE̊荞݋֎~
		}
		else{
			SD_INFO2_MaskBWE̊荞݋֎~
		}
	*/
	if (uw_status == SDD_BUF_READ) {
		Sdd_M_OrReg(SDD_SD_INFO2_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO2_MASK_BRE);
	}
	else {
		Sdd_M_OrReg(SDD_SD_INFO2_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO2_MASK_BWE);
	}
	return;
}

/********************************************************************************/
/*  ֐		FSddr_CheckAddrAlign											*/
/*  Tv		FAhXACg`FbN                       			*/
/*  		FAhX														*/
/*  ߂l		FFACgnj(SDD_ALIGN_OK)							*/
/*  			FsFACgG[(SDD_ALIGN_NG)						*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
UW Sddr_CheckAddrAlign(B *pb_Buf)
{
	return (UW)0;					/* ACg̐͂Ȃ */
}

/********************************************************************************/
/*  ֐		FSddr_CheckBusy												*/
/*  Tv		FR}hrW[`FbN										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F`FbN  0FrW[Ȃ									*/
/*						F		1FrW[										*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_CheckBusy(SDD_HANDLE *p_SddHandle, UW *checkVal)
{
	*checkVal = Sdd_M_CheckReg(SDD_SD_INFO2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO2_CBSY);
#if 0 /* ÕɂF،nR}hƈÕR}h͔rĂA
         {Busy`FbN鎖ŃfONBSYC2`FbN͂Ȃ */
#ifdef _SDD_JUPITER_
	*checkVal |= Sdd_M_CheckReg(SDD_SD_INFO2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO2_BSYC2);
#endif
#endif

    return;
}

/********************************************************************************/
/*  ֐		FSddr_CheckCardStatus											*/
/*  Tv		FCard Status(R1)擾											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_ReadFReadۂ[in]									*/
/* 				FW *w_errCode:Card Status[out]									*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_CheckCardStatus(SDD_HANDLE *p_SddHandle, UW uw_Read, SDD_ERROR *w_errCode)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UB	ub_cnt = 0;
	UW	uw_checkErr;
	
	*w_errCode = SDD_SUCCESS;

/* SPI[hŃubN[h̃J[hoO΍̂߁A͕KvȂ͂ */
	if(uw_Read == SDD_CARD_STATUS_READ){	/* Read̂ */

	}

	if(((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) != SDD_CARD_TYPE_MMC){
		uw_checkErr = SDD_CARD_STATUS_ERROR;
	}
	else
	{
		uw_checkErr = SDD_MMC_CARD_STATUS_ERROR;
	}

	while(ub_cnt < SDD_GET_STATUS_LOOP_CNT)
	{
		if(p_sdd->uw_CardStatus & uw_checkErr){		/* R}hX|X(R1)̃J[hXe[^XG[mF */
			/* WX^ݒ菈Sddr_GetResponseƒu2006/06/19 H.Miura */
			Sddr_GetResponse(p_SddHandle, &(p_sdd->uw_CardStatus));
			*w_errCode = SDD_ERR_R1_STATUS;			/* R}hX|X(R1)̃J[hXe[^X G[ */
		}
		else
		{
			*w_errCode = SDD_SUCCESS;
			break;
		}
		ub_cnt++;
	}
	return;
}

/********************************************************************************/
/*  ֐		FSddr_CheckDAT0													*/
/*  Tv		FDAT0rW[`FbN											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F`FbN  0FrW[Ȃ									*/
/*						F		1FrW[										*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_CheckDAT0(SDD_HANDLE *p_SddHandle, UW *checkVal)
{
	*checkVal = Sdd_M_CheckReg(SDD_SD_INFO2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO2_DAT0);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_CheckSecCnt												*/
/*  Tv		FZN^̗L										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FLF1														*/
/*  			FF0														*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
UW Sddr_CheckSecCnt(SDD_HANDLE *p_SddHandle)
{
	UW uw_sec;

	Sdd_M_GetReg(SDD_SD_STOP(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_sec);		/* f[^]pݒmF(SD_STOP) */

	return (UW)(((uw_sec & SDD_SD_STOP_SEC) == 0) ? 0 : 1);	/* 1:LA0: */
}

/********************************************************************************/
/*  ֐		FSddr_ClrErrAll												*/
/*  Tv		FSD I/F  G[NA											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_ClrErrAll( SDD_HANDLE *p_SddHandle )
{
	/*
	SD_INFO2̃G[ׂăNA
	*/
	Sdd_M_SetReg(SDD_SD_INFO2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), (SDD_VULH)~SDD_SD_INFO2_ERR_ALL);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_ClrInt													*/
/*  Tv		FSD I/F 荞݃NAݒ										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FʁFSDD_INT_CLR1		n荞						*/
/*  			F		SDD_INT_CLR2		ُn荞						*/
/*  ߂l		Fۂɔ荞ݏԁi荞݃}XNȊOj 			*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
void Sddr_ClrInt(SDD_HANDLE *p_SddHandle, UW uw_type, UW uw_status)
{
	switch (uw_type) {
		case SDD_INT_CLR1:
			Sdd_M_SetReg(SDD_SD_INFO1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~uw_status);
			break;
		case SDD_INT_CLR2:
			Sdd_M_SetReg(SDD_SD_INFO2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~uw_status);
			break;
		default:
			break;
	}
	return;
}

/********************************************************************************/
/*  ֐		FSddr_ClrResEnd											    */
/*  Tv		FSD I/F Response EndNA֎~									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_ClrResEnd( SDD_HANDLE *p_SddHandle )
{
	/*
	SD_INFO1Res EndNA
	*/
	Sdd_M_SetReg(SDD_SD_INFO1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_INFO1_RES_END);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_ClrTransEnd											    */
/*  Tv		FSD I/FAccess All EndNA֎~								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_ClrTransEnd( SDD_HANDLE *p_SddHandle )
{
	/*  
	SD_INFO1R/W Access  EndNA
	*/
	Sdd_M_SetReg(SDD_SD_INFO1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_INFO1_RW_ACCESSEND);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_CopyFromBuf												*/
/*  Tv		FSD obt@ǂݍ(SD_BUF)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB * Rs[													*/
/*				FUW Rs[(ByteP)											*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_CopyFromBuf(SDD_HANDLE *p_SddHandle, UB * pub_Dst, UW uw_Cnt)
{
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	LELONG ul_Tmp;
#else  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	LESHORT uh_Tmp;
#endif  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	UB *pub_buf = pub_Dst;
	UW	uw_x;
	
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	/* Rs[(2ByteP)Rs[(WX^P)ɕύX */
	uw_Cnt /= 4;
	for (uw_x = 0; uw_x < uw_Cnt; uw_x++, pub_buf+=4) {
		Sdd_M_GetReg(SDD_SD_BUF(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ul_Tmp.uw_dat);
		*((unsigned short *)pub_buf) = (unsigned short)(ul_Tmp.dt2word.low);
		*((unsigned short *)(pub_buf+2)) = (unsigned short)ul_Tmp.dt2word.high;
	}
#else  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	/* Rs[(ByteP)Rs[(WX^P)ɕύX */
	uw_Cnt /= 2;
	for (uw_x = 0; uw_x < uw_Cnt; uw_x++, pub_buf+=2) {
		Sdd_M_GetReg(SDD_SD_BUF(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Tmp.uh_dat);
		*pub_buf = uh_Tmp.dt2byte.low;
		*(pub_buf+1) = uh_Tmp.dt2byte.high;
	}
#endif  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_CopyFromRsp												*/
/*  Tv		FX|Xǂݍ(SDD_RSP0`SDD_RSP7)						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB * Rs[													*/
/*				FUW ItZbg(1ByteP)	[0`15]								*/
/*				FUW Rs[(1ByteP)										*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.6													    */
/********************************************************************************/
void Sddr_CopyFromRsp(SDD_HANDLE *p_SddHandle, UB * pub_Dst, UW uw_Offset, UW uw_Cnt)
{
	UW uw_x;
	LESHORT	uh_Tmp;
	
	/* ItZbg(1ByteP)ItZbgiWX^Pʁjɕϊ */
	uw_Offset /= 2;
	/*
	wSD_RSP0 + ItZbgRs[Af[^ǂݏoApub_DstɃRs[
	*/
	uw_x = (UW)0;
	while (uw_x < uw_Cnt) {
		/* oCgXbvȂRs[ */
		Sdd_M_GetReg(*(&SDD_SD_RSP0(Sdd_M_GetPortNum(p_SddHandle->ub_Port)) + uw_Offset + uw_x/2), uh_Tmp.uh_dat);
		pub_Dst[uw_x] = uh_Tmp.dt2byte.low;	
		uw_x++;						/* oCgP */
		if(uw_x < uw_Cnt) {
			pub_Dst[uw_x] = uh_Tmp.dt2byte.high;
			uw_x++;					/* oCgP */
		}
	}
	return;
}

/********************************************************************************/
/*  ֐		FSddr_CopyToBuf												*/
/*  Tv		FSD obt@(SD_BUF)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB * Rs[													*/
/*				FUW Rs[(ByteP)											*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_CopyToBuf(SDD_HANDLE *p_SddHandle, UB * pub_Src, UW uw_Cnt)
{
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	LELONG ul_Tmp;
#else  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	LESHORT uh_Tmp;
#endif  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	
	UB *pub_buf = pub_Src;
	UW	uw_x;
	
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	/* Rs[(2ByteP)Rs[(WX^P)ɕύX */
	uw_Cnt /= 4;
	
	for (uw_x = 0; uw_x < uw_Cnt; uw_x++, pub_buf+=4) {
		ul_Tmp.dt2word.low = *((unsigned short *)pub_buf);
		ul_Tmp.dt2word.high = *(unsigned short *)(pub_buf+2);
		Sdd_M_SetReg(SDD_SD_BUF(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ul_Tmp.uw_dat);
	}

#else  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	/* Rs[(ByteP)Rs[(WX^P)ɕύX */
	uw_Cnt /= 2;

	for (uw_x = 0; uw_x < uw_Cnt; uw_x++, pub_buf+=2) {
		uh_Tmp.dt2byte.low = *pub_buf;
		uh_Tmp.dt2byte.high = *(pub_buf+1);
		Sdd_M_SetReg(SDD_SD_BUF(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Tmp.uh_dat);
	}
#endif  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

	return;
}


/************************************************************************************/
/*  ֐		FSddr_DisIntAll												    */
/*  Tv		FSD I/F  荞ݑS֎~				    						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                  */
/*  ߂l		FȂ							    								*/
/*  ŏIXV	F2009.03.06													    */
/************************************************************************************/
void Sddr_DisIntAll(SDD_HANDLE *p_SddHandle)
{
	/*
		SD I/FSD_INFO1_MASKySD_INFO2_MASK̊荞݂
		荞݋֎~ɐݒ
	*/

	/*============================*/
	/* SDD_INFO1_MASK荞݋֎~ */
	/*============================*/
	/* INFO1Ώۊ荞݂̃}XN */
	Sdd_M_OrReg(SDD_SD_INFO1_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO1_MASK_ALL);

	/*============================*/
	/* SDD_INFO2_MASK荞݋֎~ */
	/*============================*/
	/* INFO2Ώۊ荞݂̃}XN */
	Sdd_M_OrReg(SDD_SD_INFO2_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO2_MASK_ALL);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_DisIntEraseCMD											*/
/*  Tv		FEraseR}hsOSD I/F ^CAEg荞݋֎~			*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_DisIntEraseCMD( SDD_HANDLE *p_SddHandle )
{
	/* EraseR}hsSD_INFO2X|X^CAEg, ^CAEgG[}XN */
	Sdd_M_OrReg(SDD_SD_INFO2_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO2_MASK_RES_TIMEOUT | SDD_SD_INFO2_MASK_TIMEOUT);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_DisResEnd											    */
/*  Tv		FSD I/F Response End荞݋֎~								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_DisResEnd( SDD_HANDLE *p_SddHandle )
{
	
	/*
	SD_INFO1_MaskResponse End荞݋֎~ɐݒ
	*/
	Sdd_M_OrReg(SDD_SD_INFO1_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO1_MASK_RES_END);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_DisTransEnd											    */
/*  Tv		FSD I/F SD I/FAccess All End荞݋֎~						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_DisTransEnd( SDD_HANDLE *p_SddHandle )
{
	
	/*
	SD_INFO1_MaskR/W  Access  End荞݋֎~ɐݒ
	*/
	Sdd_M_OrReg(SDD_SD_INFO1_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO1_MASK_RW_ACCESSEND);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_DisSecCnt												*/
/*  Tv		FZN^̖ݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_DisSecCnt(SDD_HANDLE *p_SddHandle)
{
	Sdd_M_AndReg(SDD_SD_STOP(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_STOP_SEC);		/* f[^]pݒmF(SD_STOP) */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_EnaClk													*/
/*  Tv		FSD NbN o/~											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  		    FNbNóFSDD_CLK_ENABLE									*/
/*				FNbN~FSDD_CLK_DISABLE									*/
/*  ߂l		FSDD_ERROR														*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sddr_EnaClk(SDD_HANDLE *p_SddHandle, UW uw_clk)
{
	/* NbNo̓tOSDD_CLK_ENABLEȂ */
	if (uw_clk == SDD_CLK_ENABLE) {
        /* SD NbN o͏ǉ 2006/06/30 H.Miura */
        return Sddr_EnaClk_enable(p_SddHandle);
	}
	else {
        /* SD NbN ~ǉ 2006/06/30 H.Miura */
        return Sddr_EnaClk_disable(p_SddHandle);
	}
}

/********************************************************************************/
/*  ֐		FSddr_EnaIntAllErr												*/
/*  Tv		FSD I/F ׂẴG[݂								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_EnaIntAllErr( SDD_HANDLE *p_SddHandle )
{
	/* SD_INFO2ׂ̂ẴG[݂ */
	Sdd_M_AndReg(SDD_SD_INFO2_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_INFO2_MASK_ERR_ALL);

	return;

}

/********************************************************************************/
/*  ֐		FSddr_EnaIntReadyCMD											*/
/*  Tv		FSD I/F R}hs荞݋								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_EnaIntReadyCMD( SDD_HANDLE *p_SddHandle )
{
	
	/*
	R}h]O荞݋
	SD_INFO1Res荞݂SD_INFO2̃G[荞݂
	*/
	/*
	SD_INFO1Response end荞݂
	*/
	Sdd_M_AndReg(SDD_SD_INFO1_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~(SDD_SD_INFO1_MASK_RES_END));

	/*
	SD_INFO2̃G[荞݂Sċ
	*/
	Sdd_M_AndReg(SDD_SD_INFO2_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_INFO2_MASK_ERR_ALL);

	return;
}

/********************************************************************************/
/*  ֐		FSddr_EnaIntSDBuf												*/
/*  Tv		FSD I/F SD-BUF݋										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FRead(SDD_BUF_READ)/Write(SDD_BUF_WRITE)						*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_EnaIntSDBuf(SDD_HANDLE *p_SddHandle, UW uw_status)
{
	/*
		if(Read){
			SD_INFO2_MaskBRE̊荞݋
		}
		else{
			SD_INFO2_MaskBWE̊荞݋
		}
	*/
	if (uw_status == SDD_BUF_READ) {
		Sdd_M_AndReg(SDD_SD_INFO2_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_INFO2_MASK_BRE);
	}
	else {
		Sdd_M_AndReg(SDD_SD_INFO2_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_INFO2_MASK_BWE);
	}
	return;
}

/********************************************************************************/
/*  ֐		FSddr_EnaResEnd											    */
/*  Tv		FSD I/F Response End荞݋								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_EnaResEnd( SDD_HANDLE *p_SddHandle )
{

	/*
	SD_INFO1_MaskResponse End荞݋ɐݒ
	*/
	Sdd_M_AndReg(SDD_SD_INFO1_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_INFO1_MASK_RES_END);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_GetCID													*/
/*  Tv		FCID̎擾														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_GetCID( SDD_HANDLE *p_SddHandle )
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*
		SD_RSP0`7ɂCIDSddDev[port].ub_Cid[]Ɋi[
	*/
	Sddr_CopyFromRsp(p_SddHandle, &(p_sdd->ub_Cid[1]), SDD_SD_CID_OFFSET, SDD_CID_SIZE -1);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_GetCSD													*/
/*  Tv		FCSD̎擾														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_GetCSD( SDD_HANDLE *p_SddHandle )
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	/*
		SD_RSP0`7ɂCSDSddDev[port].ub_Csd[]Ɋi[
	*/
	Sddr_CopyFromRsp(p_SddHandle, &(p_sdd->ub_Csd[1]), SDD_SD_CSD_OFFSET, SDD_CSD_SIZE - 1);
	return;
}

#if !defined(_SDD_UNIPHIER_2P_) && !defined(_SDD_UNIPHIER_XP_)
/********************************************************************************/
/*  ֐		FSddr_GetInt													*/
/*  Tv		FSD I/F 荞ݏԎ擾										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FXe[^XʁFSDD_INT_STATUS1		n荞			*/
/*  			F				FSDD_INT_STATUS2		ُn荞			*/
/*  ߂l		Fۂɔ荞ݏԁi荞݃}XNȊOj 			*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
UW Sddr_GetInt(SDD_HANDLE *p_SddHandle, UW uw_status)
{
	UW uw_ret = 0;
	UW uw_mask = 0;
	
	switch (uw_status) {
		case SDD_INT_STATUS1:						/* n */
			Sdd_M_GetReg(SDD_SD_INFO1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_ret);
			Sdd_M_GetReg(SDD_SD_INFO1_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_mask);
			uw_mask &= ~(SDD_SD_INFO1_SDDATA3_CARDCHECK|SDD_SD_INFO1_CARDCHECK);
			break;
		case SDD_INT_STATUS2:						/* ُn */
			Sdd_M_GetReg(SDD_SD_INFO2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_ret);
			Sdd_M_GetReg(SDD_SD_INFO2_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_mask);
			uw_mask &= ~(SDD_SD_INFO2_CBSY);
			break;
		default:
			break;
	}
	return (uw_ret & ~uw_mask);
}
#endif /* _SDD_UNIPHIER_2P_ && _SDD_UNIPHIER_XP_ */

#if !defined(_SDD_MN66826_) && !defined(_SDD_4M_ANDROID_) && !defined(_SDD_MN66830_) 
/********************************************************************************/
/*  ֐		FSddr_GetMechanicalWP											*/
/*  Tv		FWPLtÕ`FbN										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		Fpub_MechanicalWPL										*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_GetMechanicalWP(SDD_HANDLE *p_SddHandle, UB *pub_MechanicalWP)
{
	/*============================*/
	/* WPL̃`FbN L(1) */
	/*============================*/
	if(Sdd_M_CheckReg(SDD_SD_INFO1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_INFO1_WP)){
#ifdef _SDD_CHANGE_MECANICALWP_
		*pub_MechanicalWP = SDD_MECHANICALWP_ON;
#else
		*pub_MechanicalWP = SDD_MECHANICALWP_OFF;
#endif
	}
	else{
#ifdef _SDD_CHANGE_MECANICALWP_
		*pub_MechanicalWP = SDD_MECHANICALWP_OFF;
#else
		*pub_MechanicalWP = SDD_MECHANICALWP_ON;
#endif
	}

	return;
}
#endif /* !defined(_SDD_MN66826_) && !defined(_SDD_4M_ANDROID_)  */

/********************************************************************************/
/*  ֐		FSddr_GetOCR													*/
/*  Tv		FOCR̎擾														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.6													    */
/********************************************************************************/
void Sddr_GetOCR( SDD_HANDLE *p_SddHandle )
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	/*
		SD_RSP0`7ɂOCRSddDev[port].ub_Ocr[]Ɋi[
	*/
	Sddr_CopyFromRsp(p_SddHandle, &(p_sdd->ub_Ocr[0]), SDD_SD_OCR_OFFSET, SDD_OCR_SIZE);
	return;
}

/********************************************************************************/
/*  ֐		FSddr_GetRCA													*/
/*  Tv		FRCA̎擾														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_GetRCA( SDD_HANDLE *p_SddHandle )
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	/*
		SD_RSP1ɂRCASddDev[port].uh_RcaɊi[擾
		j
	*/
	Sddr_CopyFromRsp(p_SddHandle, (UB *)(&(p_sdd->uh_Rca)), SDD_SD_RCA_OFFSET, SDD_RCA_SIZE);
	return;
}


/********************************************************************************/
/*  ֐		FSddr_PollingResEnd											*/
/*  Tv		FSD_INFO1̃X|XGhrbg̃|[Os			*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.12													*/
/********************************************************************************/
void Sddr_PollingResEnd(SDD_HANDLE *p_SddHandle)
{
	UB	ub_ResEndEvent = 0;
	UB	ub_CardOutEvent = 0;
	UB	ub_ErrEvent = 0;
	UW	uw_status1;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	W	w_ret;
		
	while(1){ 
		 Sdd_M_GetReg(SDD_SD_INFO1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_status1);
		 ub_ResEndEvent = (UB)(uw_status1 & SDD_SD_INFO1_RES_END);		/* X|XGhrbg`FbN */
		 ub_CardOutEvent = (UB)(!Sdd_M_CardDetectCheck(uw_status1));	/* J[hro`FbN */
		 ub_ErrEvent = (UB)(Sdd_M_AllErrCheck(SDD_SD_INFO2(Sdd_M_GetPortNum(p_SddHandle->ub_Port))));			/* ׂẴG[rbg`FbN */
		 if ((ub_ResEndEvent != 0) || (ub_CardOutEvent != 0) || (ub_ErrEvent != 0) || (p_sdd->w_error != 0 )) {		/* X|X or SD-IPG[ or ^CAEgŃuCN */
		 	break;  
		 }
	}
	
	if ( (ub_CardOutEvent == 0) && (ub_ErrEvent == 0) && (p_sdd->w_error == 0) ){		/* G[ł͂Ȃꍇ */
        /* WX^ݒ菈Sddr_GetResponseƒu2006/06/19 H.Miura */
        Sddr_GetResponse(p_SddHandle, &(p_sdd->uw_CardStatus));
		Sddr_ClrResEnd(p_SddHandle);		/* Response endrbgNA */
		/* Cxgʒm(X|XGh) */
		w_ret = Sdd_SetEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag),SDD_EVENTFLG_RES_END);
		if (w_ret != SDD_SUCCESS) {				/* G[`FbN 	*/
				/* ߂lFG[Ȃ͂ */
				/* CxgʒmŃG[Ăʒm͂Ȃ */
		}
	}
	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetArg													*/
/*  Tv		FARGݒ(SD_ARG0,SD_ARG1)										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  		FR}hA[Mg										    */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_SetArg(SDD_HANDLE *p_SddHandle, UH uh_Arg0, UH uh_Arg1)
{
	Sdd_M_SetReg(SDD_SD_ARG0(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Arg0);	/* SD_ARG0WX^ݒ(SD_ARG0) */
	Sdd_M_SetReg(SDD_SD_ARG1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Arg1);	/* SD_ARG1WX^ݒ(SD_ARG1) */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetBusWidth												*/
/*  Tv		FSDoXݒ													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW SDoX													*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
void Sddr_SetBusWidth(SDD_HANDLE *p_SddHandle, UW uw_width)
{
	/*
		SD_OPTIONWX^SDoXݒ
		if(SDoX4bit){
			SD_OPTIONWX^SDoX4bitݒ
		}
		else{
			SD_OPTIONWX^SDoX1bitݒ
		}*/
	if (uw_width == SDD_BUS_WIDTH_4BIT) {	/* 4bit̏ꍇ */
		Sdd_M_AndReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_OPTION_WIDTH);
	}
	else {	/* 1bit̏ꍇ */
		Sdd_M_OrReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_OPTION_WIDTH);
	}
	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetAngouMode												*/
/*  Tv		FÕHgp/gpݒ										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FÕHgp/gp											*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
void Sddr_SetAngouMode( SDD_HANDLE *p_SddHandle, UB ub_AngouMode )
{

	if( ub_AngouMode ){	/* ÕHgp */
		Sdd_M_AndReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_OPTION_MSEL);
	}
	else{	/* ÕHgp */
		Sdd_M_OrReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_OPTION_MSEL);
	}

	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetCmd													*/
/*  Tv		FR}hݒ(SDD_CMD)											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_SetCmd(SDD_HANDLE *p_SddHandle, UH uh_Cmd)
{
#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_SETCMD );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

	Sdd_M_SetReg(SDD_SD_CMD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Cmd);	/* SD_CMDWX^ݒ(SDD_CMD) */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetLength												*/
/*  Tv		F]f[^ݒ												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW ]f[^												*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_SetLength(SDD_HANDLE *p_SddHandle, UW uw_NewLength)
{
	UH	uh_Length;

	uh_Length = (UH)(uw_NewLength & SDD_SD_SIZE_LEN);	/* }XN */
	Sdd_M_SetReg(SDD_SD_SIZE(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Length);			/* ]f[^ݒ */
	return;
}


/********************************************************************************/
/*  ֐		FSddr_SetSecCnt												*/
/*  Tv		F]ZN^ݒ												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW ]f[^(SDD_SD_SECCNT_CNT_MAX)						*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_SetSecCnt(SDD_HANDLE *p_SddHandle, UW uw_SecCnt)
{
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	UW	uw_Cnt;
#else  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	UH	uh_Cnt;
#endif  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

	Sdd_M_OrReg(SDD_SD_STOP(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_STOP_SEC);			/* ]ZN^ݒ(SD_SECCNT)L  */

#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	uw_Cnt = uw_SecCnt & SDD_SD_SECCNT_CNT_MASK;

	Sdd_M_SetReg(SDD_SD_SECCNT(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_Cnt);			/* ]ZN^ݒ(SD_SECCNT) */
#else  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	uh_Cnt = (UH)(uw_SecCnt & SDD_SD_SECCNT_CNT_MASK);

	Sdd_M_SetReg(SDD_SD_SECCNT(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Cnt);			/* ]ZN^ݒ(SD_SECCNT) */
#endif  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetStop													*/
/*  Tv		Ff[^]~/p											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB 	]~ݒ肠	SDD_STOP_STP						*/
/*				F		]SݒȂ	SDD_STOP_NONSTP						*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_SetStop(SDD_HANDLE *p_SddHandle, UB ub_Stop)
{
	if(ub_Stop == SDD_STOP_STP) {
		Sdd_M_OrReg(SDD_SD_STOP(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_STOP_STP);		/* f[^]~ݒ(SD_STOP) */
	} else {
		Sdd_M_AndReg(SDD_SD_STOP(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_STOP_STP);		/* f[^]pݒ(SD_STOP) */
	}
	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetWaitCycleCD											*/
/*  Tv		FJ[hoTCN̐ݒ										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FJ[hoTCNݒl(ub_SetCycle)							*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
void Sddr_SetWaitCycleCD(SDD_HANDLE *p_SddHandle, UW uw_SetCycle)
{
	UH uh_GetCycle;
	
	/* SD_OPTION̉4rbg̒lݒ */
	Sdd_M_GetReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_GetCycle);
	uh_GetCycle &= ~((UH)SDD_SD_OPTION_CTOP);	/* CTOP[4:0]ׂăNA */
	uh_GetCycle |= (UH)uw_SetCycle;
	Sdd_M_SetReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_GetCycle);

	return;

}

#if !defined(_SDD_MN6682X_) && !defined(_SDD_4M_ANDROID_) 
/********************************************************************************/
/*  ֐		FSddr_SoftReset												*/
/*  Tv		F\tgZbg												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FZbgΏۂ̃ubN										*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
void Sddr_SoftReset(SDD_HANDLE *p_SddHandle, UW uw_Target)
{
	UH	uh_SoftRst = 0;
	UH	uh_RegVal = 0;

	/*==============================*/
	/* SDW[ZbgΏ۔ */
	/*==============================*/
	if(uw_Target & SDD_SOFT_RESET_SD) {
		uh_SoftRst |= SDD_SOFT_RST_SDRST;
		Sdd_M_GetReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_RegVal);	 /* SD_OPTIONl̑ޔ */
	}
	/*==============================*/
	/* ÕW[ZbgΏ۔ */
	/*==============================*/
	if(uw_Target & SDD_SOFT_RESET_ANGOU) {
		uh_SoftRst |= SDD_SOFT_RST_CRST;
	}
	/*==================================*/
	/* ÕȊOW[ZbgΏ۔ */
	/*==================================*/
	if(uw_Target & SDD_SOFT_RESET_OTHER) {
		uh_SoftRst |= SDD_SOFT_RST_ORST;
	}
	/*================*/
	/* \tgZbg */
	/*================*/
	if(uh_SoftRst != 0) {
		Sdd_M_AndReg(SDD_SOFT_RST(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~uh_SoftRst);		/* Zbg */	/* MISRAOK:3:0290 ݌vӐ}ʂŖȂ */
		Sdd_M_OrReg(SDD_SOFT_RST(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_SoftRst);		/* Zbg */

		if (uh_SoftRst & SDD_SOFT_RST_SDRST) {
			Sdd_M_SetReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_RegVal);		/* SD_OPTIONl̕ */
		}
	}
	return;
}
#endif /* !defined(_SDD_MN6682X_) && !defined(_SDD_4M_ANDROID_)  */

/********************************************************************************/
/*  ֐		FSddr_WaitStable												*/
/*  Tv		FJ[h}́AJ[hւ̓d҂					*/
/*  		FȂ															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2004.1.22														*/
/********************************************************************************/
void Sddr_WaitStable(void)
{
	SDD_ERROR w_ret;

	w_ret = Sdd_Delay(SDD_WAIT_SDCLK_ENA);	
	w_ret &= ~SDD_ERR_OS_TIMEOUT;	/* SDD_ERR_OS_TIMEOUTNA(K͂)  */
	if (w_ret != SDD_SUCCESS) {				/* G[`FbN */
			/* ߂lFG[Ȃ͂ */
			/* G[Ăʒm͂Ȃ */
	}
	return; 
}

/********************************************************************************/
/*  ֐		FSddr_EnaTransEnd					 						    */
/*  Tv		FSD I/FAccess All End荞݋	                            */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_EnaTransEnd( SDD_HANDLE *p_SddHandle )
{
	/*
	SD_INFO1_MaskR/W  Access  End荞݋ɐݒ
	*/
	Sdd_M_AndReg(SDD_SD_INFO1_MASK(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_INFO1_MASK_RW_ACCESSEND);
	return;
}

#if defined(SDD_1BYTE_ACCESS)
/*** SDKiVer2.0ΉJnA2005.12.15 ***/
/********************************************************************************/
/*  ֐		FSddr_GetResponse												*/
/*  Tv		FResponse擾(1byten)										@@*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW *uw_R Responsei[̈										*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_GetResponse(SDD_HANDLE *p_SddHandle, UW *uw_R)
{
	Sdd_M_GetReg(SDD_SD_RSP0(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ((LELONG *)(uw_R))->dt2word.low);		/* R}hX|X R1[39:8] R擾 */
	Sdd_M_GetReg(SDD_SD_RSP1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ((LELONG *)(uw_R))->dt2word.high);		/* R}hX|X R1[39:8] R擾 */
	return;
}
#elif defined(SDD_2BYTE_ACCESS)
/*** SDKiVer2.0ΉJnA2005.12.15 ***/
/********************************************************************************/
/*  ֐		FSddr_GetResponse												*/
/*  Tv		FResponse擾(2byten)							@@@@@@@@*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW *uw_R Responsei[̈										*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sddr_GetResponse(SDD_HANDLE *p_SddHandle, UW *uw_R)
{
	Sdd_M_GetReg((UH)SDD_SD_RSP0(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ((LELONG *)(uw_R))->dt2word.low);	/* R}hX|X R[39:8] R擾 */
	Sdd_M_GetReg((UH)SDD_SD_RSP1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ((LELONG *)(uw_R))->dt2word.high);	/* R}hX|X R[39:8] R擾 */
	return;
}
#endif
