/**********************************************************************************************/
/*  t@C    F$Workfile: SddRegister_dma_for_PeaksAVC.c $                               */
/*  Tv          FSDfoCXhCoDMAWX^ANZXiwjt@C(PeaksAVCp)       */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.                       */
/*  ŏIXV    F$Modtime: 09/07/134      $                                                */
/**********************************************************************************************/
#ifdef _SDD_PEAKS_AVC_
#include <asm/cacheflush.h>  //20090713 sLD ȍ~purge_cache֐ύX̂
/********************************************************************************/
/*  ֐		FSddr_EnaDmaInt												*/
/*  Tv		FFileDMAC荞݋(PeaksAVC)					        */
/*  		FȂ															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.10.24													*/
/********************************************************************************/
void Sddr_EnaDmaInt( void )
{
	Sdd_M_OrReg(SDD_DMC_INTR_EN, SDD_DMC_INTR_EN_CH0_EN);		/* 荞݋ */

	return;
}

/********************************************************************************/
/*  ֐		FSddr_StartDma												    */
/*  Tv		F֎~FileDMAC]N(PeaksAVC)					            */
/*  		FȂ															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.11.1													    */
/********************************************************************************/
void Sddr_StartDma(UW uw_dir)
{
	if (uw_dir == SDD_DMA_READ) {
		Sdd_M_SetReg(SDD_DMC_CH_DMA_EN,
                     SDD_DMC_CH0_DMA_EN_RNGSEL_OFF |
                     SDD_DMC_CH0_DMA_EN_ENDSEL_OFF |
                     SDD_DMC_CH0_DMA_EN_DMAEN_ON);
	}
	else {
		Sdd_M_SetReg(SDD_DMC_CH_DMA_EN,
                     SDD_DMC_CH0_DMA_EN_RNGSEL_OFF |
                     SDD_DMC_CH0_DMA_EN_ENDSEL_OFF |
                     SDD_DMC_CH0_DMA_EN_RXWSEL_WRITE |
                     SDD_DMC_CH0_DMA_EN_DMAEN_ON);
	}
	return;
}
        
/********************************************************************************/
/*  ֐		FSddr_DisDmaInt												*/
/*  Tv		FFileDMA荞݋֎~(PeaksAVC)							*/
/*  		FȂ															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.10.24													*/
/********************************************************************************/
void Sddr_DisDmaInt(void)
{
	Sdd_M_AndReg(SDD_DMC_INTR_EN, ~SDD_DMC_INTR_EN_CH0_EN);/* 荞݋֎~ */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_ClrDmaInt												*/
/*  Tv		FFileDMA荞݃Xe[^XNA(PeaksAVC)				*/
/*  		FΏۊ荞													*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.10.24													*/
/********************************************************************************/
void Sddr_ClrDmaInt(void)
{
	/*========================================*/
	/* FileDMA]荞݃NA	      */
	/*========================================*/
	Sdd_M_SetReg(SDD_DMC_INTR_ST, SDD_DMC_INTR_ST_CH0_ST);
	return;
}


/********************************************************************************/
/*  ֐		FSddr_SetDma													*/
/*  Tv		FFileDMANݒ(PeaksAVCp)							        */
/*  		FUW uw_StartAdd	[in]	]JnAhX					*/
/*				FUW uw_DataByte	[in]	]TCYB(max24bit)				*/
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.23													*/
/********************************************************************************/
SDD_ERROR Sddr_SetDma(UW uw_Addr, UW uw_size, UW uw_dir)
{
	SDD_DEV	*p_sdd = &(SddDev[0]);
	BOOL	bl_Result;
    int ch;

    /* AhX]pCHݒ */
    ch = DDR_PHYADDR_TO_CH(uw_Addr);

    /* Setup DMAC */
    Sddr_ClrDmaInt();

    /* enable CH0_EN */
    Sddr_EnaDmaInt();

    /* set DMA_StartAddress(PHY) and Size */
    if (ch == 0) {
        Sdd_M_SetReg(SDD_DMC_CH_DMA_STAD,(uw_Addr&SDD_DMC_CH0_BUF_STAD_MASK));
    }
    else {
        Sdd_M_SetReg(SDD_DMC_CH_DMA_STAD,((uw_Addr&SDD_DMC_CH0_BUF_STAD_MASK)|SDD_DMC_CH_BUF_DMA_STAD_SDRCH));
    }
    /* set dma total size */
    Sdd_M_SetReg(SDD_DMC_CH_DATASIZ, uw_size);

#ifndef _SDD_PRO2_UAM1_
    /* set Direction, following modes and exec dma */
    /* RNGSEL=1(not-ring), ENDSEL=1(not-endian-excng), DMAEN=1(DMA start) */
    if (uw_dir == SDD_DMA_READ) {
        if(ch == 0){
            purge_cache(((uw_Addr&0xfffffff)|0x80000000),uw_size,1);
        }else{
            purge_cache(((uw_Addr&0xfffffff)|0x90000000),uw_size,1);
        }
    }
    else if (uw_dir == SDD_DMA_WRITE) {
        if(ch == 0){
            purge_cache(((uw_Addr&0xfffffff)|0x80000000),uw_size,0);
        }else{
            purge_cache(((uw_Addr&0xfffffff)|0x90000000),uw_size,0);
        }
    }
#else
	UW way1  ;
	UW idx ;

    /* Purge */
    for ( idx = 0 ; ( idx * 16 ) < uw_size ; idx++ ) {
        way1 = ((uw_Addr + (idx * 16)) & 0x00000FF0) + 0xC8400000;
        /* LSBbit0ׁ̈AInvalidɎ{ */
        *(UW *)way1 = ((uw_Addr + (idx * 16)) & 0xFFFFFFF0 );
    }
    /* AhX16Ŋ؂Ȃꍇ̍ŏÏPurge */
    if (uw_Addr % 16 != 0) {
        way1 = ((uw_Addr + (idx * 16)) & 0x00000FF0) + 0xC8400000;
        /* LSBbit0ׁ̈AInvalidɎ{ */
        *(UW *)way1 = ((uw_Addr + (idx * 16)) & 0xFFFFFFF0 );
    }
#endif /* _SDD_PRO2_UAM1_ */
    /* DMAJn */
    Sddr_StartDma(uw_dir);

    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_StopDma													*/
/*  Tv		FFileDMAC]~(PeaksAVC)									*/
/*  		FȂ															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2007.10.25													*/
/********************************************************************************/
SDD_ERROR Sddr_StopDma(void)
{
	Sdd_M_OrReg(SDD_DMC_CH_DMA_STP, SDD_DMC_CH0_DMA_STP_DMASTP);

    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_DmacReset												*/
/*  Tv		FFileDMACZbg(PeaksAVCp)			                        */
/*  		FȂ															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.10.25 													*/
/********************************************************************************/
void Sddr_DmacReset( void )
{
#ifdef _SDD_RESET_SDMAC_
    /* FileDMA HWoOΉ CH0Zbg */
    Sdd_M_SetReg(SDD_DMC_SUBIF_MD, SDD_DMC_SUBIFMD_CH0RST);
    /* FileDMA HWoOΉ CH0Zbg */
    Sdd_M_SetReg(SDD_DMC_SUBIF_MD, SDD_DMC_SUBIFMD_CH0RSTR);
#endif /* _SDD_RESET_SDMAC_ */
	return;
}
/********************************************************************************/
/*  ֐		FSddr_SetRingBuff												*/
/*  Tv		FOobt@ݒ(FDCchNBufStAd,FDCchNBufEdAd)(PeaksAVC)	*/
/*  		Fuw_Start		Oobt@JnAhX(FDCchNBufStAd)		*/
/*  			Fuw_End		Oobt@IAhX(FDCchNBufEdAd)		*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
void Sddr_SetRingBuff(UW uw_Start, UW uw_End)
{
    int ch;
    /* AhX]pCHݒ */
    ch = DDR_PHYADDR_TO_CH(uw_Start);

    if (ch==0) {
        uw_Start &= SDD_DMC_CH0_BUF_STAD_MASK;
        uw_End &= SDD_DMC_CH0_BUF_EDAD_MASK;
    }
    else {
        uw_Start &= SDD_DMC_CH0_BUF_STAD_MASK|SDD_DMC_CH_BUF_DMA_STAD_SDRCH;
        uw_End &= SDD_DMC_CH0_BUF_EDAD_MASK|SDD_DMC_CH_BUF_DMA_STAD_SDRCH;
    }
	Sdd_M_SetReg(SDD_DMC_CH_BUF_STAD, uw_Start); /* Oobt@JnAhXݒ(FDCchNBufStAd) */
	Sdd_M_SetReg(SDD_DMC_CH_BUF_EDAD, uw_End);   /* Oobt@IAhXݒ(FDCchNBufEdAd) */
	return;
}
#endif /* _SDD_PEAKS_AVC_ */
