/**********************************************************************************************/
/*  t@C    F$Workfile: SddRegister_dma_PeaksPro2 $                                    */
/*  Tv          FSDfoCXhCoDMAWX^ANZXiwjt@C(Peaks-sLD2p)     */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.                       */
/*  ŏIXV    F$Modtime: 06/06/19 13:30 $                                                */
/**********************************************************************************************/
#ifdef _SDD_PEAKS_PRO2_
#include <asm/cacheflush.h> /* purge_cache */
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
#include <linux/dma-mapping.h>	/* virt_to_dma */

const UW SDD_DMA_PHY_BASE[] = {
	0x5A000000
  #if SDD_DEV_COUNT >= 2
	,0x5A010000
  #endif
};
UW SDD_DMA_BASE[SDD_DEV_COUNT];

#define	DDR_CH_AND_OFFSET_TO_KERN_CACHE_PHYADDR(x, y)			\
			DDR_CH_AND_OFFSET_TO_PHYMEMADDR(x, y)

#else  /*defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

const UW SDD_DMA_BASE[] = {
	0xDA000000
  #if SDD_DEV_COUNT >= 2
	,0xDA010000
  #endif
  #if SDD_DEV_COUNT >= 3
	,0xDA020000	 /* ݒ(ɍ킹ĕύXĂ) */
  #endif
};

#endif  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

/********************************************************************************/
/*  ֐		FSddr_EnaDmaInt												*/
/*  Tv		FMIO-DMAC荞݋(Peaks-sLD2p)						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.10.01													*/
/********************************************************************************/
void Sddr_EnaDmaInt( SDD_HANDLE *p_SddHandle )
{
	Sdd_M_OrReg(SDD_DMC_CH_DMA_EN(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_DMC_CH_DMA_STAT_WR);		/* 荞݋ */

	return;
}

/********************************************************************************/
/*  ֐		FSddr_StartDma													*/
/*  Tv		F֎~FileDMAC]N(Peaks-sLD2p)							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  			FRead(SDD_DMA_READ) / Write(SDD_DMA_WRITE)						*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.10.01													*/
/********************************************************************************/
void Sddr_StartDma(SDD_HANDLE *p_SddHandle, UW uw_dir)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uwTmpReg;

	/*======================================*/
	/* ǂݍݐݒ							*/
	if (uw_dir == SDD_DMA_READ) {
		/*==================================*/
		/* ][hݒ					*/
		/*==================================*/
		Sdd_M_GetReg(SDD_DMC_CH_DMA_SRCMD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);
		uwTmpReg &= ~(SDD_DMC_CH_DMA_SRCMD_END | SDD_DMC_CH_DMA_SRCMD_RS | SDD_DMC_CH_DMA_SRCMD_AUP | SDD_DMC_CH_DMA_SRCMD_TYPE);

		if (p_sdd->uw_Endian == SDD_ENDIAN_CHANGE_OFF) {
			/* GfBAϊȂ */
			uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_END_OFF;
		}
		else {
			/* GfBAϊ */
			uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_END_ON;
		}
		/* CHw */
		uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_RS_CH;
		/* AhXŒ */
		uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_AUP_FIX;
		/* ʏ탁gp */
		uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_TYPE_MEM;

		Sdd_M_SetReg(SDD_DMC_CH_DMA_SRCMD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);

		/*==================================*/
		/* ]惂[hݒ					*/
		/*==================================*/
		Sdd_M_GetReg(SDD_DMC_CH_DMA_DSTMD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);
		uwTmpReg &= ~(SDD_DMC_CH_DMA_DSTMD_END | SDD_DMC_CH_DMA_DSTMD_RS | SDD_DMC_CH_DMA_DSTMD_AUP | SDD_DMC_CH_DMA_SRCMD_TYPE);

		/* GfBAϊȂ */
		uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_END_OFF;
		/* CHw */
		uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_RS_CH;
		/* AhXCNg */
		uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_AUP_INC;
#ifdef _SDD_ENABLE_RINGBUF_
		/* Oobt@gp */
		uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_TYPE_RNG;
#else /* _SDD_ENABLE_RINGBUF_ */
		/* ʏ탁gp */
		uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_TYPE_MEM;
#endif /* _SDD_ENABLE_RINGBUF_ */

		Sdd_M_SetReg(SDD_DMC_CH_DMA_DSTMD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);

	}
	/*======================================*/
	/* ݐݒ							*/
	/*======================================*/
	/*======================================*/
	else {
		/*==================================*/
		/* ][hݒ					*/
		/*==================================*/
		Sdd_M_GetReg(SDD_DMC_CH_DMA_SRCMD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);
		uwTmpReg &= ~(SDD_DMC_CH_DMA_SRCMD_END | SDD_DMC_CH_DMA_SRCMD_RS | SDD_DMC_CH_DMA_SRCMD_AUP | SDD_DMC_CH_DMA_SRCMD_TYPE);

		/* GfBAϊȂ */
		uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_END_OFF;
		/* CHw */
		uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_RS_CH;
		/* AhXCNg */
		uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_AUP_INC;
#ifdef _SDD_ENABLE_RINGBUF_
		/* Oobt@gp */
		uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_TYPE_RNG;
#else /* _SDD_ENABLE_RINGBUF_ */
		/* ʏ탁gp */
		uwTmpReg |= SDD_DMC_CH_DMA_SRCMD_TYPE_MEM;
#endif /* _SDD_ENABLE_RINGBUF_ */

		Sdd_M_SetReg(SDD_DMC_CH_DMA_SRCMD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);

		/*==================================*/
		/* ]惂[hݒ					*/
		/*==================================*/
		Sdd_M_GetReg(SDD_DMC_CH_DMA_DSTMD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);
		uwTmpReg &= ~(SDD_DMC_CH_DMA_DSTMD_END | SDD_DMC_CH_DMA_DSTMD_RS | SDD_DMC_CH_DMA_DSTMD_AUP | SDD_DMC_CH_DMA_SRCMD_TYPE);

		if (p_sdd->uw_Endian == SDD_ENDIAN_CHANGE_OFF) {
			/* GfBAϊȂ */
			uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_END_OFF;
		}
		else {
			/* GfBAϊ */
			uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_END_ON;
		}
		/* CHw */
		uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_RS_CH;
		/* ʏ탁gp */
		uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_TYPE_MEM;
		/* AhXŒ */
		uwTmpReg |= SDD_DMC_CH_DMA_DSTMD_AUP_FIX;

		Sdd_M_SetReg(SDD_DMC_CH_DMA_DSTMD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);

	}

	/*======================================*/
	/* MIO-DMAN							*/
	/*======================================*/
	Sdd_M_GetReg(SDD_DMC_CH_DMA_EN(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);
	Sdd_M_GetReg(SDD_DMC_CH_DATASIZ(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwTmpReg);

	Sdd_M_SetReg(SDD_DMC_DMA_START(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),SDD_DMC_DMA_START_REQ);

	return;
}
	    
/********************************************************************************/
/*  ֐		FSddr_DisDmaInt												*/
/*  Tv		FMIO-DMA 荞݋֎~(Peaks-sLD2p)						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.10.01													*/
/********************************************************************************/
void Sddr_DisDmaInt(SDD_HANDLE *p_SddHandle)
{
	Sdd_M_AndReg(SDD_DMC_CH_DMA_EN(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_DMC_CH_DMA_STAT_WR);/* 荞݋֎~ */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_ClrDmaInt												*/
/*  Tv		FMIO-DMA荞݃Xe[^XNA(Peaks-sLD2p)				*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.10.01													*/
/********************************************************************************/
void Sddr_ClrDmaInt(SDD_HANDLE *p_SddHandle)
{
	/*========================================*/
	/* MIO-DMA]荞݃NA		  */
	/*========================================*/
	Sdd_M_SetReg(SDD_DMC_CH_DMA_RQ(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_DMC_CH_DMA_STAT_WR);
	return;
}


/********************************************************************************/
/*  ֐		FSddr_SetDma													*/
/*  Tv		FFileDMANݒ(PeaksPro2p)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  			FUW uw_StartAdd	[in]	]JnAhX					*/
/*  			FUW uw_DataByte	[in]	]TCYB(max24bit)				*/
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2010.10.01													*/
/********************************************************************************/
SDD_ERROR Sddr_SetDma(SDD_HANDLE *p_SddHandle, UW uw_Addr, UW uw_size, UW uw_dir)
{
#ifdef _SDD_DMA_CACHE_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#endif /* _SDD_DMA_CACHE_ */
	UW uwCh;
	UW uwOffset;
	UW uwMemAdr;
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	UW uwTmpPAddr;
	struct device dev;		/* ۂ͎gpȂH */
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	
	if(Sdd_M_CheckReg(SDD_DMC_CH_DMA_STAT(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_DMC_CH_DMA_STAT_STA)) {
		return(SDD_ERR_STATUS);
	}

#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
	/* AhXϊ(ZONE_DMAAhX) */
	uwTmpPAddr = (UW)virt_to_dma( &dev, (void *)uw_Addr );
	if( uwTmpPAddr == 0x00000000 ){
		return(SDD_ERR_STATUS);
	}
	
	/* AhX]pCHAItZbgAAhXݒ */
	uwCh		= DDR_PHYADDR_TO_CH(uwTmpPAddr);
	uwOffset	= DDR_PHYADDR_TO_CHOFFSET(uwTmpPAddr);
	uwMemAdr	= DDR_CH_AND_OFFSET_TO_PHYMEMADDR( uwCh, uwOffset );
#else	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
	/* AhX]pCHAItZbgAAhXݒ */
	uwCh		= DDR_PHYADDR_TO_CH(uw_Addr);
	uwOffset	= DDR_PHYADDR_TO_CHOFFSET(uw_Addr);
	uwMemAdr	= DDR_CH_AND_OFFSET_TO_PHYMEMADDR( uwCh, uwOffset );
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

	/* clear DMA intr */
	Sddr_ClrDmaInt(p_SddHandle);

	/* enable DMA intr */
	Sddr_EnaDmaInt(p_SddHandle);

	/* set DMA Address and Size */
	if (uw_dir == SDD_DMA_READ) {
		Sdd_M_SetReg(SDD_DMC_CH_BUF_WRPT(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwMemAdr);
		Sdd_M_SetReg(SDD_DMC_CH_DMA_SRCAD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),0);
		Sdd_M_SetReg(SDD_DMC_CH_DMA_DSTAD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwMemAdr);
	} else if (uw_dir == SDD_DMA_WRITE) {
		Sdd_M_SetReg(SDD_DMC_CH_BUF_RDPT(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwMemAdr);
		Sdd_M_SetReg(SDD_DMC_CH_DMA_SRCAD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),uwMemAdr);
		Sdd_M_SetReg(SDD_DMC_CH_DMA_DSTAD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),0);
	}

	/* set dma total size */
	Sdd_M_SetReg(SDD_DMC_CH_DATASIZ(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_size);

#ifdef _SDD_DMA_CACHE_
	/* set Direction, following modes and exec dma */
	/* RNGSEL=1(not-ring), ENDSEL=1(not-endian-excng), DMAEN=1(DMA start) */
	if (uw_dir == SDD_DMA_READ) {
		if (p_sdd->RingBuffer.uw_OnOffFlg == SDD_USE_RINGBUFF) {
			purge_cache(uw_Addr,uw_size,1);
			purge_cache(p_sdd->RingBuffer.uw_BuffStart,p_sdd->RingBuffer.uw_BuffEnd - p_sdd->RingBuffer.uw_BuffStart,1);
		} else {
			purge_cache(DDR_CH_AND_OFFSET_TO_KERN_CACHE_PHYADDR(uwCh,uwOffset),uw_size,1);
		}
	} else if (uw_dir == SDD_DMA_WRITE) {
		if (p_sdd->RingBuffer.uw_OnOffFlg == SDD_USE_RINGBUFF) {
			purge_cache(uw_Addr,uw_size,0);
			purge_cache(p_sdd->RingBuffer.uw_BuffStart,p_sdd->RingBuffer.uw_BuffEnd - p_sdd->RingBuffer.uw_BuffStart,0);
		} else {
			purge_cache(DDR_CH_AND_OFFSET_TO_KERN_CACHE_PHYADDR(uwCh,uwOffset),uw_size,0);
		}
	}
#endif /* _SDD_DMA_CACHE_ */

	/* DMAJn */
	Sddr_StartDma(p_SddHandle, uw_dir);

	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_StopDma													*/
/*  Tv		FMIO-DMAC]~(Peaks-sLD2p)								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2010.10.01													*/
/********************************************************************************/
SDD_ERROR Sddr_StopDma(SDD_HANDLE *p_SddHandle)
{
	Sdd_M_SetReg(SDD_DMC_DMA_START(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_DMC_DMA_START_STP | SDD_DMC_DMA_START_REQ);

	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_DmacReset												*/
/*  Tv		FMIO-DMACZbg(Peaks-sLD2p)								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.10.01													*/
/********************************************************************************/
void Sddr_DmacReset( SDD_HANDLE *p_SddHandle )
{
#ifdef _SDD_RESET_SDMAC_
	/* DMA CH ʃZbg */
	Sdd_M_OrReg(SDD_DMC_DMA_RESET(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), (SDD_DMC_DMA_RESET_ON | SDD_DMC_DMA_RESET_CH));
	/* DMA CH ʃZbg */
	Sdd_M_AndReg(SDD_DMC_DMA_RESET(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_DMC_DMA_RESET_CH);
	Sdd_M_AndReg(SDD_DMC_DMA_RESET(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_DMC_DMA_RESET_ON);
#endif /* _SDD_RESET_SDMAC_ */
	return;
}
/********************************************************************************/
/*  ֐		FSddr_SetRingBuff												*/
/*  Tv		FOobt@ݒ(Peaks-sLD2p)								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  			Fuw_Start		Oobt@JnAhX						*/
/*  			Fuw_End		Oobt@IAhX						*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.10.01													*/
/********************************************************************************/
void Sddr_SetRingBuff(SDD_HANDLE *p_SddHandle, UW uw_Start, UW uw_End)
{
	Sdd_M_SetReg(SDD_DMC_CH_BUF_STAD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), DDR_PHYADDR_TO_CHOFFSET(uw_Start)); /* Oobt@JnAhXݒ(CDMIO_RBnBGNADRS) */
	Sdd_M_SetReg(SDD_DMC_CH_BUF_EDAD(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), DDR_PHYADDR_TO_CHOFFSET(uw_End));   /* Oobt@IAhXݒ(CDMIO_RBnENDADR) */
	return;
}
#endif /* _SDD_PEAKS_PRO2_ */
