/**********************************************************************************************/
/*  t@C    F$Workfile: SddRegister_dma_for_sdmaclib.c $                                 */
/*  Tv          FSDfoCXhCoDMAWX^ANZXiwjt@C(SDMAC-LIBp)     */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.                       */
/*  ŏIXV    F$Modtime: 08/07/24 9:45 $                                                */
/**********************************************************************************************/
#ifdef _SDD_USE_SDMACLIB_
/********************************************************************************/
/*  ֐		FSddr_SdmacStart												*/
/*  Tv		FSDMAC̓]ݒA]Jn									*/
/*  		FUW uw_Size	[in]	]TCYB(max24bit)					*/
/*				FUW uw_Dir		[in]	]i0:Read,1:Writej				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.25														*/
/********************************************************************************/
SDD_ERROR Sddr_SdmacStart( UW uw_Size, UW uw_Dir )
{
	W w_ret = SDD_SUCCESS;
	SDD_DEV	*p_sdd = &(SddDev[0]);
	SDMAC_PROP prop_info;
	
	/* ]ݒ */
	prop_info.size = uw_Size;
	if ((p_sdd->uw_Endian) == SDD_ENDIAN_CHANGE_ON) {		/* GfBAϊON̎ */
		prop_info.endian = SDMAC_ENDIAN_ON;
	}else{													/* GfBAϊOFF̎ */
		prop_info.endian = SDMAC_ENDIAN_OFF;
	}
	if (uw_Dir == SDD_DMA_READ) {							/* ReadiSDSDRAMj̎ */
		prop_info.dir = SDMAC_DIR_DEV1TODEV2;
	}else{													/* WriteiSDRAMSDj̎ */
		prop_info.dir = SDMAC_DIR_DEV2TODEV1;
	}
	w_ret = SDMAC_SetProp( p_sdd->SdmacHandle, &prop_info );
	w_ret = Sddr_SdmacErr2SdErr( w_ret );
	if(w_ret != SDD_SUCCESS){
		return w_ret;
	}
	/* ]Jn */
	w_ret = SDMAC_Start( p_sdd->SdmacHandle, SDD_SDMAC_TIMEOUT_MSEC/100 );
	w_ret = Sddr_SdmacErr2SdErr( w_ret );
	
	return w_ret;
}
/********************************************************************************/
/*  ֐		FSddr_SdmacStop												*/
/*  Tv		FSDMAC̓]~												*/
/*  		FȂ															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.25														*/
/********************************************************************************/
SDD_ERROR Sddr_SdmacStop( void )
{
	W w_ret = SDD_SUCCESS;
	SDD_DEV	*p_sdd = &(SddDev[0]);
	
	w_ret = SDMAC_Stop( p_sdd->SdmacHandle );
	if ( w_ret == SDMAC_E_STOP ){
		/* 0Byte]ł邾~߁A莞ԃf[^]Jn҂čČďo */
		Sdd_Delay(SDD_WAIT_SDMAC_STOP_MSEC);
		w_ret = SDMAC_Stop( p_sdd->SdmacHandle );
	}
	w_ret = Sddr_SdmacErr2SdErr( w_ret );
	
	return w_ret;
}
/********************************************************************************/
/*  ֐		FSddr_StopDma													*/
/*  Tv		FXg[DMAC]~(SDMAC_LIB)										*/
/*  		FȂ															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.25														*/
/********************************************************************************/
SDD_ERROR Sddr_StopDma(void)
{
	W w_ret = SDD_SUCCESS;
	
	/*	DMCch4DMAStp̐ݒ	*/
	w_ret = Sddr_SdmacStop();
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSddr_DmacReset												*/
/*  Tv		F0oCg]̃Xg[DMACZbg(SDMAC-LIB)				*/
/*  		FȂ															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2006.4.25	 													*/
/********************************************************************************/
void Sddr_DmacReset( void )
{
#ifdef _SDD_RESET_SDMAC_
	SDMAC_Init();
#endif /* _SDD_RESET_SDMAC_ */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_EnaDmaInt												*/
/*  Tv		FXg[DMAC荞݋(SDMAC-LIB)						*/
/*  		FȂ															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2006.4.25														*/
/********************************************************************************/
void Sddr_EnaDmaInt( void )
{
    /* Ȃ */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_DisDmaInt												*/
/*  Tv		FDMA荞݋֎~(SDMAC-LIB)								*/
/*  		FȂ															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2006.4.24														*/
/********************************************************************************/
void Sddr_DisDmaInt(void)
{
    /* Ȃ */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_CheckDmaTransfer											*/
/*  Tv		F0oCg]̃`FbN(SDMAC-LIB)							*/
/*  		FȂ															*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2006.4.25	 													*/
/********************************************************************************/
void Sddr_CheckDmaTransfer(SDD_ERROR *w_ErrCode )
{
	/* SDMAC-LibgpSDMAC_Stop̖߂l0Byte]\ */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetRingBuff												*/
/*  Tv		FOobt@ݒ(DMCch4BufStAd,DMCch4BufEdAd)(SDMAC-LIB)	*/
/*  		Fuw_Start		Oobt@JnAhX(DMCch4BufStAd)		*/
/*  			Fuw_End		Oobt@IAhX(DMCch4BufEdAd)		*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2006.4.25														*/
/********************************************************************************/
void Sddr_SetRingBuff(UW uw_Start, UW uw_End)
{
	/* SDMAC-LibgpDMA]Jnɐݒ */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_ClrDmaInt												*/
/*  Tv		FDMA荞݃Xe[^XNA(SDMAC-LIB)					*/
/*  		FΏۊ荞													*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2006.4.25														*/
/********************************************************************************/
void Sddr_ClrDmaInt(void)
{
    /* Ȃ */
	return;
}

/********************************************************************************/
/*  ֐		FSddr_CheckIntrType											*/
/*  Tv		FytF荞݂̎ނ̔ʂs(^XNReLXg)(SDMAC-LIB)	*/
/*  		F荞ݗvtOւ̃|C^(*ub_type)					*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2006.4.27														*/
/********************************************************************************/
W Sddr_CheckIntrType(void){	

	W w_intr;
	
	/*==========================================================*/
	/* 荞ݗv̔s									*/
	/*@ 	SDIF̊荞݂łꍇ		F(w_intr)1	*/
	/*@ 	DMAC̊荞݂łꍇ		F(w_intr)2	*/
	/*      LȊO̊荞݂łꍇ@@F(w_intr)4 	*/
	/*==========================================================*/
	w_intr = SDD_INTR_UNKNOWN;	/* 荞ݔ̂тɏ */

	/* SDMAC-Libgp̏ꍇA݂SD݂̂łASD I/F荞݃nhŗv̗L`FbNĂ邽߁Ał͗vWX^`FbNȂ */
	w_intr |= SDD_INTR_SD;
	return w_intr;
}

/********************************************************************************/
/*  ֐		FSddr_SetDma													*/
/*  Tv		FXg[DMAC]ݒ(SDMAC-LIBp)										*/
/*  		FUW uw_StartAdd	[in]	]JnAhX					*/
/*				FUW uw_DataByte	[in]	]TCYB(max24bit)				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.25														*/
/********************************************************************************/
SDD_ERROR Sddr_SetDma(UW uw_Addr, UW uw_size, UW uw_dir)
{
	W w_ret = SDD_SUCCESS;

	SDD_DEV	*p_sdd = &(SddDev[0]);
	UW uw_RegValue;

	p_sdd->DmaInfo.uw_DMASize = uw_size;
	w_ret = Sddr_SdmacStart(uw_size, uw_dir);
	Sddr_EnaDmaInt();	

	return w_ret;
}
#endif /*  _SDD_USE_SDMACLIB_ */

