/****************************************************************************************/
/*  t@C    F$Workfile: SddRegister_for_MarvieAV.c $								*/
/*  Tv          FSDfoCXhCoWX^ANZXiwjt@C(MarvieAVp)	*/
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.					*/
/*  ŏIXV    F$Modtime: 08/07/24 9:45 $											*/
/****************************************************************************************/
#ifdef _SDD_MARVIE_AV_
/********************************************************************************/
/*  ֐		FSddr_EnaClk_enable											*/
/*  Tv		FSD NbN o͏(MarvieAVp)							    */
/*  		FSDD_DEV *p_sdd						                        */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
static SDD_ERROR Sddr_EnaClk_enable(SDD_DEV *p_sdd) {
    Sdd_M_OrReg(SDD_SD_CLK_CTRL, SDD_SD_CLK_CTRL_SCKLEN);		/* SDNbNJnݒ(SD_CLK_CTRL) */
    return SDD_SUCCESS;
}
/********************************************************************************/
/*  ֐		FSddr_EnaClk_disable									        */
/*  Tv		FSD NbN ~(MarvieAVp)						        */
/*  		FSDD_DEV *p_sdd						                        */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
static SDD_ERROR Sddr_EnaClk_disable(SDD_DEV *p_sdd) {
    Sdd_M_AndReg(SDD_SD_CLK_CTRL, ~SDD_SD_CLK_CTRL_SCKLEN);		/* SDNbN~ݒ(SD_CLK_CTRL) */
    return SDD_SUCCESS;
}

/********************************************************************************************/
/*  ֐		FSddr_EnaSDBLKInt												            */
/*  Tv		FSD I/F荞݋֎~ݒ  IOBIntrEn[0`1]̋i1ŋj(MarvieAVp)		*/
/*  		FȂ															            */
/*  ߂l		FSDD_SUCCESS														        */
/*  ŏIXV	F2007.10.29													            */
/********************************************************************************************/
SDD_ERROR Sddr_EnaSDBLKInt( void )
{
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetClkDiv												*/
/*  Tv		FSDNbNݒ(MarvieAVp)							    */
/*  		FSDNbN												*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.10.23													*/
/********************************************************************************/
void Sddr_SetClkDiv(UW uw_Div)
{
	UH uh_GetDiv;
	UH uh_Div = 0;
	SDD_DEV	*p_sdd = &(SddDev[0]);

	p_sdd->uw_ClkDiv = uw_Div;
	
	switch (uw_Div) {
		/*==============================*/
		/* NbNݒl߂ */
		/*==============================*/
		case SDD_CLOCK_DIV_2:
			uh_Div = SDD_SD_CLK_CTRL_DIV2;
			break;
		case SDD_CLOCK_DIV_4:
			uh_Div = SDD_SD_CLK_CTRL_DIV4;
			break;
		case SDD_CLOCK_DIV_8:
			uh_Div = SDD_SD_CLK_CTRL_DIV8;
			break;
		case SDD_CLOCK_DIV_16:
			uh_Div = SDD_SD_CLK_CTRL_DIV16;
			break;
		case SDD_CLOCK_DIV_32:
			uh_Div = SDD_SD_CLK_CTRL_DIV32;
			break;
		case SDD_CLOCK_DIV_64:
			uh_Div = SDD_SD_CLK_CTRL_DIV64;
			break;
		case SDD_CLOCK_DIV_128:
			uh_Div = SDD_SD_CLK_CTRL_DIV128;
			break;
		case SDD_CLOCK_DIV_256:
			uh_Div = SDD_SD_CLK_CTRL_DIV256;
			break;
		case SDD_CLOCK_DIV_512:
			uh_Div = SDD_SD_CLK_CTRL_DIV512;
			break;
		case SDD_CLOCK_DIV_1: 
			uh_Div = SDD_SD_CLK_CTRL_DIV2;	/* ftHg2 */
			break;
		default:
			uh_Div = SDD_SD_CLK_CTRL_DIV2;	/* ftHg2 */
			break;
	}
	/*====================*/
	/* NbNݒ */
	/*====================*/
	Sdd_M_GetReg(SDD_SD_CLK_CTRL, uh_GetDiv);
	uh_GetDiv &= ~((UH)SDD_SD_CLK_CTRL_DIV_ALL);	/* DIV[7:0]ׂăNA */
	uh_GetDiv |= uh_Div;
	Sdd_M_SetReg(SDD_SD_CLK_CTRL, uh_GetDiv);
#ifdef _SDD_HIGHSPEEDCLK_
    /* J[h */
    if (p_sdd->uw_CardFunc == SDD_CARD_FUNC_HIGH_SPEED) {
        /* J[h̏ꍇ[hɐݒ肵čJ[hݒ */
		/* Ή	*/
    }
#endif /* _SDD_HIGHSPEEDCLK_ */

	return;
}

/********************************************************************************************/
/*  ֐		FSddr_SetTimeOutCycle											            */
/*  Tv		F^CAEgTCN̐ݒi250msȏ㑊SDCLKTCNj(MarvieAVp)	*/
/*  		FIMCLK(uw_div)											            */
/*  ߂l		FȂ															            */
/*  ŏIXV	F2007.10.23														        */
/********************************************************************************************/
void Sddr_SetTimeOutCycle(UW uw_Div)
{
	UH 	uh_GetCycle;
	UH	uh_SetCycle;

	switch (uw_Div) {
		/*====================================*/
		/* ^CAEgTCNݒl߂ */
		/*====================================*/
		case SDD_CLOCK_DIV_2:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_23;
			break;
		case SDD_CLOCK_DIV_4:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_22;
			break;
		case SDD_CLOCK_DIV_8:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_21;
			break;
		case SDD_CLOCK_DIV_16:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_20;
			break;
		case SDD_CLOCK_DIV_32:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_19;
			break;
		case SDD_CLOCK_DIV_64:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_18;
			break;
		case SDD_CLOCK_DIV_128:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_17;
			break;
		case SDD_CLOCK_DIV_256:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_16;
			break;
		case SDD_CLOCK_DIV_512:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_15;
			break;
		case SDD_CLOCK_DIV_1: 
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_24;
			break;
		default:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_23;	/* ftHg2̐ݒ */
			break;
	}

	uh_SetCycle += ((SDD_SDIP_TIME_FACTOR << 4) & (UH)SDD_SD_OPTION_TOP);	/* ftHglɃ[UݒlZ */
	if (uh_SetCycle > (UH)SDD_SD_OPTION_TOP_2_27) {
		uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_27;
	}	
	
	/* SD_OPTIOÑrbg[7:4]̒lݒ */
	Sdd_M_GetReg(SDD_SD_OPTION, uh_GetCycle);
	uh_GetCycle &= ~((UH)SDD_SD_OPTION_TOP);	/* TOP[27:24]ׂăNA */
	uh_GetCycle |= (UH)uh_SetCycle;
	Sdd_M_SetReg(SDD_SD_OPTION, uh_GetCycle);

	return;

}

/********************************************************************************/
/*  ֐		FSddr_HardReset												*/
/*  Tv		FSD I/F ubNn[hZbg(MarvieAVp)						*/
/*  		FȂ															*/
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.25													*/
/********************************************************************************/
SDD_ERROR Sddr_HardReset( UW uw_Mode )
{
	/* SDIOubN NbN	*/
	Sdd_M_OrReg( ACKGTD2, (ACKGTD2_SDIO) );

	/* SDIOubN NbN~	*/
	Sdd_M_AndReg( ACKGTD2, (~ACKGTD2_SDIO) );

	/* SDIOubN Zbg	*/
	Sdd_M_OrReg( ARSTCTL2, (ARSTCTL2_GPIO | ARSTCTL2_SDIO) );

	/* SDIOubN NbN(48MHz)	*/
	Sdd_M_OrReg( ACKGTD2, (ACKGTD2_SDIO) );

	/* SDJ[h\Pbgd	*/
	Sdd_M_OrReg( TDSDCNT, (TDSDCNT_SDDLIE | TDSDCNT_SDD3IE | TDSDCNT_SDCMIE | TDSDCNT_SDWPIE) );

	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetDetectCLK												*/
/*  Tv		FSDJ[hoNbNݒ(MarvieAVp)							*/
/*  		FSDD_MODE_NORMAL:IMCLK2o  									*/
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.26													*/
/********************************************************************************/
SDD_ERROR Sddr_SetDetectCLK(UW uw_Mode)
{
    /* Ȃ */
	return SDD_SUCCESS;
}

/********************************************************************************************/
/*  ֐		FSddr_DisSDBLKInt												            */
/*  Tv		FSD I/F荞݋֎~ݒ IOBPeriIntrEn[0`1]̋֎~i0ŋ֎~j(MarvieAVp)	*/
/*  		FȂ															            */
/*  ߂l		FSDD_SUCCESS														        */
/*  ŏIXV	F2007.10.29													            */
/********************************************************************************************/
SDD_ERROR Sddr_DisSDBLKInt( void )
{
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_GetModeRegister											*/
/*  Tv		FSD I/F[h擾(MarvieAVp)									*/
/*  		FUW uw_RetMode													*/
/*  ߂l		FSD I/F[h													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
SDD_ERROR Sddr_GetModeRegister(UW *uw_RetMode)
{
	(*uw_RetMode) =  SDD_MODE_NORMAL;
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetMode_normal											*/
/*  Tv		FSD I/F[hݒNORMAL(MarvieAVp)				        */
/*  		FȂ									                        */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
SDD_ERROR Sddr_SetMode_normal(void) {
    /* Ȃ */
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetMode_standby											*/
/*  Tv		FSD I/F[hݒSTANDBY(MarvieAVp)				        */
/*  		FȂ									                        */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
SDD_ERROR Sddr_SetMode_standby(void) {
    /* Ȃ */
    return SDD_SUCCESS;
}

#endif /* _SDD_MARVIE_AV_ */

