/****************************************************************************************/
/*  t@C    F$Workfile: SddRegister_for_PeaksAVC.c $                            */
/*  Tv          FSDfoCXhCoWX^ANZXiwjt@C(PeaksAVCp)   */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.                 */
/*  ŏIXV    F$Modtime: 08/07/24 9:45 $                                          */
/****************************************************************************************/
#ifdef _SDD_PEAKS_AVC_
/********************************************************************************/
/*  ֐		FSddr_EnaClk_enable											*/
/*  Tv		FSD NbN o͏(PeaksAVCp)							    */
/*  		FSDD_DEV *p_sdd						                        */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
static SDD_ERROR Sddr_EnaClk_enable(SDD_DEV *p_sdd) {
    Sdd_M_OrReg(SDD_SD_CLK_CTRL, SDD_SD_CLK_CTRL_SCKLEN);		/* SDNbNJnݒ(SD_CLK_CTRL) */
    return SDD_SUCCESS;
}
/********************************************************************************/
/*  ֐		FSddr_EnaClk_disable									        */
/*  Tv		FSD NbN ~(PeaksAVCp)						        */
/*  		FSDD_DEV *p_sdd						                        */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
static SDD_ERROR Sddr_EnaClk_disable(SDD_DEV *p_sdd) {
    Sdd_M_AndReg(SDD_SD_CLK_CTRL, ~SDD_SD_CLK_CTRL_SCKLEN);		/* SDNbN~ݒ(SD_CLK_CTRL) */
    return SDD_SUCCESS;
}

/********************************************************************************************/
/*  ֐		FSddr_EnaSDBLKInt												            */
/*  Tv		FSD I/F荞݋֎~ݒ  IOBIntrEn[0`1]̋i1ŋj(PeaksAVCp)		*/
/*  		FȂ															            */
/*  ߂l		FSDD_SUCCESS														        */
/*  ŏIXV	F2007.10.29													            */
/********************************************************************************************/
SDD_ERROR Sddr_EnaSDBLKInt( void )
{
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetClkDiv												*/
/*  Tv		FSDNbNݒ(PeaksAVCp)							    */
/*  		FSDNbN												*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2007.10.23													*/
/********************************************************************************/
void Sddr_SetClkDiv(UW uw_Div)
{
	UH uh_GetDiv;
	UH uh_Div = 0;
	SDD_DEV	*p_sdd = &(SddDev[0]);

	p_sdd->uw_ClkDiv = uw_Div;
	
	switch (uw_Div) {
		/*==============================*/
		/* NbNݒl߂ */
		/*==============================*/
		case SDD_CLOCK_DIV_2:
			uh_Div = SDD_SD_CLK_CTRL_DIV2;
			break;
		case SDD_CLOCK_DIV_4:
			uh_Div = SDD_SD_CLK_CTRL_DIV4;
			break;
		case SDD_CLOCK_DIV_8:
			uh_Div = SDD_SD_CLK_CTRL_DIV8;
			break;
		case SDD_CLOCK_DIV_16:
			uh_Div = SDD_SD_CLK_CTRL_DIV16;
			break;
		case SDD_CLOCK_DIV_32:
			uh_Div = SDD_SD_CLK_CTRL_DIV32;
			break;
		case SDD_CLOCK_DIV_64:
			uh_Div = SDD_SD_CLK_CTRL_DIV64;
			break;
		case SDD_CLOCK_DIV_128:
			uh_Div = SDD_SD_CLK_CTRL_DIV128;
			break;
		case SDD_CLOCK_DIV_256:
			uh_Div = SDD_SD_CLK_CTRL_DIV256;
			break;
		case SDD_CLOCK_DIV_512:
			uh_Div = SDD_SD_CLK_CTRL_DIV512;
			break;
		case SDD_CLOCK_DIV_1: 
			uh_Div = SDD_SD_CLK_CTRL_DIV2;	/* ftHg2 */
			break;
		default:
			uh_Div = SDD_SD_CLK_CTRL_DIV2;	/* ftHg2 */
			break;
	}
	/*====================*/
	/* NbNݒ */
	/*====================*/
	Sdd_M_GetReg(SDD_SD_CLK_CTRL, uh_GetDiv);
	uh_GetDiv &= ~((UH)SDD_SD_CLK_CTRL_DIV_ALL);	/* DIV[7:0]ׂăNA */
	uh_GetDiv |= uh_Div;
	Sdd_M_SetReg(SDD_SD_CLK_CTRL, uh_GetDiv);

#if 1	//20091202 CLASS10 44MHz 1Ή
	if(uw_Div == SDD_CLOCK_DIV_1){
	/* P̏ꍇA[hɐݒ肵Đݒ */
		Sdd_M_OrReg(SDD_MODECTRL, SDD_MODECTL_SDDMASYNC);
		Sdd_M_OrReg(SDD_SD_CLK_CTRL,SDD_SD_CLK_CTRL_SDCLK_SEL);
	}
#endif	//20091202 CLASS10 44MHz 1Ή
#ifdef _SDD_HIGHSPEEDCLK_
    /* J[h */
    if (p_sdd->uw_CardFunc == SDD_CARD_FUNC_HIGH_SPEED) {
        /* J[h̏ꍇ[hɐݒ肵čJ[hݒ */
        Sdd_M_OrReg(SDD_MODECTRL, SDD_MODECTL_SDDMASYNC);
        Sdd_M_OrReg(SDD_SD_CLK_CTRL,SDD_SD_CLK_CTRL_SDCLK_SEL);
    }
#endif /* _SDD_HIGHSPEEDCLK_ */
//Sdd_M_GetReg(SDD_SD_CLK_CTRL, uh_GetDiv); //NAKA
//printk("NAKA SDD_SD_CLK_CTRL=%08x  uw_Div=%d\n",uh_GetDiv,uw_Div); //NAKA
	return;
}

/********************************************************************************************/
/*  ֐		FSddr_SetTimeOutCycle											            */
/*  Tv		F^CAEgTCN̐ݒi250msȏ㑊SDCLKTCNj(PeaksAVCp)	*/
/*  		FIMCLK(uw_div)											            */
/*  ߂l		FȂ															            */
/*  ŏIXV	F2007.10.23														        */
/********************************************************************************************/
void Sddr_SetTimeOutCycle(UW uw_Div)
{
	UH 	uh_GetCycle;
	UH	uh_SetCycle;

	switch (uw_Div) {
		/*====================================*/
		/* ^CAEgTCNݒl߂ */
		/*====================================*/
		case SDD_CLOCK_DIV_2:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_23;
			break;
		case SDD_CLOCK_DIV_4:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_22;
			break;
		case SDD_CLOCK_DIV_8:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_21;
			break;
		case SDD_CLOCK_DIV_16:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_20;
			break;
		case SDD_CLOCK_DIV_32:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_19;
			break;
		case SDD_CLOCK_DIV_64:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_18;
			break;
		case SDD_CLOCK_DIV_128:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_17;
			break;
		case SDD_CLOCK_DIV_256:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_16;
			break;
		case SDD_CLOCK_DIV_512:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_15;
			break;
		case SDD_CLOCK_DIV_1: 
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_24;
			break;
		default:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_23;	/* ftHg2̐ݒ */
			break;
	}

	uh_SetCycle += ((SDD_SDIP_TIME_FACTOR << 4) & (UH)SDD_SD_OPTION_TOP);	/* ftHglɃ[UݒlZ */
	if (uh_SetCycle > (UH)SDD_SD_OPTION_TOP_2_27) {
		uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_27;
	}	
	
	/* SD_OPTIOÑrbg[7:4]̒lݒ */
	Sdd_M_GetReg(SDD_SD_OPTION, uh_GetCycle);
	uh_GetCycle &= ~((UH)SDD_SD_OPTION_TOP);	/* TOP[27:24]ׂăNA */
	uh_GetCycle |= (UH)uh_SetCycle;
	Sdd_M_SetReg(SDD_SD_OPTION, uh_GetCycle);

	return;

}

/********************************************************************************/
/*  ֐		FSddr_HardReset												*/
/*  Tv		FSD I/F ubNn[hZbg(PeaksAVCp)					*/
/*  		FȂ															*/
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.25													*/
/********************************************************************************/
SDD_ERROR Sddr_HardReset( UW uw_Mode )
{
    /* H/W Reset for SD-IF */
    Sdd_M_AndReg(SDD_HARD_RESET, ~0x00000001); /* assert */
    Sdd_Delay(1);
    Sdd_M_OrReg(SDD_HARD_RESET, 0x00000001); /* negate */
    Sdd_Delay(1);

    /* SDIO I/F Block Clock(44.44MHz) */
    Sdd_M_AndReg(SDD_MODECTRL, ~SDD_MODECTL_SDCLKSEL);
    
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetDetectCLK												*/
/*  Tv		FSDJ[hoNbNݒ(PeaksAVCp)							*/
/*  		FSDD_MODE_NORMAL:IMCLK2o  									*/
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.26													*/
/********************************************************************************/
SDD_ERROR Sddr_SetDetectCLK(UW uw_Mode)
{
    /* Ȃ */
	return SDD_SUCCESS;
}

/********************************************************************************************/
/*  ֐		FSddr_DisSDBLKInt												            */
/*  Tv		FSD I/F荞݋֎~ݒ IOBPeriIntrEn[0`1]̋֎~i0ŋ֎~j(PeaksAVCp)	*/
/*  		FȂ															            */
/*  ߂l		FSDD_SUCCESS														        */
/*  ŏIXV	F2007.10.29													            */
/********************************************************************************************/
SDD_ERROR Sddr_DisSDBLKInt( void )
{
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_GetModeRegister											*/
/*  Tv		FSD I/F[h擾(PeaksAVCp)									*/
/*  		FUW uw_RetMode													*/
/*  ߂l		FSD I/F[h													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
SDD_ERROR Sddr_GetModeRegister(UW *uw_RetMode)
{
	(*uw_RetMode) =  SDD_MODE_NORMAL;
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetMode_normal											*/
/*  Tv		FSD I/F[hݒNORMAL(PeaksAVCp)				        */
/*  		FȂ									                        */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
SDD_ERROR Sddr_SetMode_normal(void) {
    /* Ȃ */
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetMode_standby											*/
/*  Tv		FSD I/F[hݒSTANDBY(PeaksAVCp)				        */
/*  		FȂ									                        */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2007.10.29													*/
/********************************************************************************/
SDD_ERROR Sddr_SetMode_standby(void) {
    /* Ȃ */
    return SDD_SUCCESS;
}

#endif /* _SDD_PEAKS_AVC_ */

