/****************************************************************************************/
/*  t@C    F$Workfile: SddRegister_for_PeaksPro2.c $                            */
/*  Tv          FSDfoCXhCoWX^ANZXiwjt@C(PeaksPro2p)   */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.                 */
/*  ŏIXV    F$Modtime: 07/10/23 11:00 $                                          */
/****************************************************************************************/
#ifdef _SDD_PEAKS_PRO2_
#if defined(_SDD_PEAKS_AVC_) && defined(_SDD_SLD8_)

const UW SDD_MODECTL_PHY_BASE[] = {
     0x59810000
  #if SDD_DEV_COUNT >= 2
    ,0x59810200
  #endif
};
UW SDD_MODECTL_BASE[SDD_DEV_COUNT];

const UW SDD_SDIO_PHY_BASE[] = {
    0x5A400000
  #if SDD_DEV_COUNT >= 2
    ,0x5A500000
  #endif
};
UW SDD_SDIO_BASE[SDD_DEV_COUNT];

#elif defined(_SDD_PEAKS_AVC_) && defined(_SDD_SLD3_)  /* @date 2013/01/11 sLD3Ή (PSDCD) */

const UW SDD_MODECTL_PHY_BASE[] = {
     0x59810200
  #if SDD_DEV_COUNT >= 2
    ,0x59810000
  #endif
};
UW SDD_MODECTL_BASE[SDD_DEV_COUNT];

const UW SDD_SDIO_PHY_BASE[] = {
    0x5A500000
  #if SDD_DEV_COUNT >= 2
    ,0x5A400000
  #endif
};
UW SDD_SDIO_BASE[SDD_DEV_COUNT];

#else  /* defined(_SDD_PEAKS_AVC_) && defined(_SDD_SLD8_) */

const UW SDD_MODECTL_BASE[] = {
     0xD9810000
  #if SDD_DEV_COUNT >= 2
    ,0xD9810200
  #endif
  #if SDD_DEV_COUNT >= 3
    ,0xD9810400		/* ݒ(ɍ킹ĕύXĂ) */
  #endif
};
const UW SDD_SDIO_BASE[] = {
    0xDA400000
  #if SDD_DEV_COUNT >= 2
    ,0xDA500000
  #endif
  #if SDD_DEV_COUNT >= 3
    ,0xDA600000		/* ݒ(ɍ킹ĕύXĂ) */
  #endif
};

#endif  /* defined(_SDD_PEAKS_AVC_) && defined(_SDD_SLD8_) */

/********************************************************************************/
/*  ֐		FSddr_EnaClk_enable											*/
/*  Tv		FSD NbN o͏(PeaksPro2p)							    */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sddr_EnaClk_enable(SDD_HANDLE *p_SddHandle) {
    Sdd_M_OrReg(SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_CLK_CTRL_SCKLEN);		/* SDNbNJnݒ(SD_CLK_CTRL) */
    return SDD_SUCCESS;
}
/********************************************************************************/
/*  ֐		FSddr_EnaClk_disable									        */
/*  Tv		FSD NbN ~(PeaksPro2p)						        */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sddr_EnaClk_disable(SDD_HANDLE *p_SddHandle) {
    Sdd_M_AndReg(SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_CLK_CTRL_SCKLEN);		/* SDNbN~ݒ(SD_CLK_CTRL) */
    return SDD_SUCCESS;
}

/********************************************************************************************/
/*  ֐		FSddr_EnaSDBLKInt												            */
/*  Tv		FSD I/F荞݋֎~ݒ  IOBIntrEn[0`1]̋i1ŋj(PeaksPro2p)		*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                          */
/*  ߂l		FSDD_SUCCESS														        */
/*  ŏIXV	F2009.03.06													            */
/********************************************************************************************/
SDD_ERROR Sddr_EnaSDBLKInt( SDD_HANDLE *p_SddHandle )
{
	return SDD_SUCCESS;
}

/*******************************************************************************/
/*  ֐		FSddr_SetUHS1Clk												*/
/*  Tv		FUHS1p̃NbN̐ݒ(PeaksPro3p)							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2009.09.04													*/
/********************************************************************************/
#ifdef _SDD_PEAKS_PRO3_
void Sddr_SetUHS1Clk(SDD_HANDLE *p_SddHandle)
{
	UW uw_GetModeCtrl = 0;

	Sdd_M_GetReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_GetModeCtrl);
	uw_GetModeCtrl &= ~SDD_MODECTL_SDDMASYNC;	/* 񓯊[h */
	uw_GetModeCtrl &= ~SDD_MODECTL_SDCLKSEL1;	/* SDIO I/F Block Clock(50MHz) */
	uw_GetModeCtrl |= SDD_MODECTL_UHS1MODE;		/* UHS-I[h */
	uw_GetModeCtrl |= SDD_MODECTL_SDCLKMODE;	/* SDCLKSEL1g */
	Sdd_M_SetReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_GetModeCtrl);
}
#endif /* _SDD_PEAKS_PRO3_ */

/********************************************************************************/
/*  ֐		FSddr_SetClkDiv												*/
/*  Tv		FSDNbNݒ(PeaksPro2p)							    */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FSDNbN												*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_SetClkDiv(SDD_HANDLE *p_SddHandle, UW uw_Div)
{
	UH uh_GetDiv;
	UH uh_Div = 0;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#if  defined(_SDD_HIGHSPEEDCLK_) && defined(_SDD_PEAKS_PRO3_)
        UW pincrtctrl0, pincrtctrl1;
#endif

	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetClkDiv OperationMode=0x%lx CardFunc=%ld Div=%ld\n",
		   p_sdd->uw_OperationMode, p_sdd->uw_CardFunc, uw_Div);

	p_sdd->uw_ClkDiv = uw_Div;
	
#ifndef _SDD_SPEED_KENSHO_CLK_MIN_
	switch (uw_Div) {
		/*==============================*/
		/* NbNݒl߂ */
		/*==============================*/
		case SDD_CLOCK_DIV_2:
			uh_Div = SDD_SD_CLK_CTRL_DIV2;
			break;
		case SDD_CLOCK_DIV_4:
			uh_Div = SDD_SD_CLK_CTRL_DIV4;
			break;
		case SDD_CLOCK_DIV_8:
			uh_Div = SDD_SD_CLK_CTRL_DIV8;
			break;
		case SDD_CLOCK_DIV_16:
			uh_Div = SDD_SD_CLK_CTRL_DIV16;
			break;
		case SDD_CLOCK_DIV_32:
			uh_Div = SDD_SD_CLK_CTRL_DIV32;
			break;
		case SDD_CLOCK_DIV_64:
			uh_Div = SDD_SD_CLK_CTRL_DIV64;
			break;
		case SDD_CLOCK_DIV_128:
			uh_Div = SDD_SD_CLK_CTRL_DIV128;
			break;
		case SDD_CLOCK_DIV_256:
			uh_Div = SDD_SD_CLK_CTRL_DIV256;
			break;
		case SDD_CLOCK_DIV_512:
			uh_Div = SDD_SD_CLK_CTRL_DIV512;
			break;
		case SDD_CLOCK_DIV_1: 
			uh_Div = SDD_SD_CLK_CTRL_DIV2;	/* ftHg2 */
			break;
		default:
			uh_Div = SDD_SD_CLK_CTRL_DIV2;	/* ftHg2 */
			break;
	}
#else
    /* x(NbNŒᓮeXgj̓NbNŒɐݒ肷 */
    uh_Div = SDD_SD_CLK_CTRL_DIV512;
#endif /* _SDD_SPEED_KENSHO_CLK_MIN_ */

#ifdef _SDD_PEAKS_PRO3_
	/* ʏE[h */
    Sdd_M_AndReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_MODECTL_UHS1MODE);
	/* SDCLKSELg */
    Sdd_M_AndReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_MODECTL_SDCLKMODE);

 	if ((p_sdd->uw_OperationMode == SDD_CARD_INIT_MODE_LV) 
 		//&& (uw_Div == SDD_CLOCK_DIV_1)
 		){
		switch(p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK){
		case SDD_CARD_FUNC_SDR50: 
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetClkDiv SDR50\n");
			/* X[ */
		case SDD_CARD_FUNC_SDR25:
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetClkDiv SDR25\n");
			Sddr_EnaClk_disable(p_SddHandle);	/* SD_CLK̒~ */
			/* J[h(1) */
	    	Sdd_M_OrReg(SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),SDD_SD_CLK_CTRL_SDCLK_SEL);
			Sddr_SetUHS1Clk(p_SddHandle);	/* UHS1p̃NbN̐ݒ */
			Sddr_EnaClk_enable(p_SddHandle);	/* SD_CLK̏o */
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetClkDiv CLK_CTRL=0x%04lx MODECTRL=0x%08lx\n",
							SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)));
			return;
		case SDD_CARD_FUNC_SDR12:
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetClkDiv SDR12\n");
			Sddr_EnaClk_disable(p_SddHandle);	/* SD_CLK̒~ */
			/* ʏJ[h(2`512) */
    		Sdd_M_AndReg(SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),~SDD_SD_CLK_CTRL_SDCLK_SEL);
			Sddr_SetUHS1Clk(p_SddHandle);	/* UHS1p̃NbN̐ݒ */
			uh_Div = SDD_SD_CLK_CTRL_DIV2;
			break;
		default:
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetClkDiv SDR??\n");
			break;
		}
	}
#endif /* _SDD_PEAKS_PRO3_ */

    /*====================*/
	/* NbNݒ */
	/*====================*/
	Sddr_EnaClk_disable(p_SddHandle);	/* SD_CLK̒~ */
	Sdd_M_GetReg(SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_GetDiv);
	uh_GetDiv &= ~((UH)SDD_SD_CLK_CTRL_DIV_ALL);	/* DIV[7:0]ׂăNA */
	uh_GetDiv |= uh_Div;
	Sdd_M_SetReg(SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_GetDiv);
#ifdef _SDD_HIGHSPEEDCLK_
    /* J[h */
    if ((uw_Div == SDD_CLOCK_DIV_1) && ((p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK) == SDD_CARD_FUNC_HIGH_SPEED)) {
        /* Pݒ肩J[h̏ꍇ[hɐݒ肵čJ[hݒ */
        Sddr_SetSdclkSel(p_SddHandle);
#ifdef _SDD_PEAKS_PRO3_
        /* dlύX 12mA )port0̂*/
        Sdd_M_GetReg(SDD_PINCRTCTRL0,pincrtctrl0);
        Sdd_M_GetReg(SDD_PINCRTCTRL1,pincrtctrl1);
        pincrtctrl0 |= 0x80000000;
        pincrtctrl1 |= 0x00000002;
        pincrtctrl1 &= 0xfffffffa;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetClkDiv 12mA %08lx %08lx\n", pincrtctrl0 ,pincrtctrl1);
        Sdd_M_SetReg(SDD_PINCRTCTRL1,pincrtctrl1);
        Sdd_M_SetReg(SDD_PINCRTCTRL0,pincrtctrl0);
#endif /* _SDD_PEAKS_PRO3_ */
    }
    else {
        /* 񓯊[hɐݒ肵ĒʏJ[hݒ */
        Sddr_ResetSdclkSel(p_SddHandle);
#ifdef _SDD_PEAKS_PRO3_
        /* dlύX 8mA )port0̂*/
        Sdd_M_GetReg(SDD_PINCRTCTRL0,pincrtctrl0);
        Sdd_M_GetReg(SDD_PINCRTCTRL1,pincrtctrl1);
        pincrtctrl0 &= 0x7fffffff;
        pincrtctrl1 &= 0xfffffff8;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetClkDiv 8mA %08lx %08lx\n", pincrtctrl0 ,pincrtctrl1);
        Sdd_M_SetReg(SDD_PINCRTCTRL1,pincrtctrl1);
        Sdd_M_SetReg(SDD_PINCRTCTRL0,pincrtctrl0);
#endif /* _SDD_PEAKS_PRO3_ */
    }
#endif /* _SDD_HIGHSPEEDCLK_ */
	Sddr_EnaClk_enable(p_SddHandle);	/* SD_CLK̏o */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetClkDiv CLK_CTRL=0x%04lx MODECTRL=0x%08lx\n",
                    SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)));

	return;
}

/********************************************************************************************/
/*  ֐		FSddr_SetTimeOutCycle											            */
/*  Tv		F^CAEgTCN̐ݒi250msȏ㑊SDCLKTCNj(PeaksPro2p)	*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                          */
/*      		FIMCLK(uw_div)											            */
/*  ߂l		FȂ															            */
/*  ŏIXV	F2009.3.9													                */
/********************************************************************************************/
void Sddr_SetTimeOutCycle(SDD_HANDLE *p_SddHandle, UW uw_Div)
{
	UH 	uh_GetCycle;
	UH	uh_SetCycle;

	switch (uw_Div) {
		/*====================================*/
		/* ^CAEgTCNݒl߂ */
		/*====================================*/
		case SDD_CLOCK_DIV_2:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_23;
			break;
		case SDD_CLOCK_DIV_4:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_22;
			break;
		case SDD_CLOCK_DIV_8:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_21;
			break;
		case SDD_CLOCK_DIV_16:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_20;
			break;
		case SDD_CLOCK_DIV_32:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_19;
			break;
		case SDD_CLOCK_DIV_64:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_18;
			break;
		case SDD_CLOCK_DIV_128:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_17;
			break;
		case SDD_CLOCK_DIV_256:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_16;
			break;
		case SDD_CLOCK_DIV_512:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_15;
			break;
		case SDD_CLOCK_DIV_1: 
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_24;
			break;
		default:
			uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_23;	/* ftHg2̐ݒ */
			break;
	}

	uh_SetCycle += ((SDD_SDIP_TIME_FACTOR << 4) & (UH)SDD_SD_OPTION_TOP);	/* ftHglɃ[UݒlZ */
	if (uh_SetCycle > (UH)SDD_SD_OPTION_TOP_2_27) {	/* MISRAOK:3:3356,3:3359,3:3201 `l̕ύXl̂ߖȂ */
		uh_SetCycle = (UH)SDD_SD_OPTION_TOP_2_27;
	}	
	
	/* SD_OPTIOÑrbg[7:4]̒lݒ */
	Sdd_M_GetReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_GetCycle);
	uh_GetCycle &= ~((UH)SDD_SD_OPTION_TOP);	/* TOP[27:24]ׂăNA */
	uh_GetCycle |= (UH)uh_SetCycle;
	Sdd_M_SetReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_GetCycle);

	return;

}

/********************************************************************************/
/*  ֐		FSddr_HardReset												*/
/*  Tv		FSD I/F ubNn[hZbg(PeaksPro2p)					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
SDD_ERROR Sddr_HardReset( SDD_HANDLE *p_SddHandle, UW uw_Mode )
{
    /* H/W Reset for SD-IF */
    Sdd_M_AndReg(SDD_HARD_RESET(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~0x00000001); /* assert */
    Sdd_Delay(1);
    Sdd_M_OrReg(SDD_HARD_RESET(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), 0x00000001); /* negate */
    Sdd_Delay(1);

    /* SDIO I/F Block Clock(44.44MHz) */
    Sdd_M_AndReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_MODECTL_SDCLKSEL);
    
#if 1 /* BugFix:Not Support Sync Mode */
    Sdd_M_AndReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~(SDD_MODECTL_SDDMASYNC));
#endif
    
#ifdef _SDD_PEAKS_PRO3_
	/* ʏE[h */
    Sdd_M_AndReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_MODECTL_UHS1MODE);

	/* SDCLKSELg */
    Sdd_M_AndReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_MODECTL_SDCLKMODE);
#endif
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetDetectCLK												*/
/*  Tv		FSDJ[hoNbNݒ(PeaksPro2p)							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FSDD_MODE_NORMAL:IMCLK2o  									*/
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
SDD_ERROR Sddr_SetDetectCLK(SDD_HANDLE *p_SddHandle, UW uw_Mode)
{
    /* Ȃ */
	return SDD_SUCCESS;
}

/********************************************************************************************/
/*  ֐		FSddr_DisSDBLKInt												            */
/*  Tv		FSD I/F荞݋֎~ݒ IOBPeriIntrEn[0`1]̋֎~i0ŋ֎~j(PeaksPro2p)	*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                          */
/*  ߂l		FSDD_SUCCESS														        */
/*  ŏIXV	F2009.3.6														            */
/********************************************************************************************/
SDD_ERROR Sddr_DisSDBLKInt(SDD_HANDLE *p_SddHandle)
{
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_GetModeRegister											*/
/*  Tv		FSD I/F[h擾(PeaksPro2p)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_RetMode													*/
/*  ߂l		FSD I/F[h													*/
/*  ŏIXV	F2009.3.6														*/
/********************************************************************************/
SDD_ERROR Sddr_GetModeRegister(SDD_HANDLE *p_SddHandle, UW *uw_RetMode)
{
	(*uw_RetMode) =  SDD_MODE_NORMAL;
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetMode_normal											*/
/*  Tv		FSD I/F[hݒNORMAL(PeaksPro2p)				        */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
SDD_ERROR Sddr_SetMode_normal(SDD_HANDLE *p_SddHandle) {
    /* Ȃ */
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetMode_standby											*/
/*  Tv		FSD I/F[hݒSTANDBY(PeaksPro2p)				        */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FSDD_SUCCESS													*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
SDD_ERROR Sddr_SetMode_standby(SDD_HANDLE *p_SddHandle) {
    /* Ȃ */
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_SetSdclkSel												*/
/*  Tv		FSDNbN[h(50MHz)ݒ(PeaksPro2p)				    */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_SetSdclkSel(SDD_HANDLE *p_SddHandle) {
#if 0 /* BugFix:Not Support Sync Mode */
    Sdd_M_OrReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_MODECTL_SDDMASYNC);
#endif
    Sdd_M_OrReg(SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),SDD_SD_CLK_CTRL_SDCLK_SEL);
}

/********************************************************************************/
/*  ֐		FSddr_ResetSdclkSel											*/
/*  Tv		FSDNbN񓯊[h(50MHz)ݒ(PeaksPro2p)			    */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
void Sddr_ResetSdclkSel(SDD_HANDLE *p_SddHandle) {
#if 0 /* BugFix:Not Support Sync Mode */
    Sdd_M_AndReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~(SDD_MODECTL_SDDMASYNC));
#endif
    Sdd_M_AndReg(SDD_SD_CLK_CTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)),~(SDD_SD_CLK_CTRL_SDCLK_SEL));
}

#ifdef _SDD_ALLOW_UHS1_
/********************************************************************************/
/*  ֐		FSddr_GetVol													*/
/*  Tv		Fdl擾									@@@@@@@@*/
/*  		FUB *ub_Voltage dli[̈									*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.08.24													*/
/********************************************************************************/
void Sddr_GetVol(SDD_HANDLE *p_SddHandle, UB *ub_Voltage)
{
#ifdef _SDD_PEAKS_PRO3_
/* ɓd擾Lڂ */
	UW uw_pwr;

	Sdd_M_GetReg(SDD_SD_PWR(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_pwr);
	if((uw_pwr & SDD_SD_PWR_VOL_MASK) == SDD_SD_PWR_VOL_18){
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_GetVol 1.8V SDD_SD_PWR=%ld\n",uw_pwr);
		*ub_Voltage = SDD_VOL_18;
	}else{
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_GetVol 3.3V SDD_SD_PWR=%ld\n",uw_pwr);
		*ub_Voltage = SDD_VOL_33;
	}
#endif
	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetVol													*/
/*  Tv		Fdlݒ									@@@@@@@@*/
/*  		FUB *ub_Voltage dli[̈									*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.08.24													*/
/********************************************************************************/
void Sddr_SetVol(SDD_HANDLE *p_SddHandle, UB ub_Voltage)
{
#ifdef _SDD_PEAKS_PRO3_
/* ɓdؑ֏Lڂ */
	if(ub_Voltage == SDD_VOL_18){
		Sdd_M_OrReg(SDD_SD_PWR(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_PWR_VOL_18);		/* 1.8Vo */
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetVol 1.8V SDD_SD_PWR=%ld\n", 
						SDD_SD_PWR(Sdd_M_GetPortNum(p_SddHandle->ub_Port)));
	}else{
		Sdd_M_AndReg(SDD_SD_PWR(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_SD_PWR_VOL_18);	/* 3.3Vo */
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sddr_SetVol 3.3V SDD_SD_PWR=%ld\n", 
						SDD_SD_PWR(Sdd_M_GetPortNum(p_SddHandle->ub_Port)));
	}
#endif
	return;
}

/********************************************************************************/
/*  ֐		FSddr_EnaSDIN													*/
/*  Tv		FSD I/F̓͊ђʓdh~								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  		    F̓Cl[uFSDD_SDIN_ENABLE								*/
/*				F͒~FSDD_SDIN_DISABLE									*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.03.11													*/
/********************************************************************************/
void Sddr_EnaSDIN(SDD_HANDLE *p_SddHandle, UW uw_sdin)
{
	if (uw_sdin == SDD_SDIN_ENABLE) {
        /* Ȃ */
	}
	else {
        /* Ȃ */
	}

    return;
}
#endif	/* _SDD_ALLOW_UHS1_ */

#if defined(_SDD_DAT3_PULLUP_DISABLE_) || defined(_SDD_DAT3_PULLUP_PART_DISABLE_)
/********************************************************************************/
/*  ֐		FSdds_SetPullupSDDAT3											*/
/*  Tv		FSDDAT3[q̃vAbvRON/OFFݒ							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FBOOL bl_Set ( TRUE:vAbvON, FALSE:vAbvOFF			*/
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2010.02.17													*/
/********************************************************************************/
void Sdds_SetPullupSDDAT3(SDD_HANDLE *p_SddHandle, BOOL bl_Set)
{
    /* Ȃ */
	return;
}
#endif /* defined(_SDD_DAT3_PULLUP_DISABLE_) || defined(_SDD_DAT3_PULLUP_PART_DISABLE_) */

/********************************************************************************/
/*  ֐		FSddr_SetRegBank												*/
/*  Tv		FREG_BANKݒ												    */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2010.3.9													    */
/********************************************************************************/
void Sddr_SetRegBank(SDD_HANDLE *p_SddHandle) {
    /* Ȃ */
}

#endif /* _SDD_PEAKS_PRO2_ */
