/****************************************************************************************/
/*  t@C    F$Workfile: SddRegister_for_sdmaclib.c $                             */
/*  Tv          FSDfoCXhCoWX^ANZXiwjt@C(SDMAC-LIBp)   */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.                 */
/*  ŏIXV    F$Modtime: 08/07/24 9:45 $                                          */
/****************************************************************************************/
#ifdef _SDD_USE_SDMACLIB_

static SDD_ERROR Sddr_EnaClk_enable(SDD_DEV *p_sdd);
static SDD_ERROR Sddr_EnaClk_disable(SDD_DEV *p_sdd);
/********************************************************************************/
/*  ֐		FSddr_SdmacSetSdDevice											*/
/*  Tv		FSDfoCXݒi݁ANbNj							*/
/*  		FΏہA												*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.24														*/
/********************************************************************************/
SDD_ERROR Sddr_SdmacSetSdDevice( SDMAC_SDTGT tgt, SDMAC_CTL ctl )
{
	W w_ret = SDD_SUCCESS;
	SDMAC_SD_INFO sd_info;
	
	sd_info.tgt = tgt;
	sd_info.ctl = ctl;
	w_ret = sdmac_SetDevice( SDMAC_DID_SD, &sd_info );
	w_ret = Sddr_SdmacErr2SdErr( w_ret );
	
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSddr_SdmacGetSdDevice											*/
/*  Tv		FSDfoCXԎ擾i݁ANbNj						*/
/*  		FΏ														*/
/*  ߂l		F														*/
/*  			FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.24														*/
/********************************************************************************/
SDD_ERROR Sddr_SdmacGetSdDevice( SDMAC_SDTGT tgt, UW *uw_status )
{
	W w_ret = SDD_SUCCESS;
	SDMAC_SD_STATE sd_info;
	
	sd_info.tgt = tgt;
	w_ret = sdmac_GetDevice( SDMAC_DID_SD, &sd_info );
	w_ret = Sddr_SdmacErr2SdErr( w_ret );
	if(w_ret == SDD_SUCCESS){
		*uw_status = sd_info.state;
	}
	
	return w_ret;
}
/********************************************************************************/
/*  ֐		FSddr_SdmacCtlSdIod											*/
/*  Tv		FSDIOhCuݒ												*/
/*  		FCapacity														*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.5.11														*/
/********************************************************************************/
SDD_ERROR Sddr_SdmacCtlSdIod( IOD_SETCAPA capa )
{
	W w_ret = SDD_SUCCESS;
	
	w_ret = IOD_Ctl( IOD_SD, capa );
	if(w_ret != IOD_E_OK){
		return SDD_ERR_SDMA_ERR;
	}
	return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_DisSDBLKInt												*/
/*  Tv		FSD I/F荞݋֎~ݒ IOBPeriIntrEn[0`1]̋֎~i0ŋ֎~j(SDMAC-LIBp)		*/
/*  		FȂ															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.24														*/
/********************************************************************************/
SDD_ERROR Sddr_DisSDBLKInt( void )
{
	W w_ret = SDD_SUCCESS;
	/*==============================*/
	/* IOBPeriIntrEn[0`1]"0"ݒ */
	/*==============================*/	
	w_ret = Sddr_SdmacSetSdDevice( SDMAC_SD_IRQ, SDMAC_CTLOFF );
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSddr_EnaSDBLKInt												*/
/*  Tv		FSD I/F荞݋֎~ݒ  IOBIntrEn[0`1]̋i1ŋj(SDMAC-LIBp)		*/
/*  		FȂ															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.24														*/
/********************************************************************************/
SDD_ERROR Sddr_EnaSDBLKInt( void )
{
	W w_ret = SDD_SUCCESS;
	
	/*==============================*/
	/* IOBPeriIntrEn[0`1]"1"ݒ */
	/*==============================*/
	w_ret = Sddr_SdmacSetSdDevice( SDMAC_SD_IRQ, SDMAC_CTLON );
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSddr_SetDetectCLK												*/
/*  Tv		FSDJ[hoNbNݒ(SDMAC-LIBp)										*/
/*  		FSDD_MODE_NORMAL:IMCLK2o  									*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.24														*/
/********************************************************************************/
SDD_ERROR Sddr_SetDetectCLK(UW uw_Mode)
{
	W w_ret = SDD_SUCCESS;

	/*====================*/
	/* IOBPeriClkStopݒ */
	/*====================*/
	/* CLKSTP[8]ݒFON(0)ݒiS̃NbN͖{̓VXeŜŐݒ肵Ă͂j*/
	/* CLKSTP[7][6]ݒFݒ莞ɐݒ */

	if(uw_Mode == SDD_MODE_NORMAL) {
		w_ret = Sddr_SdmacSetSdDevice( SDMAC_SD_IMCLK2, SDMAC_CTLON );
	} else{
		w_ret = Sddr_SdmacSetSdDevice( SDMAC_SD_IMCLK2, SDMAC_CTLOFF );
	}

	return w_ret;
}

/********************************************************************************/
/*  ֐		FSddr_HardReset												*/
/*  Tv		FSD I/F ubNn[hZbg(SDMAC-LIBp)									*/
/*  		FSDD_MODE_NORMALFZbgASDD_MODE_STANDBYFZbg		*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.06.23													*/
/********************************************************************************/
SDD_ERROR Sddr_HardReset(UW uw_Mode)
{
	W w_ret = SDD_SUCCESS;
	
	/*IOBPeriReset[0]̐ݒ(1ŃZbg)
		
		IOBPeriReset[0]̐ݒ(0ŃZbg)
	*/
	/* Zbgɂ͑SӃfoCXZbg	*/
	/*    (IOBPeriReset[8]0Zbg)					*/
	if(uw_Mode == SDD_MODE_NORMAL) {
		w_ret = Sddr_SdmacSetSdDevice( SDMAC_SD_CLK, SDMAC_CTLON );
	} else{
		w_ret = Sddr_SdmacSetSdDevice( SDMAC_SD_CLK, SDMAC_CTLOFF );
	}
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSddr_SetMode_normal											*/
/*  Tv		FSD I/F[hݒNORMAL(SDMAC-LIBp)					    */
/*  		FȂ									                        */
/*  ߂l		FSDD_ERROR														*/
/*  ŏIXV	F2006.07.03													*/
/********************************************************************************/
SDD_ERROR Sddr_SetMode_normal(void) {
    return Sddr_SdmacSetSdDevice( SDMAC_SD_IMCLK, SDMAC_CTLON );
}

/********************************************************************************/
/*  ֐		FSddr_SetMode_standby											*/
/*  Tv		FSD I/F[hݒSTANDBY(SDMAC-LIBp)				        */
/*  		FȂ									                        */
/*  ߂l		FSDD_ERROR															*/
/*  ŏIXV	F2006.07.03													*/
/********************************************************************************/
SDD_ERROR Sddr_SetMode_standby(void) {
    return Sddr_SdmacSetSdDevice( SDMAC_SD_IMCLK, SDMAC_CTLOFF );
}

/********************************************************************************/
/*  ֐		FSddr_GetModeRegister											*/
/*  Tv		FSD I/F[h擾(SDMAC_LIBp)									*/
/*  		FUW uw_RetMode													*/
/*  ߂l		FSD I/F[h													*/
/*  			FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2006.4.24														*/
/********************************************************************************/
SDD_ERROR Sddr_GetModeRegister(UW *uw_RetMode)
{
	W w_ret = SDD_SUCCESS;
	UW uw_status;

	/*============================*/
	/* IOBPeriClkStopݒԎ擾 */
	/*============================*/
	w_ret = Sddr_SdmacGetSdDevice( SDMAC_SD_CLK, &uw_status );
	if(w_ret == SDD_SUCCESS){
		if(uw_status & SDD_CLKSTP_IMCLK) {
			(*uw_RetMode) =  SDD_MODE_STANDBY;
		}
		else {
			(*uw_RetMode) =  SDD_MODE_NORMAL;
		}
	}
	return w_ret;
}

/********************************************************************************/
/*  ֐		FSddr_EnaClk_enable											*/
/*  Tv		FSD NbN o͏(SDMAC_LIBp)							    */
/*  		FSDD_DEV *p_sdd						                        */
/*  ߂l		FSDD_SUCCESS															*/
/*  ŏIXV	F2007.04.26													*/
/********************************************************************************/
static SDD_ERROR Sddr_EnaClk_enable(SDD_DEV *p_sdd) {
	W w_ret = SDD_SUCCESS;
	W w_TmpRet;
#if defined(_SDD_UNIPHIER_XP_)
	UH uh_CtrlSdclk = 0x0000;	/* UniPhierXPΉFIMCLKNbN or ONbN̐ݒrbgǉ 07.04.26 H.Suzuki */
#endif /* _SDD_UNIPHIER_XP_ */

    if(p_sdd->uw_ClkDiv == SDD_CLOCK_DIV_1) {
        /* SDCLK IEXSDCLK gpꍇAIO Z̓deʂ4 mA 8 mA ɏグ */
        w_ret = Sddr_SdmacCtlSdIod( IOD_HI );
        if(w_ret != SDD_SUCCESS){
            return w_ret;
        }
        w_ret = Sddr_SdmacSetSdDevice( SDMAC_SD_IEXSDCLK, SDMAC_CTLON );
        if(w_ret != SDD_SUCCESS){
#if !defined(_SDD_CHANGE_IODRIVE_CLK_8_)
            w_TmpRet = Sddr_SdmacCtlSdIod( IOD_LOW );
            w_ret = Sdds_SetErr(w_ret, w_TmpRet);
#endif /* _SDD_CHANGE_IODRIVE_CLK_8_ */
            return w_ret;
        }
#if defined(_SDD_UNIPHIER_XP_)
        uh_CtrlSdclk |= SDD_SD_CLK_CTRL_SDCLK_SEL;
#endif /* _SDD_UNIPHIER_XP_ */
    }else{
#if defined(_SDD_CHANGE_IODRIVE_CLK_8_)
        /* SDCLK IEXSDCLK gpȂꍇłAIO Z̓deʂ8 mA ɐݒ */
        w_ret = Sddr_SdmacCtlSdIod( IOD_HI );
#else
        /* SDCLK IEXSDCLK gpȂꍇAIO Z̓deʂ4 mA ɐݒiX4 mÂ͂Ô߁j */
        w_ret = Sddr_SdmacCtlSdIod( IOD_LOW );
#endif /* _SDD_CHANGE_IODRIVE_CLK_8_ */
        if(w_ret != SDD_SUCCESS){
            return w_ret;
        }
    }
#ifdef	_SDD_TSR1_DAT3_
    if((p_sdd->uw_ClkDiv == SDD_CLOCK_DIV_2) && (p_sdd->uw_CardFunc == SDD_CARD_FUNC_HIGH_SPEED)) {
        w_ret = Sddr_SdmacCtlSdIod( IOD_HI );
        if(w_ret != SDD_SUCCESS){
            return w_ret;
        }
    }
#endif /* _SDD_TSR1_DAT3_ */

#if defined(_SDD_UNIPHIER_XP_)
    Sdd_M_OrReg(SDD_SD_CLK_CTRL, (uh_CtrlSdclk | SDD_SD_CLK_CTRL_SCKLEN) );		/* SDNbNJnݒ(SD_CLK_CTRL) */
#else
    Sdd_M_OrReg(SDD_SD_CLK_CTRL, SDD_SD_CLK_CTRL_SCKLEN);		/* SDNbNJnݒ(SD_CLK_CTRL) */
#endif /* _SDD_UNIPHIER_XP_ */
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSddr_EnaClk_disable									        */
/*  Tv		FSD NbN ~(SDMAC_LIBp)						        */
/*  		FSDD_DEV *p_sdd						                        */
/*  ߂l		FSDD_SUCCESS															*/
/*  ŏIXV	F2007.02.02													*/
/********************************************************************************/
static SDD_ERROR Sddr_EnaClk_disable(SDD_DEV *p_sdd) {
	W w_ret = SDD_SUCCESS;
	W w_TmpRet;

    Sdd_M_AndReg(SDD_SD_CLK_CTRL, ~SDD_SD_CLK_CTRL_SCKLEN);		/* SDNbN~ݒ(SD_CLK_CTRL) */
    if(p_sdd->uw_ClkDiv == SDD_CLOCK_DIV_1) {
        /* IEXSDCLK ~ɁAIO Z̓deʂɂǂi8 mA 4 mA ɉj */
        w_ret = Sddr_SdmacSetSdDevice( SDMAC_SD_IEXSDCLK, SDMAC_CTLOFF );
        if(w_ret != SDD_SUCCESS){
            return w_ret;
        }
#if !defined(_SDD_CHANGE_IODRIVE_CLK_8_)
        w_ret = Sddr_SdmacCtlSdIod( IOD_LOW );
#endif /* _SDD_CHANGE_IODRIVE_CLK_8_ */
    }
#ifdef	_SDD_TSR1_DAT3_
    if((p_sdd->uw_ClkDiv == SDD_CLOCK_DIV_2) && (p_sdd->uw_CardFunc == SDD_CARD_FUNC_HIGH_SPEED)) {
#if !defined(_SDD_CHANGE_IODRIVE_CLK_8_)
        w_ret = Sddr_SdmacCtlSdIod( IOD_LOW ); /* IOhCu\͂̓deʂŒɂRpCIvV̎w肪Ȃꍇ̂ݎ{ */
#endif /* _SDD_CHANGE_IODRIVE_CLK_8_ */
    }
#endif /* _SDD_TSR1_DAT3_ */
    return w_ret;
}


#endif /*  _SDD_USE_SDMACLIB_ */

