/********************************************************************************/
/*  t@C    F$Workfile: SddRegister.h $                                  */
/*  Tv          FSDfoCXhCoWX^ANZXwb_t@C            */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 07/04/26  9:50 $                                  */
/********************************************************************************/

#ifndef _SDD_REGISTER_H_
#define _SDD_REGISTER_H_

#if defined(_SDD_UNIPHIER_2P_)
#include "device/SddRegister_for_uniphier2p.h"
#endif /* _SDD_UNIPHIER_2P_ */

#if defined(_SDD_UNIPHIER_XP_)
#include "device/SddRegister_for_uniphierxp.h"
#endif /* _SDD_UNIPHIER_XP_ */

#if defined(_SDD_JUPITER_)
#include "device/SddRegister_for_jupiter.h"
#endif /* _SDD_JUPITER_ */

#if defined(_SDD_MN66822_)
#include "device/SddRegister_for_mn66822.h"
#endif /* _SDD_MN66822_ */

#if defined(_SDD_MN66826_)
#include "device/SddRegister_for_mn66826.h"
#endif /* _SDD_MN66826_ */

#if defined(_SDD_PEAKS_PRO2_)
#include "device/SddRegister_for_peakspro2.h"
#endif /* _SDD_PEAKS_PRO2_ */

#if defined(_SDD_PCAM_)
#include "device/SddRegister_for_pcam.h"
#endif /* _SDD_PCAM_ */

#if defined(_SDD_4M_ANDROID_)
#include "device/SddRegister_for_4mAndroid.h"
#endif /* _SDD_4M_ANDROID_ */

#if defined(_SDD_MN66830_)
#include "device/SddRegister_for_mn66830.h"
#endif /* _SDD_MN66830_ */

typedef	union{
	UW	uw_dat;
	struct	{
		UH	low;
		UH	high;
	} dt2word;
} LELONG;
typedef	union{
	UH	uh_dat;
	struct	{
		UB	low;
		UB	high;
	} dt2byte;
} LESHORT;

#if defined(SDD_2BYTE_ACCESS) /* 2bytenANZX̏ꍇ */
/* ]ZN^JEgWX^ */
#define SDD_SD_SECCNT_CNT_MASK	((SDD_VULH)0x0000ffff)	/* ]ZN^}XN */
/* SDJ[hX|XWX^ */
#define SDD_SD_RSP_MASK	((SDD_VULH)0x0000ffff)	/* X|X}XN */

#define	Sdd_M_SetReg(x, y)	((x) = (UW)(y))	/* WX^݂32rbgANZX  04/2/2 shiiba */
#define Sdd_M_GetReg(x, y)	((y) = (x))
#define	Sdd_M_AndReg(x, y)	((x) &= (UW)(y))	/* WX^݂32rbgANZX  04/2/2 shiiba */
#define Sdd_M_OrReg(x, y)	((x) |= (UW)(y))	/* WX^݂32rbgANZX  04/2/2 shiiba */
#define Sdd_M_CheckReg(x, y)	((((x) & (y)) == 0) ? 0 : 1)
#define Sdd_M_CardOutCheck(x)	((((x) & SDD_SD_INFO1_CARDOUT) == 0) ? 0 : 1)
#define Sdd_M_CardInCheck(x)	((((x) & SDD_SD_INFO1_CARDIN) == 0) ? 0 : 1)
#define Sdd_M_CardDetectCheck(x)	((((x) & SDD_SD_INFO1_CARDCHECK) == 0) ? 0 : 1)
#define Sdd_M_ResponseCheck(x)	((((x) & SDD_SD_INFO1_RES_END) == 0) ? 0 : 1)
#define Sdd_M_DataEndCheck(x)	((((x) & SDD_SD_INFO1_RW_ACCESSEND) == 0) ? 0 : 1)
#define Sdd_M_CmdErrCheck(x)	((((x) & SDD_SD_INFO2_CMD_ERR) == 0) ? 0 : 1)
#define Sdd_M_CrcErrCheck(x)	((((x) & SDD_SD_INFO2_CRC_ERR) == 0) ? 0 : 1)
#define Sdd_M_EndErrCheck(x)	((((x) & SDD_SD_INFO2_STOP_ERR) == 0) ? 0 : 1)
#define Sdd_M_ResTMoutErrCheck(x)	((((x) & SDD_SD_INFO2_RES_TIMEOUT_ERR) == 0) ? 0 : 1)
#define Sdd_M_TMoutErrCheck(x)	((((x) & SDD_SD_INFO2_TIMEOUT_ERR) == 0) ? 0 : 1)
#define Sdd_M_ILErrCheck(x)	((((x) & SDD_SD_INFO2_ILA_ERR) == 0) ? 0 : 1)
#define Sdd_M_CBSYCheck(x)	((((x) & SDD_SD_INFO2_CBSY) == 0) ? 0 : 1)
#define Sdd_M_AllErrCheck(x)	((((x) & SDD_SD_INFO2_ERR_ALL) == 0) ? 0 : 1)
#define Sdd_M_BWECheck(x)	((((x) & SDD_SD_INFO2_BWE) == 0) ? 0 : 1)
#define Sdd_M_BRECheck(x)	((((x) & SDD_SD_INFO2_BRE) == 0) ? 0 : 1)

#elif defined(SDD_1BYTE_ACCESS) /* 1bytenANZX̏ꍇ */
/* ]ZN^JEgWX^ */
#define SDD_SD_SECCNT_CNT_MASK	(UH)0xffff	/* ]ZN^}XN */
/* SDJ[hX|XWX^ */
#define SDD_SD_RSP_MASK	0xffff	/* X|X}XN */

#define	Sdd_M_SetReg(x, y)	((x) = (y))
#define Sdd_M_GetReg(x, y)	((y) = (x))
#define	Sdd_M_AndReg(x, y)	((x) &= (y))
#define Sdd_M_OrReg(x, y)	((x) |= (y))
#define Sdd_M_CheckReg(x, y)	((((x) & (y)) == 0) ? 0 : 1)
#define Sdd_M_CardOutCheck(x)	((((x) & SDD_SD_INFO1_CARDOUT) == 0) ? 0 : 1)
#define Sdd_M_CardInCheck(x)	((((x) & SDD_SD_INFO1_CARDIN) == 0) ? 0 : 1)
#define Sdd_M_CardDetectCheck(x)	((((x) & SDD_SD_INFO1_CARDCHECK) == 0) ? 0 : 1)
#define Sdd_M_ResponseCheck(x)	((((x) & SDD_SD_INFO1_RES_END) == 0) ? 0 : 1)
#define Sdd_M_DataEndCheck(x)	((((x) & SDD_SD_INFO1_RW_ACCESSEND) == 0) ? 0 : 1)
#define Sdd_M_CmdErrCheck(x)	((((x) & SDD_SD_INFO2_CMD_ERR) == 0) ? 0 : 1)
#define Sdd_M_CrcErrCheck(x)	((((x) & SDD_SD_INFO2_CRC_ERR) == 0) ? 0 : 1)
#define Sdd_M_EndErrCheck(x)	((((x) & SDD_SD_INFO2_STOP_ERR) == 0) ? 0 : 1)
#define Sdd_M_ResTMoutErrCheck(x)	((((x) & SDD_SD_INFO2_RES_TIMEOUT_ERR) == 0) ? 0 : 1)
#define Sdd_M_TMoutErrCheck(x)	((((x) & SDD_SD_INFO2_TIMEOUT_ERR) == 0) ? 0 : 1)
#define Sdd_M_ILErrCheck(x)	((((x) & SDD_SD_INFO2_ILA_ERR) == 0) ? 0 : 1)
#define Sdd_M_CBSYCheck(x)	((((x) & SDD_SD_INFO2_CBSY) == 0) ? 0 : 1)
#define Sdd_M_AllErrCheck(x)	((((x) & SDD_SD_INFO2_ERR_ALL) == 0) ? 0 : 1)
#define Sdd_M_BWECheck(x)	((((x) & SDD_SD_INFO2_BWE) == 0) ? 0 : 1)
#define Sdd_M_BRECheck(x)	((((x) & SDD_SD_INFO2_BRE) == 0) ? 0 : 1)
#endif

/*==========================*/
/* ʕ 		    */
/*==========================*/
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
extern const UW SDD_SDIO_PHY_BASE[];
extern UW SDD_SDIO_BASE[];
#else  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
extern const UW SDD_SDIO_BASE[];
#endif  /* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */

/*==================*/
/* SDIOWX^ꗗ */
/*==================*/
#define SDD_SD_CMD(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0000 * SDD_ADDR_INC))	/* SDR}hWX^ */
#define SDD_SD_PORTSEL(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0002 * SDD_ADDR_INC))	/* SDJ[h̃|[gIWX^ */
#define SDD_SD_ARG0(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0004 * SDD_ADDR_INC))	/* SDR}hARGWX^[15:0] */
#define SDD_SD_ARG1(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0006 * SDD_ADDR_INC))	/* SDR}hARGWX^[31:16] */
#define SDD_SD_STOP(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0008 * SDD_ADDR_INC))	/* f[^XgbvWX^ */
#define SDD_SD_SECCNT(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x000a * SDD_ADDR_INC))	/* ]ZN^JEgWX^ */
#define SDD_SD_RSP0(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x000c * SDD_ADDR_INC))	/* SDJ[hX|XWX^[23:8] */
#define SDD_SD_RSP1(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x000e * SDD_ADDR_INC))	/* SDJ[hX|XWX^[39:24] */
#define SDD_SD_RSP2(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0010 * SDD_ADDR_INC))	/* SDJ[hX|XWX^[55:40] */
#define SDD_SD_RSP3(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0012 * SDD_ADDR_INC))	/* SDJ[hX|XWX^[71:56] */
#define SDD_SD_RSP4(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0014 * SDD_ADDR_INC))	/* SDJ[hX|XWX^[87:72] */
#define SDD_SD_RSP5(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0016 * SDD_ADDR_INC))	/* SDJ[hX|XWX^[103:88] */
#define SDD_SD_RSP6(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0018 * SDD_ADDR_INC))	/* SDJ[hX|XWX^[119:104] */
#define SDD_SD_RSP7(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x001a * SDD_ADDR_INC))	/* SDJ[hX|XWX^[127:120] */
#define SDD_SD_INFO1(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x001c * SDD_ADDR_INC))	/* SDJ[hCtH[CVWX^ */
#define SDD_SD_INFO2(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x001e * SDD_ADDR_INC))	/* SDJ[hobt@䁕G[WX^ */
#define SDD_SD_INFO1_MASK(a)	(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0020 * SDD_ADDR_INC))	/* SDJ[hCtH[[V}XNWX^ */
#define SDD_SD_INFO2_MASK(a)	(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0022 * SDD_ADDR_INC))	/* SDJ[hobt@䁕G[}XNWX^ */
#define SDD_SD_CLK_CTRL(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0024 * SDD_ADDR_INC))	/* SDNbN䃌WX^ */
#define SDD_SD_SIZE(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0026 * SDD_ADDR_INC))	/* SDJ[h]f[^ݒ背WX^ */
#define SDD_SD_OPTION(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0028 * SDD_ADDR_INC))	/* SDJ[hANZXIvVWX^ */
#define SDD_SD_ERR_STR1(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x002c * SDD_ADDR_INC))	/* SDG[荞݁iCMD/CRC/END)Xe[^XWX^ */
#define SDD_SD_ERR_STR2(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x002e * SDD_ADDR_INC))	/* SDG[荞݁i^CAEg)Xe[^XWX^ */
#define SDD_SD_BUF(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0030 * SDD_ADDR_INC))	/* obt@R/W|[gWX^ */
#define SDD_SDIO_MODE(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0034 * SDD_ADDR_INC))	/* SDIO[h䃌WX^ */
#define SDD_SDIO_INFO1(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0036 * SDD_ADDR_INC))	/* SDIOCtH[[VWX^ */
#define SDD_SDIO_INFO1_MASK(a)	(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x0038 * SDD_ADDR_INC))	/* SDIOCtH[[V}XNWX^ */
#define SDD_CC_EXT_MODE(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x00D8 * SDD_ADDR_INC))	/* DMA&CC_BUFFg[h䃌WX^ */
#define SDD_SOFT_RST(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x00E0 * SDD_ADDR_INC))	/* \tgZbgWX^ */
#define SDD_VERSION(a)			(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x00E2 * SDD_ADDR_INC))	/* o[WWX^ */
#define SDD_HOST_MODE(a)		(*(SDD_VULH *)(SDD_SDIO_BASE[a] + 0x00E4 * SDD_ADDR_INC))	/* o[WWX^ */

/* p}N */
#define SDD_BLK_ALL_RST				((SDD_VULH)0xFFFFFFFF)		/* HSC,DMCׂăZbg */
#define SDD_BLK_PERI_ALL_RST		((SDD_VULH)0x00000100)		/* ӃfoCXׂăZbg */

#define SDD_CLKSTP_IMCLK			((SDD_VULH)0x00000001)		/* SDIOubNւIMCK~ */
#define SDD_CLKSTP_IMCLK2			((SDD_VULH)0x00000008)		/* SDIOubNւIMCLK2~ */

/*====================*/
/* SDIOWX^ݒl */
/*====================*/
/* SDR}hWX^ */
#define SDD_SD_CMD_CMDMD_SECURITY	((SDD_VULH)0x00004000)		/* R}h[h ZLeB[R}hASDIOR}h(CMD12s) */
#define SDD_SD_CMD_MD5_MALUTI		((SDD_VULH)0x00002000)		/* VO(0)/}`ubN](1)I */
#define SDD_SD_CMD_MD4_READ			((SDD_VULH)0x00001000)		/* Write/Read[qݒ 0:Write(HOSTSD card) 1:Read(HOSTSD card)*/
#define SDD_SD_CMD_MD3_DATA			((SDD_VULH)0x00000800)		/* f[^]ݒ 0:f[^ 1:f[^L */
#define SDD_SD_CMD_EXTMD_NORES		((SDD_VULH)0x00000300)		/* g[h(Noresponse) */
#define SDD_SD_CMD_EXTMD_R165		((SDD_VULH)0x00000400)		/* g[h(R1,R6,R5) */
#define SDD_SD_CMD_EXTMD_R1B		((SDD_VULH)0x00000500)		/* g[h(R1b) */
#define SDD_SD_CMD_EXTMD_R2			((SDD_VULH)0x00000600)		/* g[h(R2) */
#define SDD_SD_CMD_EXTMD_R34		((SDD_VULH)0x00000700)		/* g[h(R3,R4) */
#define SDD_SD_CMD_C_CMD			((SDD_VULH)0x000000c0)		/* SDJ[hւCMD */
#define SDD_SD_CMD_C_ACMD			((SDD_VULH)0x00000040)		/* SDJ[hCMD55ɑACMD */
#define SDD_SD_CMD_C_AUTH			((SDD_VULH)0x00000080)		/* ݔF */
#define SDD_SD_CMD_CF_MASK			((SDD_VULH)0x0000003f)		/* R}hbitʒu */


/* SDR}hARGWX^*/
#define SDD_SD_ARG_MASK				((SDD_VULH)0x0000ffff)		/* ARGݒ}XN */

/* f[^XgbvWX^ */
#define SDD_SD_STOP_SEC		((SDD_VULH)0x00000100)	/* ]ZN^JEg(sCMD12) Disable(1) */
#define SDD_SD_STOP_STP		((SDD_VULH)0x00000001)	/* f[^]f ]f(1) */


/* SDJ[hCtH[CVWX^ */
#define SDD_SD_INFO1_SDDATA3_CARDCHECK	((SDD_VULH)0x00000400)	/* SDDATA3J[ho */
#define SDD_SD_INFO1_SDDATA3_CARDIN		((SDD_VULH)0x00000200)	/* SDDATA3J[h} */
#define SDD_SD_INFO1_SDDATA3_CARDOUT	((SDD_VULH)0x00000100)	/* SDDATA3J[hro */
#define SDD_SD_INFO1_WP					((SDD_VULH)0x00000080)	/* CgveNg */
#ifdef _SDD_CARDDETECT_SDDAT3_  /* SDDAT3ŃJ[h}oꍇ */
#define SDD_SD_INFO1_CARDCHECK			SDD_SD_INFO1_SDDATA3_CARDCHECK	/* J[ho */
#define SDD_SD_INFO1_CARDIN				SDD_SD_INFO1_SDDATA3_CARDIN     /* J[h} */
#define SDD_SD_INFO1_CARDOUT			SDD_SD_INFO1_SDDATA3_CARDOUT	/* J[hro */
#else /* \Pbg[qCDSDŃJ[h}oꍇ */
#define SDD_SD_INFO1_CARDCHECK			((SDD_VULH)0x00000020)	/* J[ho */
#define SDD_SD_INFO1_CARDIN				((SDD_VULH)0x00000010)	/* J[h} */
#define SDD_SD_INFO1_CARDOUT			((SDD_VULH)0x00000008)	/* J[hro */
#endif /* _SDD_CARDDETECT_SDDAT3_ */
#define SDD_SD_INFO1_RW_ACCESSEND		((SDD_VULH)0x00000004)	/* RW access end */
#define SDD_SD_INFO1_RES_END			((SDD_VULH)0x00000001)	/* Response end */


/* SDJ[hobt@䁕G[WX^ */
#define SDD_SD_INFO2_ILA_ERR			((SDD_VULH)0x00008000)	/* C[KANZXG[ */
#define SDD_SD_INFO2_CBSY				((SDD_VULH)0x00004000)	/* R}hWX^rW[ */
#define SDD_SD_INFO2_BWE				((SDD_VULH)0x00000200)	/* J[hɑ΂鏑݋ */
#define SDD_SD_INFO2_BRE				((SDD_VULH)0x00000100)	/* J[hɑ΂ǂݏo */
#define SDD_SD_INFO2_DAT0				((SDD_VULH)0x00000080)	/* I|[gSDDATA0M */
#define SDD_SD_INFO2_RES_TIMEOUT_ERR	((SDD_VULH)0x00000040)	/* X|X^CAEg */
#define SDD_SD_INFO2_ILA_READ_ERR		((SDD_VULH)0x00000020)	/* obt@ւ̃C[K[hANZX */
#define SDD_SD_INFO2_ILA_WRITE_ERR		((SDD_VULH)0x00000010)	/* obt@ւ̃C[KCgANZX */
#define SDD_SD_INFO2_TIMEOUT_ERR		((SDD_VULH)0x00000008)	/* ^CAEgiX|X^CAEgj */
#define SDD_SD_INFO2_STOP_ERR			((SDD_VULH)0x00000004)	/* IrbgG[ */
#define SDD_SD_INFO2_CRC_ERR			((SDD_VULH)0x00000002)	/* CRCG[ */
#define SDD_SD_INFO2_CMD_ERR			((SDD_VULH)0x00000001)	/* R}hG[ */
#define SDD_SD_INFO2_ERR_ALL			((SDD_VULH)0x0000807f)	/* SG[ */
#define SDD_SD_INFO2_ERR_ILAACCESS		((SDD_VULH)(SDD_SD_INFO2_ILA_ERR | SDD_SD_INFO2_ILA_READ_ERR | SDD_SD_INFO2_ILA_WRITE_ERR))	/* ANZXG[ */
#define SDD_SD_INFO2_BSYC2				0x00001000	/* ÕHrW[ */

/* SDJ[hCtH[[V}XNWX^ */
#define SDD_SD_INFO1_MASK_SDDATA3_CARDIN	((SDD_VULH)0x00000200)	/* SDDATA3J[ho荞݋(0)֎~(1) */
#define SDD_SD_INFO1_MASK_SDDATA3_CARDOUT	((SDD_VULH)0x00000100)	/* SDDATA3J[h}荞݋(0)֎~(1)  */
#ifdef _SDD_CARDDETECT_SDDAT3_  /* SDDAT3ŃJ[h}oꍇ */
#define SDD_SD_INFO1_MASK_CARDIN			SDD_SD_INFO1_MASK_SDDATA3_CARDIN	/* J[h}荞݋(0)֎~(1)  */
#define SDD_SD_INFO1_MASK_CARDOUT			SDD_SD_INFO1_MASK_SDDATA3_CARDOUT	/* J[hro荞݋(0)֎~(1)  */
#else /* \Pbg[qCDSDŃJ[h}oꍇ */
#define SDD_SD_INFO1_MASK_CARDIN			((SDD_VULH)0x00000010)	/* J[h}荞݋(0)֎~(1)  */
#define SDD_SD_INFO1_MASK_CARDOUT			((SDD_VULH)0x00000008)	/* J[hro荞݋(0)֎~(1)  */
#endif /* _SDD_CARDDETECT_SDDAT3_ */
#define SDD_SD_INFO1_MASK_RW_ACCESSEND		((SDD_VULH)0x00000004)	/* RW access end荞݋(0)֎~(1)  */
#define SDD_SD_INFO1_MASK_RES_END			((SDD_VULH)0x00000001)	/* Response end 荞݋(0)֎~(1) */
#define SDD_SD_INFO1_MASK_ALL				((SDD_VULH)0x0000031d)	/*  */


/* SDJ[hobt@䁕G[}XNWX^ */
#define SDD_SD_INFO2_MASK_ILA				((SDD_VULH)0x00008000)	/* C[KANZXG[荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_BWE				((SDD_VULH)0x00000200)	/* BWE荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_BRE				((SDD_VULH)0x00000100)	/* BRE荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_RES_TIMEOUT		((SDD_VULH)0x00000040)	/* X|X^CAEg荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_IL_READACCESS		((SDD_VULH)0x00000020)	/* obt@ւ̃C[K[hANZX荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_IL_WRITEACCESS	((SDD_VULH)0x00000010)	/* obt@ւ̃C[KCgANZX荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_TIMEOUT			((SDD_VULH)0x00000008)	/* ^CAEgiX|X^CAEgj荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_STOP_ERR			((SDD_VULH)0x00000004)	/* IrbgG[荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_CRC_ERR			((SDD_VULH)0x00000002)	/* CRCG[荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_CMD_ERR			((SDD_VULH)0x00000001)	/* R}hG[荞݋(0)֎~(1)  */
#define SDD_SD_INFO2_MASK_ERR_ALL			((SDD_VULH)0x0000807f)	/* SG[ */
#define SDD_SD_INFO2_MASK_ALL				((SDD_VULH)0x0000837f)	/* S荞݋(0)֎~(1)  */

/* SDJ[h]f[^ݒ背WX^ */
#define SDD_SD_SIZE_LEN				((SDD_VULH)0x000003ff)	/* ]f[^ݒ */

/* SDJ[hANZXIvVWX^ */
#define SDD_SD_OPTION_WIDTH			((SDD_VULH)0x00008000)	/* rbgݒ 4bit(0) 1bit(1)*/
#define SDD_SD_OPTION_MSEL			((SDD_VULH)0x00004000)	/* ÕW[I gp(1) */
#define SDD_SD_OPTION_TOP			((SDD_VULH)0x000000f0)	/* X|X^CAEgJEg */
#define SDD_SD_OPTION_TOP_2_13		((SDD_VULH)0x00000000)	/* ^CAEgSDCLK * 2^13 */
#define SDD_SD_OPTION_TOP_2_14		((SDD_VULH)0x00000010)	/* ^CAEgSDCLK * 2^14 */
#define SDD_SD_OPTION_TOP_2_15		((SDD_VULH)0x00000020)	/* ^CAEgSDCLK * 2^15 */
#define SDD_SD_OPTION_TOP_2_16		((SDD_VULH)0x00000030)	/* ^CAEgSDCLK * 2^16 */
#define SDD_SD_OPTION_TOP_2_17		((SDD_VULH)0x00000040)	/* ^CAEgSDCLK * 2^17 */
#define SDD_SD_OPTION_TOP_2_18		((SDD_VULH)0x00000050)	/* ^CAEgSDCLK * 2^18 */
#define SDD_SD_OPTION_TOP_2_19		((SDD_VULH)0x00000060)	/* ^CAEgSDCLK * 2^19 */
#define SDD_SD_OPTION_TOP_2_20		((SDD_VULH)0x00000070)	/* ^CAEgSDCLK * 2^20 */
#define SDD_SD_OPTION_TOP_2_21		((SDD_VULH)0x00000080)	/* ^CAEgSDCLK * 2^21 */
#define SDD_SD_OPTION_TOP_2_22		((SDD_VULH)0x00000090)	/* ^CAEgSDCLK * 2^22 */
#define SDD_SD_OPTION_TOP_2_23		((SDD_VULH)0x000000a0)	/* ^CAEgSDCLK * 2^23 */
#define SDD_SD_OPTION_TOP_2_24		((SDD_VULH)0x000000b0)	/* ^CAEgSDCLK * 2^24 */
#define SDD_SD_OPTION_TOP_2_25		((SDD_VULH)0x000000c0)	/* ^CAEgSDCLK * 2^25 */
#define SDD_SD_OPTION_TOP_2_26		((SDD_VULH)0x000000d0)	/* ^CAEgSDCLK * 2^26 */
#define SDD_SD_OPTION_TOP_2_27		((SDD_VULH)0x000000e0)	/* ^CAEgSDCLK * 2^27 */
#define SDD_SD_OPTION_CTOP			((SDD_VULH)0x0000000f)	/* J[ho҂JEg */
#define SDD_SD_OPTION_CTOP_FIRST	((SDD_VULH)0x00000000)	/* J[ho҂ől */

/* SDG[荞݁iCMD/CRC/END)Xe[^XWX^ */
#define SDD_SD_ERR_STR1_CRCWRITESTATUS			((SDD_VULH)0x00007000)	/* CRC݃Xe[^X */
#define SDD_SD_ERR_STR1_CRCWRITESTATUS_ERR		((SDD_VULH)0x00000800)	/* CRC݃Xe[^XG[ ʏ(0) G[o(1) */
#define SDD_SD_ERR_STR1_READDATA_CRCERR			((SDD_VULH)0x00000400)	/* [hf[^CRCG[ ʏ(0) G[o(1)  */
#define SDD_SD_ERR_STR1_SDSTOP_RES_CRCERR		((SDD_VULH)0x00000200)	/* SD_STOPX|XCRCG[  ʏ(0) G[o(1) */
#define SDD_SD_ERR_STR1_CMD_RES_CRCERR			((SDD_VULH)0x00000100)	/* R}hX|XCRCG[  ʏ(0) G[o(1) */
#define SDD_SD_ERR_STR1_WRITECRCSTATUS_ENDERR	((SDD_VULH)0x00000020)	/* CRCXe[^X̏IrbgG[  ʏ(0) G[o(1) */
#define SDD_SD_ERR_STR1_READDATA_ENDERR			((SDD_VULH)0x00000010)	/* [hf[^̏IrbgG[  ʏ(0) G[o(1) */
#define SDD_SD_ERR_STR1_SDSTOP_RES_ENDERR		((SDD_VULH)0x00000008)	/* SD_STOPX|X̏IrbgG[  ʏ(0) G[o(1) */
#define SDD_SD_ERR_STR1_CMD_RES_ENDERR			((SDD_VULH)0x00000004)	/* R}hX|X̏IrbgG[  ʏ(0) G[o(1) */
#define SDD_SD_ERR_STR1_SDSTOP_RES_CMDERR		((SDD_VULH)0x00000002)	/* SD_STOPX|X̃R}hCfbNXG[  ʏ(0) G[o(1) */
#define SDD_SD_ERR_STR1_CMD_RES_CMDERR			((SDD_VULH)0x00000001)	/* R}hX|X̃R}hCfbNXG[ ʏ(0) G[o(1)  */

/* SDG[荞݁i^CAEg)Xe[^XWX^ */
#define SDD_SD_ERR_STR2_E6		((SDD_VULH)0x00000040)	/* CRCXe[^X݌ANTCN̊Busy̏ꍇ ʏ(0) G[o(1) */
#define SDD_SD_ERR_STR2_E5		((SDD_VULH)0x00000020)	/* CgTCNANTCN̊CRCG[Xe[^X܂Ȃꍇ */
#define SDD_SD_ERR_STR2_E4		((SDD_VULH)0x00000010)	/* [hR}hANTCN̊ԃf[^[hȂꍇ */
#define SDD_SD_ERR_STR2_E3		((SDD_VULH)0x00000008)	/* SD_STOPANTCN̊Busy̏ꍇ */
#define SDD_SD_ERR_STR2_E2		((SDD_VULH)0x00000004)	/* R1bX|XANTCN̊Busy̏ꍇ */
#define SDD_SD_ERR_STR2_E1		((SDD_VULH)0x00000002)	/* SDCLK640TCN̊ԁASD_STOPX|XȂꍇ */
#define SDD_SD_ERR_STR2_E0		((SDD_VULH)0x00000001)	/* SDCLK640TCN̊ԁAR}hX|XȂꍇ */

/* obt@R/W|[gWX^ */
#define SDD_SD_BUF_BUF15		((SDD_VULH)0x00008000)	/* f[^MɎgpA512Byteobt@RAM(256word) */
#define SDD_SD_BUF_BUF14		((SDD_VULH)0x00004000)
#define SDD_SD_BUF_BUF13		((SDD_VULH)0x00002000)
#define SDD_SD_BUF_BUF12		((SDD_VULH)0x00001000)
#define SDD_SD_BUF_BUF11		((SDD_VULH)0x00000800)
#define SDD_SD_BUF_BUF10		((SDD_VULH)0x00000400)
#define SDD_SD_BUF_BUF9			((SDD_VULH)0x00000200)
#define SDD_SD_BUF_BUF8			((SDD_VULH)0x00000100)
#define SDD_SD_BUF_BUF7			((SDD_VULH)0x00000080)
#define SDD_SD_BUF_BUF6			((SDD_VULH)0x00000040)
#define SDD_SD_BUF_BUF5			((SDD_VULH)0x00000020)
#define SDD_SD_BUF_BUF4			((SDD_VULH)0x00000010)
#define SDD_SD_BUF_BUF3			((SDD_VULH)0x00000008)
#define SDD_SD_BUF_BUF2			((SDD_VULH)0x00000004)
#define SDD_SD_BUF_BUF1			((SDD_VULH)0x00000002)
#define SDD_SD_BUF_BUF0			((SDD_VULH)0x00000001)
#define SDD_SD_BUF_BUFALL		((SDD_VULH)0x0000ffff)

/* SDIO[h䃌WX^ */
#define SDD_SDIO_MODE_C52PUB	((SDD_VULH)0x00000200)
#define SDD_SDIO_MODE_IOABT		((SDD_VULH)0x00000100)
#define SDD_SDIO_MODE_RWREQ		((SDD_VULH)0x00000004)
#define SDD_SDIO_MODE_IOMOD		((SDD_VULH)0x00000001)


/* SDIOCtH[[VWX^ */
#define SDD_SDIO_INFO1_EXWT		((SDD_VULH)0x00008000)
#define	SDIO_INFO1_EXWT				0x8000		/* SDIO_INFO1_EXWT 										*/
#define	SDIO_INFO1_EXPUB52			0x4000		/* SDIO_INFO1_EXPUB52 									*/
#define	SDIO_INFO1_RWRDY			0x0004		/* SDIO_INFO1 SDIO_INFO1_RWRDY 							*/
#define	SDIO_INFO1_C52RDY			0x0002		/* SDIO_INFO1_C52RDY 									*/
#define	SDIO_INFO1_IOIRQ			0x0001		/* SDIO_INFO1_IOIRQ 									*/
#define	SDIO_INFO1_MASK_MEXWT		0x8000		/* SDIO_INFO1_MASK_MEXWT 								*/
#define	SDIO_INFO1_MASK_MEXPUB52	0x4000		/* SDIO_INFO1_MASK_MEXPUB52								*/
#define	SDIO_INFO1_MASK_MRWRDY		0x0004		/* SDIO_INFO1_MASK_MRWRDY 								*/
#define	SDIO_INFO1_MASK_MC52RDY		0x0002		/* SDIO_INFO1_MASK_MC52RDY 								*/
#define	SDIO_INFO1_MASK_IOMSK		0x0001		/* SDIO_INFO1_MASK_IOMSK 								*/
#define	SDIO_INFO1_ALLCLR			0xC007		/* SDIO_INFO1 											*/
#define	SDIO_INFO1_MASK_ALLCLR		0xC007		/* SDIO_INFO1_MASK 										*/
#define	SDIO_INFO1_ERRCLR			0xC000		/* SDIO_INFO1 											*/
#define	SDIO_INFO1_MASK_ERRCLR		0xC000		/* SDIO_INFO1_MASK 										*/
#define	SDIO_INFO1_IRQSET			0x0007		/* Judge Interrupt for SDIO_INFO1 						*/
#define	SDIO_INFO1_ERROR_SET		0xC000		/* Judge Interrupt for SDIO_INFO1 Error					*/

/* SDIOCtH[[V}XNWX^ */

/* \tgZbgWX^ */
#define SDD_SOFT_RST_CRST		((SDD_VULH)0x00000004)	/* ÍZbg Zbg(1) ÕW[Zbg(0) */
#define SDD_SOFT_RST_ORST		((SDD_VULH)0x00000002)	/* ÍȊOZbg Zbg(1) ÕW[ȊOZbg(0) */
#define SDD_SOFT_RST_SDRST		((SDD_VULH)0x00000001)	/* SD I/FZbg */
#ifdef _SDD_ANGOU_
#define SDD_SOFT_RST_ALL		((SDD_VULH)0x00000007)	/* SZbg */
#else
#define SDD_SOFT_RST_ALL		((SDD_VULH)0x00000001)	/* SZbg */
#endif

/* o[WWX^ */
#define SDD_VERSION_UR			((SDD_VULH)0x0000ff00)
#define SDD_VERSION_IP			((SDD_VULH)0x000000ff)


/*=============================*/
/*@NbNWFl[^ݒl */
/*=============================*/
#define SDD_CHDRV_CHDRV2	((SDD_VULH)0x00000004)		/* SD-IPɊONbNgpIOZ̃hCu\͂ύX */

/* CardXe[^X */
#define SDD_CARD_STATUS_OUT_OF_RANGE	0x80000000
#define SDD_CARD_STATUS_ADDRESS_ERROR	0x40000000
#define SDD_CARD_STATUS_ERROR			0xfdf98008
#define SDD_CARD_STATUS_CURRENT_STATE	0x00001E00
#define SDD_CARD_STATUS_TRAN_STATE		0x00000800
#define SDD_CARD_STATUS_READY_FOR_DATA	0x00000100
/*** SDKiVer2.0ΉJnA2005.12.16 ***/
#define SDD_CARD_STATUS_LOCK			0x02000000
/*** SDKiVer2.0ΉENDA2005.12.16 ***/

/* oX */
#define	SDD_BUS_WIDTH_4BIT	0
#define SDD_BUS_WIDTH_1BIT	1

/* Sddr_setStopp */
#define	SDD_STOP_NONSTP		0	/* CMD12sȂ */
#define SDD_STOP_STP		1	/* CMD12s */

/* WX^ItZbg */    /* AM33ʕɈړ  03/1/23 shiiba */
#define SDD_SD_CID_OFFSET	0	/* Byte */
#define SDD_SD_RCA_OFFSET	2	/* Byte */
#define SDD_SD_CSD_OFFSET	0	/* Byte */
#define SDD_SD_OCR_OFFSET	0	/* Byte */

/* Sddr_GetMechanicalWP() */
#define SDD_MECHANICALWP_ON		1	/* CgveNgEI */
#define SDD_MECHANICALWP_OFF	0	/* CgveNgEIt */

/* Sddr_EnaIntSDBuf()p */
#define SDD_BUF_READ		0
#define SDD_BUF_WRITE		1

/* Sddr_SetAm33Dma(),Sdd_StartDMA()p */
#define SDD_DMA_READ		0
#define SDD_DMA_WRITE		1

/* Sddr_CheckCardStatus()p */
#define SDD_CARD_STATUS_WRITE	0
#define SDD_CARD_STATUS_READ	1
#define SDD_GET_STATUS_LOOP_CNT	0x0A

/* Sddr_AddrAlign()p */
#define SDD_ALIGN_OK			0	/* ACgnj */
#define SDD_ALIGN_NG			1	/* ACgُ */

/* Sdd_GetInt()p */		/* ʕɈړ 04/1/23 shiiba */
#define	SDD_INT_STATUS1		0	/* Cxgn */
#define	SDD_INT_STATUS2		1	/* ُCxgn */

/* Add_ClrInt()p */		/* ʕɈړ 04/1/23 shiiba */
#define	SDD_INT_CLR1		0	/* Cxgn */
#define	SDD_INT_CLR2		1	/* ُCxgn */

/*** SDKiVer2.0ΉJnA2005.12.14 ***/
/* R7X|X */
#define	SDD_R7_VOLTAGE1			(UH)0x0100	/* 2.7V-3.6Vd͈ */
#define	SDD_R7_CHECK_PATTERN	(UH)0x00AA	/* `FbNp^[ */
#define	SDD_R7_MASK				(UW)0x0000FFFF	/* MSH}XN */
/* SDD_DEV physical Version */
#define	SDD_PHY_VER1		(UH)0x0001	/* Ver1.x */
#define	SDD_PHY_VER2		(UH)0x0002	/* Ver2.x */
#define	SDD_PHY_HCCARD		(UH)0x0200	/* HCJ[h */
#define	SDD_PHY_LCCARD		(UH)0x0100	/* LCJ[h */
#define	SDD_PHY_CARDMASK	(UH)0x00FF	/* J[heʃ}XN */
#define	SDD_PHY_SET			(UB)0x01	/* `L */
#define	SDD_PHY_CLEAR		(UB)0x00	/* ` */

/*** SDKiVer2.0ΉENDA2005.12.14 ***/

#ifdef _SDD_ALLOW_UHS1_
#define SDD_SDIN_ENABLE         1       /* ̓Cl[u */
#define SDD_SDIN_DISABLE        0       /* ͒~ */
#endif

/*==========*/
/* ֐ */
/*==========*/
#ifdef _SDD_JUPITER_
extern void Sddr_ChangeMclk( SDD_HANDLE *p_SddHandle, UB ub_Mclk );     /* MCLK̕ύX */
#endif
extern UW Sddr_CheckAddrAlign(B *);                                     /* AhXACg`FbN */
extern void Sddr_CheckBusy(SDD_HANDLE *p_SddHandle, UW *checkVal);      /* R}hrW[`FbN */
extern void Sddr_CheckCardStatus(SDD_HANDLE *p_SddHandle, UW uw_Read, SDD_ERROR *w_errCode);	/* Card Status(R1)擾 */
extern void Sddr_CheckDAT0(SDD_HANDLE *p_SddHandle, UW *checkVal);      /* DAT0rW[`FbN */
extern UW Sddr_CheckSecCnt(SDD_HANDLE *p_SddHandle);                    /* ZN^̗L */
extern void Sddr_ClrErrAll( SDD_HANDLE *p_SddHandle );                  /* SD I/F  G[NA */
extern void Sddr_ClrInt(SDD_HANDLE *p_SddHandle, UW uw_type, UW uw_status);    /* 荞݃NA(SDD_INFO1,SDD_INFO2) */
extern void Sddr_ClrResEnd( SDD_HANDLE *p_SddHandle );                  /* SD I/F Response EndNA֎~ */
extern void Sddr_ClrTransEnd( SDD_HANDLE *p_SddHandle );                /* SD I/FAccess All EndNA֎~ */
extern void Sddr_CopyFromBuf(SDD_HANDLE *p_SddHandle, UB * pub_Dst, UW uw_Cnt);                /* SD obt@ǂݍ(SDD_BUFF) */
extern void Sddr_CopyFromRsp(SDD_HANDLE *p_SddHandle, UB * pub_Dst, UW uw_Offset, UW uw_Cnt);  /* X|Xǂݍ(SDD_RSP0`SDD_RSP7) */
extern void Sddr_CopyToBuf(SDD_HANDLE *p_SddHandle, UB * pub_Src, UW uw_Cnt);                  /* SD obt@(SDD_BUFF) */
extern void Sddr_DisIntAll(SDD_HANDLE *p_SddHandle);                    /* SD I/F̑S荞݋֎~ */
extern void Sddr_DisIntEraseCMD( SDD_HANDLE *p_SddHandle );             /* Erasẽ^CAEgG[AX|X^CAEgG[}XN */
extern void Sddr_DisIntReadyCMD( SDD_HANDLE *p_SddHandle );             /* SD I/F 荞ݑS֎~ */
extern void Sddr_DisResEnd( SDD_HANDLE *p_SddHandle );                  /* SD I/F Response End荞݋֎~ */
extern SDD_ERROR Sddr_DisSDBLKInt(SDD_HANDLE *p_SddHandle);             /* SD I/F荞݋֎~ݒ IOBIntrEn[0`1]̋֎~i0ŋ֎~j */
extern void Sddr_DisSecCnt(SDD_HANDLE *p_SddHandle);                    /* ZN^̖ݒ */
extern void Sddr_DisTransEnd( SDD_HANDLE *p_SddHandle );                /* SD I/FAccess All End荞݋֎~ */
extern SDD_ERROR Sddr_EnaClk(SDD_HANDLE *p_SddHandle, UW uw_clk);       /* SD NbNJn */
extern void Sddr_EnaIntAllErr( SDD_HANDLE *p_SddHandle );               /* SD I/F ׂẴG[݂ */
extern void Sddr_EnaIntReadyCMD( SDD_HANDLE *p_SddHandle );             /* SD I/F R}hs荞݋ */
extern void Sddr_EnaIntSDBuf(SDD_HANDLE *p_SddHandle, UW uw_status);    /* SD I/F SD BuF荞݋ */
extern void Sddr_EnaResEnd( SDD_HANDLE *p_SddHandle );                  /* SD I/F Response End荞݋ */
extern SDD_ERROR Sddr_EnaSDBLKInt( SDD_HANDLE *p_SddHandle );           /* SD I/F荞݋ݒ  IOBIntrEn[0`1]̋i1ŋj */
extern void Sddr_EnaTransEnd( SDD_HANDLE *p_SddHandle );                /* SD I/FAccess All End荞݋ */
extern void Sddr_GetCID( SDD_HANDLE *p_SddHandle );                     /* CID̎擾 */
extern void Sddr_GetCSD( SDD_HANDLE *p_SddHandle );                     /* CSD̎擾 */
extern UW Sddr_GetInt(SDD_HANDLE *p_SddHandle, UW uw_status);           /* 荞ݎ擾(SDD_INFO1,SDD_INFO2) */
extern void Sddr_GetMechanicalWP(SDD_HANDLE *p_SddHandle, UB *pub_MechanicalWP);      /* J[hLtÕ`FbN */
extern SDD_ERROR Sddr_GetModeRegister(SDD_HANDLE *p_SddHandle, UW *uw_RetMode);       /* SD I/F[h擾 */
extern void Sddr_GetOCR( SDD_HANDLE *p_SddHandle );                     /* OCR̎擾 */
extern void Sddr_GetRCA( SDD_HANDLE *p_SddHandle );                     /* RCA̎擾 */
extern void Sddr_GetResponse(SDD_HANDLE *p_SddHandle, UW *uw_R);        /* CMDX|X擾 */
extern SDD_ERROR Sddr_HardReset( SDD_HANDLE *p_SddHandle, UW uw_Mode ); /* SD I/F ubNn[hZbg */
extern void Sddr_PollingResEnd(SDD_HANDLE *p_SddHandle);                /* X|XGh̃|[O */
extern void Sddr_SetArg(SDD_HANDLE *p_SddHandle, UH uh_Arg0, UH uh_Arg1); /* ARGݒ(SDD_ARG0,SDD_ARG1) */
extern void Sddr_SetBusWidth(SDD_HANDLE *p_SddHandle, UW uw_width);     /* SDoXݒ */
extern void Sddr_SetAngouMode( SDD_HANDLE *p_SddHandle, UB ub_AngouMode ); /* ÕHL/̐ݒ */
extern void Sddr_SetClkDiv(SDD_HANDLE *p_SddHandle, UW uw_Div);         /* SDNbNݒ */
extern void Sddr_SetCmd(SDD_HANDLE *p_SddHandle, UH uh_Cmd);            /* R}hݒ(SDD_CMD) */
extern SDD_ERROR Sddr_SetDetectCLK(SDD_HANDLE *p_SddHandle, UW uw_Mode);/* IMCLK2 */
extern void Sddr_SetLength(SDD_HANDLE *p_SddHandle, UW uw_NewLength);   /* ]f[^ݒ */
extern SDD_ERROR Sddr_SetMode_normal(SDD_HANDLE *p_SddHandle);          /* SD I/F[hݒ IMCLK(ʏ) */
extern SDD_ERROR Sddr_SetMode_standby(SDD_HANDLE *p_SddHandle);         /* SD I/F[hݒ IMCLK(STANDBY) */
extern void Sddr_SetSecCnt(SDD_HANDLE *p_SddHandle, UW uw_SecCnt);      /* ]ZN^ݒ */
extern void Sddr_SetStop(SDD_HANDLE *p_SddHandle, UB ub_Stop);          /* f[^]~/p */
extern void Sddr_SetTimeOutCycle(SDD_HANDLE *p_SddHandle, UW uw_Div);   /* ^CAEg҂NbNTCN̐ݒ  */
extern void Sddr_SetWaitCycleCD(SDD_HANDLE *p_SddHandle, UW uw_SetCycle); /* J[hop҂NbNTCN̐ݒ 04/1/30 shiiba */
extern void Sddr_SoftReset(SDD_HANDLE *p_SddHandle, UW uw_Target);      /* \tgZbg */
#if defined(_SDD_UNIPHIER_2P_) || defined(_SDD_UNIPHIER_XP_)
#endif /* _SDD_UNIPHIER_2P_ || _SDD_UNIPHIER_XP_ */
extern void Sddr_DisIntSDBuf(SDD_HANDLE *p_SddHandle, UW uw_status);    /* SD I/F SD BuF荞݋֎~ */
void Sddr_SetSdclkSel(SDD_HANDLE *p_SddHandle);                         /* SDNbN[h(50MHz)ݒ */
void Sddr_ResetSdclkSel(SDD_HANDLE *p_SddHandle);                       /* SDNbN񓯊[h(50MHz)ݒ */
extern void Sddr_PrintRegister(SDD_HANDLE *p_SddHandle);

#ifdef _SDD_ALLOW_UHS1_
extern void Sddr_GetVol(SDD_HANDLE *p_SddHandle, UB *ub_voltage); 
extern void Sddr_SetVol(SDD_HANDLE *p_SddHandle, UB ub_voltage);                                 /* dlݒ */                               /* dl擾 */
extern void Sddr_EnaSDIN(SDD_HANDLE *p_SddHandle, UW uw_sdin);          /* SD I/F̓͊ђʓdh~ */
#endif /* _SDD_ALLOW_UHS1_ */

#if defined(_SDD_DAT3_PULLUP_DISABLE_) || defined(_SDD_DAT3_PULLUP_PART_DISABLE_)
void Sdds_SetPullupSDDAT3(SDD_HANDLE *p_SddHandle, BOOL bl_Set);
#endif /* defined(_SDD_DAT3_PULLUP_DISABLE_) || defined(_SDD_DAT3_PULLUP_PART_DISABLE_) */

void Sddr_SetRegBank(SDD_HANDLE *p_SddHandle);                         /* REG_BANKݒ */

#ifdef _SDD_HWTIMER_SPEEDTEST_
extern void Sddr_SettingHWTimer();
extern void Sddr_StartHWTimer();
extern void Sddr_StopHWTimer();
extern UW Sddr_GetHWTimer();
#endif /* _SDD_HWTIMER_SPEEDTEST_ */

#endif /* _SDD_REGISTER_H_ */
