/********************************************************************************/
/*  t@C    F$Workfile: SddRegister_dma.h $                              */
/*  Tv          FSDfoCXhCoDMAWX^ANZXwb_t@C         */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 07/04/26  9:50 $                                  */
/********************************************************************************/

#ifndef _SDD_REGISTER_DMA_H_
#define _SDD_REGISTER_DMA_H_

#if defined(_SDD_UNIPHIER_2P_)
#include "device/SddRegister_dma_for_uniphier2p.h"
#endif /* _SDD_UNIPHIER_2P_ */

#if defined(_SDD_UNIPHIER_XP_)
#include "device/SddRegister_dma_for_uniphierxp.h"
#endif /* _SDD_UNIPHIER_XP_ */

#if defined(_SDD_JUPITER_)
#include "device/SddRegister_dma_for_jupiter.h"
#endif /* _SDD_JUPITER_ */

#if defined(_SDD_PEAKS_PRO2_)
#include "device/SddRegister_dma_for_peakspro2.h"
#endif /* _SDD_PEAKS_PRO2_ */

#if defined(_SDD_PCAM_)
#include "device/SddRegister_dma_for_pcam.h"
#endif /* _SDD_PCAM_ */

/*==========*/
/*      */
/*==========*/
/* DMA&CC_BUFFg[h䃌WX^ */
#define SDD_CC_EXT_MODE_OREN	0x00001000	/* FIFO[hFo̓obt@empty(Ǐos)(1) Ǐo\(0) */
#define SDD_CC_EXT_MODE_OBEN	0x00000200	/* o̓obt@FrbOGfBA(1) gGfBA(0)=default */
#define SDD_CC_EXT_MODE_FOSEL	0x00000100	/* FIFO[hF̓obt@݉\(1) */
#define SDD_CC_EXT_MODE_IWEN	0x00000010	/* FIFO[hF̓obt@݉\(1) */
#define SDD_CC_EXT_MODE_CCOR	0x00000008	/* CC_output(Reco)obt@[hDMA[hL(1) */
#define SDD_CC_EXT_MODE_CCIW	0x00000004	/* CC_input(Rec)obt@CgDMA[hL(1) */
#define SDD_CC_EXT_MODE_DMASDRW	0x00000002	/* SDobt@R/WDMAL(1)@(0)=default@*/
#define SDD_CC_EXT_MODE_FISEL	0x00000001	/* ̓obt@FFIFOgpi1jRAMgp(0)=default@*/


/*==========*/
/* ֐ */
/*==========*/
#if defined(_SDD_UNIPHIER_2P_) || defined(_SDD_UNIPHIER_XP_)
extern void Sddr_CheckDmaTransfer(SDD_HANDLE *p_SddHandle, SDD_ERROR *w_ErrCode );    /* DMA 0oCg]̃`FbN */
#endif /* _SDD_UNIPHIER_2P_ || _SDD_UNIPHIER_XP_ */
extern void Sddr_ClrDmaInt(SDD_HANDLE *p_SddHandle);                    /* DMA荞݃Xe[^XNA */
extern void Sddr_DisDmaInt(SDD_HANDLE *p_SddHandle);                    /* DMA荞݋֎~ */
extern void Sddr_DisDmaSDIF(SDD_HANDLE *p_SddHandle);                   /* SD I/F DMAݒ(Disable) */
extern void Sddr_DmacBLKReset( SDD_HANDLE *p_SddHandle );               /* DMCZbgݒ@04/2/3 shiiba */
extern void Sddr_DmacReset( SDD_HANDLE *p_SddHandle );                  /* DMAZbg */
extern void Sddr_EnaDmacBLKInt( SDD_HANDLE *p_SddHandle );              /* DMC̊荞݂ 04/2/3 shiiba */
extern void Sddr_EnaDmaInt( SDD_HANDLE *p_SddHandle );                  /* Xg[DMAC荞݋ */
extern void Sddr_EnaDmaSDIF( SDD_HANDLE *p_SddHandle );                 /* SD I/F DMAݒ(Enable) */
#ifdef _SDD_JUPITER_
extern void Sddr_GetDmaStatus(SDD_HANDLE *p_SddHandle, UW uw_CheckStatus, UW *uw_Status);        /* DMȀԎ擾 */
#endif /* _SDD_JUPITER_	*/
extern void Sddr_SetAM33Dma(UW uw_StartAddr, UW uw_DataByte, UW uw_dir);/* AM33DMA]ݒ */
extern SDD_ERROR Sddr_SetDma(SDD_HANDLE *p_SddHandle, UW uw_Addr, UW uw_size, UW uw_dir);  /* Xg[DMAC]ݒ */
extern void Sddr_SetRingBuff(SDD_HANDLE *p_SddHandle, UW uw_Start, UW uw_End);     /* Oobt@ݒ(DMCch4BufStAd,DMCch4BufEdAd) */
extern void Sddr_StartAM33Dma( void );                                  /* AM33DMAC]N */
extern void Sddr_StartDma(SDD_HANDLE *p_SddHandle, UW uw_dir);          /* Xg[DMAC]N */
extern SDD_ERROR Sddr_StopDma(SDD_HANDLE *p_SddHandle);                 /* Xg[DMAC]~ */
extern void Sddr_WaitStable( void );                                    /* J[hd҂ */
#ifdef _SDD_USE_SDMACLIB_
extern W Sddr_CheckIntrType(SDD_HANDLE *p_SddHandle);
#endif /*  _SDD_USE_SDMACLIB_ */

#endif /* _SDD_REGISTER_DMA_H_ */
