/**************************************************************************************/
/*  t@C    F$Workfile: SddRegister_dma.h $                                    */
/*  Tv          FSDfoCXhCoDMAWX^ANZXwb_t@C(PeaksPro2p)  */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.               */
/*  ŏIXV    F$Modtime: 07/04/26  9:50 $                                        */
/**************************************************************************************/

#if defined(_SDD_PEAKS_PRO2_)
#ifndef _SDD_PRO2_UAM1_
#include <dtvrecdd/memtrans.h>
#else
#include "memtrans.h"
#endif
extern const UW SDD_DMA_PHY_BASE[];
extern UW SDD_DMA_BASE[];

/*=================*/
/* DMAWX^ꗗ */
/*=================*/
#if defined(_SDD_PEAKS_AVC_) && defined(_SDD_SLD3_)
#define SDD_DMA_CH			7				/* ch7gp */
#else	/* defined(_SDD_PEAKS_AVC_) && defined(_SDD_SLD3_) */
#define SDD_DMA_CH			4				/* ch4gp */
#endif	/* defined(_SDD_PEAKS_AVC_) && defined(_SDD_SLD3_) */
#define SDD_DMA_CH_OFFSET	(0x0100)
#define SDD_DMA_RNG_OFFSET	(0x0800)
#define SDD_DMA_CH_ADR		(SDD_DMA_CH_OFFSET + (0x40 * SDD_DMA_CH))
#define SDD_DMA_RNG_ADR		(SDD_DMA_RNG_OFFSET + (0x40 * SDD_DMA_CH))

#define SDD_DMC_DMA_START(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + 0x0000))						/* CDMIO_STRT0          :DMAN */
#define SDD_DMC_DMA_RESET(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + 0x0050))						/* CDMIO_PARTRESET0     :DMAʃZbg */
#define SDD_DMC_CH_DMA_STAT(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_CH_ADR + 0x0010))	/* CDMIO_CHnSTAT        :DMA ch0-8 Xe[^X */
#define SDD_DMC_CH_DMA_RQ(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_CH_ADR + 0x0014))	/* CDMIO_CHnIR          :DMA ch0-8 ݗv */
#define SDD_DMC_CH_DMA_EN(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_CH_ADR + 0x0018))	/* CDMIO_CHnIE          :DMA ch0-8 ݋ */
#define SDD_DMC_CH_DMA_DT(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_CH_ADR + 0x001C))	/* CDMIO_CHnID          :DMA ch0-8 ݌o */
#define SDD_DMC_CH_DMA_SRCMD(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_CH_ADR + 0x0020))	/* CDMIO_CHnSRCAMODE    :DMA ch0-8 DMA`ln̓][hݒ */
#define SDD_DMC_CH_DMA_DSTMD(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_CH_ADR + 0x0024))	/* CDMIO_CHnDSTSTRTADRS :DMA ch0-8 DMA`ln̓]惂[hݒ */
#define SDD_DMC_CH_DMA_SRCAD(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_CH_ADR + 0x0028))	/* CDMIO_CHnSRCSTRTADRS :DMA ch0-8 DMA`ln̓]AhXݒ */
#define SDD_DMC_CH_DMA_DSTAD(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_CH_ADR + 0x002C))	/* CDMIO_CHnDSTSTRTADRS :DMA ch0-8 DMA`ln̓]AhXݒ */
#define SDD_DMC_CH_DATASIZ(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_CH_ADR + 0x0030))	/* CDMIO_CHnSIZE        :DMA ch0-8 ]g[^TCYݒ */
#define SDD_DMC_CH_BUF_STAD(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_RNG_ADR + 0x0000))	/* CDMIO_RBnBGNADRS     :DMA ch0-8 DMA`lñOobt@̈擪AhXݒ */
#define SDD_DMC_CH_BUF_EDAD(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_RNG_ADR + 0x0004))	/* CDMIO_RBnENDADR      :DMA ch0-8 DMA`lñOobt@̈ŏIAhXݒ */
#define SDD_DMC_CH_BUF_RDPT(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_RNG_ADR + 0x0020))	/* CDMIO_RBnRDTR        :DMA ch0-8 DMA`lñOobt@ǂݏoJnAhX */
#define SDD_DMC_CH_BUF_WRPT(a)		(*(volatile unsigned long *)(SDD_DMA_BASE[a] + SDD_DMA_RNG_ADR + 0x0028))	/* CDMIO_RBnWRPTR       :DMA ch0-8 DMA`lñOobt@݊JnAhX */

/* SDD_DMC_DMA_START */
#define SDD_DMC_DMA_START_REQ			(0x00000001 << SDD_DMA_CH)	/* DMA CHnv 0:Jn 1:~ */
#define SDD_DMC_DMA_START_STP			(0x80000000)				/* DMAv~ 1:~ */
#define SDD_DMC_DMA_START_STA			(0x00000000)				/* DMAv~ 0:Jn */
#define SDD_DMC_DMA_START_MASK			(SDD_DMC_DMA_START_REQ | SDD_DMC_DMA_START_STP)

/* SDD_DMC_DMA_RESET */
#define SDD_DMC_DMA_RESET_CH			(0x00010101 << SDD_DMA_CH)	/* DMA CHn ʃZbg */
#define SDD_DMC_DMA_RESET_ON			(0x80000000)

/* SDD_DMC_CH_DMA_SRCMD */
#define SDD_DMC_CH_DMA_SRCMD_END		(0x00030000)		/* Specifies source endian */
#define SDD_DMC_CH_DMA_SRCMD_END_OFF	(0x00000000)		/*  Little-Endian (D3, D2, D1, D0) */
#define SDD_DMC_CH_DMA_SRCMD_END_ON		(0x00010000)		/*  32-bit Big-Endian (D0, D1, D2, D3) */
#define SDD_DMC_CH_DMA_SRCMD_RS			(0x00000F00)		/* Indicate ring buffer resource number of source */
#define SDD_DMC_CH_DMA_SRCMD_RS_CH		(0x00000100 * SDD_DMA_CH)
#define SDD_DMC_CH_DMA_SRCMD_AUP		(0x00000030)		/* Specify addres update method */
#define SDD_DMC_CH_DMA_SRCMD_AUP_INC	(0x00000000)		/*  Increment */
#define SDD_DMC_CH_DMA_SRCMD_AUP_FIX	(0x00000020)		/*  Fixed */
#define SDD_DMC_CH_DMA_SRCMD_TYPE		(0x0000000C)		/* Specifies source type */
#define SDD_DMC_CH_DMA_SRCMD_TYPE_MEM	(0x00000000)		/*  Normal memoryiincludes address-mapped registerj */
#define SDD_DMC_CH_DMA_SRCMD_TYPE_RNG	(0x00000004)		/*  Ring buffer */
#define SDD_DMC_CH_DMA_SRCMD_TYPE_REG	(0x00000008)		/*  Source data registeriDMAC-embedded registerj */

/* SDD_DMC_CH_DMA_DSTCMD */
#define SDD_DMC_CH_DMA_DSTMD_END		(0x00030000)		/* Specifies destination endian */
#define SDD_DMC_CH_DMA_DSTMD_END_OFF	(0x00000000)		/*  Little-Endian (D3, D2, D1, D0) */
#define SDD_DMC_CH_DMA_DSTMD_END_ON		(0x00010000)		/*  32-bit Big-Endian (D0, D1, D2, D3) */
#define SDD_DMC_CH_DMA_DSTMD_RS			(0x00000F00)		/* Indicate ring buffer resource number of destination */
#define SDD_DMC_CH_DMA_DSTMD_RS_CH		(0x00000100 * SDD_DMA_CH)
#define SDD_DMC_CH_DMA_DSTMD_AUP		(0x00000030)		/* Specify addres update method */
#define SDD_DMC_CH_DMA_DSTMD_AUP_INC	(0x00000000)		/*  Increment */
#define SDD_DMC_CH_DMA_DSTMD_AUP_FIX	(0x00000020)		/*  Fixed */
#define SDD_DMC_CH_DMA_DSTMD_TYPE		(0x00000004)		/* Specifies destination type */
#define SDD_DMC_CH_DMA_DSTMD_TYPE_MEM	(0x00000000)		/*  Normal memoryiincludes address-mapped registerj */
#define SDD_DMC_CH_DMA_DSTMD_TYPE_RNG	(0x00000004)		/*  Ring buffer */

/* SDD_DMC_CH_DMA_STAT */
#define SDD_DMC_CH_DMA_STAT_CMD			(0x00000001)		/* Command done : Command done or abort transfer */
#define SDD_DMC_CH_DMA_STAT_WR			(0x00000002)		/* Write done : Write done of abort transfer */
#define SDD_DMC_CH_DMA_STAT_STA			(0x00000010)		/* Transfer start : Other tha stop staus */

#endif /* defined(_SDD_PEAKS_PRO2_) */
