/********************************************************************************/
/*  t@C    F$Workfile: SddCommand_secure.c $                            */
/*  Tv          FSDfoCXhCoF،nR}h֘At@C            */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 06/06/12 15:25 $                                  */
/*                  MDKIOǉ 2006/10/13 H.Miura                        */
/********************************************************************************/
/* SddCom.h́ASddConfig.hǂݍފ֌WAifdef`̊OŌĂ΂ */
#include "SddCom.h"
#ifdef _SDD_FUNC_SECURE_
#include "SddRegister.h"
#include "SddOsEvent.h"
#include "SddRegister_secure.h"
#ifdef _SDD_SDCARDINOUT_KENSHO_
#include "SddCardInOut.h"
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

static void Sdds_SelectMdk_before(SDD_HANDLE *p_SddHandle);
/********************************************************************************/
/*  ֐		FSdds_SecureEraseSub											*/
/*  Tv		FFؗ̈													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SecureEraseSub(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uw_Wp;
    SDD_COMMAND_DATA scdData;

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle,WAIT_SECUREERASESUB );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

	/*==========================================================*/
	/* Sdds_GetWP𔭍s,Write Protect̃`FbN 				*/
	/*   SDD_SUCCESSȊOȂ,Sdds_SetErrR[ă^[	*/
	/*==========================================================*/
	Sdds_GetWP(p_SddHandle, SDD_WP_ALL, TRUE, &uw_Wp);
	if(uw_Wp) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_WP);
		return w_Result;
	}

	/*===============================================*/
	/* SDD_CMD_SECUREERASER}hs(ACMD38)       */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_SECUREERASE, 0, 0, &scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetREndTimeOut(Sdds_Get_EraseTm(p_SddHandle, p_sdd->uw_SecureRwSector),&scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS ) {
		p_sdd->Result.uw_Resid = 0;
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	else{
		p_sdd->Result.uw_Resid = p_sdd->uw_SecureRwSector;
	}
	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_GetMID													*/
/*  Tv		FMID擾														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_GetMID(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;
#ifndef _SDD_ANGOU_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#endif

	/*===============================================*/
	/* SDD_CMD_GETMIDR}hs(ACMD44)            */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_GETMID, 0, 0, &scdData);
    Sdds_SetTypeCheckR1(&scdData);
#ifndef _SDD_ANGOU_
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetBuffAddress(p_sdd->ub_MID, &scdData);
    Sdds_SetBlockSize(SDD_MID_SIZE, &scdData);
#endif
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*==============================================*/
	/* CMD13𔭍săJ[hXe[^X擾	*/
	/*==============================================*/
	w_ResTmp = Sdds_GetCardStatus(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetR1													*/
/*  Tv		F(R1)̑o												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FȂ															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetR1(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;
#ifndef _SDD_ANGOU_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#endif

	/*===============================================*/
	/* SDD_CMD_SETCERRN1R}hs(ACMD45)         */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_SETCERRN1, 0, 0, &scdData);
    Sdds_SetTypeCheckR1(&scdData);
#ifndef _SDD_ANGOU_
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetBuffAddress(p_sdd->ub_RN1, &scdData);
    Sdds_SetBlockSize(SDD_RN1_SIZE, &scdData);
    Sdds_SetTypeWrite(&scdData);
#endif
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*==============================================*/
	/* CMD13𔭍săJ[hXe[^X擾	*/
	/*==============================================*/
	w_ResTmp = Sdds_GetCardStatus(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_GetR2													*/
/*  Tv		F(R2)̎擾												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_GetR2(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;
#ifndef _SDD_ANGOU_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#endif

	/*===============================================*/
	/* SDD_CMD_GETCERRN2R}hs(ACMD46)         */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_GETCERRN2, 0, 0, &scdData);
    Sdds_SetTypeCheckR1(&scdData);
#ifndef _SDD_ANGOU_
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetBuffAddress(p_sdd->ub_RN2, &scdData);
    Sdds_SetBlockSize(SDD_RN2_SIZE, &scdData);
#endif
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*==============================================*/
	/* CMD13𔭍săJ[hXe[^X擾	*/
	/*==============================================*/
	w_ResTmp = Sdds_GetCardStatus(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetRes2													*/
/*  Tv		F(RES2)̑o												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetRes2(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;
#ifndef _SDD_ANGOU_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#endif

	/*===============================================*/
	/* SDD_CMD_SETCERRES2R}hs(ACMD47)        */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_SETCERRES2, 0, 0, &scdData);
    Sdds_SetTypeCheckR1(&scdData);
#ifndef _SDD_ANGOU_
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetBuffAddress(p_sdd->ub_RES2, &scdData);
    Sdds_SetBlockSize(SDD_RES2_SIZE, &scdData);
    Sdds_SetTypeWrite(&scdData);
#endif
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*==============================================*/
	/* CMD13𔭍săJ[hXe[^X擾	*/
	/*==============================================*/
	w_ResTmp = Sdds_GetCardStatus(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_GetRes1													*/
/*  Tv		F(RES1)̎擾												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_GetRes1(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;
#ifndef _SDD_ANGOU_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#endif

	/*===============================================*/
	/* SDD_CMD_GETCERRES1R}hs(ACMD48)        */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_GETCERRES1, 0, 0, &scdData);
    Sdds_SetTypeCheckR1(&scdData);
#ifndef _SDD_ANGOU_
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetBuffAddress(p_sdd->ub_RES1, &scdData);
    Sdds_SetBlockSize(SDD_RES1_SIZE, &scdData);
#endif
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
#ifdef _SDD_ACMD48_1MSEC_WAIT_
    Sdd_Delay(SDD_ACMD48_WAIT);    
#endif /* _SDD_ACMD48_1MSEC_WAIT_ */

	/*==============================================*/
	/* CMD13𔭍săJ[hXe[^X擾	*/
	/*==============================================*/
	w_ResTmp = Sdds_GetCardStatus(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_SelectMdk												*/
/*  Tv		FMDKI														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB ub_Mdk(Master Keyԍ)										*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SelectMdk( SDD_HANDLE *p_SddHandle, UB ub_Mdk )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

    /* MDKIOǉ 2006/10/13 H.Miura */
    Sdds_SelectMdk_before(p_SddHandle);

	/*==================================*/
	/* WX^ݒ(Sddr_CCData0_Set)	*/
	/* CC_CDATA0Master Keyԍݒ	*/
	/*==================================*/
	Sddr_CCData0_Set( p_SddHandle, (UH)ub_Mdk );

	/*===============================================*/
	/* SDD_CMD_SEL_MDKR}hs(SCMD0)            */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_SEL_MDK, 0x0000, 0x0000, &scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetEncDk													*/
/*  Tv		FEncDkݒ														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH *puh_EncDk(ÍfoCXL[i[|C^)					*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetEncDk( SDD_HANDLE *p_SddHandle, UH *puh_EncDk )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*==============================================================*/
	/* WX^ݒ(Sddr_CCData3_Sets)							*/
	/*	FEncDKŏ2Byte(1,2Byteڂւ)			*/
	/*==============================================================*/
	Sddr_CCData3_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_EncDk) );
	puh_EncDk++;

	/*==============================================================*/
	/* WX^ݒ(Sddr_CCData2_Sets)							*/
	/*	FEncDKŏʂ3`4Byte(3,4Byteڂւ)	*/
	/*==============================================================*/
	Sddr_CCData2_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_EncDk) );
	puh_EncDk++;

	/*==============================================================*/
	/* WX^ݒ(Sddr_CCData1_Set)								*/
	/*	FEncDKŏʂ5`6Byte(5,6Byteڂւ)	*/
	/*==============================================================*/
	Sddr_CCData1_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_EncDk) );
	puh_EncDk++;

	/*==============================================================*/
	/* WX^ݒ(Sddr_CCData0_Set)								*/
	/*	FEncDKŏʂ7`8Byte(7,8Byteڂւ)	*/
	/*==============================================================*/
	Sddr_CCData0_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_EncDk) );

	/*===============================================*/
	/* SDD_CMD_SET_ENCDKR}hs(SCMD1)          */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_SET_ENCDK, 0x0000, 0x0000, &scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetCalcEncMk												*/
/*  Tv		FCalculate EncDkݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH *puh_CalcEncMk(Calculate EncMKi[|C^)				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetCalcEncMk( SDD_HANDLE *p_SddHandle, UH *puh_CalcEncMk )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*======================================================================*/
	/* WX^ݒ(Sddr_CCData3_Sets)									*/
	/*	FCalculate EncMKŏ2Byte(1,2Byteڂւ)			*/
	/*======================================================================*/
	Sddr_CCData3_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_CalcEncMk) );
	puh_CalcEncMk++;

	/*======================================================================*/
	/* WX^ݒ(Sddr_CCData2_Sets)									*/
	/*	FCalculate EncMKŏʂ3`4Byte(3,4Byteڂւ)*/
	/*======================================================================*/
	Sddr_CCData2_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_CalcEncMk) );
	puh_CalcEncMk++;

	/*======================================================================*/
	/* WX^ݒ(Sddr_CCData1_Set)										*/
	/*	FCalculate EncMKŏʂ5`6Byte(5,6Byteڂւ)*/
	/*======================================================================*/
	Sddr_CCData1_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_CalcEncMk) );
	puh_CalcEncMk++;

	/*======================================================================*/
	/* WX^ݒ(Sddr_CCData0_Set)										*/
	/*	FCalculate EncMKŏʂ7`8Byte(7,8Byteڂւ)*/
	/*======================================================================*/
	Sddr_CCData0_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_CalcEncMk) );

	/*===============================================*/
	/* SDD_CMD_SET_ENCMK_CALCR}hs(SCMD2)     */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_SET_ENCMK_CALC, 0x0000, 0x0000, &scdData );
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetCondEncMk												*/
/*  Tv		FConditionally EncMKݒ										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH *puh_CondMk(Conditionally EncMKi[|C^)				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetCondEncMk( SDD_HANDLE *p_SddHandle, UH *puh_CondMk )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*==========================================================================*/
	/* WX^ݒ(Sddr_CCData3_Sets)										*/
	/*	FConditionally EncMKŏ2Byte(1,2Byteڂւ)			*/
	/*==========================================================================*/
	Sddr_CCData3_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_CondMk) );
	puh_CondMk++;

	/*==========================================================================*/
	/* WX^ݒ(Sddr_CCData2_Sets)										*/
	/*	FConditionally EncMKŏʂ3`4Byte(3,4Byteڂւ)*/
	/*==========================================================================*/
	Sddr_CCData2_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_CondMk) );
	puh_CondMk++;

	/*==========================================================================*/
	/* WX^ݒ(Sddr_CCData1_Set)											*/
	/*	FConditionally EncMKŏʂ5`6Byte(5,6Byteڂւ)*/
	/*==========================================================================*/
	Sddr_CCData1_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_CondMk) );
	puh_CondMk++;

	/*==========================================================================*/
	/* WX^ݒ(Sddr_CCData0_Set)											*/
	/*	FConditionally EncMKŏʂ7`8Byte(7,8Byteڂւ)*/
	/*==========================================================================*/
	Sddr_CCData0_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_CondMk) );

	/*===============================================*/
	/* SDD_CMD_SET_ENCMK_CONDR}hs(SCMD3)     */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_SET_ENCMK_COND, 0x0000, 0x0000, &scdData );
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetDv													*/
/*  Tv		FDvݒ														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW *uw_Dv(Dvi[|C^)										*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetDv( SDD_HANDLE *p_SddHandle, UH *puh_Dv )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData3_Sets)						*/
	/*	FDvŏ2Byte(1,2Byteڂւ)			*/
	/*==========================================================*/
	Sddr_CCData3_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Dv) );
	puh_Dv++;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData2_Sets)						*/
	/*	FDvŏʂ3`4Byte(3,4Byteڂւ)	*/
	/*==========================================================*/
	Sddr_CCData2_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Dv) );
	puh_Dv++;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData1_Set)							*/
	/*	FDvŏʂ5`6Byte(5,6Byteڂւ)	*/
	/*==========================================================*/
	Sddr_CCData1_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Dv) );
	puh_Dv++;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData0_Set)							*/
	/*	FDvŏʂ7`8Byte(7,8Byteڂւ)	*/
	/*==========================================================*/
	Sddr_CCData0_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Dv) );

	/*===============================================*/
	/* SDD_CMD_SET_DVR}hs(SCMD4)             */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_SET_DV, 0x0000, 0x0000, &scdData );
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetDce													*/
/*  Tv		FDceݒ														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH *puh_Dce(Dcei[|C^)									*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetDce( SDD_HANDLE *p_SddHandle, UH *puh_Dce )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData3_Sets)						*/
	/*	FDceŏ2Byte(1,2Byteڂւ)			*/
	/*==========================================================*/
	Sddr_CCData3_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Dce) );
	puh_Dce++;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData2_Sets)						*/
	/*	FDceŏʂ3`4Byte(3,4Byteڂւ)*/
	/*==========================================================*/
	Sddr_CCData2_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Dce) );
	puh_Dce++;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData1_Set)							*/
	/*	FDceŏʂ5`6Byte(5,6Byteڂւ)*/
	/*==========================================================*/
	Sddr_CCData1_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Dce) );
	puh_Dce++;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData0_Set)							*/
	/*	FDceŏʂ7`8Byte(7,8Byteڂւ)*/
	/*==========================================================*/
	Sddr_CCData0_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Dce) );

	/*===============================================*/
	/* SDD_CMD_SET_DCER}hs(SCMD5)            */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_SET_DCE, 0x0000, 0x0000, &scdData );
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetSDP													*/
/*  Tv		FV[hp^[ݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH *puh_Sdp(V[hp^[i[|C^)						*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetSDP( SDD_HANDLE *p_SddHandle, UH *puh_Sdp )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*======================================================================*/
	/* WX^ݒ(Sddr_CCData3_Sets)									*/
	/*	FV[hp^[ŏ2Byte(1,2Byteڂւ)			*/
	/*======================================================================*/
	Sddr_CCData3_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Sdp) );
	puh_Sdp++;

	/*======================================================================*/
	/* WX^ݒ(Sddr_CCData2_Sets)									*/
	/*	FV[hp^[ŏʂ3`4Byte(3,4Byteڂւ)	*/
	/*======================================================================*/
	Sddr_CCData2_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Sdp) );
	puh_Sdp++;

	/*======================================================================*/
	/* WX^ݒ(Sddr_CCData1_Set)										*/
	/*	FV[hp^[ŏʂ5`6Byte(5,6Byteڂւ)	*/
	/*======================================================================*/
	Sddr_CCData1_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Sdp) );
	puh_Sdp++;

	/*======================================================================*/
	/* WX^ݒ(Sddr_CCData0_Set)										*/
	/*	FV[hp^[ŏʂ7`8Byte(7,8Byteڂւ)	*/
	/*======================================================================*/
	Sddr_CCData0_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Sdp) );

	/*===============================================*/
	/* SDD_CMD_SET_SDPR}hs(SCMD6)            */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_SET_SDP, 0x0000, 0x0000, &scdData );
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_GetNextSDP												*/
/*  Tv		FV[hp^[擾											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW *uw_NxtSdp(V[hp^[i[|C^)					*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_GetNextSDP( SDD_HANDLE *p_SddHandle, UH *puh_NxtSdp )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UH uh_GetSDP;
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_GET_NEXTSDPR}hs(SCMD7)        */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_GET_NEXTSDP, 0x0000, 0x0000, &scdData );
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
		return w_Result;
	}

	/*==============================================*/
	/* WX^l擾(Sddr_CCOsr3_Gets)	*/
	/*	F擾V[hp^[(ϐ)	*/
	/*==============================================*/
	Sddr_CCOsr3_Get( p_SddHandle, &uh_GetSDP );

	/*======================================================================*/
	/* GfBAϊ														*/
	/*	擾V[hp^[̑O1ByteւA̍ŏ2Byteɐݒ*/
	/*======================================================================*/
	*puh_NxtSdp = SDD_M_SWAPBYTE( uh_GetSDP );
	puh_NxtSdp++;

	/*==============================================*/
	/* WX^l擾(Sddr_CCOsr2_Gets)	*/
	/*	F擾V[hp^[(ϐ)	*/
	/*==============================================*/
	Sddr_CCOsr2_Get( p_SddHandle, &uh_GetSDP );

	/*==================================================================================*/
	/* GfBAϊ																	*/
	/*	擾V[hp^[̑O1ByteւA̍ŏʂ3`4Byteڂɐݒ	*/
	/*==================================================================================*/
	*puh_NxtSdp = SDD_M_SWAPBYTE( uh_GetSDP );
	puh_NxtSdp++;

	/*==============================================*/
	/* WX^l擾(Sddr_CCOsr1_Gets)	*/
	/*	F擾V[hp^[(ϐ)	*/
	/*==============================================*/
	Sddr_CCOsr1_Get( p_SddHandle, &uh_GetSDP );

	/*==================================================================================*/
	/* GfBAϊ																	*/
	/*	擾V[hp^[̑O1ByteւA̍ŏʂ5`6Byteڂɐݒ	*/
	/*==================================================================================*/
	*puh_NxtSdp = SDD_M_SWAPBYTE( uh_GetSDP );
	puh_NxtSdp++;

	/*==============================================*/
	/* WX^l擾(Sddr_CCOsr0_Gets)	*/
	/*	F擾V[hp^[(ϐ)	*/
	/*==============================================*/
	Sddr_CCOsr0_Get( p_SddHandle, &uh_GetSDP );

	/*==================================================================================*/
	/* GfBAϊ																	*/
	/*	擾V[hp^[̑O1ByteւA̍ŏʂ7`8Byteڂɐݒ	*/
	/*==================================================================================*/
	*puh_NxtSdp = SDD_M_SWAPBYTE( uh_GetSDP );

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_GoNextAke												*/
/*  Tv		FĔF؊Jn													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FȂ															*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_GoNextAke( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_GO_NEXTAKER}hs(SCMD8)         */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_GO_NEXTAKE, 0x0000, 0x0000, &scdData );
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetRWArg													*/
/*  Tv		FFR/W Argumentݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_Arg(FR/W Argument)									*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetRWArg( SDD_HANDLE *p_SddHandle, UW uw_Arg )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*==================================================================*/
	/* WX^ݒ(Sddr_CCData2_Sets)								*/
	/*	FArgument2Byte											*/
	/*==================================================================*/
	Sddr_CCData2_Set( p_SddHandle, (((LELONG *)&uw_Arg)->dt2word.low) );

	/*==================================================================*/
	/* WX^ݒ(Sddr_CCData3_Sets)								*/
	/*	FArgumentʂ2Byte										*/
	/*==================================================================*/
	Sddr_CCData3_Set( p_SddHandle, (((LELONG *)&uw_Arg)->dt2word.high) );

	/*===============================================*/
	/* SDD_CMD_SET_RW_ARGR}hs(SCMD9)         */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_SET_RW_ARG, 0x0000, 0x0000, &scdData );
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_KruSet													*/
/*  Tv		FKRUݒ														*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH *puh_Kru(R[_j[NL[i[|C^)					*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_KruSet( SDD_HANDLE *p_SddHandle, UH *puh_Kru )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData3_Sets)						*/
	/*	FKruŏ2Byte(1,2Byteڂւ)			*/
	/*==========================================================*/
	Sddr_CCData3_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Kru) );
	puh_Kru++;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData2_Sets)						*/
	/*	FKruŏʂ3`4Byte(3,4Byteڂւ)*/
	/*==========================================================*/
	Sddr_CCData2_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Kru) );
	puh_Kru++;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData1_Set)							*/
	/*	FKruŏʂ5`6Byte(5,6Byteڂւ)*/
	/*==========================================================*/
	Sddr_CCData1_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Kru) );
	puh_Kru++;

	/*==========================================================*/
	/* WX^ݒ(Sddr_CCData0_Set)							*/
	/*	FKruŏʂ7`8Byte(7,8Byteڂւ)*/
	/*==========================================================*/
	Sddr_CCData0_Set( p_SddHandle, SDD_M_SWAPBYTE(*puh_Kru) );

	/*===============================================*/
	/* SDD_CMD_SET_KRUR}hs(SCMD10)           */
	/*===============================================*/
    Sdds_SetCommandDefault( SDD_CMD_SET_KRU, 0x0000, 0x0000, &scdData );
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if( w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_MkbReadSub												*/
/*  Tv		FMKBǂݏo													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB ub_MKBId:MKB_ID											*/
/*                UB *pub_Buff:MKBi[obt@									*/
/*                UW uw_Count:ǂݏoZN^									*/
/*                UW uw_Offset:MKBǂݍ݊JnItZbg						*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sdds_MkbReadSub(SDD_HANDLE *p_SddHandle, UB ub_MKBId, UB *pub_Buff, UW uw_Count, UW uw_Offset)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UB ub_RetryCount = 0;	/* gC{ */
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_MKBREADSUB );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

	/*======================================================*/
	/*	gC[vJn									*/
	/*	ŏ̏ꍇ̂݃gCJE^NA				*/
	/*	gCJE^gCݒlɂȂ܂ŌJԂ	*/
	/*	gCJE^̓wb_t@CŒ`				*/
	/*======================================================*/
	while(ub_RetryCount <= SDD_RETRY_MAX) {
		do{
			/*======================================================*/
			/* SDD_DEV\̂̏ʏ̏ZN^	*/
			/*======================================================*/
			p_sdd->Result.uw_Resid = 0;

			/*======================================================*/
			/* SDD_DEV\̂DMA]Ɉȉ̒lݒ			*/
			/*  DMA]AhXFSD_BUF							*/
			/*  DMA]AhXFMKBi[AhX			*/
			/*  DMAJgTCYF0								*/
			/*  DMAcTCYFuw_Count							*/
			/*======================================================*/
			p_sdd->DmaInfo.uw_RestSec = uw_Count;
			p_sdd->DmaInfo.uw_DMADstAddr = (UW)pub_Buff;
			p_sdd->DmaInfo.uw_DMASrcAddr = (UW)&SDD_SD_BUF(Sdd_M_GetPortNum(p_SddHandle->ub_Port));
			p_sdd->DmaInfo.uw_DMASize = 0;

			/*======================================================*/
			/* SDD_DEV\̂̃ItZbg,JgItZbgݒ */
			/*======================================================*/
			p_sdd->uw_Offset = uw_Offset;

			/*======================================================================*/
			/* Sdds_SendGetMkbCMDMulti𔭍s,ȉ̏s						*/
			/*   f[^]OSDI/Feݒ											*/
			/*   荞݋֎~														*/
			/*   G[NA														*/
			/*   CMD12sݒ													*/
			/*   荞݋														*/
			/*   CBUSY҂														*/
			/*   ARGݒiReadJnoffsetݒ,MKB_ID)								*/
			/*   R}hiACMD43)s												*/
			/*   X|XorG[M҂											*/
			/*   X|XG[`FbN											*/
			/*      1)߂lIiSUCCESSj̏ꍇ,p					*/
			/*      2)߂lG[̏ꍇ̂,ȉ̃G[{				*/
			/*        2.1)CPUDMAC荞݋֎~										*/
			/*        2.2)CPUDMA荞݃NA								*/
			/*        2.3)SDD_DEV\̂̓]ZN^NA					*/
			/*        2.4)Sdds_SetErrR[,G[lۑ						*/
			/*======================================================================*/
			w_ResTmp = Sdds_SendGetMkbCMDMulti(p_SddHandle, ub_MKBId, uw_Count, uw_Offset, FALSE, pub_Buff);
			if(w_ResTmp != SDD_SUCCESS) {
				break;
			}
			/*==========================================================*/
			/* ]Ɋꍇ̓gC[v𔲂			*/
			/* G[̓gCJE^CNg			*/
			/*==========================================================*/
   			if(w_ResTmp == SDD_SUCCESS) {
				p_sdd->Result.uw_Resid += uw_Count;
			}
			break;

		} while(0);		/* G[֕򂳂邽߂do-while */
		
		/*==============================================================*/
		/* Tu֐̏ʂȊȌꍇ,ȉ̃G[{	*/
		/* 1)CPUDMAC荞݋֎~										*/
		/* 2)CPUDMA荞݃NA									*/
		/* 3)SDD_DEV\̂̓]ZN^NA					*/
		/* 4)Sdds_SetErrR[,G[lۑ							*/
		/* 5)gCJE^+1,gC[v̐擪֖߂			*/
		/* Tu֐̏ʂ̏ꍇ,gC[v甲		*/
		/*==============================================================*/
		/*
			]ɊꍇOS^CAEgJ[h̓gC[v𔲂
			(p_sdd->w_errorIP甭G[݂̂AOS^CAEgJ[h͔fȂ)
		@ 	ȊÕG[̓gCJE^CNg 
		*/ 
		if ((w_ResTmp == SDD_SUCCESS) || Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_CARD_OUT) 
				|| Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_OS_TIMEOUT)) {
				break;  
		} else {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			p_sdd->Result.uw_Resid = 0;
			ub_RetryCount++;
			Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_SD);	/* SD-IPSDRSTZbg */
            if ((w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_ENABLE)) != SDD_SUCCESS) {		/* ZbgŒ~ꂽSDCLKďo */
                w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
            }
			continue;
		}

	/*==========================*/
	/*	gC[vEnd		*/
	/*==========================*/
	}

	/* SDCLK~nOAbvh~΍ */
	if ((Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_CARD_OUT)) 
			|| (Sdds_CheckErr(p_SddHandle, w_Result, SDD_ERR_OS_TIMEOUT))) 
	{
		Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_SD);	/* SD-IPSDRSTZbg */
	}

	return	w_Result;
}
#endif	/* _SDD_FUNC_SECURE_ */
