/********************************************************************************/
/*  t@C    F$Workfile: SddRegister_c2.c $                               */
/*  Tv          FSDfoCXhCoC2WX^ANZXiwjt@C      */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.         */
/*  ŏIXV    F$Modtime: 06/06/12 13:20 $                                  */
/********************************************************************************/
/* SddCom.h́ASddConfig.hǂݍފ֌WAifdef`̊OŌĂ΂ */
#include "SddCom.h"
#ifdef _SDD_FUNC_SECURE_
#include "SddRegister.h"
#include "SddRegister_secure.h"

/* Tu֐t@C */
#ifdef _SDD_JUPITER_
#include "device/SddRegister_secure_for_jupiter.c"
#endif	/* _SDD_JUPITER_ */

static void Sddr_CcClkdivSet(SDD_HANDLE *p_SddHandle, UW uw_ccclkdiv);
static void Sddr_CCData3_Set( SDD_HANDLE *p_SddHandle, UH uh_Data );
static void Sddr_CCData2_Set( SDD_HANDLE *p_SddHandle, UH uh_Data );
static void Sddr_CCData1_Set( SDD_HANDLE *p_SddHandle, UH uh_Data );
static void Sddr_CCData0_Set( SDD_HANDLE *p_SddHandle, UH uh_Data );
static void Sddr_CClkEna(SDD_HANDLE *p_SddHandle, BOOL bl_ccclk);
static void Sddr_CCOsr3_Get( SDD_HANDLE *p_SddHandle, UH *uh_Data );
static void Sddr_CCOsr2_Get( SDD_HANDLE *p_SddHandle, UH *uh_Data );
static void Sddr_CCOsr1_Get( SDD_HANDLE *p_SddHandle, UH *uh_Data );
static void Sddr_CCOsr0_Get( SDD_HANDLE *p_SddHandle, UH *uh_Data );
static void Sddr_CheckAuthCheck(SDD_HANDLE *p_SddHandle, UB ub_stage, BOOL *bl_result);
static void Sddr_GetColumn( SDD_HANDLE *p_SddHandle, UH *uh_Column );
static void Sddr_Kmuselect(SDD_HANDLE *p_SddHandle, UB ub_ksel);
static void Sddr_MKBselect(SDD_HANDLE *p_SddHandle, BOOL bl_mkbsel);
static void Sddr_SetMKBmode(SDD_HANDLE *p_SddHandle, BOOL bl_oore);
static SDD_ERROR Sddr_GetKmuMkb( SDD_HANDLE *p_SddHandle, UB *pub_kmu);

/********************************************************************************/
/*  ֐		FSddr_CcClkdivSet												*/
/*  Tv		FCC CLK ݒ												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F																*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CcClkdivSet(SDD_HANDLE *p_SddHandle, UW uw_ccclkdiv)
{
#ifndef _SDD_SPEED_KENSHO_CLK_MIN_
	/*===================================================*/
	/* ̒lɉ,CC_CLKDIVWX^CDIV0-7ݒ */
	/*===================================================*/
	switch(uw_ccclkdiv){
		case	SDD_CLOCK_DIV_2 :		/* 2 */
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV2);
			break;
		case	SDD_CLOCK_DIV_4 :		/* 4 */
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV4);
			break;
		case	SDD_CLOCK_DIV_8 :		/* 8 */
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV8);
			break;
		case	SDD_CLOCK_DIV_16 :		/* 16 */
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV16);
			break;
		case	SDD_CLOCK_DIV_32 :		/* 32 */
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV32);
			break;
		case	SDD_CLOCK_DIV_64 :		/* 64 */
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV64);
			break;
		case	SDD_CLOCK_DIV_128 :		/* 128 */
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV128);
			break;
		case	SDD_CLOCK_DIV_256 :		/* 256 */
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV256);
			break;
		case	SDD_CLOCK_DIV_512 :		/* 512 */
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV512);
			break;
		default :
			Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV2);
			break;
	}
#else
    /* x(NbNŒᓮeXgj̓NbNŒɐݒ肷 */
    Sdd_M_SetReg(SDD_CC_CLKDIV(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_CLKDIV_DIV512);
#endif /* _SDD_SPEED_KENSHO_CLK_MIN_ */
	return;
}


/********************************************************************************/
/*  ֐		FSddr_CCData3_Set												*/
/*  Tv		FCC_CDATA3WX^ݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		Fݒf[^													*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CCData3_Set( SDD_HANDLE *p_SddHandle, UH uh_Data )
{
	/*==========================================================*/
	/* ̒lɉāACC_CDATA3WX^ݒ				*/
	/*==========================================================*/
	Sdd_M_SetReg(SDD_CC_CDATA3(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Data);

	return;
}


/********************************************************************************/
/*  ֐		FSddr_CCData2_Set												*/
/*  Tv		FCC_CDATA3WX^ݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		Fݒf[^													*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CCData2_Set( SDD_HANDLE *p_SddHandle, UH uh_Data )
{
	/*==========================================================*/
	/* ̒lɉāACC_CDATA2WX^ݒ				*/
	/*==========================================================*/
	Sdd_M_SetReg( SDD_CC_CDATA2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Data );

	return;
}


/********************************************************************************/
/*  ֐		FSddr_CCData1_Set												*/
/*  Tv		FCC_CDATA1WX^ݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		Fݒf[^													*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CCData1_Set( SDD_HANDLE *p_SddHandle, UH uh_Data )
{
	/*==========================================================*/
	/* ̒lɉāACC_CDATA1WX^ݒ				*/
	/*==========================================================*/
	Sdd_M_SetReg( SDD_CC_CDATA1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Data );

	return;
}


/********************************************************************************/
/*  ֐		FSddr_CCData0_Set												*/
/*  Tv		FCC_CDATA0WX^ݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		Fݒf[^													*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CCData0_Set( SDD_HANDLE *p_SddHandle, UH uh_Data )
{
	/*==========================================================*/
	/* ̒lɉāACC_CDATA0WX^ݒ				*/
	/*==========================================================*/
	Sdd_M_SetReg( SDD_CC_CDATA0(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_Data );

	return;
}

/********************************************************************************/
/*  ֐		FSddr_CClkEna													*/
/*  Tv		FCC CLK ON/OFF													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FBOOL ON:CLK ON,OFF:CLK OFF									*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CClkEna(SDD_HANDLE *p_SddHandle, BOOL bl_ccclk)
{
	UH uh_Sdd_cclken = 0;		/* _~[|[g */
	/*======================================================*/
	/* ̂ONȂ,_~[|[gɃNbNONݒ		*/
	/* ̂OFFȂ,_~[|[gɃNbNOFFݒ	*/
	/*======================================================*/
	if (bl_ccclk){
		uh_Sdd_cclken |= SDD_CC_SECURECLKEN;
	}else{
		uh_Sdd_cclken &= ~SDD_CC_SECURECLKEN;
	}

	return;
}

/********************************************************************************/
/*  ֐		FSddr_CCOsr3_Get												*/
/*  Tv		FCC_COSR3WX^擾											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F擾f[^i[̈|C^									*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CCOsr3_Get( SDD_HANDLE *p_SddHandle, UH *uh_Data )
{
	/*==============================*/
	/* CC_COSR3WX^l擾 */
	/*==============================*/
	Sdd_M_GetReg( SDD_CC_OSR3(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), *uh_Data );

	return;
}


/********************************************************************************/
/*  ֐		FSddr_CCOsr2_Get												*/
/*  Tv		FCC_COSR2WX^擾											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F擾f[^i[̈|C^									*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CCOsr2_Get( SDD_HANDLE *p_SddHandle, UH *uh_Data )
{
	/*==============================*/
	/* CC_COSR2WX^l擾 */
	/*==============================*/
	Sdd_M_GetReg( SDD_CC_OSR2(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), *uh_Data );

	return;
}


/********************************************************************************/
/*  ֐		FSddr_CCOsr1_Get												*/
/*  Tv		FCC_COSR1WX^擾											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F擾f[^i[̈|C^									*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CCOsr1_Get( SDD_HANDLE *p_SddHandle, UH *uh_Data )
{
	/*==============================*/
	/* CC_COSR1WX^l擾 */
	/*==============================*/
	Sdd_M_GetReg( SDD_CC_OSR1(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), *uh_Data );

	return;
}


/********************************************************************************/
/*  ֐		FSddr_CCOsr0_Get												*/
/*  Tv		FCC_COSR0WX^擾											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F擾f[^i[̈|C^									*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CCOsr0_Get( SDD_HANDLE *p_SddHandle, UH *uh_Data )
{
	/*==============================*/
	/* CC_COSR0WX^l擾 */
	/*==============================*/
	Sdd_M_GetReg( SDD_CC_OSR0(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), *uh_Data );

	return;
}

/********************************************************************************/
/*  ֐		FSddr_CheckAuthCheck											*/
/*  Tv		FF؃Xe[W`FbN											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FXe[W`FbNʊi[|C^								*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_CheckAuthCheck(SDD_HANDLE *p_SddHandle, UB ub_stage, BOOL *bl_result)
{
	UH	uh_stagebit = 0;	/* rbgp^[ */

	/*==============================================================*/
	/* ̃Xe[Wԍ1stStagȅꍇ 							*/
	/*  CSTAT0CSTAT1ȊO}XNrbgp^[ݒ			*/
	/* ̃Xe[Wԍ2ndStagȅꍇ 							*/
	/*  CSTAT2CSTAT3ȊO}XNrbgp^[ݒ			*/
	/* ̃Xe[Wԍ3rdStagȅꍇ 							*/
	/*  CSTAT4CSTAT5ȊO}XNrbgp^[ݒ			*/
	/*==============================================================*/
	switch(ub_stage){
		case	SDD_1ST_STAGE :
			uh_stagebit = SDD_CC_STATUS_1ST;
			break;
		case	SDD_2ND_STAGE :
			uh_stagebit = SDD_CC_STATUS_2ND;
			break;
		case	SDD_3RD_STAGE :
			uh_stagebit = SDD_CC_STATUS_3RD;
			break;
		default :
			*bl_result = SDD_FALSE;
			return;
	}

	/*==============================================================*/
	/* CC_STATUS̒l擾,̃rbgp^[Ń}XN				*/
	/* }XNʂ0̏ꍇ,̃`FbNʂSDD_TRUEi[	*/
	/* ȊȌꍇ,̃`FbNʂSDD_FALSEi[			*/
	/*==============================================================*/
	if(Sdd_M_CheckReg(SDD_CC_STATUS(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uh_stagebit)){
		*bl_result = SDD_FALSE;
	}else{
		*bl_result = SDD_TRUE;
	}

	return;
}

/********************************************************************************/
/*  ֐		FSddr_GetColumn												*/
/*  Tv		FCC_COLUMNWX^ݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F擾f[^i[̈|C^									*/
/*  ߂l		F															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_GetColumn( SDD_HANDLE *p_SddHandle, UH *uh_Column )
{
	/*==================================*/
	/* CC_COLUMNWX^l擾	*/
	/*==================================*/
	Sdd_M_GetReg( SDD_CC_COLUMN(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), *uh_Column );

	return;
}

/********************************************************************************/
/*  ֐		FSddr_Kmuselect												*/
/*  Tv		FKMUIrbgݒ												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB ub_ksel 													*/
/*                0:KmuA,1:kmuB													*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_Kmuselect(SDD_HANDLE *p_SddHandle, UB ub_ksel)
{
	/*==============================================*/
	/* CC_SWITCHKSELɈ̃rbgݒ			*/
	/*==============================================*/

	switch(ub_ksel){
		case	SDD_KMU_A :
			Sdd_M_AndReg(SDD_CC_SWITCH(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_CC_SWITCH_KSEL);
			break;
		case	SDD_KMU_B :
			Sdd_M_OrReg(SDD_CC_SWITCH(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_SWITCH_KSEL);
			break;
		default :
			break;
	}

	return ;
}

/********************************************************************************/
/*  ֐		FSddr_MKBselect												*/
/*  Tv		FMKBXbgI												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FBOOL bl_mkbsel 												*/
/*                0:MKB(Default),1:MKB1											*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_MKBselect(SDD_HANDLE *p_SddHandle, BOOL bl_mkbsel)
{
	/*==============================================*/
	/* CC_MKBmkbselɈ̃rbgݒ			*/
	/*==============================================*/
	if(bl_mkbsel == SDD_TRUE){
		Sdd_M_OrReg(SDD_CC_MKB(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_MKB_MSEL);
	}else{
		Sdd_M_AndReg(SDD_CC_MKB(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_CC_MKB_MSEL);
	}

	return;
}

/********************************************************************************/
/*  ֐		FSddr_SetMKBmode												*/
/*  Tv		FMKB[hrbgݒ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FBOOL bl_oore 													*/
/*                0:IWiMKB,1:gMKB										*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sddr_SetMKBmode(SDD_HANDLE *p_SddHandle, BOOL bl_oore)
{
	/*==========================================*/
	/* CC_MKBooreɈ̃rbgݒ			*/
	/*==========================================*/
	if(bl_oore == SDD_TRUE){
		Sdd_M_OrReg(SDD_CC_MKB(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_CC_MKB_OORE);
	}else{
		Sdd_M_AndReg(SDD_CC_MKB(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_CC_MKB_OORE);
	}

	return;
}

/********************************************************************************/
/*  ֐		FSddr_GetKmuMkb												*/
/*  Tv		FKmui[WX^ɐݒ肳ĂKMU擾					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB *	pub_Kmu													*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static SDD_ERROR Sddr_GetKmuMkb( SDD_HANDLE *p_SddHandle, UB *pub_kmu)
{
	UW	uw_cc_mkb;
	UW	uw_cc_switch;
	
	Sdd_M_GetReg( SDD_CC_SWITCH(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_cc_switch );	/* CC_SWITCHWX^擾 */
	Sdd_M_GetReg( SDD_CC_MKB(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), uw_cc_mkb );			/* CC_MKBWX^擾 */
	
	/*=============================================================
		KMU̔F
			if (KSEL,MSEL) = (0,0){
				*pub_kmu = SDD_KMU_B;
				MV2PLUS̏ꍇF
				if(KSEL2,MSEL2) = (0,0) {
					*pub_kmu = SDD_KMU_B;
					return SDD_SUCCESS;
				}else if(KSEL2,MSEL2) = (1,1) {
					*pub_kmu = SDD_KMU_D;
					return SDD_SUCCESS;
				}else {
					sKMU;
					return SDD_ERR_WRONG_KMU;
				}
			}else if(KSEL,MSEL) = (1,1){
				*pub_kmu = SDD_KMU_B;
				return SDD_SUCCESS
				MV2PLUS̏ꍇF
				if(KSEL2,MSEL2) = (0,0) {
					*pub_kmu = SDD_KMU_A;
					return SDD_SUCCESS;
				}else if(KSEL2,MSEL2) = (1,1) {
					*pub_kmu = SDD_KMU_C;
					return SDD_SUCCESS;
				}else {
					sKMU;
					return SDD_ERR_WRONG_KMU;
				}
			}else {
				sKMU;
				return SDD_ERR_WRONG_KMU;
			}
	===============================================================*/
	
	if ( ( (uw_cc_mkb & SDD_CC_MKB_MSEL) == SDD_CC_MKB_MSEL ) && ( (uw_cc_switch & SDD_CC_SWITCH_KSEL) == SDD_CC_SWITCH_KSEL ) ) {

		*pub_kmu = SDD_KMU_B;
		return SDD_SUCCESS;
	} else if ( ( (uw_cc_mkb & SDD_CC_MKB_MSEL) == 0 ) && ( (uw_cc_switch & SDD_CC_SWITCH_KSEL) == 0 ) ) {
		*pub_kmu = SDD_KMU_A;
		return SDD_SUCCESS;
	} else {
		/*====================================================
			sKMU
			(KSEL,MSEL) = (0,1)or(1,0)
			MV2PLUS̏ꍇF
			(KSEL2,MSEL2,KSEL,MSEL)=(0,0,0,1)or(0,0,1,0)
									(0,1,0,0)or(1,0,0,0)
									(0,1,0,1)or(1,0,0,1)
									(1,1,0,1)or(0,1,1,0)
									(1,0,1,0)or(1,1,1,0)
		=====================================================*/
		return SDD_ERR_WRONG_KMU;									
	}
}


#endif		/* _SDD_FUNC_SECURE_*/

