/****************************************************************************************/
/*  t@C    F$Workfile: SddSubr_secure.c $                                       */
/*  Tv          FSDfoCXhCoFؗpo͐֐pTu֐t@C            */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.                 */
/*  ŏIXV    F$Modtime: 06/06/12 12:10 $                                          */
/*                  Sdds_SecureReadSub,Sdds_SecureWriteSubʉ2006/08/07 H.Miura    */
/****************************************************************************************/
#ifdef _SDD_FUNC_SECURE_

#ifdef _SDD_SDCARDINOUT_KENSHO_
#include "SddCardInOut.h"
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

/* Tu֐t@C */
#if defined(_SDD_JUPITER_)
#include "device/SddSubr_secure_for_jupiter.c"
#endif /* defined(_SDD_JUPITER_) */

#ifndef _SDD_JUPITER_
/********************************************************************************/
/*  ֐		FSdds_SelectMdk_before											*/
/*  Tv		FMDKIO                                                 */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ                                                          */
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
static void Sdds_SelectMdk_before(SDD_HANDLE *p_SddHandle) {
    /* Ȃ */
}
#endif /* _SDD_JUPITER */

/**********************************************************************************************/
/*  ֐		FSdds_SecureReadWriteSub										              */
/*  Tv		FFRead/Writeʏ										              */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                            */
/*      		FUB *pub_Buff(݃f[^i[|C^)					                  */
/*				FUW uw_SecCnt(]ZN^)									              */
/*				FUW uw_Offset(ItZbg)										              */
/*              FBOOL bl_Write  ReadR}hs(FALSE) or WriteR}hs(TRUE)           */
/*  ߂l		FFSDD_SUCCESS												              */
/*  			FsFG[R[h											              */
/*  ŏIXV	F2009.03.10												                  */
/**********************************************************************************************/
static SDD_ERROR Sdds_SecureReadWriteSub( SDD_HANDLE *p_SddHandle, UB *pub_Buff, UW uw_SecCnt, UW uw_Offset, BOOL bl_Write)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#ifndef	_SDD_NO_RESID_
	UW uw_GetWriteSec = 0;				/* ݊ZN^擾 */
#endif	/* !_SDD_NO_RESID_ */

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_SECUREREADWRITESUB );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

	/*======================================================*/
	/* [hECgς݃ZN^						*/
	/*	SDD_DEV\̂̏ʏ̏ZN^	*/
	/*======================================================*/
	p_sdd->Result.uw_Resid = 0;

#if 0	/* Fؗ̈WriteProtectΏۊO */
    if (bl_Write) {
        /* ݎWriteProtect`FbN */
        /*==================================================================*/
        /* WriteProtect̃`FbN											*/
        /*	Sdds_GetWP𔭍s												*/
        /*	F`FbNΏWrite Protect									*/
        /*		  Write ProtectL/									*/
        /*		  Write Protect`FbN									*/
        /*	`FbNWriteProtect͊Odli\12ĵƂ			*/
        /*	͈ȉWriteProtect`FbN֐ōs					*/
        /*	SDD_ERROR Sdds_GetWP(UW uw_Check, BOOL bl_Stop, UW * puw_WP)	*/
        /*	߂lG[Ȃipj									*/
        /*		WriteProtectĂꍇ									*/
        /*			1.Sdds_SetErrR[AG[lۑ					*/
        /*			2.return												*/
        /*		WriteProtectĂȂꍇ								*/
        /*			p												*/
        /*==================================================================*/
        Sdds_GetWP(p_SddHandle, ( SDD_WP_ALL & ~SDD_WP_CCC_ERASE ), TRUE, &uw_Wp );
        if( uw_Wp )
            {
                w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, SDD_ERR_WP );
                return w_Result;
            }
    }
#endif

	/*==============================================================================*/
	/* SDD_DEV\̂DMA]Ɉȉ̒lݒ			                        */
	/*	DMA]AhXFREAD:SD_BUF WRITE:̏݃f[^i[AhX	*/
	/*	DMA]AhXFREAD:̓ǂݎf[^i[AhX WRITE:SD_BUF	*/
	/*	DMAJgTCYF0								                        */
	/*	DMAcTCYFuw_SecCnt						                        */
	/*==============================================================================*/
    if (bl_Write) {
        /* ݎݒ */
        p_sdd->DmaInfo.uw_DMASrcAddr = (UW)pub_Buff;
        p_sdd->DmaInfo.uw_DMADstAddr = (UW)&SDD_SD_BUF(Sdd_M_GetPortNum(p_SddHandle->ub_Port));
    }
    else {
        p_sdd->DmaInfo.uw_DMASrcAddr = (UW)&SDD_SD_BUF(Sdd_M_GetPortNum(p_SddHandle->ub_Port));
        p_sdd->DmaInfo.uw_DMADstAddr = (UW)pub_Buff;
    }
    p_sdd->DmaInfo.uw_DMASize = 0;
    p_sdd->DmaInfo.uw_RestSec = uw_SecCnt;

	/*======================================================*/
	/* SDD_DEV\̂̃ItZbg,JgItZbgݒ */
	/*======================================================*/
	p_sdd->uw_Offset = uw_Offset;

	/*======================================================================*/
	/* FReadWrite														*/
	/* Sdds_SendSecureCMDMulti𔭍s(ȉ̏͊֐Ŏs)			*/
	/*	FRead,WriteR}hs(bl_Write)								*/
	/*	f[^]OSDI/Feݒ(Sdds_ReadyCMDs)						*/
	/*		荞݋֎~													*/
	/*		G[NA													*/
	/*		荞݋													*/
	/*		CBUSY҂													*/
	/*	CMD12sݒ(Sddr_SetStops)									*/
	/*	R}hiACMD18) or R}hiACMD19)s							*/
	/*		ACMD18 or ACMD19Argument͔FR/W ArgumentݒɂĐݒ肳	*/
    /*      邽߁Ał̐ݒ菈͍sȂ							*/
	/*	X|XorG[M҂(Sdds_WaitResEnds)						*/
	/*	X|XG[`FbN											*/
	/*		1)߂lIiSUCCESSj̏ꍇ,p					*/
	/*		2)߂lG[̏ꍇ̂,ȉ̃G[{				*/
	/*		  2.1)CPUDMAC荞݋֎~										*/
	/*		  2.2)CPUDMA荞݃NA								*/
	/*		  2.3)Sdds_SetErrR[AG[lۑ						*/
	/*		  2.4)return													*/
	/*======================================================================*/
	w_ResTmp = Sdds_SendSecureCMDMulti(p_SddHandle, uw_SecCnt, bl_Write, FALSE, pub_Buff );
	if( w_ResTmp != SDD_SUCCESS )
	{
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
        if (bl_Write) {
            /* write͏Ƃ܂Œlۑ */
        }
        else {
            p_sdd->Result.uw_Resid = 0;
        }
		Sddr_SoftReset(p_SddHandle, SDD_SOFT_RESET_SD);	/* SD-IPSDRSTZbg */
		return w_Result;
	}
    p_sdd->Result.uw_Resid += uw_SecCnt;

#ifndef	_SDD_NO_RESID_
    if (bl_Write) {
	/*==================================================================================*/
        /* ݊ZN^`FbN(߂lIłꍇ̂ݎs)					*/
        /*	Sdds_GetWrSector𔭍s															*/
        /*	F݊ZN^														*/
        /*	ubNTCYݒ(4Byte)(Sdds_SetBlockLengths)								*/
        /*	CMD55s(Sdds_SendACMDs)													*/
        /*	ACMD22sO																*/
        /*		f[^]OSDI/Feݒ(Sdds_ReadyCMDs)								*/
        /*		CMD12sݒ(Sddr_SetStops)											*/
        /*		ARGݒ(Sddr_SetArgs)													*/
        /*	ACMD22s																		*/
        /*	X|XorG[M҂(Sdds_WaitResEnds)									*/
        /*	Access All End or G[M҂(Sdds_WaitAllEnds)							*/
        /*	G[`FbN(Sdds_WaitAllEnd̖߂l)											*/
        /*	G[ȂiSUCCESSj̏ꍇ														*/
        /*		ACMD22Ŏ擾]ς݃ZN^=SD Buffer擾							*/
        /*	G[iSUCCESSȊOj̏ꍇ													*/
        /*		DMAC~(Sdds_StopSdmas)													*/
        /*		ACMD22Ŏ擾]ς݃ZN^=0											*/
        /*	ubNTCYݒi512Byte)													*/
        /*	^[G[F															*/
        /*	1)Sdds_GetWrSector()̖߂liSUCCESSj̏ꍇ								*/
        /*		݊ZN^(puw_WriteSector) == ]ZN^̏ꍇ				*/
        /*			return																	*/
        /*		݊ZN^(puw_WriteSector) != ]ZN^̏ꍇ				*/
        /*			]ZN^͂̂܂܁iSddDev.Result.uw_Resid ̂܂܁j			*/
        /*			Sdds_SetErr𔭍s(SDD_ERR_NUM_WR_SECTORS)								*/
        /*	2)Sdds_GetWrSector()̖߂liSUCCESSjȊȌꍇ							*/
        /*		Sdds_SetErr𔭍s(Sdds_GetWrSector̖߂l)									*/
        /*==================================================================================*/
        w_ResTmp = Sdds_GetWrSector( p_SddHandle, &uw_GetWriteSec );
        if( w_ResTmp != SDD_SUCCESS )
            {
                w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, w_ResTmp );
            }
        else
            {
                if( uw_SecCnt != uw_GetWriteSec )
                    {
                        w_Result = Sdds_SetErr(p_SddHandle, __LINE__,  w_Result, SDD_ERR_NUM_WR_SECTORS );
                    }
            }
    }
#endif	/* !_SDD_NO_RESID_ */

	return w_Result;
}

#endif	/* _SDD_FUNC_SECURE_ */
