/***************************************************************************************/
/*  t@C    F$Workfile: SddCommand.c $                                          */
/*  Tv          FSDfoCXhCoR}h֘At@C                         */
/*  Copyright (c) 2003-2004 by Matsushita Electric Industrial Co., Ltd.                */
/*  ŏIXV    F$Modtime: 06/06/12 15:10 $                                         */
/*                  R}hM㏈ǉ 2006/07/03 H.Miura                          */
/*                  ReadorWriteR}hs`X|X㏈ǉ 2006/07/03 H.Miura */
/*                  Sdds_ErrorStop,Sdds_ReadyCMDpʏSdds_SendCommand_before()  */
/*                  ǉ 2006/08/07 H.Miura                                            */
/*                  R}hMRg[֐ǉɊւύXǉ 2006/08/08 H.Miura*/
/***************************************************************************************/
/* wb_[t@C */

#include "SddCom.h"
#include "SddRegister.h"
#include "SddOsEvent.h"
#include "SddError.h"
#include "SddOsTimer.h"
#include "SddCardInOut.h"
#ifdef _SDD_FUNC_SDIO_
#include "SddIoctl_sdio.h"
#endif /* _SDD_FUNC_SDIO_ */
#include "SddDma.h"


#ifdef _SDD_STATUS_MONITOR_ /* Xe[^Xj^pvON */
#include "..\StatusMonitor\statusmonitor.h"
#define settingStatusMonitor() {\
    /* CH6cTCYݒ */\
    setStatusDataAddress(0,(unsigned int*)(0x3A810080 + (0x40 * (6)) + 0x30));\
    /* CH7cTCYݒ */\
    setStatusDataAddress(1,(unsigned int*)(0x3A810080 + (0x40 * (7)) + 0x30));\
    /* RB0[h|C^ݒ */\
    setStatusDataAddress(2,(unsigned int*)(0x3A810400 + (0x40 * (0)) + 0x20));\
    /* RB0Cg|C^ݒ */\
    setStatusDataAddress(3,(unsigned int*)(0x3A810400 + (0x40 * (0)) + 0x28));\
    /* INFO2AhXݒ */\
    setStatusDataAddress(4,(unsigned int*)(SDD_SDIO_BASE[(Sdd_M_GetPortNum(p_SddHandle->ub_Port))] + 0x001e * SDD_ADDR_INC));\
    /* Xe[^Xj^N */\
    getStatustDataStart();\
}
#define setCommandStatusMonitor() {\
    setStatusData(0,(unsigned int)uh_Cmd);       /* R}hi[ */\
}
#define setCommandError() {\
    setStatusData(2,(unsigned int)w_Result);       /* G[i[*/\
}
#else
#define settingStatusMonitor() {\
    /* Ȃ */\
}
#define setCommandStatusMonitor() {\
    /* Ȃ */\
}
#define setCommandError() {\
    /* Ȃ */\
}
#endif /* _SDD_STATUS_MONITOR_ */

/********************************************************************************/
/*  ֐		FSdds_SendCommandBefore										*/
/*  Tv		FR}hMO					                        */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ										                    */
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static void Sdds_SendCommand_before(SDD_HANDLE *p_SddHandle){
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	/*
	R}h]O荞݋֎~
	SD_INFO1_MASKSD_INFO2_MASK}XN
	Sddr_DisIntReadyCMD();
	Fp_SddHandle
	߂lFȂ
	*/
	Sddr_DisIntReadyCMD(p_SddHandle);

	/*
	G[NA
	SD_INFO1SD_INFO2̃G[ׂăNA
	Sddr_ClrErrAll();
	Fp_SddHandle
	߂lFȂ
	*/
	Sddr_ClrErrAll(p_SddHandle);
	Sddr_ClrResEnd(p_SddHandle);		/* X|XEND̃NAÔ߂Ȃ(ʏ킽ĂȂ͂) */
	Sddr_ClrTransEnd(p_SddHandle);		/* RWANZXEND̃NAÔ߂Ȃ(ʏ킽ĂȂ͂) */

	/*
	StÕNA
	clr_flgł̃tO҂s
	OS̃bsO֐Ŏs
		FStOp^[
		߂lFG[Ȃî͂j
	*/
	Sdd_ClrEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), SDD_EVENTFLG_RW_ACCESS_END | SDD_EVENTFLG_ERROR | SDD_EVENTFLG_RES_END | SDD_EVENTFLG_DMA_END | SDD_EVENTFLG_BRWENA);	/* CxgtÕNA */
}

/********************************************************************************/
/*  ֐		FSdds_GetCardInfo												*/
/*  Tv		FJ[h̓擾											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static void Sdds_GetCardInfo(SDD_HANDLE *p_SddHandle)
{
#ifndef _SDD_RW_WAIT_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UB		ub_Mid = 0;
	UH		uh_Oid = 0;
	UB		ub_Prv = 0;
	UW		uw_Psn = 0;
	UH		uh_Mdt = 0;
	
	ub_Mid = p_sdd->ub_Cid[15];
	uh_Oid = ((UH)p_sdd->ub_Cid[14] << 8) | (UH)p_sdd->ub_Cid[13];
	ub_Prv = p_sdd->ub_Cid[7];
	uw_Psn = ((UW)p_sdd->ub_Cid[6] << 24) | 
	         ((UW)p_sdd->ub_Cid[5] << 16) | 
	         ((UW)p_sdd->ub_Cid[4] << 8 ) | 
	         (UW)p_sdd->ub_Cid[3];
	uh_Mdt = ((UH)(p_sdd->ub_Cid[2] & 0x0F) << 8) | (UH)p_sdd->ub_Cid[1];
	
	if(p_sdd->ub_CardType & (UB)SDD_CARD_TYPE_SD){
		if (ub_Mid == 0x03) {
			if ( ((uh_Mdt >= 0x0031) && (uh_Mdt <= 0x004C)) || (ub_Prv < 0x57) ){
				p_sdd->uw_CardInfo = SDD_INFO_CARDBUG_TYPE_A;		/* J[hoO^CvA(eConfidential) */
			}
		}
	}
#endif /* _SDD_RW_WAIT_ */
	return;
}

/**********************************************************************************/
/*  ֐		FSdds_SetCommandDefault     									  */
/*  Tv		Fm_scdDatauh_Cmd,uh_Arg0,uh_Arg1̒lɐݒ肵A @@@  */
/*                m_scdData.uh_Type = SDD_COMMAND_TYPE_DEFAULT                    */
/*                m_scdData.uh_REndTimeOut=SDD_RES_TIMEOUT_MSEC                   */
/*                m_scdData.uh_AEndTimeOut=SDD_1SEC_TIMEOUT_MSEC                  */
/*                m_scdData.pub_Buff=NULL                                          */
/*                m_scdData.uw_SendSec=1                                          */
/*                m_scdData.uw_BlockSize=0                                        */
/*                ɏB                                                  */
/*                R}h̍ۂɂ͏ɖ{֐ĂяoǍɊeR}hʂ*/
/*                ݒsɁASdds_SendCommandsB                  */
/*  		FUH uh_Cmd R}h				                              */
/*                UH uh_Arg0 SD_ARG0Ɋi[                                */
/*                UH uh_Arg1 SD_ARG1Ɋi[                                */
/*                SDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.09													  */
/**********************************************************************************/
void Sdds_SetCommandDefault(UH uh_Cmd, UH uh_Arg0, UH uh_Arg1, SDD_COMMAND_DATA *pscdData) {
    /* li[ */
    pscdData->uh_Cmd = uh_Cmd;
    pscdData->uh_Arg0 = uh_Arg0;
    pscdData->uh_Arg1 = uh_Arg1;
    pscdData->uh_Type = SDD_COMMAND_TYPE_DEFAULT;
    pscdData->uw_REndTimeOut=SDD_RES_TIMEOUT_MSEC;
    pscdData->uw_AEndTimeOut=SDD_1SEC_TIMEOUT_MSEC;
    pscdData->pub_Buff=NULL;
    pscdData->uw_SendSec=1;
    pscdData->uw_BlockSize=SDD_SECTOR_SIZE;
}
/**********************************************************************************/
/*  ֐		FSdds_SetTypeWithData     									      */
/*  Tv		Fuh_TypeɁASDD_COMMAND_TYPE_WITHDATǉB                 */
/*                adtc^CṽR}hɎgpB                                    */
/*  		FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.16													  */
/**********************************************************************************/
void Sdds_SetTypeWithData(SDD_COMMAND_DATA *pscdData) {
    pscdData->uh_Type |= SDD_COMMAND_TYPE_WITHDAT;
}

/**********************************************************************************/
/*  ֐		FSdds_SetTypeCheckR1     									      */
/*  Tv		Fuh_TypeɁASDD_COMMAND_TYPE_CHECK_R1ǉB                */
/*                R}hMɃ`FbNsadtc^CvErasenR}hA     */
/*                Xe[^XnR}hɎgpB                                    */
/*  		FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.17													  */
/**********************************************************************************/
void Sdds_SetTypeCheckR1(SDD_COMMAND_DATA *pscdData) {
    pscdData->uh_Type |= SDD_COMMAND_TYPE_CHECK_R1;
}

/**********************************************************************************/
/*  ֐		FSdds_SetTypeNoRWE     									      */
/*  Tv		Fuh_TypeɁASDD_COMMAND_TYPE_NORWEǉB                   */
/*                USBnR}hȂǂŁÃR}hR/WANZXGh҂    */
/*                {ȂꍇɎgpB                                          */
/*  		FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.17													  */
/**********************************************************************************/
void Sdds_SetTypeNoRWE(SDD_COMMAND_DATA *pscdData) {
    pscdData->uh_Type |= SDD_COMMAND_TYPE_NORWE;
}

/**********************************************************************************/
/*  ֐		FSdds_SetTypeDMA     									          */
/*  Tv		Fuh_TypeɁASDD_COMMAND_TYPE_DMAǉB                     */
/*                PIOŃf[^擾DMAɂăf[^擾R}hɎgpB  */
/*                512byte̓]̍ۂɂ͖{֐ĂяoȂB                 */
/*  		FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.17													  */
/**********************************************************************************/
void Sdds_SetTypeDMA(SDD_COMMAND_DATA *pscdData) {
#ifndef _SDD_PIO_ /* PIOݒ̏ꍇɂ̓rbg𗧂ĂȂ */
    pscdData->uh_Type |= SDD_COMMAND_TYPE_DMA;
#endif /* _SDD_PIO_ */
}

/**********************************************************************************/
/*  ֐		FSdds_SetTypeWrite    									          */
/*  Tv		Fuh_TypeɁASDD_COMMAND_TYPE_WRITEǉB                   */
/*                HOSTSDɃf[^]ۂɎgpB                            */
/*  		FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.17													  */
/**********************************************************************************/
void Sdds_SetTypeWrite(SDD_COMMAND_DATA *pscdData) {
    pscdData->uh_Type |= SDD_COMMAND_TYPE_WRITE;
}

/**********************************************************************************/
/*  ֐		FSdds_SetREndTimeOut  									          */
/*  Tv		Fuh_REndTimeOutɁAw肳ꂽԂݒ肷                      */
/*  		FUW uw_REndTimeOut X|XGh^CAEg              */
/*          	FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.17													  */
/**********************************************************************************/
void Sdds_SetREndTimeOut(UW uw_REndTimeOut, SDD_COMMAND_DATA *pscdData) {
    pscdData->uw_REndTimeOut = uw_REndTimeOut;
}

/**********************************************************************************/
/*  ֐		FSdds_SetAEndTimeOut  									          */
/*  Tv		Fuh_AEndTimeOutɁAw肳ꂽԂݒ肷                      */
/*  		FUW uw_AEndTimeOut R/WANZXGh^CAEg             */
/*          	FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.17													  */
/**********************************************************************************/
void Sdds_SetAEndTimeOut(UW uw_AEndTimeOut, SDD_COMMAND_DATA *pscdData) {
    pscdData->uw_AEndTimeOut = uw_AEndTimeOut;
}

/**********************************************************************************/
/*  ֐		FSdds_SetBuffAddress  									          */
/*  Tv		Fpub_BuffɁAw肳ꂽAhXݒ肷                        */
/*  		FUB *pub_Buff                                                    */
/*          	FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.17													  */
/**********************************************************************************/
void Sdds_SetBuffAddress(UB *pub_Buff, SDD_COMMAND_DATA *pscdData) {
    pscdData->pub_Buff =pub_Buff;
}

/**********************************************************************************/
/*  ֐		FSdds_SetSendSec  									              */
/*  Tv		Fuw_SendSecɁAw肳ꂽZN^TCYݒ肷B                */
/*                A̒l1ȉ̏ꍇɂ́AZN^]{ȂB   */
/*  		FUW uw_SendSec ZN^TCY                                      */
/*          	FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.17													  */
/**********************************************************************************/
void Sdds_SetSendSec(UW uw_SendSec, SDD_COMMAND_DATA *pscdData) {
    pscdData->uw_SendSec =uw_SendSec;
}

/**********************************************************************************/
/*  ֐		FSdds_SetBlockSize									              */
/*  Tv		Fuw_BlockSizeɁAw肳ꂽ]ubNTCY                  */
/*                ݒ肷B                                                      */
/*                A̒lSDD_SECTOR_SIZȄꍇɂ́A]ubNTCY     */
/*                ftHĝ܂ܕύXȂB                                    */
/*  		FUW uw_BlockSize ]ubNTCY                              */
/*          	FSDD_COMMAND_DATA *pscdData R}hf[^             */
/*  ߂l		FȂ   												@@@@@*/
/*  ŏIXV	F2007.10.17													  */
/**********************************************************************************/
void Sdds_SetBlockSize(UW uw_BlockSize, SDD_COMMAND_DATA *pscdData) {
    pscdData->uw_BlockSize =uw_BlockSize;
}

/**********************************************************************************/
/*  ֐		FSdds_SetCommandWithoutSetting									  */
/*  Tv		FX|X҂Ȃǂ̑҂ɁASDD_ARG0,SDD_ARG1,@@@  */
/*                SD_CMDɐݒsBSdds_SendCommandŌĂяo鑼ɁA    */
/*                ȉ̏ꍇ͂̊֐𗘗p                                  */
/*                ER}hSDD_CMD_STOP̏ꍇ@@@@@@@@@@@@@@@@  */
/*                  (WX^ݒŒ~ꍇƋpAG[Ȃ */
/*                ER}hSDD_CMD_STATUSSD_ARG1 == 0̏ꍇ                  */
/*                  (Deselect̏ꍇ)                                          */
/*                ER}hSDD_CMD_IO_RW_DIRECTŁA                            */
/*                  SD_ARG0==SDD_ARG0_IOCARD_RST                                  */
/*                  SD_ARG1==SDD_ARG1_IOCARD_RST                                  */
/*                  ̏ꍇ                                                        */
/*                  (SDIO I/OReset̏ꍇ)                                     */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh                */
/*      		FUH uh_Cmd R}h				                              */
/*                UH uh_Arg0 SD_ARG0Ɋi[                                */
/*                UH uh_Arg1 SD_ARG1Ɋi[                                */
/*  ߂l		FȂ   												@@@@@*/
/*  			FsFG[R[h											  */
/*  ŏIXV	F2009.3.9													      */
/**********************************************************************************/
void Sdds_SetCommandWithoutSetting(SDD_HANDLE *p_SddHandle, UH uh_Cmd, UH uh_Arg0, UH uh_Arg1) {
	/* ARGݒiݒj*/
	Sddr_SetArg(p_SddHandle, uh_Arg0, uh_Arg1);
    /* R}hiCMD)s */
	Sddr_SetCmd(p_SddHandle, uh_Cmd);

    /* MR}hfobOo */
    if ((uh_Cmd&SDD_UNDER_1BYTE_MASK) < 64) {
        /* CMDX */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uh_Cmd=%X CMD%d\n", uh_Cmd, uh_Cmd&SDD_UNDER_1BYTE_MASK);
    }
    else if ((uh_Cmd&SDD_UNDER_1BYTE_MASK) < 128) {
        /* ACMDX */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uh_Cmd=%X ACMD%d\n", uh_Cmd, (uh_Cmd&SDD_UNDER_1BYTE_MASK) - 64);
    }
    else {
        /* SCMDX */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uh_Cmd=%X SCMD%d\n", uh_Cmd, (uh_Cmd&SDD_UNDER_1BYTE_MASK) - 128);
    }
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uh_Arg0=%X\n", uh_Arg0);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uh_Arg1=%X\n", uh_Arg1);
    
    /* Xe[^Xj^ɂR}hL^ */
    setCommandStatusMonitor()
}


/********************************************************************************/
/*  ֐		FSdds_ResetCard												*/
/*  Tv		FSDJ[hResetȂ								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_ResetCard( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
    SDD_COMMAND_DATA scdData;

	/*===================================*/
	/* ResetR}hs(CMD0)           */
	/*===================================*/
    Sdds_SetCommandDefault(SDD_CMD_CARDRST, 0x0000, 0x0000, &scdData);
    w_Result = Sdds_SendCommand(p_SddHandle, &scdData);

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SendOpCMD												*/
/*  Tv		FR}hs													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sdds_SendOpCMD(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_OP_CONDR}hs(CMD1)             */
	/*			OCR̎擾                            */
	/*			Busỹ`FbN                   */
	/*				BusyĂꍇ         */
	/*					w_Result =               */
	/*					return;                      */
	/*				BusyĂȂꍇ       */
	/*					߂lF                     */
	/*					(SUCCESS)̏ꍇ          */
	/*	 					LCMD1Ĕs         */
	/*					G[iSUCCESSȊO)̏ꍇ   */
	/*						w_Result = G[lݒ; */
	/*						return;                  */
	/*		G[iSUCCESSȊOj̏ꍇ          */
	/*			w_Result = G[lݒ;             */
	/*			return;                              */
	/*===============================================*/
#ifdef _SDD_ALLOW_MMC_
    Sdds_SetCommandDefault(SDD_CMD_OP_COND, 0x0000, (SDD_ARG1_OCR_BIT20|SDD_MMC_SECTOR_ACCESS), &scdData);
#else
    Sdds_SetCommandDefault(SDD_CMD_OP_COND, 0x0000, SDD_ARG1_OCR_BIT20, &scdData);
#endif /* _SDD_ALLOW_MMC_ */
	w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	while(1) {
		Sddr_GetOCR(p_SddHandle);	/* OCR擾 */
		if(p_sdd->ub_Ocr[3] & SDD_OCR_BIT31_BUSY) {		/* OCR(WX^)31bitڃ`FbN(busy) */
#ifdef _SDD_ALLOW_MMC_
			if(p_sdd->ub_Ocr[3] & SDD_MMC_OCR_SECTOR_ACCESS) {
				p_sdd->MmcInfo.ub_HcFlag = SDD_MMC_HC;
			}
#endif /* _SDD_ALLOW_MMC_ */
			break;
		} else {
            w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
			if(w_ResTmp != SDD_SUCCESS) {
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				return w_Result;
			}
		}
	}

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SendCIDCMD												*/
/*  Tv		FCID̎擾Ȃ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sdds_SendCIDCMD( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_CIDR}hs(CMD2)                 */
	/*		iSUCCESSj̏ꍇ                    */
	/*			w_Result = ݒ                  */
	/*			CIDf[^̎擾                      */
	/*			Sddr_GetCID()Ŏs          */
	/* 				FȂ                       */
	/*				߂lFȂ                     */
	/*			p                             */
	/*		G[iSUCCESSȊOj̏ꍇ          */
	/*			w_Result = G[lݒ;             */
	/*			p                             */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_CID, 0x0000, 0x0000, &scdData);
    w_Result = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_Result == SDD_SUCCESS) {
		Sddr_GetCID(p_SddHandle);
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SendRCACMD												*/
/*  Tv		FNew RCA̎擾Ȃ										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_SendRCACMD( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UH	uh_Rca;
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_RCAR}hs(CMD3)                 */
	/* 		 ARGFMMC̏ꍇARG(0x0000,0x0100-}N) */
	/*		 ARGFSD̏ꍇARG(0x0000,0x0000-}N)  */
	/* 			RCAf[^̎擾                      */
	/*			MMC̏ꍇRCA = 0x0100(}N)ɐݒ*/
	/*			SD̏ꍇ                             */
	/*			  Sddr_GetRCA()Ŏs        */
	/*===============================================*/
	if(((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC) {
		uh_Rca = 0x0100;
	} else {
		uh_Rca = 0x0000;
	}
    Sdds_SetCommandDefault(SDD_CMD_RCA, 0x0000, uh_Rca, &scdData);
    w_Result = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_Result == SDD_SUCCESS) {
		if(((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC) {
			p_sdd->uh_Rca = uh_Rca;
		} else {
			Sddr_GetRCA(p_SddHandle);
		}
	}
	return w_Result;
}


#if	defined(_SDD_HIGHSPEEDCLK_)
/********************************************************************************/
/*  ֐		FSdds_CtrlCardFunction											*/
/*  Tv		FSDKiVer1.10Ή Card Function							*/
/*				ubNTCYݒi64Byte)										*/
/*				CMD6s														*/
/*				X|XM												*/
/*				AccessAllEnd]I										*/
/*				G[`FbN													*/
/*				G[ȂiSUCCESSj̏ꍇ										*/
/*					CMD6Ŏ擾Function Statusǂݏo						*/
/*		@  		Function Status̓dl`FbN(G[̏ꍇ0V)			*/
/*				ubNTCYݒi512Byte)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FCMD6̃[h, gpFunction								*/
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
SDD_ERROR Sdds_CtrlCardFunction(SDD_HANDLE *p_SddHandle, UW uw_Mode, UW uw_Function)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UW	uw_TmpArg = SDD_CARD_FUNC_NO_INFLUENCE;
	UW	uw_CurrentMax = 0;
	UB	ub_GroupNo = 0;
	UW	uw_FuncNo = 0;
	UB	*pub_BusyStatus_offset;
	UH	uh_BusyStatus;
	UB	ub_FuncStatus[SDD_FUNCSTATUS_SIZE];
    SDD_COMMAND_DATA scdData;

	/*
		ARGݒiuw_TmpArgj
		ARG쐬(uw_TmpArg = uw_Mode|uw_Function) 
		Sddr_SetArg()Ŏs
		FCMD6pArgument(uw_TmpArg)
		߂lFȂ
	*/
	switch (uw_Function) {
		case SDD_CARD_FUNC_DEFAULT_SPEED:
		case SDD_CARD_FUNC_SDR12:
			ub_GroupNo =  SDD_FUNC_GROUP1;
			uw_FuncNo = (UW)SDD_FUNC_FUNC0;
			break;
		case SDD_CARD_FUNC_HIGH_SPEED:
		case SDD_CARD_FUNC_SDR25:
			ub_GroupNo = SDD_FUNC_GROUP1;
			uw_FuncNo = (UW)SDD_FUNC_FUNC1;
			break;
#ifdef _SDD_ALLOW_UHS1_
		case SDD_CARD_FUNC_SDR50:
			ub_GroupNo = SDD_FUNC_GROUP1;
			uw_FuncNo = (UW)SDD_FUNC_FUNC2;
			break;
		case SDD_CARD_FUNC_DEFAULT_CL:
			ub_GroupNo =  SDD_FUNC_GROUP4;
			uw_FuncNo = (UW)SDD_FUNC_FUNC0;
			break;
		case SDD_CARD_FUNC_CL400MA:
			ub_GroupNo =  SDD_FUNC_GROUP4;
			uw_FuncNo = (UW)SDD_FUNC_FUNC1;
			break;
		case SDD_CARD_FUNC_CL600MA:
			ub_GroupNo =  SDD_FUNC_GROUP4;
			uw_FuncNo = (UW)SDD_FUNC_FUNC2;
			break;
		case SDD_CARD_FUNC_CL800MA:
			ub_GroupNo =  SDD_FUNC_GROUP4;
			uw_FuncNo = (UW)SDD_FUNC_FUNC3;
			break;
#endif
		default:
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
			return w_Result;
	} 

	uw_TmpArg = (uw_TmpArg ^ (0x0000000F << (SDD_FUNC_GROUP_SHIFT * ub_GroupNo)))|(uw_FuncNo << (SDD_FUNC_GROUP_SHIFT * ub_GroupNo));
	uw_TmpArg |= uw_Mode;

	/*===============================================*/
	/* SDD_CMD_CARDFUNCR}hs(CMD6)            */
	/*			FCMD6pArgument(uw_TmpArg)      */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_CARDFUNC, ((LELONG *)&uw_TmpArg)->dt2word.low, ((LELONG *)&uw_TmpArg)->dt2word.high, &scdData);
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetBuffAddress((UB *)(ub_FuncStatus), &scdData);
    Sdds_SetBlockSize(SDD_FUNCSTATUS_SIZE, &scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	else {
/*** SDKiVer2.0ΉJnA2005.12.19 ***/
		uw_CurrentMax = (((UW)ub_FuncStatus[0] << 8) | (UW)ub_FuncStatus[1]);
		if ((uw_CurrentMax == 0) || /* Current = 0̏ꍇG[ */
		/* Function error check: Fuc Group(x) = F̏ꍇG[ */
			((ub_FuncStatus[14] & SDD_CARD_FUNC_ERRH) == SDD_CARD_FUNC_ERRH) || 
			((ub_FuncStatus[14] & SDD_CARD_FUNC_ERRL) == SDD_CARD_FUNC_ERRL) || 
			((ub_FuncStatus[15] & SDD_CARD_FUNC_ERRH) == SDD_CARD_FUNC_ERRH) || 
			((ub_FuncStatus[15] & SDD_CARD_FUNC_ERRL) == SDD_CARD_FUNC_ERRL) || 
			((ub_FuncStatus[16] & SDD_CARD_FUNC_ERRH) == SDD_CARD_FUNC_ERRH) || 
			((ub_FuncStatus[16] & SDD_CARD_FUNC_ERRL) == SDD_CARD_FUNC_ERRL))
		{
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
			return w_Result;
		}
		/* Data Structure Version */
		if(ub_FuncStatus[17] == SDD_CARD_FUNC_VERSION)/* Ver01h: bit511:272 defined */
		{
			pub_BusyStatus_offset =  &(ub_FuncStatus[28]) - 2*ub_GroupNo;
			uh_BusyStatus = (((UH)(*pub_BusyStatus_offset)) << 8) | (UH)(*(pub_BusyStatus_offset+1)); 

			if (uh_BusyStatus & (0x0001 << uw_FuncNo)){
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
			}

		}
/*** SDKiVer2.0ΉENDA2005.12.19 ***/
	}
	return w_Result;

}
#endif


/********************************************************************************/
/*  ֐		FSdds_SendSelectCMD											*/
/*  Tv		FSDJ[hSelectȂ								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_SendSelectCMD( SDD_HANDLE *p_SddHandle, BOOL bl_Select )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_STATUSR}hs(CMD7)              */
	/*			FARG(0x0000,RCA)                */
	/*===============================================*/
	if (bl_Select == TRUE){	/* Select̏ꍇ */
        Sdds_SetCommandDefault(SDD_CMD_STATUS, 0x0000, p_sdd->uh_Rca, &scdData);
        Sdds_SetTypeCheckR1(&scdData);
        w_Result = Sdds_SendCommand(p_SddHandle, &scdData);
	} 
	else {	/* De-Select̏ꍇ */
        Sdds_SetCommandWithoutSetting(p_SddHandle, SDD_CMD_STATUS, 0x0000, 0x0000);
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SendCMD8													*/
/*  Tv		FSend Interface Condition Commands							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sdds_SendCMD8(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uw_R7;
    SDD_COMMAND_DATA scdData;
	
	/*============================================================*/
	/* SDD_CMD_IF_CONDR}hs(CMD8)                          */
	/*	FARG(0x01AA,0x0000):d=2.7-3.6V,check pattern=0xAA */
	/*============================================================*/
    Sdds_SetCommandDefault(SDD_CMD_IF_COND, (SDD_R7_VOLTAGE1 | SDD_R7_CHECK_PATTERN), (UH)0x0000, &scdData);
    w_Result = Sdds_SendCommand(p_SddHandle, &scdData);
	/*
		iSUCCESS)̏ꍇ
		@Ver2.xKiΉJ[hSddDev.v20.uh_PhyVer = 0x0002
		@p_sdd->uw_CardStatusɓĂR7𔻒f
		@(ӁA̎p_sdd->uw_CardStatusɂR7łAR1ł͂Ȃ)
		@@R7 = SDD_R7_VOLTAGE1 | SDD_R7_CHECK_PATTERN ?
		@  =:
		@  !=̏ꍇ
				w_Result = G[R[hݒ(T|[g)
				return;
		@
		G[̏ꍇ
		@Ver1.xKiΉJ[hSddDev.v20.uh_PhyVer = 0x0001
	*/
	if(w_Result == SDD_SUCCESS)/* R7X|X */
	{
		Sddr_GetResponse(p_SddHandle, &uw_R7);
		/* R7 p[^`FbN */
		if((uw_R7 & SDD_R7_MASK) == (UW)(SDD_R7_VOLTAGE1 | SDD_R7_CHECK_PATTERN))
		{
			p_sdd->v20.uh_PhyVer = SDD_PHY_VER2;
		}
		else
		{
			w_Result = SDD_ERR_NOT_SUPPORT;
		}
	}
	else /* R7X|XȂ */
	{
		Sdds_ResetCard(p_SddHandle);
		p_sdd->v20.uh_PhyVer = SDD_PHY_VER1;
		p_sdd->w_error &= ~SDD_ERR_IP_TIMEOUT;	/* SDD_DEVRES^CAEgG[NA */
		w_Result = SDD_SUCCESS;
	}
	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_SendCSDCMD												*/
/*  Tv		FCSD̎擾Ȃ											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_SendCSDCMD( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_CSDR}hs(CMD9)                 */
	/*			FARG(0x0000,RCA)                */
	/*		iSUCCESSj̏ꍇ                    */
	/*			w_Result = ݒ                  */
	/*			CSDf[^̎擾                      */
	/*			Sddr_GetCSD()Ŏs          */
	/*			p                             */
	/*		G[iSUCCESSȊOj̏ꍇ          */
	/*			w_Result = G[lݒ;             */
	/*			p                             */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_CSD, 0x0000, p_sdd->uh_Rca, &scdData);
    w_Result = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_Result == SDD_SUCCESS) {
		Sddr_GetCSD(p_SddHandle);
	}

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_ErrorStop												*/
/*  Tv		FJ[hG[CMD12𔭍s							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FBOOL bl_Stop													*/
/*  ߂l		FȂ															*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
void Sdds_ErrorStop(SDD_HANDLE *p_SddHandle, BOOL bl_Stop)
{
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	SDD_ERROR	w_ResTmp;
	UW	uw_WaiEvent;
	UW	uw_Event = 0;

    /* R}hMOǉ H.Miura 2006/08/07 */
    Sdds_SendCommand_before(p_SddHandle);

	/*
	SD_INFO1ResEnd荞݋
	Sddr_EnaResEnd();
	Fp_SddHandle
	߂lFȂ
	*/
	Sddr_EnaResEnd(p_SddHandle);	/* SD_INFO1Res荞݂ */

	/*	AccessAllEnd҂荞݉
		Sddr_EnaTransEnd()
			Fp_SddHandle
			߂lFȂ
	*/
	Sddr_EnaTransEnd(p_SddHandle);

#ifdef _SDD_FUNC_SDIO_
    if (Sdds_OperationModeCheck(p_SddHandle, SDD_CARD_INIT_MODE_SDIO) == SDD_SUCCESS) {
        /* SDIO[hɂ́ACMD52ɂAborts */
        Sdds_IO_Abort(p_SddHandle);
    }
    else {
        /* SD_STOPWX^Sdds_SetCommandWithoutSettinggpCMD12𔭍s */
        if (bl_Stop == TRUE){
            /*===============================================*/
            /* SDD_CMD_STOPR}hs(CMD12)               */
            /*===============================================*/
            Sdds_SetCommandWithoutSetting(p_SddHandle, SDD_CMD_STOP,0,0);	/* SD-IP̃gUNVISD_CMDWX^gp */
        } else {
            Sddr_SetStop(p_SddHandle, SDD_STOP_STP);	/* SD-IP̃gUNVIOSD_STOPWX^gp */
        }
    }
#else
	/* SD_STOPWX^Sdds_SetCommandWithoutSettinggpCMD12𔭍s */
	if (bl_Stop == TRUE){
        /*===============================================*/
        /* SDD_CMD_STOPR}hs(CMD12)               */
        /*===============================================*/
		Sdds_SetCommandWithoutSetting(p_SddHandle, SDD_CMD_STOP,0,0);	/* SD-IP̃gUNVISD_CMDWX^gp */
	} else {
		Sddr_SetStop(p_SddHandle, SDD_STOP_STP);	/* SD-IP̃gUNVIOSD_STOPWX^gp */
	}
#endif
	/* CxgtO҂(X|X or ANZX@or G[ or J[hro) */
	/* G[̏ꍇłʂɂ͒ʒmȂ@*/
	/* ^CAEg2000ms */
	uw_WaiEvent = SDD_EVENTFLG_RES_END | SDD_EVENTFLG_RW_ACCESS_END | SDD_EVENTFLG_ERROR | SDD_EVENTFLG_CARD_OUT;
	w_ResTmp = Sdd_WaiEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_WaiEvent, &uw_Event, SDD_ALLEND_TIMEOUT_MSEC);
	if (w_ResTmp == SDD_SUCCESS){
		w_ResTmp = Sdd_ClrEvent(p_SddHandle, &(p_sdd->OsInfo.normalEventFlag), uw_Event);	/* CxgtÕNA */
	}

	/*
	R}h]㊄荞݋֎~
	SD_INFO1_MASKSD_INFO2_MASK}XN
	Sddr_DisIntReadyCMD();
	Fp_SddHandle
	߂lFȂ
	*/
	Sddr_DisIntReadyCMD(p_SddHandle);

	return ;
	
}

/********************************************************************************/
/*  ֐		FSdds_GetCardStatus											*/
/*  Tv		FCardStatus擾(CMD13s)										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_GetCardStatus( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_GETCARDSTATUS );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

	/*===============================================*/
	/* SDD_CMD_CARDSTATUSR}hs(CMD13)         */
	/*			FARG(0x0000,RCA)                */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_CARDSTATUS, 0x0000, p_sdd->uh_Rca, &scdData);
    Sdds_SetTypeCheckR1(&scdData);
    w_Result = Sdds_SendCommand(p_SddHandle, &scdData);

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetBlockLength											*/
/*  Tv		F]f[^ݒ(CMD16s)									*/
/*				FCMD16ɎsSD_SIZEWX^512Bɖ߂				*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_BlockLength(]f[^)								*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
static SDD_ERROR Sdds_SetBlockLength(SDD_HANDLE *p_SddHandle, UW uw_BlockLength)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

    /*===============================================*/
	/* SDD_CMD_BLOCKLENR}hs(CMD16)           */
	/*			FARG(ubN)                */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_BLOCKLEN, SDD_LWORD(uw_BlockLength), SDD_HWORD(uw_BlockLength), &scdData);
    Sdds_SetTypeCheckR1(&scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*===================================*/
	/* ]f[^WX^ݒ(SD_SIZE) */
	/*===================================*/
	/*
		]f[^WX^ݒ֐(Sddr_SetLength)
		FݒubNiLXgϊKvHj
		߂lFG[Ȃ
	*/
	Sddr_SetLength(p_SddHandle, uw_BlockLength);

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SendCMDMulti												*/
/*  Tv		FReadorWriteR}hs`X|X						*/
/*					f[^]OSDI/Feݒ1									*/
/*					荞݋֎~												*/
/*					G[NA												*/
/*					CMD12sݒ											*/
/*					荞݋												*/
/*					CBUSY҂												*/
/*					ARGݒiReadJnoffsetݒj								*/
/*					R}hiCMD18orCMD25)s									*/
/*					X|XorG[M҂									*/
/*					X|XG[`FbN									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F[v1ǂݏooffsetiByteP)								*/
/*				FReadR}hs(FALSE) or WriteR}hs(TRUE)			*/
/*                BOOL bl_RWE R/WANZXGhstO                       */
/*                (TRUE:R/WANZXGhs,FALSE:sȂ)       */
/*                UB *pub_Buff f[^AhX                                   */
/*  ߂l		FFSDD_SUCCESS												*/
/*	G[		F																*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_SendCMDMulti( SDD_HANDLE *p_SddHandle, UW uw_Offset, BOOL bl_Write, UW uw_SendSec, BOOL bl_RWE, UB *pub_Buff)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;
#ifdef _SDD_RW_WAIT_
	UW	uw_WaitCnt;
#endif
#if defined(_SDD_DEFECT_SCARD_)
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#endif

#ifdef _SDD_RW_WAIT_
	/*================================*/
	/* R}hsOEFCg} */
	/* SanDisk 1GB SDJ[hs΍ */
	/*================================*/
	if(bl_Write == FALSE) {
		uw_WaitCnt = p_sdd->uw_ReadWait;
	} else {
		uw_WaitCnt = p_sdd->uw_WriteWait;
	}
	while (uw_WaitCnt) {
				uw_WaitCnt--;
	};
#elif defined(_SDD_DEFECT_SCARD_) /* ُJ[hɁAOST[rXR[ɂ҂{ */
	if(p_sdd->uw_CardInfo == SDD_INFO_CARDBUG_TYPE_A) {
		w_ResTmp = Sdd_Delay(SDD_WAIT_2MSEC);
	}
#else
    /* Ȃ */
#endif 
	/*===============================================*/
	/* SDD_CMD_SINGLEREADR}hs(CMD17)         */
	/* SDD_CMD_MULTIREADR}hs(CMD18)          */
	/* SDD_CMD_SINGLEWRITER}hs(CMD24)        */
	/* SDD_CMD_MULTIWRITER}hs(CMD25)         */
	/*	F[v1ǂݏooffset̉16bit,      */
    /*        [v1ǂݏooffset̏16bit       */
	/*===============================================*/
	if(bl_Write != TRUE ) {
		if(uw_SendSec != 1) {
            /* Multi ReadR}hs */
            Sdds_SetCommandDefault(SDD_CMD_MULTIREAD,SDD_LWORD(uw_Offset),SDD_HWORD(uw_Offset), &scdData);
		} else {
            /* Single ReadR}hs */
            Sdds_SetCommandDefault(SDD_CMD_SINGLEREAD,SDD_LWORD(uw_Offset),SDD_HWORD(uw_Offset), &scdData);
		}
	} else {
		if(uw_SendSec != 1) {
            /* Multi WriteR}hs */
            Sdds_SetCommandDefault(SDD_CMD_MULTIWRITE,SDD_LWORD(uw_Offset),SDD_HWORD(uw_Offset), &scdData);
		} else {
            /* Single WriteR}hs */
            Sdds_SetCommandDefault(SDD_CMD_SINGLEWRITE,SDD_LWORD(uw_Offset),SDD_HWORD(uw_Offset), &scdData);
		}
        Sdds_SetTypeWrite(&scdData);
	}
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetTypeDMA(&scdData);
    Sdds_SetSendSec(uw_SendSec,&scdData);
    Sdds_SetBuffAddress(pub_Buff,&scdData);
    Sdds_SetAEndTimeOut(Sdds_CalcTimeOutTime(uw_SendSec, bl_Write, p_SddHandle),&scdData);
    if (bl_RWE == TRUE) {
        Sdds_SetTypeNoRWE(&scdData);
    }
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
    if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	return w_Result;

}

/********************************************************************************/
/*  ֐		FSdds_EraseSub													*/
/*  Tv		Fʏ̈(CMD32,CMD33,CMD38)								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUW uw_AdrStart(폜JnoCg)								*/
/*  			FUW uw_AdrEnd(폜IoCg)									*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdds_EraseSub(SDD_HANDLE *p_SddHandle, UW uw_AdrStart, UW uw_AdrEnd)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UW uw_Wp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uw_Count = 0;
    SDD_COMMAND_DATA scdData;

#ifdef _SDD_SDCARDINOUT_KENSHO_
	Sdd_CardinoutKenshoWait( p_SddHandle, WAIT_ERASESUB );	/* }eXg͑҂ */
#endif /* _SDD_SDCARDINOUT_KENSHO_ */

	/* TCYiByteZN^j^CAEgԎZop*/
/*** SDKiVer2.0ΉJnA2005.12.19 ***/
	/* HCJ[h̏ꍇAstart,endP = BLOCK */
#ifdef _SDD_ALLOW_MMC_
	if((p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2)) || (p_sdd->MmcInfo.ub_HcFlag == SDD_MMC_HC))
#else
	if(p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2))
#endif /* _SDD_ALLOW_MMC_ */
	{
		uw_Count = (uw_AdrEnd - uw_AdrStart);
	}
	else
	{
		uw_Count = (uw_AdrEnd - uw_AdrStart) / p_sdd->uw_SectorSize;
	}
/*** SDKiVer2.0ΉENDA2005.12.19 ***/
	/*	WriteProtect̃`FbN
		`FbNWriteProtect͕݌vi\2-6ĵƂ
		͈ȉWriteProtect`FbN֐ōs
		SDD_ERROR Sdds_GetWP(UW uw_Check, BOOL bl_Stop, UW * puw_WP)
		߂lG[Ȃipj
			WriteProtectĂꍇ
				[v1o
			WriteProtectĂȂꍇ
				p
	*/
	Sdds_GetWP(p_SddHandle, SDD_WP_ALL, TRUE, &uw_Wp);
	if(uw_Wp) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_WP);
		return w_Result;
	}

	/*==================================================================================*/
	/* JnAhXEIAhXvZ͌Ăяołł̂łł͐ݒl߂ */
	/*==================================================================================*/
	uw_AdrEnd -= p_sdd->uw_EraseByteMin;

	/*===============================================*/
	/* SDD_CMD_ERASE_STARTADR}hs(CMD32)      */
	/* SDD_CMD_MMC_ERASE_STARTADR}hs(CMD35)  */
	/*	FJnAhX@@@@@@@@@@@     */
	/*	MMCȊÕJ[h̏ꍇ                        */
	/*		CMD32𔭍s                          */
	/*	MMC̏ꍇ                                    */
	/*		CMD35𔭍s                          */
	/*===============================================*/
	if (((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) != SDD_CARD_TYPE_MMC) {
        Sdds_SetCommandDefault(SDD_CMD_ERASE_STARTAD, SDD_LWORD(uw_AdrStart), SDD_HWORD(uw_AdrStart), &scdData);
	} else {
        Sdds_SetCommandDefault(SDD_CMD_MMC_ERASE_STARTAD, SDD_LWORD(uw_AdrStart), SDD_HWORD(uw_AdrStart), &scdData);
	}
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}


	/*===============================================*/
	/* SDD_CMD_ERASE_ENDADR}hs(CMD33)        */
	/* SDD_CMD_MMC_ERASE_ENDADR}hs(CMD36)    */
	/*	FIAhX@@@@@@@@@@@     */
	/*	MMCȊÕJ[h̏ꍇ                        */
	/*		CMD33𔭍s                          */
	/*	MMC̏ꍇ                                    */
	/*		CMD36𔭍s                          */
	/*===============================================*/
	if (((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) != SDD_CARD_TYPE_MMC) {
        Sdds_SetCommandDefault(SDD_CMD_ERASE_ENDAD, SDD_LWORD(uw_AdrEnd), SDD_HWORD(uw_AdrEnd), &scdData);
	} else {
        Sdds_SetCommandDefault(SDD_CMD_MMC_ERASE_ENDAD, SDD_LWORD(uw_AdrEnd), SDD_HWORD(uw_AdrEnd), &scdData);
	}
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*===============================================*/
	/* SDD_CMD_ERASER}hs(CMD38)              */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_ERASE, 0x0000,0x0000, &scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetREndTimeOut(Sdds_Get_EraseTm(p_SddHandle, uw_Count), &scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp == SDD_SUCCESS) {
		p_sdd->Result.uw_Resid = uw_Count;
	} else {
		p_sdd->Result.uw_Resid = 0;
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	} 

	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_SendACMD													*/
/*  Tv		FAvP[VR}hs									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
SDD_ERROR Sdds_SendACMD(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_PREACMDR}hs(CMD55)            */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_PREACMD, (UH)0x0000, p_sdd->uh_Rca, &scdData);
    w_Result = Sdds_SendCommand(p_SddHandle, &scdData);
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SetBusWidth												*/
/*  Tv		FSDoXݒ													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FSDoX														*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
static SDD_ERROR Sdds_SetBusWidth(SDD_HANDLE *p_SddHandle, UW uw_busWidth)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

	/*
		d[hSDJ[hȊȌꍇɉL̏{id[h4rbgK{j
		if(SDoX4bit){
			SCRSDoX1bit݂̂̏ꍇ
			{֐̈̃oX1bitɐݒ
	*/
	if((p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK) != SDD_CARD_FUNC_SDR12){
		if(uw_busWidth == SDD_BUS_WIDTH_4) {
			if((p_sdd->ub_Scr[1] & SDD_SCR_BUS_WIDTH_4) == 0) {	/* 4bitT|[g */
				uw_busWidth = SDD_BUS_WIDTH_1;
			}
		}
		/* 
           MMCr
		   oX1bitŐݒ 
		*/
		if(((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC) {
			Sddr_SetBusWidth(p_SddHandle, SDD_BUS_WIDTH_1BIT);
			return w_Result;
		}
	}

	/*===============================================*/
	/* SDD_CMD_BITLENR}hs(ACMD6)             */
    /*   SDJ[h:4bitݒ                           */
    /*              :(0x0002,0x0000-}N)      */
    /*            1bitݒ                           */
    /*              :(0x0000,0x0000-}N)      */
    /*            Sddr_SetBusWidth()Ŏs @*/
	/*===============================================*/
	switch(uw_busWidth) {
      case SDD_BUS_WIDTH_4:
        Sdds_SetCommandDefault(SDD_CMD_BITLEN, SDD_ARG0_BUS_WIDTH_4, 0x0000, &scdData); /* 4rbgݒ */
        Sdds_SetTypeCheckR1(&scdData);
        w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
        if(w_ResTmp != SDD_SUCCESS) {
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
            return w_Result;
        }
        Sddr_SetBusWidth(p_SddHandle, SDD_BUS_WIDTH_4BIT);
        break;
      case SDD_BUS_WIDTH_1:
        Sdds_SetCommandDefault(SDD_CMD_BITLEN, SDD_ARG0_BUS_WIDTH_1, 0x0000,&scdData); /* 1rbgݒ */
        Sdds_SetTypeCheckR1(&scdData);
        w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
        if(w_ResTmp != SDD_SUCCESS) {
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
            return w_Result;
        }
        Sddr_SetBusWidth(p_SddHandle, SDD_BUS_WIDTH_1BIT);
        break;
      default:
        w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
        break;
    }

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SendSDStatus												*/
/*  Tv		FSD Status擾													*/
/*				ubNTCYݒ(8Byte)										*/
/*				CMD55s														*/
/*				ACMD13sO												*/
/*				ACMD13s														*/
/*				X|XM												*/
/*				AccessAllEnd]I										*/
/*				G[`FbN													*/
/*				G[ȂiSUCCESSj̏ꍇ										*/
/*					ACMD13Ŏ擾SD Status =SD Buffer擾				*/
/*					SDD_DEV.֊i[												*/
/*				ubNTCYݒi512Byte)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F݊ZN^											*/
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
SDD_ERROR Sdds_SendSdStatus( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_SDSTATUSR}hs(ACMD13)          */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_SDSTATUS,0x0000,0x0000, &scdData);
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetBuffAddress(p_sdd->ub_SdStatus, &scdData);
    Sdds_SetBlockSize(SDD_SDSTATUS_SIZE,&scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	return w_Result;

}

/********************************************************************************/
/*  ֐		FSdds_SendSecureCMDMulti										*/
/*  Tv		FReadorWriteR}hs`X|X						*/
/*					f[^]OSDI/Feݒ1									*/
/*					荞݋֎~												*/
/*					G[NA												*/
/*					CMD12sݒ											*/
/*					荞݋												*/
/*					CBUSY҂												*/
/*					ARGݒiReadJnoffsetݒj								*/
/*					R}hiACMD18orACMD25)s								*/
/*					X|XorG[M҂									*/
/*					X|XG[`FbN									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FReadR}hs(FALSE) or WriteR}hs(TRUE)			*/
/*                BOOL bl_RWE R/WANZXGhstO                       */
/*                (TRUE:R/WANZXGhs,FALSE:sȂ)       */
/*  ߂l		FFSDD_SUCCESS												*/
/*	G[		F																*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdds_SendSecureCMDMulti(SDD_HANDLE *p_SddHandle, UW uw_SendSec, BOOL bl_Write, BOOL bl_RWE, UB *pub_Buff )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;
    UH cmd=0;
	UH arg0=0;
	UH arg1=0;

    if(bl_Write != TRUE ) {
        cmd = SDD_CMD_SECURE_MULTIREAD;  /* Secure ReadR}hs */
    }
    else {
        cmd = SDD_CMD_SECURE_MULTIWRITE; /* Secure WriteR}hs */
    }
    arg0=0;
    arg1=0;

	/*===============================================*/
	/* SDD_CMD_SECURE_MULTIREADR}hs(ACMD18)  */
	/* SDD_CMD_SECURE_MULTIWRITER}hs(ACMD25) */
	/*===============================================*/
    Sdds_SetCommandDefault(cmd,arg0,arg1,&scdData);
	if(bl_Write == TRUE ) {
        Sdds_SetTypeWrite(&scdData);
	}
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetTypeDMA(&scdData);
    Sdds_SetSendSec(uw_SendSec,&scdData);
    Sdds_SetBuffAddress(pub_Buff,&scdData);
    Sdds_SetAEndTimeOut(Sdds_CalcTimeOutTime(uw_SendSec, bl_Write, p_SddHandle),&scdData);
    if (bl_RWE == TRUE) {
        Sdds_SetTypeNoRWE(&scdData);
    }
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

    return w_Result;

}

/********************************************************************************/
/*  ֐		FSdds_SendGetMkbCMDMulti										*/
/*  Tv		FMKBǂݏo													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUB ub_MKBId:MKB_ID											*/
/*                UW uw_Count:ǂݏoZN^							     	*/
/*                UW uw_Offset:MKBǂݍ݊JnItZbg						*/
/*                BOOL bl_RWE R/WANZXGhstO                       */
/*                (TRUE:R/WANZXGhs,FALSE:sȂ)       */
/*                UB *pub_Buff f[^AhX                                   */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdds_SendGetMkbCMDMulti(SDD_HANDLE *p_SddHandle, UB ub_MKBId, UW uw_Count, UW uw_Offset, BOOL bl_RWE, UB *pub_Buff)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UH	uh_tmpArg0;
	UH	uh_tmpArg1;
    UW uw_CountTmp = uw_Count;
    SDD_COMMAND_DATA scdData;

	/*======================================================*/
	/* SDKi,256ZN^̏ꍇ,argument0ݒ肷		*/
	/*======================================================*/
	if(uw_Count == SDD_MAX_SECRW_SIZE_MAX){
		uw_Count = 0;
	}

	/*==============================================*/
	/* SD_Arg0,uw_Offsetݒ					*/
	/* SD_Arg1̏8bituw_Countݒ肵			*/
	/* 8bitub_MKBIdݒ						*/
	/*==============================================*/
	uh_tmpArg0 = ((LELONG *)&uw_Offset)->dt2word.low;
	uh_tmpArg1 = ((((LELONG *)&uw_Count)->dt2word.low)) & SDD_UNDER_1BYTE_MASK;
	uh_tmpArg1 = ((uh_tmpArg1 << 8) | ub_MKBId);

	/*===============================================*/
	/* SDD_CMD_GETMKBR}hs(ACMD43)            */
	/*	Fǂݍ݊JnItZbgݒ             */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_GETMKB, uh_tmpArg0, uh_tmpArg1,&scdData);
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetTypeDMA(&scdData);
    Sdds_SetBuffAddress(pub_Buff,&scdData);
    Sdds_SetSendSec(uw_CountTmp,&scdData);
    Sdds_SetAEndTimeOut(Sdds_CalcTimeOutTime(uw_CountTmp, FALSE, p_SddHandle),&scdData);
    if (bl_RWE == TRUE) {
        Sdds_SetTypeNoRWE(&scdData);
    }
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	return w_Result;

}

/********************************************************************************/
/*  ֐		FSdds_GetWrSector												*/
/*  Tv		F݊ZN^`FbN									*/
/*				ubNTCYݒ(4Byte)										*/
/*				CMD55s														*/
/*				ACMD22sO												*/
/*				ACMD22s														*/
/*				X|XM												*/
/*				AccessAllEnd]I										*/
/*				G[`FbN													*/
/*				G[ȂiSUCCESSj̏ꍇ										*/
/*					ACMD22Ŏ擾]ς݃ZN^=SD Buffer擾			*/
/*				G[iSUCCESSȊOj̏ꍇ									*/
/*					ACMD22Ŏ擾]ς݃ZN^=0							*/
/*				ubNTCYݒi512Byte)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F݊ZN^											*/
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
SDD_ERROR Sdds_GetWrSector( SDD_HANDLE *p_SddHandle, UW * puw_WrSectors )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UB ub_Resid[SDD_WRSEC_BLOCKSIZE] = {0, 0, 0, 0}; /* Klocwork΍ */
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_WRITE_SECR}hs(ACMD22)         */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_WRITE_SEC, 0x0000, 0x0000, &scdData);
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetBuffAddress(ub_Resid,&scdData);
    Sdds_SetBlockSize(SDD_WRSEC_BLOCKSIZE,&scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp == SDD_SUCCESS) {
		*puw_WrSectors = (UW)(((UW)ub_Resid[0] << 24) | ((UW)ub_Resid[1] << 16) | ((UW)ub_Resid[2] << 8) | ((UW)ub_Resid[3]));
	} 
	else {
		p_sdd->Result.uw_Resid = 0;
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	return w_Result;

}

/********************************************************************************/
/*  ֐		FSdds_SendApOpCMD												*/
/*  Tv		FR}hs													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sdds_SendApOpCMD(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_APP_OP_CONDR}hs(ACMD41)       */
	/*	FARG(ݒ\ȓdl-}N)           */
	/*		iSUCCESSj̏ꍇ                    */
	/*			OCR̎擾                            */
	/*			Busỹ`FbN                   */
	/*				BusyĂꍇ         */
	/*					w_Result =               */
	/*					return;                      */
	/*				BusyĂȂꍇ       */
	/*					CMD55s                    */
	/*					SddsSendACMDŎs   */
	/*						FȂ               */
	/*						߂lF                 */
	/*						(SUCCESS)̏ꍇ      */
	/*						LACMD41Ĕs       */
	/*						G[̏ꍇ             */
	/*						w_Result = G[lݒ; */
	/*								return;          */
	/*		G[iSUCCESSȊOj̏ꍇ          */
	/*			w_Result = G[lݒ;             */
	/*			return;                              */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_APP_OP_COND, 0x0000, SDD_ARG1_OCR_BIT20, &scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	while(1) {
		Sddr_GetOCR(p_SddHandle);	/* OCR擾 */
		if(p_sdd->ub_Ocr[3] & SDD_OCR_BIT31_BUSY) {		/* OCR(WX^)31bitڃ`FbN(busy) */
			break;
		} else {
#ifdef _SDD_FUNC_QUICK_BOOT_
			if( p_sdd->ub_StartCardInit ){
				return SDD_ERR_OS_TIMEOUT;		/* rW[ĂȂ߁A^CAEgԂ(ʂɂ͒ʒmȂ) */
			}
#endif /* _SDD_FUNC_QUICK_BOOT_ */
#ifdef	_SDD_TSKSLP_CARDINIT_
			w_ResTmp = Sdd_Delay(SDD_INIT_ACMD41_MSEC);
			w_ResTmp &= ~SDD_ERR_OS_TIMEOUT;	/* SDD_ERR_OS_TIMEOUTNA(K͂)  */
			if(w_ResTmp != SDD_SUCCESS)  {
				/* ߂lFG[Ȃ͂ */
				/* G[Ăʒm͂Ȃ */
			}
#endif
            w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
			if(w_ResTmp != SDD_SUCCESS) {
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				return w_Result;
			}
		}
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SendNewApOpCMD											*/
/*  Tv		FVer2.0/UHS-IΉVApOpR}hs							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sdds_SendNewApOpCMD(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;
    UH	uh_Arg1 = SDD_ARG1_OCR_HCS;	/* R}hA[Mglݒ */
	
	/*===============================================*/
	/* SDD_CMD_APP_OP_CONDR}hs(ACMD41)       */
	/*	FARG(ݒ\ȓdl-}N)HCS=1,S18R=1 ݒ*/
	/*		iSUCCESSj̏ꍇ                    */
	/*			OCR̎擾                            */
	/*			Busỹ`FbN                   */
	/*				BusyĂꍇ         */
	/*					w_Result =               */
	/*						X|XCCS`FbN  */
	/*						CCS=1FHCJ[h          */
	/*						CCS=0FVer2.0ΉLCJ[h*/
	/*						X|XS18A`FbN */
	/*						S18A=1FUHS-IJ[h      */
	/*						S18A=0FUHS-IΉ      */
	/*					return;                      */
	/*				BusyĂȂꍇ       */
	/*					CMD55s                    */
	/*					SddsSendACMDŎs   */
	/*						FȂ               */
	/*						߂lF                 */
	/*						(SUCCESS)̏ꍇ      */
	/*						LACMD41Ĕs       */
	/*						G[̏ꍇ             */
	/*						w_Result = G[lݒ; */
	/*								return;          */
	/*		G[iSUCCESSȊOj̏ꍇ          */
	/*			w_Result = G[lݒ;             */
	/*			return;                              */
	/*===============================================*/
#if defined(_SDD_ALLOW_UHS1_)
	if (p_sdd->ub_UHS1Info == SDD_ALLOW_UHS1_USED) {
		uh_Arg1 |= SDD_ARG1_OCR_UHS;
	}
#endif /* defined(_SDD_ALLOW_UHS1_) */

#ifdef _SDD_SDXC_SPEED_CLASS_
	uh_Arg1 |= SDD_ARG1_OCR_XPC;
#endif /* _SDD_SDXC_SPEED_CLASS_ */

	Sdds_SetCommandDefault(SDD_CMD_APP_OP_COND, 0x0000, uh_Arg1, &scdData);

	w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
    if(w_ResTmp != SDD_SUCCESS) {
        if (p_sdd->SddCommandSendData.uh_Cmd == SDD_CMD_PREACMD) {
            /* ACMDMɃG[ꍇ */
            w_Result = SDD_ERR_NOT_SUPPORT;/* G[FT|[gJ[h */
        }
        else {
            w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
        }
        return w_Result;
    }
    while(1) {
        Sddr_GetOCR(p_SddHandle);	/* OCR擾 */
        if(p_sdd->ub_Ocr[3] & SDD_OCR_BIT31_BUSY) {		/* OCR(WX^)31bitڃ`FbN(busy) */
            break;
        } else {
#ifdef _SDD_FUNC_QUICK_BOOT_
			if( p_sdd->ub_StartCardInit ){
				return SDD_ERR_OS_TIMEOUT;		/* rW[ĂȂ߁A^CAEgԂ(ʂɂ͒ʒmȂ) */
			}
#endif /* _SDD_FUNC_QUICK_BOOT_ */
#ifdef	_SDD_TSKSLP_CARDINIT_
            w_ResTmp = Sdd_Delay(SDD_INIT_ACMD41_MSEC);
            w_ResTmp &= ~SDD_ERR_OS_TIMEOUT;	/* SDD_ERR_OS_TIMEOUTNA(K͂)  */
            if(w_ResTmp != SDD_SUCCESS)  {
                /* ߂lFG[Ȃ͂ */
                /* G[Ăʒm͂Ȃ */
            }
#endif
            w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
            if(w_ResTmp != SDD_SUCCESS) {
                w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
                return w_Result;
            }
        }
    }
    /*HC,LCJ[h */
    p_sdd->v20.uh_PhyVer &= SDD_PHY_CARDMASK;
    if(p_sdd->ub_Ocr[3] & SDD_OCR_BIT30_CCS) {		/* OCR(WX^)30bitڃ`FbN(CCS) */
        /* HCJ[h */
        p_sdd->v20.uh_PhyVer |= SDD_PHY_HCCARD;
    }
    else {
        /* LCJ[h */
        p_sdd->v20.uh_PhyVer |= SDD_PHY_LCCARD;
    }

#ifdef _SDD_ALLOW_UHS1_
	if (p_sdd->ub_UHS1Info == SDD_ALLOW_UHS1_USED) {
		/* UHS-IJ[h */
		if(p_sdd->ub_Ocr[3] & SDD_OCR_BIT24_S18A){		/* OCR(WX^)24bitڃ`FbN(S18A) */
			/* UHS-IJ[h*/
			p_sdd->uh_CardType2 |= SDD_CARDTYPE2_UHS1;
		}
	}
#endif /* _SDD_ALLOW_UHS1_ */

	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_SetSecureArea											*/
/*  Tv		FFؗ̈TCYύX											*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdds_SetSecureArea(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	UW uw_Wp;
    SDD_COMMAND_DATA scdData;

/*** SDKiVer2.0ΉJnA2005.12.20 ***/
	/* HCJ[h̏ꍇA{ߔT|[g */
	if(p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2))
	{
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
		return w_Result;
	}
/*** SDKiVer2.0ΉENDA2005.12.20 ***/

	/*==========================================================*/
	/* Sdds_GetWP𔭍s,Write Protect̃`FbN 				*/
	/*   SDD_SUCCESSȊOȂ,Sdds_SetErrR[ă^[	*/
	/*==========================================================*/
	Sdds_GetWP(p_SddHandle, SDD_WP_ALL, TRUE, &uw_Wp);
	if(uw_Wp) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_WP);
		return w_Result;
	}

	/*===============================================*/
	/* SDD_CMD_SECURE_AREAR}hs(ACMD49)       */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_SECURE_AREA, 0, 0, &scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetREndTimeOut(Sdds_Get_EraseTm(p_SddHandle, p_sdd->uw_CardSize),&scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS ) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*==========================================================*/
	/* Sdds_SendSdStatus𔭍s,SD_STATUS擾					*/
	/*   SDD_SUCCESSȊOȂ,Sdds_SetErrR[ă^[	*/
	/*==========================================================*/
	w_ResTmp = Sdds_SendSdStatus(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*==========================================================*/
	/* Sdds_SendSelectCMD(J[hde-select)𔭍s,CMD7𔭍s	*/
	/*   SDD_SUCCESSȊOȂ,Sdds_SetErrR[ă^[	*/
	/*==========================================================*/
	w_ResTmp = Sdds_SendSelectCMD(p_SddHandle, FALSE);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*==========================================================*/
	/* Sdds_SendCSDCMD𔭍s,CSD擾						*/
	/*   SDD_SUCCESSȊOȂ,Sdds_SetErrR[				*/
	/*==========================================================*/
	w_ResTmp =Sdds_SendCSDCMD(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);	/* return */
	}

	/*==========================================================*/
	/* Sdds_SendSelectCMD(J[hselect)𔭍s,CMD7𔭍s		*/
	/*   SDD_SUCCESSȊOȂ,Sdds_SetErrR[ă^[	*/
	/*   ܂,Sdds_SendCSDCMDŃG[Ȃ΃^[		*/
	/*==========================================================*/
	w_ResTmp = Sdds_SendSelectCMD(p_SddHandle, TRUE);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*==========================================================*/
	/* CSDSD_StatusJ[hTCYvZ						*/
	/*==========================================================*/
	Sdds_SdcardSizeCalc(p_SddHandle);

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_SendSCR													*/
/*  Tv		FSCR擾														*/
/*				ubNTCYݒ(8Byte)										*/
/*				CMD55s														*/
/*				ACMD51sO												*/
/*				ACMD51s														*/
/*				X|XM												*/
/*				AccessAllEnd]I										*/
/*				G[`FbN													*/
/*				G[ȂiSUCCESSj̏ꍇ										*/
/*					ACMD51Ŏ擾]ςSCR =SD Buffer擾				*/
/*					SDD_DEV.Ub_Scr֊i[										*/
/*				ubNTCYݒi512Byte)									*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		F݊ZN^											*/
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
static SDD_ERROR Sdds_SendSCR( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_SCRR}hs(ACMD51)               */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_SCR, 0x0000, 0x0000, &scdData);
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetBuffAddress(p_sdd->ub_Scr,&scdData);
    Sdds_SetBlockSize(SDD_SCR_SIZE,&scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
        p_sdd->Result.uw_Resid = 0;
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	return w_Result;
}

#if defined(_SDD_DAT3_PULLUP_DISABLE_) || defined(_SDD_DAT3_PULLUP_PART_DISABLE_)
/********************************************************************************/
/*  ֐		FSdds_SendACMD42												*/
/*  Tv		FSD[qPin#1(CD/DAT3)̃vAbvRON/OFFݒ				*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FBOOL bl_Set ( TRUE:vAbvON, FALSE:vAbvOFF			*/
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2009.06.02													*/
/********************************************************************************/
static SDD_ERROR Sdds_SendACMD42( SDD_HANDLE *p_SddHandle, BOOL bl_Set )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_CLR_CARD_DETECTR}hs(ACMD42)   */
	/*===============================================*/
 	if(bl_Set) {
 		Sdds_SetCommandDefault(SDD_CMD_CLR_CARD_DETECT, 0x0001, 0x0000, &scdData);
 	} else {
 		Sdds_SetCommandDefault(SDD_CMD_CLR_CARD_DETECT, 0x0000, 0x0000, &scdData);
	}
    Sdds_SetTypeCheckR1(&scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}
	return w_Result;
}
#endif /* defined(_SDD_DAT3_PULLUP_DISABLE_) || defined(_SDD_DAT3_PULLUP_PART_DISABLE_) */

#ifdef _SDD_CARDDETECT_SDDAT3_ /* SDDAT3ŃJ[h}oꍇ */
/********************************************************************************/
/*  ֐		FSdds_BeforeCommandTypeWithDat									*/
/*  Tv		FSD_BUFɂf[^MO								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2010.02.05													*/
/********************************************************************************/
SDD_ERROR Sdds_BeforeCommandTypeWithDat( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;	/* SDD_DEV\̂ւ̃|C^ */
	UB	ub_check = SDD_POLLING_OFF;

	/* 1bit[h/4bit[hf */
	if ( !(Sdd_M_CheckReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_OPTION_WIDTH)) ) {
		/* 4bit[h̏ꍇ̂ݏ{ */

		/* J[h}݂̋֎~ */
		Sddr_DisIntCD(p_SddHandle);

		/* nh̒~ */
		/* ()APIƎnhł~/NĂ邪AƏdȂ邱Ƃ͂Ȃ͂ */
		/* APIɂẮAZ}tHŔr䂳ĂȂ */
		/* nhDx̂ŁA~/N͂Ȃ */
		/* dȂ邱Ƃ΁AŒ~Ă鎞ɁAN邱ƂȂ悤ɁA */
		/* Sdds_StopCDDetect()Sdds_StartCDDetect()ŁAN̑Ǘ悤ȏCKv */
		ub_check = Sdds_CheckCDDetect(p_SddHandle);
		if (ub_check == SDD_POLLING_ON) {
			Sdds_StopCDDetect(p_SddHandle);	/* J[h}pnh쒆̏ꍇAꎞIɒ~ */
		}

		/* }os̋ԗL(}o̒~ɂ) */
		p_sdd->ub_DetectState = SDD_STATE_UNDETECTED;

#ifdef _SDD_DAT3_PULLUP_PART_DISABLE_
		if ( ((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_SD ) {
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_BeforeCommandTypeWithDat:Sdds_SendACMD42\n");
			/* SDD_CMD_CLR_CARD_DETECTR}hs(ACMD42) vAbvOFF */
			w_ResTmp = Sdds_SendACMD42(p_SddHandle, FALSE);
			if(w_ResTmp != SDD_SUCCESS) {
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				return w_Result;
			}

			/* SDDAT3[qvAbvؑ vAbvON */
			Sdds_SetPullupSDDAT3(p_SddHandle, TRUE);
		}
#endif /* _SDD_DAT3_PULLUP_PART_DISABLE_ */
	}
	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_AfterCommandTypeWithDat									*/
/*  Tv		FSD_BUFɂf[^M㏈								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2010.02.05													*/
/********************************************************************************/
SDD_ERROR Sdds_AfterCommandTypeWithDat( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;	/* SDD_DEV\̂ւ̃|C^ */
	UB	ub_check = SDD_POLLING_ON;

	/* 1bit[h/4bit[hf */
	if ( !(Sdd_M_CheckReg(SDD_SD_OPTION(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_SD_OPTION_WIDTH)) ) {
		/* 4bit[h̏ꍇ̂ݏ{ */

		/* J[h}&J[hro荞݃NA(SDDAT3̃R}hMő}Ɋ֌WȂtOĂ܂) */
		Sddr_ClrInt(p_SddHandle, SDD_INT_CLR1, (SDD_SD_INFO1_CARDIN | SDD_SD_INFO1_CARDOUT));
		/* J[h}݂̋ */
		Sddr_EnaIntCD(p_SddHandle);

		/* nh̋N */
		/* ()APIƎnhł~/NĂ邪AƏdȂ邱Ƃ͂Ȃ͂ */
		/* APIɂẮAZ}tHŔr䂳ĂȂ */
		/* nhDx̂ŁA~/N͂Ȃ */
		/* dȂ邱Ƃ΁AŒ~Ă鎞ɁAN邱ƂȂ悤ɁA */
		/* Sdds_StopCDDetect()Sdds_StartCDDetect()ŁAN̑Ǘ悤ȏCKv */
		ub_check = Sdds_CheckCDDetect(p_SddHandle);
		if (ub_check == SDD_POLLING_OFF) {
			Sdds_StartCDDetect(p_SddHandle);	/* J[h}pnh~ĂꍇAN */
		}

#ifdef _SDD_DAT3_PULLUP_PART_DISABLE_
		if ( ((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_SD ) {
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_AfterCommandTypeWithDat:Sdds_SendACMD42\n");
			/* SDD_CMD_CLR_CARD_DETECTR}hs(ACMD42) vAbvON */
			w_ResTmp = Sdds_SendACMD42(p_SddHandle, TRUE);
			if(w_ResTmp != SDD_SUCCESS) {
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				return w_Result;
			}

			/* SDDAT3[qvAbvؑ vAbvOFF */
			Sdds_SetPullupSDDAT3(p_SddHandle, FALSE);
		}
#endif /* _SDD_DAT3_PULLUP_PART_DISABLE_ */
	}
	return w_Result;
}
#endif /* _SDD_CARDDETECT_SDDAT3_ */

/********************************************************************************/
/*  ֐		FSdds_GetEraseMin												*/
/*  Tv		FErasełŏTCY(Byte)̎擾								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sdds_GetEraseMin( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	UW uw_MinSize = 0;
	UB ub_WriteBlockLen = 0;
	UB ub_SectorSize = 0;
	UB ub_GroupSize = 0;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/* SD,MMC WRITE_BLK_LEN̎擾 */
	ub_WriteBlockLen = (((p_sdd->ub_Csd[3] & SDD_CSD_WRITE_BL_LEN_BIT_25_24) << 2) & SDD_CSD_WRITE_BL_LEN_BIT_25_24_MASK)
						| (((p_sdd->ub_Csd[2] & SDD_CSD_WRITE_BL_LEN_BIT_23_22) >> 6) & SDD_CSD_WRITE_BL_LEN_BIT_23_22_MASK);

	/* SDJ[h̏ꍇ */
	if(p_sdd->ub_CardType & (UB)SDD_CARD_TYPE_SD){
		/* ERASE_BLK_EN = 1̏ꍇ */
		if(p_sdd->ub_Csd[5] & SDD_CSD_ERASE_BLK_EN_BIT_46_46){
			uw_MinSize = SDD_SECTOR_SIZE;
/*** SDKiVer2.0ΉJnA2005.12.20 ***/
	/* HCJ[h̏ꍇAoffsetP = BLOCK */
			if(p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2))
			{
				uw_MinSize = 1;
			}
/*** SDKiVer2.0ΉENDA2005.12.20 ***/
		/* ERASE_BLK_EN = 0̏ꍇ */
		}else{
			ub_SectorSize = (((p_sdd->ub_Csd[5] & SDD_CSD_SECTOR_SIZE_BIT_45_40) << 1) & SDD_CSD_SECTOR_SIZE_BIT_45_40_MASK)
								| (((p_sdd->ub_Csd[4] & SDD_CSD_SECTOR_SIZE_BIT_39_39) >> 7) & SDD_CSD_SECTOR_SIZE_BIT_39_39_MASK);
			uw_MinSize = (UW)ub_SectorSize + 1;
			uw_MinSize <<= ub_WriteBlockLen;
		}
	/* MMC̏ꍇ */
	}else if(((p_sdd->ub_CardType) & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC){
#ifdef _SDD_ALLOW_MMC_
		if (p_sdd->MmcInfo.uh_SetFunc & SDD_MMC_FUNC_LARGE_ERASE) {
			uw_MinSize = p_sdd->MmcInfo.uw_EraseUnitSize;				/* LargeErase[hΉMMC(MMC-HC Ver4.3)̓ZN^ItZbg */
		} else {
			ub_SectorSize = ((p_sdd->ub_Csd[5] & SDD_CSD_MMC_ERASE_GRP_SIZE_BIT_46_42) >> 2) & SDD_CSD_MMC_ERASE_GRP_SIZE_BIT_46_42_MASK;
			ub_GroupSize = (((p_sdd->ub_Csd[5] & SDD_CSD_MMC_ERASE_GRP_MULT_BIT_41_40) << 3) & SDD_CSD_MMC_ERASE_GRP_MULT_BIT_41_40_MASK)
							| (((p_sdd->ub_Csd[4] & SDD_CSD_MMC_ERASE_GRP_MULT_BIT_39_37) >> 5) & SDD_CSD_MMC_ERASE_GRP_MULT_BIT_39_37_MASK); 
			uw_MinSize = ((UW)ub_SectorSize + 1) * ((UW)ub_GroupSize + 1);
			uw_MinSize <<= ub_WriteBlockLen;
			if (p_sdd->MmcInfo.ub_HcFlag == SDD_MMC_HC){ /* MMC-HC Ver4.2̓ZN^ItZbg */
				uw_MinSize /= SDD_SECTOR_SIZE;
			}
		}
#else
		ub_SectorSize = ((p_sdd->ub_Csd[5] & SDD_CSD_MMC_ERASE_GRP_SIZE_BIT_46_42) >> 2) & SDD_CSD_MMC_ERASE_GRP_SIZE_BIT_46_42_MASK;
		ub_GroupSize = (((p_sdd->ub_Csd[5] & SDD_CSD_MMC_ERASE_GRP_MULT_BIT_41_40) << 3) & SDD_CSD_MMC_ERASE_GRP_MULT_BIT_41_40_MASK)
						| (((p_sdd->ub_Csd[4] & SDD_CSD_MMC_ERASE_GRP_MULT_BIT_39_37) >> 5) & SDD_CSD_MMC_ERASE_GRP_MULT_BIT_39_37_MASK); 
		uw_MinSize = ((UW)ub_SectorSize + 1) * ((UW)ub_GroupSize + 1);
		uw_MinSize <<= ub_WriteBlockLen;
#endif /* _SDD_ALLOW_MMC_ */
	}
	p_sdd->uw_EraseByteMin = uw_MinSize;

	return w_Result;
}

/********************************************************************************/
/*  ֐		FSdds_ReadyCMD													*/
/*  Tv		Ff[^]OSDI/Feݒ1									*/
/* 					荞݋֎~												*/
/* 					G[NA												*/
/* 					荞݋												*/
/* 					CBUSY҂												*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FUH uh_Cmd														*/
/*  ߂l		FFSDD_SUCCESS												*/
/* 	G[		FCBUSY^CAEg												*/
/*  ŏIXV	F2009.03.09													*/
/********************************************************************************/
static SDD_ERROR Sdds_ReadyCMD( SDD_HANDLE *p_SddHandle, UH uh_Cmd )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UW uw_Loop;
	UW uw_Check;

#ifndef _SDD_NO_WAIT_CBUSY_	/* CBUSY҂ */

	/*================================*/
	/* ȌI҂(rW[mF) */
	/*================================*/
	for(uw_Loop = 0; ; uw_Loop++) {
		/* Busy`FbN */
		Sddr_CheckBusy(p_SddHandle, &uw_Check);
		if(uw_Check == 0){	
			break;		/* rW[ */
		}
		if(uw_Loop >= SDD_BUSY_COUNT) {			/* rW[҂񐔂𒴂 */
            Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_ReadyCMD:CBusy TimeOut!\n");
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_ACC_TIMEOUT);
			return w_Result;					/* ^CAEg̃G[ɂ */
		}
		w_ResTmp = Sdd_Delay(SDD_BUSY_WAIT);				/* 莞Ԃ̑҂ */
		w_ResTmp &= ~SDD_ERR_OS_TIMEOUT;	/* SDD_ERR_OS_TIMEOUTNA(K͂)  */
		if(w_ResTmp != SDD_SUCCESS)  {
			/* ߂lFG[Ȃ͂ */
			/* G[Ăʒm͂Ȃ */
		}
	}

#endif /* SDD_WAIT_CBUSY CBUSY҂ */

    /* R}hMOǉ H.Miura 2006/08/07 */
    Sdds_SendCommand_before(p_SddHandle);

/*
	荞݋
	SD_INFO1Res荞݂SD_INFO2̃G[荞݂
	Sddr_EnaIntReadyCMD();
	Fp_SddHandle
	߂lFȂ
*/
	Sddr_EnaIntReadyCMD(p_SddHandle);	/* SD_INFO1Res荞݂SD_INFO2̃G[荞݂ */

    /* EraseR}hp^CAEg}XN */
    if (uh_Cmd == SDD_CMD_ERASE) {
        /* ^CAEg荞݋֎~ */
        Sddr_DisIntEraseCMD(p_SddHandle);
    }
    
	return w_Result;
}



#ifdef _SDD_DETECT_SDIO_
/********************************************************************************/
/*  ֐		FSdds_SDIOInit													*/
/*  Tv		FSDIOSD_COMBOJ[h̏Ȃ							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.6													    */
/********************************************************************************/
SDD_ERROR Sdds_SDIOInit( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*
		SDIOJ[h̃Zbg
		Sdds_ResetIoCard()Ŏs
			Sdds_ResetIoCard()
				Fp_SddHandle
				߂lFG[Ȃ
	*/
	Sdds_ResetIoCard(p_SddHandle);

	/*
		^CAEg^C}X^[g
		Sddt_TimerStart()Ŏs
			Sddt_TimerStart()
				F^CAEgli}N)
				߂lFȂ
	*/

	Sdd_TimerStart(p_SddHandle, SDD_INIT_TIMEOUT_MSEC);

	/*
		CMD5𔭍s
		 R}hs֐(Sdds_SendCMD)Ŏs
		FCMD5
		߂lF
			iSUCCESSj̏ꍇ
				SDIOJ[horSDCOMBOJ[h
				p
			G[iSUCCESSȊOj̏ꍇ
				X|X^CAEg̏ꍇ
						SDMemoryJ[h
						p
				X|X^CAEgȊȌꍇ
						w_Result = G[R[hݒ
						return;
	*/
	w_ResTmp = Sdds_SendIoOpCMD(p_SddHandle);

	Sdd_TimerStop(p_SddHandle);

	if(w_ResTmp == SDD_SUCCESS) {
        /* ]͂ACMD𑗐MComboJ[h𔻒肵ĂA
           ACMD󂯂鎖ɂďԂȂ^CṽJ[h
           ݂鎖ׁAWbNCMD5̖߂lMemoryPresents
           f悤ɕύX(H.Miura 2009/02/24) */
        if (p_sdd->ub_Ocr[3] & SDD_OCR_BIT27_MEMORYPRESENT) {
            p_sdd->ub_CardType = (UB)SDD_CARD_TYPE_COMBO;		/* SDCOMBOJ[hƔ肷 */
        }
        else {
            p_sdd->ub_CardType = (UB)SDD_CARD_TYPE_IO;		/* SDIOJ[hƔ肷 */
        }
        /* T|[gςFunctionL */
        p_sdd->SupportedFunc = (p_sdd->ub_Ocr[3]&SDD_OCR_SUPPORT_FUNC)>>SDD_OCR_SUPPORT_SHIFT;
    }
	else if (w_ResTmp != SDD_ERR_IP_TIMEOUT) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}
	p_sdd->w_error &= ~SDD_ERR_IP_TIMEOUT;	/* SDD_DEVRES^CAEgG[NA (SD-Memory(Combo)łResTimeOut邽) */

	return w_Result;
}

#endif /* _SDD_DETECT_SDIO_ */


/********************************************************************************/
/*  ֐		FSdds_SDInit													*/
/*  Tv		FSDJ[h̏Ȃ								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.6													    */
/********************************************************************************/
SDD_ERROR Sdds_SDInit( SDD_HANDLE *p_SddHandle )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	UB	ub_CardType = (UB)SDD_CARD_TYPE_UNKNOWN;
	UB	ub_MechanicalWP = (UB)0;
	UW	uw_SetDiv;
	UW	uw_class;
#if  defined(_SDD_HIGHSPEEDCLK_)
	UW	uw_SetSpeed = SDD_CARD_FUNC_NO_FUNC;
#endif
#ifdef _SDD_ALLOW_UHS1_
	UW	uw_SetCurrent = SDD_CARD_FUNC_NO_FUNC;
#endif
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
#ifdef _SDD_FUNC_QUICK_BOOT_
	UB	ub_RestartCardInit = 0;
#endif /* _SDD_FUNC_QUICK_BOOT_ */

    /* Xe[^Xj^pvON(1ڂ̂ݎsԂɈڍs) */
    settingStatusMonitor();

#ifdef _SDD_FUNC_QUICK_BOOT_
	if( p_sdd->ub_StartCardInit ){	/* J[hJn */
		if( p_sdd->ub_Cmd8Info ){
			p_sdd->v20.uh_PhyVer = SDD_PHY_VER2;
		}else{
			p_sdd->v20.uh_PhyVer = SDD_PHY_VER1;
		}
		
		if( p_sdd->v20.uh_PhyVer == SDD_PHY_VER2 ){		/* J[h̃rW[mF */
			/* HCJ[h̏ꍇ */
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendNewApOpCMD\n");
			w_ResTmp = Sdds_SendNewApOpCMD(p_SddHandle);
		}else{
			/* SCJ[h̏ꍇ */
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendApOpCMD\n");
			w_ResTmp = Sdds_SendApOpCMD(p_SddHandle);
		}
		
		if(w_ResTmp == SDD_SUCCESS) {
			ub_CardType = (UB)SDD_CARD_TYPE_SD;
		}else{
			ub_RestartCardInit = 0x01;
		}
	}else{							/* J[hJn */
		ub_RestartCardInit = 0x01;
	}

	/* O[oϐ̃NA */
	p_sdd->ub_StartCardInit = 0;
	p_sdd->ub_Cmd8Info = 0;
	
#endif /* _SDD_FUNC_QUICK_BOOT_ */

#ifdef _SDD_FUNC_QUICK_BOOT_
	if( ub_RestartCardInit ){
#endif /* _SDD_FUNC_QUICK_BOOT_ */

	/*
		SDJ[h̃Zbg
		Sdds_ResetCard()Ŏs
			Sdds_ResetCard()
				Fp_SddHandle
				߂lFG[Ȃ
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_ResetCard\n");
	Sdds_ResetCard(p_SddHandle);

/*** SDKiVer2.0ΉJnA2005.12.14 ***/
	/*
		CMD8s
		iSUCCESS)̏ꍇ
		@  
		G[̏ꍇ
				w_Result = G[R[hݒ
				return;
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendCMD8\n");
	w_ResTmp = Sdds_SendCMD8(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*
		^CAEg^C}X^[g
		Sddt_TimerStart()Ŏs
			Sddt_TimerStart()
				F^CAEgli}N)
				߂lFȂ
	*/
	Sdd_TimerStart(p_SddHandle, SDD_INIT_TIMEOUT_MSEC);

	/* 
	   KiVer2.0ΉSDJ[h̏ꍇAVACMD41s
	   KiVer1.x̏ꍇA]ACMD41s
	*/
	if(p_sdd->v20.uh_PhyVer == SDD_PHY_VER2)/* Ver2.0Ή */
	{
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendNewApOpCMD\n");
		w_ResTmp = Sdds_SendNewApOpCMD(p_SddHandle);
		if(w_ResTmp == SDD_SUCCESS) {
			ub_CardType = (UB)SDD_CARD_TYPE_SD;		/* SDJ[hƉ肷 */
		}
	}
	else/* Ver2.0Ή */
	{
/*** SDKiVer2.0ΉENDA2005.12.14 ***/

	/*
		SD or MMC
		RCA=0CMD55sSdds_SendACMD()Ŏs
			Sdds_SendACMD(void)
				Fp_SddHandle
				߂lF
					iSUCCESS)̏ꍇ
						ACMD41s
						Sdds_SendApOpCMD()Ŏs
							Sdds_SendApOpCMD()
								Fp_SddHandle
								߂lF
									iSUCCESS)̏ꍇ
										SDJ[hƉ肷
										1
									G[iSUCCESSȊO)̏ꍇ
										1
					G[iResponse^CAEgG[)̏ꍇ
						MMCJ[hƉ肷
						G[NA
						RCA1ƂCMD1sSdds_SendOpCMD()Ŏs
							Sdds_SendOpCMD()
								Fp_SddHandle
								߂lF
									iSUCCESS)̏ꍇ
										MMCJ[hƔ肷(SDD_DEV.Ub_CardType = MMC)
										1
									G[iSUCCESSȊOj̏ꍇ
										1
					G[iSUCCESSResponse^CAEgȊO)̏ꍇ
						1

			1F
				^CAEg^C}~
				Sddt_TimerStop()Ŏs
				Sddt_TimerStop()
					Fp_SddHandle
					߂lFȂ
				G[L
					G[̏ꍇF
						w_Result = G[R[hݒ
						return;
					G[Ȃ̏ꍇF
						p
	*/
        /* R}hMRg[֐ǉɊւύXǉ 2006/08/08 H.Miura*/
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendApOpCMD\n");
        w_ResTmp = Sdds_SendApOpCMD(p_SddHandle);

		switch(w_ResTmp) {
          case SDD_SUCCESS:			/*  */
            ub_CardType = (UB)SDD_CARD_TYPE_SD;		/* SDJ[hƉ肷 */
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
            Sdd_M_AndReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), ~SDD_MODECTL_MMCMODE0);	/* MODECTRLWX^̃J[h[hSDɐݒ */
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
            /* 1 */
            break;
          case SDD_ERR_IP_TIMEOUT:	/* IP^CAEg */
            if (p_sdd->SddCommandSendData.uh_Cmd == SDD_CMD_PREACMD) {
                /* ACMDMɃG[ꍇ */
				w_ResTmp = Sdds_SendOpCMD(p_SddHandle);
                if(w_ResTmp == SDD_SUCCESS) {
                    p_sdd->ub_CardType = (p_sdd->ub_CardType & ~SDD_CARD_TYPE_MASK) | (UB)SDD_CARD_TYPE_MMC;/* MMCJ[hƌ肷 */
					ub_CardType = (UB)SDD_CARD_TYPE_MMC;		/* MMCJ[hƔ肷 */
					p_sdd->w_error &= ~SDD_ERR_IP_TIMEOUT;	/* SDD_DEVRES^CAEgG[NA */
#if defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_))  /* @date 2013/01/14 sLD3Ή (PSDCD) */
                    Sdd_M_OrReg(SDD_MODECTRL(Sdd_M_GetPortNum(p_SddHandle->ub_Port)), SDD_MODECTL_MMCMODE0);	/* MODECTRLWX^̃J[h[hMMCɐݒ */
#endif	/* defined(_SDD_PEAKS_AVC_) && (defined(_SDD_SLD8_) || defined(_SDD_SLD3_)) */
					/* 1 */
				} else {
					/* 1 */
                }
            }
            /* P */
            break;
          default:
            /* 1 */
            break;
		}
/*** SDKiVer2.0ΉJnA2005.12.16 ***/
	}
/*** SDKiVer2.0ΉENDA2005.12.16 ***/
	/* 1 */
	Sdd_TimerStop(p_SddHandle);

	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

#ifdef _SDD_FUNC_QUICK_BOOT_
	}
#endif /* _SDD_FUNC_QUICK_BOOT_ */

	/* L΍AKvȂ */ 
	/* J[h^Cvunknown̏ꍇ͂Ń^[ */
	/** J[h^Cvunknown̏ꍇw_ResTmpɃG[Ă邽ߏŃ^[Ă **/

#ifdef _SDD_ALLOW_UHS1_
	if((p_sdd->uh_CardType2 & SDD_CARDTYPE2_UHS1) && (p_sdd->uw_TmpOperationMode == SDD_CARD_INIT_MODE_LV)) {
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendCMD11\n");
		w_ResTmp = Sdds_SendCMD11(p_SddHandle);			/* CMD11s˓dؑ(3.3V1.8V) */
		if(w_ResTmp == SDD_SUCCESS) {
			/* SDJ[ht@NVSDR12[hݒ */
			p_sdd->uw_CardFunc = (p_sdd->uw_CardFunc & (~SDD_CARD_FUNC_SPEED_MASK)) | SDD_CARD_FUNC_SDR12; 
			p_sdd->uw_OperationMode =  SDD_CARD_INIT_MODE_LV; /* Iy[V[hm */
		}
		else{
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			return w_Result;
		}
	}
	else {
		/* UHS-IΉJ[h͒ʏ탁[hɑJ */
		p_sdd->uw_TmpOperationMode = SDD_CARD_INIT_MODE_MEMORY;
	}
#endif /* _SDD_ALLOW_UHS1_ */

	/*
		SDJ[h/MMC
		CID擾(CMD2s)
		CMD2sSdds_SendCIDCMD()Ŏs
			Sdds_SendCIDCMD(void)
				Fp_SddHandle
				߂lF
					iSUCCESS)̏ꍇ
						p
					G[iSUCESSȊO)̏ꍇ
						w_Result = G[R[hݒ
						return;
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendCIDCMD\n");
	w_ResTmp = Sdds_SendCIDCMD(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

#ifdef _SDD_ALLOW_MMC_
	/* 
		MMC̃foCXʂ̔(Ver4.3ȍ~Ήj
		CID[113:112]CBXtB[h`FbN
			foCXʁieMMC or Cardj̐ݒ
	*/
	if ((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC){
		if ((p_sdd->ub_Cid[14] & SDD_MMC_CID_CBX_MASK) == SDD_MMC_DEVICE_TYPE_BGA){
			p_sdd->MmcInfo.ub_DeviceType = SDD_MMC_DEVICE_TYPE_BGA;
		} else {
			p_sdd->MmcInfo.ub_DeviceType = SDD_MMC_DEVICE_TYPE_CARD;
		}
	}
#endif /* _SDD_ALLOW_MMC_ */

	/*
		^CAEg^C}X^[g
		Sddt_TimerStart()Ŏs
			Sddt_TimerStart()
				F^CAEgli}N)
				߂lFȂ
	*/
	Sdd_TimerStart(p_SddHandle, SDD_INIT_TIMEOUT_MSEC);

	/*
		NewRCA擾(CMD3s)
		CMD3sSdds_SendRCACMD()
			Sdds_SendRCACMD()
				Fp_SddHandle
				߂lF
					iSUCCESS)̏ꍇ
						擾RCANewRCA(0łȂ)
							NewRCA擾
								p
							NewRCAł͂Ȃ(RCA=0)
								ēxNewRCA擾
								(^CAEg܂߂ăG[܂ŌJԂj
								p
					G[iSUCESSȊO)̏ꍇ
						w_Result = G[R[hݒ
						^CAEg^C}~
						Sddt_TimerStop()Ŏs
							Sddt_TimerStop()
								FȂ
								߂lFȂ
						return;
	*/
	while(1) {
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendRCACMD\n");
		w_ResTmp = Sdds_SendRCACMD(p_SddHandle);
		if(w_ResTmp == SDD_SUCCESS) {
			if(p_sdd->uh_Rca != 0) {
				break;				/* VRCA擾 */
			}
		} else {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			Sdd_TimerStop(p_SddHandle);
			return w_Result;
		}
	}

	/*
		^CAEg^C}~
			Sddt_TimerStop()Ŏs
				Sddt_TimerStop()
					Fp_SddHandle
					߂lFȂ
	*/
	Sdd_TimerStop(p_SddHandle);

	/*
		CSD擾
		Sdds_SendCSDCMD()Ŏs
			Sdds_SendCSDCMD()
				Fp_SddHandle
				߂lF
					iSUCCESS)̏ꍇ
						p
					G[iSUCESSȊO)̏ꍇ
						w_Result = G[R[hݒ
						return;
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendCSDCMD\n");
	w_ResTmp = Sdds_SendCSDCMD(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	
	/* CSD_STRUCTURẼ`FbN */
	if((ub_CardType & SDD_CARD_TYPE_MASK) & (UB)SDD_CARD_TYPE_SD){ 
		if( p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2) ){						/* Ver.2.00J[hi2GBj*/
#ifndef _SDD_ALLOW_ILL_CSD_STRUCTURE_V2HC_
			if( (p_sdd->ub_Csd[15] & SDD_CSD_STRUCTURE_MASK) != SDD_CSD_STRUCTURE_V20 ){	/* CSD_STRUCTURE1łȂ */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
				return w_Result;
			}
#endif /* _SDD_ALLOW_ILL_CSD_STRUCTURE_V2HC_ */
		}else if( p_sdd->v20.uh_PhyVer == (SDD_PHY_LCCARD | SDD_PHY_VER2) ){				/* Ver.2.00J[hi2GBȉj*/
#ifndef _SDD_ALLOW_ILL_CSD_STRUCTURE_V2LC_
			if( (p_sdd->ub_Csd[15] & SDD_CSD_STRUCTURE_MASK) != SDD_CSD_STRUCTURE_V10 ){	/* CSD_STRUCTURE0łȂ */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
				return w_Result;
			}
#endif /* _SDD_ALLOW_ILL_CSD_STRUCTURE_V2LC_ */
		}else{																				/* Ver.1.XXJ[hi2GBȉj*/
#ifndef _SDD_ALLOW_ILL_CSD_STRUCTURE_V1_
			if( (p_sdd->ub_Csd[15] & SDD_CSD_STRUCTURE_MASK) != SDD_CSD_STRUCTURE_V10 ){	/* CSD_STRUCTURE0łȂ */
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
				return w_Result;
			}
#endif /* _SDD_ALLOW_ILL_CSD_STRUCTURE_V1_ */
		}
	}
	
#ifdef _SDD_ALLOW_MMC_
	/*
		MMC̏ꍇACSDMMCKiVer擾
	*/
	if ((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC){
		p_sdd->MmcInfo.ub_Spec = ((p_sdd->ub_Csd[15] & SDD_MMC_CSD_SPEC_VERS_MASK) >> 2);
	}
#endif /* _SDD_ALLOW_MMC_ */

#ifndef _SDD_NO_WPCHECK_
	Sddr_GetMechanicalWP(p_SddHandle, &ub_MechanicalWP);			/* J[hWP */
	if(ub_MechanicalWP == SDD_MECHANICALWP_ON) {	/* CgveNg̏ꍇ */
		p_sdd->uw_Wp |= SDD_WP_MECHANICAL;					/* J[hWPveNgݒ*/
	}
#endif
	/* CSDCCC WP擾[84:95] */
	uw_class = ((((UW)(p_sdd->ub_Csd[SDD_CSD_CCC_BYTE_OFFSET1]) >> SDD_CSD_CCC_BIT_SHIFT1) & SDD_CSD_CCC_MASK1) | 
				(((UW)(p_sdd->ub_Csd[SDD_CSD_CCC_BYTE_OFFSET2]) << SDD_CSD_CCC_BIT_SHIFT2) & SDD_CSD_CCC_MASK2));
	if ((uw_class & SDD_CSD_CLASS_4) == 0) {
		p_sdd->uw_Wp |= SDD_WP_CCC_BLOCK_WRITE;
	}
	if ((uw_class & SDD_CSD_CLASS_5) == 0) {
		p_sdd->uw_Wp |= SDD_WP_CCC_ERASE;
	}
	/* CSDPermanent WP擾[13:13] */
	if (p_sdd->ub_Csd[SDD_CSD_PWP_BYTE_OFFSET] & SDD_CSD_PWP_MASK) {
		p_sdd->uw_Wp |= SDD_WP_PERMANENT;
	}
	/* CSDTmp WP擾[12:12] */
	if (p_sdd->ub_Csd[SDD_CSD_TWP_BYTE_OFFSET] & SDD_CSD_TWP_MASK) {
		p_sdd->uw_Wp |= SDD_WP_TEMPORARY;
	}
#ifdef _WP_ROM_CARD_
	/* łCgveNgROMJ[hbitݒ */
	if(p_sdd->uw_Wp){
		p_sdd->ub_CardType |= (UB)SDD_CARD_TYPE_ROM;
		p_sdd->uw_Wp |= SDD_WP_ROMCARD;
	}
#endif
	/*
		SD CLK̕ݒ
		Sddr_SetClkDivŎs
			 : p_SddHandle, FULLSPEED
			߂lFȂ
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_CheckSetDiv\n");
	w_ResTmp = Sdds_CheckSetDiv(p_SddHandle, SDD_CLOCK_DIV_FULLSPEED, &uw_SetDiv);
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	Sddr_SetClkDiv(p_SddHandle, uw_SetDiv);	/* uw_SetDivɕݒ */

	/*================================================*/
	/* ύXɂƂȂ^CAEgTCN̕ύX */
	/*================================================*/
	/* 
		TOP[27:24](SD_OPTIONWX^j̐ݒ
		Sddr_SetClkDivŎs
			Fp_SddHandle, SDD_CLOCK_DIV_1`512̂ǂꂩ
			߂lFȂ
	*/		
	Sddr_SetTimeOutCycle(p_SddHandle, uw_SetDiv);

	/*
		J[hZNgiCMD7)
		Sdds_SendSelectCMD()Ŏs
			Sdds_SendSelectCMD()
				Fp_SddHandle, TRUEiSelect)
				߂lF
					iSUCCESS)̏ꍇ
						p
					G[iSUCESSȊO)̏ꍇ
						w_Result = G[R[hݒ
						return;
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendSelectCMD\n");
	w_ResTmp = Sdds_SendSelectCMD(p_SddHandle, TRUE);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*
		]ubNTCYݒ
		Sdds_SetBlockLength(UW uw_BlockLength)Ŏs
			Sdds_SetBlockLength
				F512Bi}Nl)
				߂lF
					iSUCCESS)̏ꍇ
						p
					G[iSUCESSȊO)̏ꍇ
						w_Result = G[R[hݒ
						return;
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SetBlockLength\n");
	w_ResTmp = Sdds_SetBlockLength(p_SddHandle, SDD_SECTOR_SIZE);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	p_sdd->uw_SectorSize = SDD_SECTOR_SIZE;				/* ZN^TCY */

#ifdef _SDD_DAT3_PULLUP_DISABLE_
	if(ub_CardType == (UB)SDD_CARD_TYPE_SD) {
		Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendACMD42\n");
		w_ResTmp = Sdds_SendACMD42(p_SddHandle, FALSE);
		if(w_ResTmp != SDD_SUCCESS) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			return w_Result;
		}
	}
#endif /* _SDD_DAT3_PULLUP_DISABLE_ */

	/*
		SDoX̕ύX
		Sdds_SetBusWidth()Ŏs
			Fp_SddHandle, ݒoX(1bit, SDR[h̏ꍇ4bit)
			߂lFȂ
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SetBusWidth\n");
	if((p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK) == SDD_CARD_FUNC_SDR12){
		w_ResTmp = Sdds_SetBusWidth(p_SddHandle, SDD_BUS_WIDTH_4);
	}
	else{ 
		w_ResTmp = Sdds_SetBusWidth(p_SddHandle, SDD_BUS_WIDTH_1);
	}
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*
		SCR̎擾
		SDJ[hƉ肳ꂽꍇ̂SCR̎擾s
		Sdds_SendSCRCMD()Ŏs
			Sdds_SendSCRCMD();
				Fp_SddHandle
				߂lF
					iSUCCESS)̏ꍇ
						p
					G[iSUCESSȊO)̏ꍇ
						w_Result = G[R[hݒ
						return;
	*/
	/* SDJ[h̏ꍇ */
	if(ub_CardType == (UB)SDD_CARD_TYPE_SD) {
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendSCR\n");
		w_ResTmp = Sdds_SendSCR(p_SddHandle);
		if(w_ResTmp != SDD_SUCCESS) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			return w_Result;
		}
		
		/* SD_SPEC̃`FbN */
		if( p_sdd->v20.uh_PhyVer == (SDD_PHY_HCCARD | SDD_PHY_VER2) ){			/* Ver.2.00J[hi2GBj*/
#ifndef _SDD_ALLOW_ILL_SD_SPEC_V2HC_
			if( (p_sdd->ub_Scr[0] & SDD_SCR_SD_SPEC_59_56) < SDD_SCR_SD_SPEC_VER_2_00 ){
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);			/* SD_SPEC0܂1 */
				return w_Result;
			}
#endif /* _SDD_ALLOW_ILL_SD_SPEC_V2HC_ */
		}else if( p_sdd->v20.uh_PhyVer == (SDD_PHY_LCCARD | SDD_PHY_VER2) ){		/* Ver.2.00J[hi2GBȉj*/
#ifdef _SDD_DENY_ILL_SD_SPEC_V2LC_
			if( (p_sdd->ub_Scr[0] & SDD_SCR_SD_SPEC_59_56) < SDD_SCR_SD_SPEC_VER_2_00 ){
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);			/* SD_SPEC0܂1 */
				return w_Result;
			}
#endif /* _SDD_DENY_ILL_SD_SPEC_V2LC_ */
		}else{																	/* Ver.1.XXJ[hi2GBȉj*/
#ifdef _SDD_DENY_ILL_SD_SPEC_V1_
			if( (p_sdd->ub_Scr[0] & SDD_SCR_SD_SPEC_59_56) >= SDD_SCR_SD_SPEC_VER_2_00 ){
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);			/* SD_SPEC2ȏ */
				return w_Result;
			}
#endif /* _SDD_DENY_ILL_SD_SPEC_V1_ */
		}
		
		/* SD_SPEC3`FbN */
		/* SDKiVer3.01ɋKi鎟XSDJ[hɑ΂ANZXΉ */
		/* {oĂȂo[WłĂhCoʂĂ܂p */
		if( ((p_sdd->ub_Scr[0] & SDD_SCR_SD_SPEC_59_56) >= SDD_SCR_SD_SPEC_VER_2_00)
			&& (p_sdd->ub_Scr[2] & SDD_SCR_SD_SPEC3_47))
		{
			p_sdd->v20.ub_PhyExt |= SDD_PHY_VER3;
			if (p_sdd->ub_Scr[3] & SDD_SCR_CMD_SUPPORT_32){
				 p_sdd->uh_CardType2 |= SDD_CARDTYPE2_CLASS_RECORD;
			}
		}
		
		
/*** SDKiVer2.0ΉJnA2005.12.16 ***/
		/* J[hbNH
		@bNFbNL^AoXݒ肹
		@񃍃bNFoXݒ
		*/
		if(((p_sdd->uw_CardStatus) & SDD_CARD_STATUS_LOCK) == SDD_CARD_STATUS_LOCK)
		{
			p_sdd->v20.ub_Lock = SDD_PHY_SET;/* bNꂽ */
		}
		else
		{
			p_sdd->v20.ub_Lock = SDD_PHY_CLEAR;/* bNĂȂ */

		/*
			SDoX̕ύX
			if(MMC){
				1bitoX
			}
			else{
				4bitoX
			}
			Sdds_SetBusWidth()Ŏs
				FݒoX(1bit or 4bit)
				߂lFȂ
				CSD̒l4bitoXɂłȂꍇ͓
				1bitɂ(I4bitłȂSDJ[h݂͑Ȃ̂ŖȂ)
		*/

			/* TSR1{[hłDAT3̐ڑsꍇ̂4bitoXڑ\ */
			/* SDR12[h̏ꍇ͂łɐݒ */
			if((p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK) != SDD_CARD_FUNC_SDR12){
            	Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SetBusWidth\n");
				w_ResTmp = Sdds_SetBusWidth(p_SddHandle, SDD_BUS_WIDTH_4);
				if (w_ResTmp != SDD_SUCCESS) {
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
					return w_Result;
				}
			}
		}
/*** SDKiVer2.0ΉENDA2005.12.16 ***/
#if  defined(_SDD_HIGHSPEEDCLK_)
		if(p_sdd->ub_HighspeedInfo == SDD_HIGHSPEEDCLK_USED) {

			/* J[ht@NVݒ̊mF */
			if((p_sdd->uw_CardFunc & SDD_CARD_FUNC_SPEED_MASK) == SDD_CARD_FUNC_SDR12){
			/* Xs[h[hݒ */
#ifdef _SDD_ALLOW_UHS1_
				if (p_sdd->ub_UHS1Info == SDD_ALLOW_UHS1_USED) {
#if SDD_UHS_MODE == SDD_UHS_MODE_SDR25
					uw_SetSpeed = SDD_CARD_FUNC_SDR25;
#elif SDD_UHS_MODE == SDD_UHS_MODE_SDR50
					uw_SetSpeed = SDD_CARD_FUNC_SDR50;
#endif
				/* dݒ */
#if SDD_UHS_CURRENT_LIMIT == SDD_UHS_CURRENT_400MA
					uw_SetCurrent = SDD_CARD_FUNC_CL400MA;
#elif SDD_UHS_CURRENT_LIMIT == SDD_UHS_CURRENT_600MA
					uw_SetCurrent = SDD_CARD_FUNC_CL600MA;
#elif SDD_UHS_CURRENT_LIMIT == SDD_UHS_CURRENT_800MA
					uw_SetCurrent = SDD_CARD_FUNC_CL800MA;
#endif
				} else {
					uw_SetSpeed = SDD_CARD_FUNC_NO_FUNC;
				}
#else
				uw_SetSpeed = SDD_CARD_FUNC_NO_FUNC;
#endif /* _SDD_ALLOW_UHS1_ */
			}
			else{	/* SDR12[hłȂƂ */
				uw_SetSpeed =  SDD_CARD_FUNC_HIGH_SPEED;
			}

			/*	J[ht@NVR}h(CMD6)ΉiSCRSD_SPEC!=0łȂjƂ	*/
			 if ((p_sdd->ub_Scr[0] & SDD_SCR_SD_SPEC_59_56) != SDD_SCR_SD_SPEC_VER_1_01) {
				/* Xs[h[h̐ݒ{Ƃ */
				if(uw_SetSpeed != SDD_CARD_FUNC_NO_FUNC){
					do {
						/*  
							Xs[h[hݒ
							Sdds_SetCardFunction()Ŏ{
								Xs[h[hΉ`FbNR}hiCMD6 mode0js
				  				Read Data̓dl`FbN(G[̏ꍇ0V)
	 			 				Xs[h[hݒR}h (CMD6 mode1) s	
	 			 				Read Data̓dl`FbNiG[̏ꍇ0V)
									Fp_SddHandle, uw_SetSpeed
									߂lF
										iSUCCESS)̏ꍇ
											p
										G[iSUCESSȊO)̏ꍇ
											w_Result = G[R[hݒ
											return;
						*/
		                Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SetCardFunction\n");
						w_ResTmp = Sdds_SetCardFunction(p_SddHandle, uw_SetSpeed);
						if (w_ResTmp != SDD_SUCCESS) {
							if (w_ResTmp == SDD_ERR_NOT_SUPPORT) {	/* ړĨXs[h[hΉJ[h̏ꍇ */
								break;
							}
							w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
							return w_Result;
						}
						/* SDJ[hJ[ht@NVɃXs[h[hݒ */
						p_sdd->uw_CardFunc = (p_sdd->uw_CardFunc & (~SDD_CARD_FUNC_SPEED_MASK)) | uw_SetSpeed;

						/*
							J[hZNgiCMD7)
							Sdds_SendSelectCMD()Ŏs
								Sdds_SendSelectCMD()
									Fp_SddHandle, FALSEiDe-Select)
									߂lF
										iSUCCESS)̏ꍇ
											p
										G[iSUCESSȊO)̏ꍇ
											w_Result = G[R[hݒ
											return;
						*/
	             	   Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendSelectCMD\n");
						w_ResTmp = Sdds_SendSelectCMD(p_SddHandle, FALSE);
						if(w_ResTmp != SDD_SUCCESS) {
							w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
							return w_Result;
						}

						/*
							CSD擾
							Sdds_SendCSDCMD()Ŏs
								Sdds_SendCSDCMD()
									Fp_SddHandle
									߂lF
										iSUCCESS)̏ꍇ
											p
										G[iSUCESSȊO)̏ꍇ
											w_Result = G[R[hݒ
											return;
						*/
	            	    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendCSDCMD\n");
						w_ResTmp = Sdds_SendCSDCMD(p_SddHandle);
						if(w_ResTmp != SDD_SUCCESS) {
							w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
							return w_Result;
						}

						/*
							SD CLK̕ݒ
							Sddr_SetClkDivŎs
								Fp_SddHandle, FULLSPEED
								߂lFȂ
						*/
						Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_CheckSetDiv\n");
						w_ResTmp = Sdds_CheckSetDiv(p_SddHandle, SDD_CLOCK_DIV_FULLSPEED, &uw_SetDiv);
						if (w_ResTmp != SDD_SUCCESS) {
							w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
							return w_Result;
						}
						Sddr_SetClkDiv(p_SddHandle, uw_SetDiv);	/* uw_SetDivɕݒ */
						/*================================================*/
						/* ύXɂƂȂ^CAEgTCN̕ύX */
						/*================================================*/
						/* 
							TOP[27:24](SD_OPTIONWX^j̐ݒ
							Sddr_SetClkDivŎs
								 = SDD_CLOCK_DIV_1`512̂ǂꂩ
								߂lFȂ
						*/		
						Sddr_SetTimeOutCycle(p_SddHandle, uw_SetDiv);

						/*
							J[hZNgiCMD7)
							Sdds_SendSelectCMD()Ŏs
								Sdds_SendSelectCMD()
									FTRUEiSelect)
									߂lF
										iSUCCESS)̏ꍇ
											p
										G[iSUCESSȊO)̏ꍇ
											w_Result = G[R[hݒ
											return;
						*/
	         	       Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendSelectCMD\n");
						w_ResTmp = Sdds_SendSelectCMD(p_SddHandle, TRUE);
						if(w_ResTmp != SDD_SUCCESS) {
							w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
							return w_Result;
						}
					} while(0);	/* [vł͂Ȃ */
				}
#ifdef _SDD_ALLOW_UHS1_
				if ((p_sdd->ub_UHS1Info == SDD_ALLOW_UHS1_USED)
				 && (uw_SetCurrent != SDD_CARD_FUNC_NO_FUNC)) {
					do {
						/*  
							dݒ
							Sdds_SetCardFunction()Ŏ{
								dΉ`FbNR}hiCMD6 mode0js
				  				Read Data̓dl`FbN(G[̏ꍇ0V)
	 			 				dݒR}h (CMD6 mode1) s	
	 			 				Read Data̓dl`FbNiG[̏ꍇ0V)
									Fuw_SetCurrent
									߂lF
										iSUCCESS)̏ꍇ
											p
										G[iSUCESSȊO)̏ꍇ
											w_Result = G[R[hݒ
											return;
						*/
	        	        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SetCardFunction\n");
						w_ResTmp = Sdds_SetCardFunction(p_SddHandle, uw_SetCurrent);
						if (w_ResTmp != SDD_SUCCESS) {
							if (w_ResTmp == SDD_ERR_NOT_SUPPORT) {	/* ړȈdΉJ[h̏ꍇ */
								break;
							}
							w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
							return w_Result;
						}
						/* SDJ[hJ[ht@NVɏdݒ */
						p_sdd->uw_CardFunc = (p_sdd->uw_CardFunc & (~SDD_CARD_FUNC_CL_MASK)) | uw_SetCurrent;
					} while(0);	/* [vł͂Ȃ */
				}
#endif /* _SDD_ALLOW_UHS1_ */
			}
		}
#endif /* _SDD_HIGHSPEEDCLK_ */
		/* 
			SD Status擾 
			Sdds_SendSelectCMD()Ŏs
				Sdds_SendSdStatus()
					Fp_SddHandle
					߂lF
						iSUCCESS)̏ꍇ
							p
						G[iSUCESSȊO)̏ꍇ
							w_Result = G[R[hݒ
							return;	
		*/
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_SendSdStatus\n");
		w_ResTmp = Sdds_SendSdStatus(p_SddHandle);
		if(w_ResTmp != SDD_SUCCESS) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			return w_Result;
		}

        /*@SD̏ꍇROMJ[h̔ȂBMMC͂łp_sdd->ub_CardTypeɐݒ肵Ă  */
		if((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) != SDD_CARD_TYPE_COMBO){
				p_sdd->ub_CardType = (p_sdd->ub_CardType & ~SDD_CARD_TYPE_MASK) | (UB)SDD_CARD_TYPE_SD;	/* SDJ[hƌ肷 */
		}
		if((p_sdd->ub_SdStatus[3]) & SDD_SDSTATUS_CARD_TYPE_ROM_MASK){
			p_sdd->ub_CardType |= (UB)SDD_CARD_TYPE_ROM;	/* SD ROMJ[hƌ肷 */
			p_sdd->uw_Wp |= SDD_WP_ROMCARD;
		}
		
		if((p_sdd->ub_SdStatus[3]) & SDD_SDSTATUS_CARD_TYPE_OTP_MASK){
			p_sdd->uh_CardType2 |= SDD_CARDTYPE2_OTP;	/* SD OTPJ[hƌ肷 */
		}

		/*** SDKiVer2.0ΉJnA2005.12.19 ***/
		p_sdd->v20.ub_Class = p_sdd->ub_SdStatus[8];			/* Sppeed Class */
		p_sdd->v20.ub_Perfm = p_sdd->ub_SdStatus[9];			/* MOVE Performance */
		p_sdd->v20.ub_Au = (p_sdd->ub_SdStatus[10] & SDD_AUSIZE_MASK) >> 4;	/* AU Size */
		p_sdd->v20.ub_ErTm = ((p_sdd->ub_SdStatus[13]) & SDD_ERASETMOUT_MASK) >> 2;	/* Erase TimeOut	*/
		p_sdd->v20.ub_ErOffset = (p_sdd->ub_SdStatus[13]) & SDD_ERASEOFFSET_MASK;	/* Erase Time Offset*/
		p_sdd->v20.uh_ErSize = ((UH)(p_sdd->ub_SdStatus[11]) << 8) | (p_sdd->ub_SdStatus[12]);/* Erase Size by AU */
		if(p_sdd->v20.ub_Class != 0){
			/* J[h^CvɃptH[}X^Cvǉ */
			p_sdd->ub_CardType |= SDD_CARD_TYPE_PERFORMANCE;
		}

    } 	/* SDJ[ĥ݂̏͂܂ */

#ifdef _SDD_ALLOW_MMC_
	/* 
		MMCgiVer4.3KiΉj
		MMCKiVer.4.0ȏ̏ꍇ͉L̏{
			EXT-CSD擾
			4bit[hݒ
			pCXs[h[hݒ
			p[NXݒ
			LargeErase[hݒ
	*/
	if (((p_sdd->ub_CardType & SDD_CARD_TYPE_MASK) == (UB)SDD_CARD_TYPE_MMC) 
		&& (p_sdd->MmcInfo.ub_Spec >= SDD_MMC_SPEC_VERS_4)){
			w_ResTmp = Sdds_MmcSetExtension(p_SddHandle);
			if (w_ResTmp !=  SDD_SUCCESS) {
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				return w_Result;
			}
		}
#endif

	Sdds_SdcardSizeCalc(p_SddHandle);
	
	/* sJ[heʂ̃`FbN */
	/*  */
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_CheckCardSize\n");
	w_ResTmp = Sdds_CheckCardSize(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	
/*** SDKiVer2.0ΉENDA2005.12.19 ***/
	/*
		Erase\P(Byte)̌iCSDZoj
		FȂ
		߂lFG[Ȃ
	*/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_GetEraseMin\n");
	w_ResTmp = Sdds_GetEraseMin(p_SddHandle);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

	/*** ǗpJ[h擾 ***/
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SDInit:Sdds_GetCardInfo\n");
	Sdds_GetCardInfo(p_SddHandle);
    Sdds_PrintCardInfo(p_SddHandle);

	return w_Result;
}

#if	defined(_SDD_HIGHSPEEDCLK_)
/********************************************************************************/
/*  ֐		FSdds_SetCardFunction											*/
/*  Tv		FSDKiVer1.10Ή Card Functionݒ							*/
/*				ubNTCYݒi64Byte)										*/
/*				FucntionΉCheck(CMD6s mode0)								*/
/*				G[`FbN													*/
/*				Functionݒ(CMD6s mode1)									*/
/*				G[`FbN													*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FgpFunction												*/
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2009.03.06													*/
/********************************************************************************/
SDD_ERROR Sdds_SetCardFunction(SDD_HANDLE *p_SddHandle, UW uw_Function)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*
		Card Function`FbN(CMD6:MODE0)
		Sdds_CtrlCardFunctionŎ{
		FMODE0, Card Function
		߂lF
			iSUCCESS)̏ꍇ
				p
			G[iSUCCESSȊOj̏ꍇ
				w_Result = G[lݒ;
				return;
	*/
	w_ResTmp = Sdds_CtrlCardFunction(p_SddHandle, SDD_CARD_FUNC_MODE0, uw_Function);
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}

#if !defined(_SDD_HIGHSPEEDCLK_)
    /* HighSpeed[h̏sȂȂꍇɂ́AȂ */
#else
	if(p_sdd->ub_HighspeedInfo == SDD_HIGHSPEEDCLK_USED) {
		/*
			Card Functionݒ(CMD6:MODE1)
			Sdds_CtrlCardFunctionŎ{
			FMODE1, Card Function
			߂lF
				iSUCCESS)̏ꍇ
					p
				G[iSUCCESSȊOj̏ꍇ
					w_Result = G[lݒ;
		*/
		w_ResTmp = Sdds_CtrlCardFunction(p_SddHandle, SDD_CARD_FUNC_MODE1, uw_Function);
		if (w_ResTmp != SDD_SUCCESS) {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		}
	}
#endif
	
	return w_Result;
}
#endif

/********************************************************************************/
/*  ֐		FSdds_NonSecureCardProcess										*/
/*  Tv		FFؗ̈ȂJ[h				                        */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FSDD_ERROR SDD_SUCCESS                                     */
/*                          Fؗ̈ȂJ[h̏ꍇSDD_ERR_NOT_SUPPORT         */
/*  ŏIXV	F2009.03.10													*/
/********************************************************************************/
SDD_ERROR Sdds_NonSecureCardProcess(SDD_HANDLE *p_SddHandle){
#ifdef _SDD_ALLOW_NON_SECURE_
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    if (p_sdd->ub_CardType&SDD_CARD_TYPE_NONSECURE) {
        return SDD_ERR_NOT_SUPPORT;
    }
#endif /* _SDD_ALLOW_NON_SECURE_ */
    return SDD_SUCCESS;
}

/********************************************************************************/
/*  ֐		FSdds_SendCommand												*/
/*  Tv		F*pscdDataR}hf[^^Cv	                            */
/*                ÂAR}hM{                                */
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FSDD_COMMAND_DATA *pscdData R}hf[^           */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.9													    */
/********************************************************************************/
SDD_ERROR Sdds_SendCommand(SDD_HANDLE *p_SddHandle, SDD_COMMAND_DATA *pscdData) {
	SDD_ERROR w_Result = SDD_SUCCESS; /* ߂l */
	SDD_ERROR w_ResTmp = SDD_SUCCESS; /* ߂lꎞi[p */
	SDD_ERROR w_R1;                   /* ߂lR1`FbNp */
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

#ifdef _SDD_SPEED_KENSHO_ /* x{ */
    SYSTIM systim;
    UW uw_Timer;        /* xp^C}l */
    UW i;
#endif /* _SDD_SPEED_KENSHO_ */
    
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand>\n");
    
    if (pscdData->uh_Type & SDD_COMMAND_TYPE_WITHDAT) {
        /* f[^M{Ăꍇ */

#ifdef _SDD_CARDDETECT_SDDAT3_ /* SDDAT3ŃJ[h}oꍇ */
		/* SD_BUFɂf[^MO */
		w_ResTmp = Sdds_BeforeCommandTypeWithDat(p_SddHandle);
		if (w_ResTmp != SDD_SUCCESS) {
			/* G[{ */
			Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:BeforeWithDat=%lX\n", w_ResTmp);
			goto SDDS_SENDCOMMAND_END;
		}
#endif /* _SDD_CARDDETECT_SDDAT3_ */

        /* ubNTCYύX菈 */
        if (pscdData->uw_BlockSize != SDD_SECTOR_SIZE) {
            /* ubNTCYύX */
#ifdef _SDD_FUNC_SDIO_
            if (Sdds_OperationModeCheck(p_SddHandle, SDD_CARD_INIT_MODE_SDIO) == SDD_SUCCESS) {
                /* SDIO[hɂ́ASDIOp̃ubNTCYύXs */
                if (p_sdd->MaxBlockLength[p_sdd->ub_FuncNo] != pscdData->uw_BlockSize) {
                    /* ubNTCYقȂꍇ̂ݕύX */
                    w_ResTmp = Sdds_IO_SetBlockLength(p_SddHandle, pscdData->uw_BlockSize, p_sdd->ub_FuncNo);
                }
            }
            else {
				/*===================================*/
				/* ]f[^WX^ݒ(SD_SIZE) */
				/*===================================*/
				/*
					]f[^WX^ݒ֐(Sddr_SetLength)
					FݒubNiLXgϊKvHj
					߂lFG[Ȃ
				*/
				Sddr_SetLength(p_SddHandle, pscdData->uw_BlockSize);
				w_ResTmp = SDD_SUCCESS;
            }
            if(w_ResTmp != SDD_SUCCESS) {
                /* G[{ */
                Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:SetBlockLen=%lX\n", w_ResTmp);
                goto SDDS_SENDCOMMAND_END;
            }
#else
			/*===================================*/
			/* ]f[^WX^ݒ(SD_SIZE) */
			/*===================================*/
			/*
				]f[^WX^ݒ֐(Sddr_SetLength)
				FݒubNiLXgϊKvHj
				߂lFG[Ȃ
			*/
			Sddr_SetLength(p_SddHandle, pscdData->uw_BlockSize);
#endif
        }

        /* ZN^JE^ݒ菈 */
        if (pscdData->uw_SendSec > 1 ||
            pscdData->uh_Cmd == SDD_CMD_GETMKB ||
            pscdData->uh_Cmd == SDD_CMD_SECURE_MULTIREAD ||
            pscdData->uh_Cmd == SDD_CMD_SECURE_MULTIWRITE
#ifdef _SDD_FUNC_SDIO_
            || ((pscdData->uh_Cmd)&0x3F) == (SDD_CMD_IO_RW_EXTENDED_READ&0x3F)
            || ((pscdData->uh_Cmd)&0x3F) == (SDD_CMD_IO_RW_EXTENDED_WRITE&0x3F)
#endif
            ) {
            Sddr_SetSecCnt(p_SddHandle, pscdData->uw_SendSec);
        }
        else {
            Sddr_DisSecCnt(p_SddHandle);		/* VO]SD_SECCNT𖳌ɂ */
        }
#ifndef _SDD_DMA_TRANSFER_AFTER_COMMAND_
        /* DMA] */
        if (pscdData->uh_Type & SDD_COMMAND_TYPE_DMA && !(pscdData->uh_Type & SDD_COMMAND_TYPE_NORWE) ) {
            /* M */
            if (pscdData->uh_Type & SDD_COMMAND_TYPE_WRITE) {
                /* Write] */
                w_ResTmp = Sdds_StartSdma(p_SddHandle, pscdData->uw_SendSec, (UW)(pscdData->pub_Buff), SDD_DMA_WRITE);
            }
            else {
                /* Read] */
                w_ResTmp = Sdds_StartSdma(p_SddHandle, pscdData->uw_SendSec, (UW)(pscdData->pub_Buff), SDD_DMA_READ);
            }
            if (w_ResTmp != SDD_SUCCESS) {
                /* G[{ */
                Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:StartSdma=%lX\n", w_ResTmp);
                goto SDDS_SENDCOMMAND_END;
            }
        }
#endif /* _SDD_DMA_TRANSFER_AFTER_COMMAND_ */
    }
    /* CMD55M菈 */
    if (pscdData->uh_Cmd&SDD_CMD_ACMD) {
        /* ACMDM */
        w_ResTmp = Sdds_SendACMD(p_SddHandle);

        if(w_ResTmp != SDD_SUCCESS) {
            /* G[{ */
            Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:ACMD=%lX\n", w_ResTmp);
#ifndef _SDD_DMA_TRANSFER_AFTER_COMMAND_
			/* DMA] */
			if (  pscdData->uh_Type & SDD_COMMAND_TYPE_WITHDAT
			 &&   pscdData->uh_Type & SDD_COMMAND_TYPE_DMA
			 && !(pscdData->uh_Type & SDD_COMMAND_TYPE_NORWE) ) {
				/* Sdds_StartSdma(){ς݂Ȃ̂ŁASdds_StopSdma(){ */
				w_Result |= w_ResTmp;
				w_ResTmp = Sdds_StopSdma(p_SddHandle);
			}
#endif /* _SDD_DMA_TRANSFER_AFTER_COMMAND_ */
			goto SDDS_SENDCOMMAND_END;
        }
    }

    /* 荞݋ */
    w_ResTmp = Sdds_ReadyCMD(p_SddHandle, pscdData->uh_Cmd);
    if(w_ResTmp != SDD_SUCCESS ) {
        /* G[{ */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:ReadyCMD=%lX\n", w_ResTmp);
#ifndef _SDD_DMA_TRANSFER_AFTER_COMMAND_
        /* DMA] */
		if (  pscdData->uh_Type & SDD_COMMAND_TYPE_WITHDAT
		 &&   pscdData->uh_Type & SDD_COMMAND_TYPE_DMA
		 && !(pscdData->uh_Type & SDD_COMMAND_TYPE_NORWE) ) {
			/* Sdds_StartSdma(){ς݂Ȃ̂ŁASdds_StopSdma(){ */
				w_Result |= w_ResTmp;
				w_ResTmp = Sdds_StopSdma(p_SddHandle);
		}
#endif /* _SDD_DMA_TRANSFER_AFTER_COMMAND_ */
		goto SDDS_SENDCOMMAND_END;
    }

    if (pscdData->uh_Type & SDD_COMMAND_TYPE_WITHDAT
#ifdef _SDD_FUNC_SDIO_
        && (Sdds_OperationModeCheck(p_SddHandle, SDD_CARD_INIT_MODE_SDIO) != SDD_SUCCESS) /* SDIOɂCMD12𔭍sȂ */
#endif
        ) {
        /* f[^M{Ăꍇ */
        /* CMD12sݒ */
        Sddr_SetStop(p_SddHandle, SDD_STOP_NONSTP);
    }
    
    /* R}hf[^L */
    Sdd_memcpy(p_SddHandle, &(p_sdd->SddCommandSendData), pscdData, sizeof(SDD_COMMAND_DATA));
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uh_Type=0x%X\n", pscdData->uh_Type);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uw_REndTimeOut=%ld\n", pscdData->uw_REndTimeOut);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uw_AEndTimeOut=%ld\n", pscdData->uw_AEndTimeOut);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uw_REndTimeOut=%ld\n", pscdData->uw_REndTimeOut);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uw_SendSec=%ld\n", pscdData->uw_SendSec);
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," uw_BlockSize=%ld\n", pscdData->uw_BlockSize);
#ifdef _SDD_FUNC_SDIO_
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," ub_FuncNo=%ld\n", p_sdd->ub_FuncNo);
#endif
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," SD_INFO1=%04X\n", (UH)(SDD_SD_INFO1(Sdd_M_GetPortNum(p_SddHandle->ub_Port))));
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG," SD_INFO2=%04X\n", (UH)(SDD_SD_INFO2(Sdd_M_GetPortNum(p_SddHandle->ub_Port))));

#ifdef _SDD_SPEED_KENSHO_ /* x{ */
    Sdd_GetTim( &systim );				/* ݃VXe擾	*/
    uw_Timer = Sdd_GetTimLow(&systim);
#endif /* _SDD_SPEED_KENSHO_ */

    /* R}hM */
    Sdds_SetCommandWithoutSetting(p_SddHandle, pscdData->uh_Cmd, pscdData->uh_Arg0, pscdData->uh_Arg1);

    /* X|X҂ */
    w_ResTmp = Sdds_WaitResEnd(p_SddHandle, pscdData->uw_REndTimeOut, pscdData->uh_Cmd);
    if(w_ResTmp != SDD_SUCCESS ) {
        /* G[{ */
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:ResEnd=%lX\n", w_ResTmp);
        goto SDDS_SENDCOMMAND_ERROR;
    }
#ifdef _SDD_SPEED_KENSHO_ /* x{ */
    Sdd_GetTim( &systim );				/* ݃VXe擾	*/
    for(i=0; i<SDD_UNDER_1BYTE_MASK; i++) {
        if (i==(pscdData->uh_Cmd&SDD_UNDER_1BYTE_MASK)) {
            p_sdd->uw_CommandTimer[i]+=Sdd_GetTimLow(&systim) - uw_Timer;
            p_sdd->uw_CommandCnt[i]++;
            break;
        }
    }
#endif /* _SDD_SPEED_KENSHO_ */

    /* R/E AccessEnd҂ */
    if (pscdData->uh_Type & SDD_COMMAND_TYPE_WITHDAT && !(pscdData->uh_Type & SDD_COMMAND_TYPE_NORWE) ) {
        /* R/W AccessEnd҂{ꍇ */
#ifdef _SDD_SPEED_KENSHO_ /* x{ */
    Sdd_GetTim( &systim );				/* ݃VXe擾	*/
    uw_Timer = Sdd_GetTimLow(&systim);
#endif /* _SDD_SPEED_KENSHO_ */

        /* DMA] */
        if (pscdData->uh_Type & SDD_COMMAND_TYPE_DMA) {
            /* DMA]{ꍇ */
            w_ResTmp = Sdds_DMATransfer(p_SddHandle, pscdData);
        }
        else {
            /* DMA]{Ȃꍇ */

            /* M */
            if (pscdData->uh_Type & SDD_COMMAND_TYPE_WRITE) {
                /* Write] */
                w_ResTmp = Sdds_WaitAllEnd( p_SddHandle, pscdData->pub_Buff, pscdData->uw_BlockSize, pscdData->uw_SendSec, TRUE, pscdData->uw_AEndTimeOut);
            }
            else {
                /* Read] */
                w_ResTmp = Sdds_WaitAllEnd( p_SddHandle, pscdData->pub_Buff, pscdData->uw_BlockSize, pscdData->uw_SendSec, FALSE, pscdData->uw_AEndTimeOut);
            }
        }
        if (w_ResTmp != SDD_SUCCESS) {
            Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:R/WAccessEnd=%lX\n", w_ResTmp);
            goto SDDS_SENDCOMMAND_ERROR;
        }
#ifdef _SDD_SPEED_KENSHO_ /* x{ */
        Sdd_GetTim( &systim );				/* ݃VXe擾	*/
        p_sdd->uw_RWWaitTimer += Sdd_GetTimLow(&systim) - uw_Timer;
        p_sdd->uw_RWWaitCnt++;
#endif /* _SDD_SPEED_KENSHO_ */
        
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:Data Transfer END!\n");
    }

    /* R1`FbN */
    if (pscdData->uh_Type & SDD_COMMAND_TYPE_CHECK_R1) {
        Sddr_CheckCardStatus(p_SddHandle, SDD_CARD_STATUS_READ, &w_R1);
        if (pscdData->uh_Type & SDD_COMMAND_TYPE_WITHDAT && !(pscdData->uh_Type & SDD_COMMAND_TYPE_NORWE)) {
            /* f[^M{ۂ̍ŏIZN^ */

			/* MMC,KingMax,PQI,A-DATASDJ[h oOΉJn */
			if(w_R1 != SDD_SUCCESS) {		/* ŏIAhXւ̃ANZXOUT_OF_RANGEG[𔭐 */
                w_R1 = Sdds_CheckLastSectorError(p_SddHandle, pscdData->uw_SendSec, w_R1);
            }		/* MMC,KingMax,PQI,A-DATASDJ[h oOΉI */
            if(w_R1 == SDD_SUCCESS) {
#ifdef _SDD_CARD_STATUS_CHECK_
                w_ResTmp = Sdds_GetCardStatus(p_SddHandle);	/* J[hXe[^X擾 */
                /* MMC,PQISDJ[h128MB oOΉJn */
                if(w_ResTmp != SDD_SUCCESS){   /* ŏIAhX,ŏI-1AhX(̂)ւ̃ANZXOUT_OF_RANGEG[𔭐 */
                    w_ResTmp = Sdds_CheckLastSectorError(p_SddHandle, pscdData->uw_SendSec, w_ResTmp);
                }	/* MMC,PQISDJ[h128MB oOΉI */
#endif /* __SDD_CARD_STATUS_CHECK__ */
            } 
            else {
                w_ResTmp = w_R1;
			}
            w_Result |= w_ResTmp;
        }
        else {
			if(w_R1 != SDD_SUCCESS) {
                w_ResTmp = w_R1;
            }
        }
    }
    if (w_ResTmp == SDD_SUCCESS) {
        goto SDDS_SENDCOMMAND_END;
    }

SDDS_SENDCOMMAND_ERROR:
    /* SD_BUF] */
    if (pscdData->uh_Type & SDD_COMMAND_TYPE_WITHDAT) {
        /* f[^M{ăG[̏ꍇ */
        w_Result |= w_ResTmp;
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:R1Check=%lX\n", w_ResTmp);
        Sdds_ErrProcess(p_SddHandle, w_ResTmp);
        if (pscdData->uh_Type & SDD_COMMAND_TYPE_DMA && !(pscdData->uh_Type & SDD_COMMAND_TYPE_NORWE)) {
            w_ResTmp = Sdds_StopSdma(p_SddHandle);
        }
    }
SDDS_SENDCOMMAND_END:
    if (w_ResTmp != SDD_SUCCESS) {
        Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"Sdds_SendCommand:End=%lX\n", w_ResTmp);
        w_Result |= w_ResTmp;
    }

    /* Access End */
    if(!(pscdData->uh_Type & SDD_COMMAND_TYPE_NORWE)) {
        /* USBňʂ̃R}hR/WANZXGh{ꍇȊÓAŊ荞݂֎~ */
        Sddr_DisIntReadyCMD(p_SddHandle);

        if (pscdData->uh_Type & SDD_COMMAND_TYPE_WITHDAT) {
            /* f[^M{Ăꍇ */

#ifdef _SDD_CARDDETECT_SDDAT3_ /* SDDAT3ŃJ[h}oꍇ */
			/* SD_BUFɂf[^M㏈ */
			w_ResTmp = Sdds_AfterCommandTypeWithDat(p_SddHandle);
			w_Result |= w_ResTmp;
#endif /* _SDD_CARDDETECT_SDDAT3_ */

            /* DMAI */
            if (pscdData->uh_Type & SDD_COMMAND_TYPE_DMA) {
                /* DMAI */
                w_ResTmp = Sdds_EndSdma(p_SddHandle);
                w_Result |= w_ResTmp;
            }
            /* ubNTCYI */
            if (pscdData->uw_BlockSize != SDD_SECTOR_SIZE) {
                /* ubNTCYftHglύX */
#ifdef _SDD_FUNC_SDIO_
                if (Sdds_OperationModeCheck(p_SddHandle, SDD_CARD_INIT_MODE_SDIO) == SDD_SUCCESS) {
                    /* SDIO[hɂ́ASDIOp̃ubNTCYύXs */
                    if (p_sdd->MaxBlockLength[p_sdd->ub_FuncNo] != pscdData->uw_BlockSize) {
                        /* ubNTCYقȂꍇ̂ݕύX */
                        w_ResTmp = Sdds_IO_SetBlockLength(p_SddHandle, p_sdd->MaxBlockLength[p_sdd->ub_FuncNo], p_sdd->ub_FuncNo);
                    }
                }
                else {
					/*===================================*/
					/* ]f[^WX^ݒ(SD_SIZE) */
					/*===================================*/
					/*
						]f[^WX^ݒ֐(Sddr_SetLength)
						FݒubNiLXgϊKvHj
						߂lFG[Ȃ
					*/
					Sddr_SetLength(p_SddHandle, SDD_SECTOR_SIZE);
					w_ResTmp = SDD_SUCCESS;
                }
#else
				/*===================================*/
				/* ]f[^WX^ݒ(SD_SIZE) */
				/*===================================*/
				/*
					]f[^WX^ݒ֐(Sddr_SetLength)
					FݒubNiLXgϊKvHj
					߂lFG[Ȃ
				*/
				Sddr_SetLength(p_SddHandle, SDD_SECTOR_SIZE);
				w_ResTmp = SDD_SUCCESS;
#endif
                w_Result |= w_ResTmp;
            }
            if(Sddr_CheckSecCnt(p_SddHandle)) {	/* ]ZN^ݒ肪L`FbN(֐FSD_STOPWX^LE`FbN) */
                Sddr_DisSecCnt(p_SddHandle);		/* ]ZN^ݒ肪LȏꍇAݒi֐FSD_SECCNTWX^ݒj */
            }
        }
    }
    if (w_Result != SDD_SUCCESS) {
        if (Sdds_DoExecCommandError(p_SddHandle, w_Result)) {
			/* G[񏑍 */
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_Result);
			/* Xe[^Xj^G[i[ */
			setCommandError();
			Sdds_DebugPrint(__LINE__, SDD_PWARN,"S:%lX %X %X %04X %04lX %lX\n",
                            w_Result, p_sdd->SddCommandSendData.uh_Cmd,
                            p_sdd->SddCommandSendData.uh_Arg0,
                            p_sdd->SddCommandSendData.uh_Arg1,
                            p_sdd->uw_SDINFO1_INTERR,
                            p_sdd->uw_SDINFO2_INTERR);
		}
    }
    Sdds_DebugPrint(__LINE__, SDD_PDEBUG,"<Sdds_SendCommand\n");
    return w_Result;
}

#ifdef _SDD_ALLOW_UHS1_
/********************************************************************************/
/*  ֐		FSdds_SendCMD11												*/
/*  Tv		FSend Switch Voltage Commands								*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2007.10.09													*/
/********************************************************************************/
SDD_ERROR Sdds_SendCMD11(SDD_HANDLE *p_SddHandle)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
    SDD_ERROR w_ResTmp;
	SDD_COMMAND_DATA scdData;
	
	
    Sdds_StopCDDetect(p_SddHandle);	/* J[h}oƂ̔rJn */

	/*==============================================================*/
	/* SDD_SW_VOLR}hs(CMD11)								*/
	/*	FȂ												 	*/
	/*==============================================================*/
    Sdds_SetCommandDefault(SDD_CMD_SW_VOL, 0x0000, 0x0000, &scdData);
	Sdds_SetTypeCheckR1(&scdData);
	w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
        Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	w_ResTmp = Sdds_SwitchVoltage(p_SddHandle, SDD_VOL_18);		/* dؑ */
	if(w_ResTmp != SDD_SUCCESS) {
        Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}

    Sdds_StartCDDetect(p_SddHandle);	/* J[h}oƂ̔rI */

	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_SwitchVoltage											*/
/*  Tv		Fdؑ֊֐													*/
/*  			FCMDADAT Line̓dUύX							    */
/*  		FUB ub_VolFlg													*/
/*                SDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2008.11.17													*/
/********************************************************************************/
SDD_ERROR Sdds_SwitchVoltage(SDD_HANDLE *p_SddHandle, UB ub_VolFlg)
{
	UB	ub_Vol;	/* ݒl */
	UB	ub_cnt;
	UW	uw_DAT0state;
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	
	Sddr_GetVol(p_SddHandle, &ub_Vol);
	
	if( ub_VolFlg == ub_Vol){
		return SDD_SUCCESS;
	}

	if (ub_VolFlg == SDD_VOL_33) {
		Sddr_SetVol(p_SddHandle, SDD_VOL_33); /* 3.3Vݒ */
		Sdd_Delay(1);	/* d艻҂ */

/*
 * LɂĂ͓d\m肵_ōČ
 */
#if 0
        /* SD I/F̓͊ђʓdh~(SD I/Fւ̓͂Cl[u) */
        Sddr_EnaSDIN(p_SddHandle, SDD_SDIN_ENABLE);
#endif
	}
    else if (ub_VolFlg == SDD_VOL_0) {
/*
 * LɂĂ͓d\m肵_ōČ
 */
#if 0
        /* SD I/F̓͊ђʓdh~(SD I/Fւ̓͂~) */
        Sddr_EnaSDIN(p_SddHandle, SDD_SDIN_DISABLE);

        /*
         * n[h\ɂNbN̉荞݂ꍇɂ
         * NbN~Kv(v)
         */
#endif

		Sddr_SetVol(p_SddHandle, SDD_VOL_0); /* 0Vݒ */
		Sdd_Delay(1);	/* d艻҂ */
    }
	else{
		for(ub_cnt=0; ;ub_cnt++){
			Sddr_CheckDAT0(p_SddHandle, &uw_DAT0state);
			if (uw_DAT0state == 0) {	/* rW[ԑ҂ */
				break;
			}
			if(ub_cnt >= SDD_VOL_CNT) {			/* ҂񐔂𒴂 */
            	Sdds_DebugPrint(__LINE__, SDD_PDEBUG, "Sdds_SwitchVoltage:Busy TimeOut!\n");
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_ACC_TIMEOUT);
				return w_Result;					/* ^CAEg̃G[ɂ */
			}
			Sdd_Delay(1);	/* 1mswait */
		}
		w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_DISABLE);	/* SD_CLK̒~ */
		if(w_ResTmp != SDD_SUCCESS){
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			return w_Result;
		}	

        /* SD I/F̓͊ђʓdh~(SD I/Fւ̓͂~) */
        Sddr_EnaSDIN(p_SddHandle, SDD_SDIN_DISABLE);

		Sddr_SetVol(p_SddHandle, SDD_VOL_18); /* 1.8Vݒ */
		Sdd_Delay(SDD_VOL_WAIT_TIME);	/* J[h̉Hؑwait */
		
        /* SD I/F̓͊ђʓdh~(SD I/Fւ̓͂Cl[u) */
        Sddr_EnaSDIN(p_SddHandle, SDD_SDIN_ENABLE);

		w_ResTmp = Sddr_EnaClk(p_SddHandle, SDD_CLK_ENABLE);		/* SD_CLK̏o */
		if(w_ResTmp != SDD_SUCCESS){
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			return w_Result;
		}
		Sdd_Delay(1);	/* d艻҂ */
		for(ub_cnt=0; ;ub_cnt++){
			Sddr_CheckDAT0(p_SddHandle, &uw_DAT0state);
			if (uw_DAT0state != 0) {	/* rW[ԉ҂ */
				break;
			}
			if(ub_cnt >= SDD_VOL_CNT) {			/* ҂񐔂𒴂 */
            	Sdds_DebugPrint(__LINE__, SDD_PDEBUG, "Sdds_SwitchVoltage:Busy TimeOut!\n");
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_ACC_TIMEOUT);
				return w_Result;					/* ^CAEg̃G[ɂ */
			}
			Sdd_Delay(1);	/* 1mswait */
		}		
	}
	return w_Result;
}
#endif /* _SDD_ALLOW_UHS1_ */

/********************************************************************************/
/*  ֐		FSdds_SpeedClassRecording										*/
/*  Tv		FXs[hNXL^R}hiCMD20js						*/
/*  			FCMD20𔭍s												*/
/*  		FUW uw_Arg														*/
/*                SDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FȂ															*/
/*  ŏIXV	F2008.11.17													*/
/********************************************************************************/
SDD_ERROR Sdds_SpeedClassRecording(SDD_HANDLE *p_SddHandle, UW uw_Arg)
{
	SDD_ERROR w_Result = SDD_SUCCESS;
    SDD_ERROR w_ResTmp;
	UW uw_TmpArg;
	SDD_COMMAND_DATA scdData;
	
	/* R}hA[Mg쐬 */
	uw_TmpArg = uw_Arg << 28;
	
	Sdds_SetCommandDefault(SDD_CMD_CLASS_CTRL, SDD_LWORD(uw_TmpArg), SDD_HWORD(uw_TmpArg), &scdData);
    Sdds_SetTypeCheckR1(&scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}

	return w_Result;
}


#ifdef _SDD_ALLOW_MMC_
/********************************************************************************/
/*  ֐		FSdds_MmcSetExtension											*/
/*  Tv		FMMCg@\ݒiVer4.0ȏMMCɑΉj						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.17														*/
/********************************************************************************/
SDD_ERROR Sdds_MmcSetExtension(SDD_HANDLE *p_SddHandle) {
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
#ifdef _SDD_HIGHSPEEDCLK_
	UW uw_SetDiv = 0;
#endif
	
	/*
		EXT-CSDWX^l̎擾
		SddDev.MmcInfo.ub_ExtCsd[512]Ɋi[
	*/
	w_ResTmp = Sdds_MmcGetExtCsd(p_SddHandle);
	if (w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		return w_Result;
	}
	
	/*
		EXT-CSDWX^̉ 
			J[ht@NV@\SddDev.MmcInfo.uh_FuncɊi[
			ErasejbgTCYSddDev.MmcInfo.uw_EraseUnitSizeɊi[
			Erase^CAEgԂSddDev.MmcInfo.uw_EraseTimeoutɊi[
	*/
	Sdds_MmcExtCsdAnalysis(p_SddHandle);
	
	/*
		4bit[h̐ݒ
	*/
	if (p_sdd->MmcInfo.uh_Func & SDD_MMC_FUNC_4BIT_BUS){
		w_ResTmp = Sdds_MmcSetBusWidth(p_SddHandle);
		if (w_ResTmp == SDD_SUCCESS) {
			p_sdd->MmcInfo.uh_SetFunc |= SDD_MMC_FUNC_4BIT_BUS;  
		} else {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
			return w_Result;
		}
	} else {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
		return w_Result;
	}

#ifdef _SDD_HIGHSPEEDCLK_
	if(p_sdd->ub_HighspeedInfo == SDD_HIGHSPEEDCLK_USED) {
		/*
			nCXs[h[h̐ݒ
		*/
		if (p_sdd->MmcInfo.uh_Func & (SDD_MMC_FUNC_HS_52MHZ | SDD_MMC_FUNC_HS_26MHZ)){
			w_ResTmp = Sdds_MmcSetHighSpeed(p_SddHandle);
			if (w_ResTmp == SDD_SUCCESS) {
				p_sdd->MmcInfo.uh_SetFunc |= (p_sdd->MmcInfo.uh_Func & (SDD_MMC_FUNC_HS_52MHZ | SDD_MMC_FUNC_HS_26MHZ));
				w_ResTmp = Sdds_CheckSetDiv(p_SddHandle, SDD_CLOCK_DIV_FULLSPEED, &uw_SetDiv);
				if (w_ResTmp == SDD_SUCCESS) {
					Sddr_SetClkDiv(p_SddHandle, uw_SetDiv);	/* uw_SetDivɕݒ */
					/*================================================*/
					/* ύXɂƂȂ^CAEgTCN̕ύX */
					/*================================================*/
					/* 
						TOP[27:24](SD_OPTIONWX^j̐ݒ
						Sddr_SetClkDivŎs
							 = SDD_CLOCK_DIV_1`512̂ǂꂩ
							߂lFȂ
					*/
					Sddr_SetTimeOutCycle(p_SddHandle, uw_SetDiv);
				} else {
					w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
					return w_Result;
				}
			} else {
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				return w_Result;
			}
		} else {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
			return w_Result;
		}
	}
#endif	/* _SDD_HIGHSPEEDCLK_ */

	/*
		p[NX̐ݒ
	*/
	if ( SDD_MMC_POWER_CLASS != 0) {
		if (p_sdd->MmcInfo.uh_Func & SDD_MMC_FUNC_POWER_CLASS){
			w_ResTmp = Sdds_MmcSetPowerClass(p_SddHandle);
			if (w_ResTmp == SDD_SUCCESS) {
				p_sdd->MmcInfo.uh_SetFunc |= SDD_MMC_FUNC_POWER_CLASS;
				p_sdd->MmcInfo.ub_PowerClass = (UB)SDD_MMC_POWER_CLASS;
			} else {
				w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
				return w_Result;
			}
		} else {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_NOT_SUPPORT);
			return w_Result;
		}
	}
	/*
		Large Erase[h̐ݒ
	*/
	if (p_sdd->MmcInfo.uh_Func & SDD_MMC_FUNC_LARGE_ERASE){
		w_ResTmp = Sdds_MmcSetLargeErase(p_SddHandle);
		if (w_ResTmp == SDD_SUCCESS) {
			p_sdd->MmcInfo.uh_SetFunc |= SDD_MMC_FUNC_LARGE_ERASE;  
		} else {
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
		}
	} 

	return w_Result;
}	


/********************************************************************************/
/*  ֐		FSdds_MmcGetExtCsd												*/
/*  Tv		FEXT-CSD擾iVer4.0ȏMMCɑΉj							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.17														*/
/********************************************************************************/
SDD_ERROR Sdds_MmcGetExtCsd(SDD_HANDLE *p_SddHandle) {
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */
    SDD_COMMAND_DATA scdData;

	/*===============================================*/
	/* SDD_CMD_MMC_EXTCSDR}hs(CMD8)          */
	/*===============================================*/
    Sdds_SetCommandDefault(SDD_CMD_MMC_EXTCSD, 0x0000, 0x0000, &scdData);
    Sdds_SetTypeWithData(&scdData);
    Sdds_SetTypeCheckR1(&scdData);
    Sdds_SetBuffAddress(p_sdd->MmcInfo.ub_ExtCsd, &scdData);
    Sdds_SetBlockSize(SDD_MMC_EXTCSD_SIZE, &scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}

	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_MmcExtCsdAnalysis										*/
/*  Tv		FEXT-CSD́iVer4.0ȏMMCɑΉj							*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FȂ															*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.17														*/
/********************************************************************************/
void Sdds_MmcExtCsdAnalysis(SDD_HANDLE *p_SddHandle) {
	SDD_DEV	*p_sdd = p_SddHandle->vp_Sdif;/* SDD_DEV\̂ւ̃|C^ */

	/*
		EXT-CSD擾ł_ŉL@\ɂ͑ΉςȂ̂ŁAtOZbg
		  4rbg[h
		  8rbg[h
		  p[NX
	*/
	p_sdd->MmcInfo.uh_Func |= (SDD_MMC_FUNC_4BIT_BUS | SDD_MMC_FUNC_8BIT_BUS |SDD_MMC_FUNC_POWER_CLASS);

	/*
		ΉĂnCXs[h[hmF
			EXT-CSD[196] bit1FnCXs[h52MHz
			EXT-CSD[196] bit0FnCXs[h26MHz
	*/
	if (p_sdd->MmcInfo.ub_ExtCsd[196] & 0x02){
		p_sdd->MmcInfo.uh_Func |= SDD_MMC_FUNC_HS_52MHZ;
	}
	else if (p_sdd->MmcInfo.ub_ExtCsd[196] & 0x01){
		p_sdd->MmcInfo.uh_Func |= SDD_MMC_FUNC_HS_26MHZ;
	}
	
	/*
		Large Erase[hΉmFB
		ΉĂꍇ́AEraseUnitSize, Erase^CAEgZo
	*/
	if ((p_sdd->MmcInfo.ub_ExtCsd[223] != 0x00) && (p_sdd->MmcInfo.ub_ExtCsd[224] != 0x00)){
		p_sdd->MmcInfo.uh_Func |= SDD_MMC_FUNC_LARGE_ERASE;
		p_sdd->MmcInfo.uw_EraseUnitSize = (UW)(SDD_MMC_ERASE_UNIT_MIN * p_sdd->MmcInfo.ub_ExtCsd[224]);
		p_sdd->MmcInfo.uw_EraseTimeout = (UW)(SDD_MMC_ERASE_TIMEOUT_MIN * p_sdd->MmcInfo.ub_ExtCsd[223]);
	}

	return;
}


/********************************************************************************/
/*  ֐		FSdds_MmcSendSwitchCMD											*/
/*  Tv		FSWITCHR}h(CMD6)siVer4.0ȏMMCɑΉj				*/
/*  		FA[Mg												*/
/*                SDD_HANDLE *p_SddHandle foCXhConh              */
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.17														*/
/********************************************************************************/
SDD_ERROR Sdds_MmcSendSwitchCMD(SDD_HANDLE *p_SddHandle, UW uw_Arg) {
 	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;
     
    Sdds_SetCommandDefault(SDD_CMD_MMC_SWITCH, SDD_LWORD(uw_Arg), SDD_HWORD(uw_Arg), &scdData);
    Sdds_SetTypeCheckR1(&scdData);
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp != SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}
	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_MmcSetBusWidth											*/
/*  Tv		F4rbg[hݒiVer4.0ȏMMCɑΉj					*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.17														*/
/********************************************************************************/
SDD_ERROR Sdds_MmcSetBusWidth(SDD_HANDLE *p_SddHandle) {
	SDD_ERROR w_Result = SDD_SUCCESS;

	w_Result = Sdds_MmcSendSwitchCMD(p_SddHandle, SDD_MMC_ARG_BUS_WIDTH);
	if(w_Result == SDD_SUCCESS){
		Sddr_SetBusWidth(p_SddHandle, SDD_BUS_WIDTH_4BIT);
	}
	
	return w_Result;
}


/********************************************************************************/
/*  ֐		FSdds_MmcSetHighSpeed											*/
/*  Tv		FnCXs[h[hݒiVer4.0ȏMMCɑΉj				*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.17														*/
/********************************************************************************/
SDD_ERROR Sdds_MmcSetHighSpeed(SDD_HANDLE *p_SddHandle) {

	return Sdds_MmcSendSwitchCMD(p_SddHandle, SDD_MMC_ARG_HIGH_SPEED);
}


/********************************************************************************/
/*  ֐		FSdds_MmcSetPowerClass											*/
/*  Tv		Fp[NXݒiVer4.0ȏMMCɑΉj						*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.17														*/
/********************************************************************************/
SDD_ERROR Sdds_MmcSetPowerClass(SDD_HANDLE *p_SddHandle) {
	UW uw_Arg;
	
	uw_Arg = SDD_MMC_ARG_POWER_CLASS |((UW)SDD_MMC_POWER_CLASS << 8);
	return Sdds_MmcSendSwitchCMD(p_SddHandle, uw_Arg);
}


/********************************************************************************/
/*  ֐		FSdds_MmcSetLargeErase											*/
/*  Tv		FLarge Erase[hݒiVer4.0ȏMMCɑΉj				*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh				*/
/*  ߂l		FFSDD_SUCCESS												*/
/*  			FsFG[R[h											*/
/*  ŏIXV	F2009.3.17														*/
/********************************************************************************/
SDD_ERROR Sdds_MmcSetLargeErase(SDD_HANDLE *p_SddHandle) {

	return Sdds_MmcSendSwitchCMD(p_SddHandle, SDD_MMC_ARG_LARGE_ERASE);
}
#endif /* _SDD_ALLOW_MMC_ */


/********************************************************************************/
/*  ֐		FSdds_SetSoftCmd												*/
/*  Tv		F\tgEFAR}hs										*/
/*  		FSDD_HANDLE *p_SddHandle foCXhConh              */
/*      		FR}hݒ(SDD_CMD_INFO)								*/
/*  ߂l		FFSDD_SUCCESS												*/
/*				 G[F														*/
/*  ŏIXV	F2009.6.3													    */
/********************************************************************************/
SDD_ERROR Sdds_SetSoftCmd( SDD_HANDLE *p_SddHandle, SDD_CMD_INFO *p_cmdinfo )
{
	SDD_ERROR w_Result = SDD_SUCCESS;
	SDD_ERROR w_ResTmp;
    SDD_COMMAND_DATA scdData;
    BOOL bl_Write = FALSE;

	/*
		R}hftHglݒ
	*/
	Sdds_SetCommandDefault(SDD_LWORD(p_cmdinfo->uw_Cmd), SDD_LWORD(p_cmdinfo->uw_Arg), SDD_HWORD(p_cmdinfo->uw_Arg), &scdData);
	
	/* 
		SD_CMD[15:14]ݒlmF
	*/
	if(((p_cmdinfo->uw_Cmd & SDD_SD_CMD_15_14) != SDD_SOFT_CMD_NORMAL) 
		&& ((p_cmdinfo->uw_Cmd & SDD_SD_CMD_15_14) != SDD_SOFT_CMD_SECURE_AND_IO)){
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
			return w_Result;
	}
	
	/* 
		SD_CMD[13]ݒlmF & ]TCYݒ & DMAݒ
	*/
	if(p_cmdinfo->uw_Cmd & SDD_SD_CMD_13){
		if(p_cmdinfo->uw_Size >= (SDD_SECTOR_SIZE*2)) {
			Sdds_SetSendSec(p_cmdinfo->uw_Size/SDD_SECTOR_SIZE, &scdData);
			Sdds_SetTypeDMA(&scdData);
		}
		else{
			w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, SDD_ERR_PARAM);
			return w_Result;
		}
	}

	/* 
		SD_CMD[12]ݒlmF
	*/
	if((p_cmdinfo->uw_Cmd & SDD_SD_CMD_12) == 0){
		 Sdds_SetTypeWrite(&scdData);
		 bl_Write = TRUE;
	}

	/* 
		SD_CMD[11]ݒlmF
	*/
	if(p_cmdinfo->uw_Cmd & SDD_SD_CMD_11){
		Sdds_SetTypeWithData(&scdData);
	}
	
	/* 
		SD_CMD[10:8]ݒlmF
	*/
	if((p_cmdinfo->uw_Cmd & SDD_SD_CMD_10_8) != 0x00000000 ){
		if (((p_cmdinfo->uw_Cmd & SDD_SD_CMD_10_8) == SDD_SOFT_CMD_RSP_R1_R5_R6)
			|| ((p_cmdinfo->uw_Cmd & SDD_SD_CMD_10_8) == SDD_SOFT_CMD_RSP_R1B_R5B))
		{
			/*
				R5, R5b, R6, R7X|X̃R}hOăX|X`FbN{
			*/
			
			if (((p_cmdinfo->uw_Cmd & SDD_SD_CMD_7_0) != SDD_CMD_RCA)
				&& ((p_cmdinfo->uw_Cmd & SDD_SD_CMD_7_0) != SDD_CMD_IF_COND)
				&& ((p_cmdinfo->uw_Cmd & SDD_SD_CMD_7_0) != (SDD_CMD_IO_OP_COND & SDD_SD_CMD_7_0))
				&& ((p_cmdinfo->uw_Cmd & SDD_SD_CMD_7_0) != (SDD_CMD_IO_RW_DIRECT & SDD_SD_CMD_7_0))
				&& ((p_cmdinfo->uw_Cmd & SDD_SD_CMD_7_0) != 0x00000035))		/* SDIOwb_t@CȊOCMD53`̂ߒlL */
			{
				Sdds_SetTypeCheckR1(&scdData);
			}
		}
	} 
	else {
		/* DecordR}hݒ̏ꍇ̓X|X^Cvʕs̂߃`FbN{Ȃ */
		/* ǂĂR}h`FbNꍇ͑SR}h̃X|X^Cvo^Kv */
	}
	/*
		R}hݒ
	*/
	if(p_cmdinfo->uw_Size != 0){
		Sdds_SetTypeWithData(&scdData);
		Sdds_SetBuffAddress(p_cmdinfo->pub_Data, &scdData);
		Sdds_SetAEndTimeOut(Sdds_CalcTimeOutTime(scdData.uw_SendSec, bl_Write, p_SddHandle), &scdData);
	}
	if(p_cmdinfo->uw_Size < SDD_SECTOR_SIZE){
		Sdds_SetBlockSize(p_cmdinfo->uw_Size, &scdData);
	}

	/*
		R}hs
	*/
    w_ResTmp = Sdds_SendCommand(p_SddHandle, &scdData);
	if(w_ResTmp == SDD_SUCCESS) {
		w_Result = Sdds_SetErr(p_SddHandle, __LINE__, w_Result, w_ResTmp);
	}

	return w_Result;

}
